/*
 Copyright 2009-2015 Luc Saffre
 License: BSD (see file COPYING for details)
*/

// lino.js --- generated Wed Oct  4 10:39:40 2017 by Lino Voga 2017.7.0 for Verwalter.
Ext.BLANK_IMAGE_URL = '/static/ext-3.3.1/resources/images/default/s.gif';
LANGUAGE_CHOICES = [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ];
MEDIA_URL = "/media/";

// hack to add a toCamel function, inspired by
// http://jamesroberts.name/blog/2010/02/22/string-functions-for-javascript-trim-to-camel-case-to-dashed-and-to-underscore/
String.prototype.toCamel = function(){
  //~ return this.replace(/(\-[a-z])/g, function($1){return $1.toUpperCase().replace('-','');});
  //~ return this;
  return this.replace(/([A-Z])([A-Z]+)/g, function(match,p1,p2,offset,string){
      //~ console.log("20131005 got ",arguments);
      return p1 + p2.toLowerCase();});
};


// 20151126 hack to modify Ext.EventObjectImpl.isSpecialKey() which
// returned false for Ctrl-S when called from a keyup handler (namely
// ComboBox.onLoad)

Ext.EventObjectImpl.prototype.isSpecialKey = function(){
    // same as original except for one line
    var k = this.normalizeKey(this.keyCode);
    // return (this.type == 'keypress' && this.ctrlKey) ||
    return (this.ctrlKey) ||
        this.isNavKeyPress() ||
        (k == this.BACKSPACE) || 
        (k >= 16 && k <= 20) || 
        (k >= 44 && k <= 46);   
};





/* MonthPickerPlugin: thanks to keypoint @ sencha forum
   http://www.sencha.com/forum/showthread.php?74002-3.x-Ext.ux.MonthMenu&p=356860#post356860
*/
Ext.namespace('Ext.ux'); 

Ext.ux.MonthPickerPlugin = function() { 
    var picker; 
    var oldDateDefaults; 

    this.init = function(pk) { 
        picker = pk; 
        picker.onTriggerClick = picker.onTriggerClick.createSequence(onClick); 
        picker.getValue = picker.getValue.createInterceptor(setDefaultMonthDay).createSequence(restoreDefaultMonthDay); 
        picker.beforeBlur = picker.beforeBlur.createInterceptor(setDefaultMonthDay).createSequence(restoreDefaultMonthDay); 
    }; 

    function setDefaultMonthDay() { 
        oldDateDefaults = Date.defaults.d; 
        Date.defaults.d = 1; 
        return true; 
    } 

    function restoreDefaultMonthDay(ret) { 
        Date.defaults.d = oldDateDefaults; 
        return ret; 
    } 

    function onClick(e, el, opt) { 
        var p = picker.menu.picker; 
        p.activeDate = p.activeDate.getFirstDateOfMonth(); 
        if (p.value) { 
            p.value = p.value.getFirstDateOfMonth(); 
        } 

        p.showMonthPicker(); 
         
        if (!p.disabled) { 
            p.monthPicker.stopFx(); 
            p.monthPicker.show(); 

            p.mun(p.monthPicker, 'click', p.onMonthClick, p); 
            p.mun(p.monthPicker, 'dblclick', p.onMonthDblClick, p); 
            p.onMonthClick = p.onMonthClick.createSequence(pickerClick); 
            p.onMonthDblClick = p.onMonthDblClick.createSequence(pickerDblclick); 
            p.mon(p.monthPicker, 'click', p.onMonthClick, p); 
            p.mon(p.monthPicker, 'dblclick', p.onMonthDblClick, p); 
        } 
    } 

    function pickerClick(e, t) { 
        var el = new Ext.Element(t); 
        if (el.is('button.x-date-mp-cancel')) { 
            picker.menu.hide(); 
        } else if(el.is('button.x-date-mp-ok')) { 
            var p = picker.menu.picker; 
            p.setValue(p.activeDate); 
            p.fireEvent('select', p, p.value); 
        } 
    } 

    function pickerDblclick(e, t) { 
        var el = new Ext.Element(t); 
        if (el.parent() 
            && (el.parent().is('td.x-date-mp-month') 
            || el.parent().is('td.x-date-mp-year'))) { 

            var p = picker.menu.picker; 
            p.setValue(p.activeDate); 
            p.fireEvent('select', p, p.value); 
        } 
    } 
}; 

Ext.preg('monthPickerPlugin', Ext.ux.MonthPickerPlugin);  


/**
JC Watsons solution (adapted to ExtJS 3.3.1 by LS) is elegant and simple:
`A "fix" for unchecked checkbox submission  behaviour
<http://www.sencha.com/forum/showthread.php?28449>`_

Added special handling for checkbox inputs. 
ExtJS defines disabled checkboxes `readonly`, not `disabled` as for other inputs.

*/
Ext.lib.Ajax.serializeForm = function(form) {
    // console.log('20170731 linolib.js serializeForm', form);
    var fElements = form.elements || (document.forms[form] || Ext.getDom(form)).elements, 
        hasSubmit = false, 
        encoder = encodeURIComponent, 
        name, 
        data = '', 
        type, 
        hasValue;

    Ext.each(fElements, function(element){
        name = element.name;
        type = element.type;

        if (!element.disabled && name && !(type == 'checkbox' && element.readonly)) {
            if (/select-(one|multiple)/i.test(type)) {
                Ext.each(element.options, function(opt){
                    if (opt.selected) {
                        hasValue = opt.hasAttribute ? opt.hasAttribute('value') : opt.getAttributeNode('value').specified;
                        data += String.format("{0}={1}&", encoder(name), encoder(hasValue ? opt.value : opt.text));
                    }
                });
            } else if (!(/file|undefined|reset|button/i.test(type))) {
                //~ if (!(/radio|checkbox/i.test(type) && !element.checked) && !(type == 'submit' && hasSubmit)) {
                if (!(type == 'submit' && hasSubmit)) {
                    if (type == 'checkbox') {
                        //~ console.log('20111001',element,'data += ',encoder(name) + '=' + (element.checked ? 'on' : 'off') + '&');
                        data += encoder(name) + '=' + (element.checked ? 'on' : 'off') + '&';
                    } else {
                        //~ console.log('20111001',element,'data += ',encoder(name) + '=' + encoder(element.value) + '&');
                        data += encoder(name) + '=' + encoder(element.value) + '&';
                    }
                    hasSubmit = /submit/i.test(type);
                }
            }
        //~ } else {
            //~ console.log(name,type,element.readonly);
        }
    });
    return data.substr(0, data.length - 1);
};



/*
Set a long timeout of fifteen minutes. 
See /blog/2012/0307
*/
Ext.Ajax.timeout = 15 * 60 * 1000; 

/*
 * Thanks to 
 * `huuze <http://stackoverflow.com/users/10040/huuuze>`_ for the question
 * and to 
 * `chrisv <http://stackoverflow.com/users/683808/chrisv>`_
 * for the answer on
 * http://stackoverflow.com/questions/3764589/how-do-i-include-django-1-2s-csrf-token-in-a-javascript-generated-html-form/5485616#5485616
 * 
 * */
 
Ext.Ajax.on('beforerequest', function (conn, options) {
   if (!(/^http:.*/.test(options.url) || /^https:.*/.test(options.url))) {
     if (typeof(options.headers) == "undefined") {
       options.headers = {'X-CSRFToken': Ext.util.Cookies.get('csrftoken')};
     } else {
       options.headers.extend({'X-CSRFToken': Ext.util.Cookies.get('csrftoken')});
     }                        
   }
}, this);


/*
My fix for the "Cannot set QuickTips dismissDelay to 0" bug,
see http://www.sencha.com/forum/showthread.php?183515 
*/
Ext.override(Ext.QuickTip,{
  showAt : function(xy){
        var t = this.activeTarget;
        //~ console.log("20120224 QuickTip.showAt",this.title,this.dismissDelay,t.dismissDelay);
        if(t){
            if(!this.rendered){
                this.render(Ext.getBody());
                this.activeTarget = t;
            }
            if(t.width){
                this.setWidth(t.width);
                this.body.setWidth(this.adjustBodyWidth(t.width - this.getFrameWidth()));
                this.measureWidth = false;
            } else{
                this.measureWidth = true;
            }
            this.setTitle(t.title || '');
            this.body.update(t.text);
            this.autoHide = t.autoHide;
            // bugfix by Luc 20120226
            if (t.dismissDelay != undefined) this.dismissDelay = t.dismissDelay;
            //~ this.dismissDelay = t.dismissDelay || this.dismissDelay;
            if(this.lastCls){
                this.el.removeClass(this.lastCls);
                delete this.lastCls;
            }
            if(t.cls){
                this.el.addClass(t.cls);
                this.lastCls = t.cls;
            }
            if(this.anchor){
                this.constrainPosition = false;
            }else if(t.align){ 
                xy = this.el.getAlignToXY(t.el, t.align);
                this.constrainPosition = false;
            }else{
                this.constrainPosition = true;
            }
        }
        Ext.QuickTip.superclass.showAt.call(this, xy);
    }
});

/*
Another hack. See /docs/blog/2012/0228
*/
Ext.Element.addMethods(
    function() {
        var VISIBILITY      = "visibility",
            DISPLAY         = "display",
            HIDDEN          = "hidden",
            NONE            = "none",
            XMASKED         = "x-masked",
            XMASKEDRELATIVE = "x-masked-relative",
            data            = Ext.Element.data;

        return {
            
            mask : function(msg, msgCls) {
                var me  = this,
                    dom = me.dom,
                    dh  = Ext.DomHelper,
                    EXTELMASKMSG = "ext-el-mask-msg",
                    el,
                    mask;
                // removed the following lines. See /docs/blog/2012/0228
                //~ if (!(/^body/i.test(dom.tagName) && me.getStyle('position') == 'static')) {
                    //~ console.log(20120228,dom.tagName,me);
                    //~ me.addClass(XMASKEDRELATIVE); 
                //~ }
                if (el = data(dom, 'maskMsg')) {
                    el.remove();
                }
                if (el = data(dom, 'mask')) {
                    el.remove();
                }

                mask = dh.append(dom, {cls : "ext-el-mask"}, true);
                data(dom, 'mask', mask);

                me.addClass(XMASKED);
                mask.setDisplayed(true);
                
                if (typeof msg == 'string') {
                    var mm = dh.append(dom, {cls : EXTELMASKMSG, cn:{tag:'div'}}, true);
                    data(dom, 'maskMsg', mm);
                    mm.dom.className = msgCls ? EXTELMASKMSG + " " + msgCls : EXTELMASKMSG;
                    mm.dom.firstChild.innerHTML = msg;
                    mm.setDisplayed(true);
                    mm.center(me);
                }
                
                
                if (Ext.isIE && !(Ext.isIE7 && Ext.isStrict) && me.getStyle('height') == 'auto') {
                    mask.setSize(undefined, me.getHeight());
                }
                
                return mask;
            }

            
        };
    }()
);



Ext.namespace('Lino');
    
    

//~ Lino.subst_user_field = new Ext.form.ComboBox({});
//~ Lino.subst_user = null;
Lino.insert_subst_user = function(p){
    //~ console.log('20120714 insert_subst_user',Lino.subst_user,p);
    //~ if (Lino.subst_user_field.getValue()) {
    if (p.su) return;
    if (Lino.subst_user) {
        //~ p.su = Lino.subst_user_field.getValue();
        p.su = Lino.subst_user;
    //~ } else {
        //~ delete p.su;
    }
    //~ console.log('20120714 insert_subst_user -->',Lino.subst_user,p);
}

// Lino.login_window = null;

Lino.autorefresh = function() {
  if (Lino.current_window == null) {
      Lino.viewport.refresh();
      Lino.autorefresh.defer(60000);
  }
}

Lino.set_subst_user = function(id, name) {
    //~ console.log(20130723,'Lino.set_subst_user',id,name,Lino.current_window,Lino.viewport);
    Lino.subst_user = id;
    if (Lino.current_window) 
        Lino.current_window.main_item.set_base_param("su",id);
    if (Lino.viewport) 
        Lino.permalink_handler(Lino.current_window)();
}



//~ Lino.select_subst_user = function(cmp,rec,value){
    //~ Lino.subst_user=value;
    //~ console.log(20120713,rec);
//~ }
    
Lino.current_window = null;
Lino.window_history = Array();
    
Lino.chars2width = function(cols) {  return cols * 9; }
Lino.rows2height = function(cols) {  return cols * 20; }
Lino.perc2width = function(perc) {  
    // var w = Math.max(document.documentElement.clientWidth, window.innerWidth);
    // console.log("20151226", document, window, w);
    var w = Lino.viewport.getWidth();
    return w * perc / 100; 
}



Lino.MainPanel = {
  is_home_page: false
  ,auto_apply_params: true
  ,setting_param_values : false
  ,config_containing_window : function(wincfg) { }
  ,init_containing_window : function(win) { }
  ,is_loading : function() { 
      if (!this.rendered) return true;
      //~ return (Ext.select('.x-loading-msg').elements.length > 0);
      return true; 
    } 
  ,do_when_clean : function(auto_save,todo) { todo() }
  ,get_master_params : function() {
    var p = {}
    p['mt'] = this.content_type; 
    rec = this.get_current_record()
    if (rec) {
      if (rec.phantom) {
          p['mk'] = undefined; 
      }else{
          p['mk'] = rec.id; 
      }
    } else {
      p['mk'] = undefined;
    }
    //~ console.log('get_master_params returns',p,'using record',rec);
    return p;
  }
  ,get_permalink : function() {
    var p = Ext.apply({}, this.get_base_params());
    delete p.fmt;
    Ext.apply(p, this.get_permalink_params());
    
    if (this.toggle_params_panel_btn) {
        p.sp = this.toggle_params_panel_btn.pressed;
        //~ if (this.toggle_params_panel_btn.pressed == this.params_panel_hidden) {
          //~ p.sp = true;
        //~ }
    }
    
    //~ Lino.insert_subst_user(p);
     //~ p.fmt = 'html';
    //~ console.log('get_permalink',p,this.get_permalink_params());
    if (this.is_home_page)
        //~ var url = '';
        var url = '/';
    else 
        var url = this.get_permalink_url();
    if (p.su == null) 
        delete p.su;
    if (Ext.urlEncode(p)) url = url + "?" + Ext.urlEncode(p);
    return url;
  }
  ,get_record_url : function(record_id) {
      var url = '/api' + this.ls_url
      //~ var url = this.containing_window.config.url_data; // ls_url;
      url += '/' + (record_id === undefined ? this.default_record_id : String(record_id));
      //~ if (record_id !== undefined) url += '/' + String(record_id);
      //~ url += '/' + String(record_id);
      return url;
  }
  ,get_permalink_url : function() {
      return '/api' + this.ls_url;
  }
  ,get_permalink_params : function() {
      //~ return {an:'grid'};
      var p = {};
      if (this.action_name)
          p.an = this.action_name;
      this.add_param_values(p,false)
      return p;
  }
  /*

  Lino.MainPanel.set_status() : the status can have the following keys:

  - param_values : values of parameter fields
  - field_values : values of action parameter fields
  - base_params
  - record_id
  - active_tab
  - data_record
  - show_params_panel
  - current_page

   */
  ,set_status : function(status, requesting_panel) {}
  ,get_status : function() { return {}}
  ,refresh : function() {}
  ,get_base_params : function() {  // Lino.MainPanel
    var p = {};
    Lino.insert_subst_user(p);
    return p;
  }
  ,add_params_panel : function (tbar) {
      if (this.params_panel) {
        //~  20130923b
        //~ this.params_panel.autoHeight = true; // 20130924
        var t = this;
        var update = function() {
            var p = t.params_panel;
            //~ console.log("update", p.getSize().height,p.forceLayout,p.autoHeight);
            var w = t.get_containing_window();
            Lino.do_when_visible(w, function() {
                //~ p.doLayout(true); // doLayout(shallow, force)
                w.doLayout(true); // doLayout(shallow, force)
                //~ t.params_panel.on('afterlayout',update,t,{single:true});
            });
        };
        Lino.do_when_visible(this.params_panel, update);
        this.params_panel.on('show',update);
        this.params_panel.on('hide',update);
        //~ this.params_panel.on('bodyresize',update);
        this.params_panel.on('afterlayout',update);
        //~ this.params_panel.on('afterlayout',update,this,{single:true});
        //~ this.params_panel.on('bodyresize',update,this,{single:true});
        //~ this.params_panel.on('resize',update,this,{single:true});
        //~ this.params_panel.on('render',update,this,{single:true});
        
        // this.params_panel.on('render',
        //~ this.params_panel.on('afterlayout',update,this,{single:true,delay:200});
        //~ this.params_panel.on('bodyresize',update,this,{single:true,delay:200});
        this.toggle_params_panel_btn = new Ext.Button({ scope:this, 
          //~ text: "$_("[parameters]")", // gear
          iconCls: 'x-tbar-database_gear',
          tooltip:"Parameter-Panel ein- bzw. ausblenden",
          enableToggle: true,
          //~ pressed: ! this.params_panel.hidden,
          pressed: ! this.params_panel_hidden,
          toggleHandler: function(btn,state) { 
            //~ console.log("20120210 add_params_panel",state,this.params_panel);
            if (state) {
                this.params_panel.show();
            } else {
                this.params_panel.hide();
            }
            //~ this.params_panel.on('afterlayout',update,this,{single:true});
            //~ t.get_containing_window().doLayout();
            //~ this.params_panel.on('afterlayout',function() {
                //~ console.log("20130918 afterlayout");
                //~ t.get_containing_window().doLayout(); // doLayout(shallow, force)
            //~ },this,{single:true});
          }
        }); 
        tbar = tbar.concat([this.toggle_params_panel_btn]);

        if (this.auto_apply_params) {
            var refresh = function() {
                if (!t.setting_param_values) {
                    t._force_dirty = true; 
                    t.refresh();
                }
            }
            Ext.each(this.params_panel.fields,function(f) {
              //~ f.on('valid',function() {t.refresh()});
              if (f instanceof Ext.form.Checkbox) {
                  f.on('check',refresh);
              } else if (f instanceof Ext.DatePicker) {
                  f.on('select',refresh);
              } else if (f instanceof Ext.form.TriggerField) {
                  f.on('select',refresh);
                  //~ f.on('change',refresh);
                  //~ f.on('valid',refresh);
              } else {
                  if (! f.on) 
                      console.log("20121010 no method 'on'",f);
                  else
                      f.on('change',refresh);
                }
              });
        }
      }
      return tbar;
  }
  ,add_param_values : function (p,force_dirty) {
    if (this.params_panel) {
      /* 
      * 20120918 add param_values to the request string 
      * *only if the params_form is dirty*.
      * Otherwise Actor.default_params() would never be used.
      *
      * 20121023 But IntegClients.params_default has non-empty default values. 
      * Users must have the possibility to make them empty.
      * 
      * 20130605 : added `force_dirty` parameter because Checkbox fields don't 
      * mark their form as dirty when check is fired.
      * 
      * 20130721 : `force_dirty` not as a parameter but as 
      * `this._force_dirty` because
      * 
      * 20130915 : both _force_dirty and force_dirty parameter are needed.
      * 
      */
      if (force_dirty || this._force_dirty || this.params_panel.form.isDirty()) {
      //~ if (this._force_dirty || this.params_panel.form.isDirty()) {
        p.pv = this.get_param_values();
        //~ console.log("20130923 form is dirty (",force_dirty,this._force_dirty,this.params_panel.form.isDirty(),")");
        //~ console.log("20130923 form is dirty",p);
      }else{
        //~ console.log("20130923 form not dirty:",this.params_panel.form);
        if (this.status_param_values) 
          p.pv = Lino.fields2array(
            this.params_panel.fields,this.status_param_values);
      }
      //~ if (!this.params_panel.form.isDirty()) return;
      //~ p.pv = this.get_param_values();
      //~ console.log("20120203 add_param_values added pv",p.pv,"to",p);
    }
  },
  get_param_values : function() { // similar to get_field_values()
      return Lino.fields2array(this.params_panel.fields);
  },
  set_param_values : function(pv) {
    if (this.params_panel) {
      //~ console.log('20120203 MainPanel.set_param_values', pv);
      this.status_param_values = pv;
      //~ this.params_panel.form.suspendEvents(false);
      this.setting_param_values = true;
      if (pv) { 
          this.params_panel.form.my_loadRecord(pv);
      } else { 
        this.params_panel.form.reset(); 
      }
      this.setting_param_values = false;
      this._force_dirty = false; 
      //~ this.params_panel.form.resumeEvents();
    }
  }
};




Lino.Viewport = Ext.extend(Ext.Viewport, Lino.MainPanel);
Lino.Viewport = Ext.extend(Lino.Viewport, {
  layout : "fit"
  ,is_home_page : true
  ,initComponent : function(){
    Lino.Viewport.superclass.initComponent.call(this);
    this.on('render',function(){
      this.loadMask = new Ext.LoadMask(this.el,{msg:"Bitte warten..."});
      //~ console.log("20121118 Lino.viewport.loadMask",this.loadMask);
    },this);
  }
  ,refresh : function() {
      var caller = this;
      // console.log("20140829 Lino.Viewport.refresh()");
      if (caller.loadMask) caller.loadMask.show();
      var success = function(response) {
        if (caller.loadMask) caller.loadMask.hide();
        if (response.responseText) {
          var result = Ext.decode(response.responseText);
          //~ console.log('Lino.do_action()',action.name,'result is',result);
          if (result.html) {
              var cmp = Ext.getCmp('dashboard');
              // cmp.removeAll(true);  // 20140829
              cmp.update(result.html, true);
          }
          if (result.message) {
              if (result.alert) {
                  //~ Ext.MessageBox.alert('Alert',result.alert_msg);
                  Ext.MessageBox.alert('Alert',result.message);
              } else {
                  Lino.notify(result.message);
              }
          }
          
          if (result.notify_msg) Lino.notify(result.notify_msg);
          if (result.js_code) { 
            var jsr = result.js_code(caller);
            //~ console.log('Lino.do_action()',action,'returned from js_code in',result);
          };
        }
      };
      var action = {
        url : '/api/main_html',
        waitMsg: "Bitte warten...",
        failure: Lino.ajax_error_handler(caller),
        success: success,
        method: 'GET',
        params: {}
      };
      Lino.insert_subst_user(action.params);
      Ext.Ajax.request(action);
    
  }
});




Lino.open_window = function(win, st, requesting_panel) {
  // console.log("20140831 Lino.open_window()", win, win.el.getBox());
  var cw = Lino.current_window;
  if (cw) {
    // console.log("20140829 Lino.open_window() save current status",
    //             cw.main_item.get_status());
    Lino.window_history.push({
      window:cw,
      status:cw.main_item.get_status()
    });
  }
  Lino.current_window = win;
  //~ if (st.su) 
      //~ Lino.subst_user_field.setValue(st.su);
  win.main_item.set_status(st, requesting_panel);
  // win.toFront();
  win.show();
};

Lino.load_url = function(url) {
    //~ foo.bar.baz = 2; 
    //~ console.log("20121120 Lino.load_url()");
    //~ Lino.body_loadMask.show();
    Lino.viewport.loadMask.show();
    //~ location.replace(url);
    document.location = url;
}

Lino.close_window = function(status_update, norestore) {
  // norestore is used when called by handle_action_result() who 
  // will call set_status itself later
  var cw = Lino.current_window;
  var ww = Lino.window_history.pop();
  var retval = cw.main_item.requesting_panel;
  // console.log(
  //     "20150514 Lino.close_window() going to close", cw.title,
  //     "previous is", ww, 
  //     "norestore is", norestore,
  //     "retval is", retval);
  if (ww) {
    //~ if (status_update) Ext.apply(ww.status,status_update);
    if(!norestore) {
        if (status_update) status_update(ww);
        ww.window.main_item.set_status(ww.status , cw.id);
    }
    Lino.current_window = ww.window;
  } else {
      Lino.current_window = null;
      // new since 20140829:
      if(!norestore) { Lino.viewport.refresh(); }
  }
  if (cw) cw.hide_really();
  return retval;
};

Lino.kill_current_window = function() {
  // console.log("20140418 Lino.kill_current_window()");
  var cw = Lino.current_window;
  Lino.current_window = null;
  if (cw) cw.hide_really();
};

Lino.reload = function() {
    // First close all windows to ensure all changes are saved
    Lino.close_all_windows();

    // Then reload current view
    var url =  "/"

    var p = {};
    Lino.insert_subst_user(p)
    if (Ext.urlEncode(p))
        url = url + "?" + Ext.urlEncode(p);

    Lino.load_url(url);
}

Lino.handle_home_button = function() {
  if (Lino.window_history.length == 0)
      Lino.reload();
  else
      Lino.close_all_windows();
}

Lino.close_all_windows = function() {
    while (Lino.window_history.length > 0) {
        Lino.close_window();
    }
}

Lino.calling_window = function() {
    if (Lino.window_history.length) 
        return Lino.window_history[Lino.window_history.length-1];
}

//~ Lino.WindowAction = function(mainItemClass,windowConfig,mainConfig,ppf) {
Lino.WindowAction = function(windowConfig,main_item_fn) {
    //~ if(!mainConfig) mainConfig = {};
    //~ mainConfig.is_main_window = true;
    this.windowConfig = windowConfig;
    this.main_item_fn = main_item_fn;
    //~ if (ppf) mainConfig.params_panel.fields = ppf;
    //~ this.mainConfig = mainConfig;
    //~ this.mainItemClass = mainItemClass;
};

Lino.WindowAction = Ext.extend(Lino.WindowAction,{
    window : null,
    //~ mainItemClass: null,
    get_window : function() {
      //~ if(mainConfig) Ext.apply(this.mainConfig,mainConfig);
      // if (this.window == null || this.window.isDestroyed)  { // 20140829
      // if (this.window == null || this.window.getBox().width == 0)  { // 20140829
      if (this.window == null)  {
      // if (true)  {
          //~ this.windowConfig.main_item = new this.mainItemClass(this.mainConfig);
          this.windowConfig.main_item = this.main_item_fn();
          this.window = new Lino.Window(this.windowConfig);
      }
      return this.window;
    },
    run : function(requesting_panel, status) {
      // console.log('20140829 window_action.run()', this)
      Lino.open_window(this.get_window(), status, requesting_panel);
    }
  
});


Lino.PanelMixin = {
  get_containing_window : function (){
      if (this.containing_window) return this.containing_window;
      return this.containing_panel.get_containing_window();
  }
  ,set_window_title : function(title) {
    //~ this.setTitle(title);
    var cw = this.get_containing_window();

    //~ if (cw) {
    //~ if (cw && cw.closable) {
    if (cw && !cw.main_item.hide_window_title) {
      //~ console.log('20111202 set_window_title(',title,') for',this.containing_window);
      //~ if (! this.containing_window.rendered) console.log("WARNING: not rendered!");
      cw.setTitle(title);
    //~ } else {
      //~ document.title = title;
    }
    //~ else console.log('20111202 not set_window_title(',title,') for',this);
  }
  
};


// Lino.status_bar = new Ext.ux.StatusBar({defaultText:'Lino version 2016.12.0.'});






/* 
  Originally copied from Ext JS Library 3.3.1
  Modifications by Luc Saffre : 
  - rendering of phantom records
  - fire afteredit event
  - react on dblclcik, not on single click

 */
Lino.CheckColumn = Ext.extend(Ext.grid.Column, {

    processEvent : function(name, e, grid, rowIndex, colIndex){
        //~ console.log('20110713 Lino.CheckColumn.processEvent',name)
        if (name == 'click') {
        //~ if (name == 'mousedown') {
        //~ if (name == 'dblclick') {
            return this.toggleValue(grid, rowIndex, colIndex);
        } else {
            return Ext.grid.ActionColumn.superclass.processEvent.apply(this, arguments);
        }
    },
    
    toggleValue : function (grid,rowIndex,colIndex) {
        var record = grid.store.getAt(rowIndex);
        var dataIndex = grid.colModel.getDataIndex(colIndex);
        // 20120514
        //~ if(record.data.disabled_fields && record.data.disabled_fields[dataIndex]) {
          //~ Lino.notify("Dieses Feld ist deaktiviert");
          //~ return false;
        //~ }
      
        //~ if (dataIndex in record.data['disabled_fields']) {
            //~ Lino.notify("This field is disabled.");
            //~ return false;
        //~ }
        var startValue = record.data[dataIndex];
        var value = !startValue;
        //~ record.set(this.dataIndex, value);
        var e = {
            grid: grid,
            record: record,
            field: dataIndex,
            originalValue: startValue,
            value: value,
            row: rowIndex,
            column: colIndex,
            cancel: false
        };
        if(grid.fireEvent("beforeedit", e) !== false && !e.cancel){
        //~ if(grid.fireEvent("validateedit", e) !== false && !e.cancel){
            record.set(dataIndex, value);
            delete e.cancel;
            grid.fireEvent("afteredit", e);
        }
        return false; // Cancel event propagation
    },

    renderer : function(v, p, record){
        if (record.phantom) return '';
        p.css += ' x-grid3-check-col-td'; 
        return String.format('<div class="x-grid3-check-col{0}">&#160;</div>', v ? '-on' : '');
    }

    // Deprecate use as a plugin. Remove in 4.0
    // init: Ext.emptyFn
});

// register ptype. Deprecate. Remove in 4.0
// Ext.preg('checkcolumn', Lino.CheckColumn);

// backwards compat. Remove in 4.0
// Ext.grid.CheckColumn = Lino.CheckColumn;

// register Column xtype
Ext.grid.Column.types.checkcolumn = Lino.CheckColumn;


/* 20110725 : 
Lino.on_tab_activate is necessary 
in contacts.Person.2.dtl 
(but don't ask me why...)
*/
Lino.on_tab_activate = function(item) {
  //~ console.log('activate',item); 
  if (item.rendered && item.doLayout) item.doLayout();
  //~ if (item.rendered) item.doLayout();
}

Lino.TimeField = Ext.extend(Ext.form.TimeField,{
  format: 'H:i',
  increment: 15
  });
Lino.DateField = Ext.extend(Ext.form.DateField,{
  //~ boxMinWidth: Lino.chars2width(15), // 20131005 changed from 11 to 15
  format: 'd.m.Y',
  altFormats: 'd/m/Y|Y-m-d'
  });
Lino.DatePickerField = Ext.extend(Ext.DatePicker,{
  //~ boxMinWidth: Lino.chars2width(11),
  format: 'd.m.Y',
  //~ altFormats: 'd/m/Y|Y-m-d'
  formatDate : function(date){
      //~ console.log("20121203 formatDate",this.name,date);
      return Ext.isDate(date) ? date.dateFormat(this.format) : date;
  }
  });
Lino.DateTimeField = Ext.extend(Ext.ux.form.DateTime,{
  dateFormat: 'd.m.Y',
  timeFormat: 'H:i'
  //~ ,hiddenFormat: 'd.m.Y H:i'
  });
Lino.URLField = Ext.extend(Ext.form.TriggerField,{
  triggerClass : 'x-form-search-trigger',
  //~ triggerClass : 'x-form-world-trigger',
  vtype: 'url',
  onTriggerClick : function() {
    //~ console.log('Lino.URLField.onTriggerClick',this.value)
    //~ document.location = this.value;
    window.open(this.getValue(),'_blank');
  }
});
Lino.IncompleteDateField = Ext.extend(Ext.form.TextField,{
  //~ regex: /^-?\d+-[01]\d-[0123]\d$/,
  //~ regex: /^[0123]\d\.[01]\d\.-?\d+$/,
  maxLength: 10,
  boxMinWidth: Lino.chars2width(10),
  regex: /^[0123]?\d\.[01]?\d\.-?\d+$/,
  regexText: 'Datum im Format JJJJ-MM-TT eingeben (Nullen für unbekannte Teile)'
  });


//~ Lino.make_dropzone = function(cmp) {
    //~ cmp.on('render', function(ct, position){
      //~ ct.el.on({
        //~ dragenter:function(event){
          //~ event.browserEvent.dataTransfer.dropEffect = 'move';
          //~ return true;
        //~ }
        //~ ,dragover:function(event){
          //~ event.browserEvent.dataTransfer.dropEffect = 'move';
          //~ event.stopEvent();
          //~ return true;
        //~ }
        //~ ,drop:{
          //~ scope:this
          //~ ,fn:function(event){
            //~ event.stopEvent();
            //~ console.log(20110516);
            //~ var files = event.browserEvent.dataTransfer.files;
            //~ if(files === undefined){
              //~ return true;
            //~ }
            //~ var len = files.length;
            //~ while(--len >= 0){
              //~ console.log(files[len]);
              //~ // this.processDragAndDropFileUpload(files[len]);
            //~ }
          //~ }
        //~ }
      //~ });
    //~ });
//~ };

//~ Lino.FileUploadField = Ext.ux.form.FileUploadField;

Lino.FileUploadField = Ext.extend(Ext.ux.form.FileUploadField,{
    unused_onRender : function(ct, position){
      Lino.FileUploadField.superclass.onRender.call(this, ct, position);
      this.el.on({
        dragenter:function(event){
          event.browserEvent.dataTransfer.dropEffect = 'move';
          return true;
        }
        ,dragover:function(event){
          event.browserEvent.dataTransfer.dropEffect = 'move';
          event.stopEvent();
          return true;
        }
        ,drop:{
          scope:this
          ,fn:function(event){
            event.stopEvent();
            //~ console.log(20110516);
            var files = event.browserEvent.dataTransfer.files;
            if(files === undefined){
              return true;
            }
            var len = files.length;
            while(--len >= 0){
              console.log(files[len]);
              //~ this.processDragAndDropFileUpload(files[len]);
            }
          }
        }
      });
    }
});

Lino.FileField = Ext.extend(Ext.form.TriggerField,{
  triggerClass : 'x-form-search-trigger',
  editable: false,
  onTriggerClick : function() {
    //~ console.log('Lino.URLField.onTriggerClick',this.value)
    //~ document.location = this.value;
    if (this.getValue()) window.open(MEDIA_URL + '/'+this.getValue(),'_blank');
  }
});

Lino.file_field_handler = function(panel,config) {
  if (panel.action_name == 'insert') {
      panel.has_file_upload = true;


      // config.value = '<br/><br/>';

      var f = new Lino.FileUploadField(config);
      //~ Lino.make_dropzone(f);
      return f;
      //~ return new Ext.ux.form.FileUploadField(config);
      //~ return new Lino.FileField(config);
      
  } else {
      //~ return new Lino.URLField(config);
      return new Lino.FileField(config);
  }
}

Lino.VBorderPanel = Ext.extend(Ext.Panel,{
    constructor : function(config) {
      config.layout = 'border';
      delete config.layoutConfig;
      Lino.VBorderPanel.superclass.constructor.call(this,config);
      for(var i=0; i < this.items.length;i++) {
        var item = this.items.get(i);
        if (this.isVertical(item) && item.collapsible) {
          item.on('collapse',this.onBodyResize,this);
          item.on('expand',this.onBodyResize,this);
        }
      }
    },
    isVertical : function(item) {
       return (item.region == 'north' || item.region == 'south' || item.region == 'center');
    },
    onBodyResize: function(w, h){
        //~ console.log('VBorderPanel.onBodyResize',this.title)
      if (this.isVisible()) { // to avoid "Uncaught TypeError: Cannot call method 'getHeight' of undefined."
        var sumflex = 0;
        var availableHeight = this.getInnerHeight();
        var me = this;
        this.items.each(function(item){
          if (me.isVertical(item)) {
              if (item.collapsed || item.flex == 0 || item.flex === undefined) {
                  if (item.rendered) availableHeight -= item.getHeight();
              } else {
                  sumflex += item.flex;
              }
          } 
          
        });
        //~ for(var i=0; i < this.items.length;i++) {
          //~ var item = this.items.get(i);
          //~ // if (this.isVertical(item) && item.getResizeEl()) {
          //~ if (this.isVertical(item)) {
              //~ if (item.collapsed || item.flex == 0 || item.flex === undefined) {
                  //~ // item.syncSize()
                  //~ // item.doLayout()
                  //~ // if (item.region == "north") console.log('region north',item.getHeight(),item.id, item);
                  //~ // if (item.getHeight() == 0) console.log(20100921,'both flex and getHeight() are 0!');
                  //~ availableHeight -= item.getHeight();
              //~ } else {
                  //~ sumflex += item.flex;
                  //~ // console.log(item.flex);
              //~ }
          //~ } 
          //~ // else console.log('non-vertical item in VBoderPanel:',item)
        //~ }
        var hunit = availableHeight / sumflex;
        //~ console.log('sumflex=',sumflex,'hunit=',hunit, 'availableHeight=',availableHeight);
        for(var i=0; i < this.items.length;i++) {
          var item = this.items.get(i);
          if (this.isVertical(item)) {
              if (item.flex != 0 && ! item.collapsed) {
                  item.setHeight(hunit * item.flex);
                  //~ console.log(item.region,' : height set to',item.getHeight());
              }
          }
          //~ else console.log('non-vertical item in VBoderPanel:',item)
        }
      }
      Lino.VBorderPanel.superclass.onBodyResize.call(this, w, h);
    }
});


/*
  modifications to the standard behaviour of a CellSelectionModel:
  
*/
Ext.override(Ext.grid.CellSelectionModel, {
//~ var dummy = {

    handleKeyDown : function(e){
        /* removed because F2 wouldn't pass
        if(!e.isNavKeyPress()){
            return;
        }
        */
        //~ console.log('handleKeyDown',e)
        var k = e.getKey(),
            g = this.grid,
            s = this.selection,
            sm = this,
            walk = function(row, col, step){
                return g.walkCells(
                    row,
                    col,
                    step,
                    g.isEditor && g.editing ? sm.acceptsNav : sm.isSelectable, 
                    sm
                );
            },
            cell, newCell, r, c, ae;

        switch(k){
            case e.ESC:
            case e.PAGE_UP:
            case e.PAGE_DOWN:
                break;
            default:
                // e.stopEvent(); // removed because Browser keys like Alt-Home, Ctrl-R wouldn't work
                break;
        }

        if(!s){
            cell = walk(0, 0, 1); 
            if(cell){
                this.select(cell[0], cell[1]);
            }
            return;
        }

        cell = s.cell;
        r = cell[0];    
        c = cell[1];    
        
        switch(k){
            case e.TAB:
                if(e.shiftKey){
                    newCell = walk(r, c - 1, -1);
                }else{
                    newCell = walk(r, c + 1, 1);
                }
                break;
            case e.HOME:
                if (! (g.isEditor && g.editing)) {
                  if (!e.hasModifier()){
                      newCell = [r, 0];
                      //~ console.log('home',newCell);
                      break;
                  }else if(e.ctrlKey){
                      var t = g.getTopToolbar();
                      var activePage = Math.ceil((t.cursor + t.pageSize) / t.pageSize);
                      if (activePage > 1) {
                          e.stopEvent();
                          t.moveFirst();
                          return;
                      }
                      newCell = [0, c];
                      break;
                  }
                }
            case e.END:
                if (! (g.isEditor && g.editing)) {
                  c = g.colModel.getColumnCount()-1;
                  if (!e.hasModifier()) {
                      newCell = [r, c];
                      //~ console.log('end',newCell);
                      break;
                  }else if(e.ctrlKey){
                      var t = g.getTopToolbar();
                      var d = t.getPageData();
                      if (d.activePage < d.pages) {
                          e.stopEvent();
                          var self = this;
                          t.on('change',function(tb,pageData) {
                              var r = g.store.getCount()-2;
                              self.select(r, c);
                              //~ console.log('change',r,c);
                          },this,{single:true});
                          t.moveLast();
                          return;
                      } else {
                          newCell = [g.store.getCount()-1, c];
                          //~ console.log('ctrl-end',newCell);
                          break;
                      }
                  }
                }
            case e.DOWN:
                newCell = walk(r + 1, c, 1);
                break;
            case e.UP:
                newCell = walk(r - 1, c, -1);
                break;
            case e.RIGHT:
                newCell = walk(r, c + 1, 1);
                break;
            case e.LEFT:
                newCell = walk(r, c - 1, -1);
                break;
            case e.F2:
                if (!e.hasModifier()) {
                    if (g.isEditor && !g.editing) {
                        g.startEditing(r, c);
                        e.stopEvent();
                        return;
                    }
                    break;
                }
            case e.INSERT:
                if (!e.hasModifier()) {
                    if (g.ls_insert_handler && !g.editing) {
                        e.stopEvent();
                        Lino.show_insert(g);
                        return;
                    }
                    break;
                }
            // case e.DELETE:
            //     if (!e.hasModifier()) {
            //         if (!g.editing) {
            //             e.stopEvent();
            //             Lino.delete_selected(g);
            //             return;
            //         }
            //         break;
            //     }

            case e.ENTER:
                e.stopEvent();
                g.onCellDblClick(r,c);
                break;

            default:
                g.handle_key_event(e);
                
        }
        

        if(newCell){
          e.stopEvent();
          r = newCell[0];
          c = newCell[1];
          this.select(r, c); 
          if(g.isEditor && g.editing){ 
            ae = g.activeEditor;
            if(ae && ae.field.triggerBlur){
                ae.field.triggerBlur();
            }
            g.startEditing(r, c);
          }
        //~ } else if (g.isEditor && !g.editing && e.charCode) {
        //~ // } else if (!e.isSpecialKey() && g.isEditor && !g.editing) {
            //~ g.set_start_value(String.fromCharCode(e.charCode));
            //~ // g.set_start_value(String.fromCharCode(k));
            //~ // g.set_start_value(e.charCode);
            //~ g.startEditing(r, c);
            //~ // e.stopEvent();
            //~ return;
        // } else {
          // console.log('20120513',e,g);
        }
        
    }


//~ };
});

 

function PseudoConsole() {
    this.log = function() {};
};
if (typeof(console) == 'undefined') console = new PseudoConsole();

Lino.notify = function(msg) {
  if (msg == undefined) msg = ''; else console.log(msg);
  
    if (msg == undefined) return;
    // Lino.alert(msg);
  
};

Lino.alert = function(msg) {
  Ext.MessageBox.alert('Notify',msg);
};


//~ Lino.show_about = function() {
  //~ new Ext.Window({
    //~ width: 400, height: 400,
    //~ title: "About",
    //~ html: '<a href="http://www.extjs.com" target="_blank">ExtJS</a> version ' + Ext.version
  //~ }).show();
//~ };

function obj2str(o) {
  if (typeof o != 'object') return String(o);
  var s = '';
  for (var p in o) {
    s += p + ': ' + obj2str(o[p]) + '\n';
  }
  return s;
}

Lino.on_store_exception = function (store,type,action,options,response,arg) {
  //~ throw response;
  console.log("on_store_exception: store=",store,
    "type=",type,
    "action=",action,
    "options=",options,
    "response=",response,
    "arg=",arg);
    if (arg != undefined && arg) { console.log(arg.stack)};
    var msg = "There was a problem with the database connection.";
    if (response.responseText)
        msg += '<br/>' + response.responseText
    msg += '<br/>' + "If the error persists, try reloading the browser page."
    Ext.Msg.alert("Database problem", msg );
    
};

//~ Lino.on_submit_success = function(form, action) {
   //~ Lino.notify(action.result.message);
   //~ this.close();
//~ };

Lino.on_submit_failure = function(form, action) {
    //~ Lino.notify();
  // action may be undefined
    switch (action.failureType) {
        case Ext.form.Action.CLIENT_INVALID:
            Ext.Msg.alert('Client-side failure', 'Form fields may not be submitted with invalid values');
            break;
        case Ext.form.Action.CONNECT_FAILURE:
            Ext.Msg.alert('Connection failure', 'Ajax communication failed');
            break;
        case Ext.form.Action.SERVER_INVALID:
            Ext.Msg.alert('Server-side failure', action.result.message);
   }
};



/*
Lino.save_wc_handler = function(ww) {
  return function(event,toolEl,panel,tc) {
    var pos = panel.getPosition();
    var size = panel.getSize();
    wc = ww.get_window_config();
    Ext.applyIf(wc,{ 
      x:pos[0],y:pos[1],height:size.height,width:size.width,
      maximized:panel.maximized});
    Lino.do_action(ww,{url:'/window_configs/'+ww.config.permalink_name,params:wc,method:'POST'});
  }
};

*/

Lino.show_in_own_window_button = function(handler) {
  return {
    qtip: "Dieses Panel in eigenem Fenster öffnen", 
    id: "up",
    handler: function(event,toolEl,panel, tc) {
      //~ console.log('20111206 report_window_button',panel,handler);
      handler.run(null,{base_params:panel.containing_panel.get_master_params()});
    }
  }
}

Lino.action_handler = function (panel, on_success, on_confirm) {
  return function (response) {
      if (!panel) { 
          if (Lino.current_window) 
              panel = Lino.current_window.main_item;
          else panel = Lino.viewport;
      }
      
    if (panel.loadMask) panel.loadMask.hide(); // 20120211
    if (!response.responseText) return ;
    var result = Ext.decode(response.responseText);
    Lino.handle_action_result(panel, result, on_success, on_confirm);
  }
};

Lino.handle_action_result = function (panel, result, on_success, on_confirm) {

    // console.log('20150514 Lino.handle_action_result()', result);
    
    // if (panel instanceof Lino.GridPanel) {
    //     gridmode = true;
    // } else {
    //     gridmode = false;
    // }

    //~ if (result.goto_record) {
        //~ var js = "Lino." + result.goto_record[0] + '.detail.run';
        //~ var h = eval(js);
        //~ h(panel,{record_id:result.goto_record[1]});
    //~ }
    
    if (result.xcallback) {
        //~ var config = {title:"Bestätigung"};
        var config = {title:result.xcallback.title};
        //~ config.buttons = Ext.MessageBox.YESNOCANCEL;
        //~ config.buttons = Ext.MessageBox.YESNO;
        var p = {};
        Lino.insert_subst_user(p);
        config.buttons = result.xcallback.buttons;
        config.msg = result.message;
        config.fn = function(buttonId, text, opt) {
          panel.loadMask.show(); 
          //~ Lino.insert_subst_user(p);
          Ext.Ajax.request({
            method: 'GET',
            url: '/callbacks/'
                  + result.xcallback.id + '/' + buttonId,
            params: p,
            failure: Lino.ajax_error_handler(panel),
            success: Lino.action_handler(panel, on_success, on_confirm)
          });
        }
        Ext.MessageBox.show(config);
        return;
    }

    // `record_id` and/or `data_record` both mean "display the detail
    // of this record". 
    
    if(result.detail_handler_name) {
        // TODO: make sure that result.detail_handler_name is secure
        var detail_handler = eval("Lino." + result.detail_handler_name);
    }
    var ns = {};  // new status
    if (result.close_window) {
        
        // Subsequent processing expects that `panel` is "the current
        // panel". But if we close the window, `panel` must point
        // to the previous window. Note the case of an insert window
        // that has been invoked by double-clicking on the phantom row
        // of a slave table in a detail window. In that case we want
        // `panel` to become the grid panel of the slave table who
        // called the insert window, not the master's detail form
        // panel.  When the insert window has been called by an action
        // link (e.g. generated using ar.insert_button), then
        // Lino.close_window can return `undefined`.

        if(result.record_id || result.data_record) {
            var ww = Lino.calling_window();
            if (ww && ww.window.main_item instanceof Lino.FormPanel) {
                if (ww.window.main_item.ls_detail_handler == detail_handler) {
                    ns.record_id = result.record_id;
                    ns.data_record = result.data_record;
                    // console.log("20150514 use new status.");
                }
            }
        }

        panel = Lino.close_window(
            function(ww) { Ext.apply(ww.status, ns) }); 
        if (!panel) 
            // console.log("20150514 close_window returned no panel.");
            if (Lino.current_window)
                panel = Lino.current_window.main_item;

    }

    if(result.record_id || result.data_record) {
        if (! (ns.record_id || ns.data_record)) {
          // no close_window, so we must update record data in current
          // panel (if it is the detail_handler for this record) or
          // open the detail handler.
          var st = {
              record_id: result.record_id,
              data_record: result.data_record
          };
          if (result.active_tab) st.active_tab = result.active_tab;
          if (panel instanceof Lino.FormPanel 
              && panel.ls_detail_handler == detail_handler) 
            {
              // console.log("20150514 use panel.set_status().");
              panel.set_status(st);
          } else {
              // console.log("20150514 run detail_handler.");
              st.base_params = panel.get_base_params();
              detail_handler.run(null, st);
          }

          // if (panel instanceof Lino.FormPanel 
          //     && panel.ls_url == result.actor_url) {
          //     // console.log("20140506 case 2 it's a FormPanel:", panel);
          //     panel.set_status({
          //         record_id: result.record_id,
          //         data_record: result.data_record});
          // } else if (panel.ls_detail_handler 
          //            && panel.ls_url == result.actor_url) {
          //     // console.log("20140506 case 4");
          //     panel.ls_detail_handler.run(null, {
          //         record_id: result.record_id,
          //         data_record: result.data_record,
          //         base_params: panel.get_base_params()});
          // } else {
          //     result.refresh_all = true;
          //     console.log("20140604 case 6", result.actor_url);
          // }
        }
    }

    // `eval_js` must get handled after `close_window` because it
    // might ask to open a new window (and we don't want to close that
    // new window).  It must execute *before* any MessageBox,
    // otherwise the box would get hidden by a window that opens
    // afterwards.

    if (result.eval_js) {
        //~ console.log(20120618,result.eval_js);
        eval(result.eval_js);
    }
    
    if (on_success && result.success) {
        // console.log("20140430 handle_action_result calls on_success", 
        //             on_success);
        on_success(result);
    }
    
    if (result.info_message) {
        console.log(result.info_message);
    }
    
    if (result.warning_message) {
        if (!result.alert) result.alert = "Warnung";
        Ext.MessageBox.alert(result.alert, result.warning_message);
    }
    
    if (result.message) {
        //~ if (result.alert && ! gridmode) {
        if (result.alert) { // 20120628b 
            //~ Ext.MessageBox.alert('Alert',result.alert_msg);
            if (result.alert === true) result.alert = "Alarm";
            Ext.MessageBox.alert(result.alert, result.message);
        } else {
            Lino.notify(result.message);
        }
    }

    if(result.record_deleted && panel.ls_detail_handler == detail_handler) {
        panel.after_delete();
    }
    
    if (result.refresh_all) {
        var cw = Lino.current_window;
        // var cw = panel.get_containing_window();
        if (cw) {
            // console.log("20140917 refresh_all calls refresh on", cw.main_item);
            cw.main_item.refresh();
        } else { Lino.viewport.refresh(); }
        // else console.log("20140917 cannot refresh_all because ",
        //                  "there is no current_window");
    } else {
        if (result.refresh) {
            // console.log("20140917 Gonna call panel.refresh()", panel);
            panel.refresh();
        }
    }if (result.goto_url) document.location = result.goto_url;
    if (result.open_url) {
        //~ console.log(20111126,result.open_url);
        //~ if (!result.message)
            //~ Lino.notify('Open new window <a href="'+result.open_url+'" target="_blank">'+result.open_url+'</a>');
        window.open(result.open_url,'foo',"");
        //~ document.location = result.open_url;
    }
};

// obsolete but still used for deleting records.
Lino.do_action = function(caller,action) { 
  action.success = function(response) {
    if (caller.loadMask) caller.loadMask.hide();
    //~ console.log('Lino.do_action()',action,'action success',response);
    if (action.after_success) {
        //~ console.log('Lino.do_action() calling after_success');
        action.after_success();
    }
    if (response.responseText) {
      var result = Ext.decode(response.responseText);
      //~ console.log('Lino.do_action()',action.name,'result is',result);
      if (result.message) {
          if (result.alert) {
              //~ Ext.MessageBox.alert('Alert',result.alert_msg);
              Ext.MessageBox.alert('Alert',result.message);
          } else {
              Lino.notify(result.message);
          }
      }
      
      //~ if (result.alert_msg) Ext.MessageBox.alert('Alert',result.alert_msg);
      //~ if (result.message) Lino.notify(result.message);
      if (result.notify_msg) Lino.notify(result.notify_msg);
      if (result.js_code) { 
        //~ console.log('Lino.do_action()',action,'gonna call js_code in',result);
        var jsr = result.js_code(caller);
        //~ console.log('Lino.do_action()',action,'returned from js_code in',result);
        if (action.after_js_code) {
          //~ console.log('Lino.do_action()',action,'gonna call after_js_code');
          action.after_js_code(jsr);
          //~ console.log('Lino.do_action()',action,'returned from after_js_code');
        //~ } else {
          //~ console.log('Lino.do_action()',action,' : after_js_code is false');
        }
      };
    }
  };
  Ext.applyIf(action,{
    waitMsg: "Bitte warten...",
    failure: Lino.ajax_error_handler(caller),
    params: {}
  });
  //~ action.params.su = Lino.subst_user;
  Lino.insert_subst_user(action.params);
  
  Ext.Ajax.request(action);
};

//~ Lino.gup = function( name )
//~ {
  //~ // Thanks to http://www.netlobo.com/url_query_string_javascript.html
  //~ name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
  //~ var regexS = "[\\?&]"+name+"=([^&#]*)";
  //~ var regex = new RegExp( regexS );
  //~ var results = regex.exec( window.location.href );
  //~ if( results == null )
    //~ return "";
  //~ else
    //~ return results[1];
//~ };

//~ Lino.refresh_handler = function (ww) {
  //~ return function() { 
      //~ console.log('refresh',ww);
      //~ ww.main_item.doLayout(false,true);
      //~ ww.main_item.syncSize();
  //~ }
//~ };

//~ Lino.tools_close_handler = function (ww) {
  //~ return function() { 
      //~ ww.close();
  //~ }
//~ };
Lino.permalink_handler = function (ww) {
  return function() { 
    //~ document.location = ww.main_item.get_permalink();
    //~ console.log('20130723 Lino.permalink_handler',ww);
    
    /* Uncaught TypeError: Cannot read property 'main_item' of null  */
    if (ww) {
        var url = ww.main_item.get_permalink();
    } else {
        var url = Lino.viewport.get_permalink();
    }
    Lino.load_url(url);
  }
};
//~ Lino.run_permalink = function() {
  //~ var plink = Lino.gup('permalink');
  //~ if(plink) { eval('Lino.'+plink); }
//~ }


Lino.ajax_error_handler = function(panel) {
  return function(response,options) {
    console.log('Ajax failure:', response, options);
    if (panel.loadMask) panel.loadMask.hide();
    if (response.responseText) {
      var lines = response.responseText.split('\n');
      if (lines.length > 10) {
          line = lines.splice(5, lines.length-10, "(...)");
      }
      //~ console.log(20131005, response.statusText.toCamel());
      Ext.MessageBox.alert(
        response.statusText.toCamel(),
        lines.join('<br/>')
        //~ response.responseText.replace(/\n/g,'<br/>'))
      )
    } else {
      Ext.MessageBox.alert('Action failed',
        'Lino server did not respond to Ajax request');
    }
  }
}
// Ext.Ajax.on('requestexception',Lino.ajax_error_handler)
 


Ext.QuickTips.init();

/* setting QuickTips dismissDelay to 0 */
// Apply a set of config properties to the singleton
//~ Ext.apply(Ext.QuickTips.getQuickTip(), {
//~ Ext.apply(Ext.ToolTip, {
    //~ dismissDelay: 0
    //~ autoHide: false,
    //~ closable: true,
    //~ maxWidth: 200,
    //~ minWidth: 100,
    //~ showDelay: 50      // Show 50ms after entering target
    //~ ,trackMouse: true
//~ });


//~ Ext.apply(Ext.QuickTip, {
    //~ dismissDelay: 0,
//~ });
  
Lino.quicktip_renderer = function(title, body) {
  return function(c) {
    //~ if (c instanceof Ext.Panel) var t = c.bwrap; else // 20130129
      if (c instanceof Ext.Panel)
          var t = c.header;
      else // 20130129
          var t = c.getEl();
    // if (title == 'a2btn') console.log(20160829, c, t, body);
    //~ t.dismissDelay = 0;
    Ext.QuickTips.register({
      target: t,
      //~ cls: 'lino-quicktip-classical',
      dismissDelay: 0,
      //~ autoHide: false,
      showDelay: 50,      // Show 50ms after entering target
      //~ title: title,
      text: body
    });
  }
};


  
Lino.help_text_editor = function() {
  //~ var bp = {
      //~ mk:this.content_type,
      //~ mt:1
    //~ };
    //~ console.log(20120202,bp);
  //~ Lino.lino.ContentTypes.detail({},{base_params:bp});
  //~ Lino.lino.ContentTypes.detail.run(null,{record_id:this.content_type});
  Lino.lino.ContentTypes.detail.run(null,{record_id:this.content_type});
}

// Path to the blank image should point to a valid location on your server
//~ Ext.BLANK_IMAGE_URL = MEDIA_URL + '/extjs/resources/images/default/s.gif'; 


// used as Ext.grid.Column.renderer for id columns in order to hide the special id value -99999
Lino.id_renderer = function(value, metaData, record, rowIndex, colIndex, store) {
  //~ if (record.phantom) return '';
  return value;
}

Lino.raw_renderer = function(value, metaData, record, rowIndex, colIndex, store) {
  return value;
}

Lino.text_renderer = function(value, metaData, record, rowIndex, colIndex, store) {
  //~ return "not implemented"; 
  return value;
}

Lino.NullNumberColumn = Ext.extend(Ext.grid.Column, {
    align : 'right', 
    format : '0,000.00/i', 
    renderer : function(value, metaData, record, rowIndex, colIndex, store) {
        // if( colIndex == 3)
        //     console.log(20130128,"NullNumberColumn.renderer",value);
        if (value === null) return '';
        return Ext.util.Format.number(value, this.format);
    }
});


Lino.link_button = function(url) {
    // return '<a href="' + url + '"><img src="/media/lino/extjs/images/xsite/link.png" alt="link_button"></a>'
    return '<a href="' + url + '" style="text-decoration:none;">&#10138;</a>'
}

Lino.fk_renderer = function(fkname,handlername) {
  //~ console.log('Lino.fk_renderer handler=',handler);
  return function(value, metaData, record, rowIndex, colIndex, store) {
    //~ console.log('Lino.fk_renderer',fkname,rowIndex,colIndex,record,metaData,store);
    //~ if (record.phantom) return '';
    if (value) {
        return Lino.link_button('javascript:'+handlername + '.run(null,{record_id:\'' + String(record.data[fkname]) + '\'})")') + value;
        // until 20140822 (clickable foreign keys):
        // var s = '<a href="javascript:' ;
        // s += handlername + '.run(null,{record_id:\'' + String(record.data[fkname]) + '\'})">';
        // s += value + '</a>';
        // return s
    }
    return '';
  }
};

Lino.lfk_renderer = function(panel,fkname) {
  //~ console.log('Lino.fk_renderer handler=',handler);
  var handlername = 'console.log';
  return function(value, metaData, record, rowIndex, colIndex, store) {
    //~ console.log('Lino.fk_renderer',fkname,rowIndex,colIndex,record,metaData,store);
    if (record.phantom) return '';
    if (value) {
        var s = '<a href="javascript:' ;
        s += handlername + '({},{record_id:\'' + String(record.data[fkname]) + '\'})">';
        s += value + '</a>';
        //~ console.log('Lino.fk_renderer',value,'-->',s);
        return s
    }
    return '';
  }
};

//~ Lino.gfk_renderer = function() {
  //~ return function(value, metaData, record, rowIndex, colIndex, store) {
    //~ if (record.phantom) return '';
    //~ console.log('Lino.gfk_renderer',value,colIndex,record,metaData,store);
    //~ return value;
  //~ }
//~ };


Lino.build_buttons = function(panel,actions) {
  //~ console.log("20121006 Lino.build_buttons",actions);
  if (actions) {
    var buttons = Array(actions.length);
    var cmenu = Array(actions.length);
    var keyhandlers = {};
    for (var i=0; i < actions.length; i++) { 
      var a = actions[i];
      if (a.menu) a.menu = Lino.build_buttons(panel,a.menu).bbar;
      buttons[i] = a;
      cmenu[i] = {
            text : a.menu_item_text,
            iconCls : a.iconCls,
            menu : a.menu,
            itemId : a.itemId
          };
      if (a.panel_btn_handler) {
          var h = a.panel_btn_handler.createCallback(panel);
          if (a.auto_save == true) {
              h = panel.do_when_clean.createDelegate(panel,[true,h]);
          } else if (a.auto_save == null) {
              h = panel.do_when_clean.createDelegate(panel,[false,h]);
          } else if (a.auto_save == false) {
              // h = h;
          } else {
              console.log("20120703 unhandled auto_save value",a)
          }
          buttons[i].handler = h;
          cmenu[i].handler = h;
          if (a.keycode) {
              keyhandlers[a.keycode] = h;
          }
          //~ if (buttons[i].xtype == 'splitbutton') {
              //~ cmenu[i].menu = a.menu;
          //~ } else {
              //~ cmenu[i].handler = h;
          //~ }
      } else {
          console.log("action without panel_btn_handler",a)
          // cmenu[i].handler = a.handler;
      }
    }
    return {
        bbar:buttons, 
        cmenu:new Ext.menu.Menu(cmenu),
        keyhandlers: keyhandlers
    };
  }
}

Lino.do_when_visible = function(cmp,todo) {
  //~ if (cmp.el && cmp.el.dom) 
  if (cmp.isVisible()) { 
    // 'visible' means 'rendered and not hidden'
    //~ console.log(cmp.title,'-> cmp is visible now');
    todo(); 
  //~ } else {
      //~ cmp.on('resize',todo,cmp,{single:true});
  //~ }
  //~ if (false) { // 20120213
  } else { 
    //~ console.log('Lino.do_when_visible() must defer because not isVisible()',todo,cmp);
    if (cmp.rendered) {
      //~ console.log(cmp,'-> cmp is rendered but not visible: and now?');
      //~ console.log(cmp.title,'-> cmp is rendered but not visible: try again in a moment...');
      //~ var fn = function() {Lino.do_when_visible(cmp,todo)};
      //~ fn.defer(100);
      
      Lino.do_when_visible.defer(50,this,[cmp,todo]);
      //~ Lino.do_when_visible.defer(100,this,[cmp,todo]);
      
    } else {
      //~ console.log(cmp.title,'-> after render');
      cmp.on('afterrender',todo,cmp,{single:true});
    }
  }
  
};    

/*
*/
Lino.do_on_current_record = function(panel, fn, phantom_fn) {
  // console.log('20140930 do_on_current_record', arguments);
  var rec = panel.get_current_record();
  if (rec == undefined) {
    Lino.notify("There's no selected record.");
    return;
  }
  // 20120307 A VirtualTable with a Detail (lino.Models) has only "phantom" records.
  if (rec.phantom) {
    //~ if (!panel.editable) { console.log("20120312 not editable:",panel)}
    if (phantom_fn) {
      phantom_fn(panel);
    } else {
      Lino.notify("Aktion nicht verfügbar auf dem Phantom-Record.");
    }
    return;
  }
  return fn(rec);
};


Lino.call_ajax_action = function(
    panel, method, url, p, actionName, step, on_confirm, on_success) {
  p.an = actionName;
  if (!panel || !panel.isVisible()) {
  //~ if (true) { // 20131026 : workflow_actions of a newly created record detail executed but did't refresh the screen because their requesting panel was the insert (not the detail) formpanel.
      if (Lino.current_window) 
          panel = Lino.current_window.main_item;
      else panel = Lino.viewport;
  }
  // console.log("20150130 a", p.pv);
  // Ext.apply(p, panel.get_base_params());
  // console.log("20150130 b", p.pv);

  if (panel.get_selected) {
      var selected_recs = panel.get_selected();
      //~ console.log("20130831",selected_recs);
      var rs = Array(selected_recs.length);
      for(var i=0; i < selected_recs.length;i++) {
          rs[i] = selected_recs[i].data.id;
      };
      p.sr = rs;
  }
  
  // console.log("20170731 Lino.call_ajax_action", Ext.Ajax, p, actionName, step);
  
  if (panel.loadMask) panel.loadMask.show(); 
    
  // Ext.Ajax.params = {}; 
  Ext.Ajax.request({
    method: method
    ,url: url
    ,params: p
    ,success: Lino.action_handler(panel, on_success, on_confirm)
    ,failure: Lino.ajax_error_handler(panel)
  });
};




Lino.row_action_handler = function(actionName, hm, pp) {
  var p = {};
  var fn = function(panel, btn, step) {
      // console.log('20150514 row_action_handler');
      if (pp) { p = pp(panel); if (! p) return; }
      
      if (!panel || panel.get_current_record == undefined) { // AFTER_20130725
        // console.log('20140930 row_action_handler 2', panel);
        panel = Ext.getCmp(panel);
        if (panel == undefined) {
          console.log("20160410 Invalid panel spec.", actionName, hm, pp);
          Lino.notify("Invalid panel spec.");
          return;
        }
      }
      
      Lino.do_on_current_record(panel, function(rec) {
          //~ console.log(panel);
          panel.add_param_values(p, true);
          Ext.apply(p, panel.get_base_params());
          Lino.call_ajax_action(
              panel, hm, panel.get_record_url(rec.id), 
              p, actionName, step, fn);
      });
  };
  return fn;
};

Lino.list_action_handler = function(ls_url,actionName,hm,pp) {
  var p = {};
  var url = '/api' + ls_url
  var fn = function(panel,btn,step) {
      //~ console.log("20121210 Lino.list_action_handler",arguments);
      if (pp) { p = pp(panel);  if (! p) return; }
      if (panel) { // may be undefined when called e.g. from quicklink
          panel.add_param_values(p, true);
          Ext.apply(p, panel.get_base_params());
      }
      Lino.call_ajax_action(panel, hm,url, p, actionName, step, fn);
  };
  return fn;
};

Lino.param_action_handler = function(window_action) { // 20121012
  var fn = function(panel,btn,step) {
    Lino.do_on_current_record(panel,function(rec) {
      window_action.run(panel.getId(),{}); 
    });
  };
  return fn;
};


Lino.run_row_action = function(
    requesting_panel, is_on_main_actor, url, meth, pk,
    actionName, params, preprocessor) {
  //~ var panel = action.get_window().main_item;
  // console.log("20140930 Lino.run_row_action", params);
  url = '/api' + url  + '/' + pk;
  var panel = Ext.getCmp(requesting_panel);
  // var params = {}
  // if (init_params) Ext.apply(params, init_params);
  if (!params) params = {};
  if (preprocessor) {
      var p = preprocessor(); 
      Ext.apply(params, p);
  }
  if (panel && is_on_main_actor) {
      Ext.apply(params, panel.get_base_params())
  } else {
      // 20170731
      // params.pv = Array();
      // delete params.pv;
      Lino.insert_subst_user(params);
  }
  var fn = function(panel, btn, step) {
    Lino.call_ajax_action(panel, meth, url, params, actionName, step, fn);
  }
  fn(panel, null, null);
}


Lino.show_detail = function(panel, btn) {
  Lino.do_on_current_record(panel, 
    function(rec) {
      //~ panel.loadMask.show();
      Lino.run_detail_handler(panel, rec.id);
    },
    Lino.show_insert
  );
};

Lino.run_detail_handler = function(panel,pk) {
  var bp = panel.get_base_params();
  panel.add_param_values(bp); // 20120918
  var status = {
    record_id:pk,
    base_params:bp
  }
  //~ console.log("20120918 Lino.show_detail",status);
  panel.ls_detail_handler.run(null,status);
}

Lino.show_fk_detail = function(combo,detail_action,insert_action) {
    //~ console.log("Lino.show_fk_detail",combo,handler);
    pk = combo.getValue();
    if (pk) {
        detail_action.run(null,{record_id: pk})
      } else {
        insert_action.run(null);
        //~ Lino.notify("Cannot show detail for empty foreign key.");
      }
};

Lino.show_insert = function(panel,btn) {
  var bp = panel.get_base_params();
  //~ console.log('20120125 Lino.show_insert',bp)
  //~ panel.ls_insert_handler.run(null,{record_id:-99999,base_params:bp});
  panel.ls_insert_handler.run(panel.getId(),{base_params:bp});
};



if (Ext.ux.grid !== undefined) {
    Lino.GridFilters = Ext.extend(Ext.ux.grid.GridFilters,{
      encode:true,
      local:false
    });
} else {
    Lino.GridFilters = function() {}; // dummy
    Ext.override(Lino.GridFilters,{
      init : function() {}
    });
};



Lino.FieldBoxMixin = {
  before_init : function(config,params) {
    if (params) Ext.apply(config,params);
    var actions = Lino.build_buttons(this, config.ls_bbar_actions);
    if (actions) config.bbar = actions.bbar;
  },
  //~ constructor : function(ww,config,params){
    //~ this.containing_window = ww;
    //~ if (params) Ext.apply(config,params);
    //~ var actions = Lino.build_buttons(this,config.ls_bbar_actions);
    //~ if (actions) config.bbar = actions.bbar;
    //~ Lino.FieldBoxMixin.superclass.constructor.call(this, config);
  //~ },
  do_when_clean : function(auto_save,todo) { todo() },
  //~ format_data : function(html) { return '<div class="htmlText">' + html + '</div>' },
  format_data : function(html) { return html },
  get_base_params : function() {
    // needed for insert action
    var p = Ext.apply({}, this.base_params);
    Lino.insert_subst_user(p);
    return p;
  },
  set_base_params : function(p) {
    this.base_params = Ext.apply({},p);
    //~ if (p.param_values) this.set_param_values(p.param_values);  
  },
  clear_base_params : function() {
      this.base_params = {};
      Lino.insert_subst_user(this.base_params);
  },
  set_base_param : function(k,v) {
    this.base_params[k] = v;
  }
};

Ext.override(Ext.form.HtmlEditor, {
    fixKeys : function(){
        if(Ext.isIE){
            return function(e){
                var k = e.getKey(),
                    doc = this.getDoc(),
                        r;
                if(k == e.TAB){
                    e.stopEvent();
                    r = doc.selection.createRange();
                    if(r){
                        r.collapse(true);
                        r.pasteHTML('&nbsp;&nbsp;&nbsp;&nbsp;');
                        this.deferFocus();
                    }
                }else if(k == e.ENTER){
                    r = doc.selection.createRange();
                    if(r){
                        var target = r.parentElement();
                        if(!target || target.tagName.toLowerCase() != 'li'){
                            e.stopEvent();
                            r.pasteHTML('<br />');
                            r.collapse(false);
                            r.select();
                        }
                    }
                }
            };
        }else if(Ext.isOpera){
            return function(e){
                var k = e.getKey();
                if(k == e.TAB){
                    e.stopEvent();
                    this.win.focus();
                    this.execCmd('InsertHTML','&nbsp;&nbsp;&nbsp;&nbsp;');
                    this.deferFocus();
                }
            };
        }else if(Ext.isWebKit){
            // HKC : this is probably our most used case.
            return function(e){
                var k = e.getKey();
                if(k == e.TAB){
                    e.stopEvent();
                    this.execCmd('InsertText','\t');
                    this.deferFocus();
                }else if(k == e.ENTER){
                    e.stopEvent();
                    this.execCmd('InsertHtml','<br /><br />');
                    this.deferFocus();
                }
             //   HKC
               else if (k == e.S && e.ctrlKey){
                    e.stopEvent();
                    e.preventDefault();
                    //this.getWin.fireEvent('keyup');
                    // this.fireKey(e);
                    console.log('HTMLEditor is saving...');
                }
             };
        }
    }(),
    // bubbleEvents : ['keypress']
    // initComponent : function() {
    //     Ext.form.HtmlEditor.superclass.initComponent.call(this);
    //     this.addEvents('submit');
    // },
    // submit : function (event) {
    //     console.log("rrrrr");
    // },
    // initEditor : function() {
    //     Ext.form.HtmlEditor.superclass.initEditor.call(this);
    //     if (Ext.isGecko) {
    //         Ext.EventManager.on(this, 'keypress', this.fireSubmit, this);
    //     }
    //     if (Ext.isIE || Ext.isWebKit || Ext.isOpera) {
    //         Ext.EventManager.on(this, 'keydown', this.fireSubmit,
    //             this);
    //     }
    // },
    fireSubmit : function(e) {
        console.log("fireSubmit ...");
    }
});


Lino.HtmlBoxPanel = Ext.extend(Ext.Panel, Lino.PanelMixin);
Lino.HtmlBoxPanel = Ext.extend(Lino.HtmlBoxPanel, Lino.FieldBoxMixin);
Lino.HtmlBoxPanel = Ext.extend(Lino.HtmlBoxPanel, {
  disabled_in_insert_window : true,
  constructor : function(config,params) {
    this.before_init(config,params);
    Lino.HtmlBoxPanel.superclass.constructor.call(this, config);
  },
  //~ constructor : function(ww,config,params){
    //~ this.ww = ww;
    //~ if (params) Ext.apply(config,params);
    //~ var actions = Lino.build_buttons(this,config.ls_bbar_actions);
    //~ if (actions) config.bbar = actions.bbar;
    //~ Lino.FieldBoxMixin.constructor.call(this, ww,config,params);
  //~ },
  //~ constructor : function(ww,config,params){
    //~ this.ww = ww;
    //~ if (params) Ext.apply(config,params);
    //~ var actions = Lino.build_buttons(this,config.ls_bbar_actions);
    //~ if (actions) config.bbar = actions.bbar;
    //~ Lino.FieldBoxMixin.superclass.constructor.call(this, config);
  //~ },
  //~ disable : function() { var tb = this.getBottomToolbar(); if(tb) tb.disable()},
  //~ enable : function() { var tb = this.getBottomToolbar(); if(tb) tb.enable()},
  onRender : function(ct, position){
    Lino.HtmlBoxPanel.superclass.onRender.call(this, ct, position);
    //~ console.log(20111125,this.containing_window);
    if (this.containing_panel) {
      this.containing_panel.on('enable',this.enable,this);
      this.containing_panel.on('disable',this.disable,this);
    }
    this.el.on({
      dragenter:function(event){
        event.browserEvent.dataTransfer.dropEffect = 'move';
        return true;
      }
      ,dragover:function(event){
        event.browserEvent.dataTransfer.dropEffect = 'move';
        event.stopEvent();
        return true;
      }
      ,drop:{
        scope:this
        ,fn:function(event){
          event.stopEvent();
          //~ console.log(20110516);
          var files = event.browserEvent.dataTransfer.files;
          if(files === undefined){
            return true;
          }
          var len = files.length;
          while(--len >= 0){
            console.log(files[len]);
            //~ this.processDragAndDropFileUpload(files[len]);
          }
          Lino.show_insert(this);
        }
      }
    });
  },
  refresh : function(unused) { 
      // this.containing_panel.refresh();
      this.refresh_with_after();
  },
  /* HtmlBoxPanel */
  refresh_with_after : function(after) {
      // var todo = this.containing_panel.refresh();
      var box = this.items.get(0);
      var todo = function() {
        if (this.disabled) { return; }
        this.set_base_params(this.containing_panel.get_master_params());

        var el = box.getEl();
        if (el) {
            var record = this.containing_panel.get_current_record();
            var newcontent = record ? 
                this.format_data(record.data[this.name]) : '';
            // console.log('20140917 HtmlBox.refresh()',
            //             this.name, record.data.LinksByHuman);
            el.update(newcontent, true);
        // } else {
        //     console.log('20140502 cannot HtmlBox.refresh()',this.name);
        }
      };

      Lino.do_when_visible(box, todo.createDelegate(this));
  }
});
//~ Ext.override(Lino.HtmlBoxPanel,Lino.FieldBoxMixin);


Lino.ActionFormPanel = Ext.extend(Ext.form.FormPanel,Lino.MainPanel);
Lino.ActionFormPanel = Ext.extend(Lino.ActionFormPanel, Lino.PanelMixin);
Lino.ActionFormPanel = Ext.extend(Lino.ActionFormPanel, Lino.FieldBoxMixin);
Lino.ActionFormPanel = Ext.extend(Lino.ActionFormPanel, {
  //~ layout:'fit'
  //~ ,autoHeight: true
  //~ ,frame: true
  window_title : "Action Parameters",
  constructor : function(config){
    config.buttons = [
        {text: 'OK', handler: this.on_ok, scope: this},
        {text: 'Cancel', handler: this.on_cancel, scope: this}
    ];
    Lino.ActionFormPanel.superclass.constructor.call(this, config);
  }
  //~ ,initComponent : function(){
    //~ Lino.ActionFormPanel.superclass.initComponent.call(this);
  //~ }
  ,on_cancel : function() { 
    this.get_containing_window().close();
  }
  ,on_ok : function() { 
    var panel = this.requesting_panel;
    // var panel = this.get_containing_window().main_item;
    // console.log("20131004 on_ok",this,panel,arguments);
    var actionName = this.action_name;
    var pk = this.record_id || this.default_record_id;
    if (pk == undefined && this.base_params) { pk = this.base_params.mk; }
    if (pk == undefined && panel) {
        pk = panel.get_current_record().id;
    }
    if (pk == undefined) {
        // 20170101 VerifyUser action
        pk = '-99998';
        // Lino.alert("Sorry, dialog action without base_params.mk");
        // return;
    }
    var self = this;
    // function on_success() { self.get_containing_window().close(); };
    // see 20131004 and 20140430
    var url = '/api';

    // 20150119 : The OK button on AgentsByClient.create_visit went to
    // /api/pcsw/Clients/ instead of /api/pcsw/Coachings/
    // if (panel) 
    //     url += panel.ls_url;
    // else 
    //     url += this.ls_url;

    if (this.ls_url) 
        url += this.ls_url;
    else 
        url += panel.ls_url;
    url += '/' + pk;
    // wrap into function to prepare possible recursive call
    var fn = function(panel, btn, step) {
      var p = {};
      self.add_field_values(p)
      if (panel) Ext.apply(p, panel.get_base_params());
      delete p.pv;
      // console.log("20150130", p.pv);

      Lino.call_ajax_action(
          panel, 'GET', url, p, actionName, step, fn); //  , on_success);
    }
    fn(panel, null, null);
    
    
  }
  /* ActionFormPanel*/
  ,set_status : function(status, rp){
    this.requesting_panel = Ext.getCmp(rp);
    //~ console.log('20120918 ActionFormPanel.set_status()',status,rp,this.requesting_panel);
    this.clear_base_params();
    if (status == undefined) status = {};
    //~ if (status.param_values) 
    this.set_field_values(status.field_values);
    if (status.base_params) this.set_base_params(status.base_params);
    this.record_id = status.record_id;
  }
  
  ,before_row_edit : function(record) {}
  ,add_field_values : function (p) { // similar to add_param_values()
      /* LS 20160517 : Until now Lino tested whether the form is
       dirty, and if not, submitted only the values which had been set
       by set_status. But now status_field_values can be empty because
       Action.keep_user_values is True. In that case we must submit
       the current values even if the form is not dirty.  I don't
       remember why we had this feature of not submitting unmodified
       field values, so I remove this feature for now. */
      p.fv = this.get_field_values();
      // if (this.form.isDirty()) {
      //   p.fv = this.get_field_values();
      // }else{
      //   // console.log("20160517 add_param_values not dirty, status_field_values",
      //   //             this.status_field_values);
      //   if (this.status_field_values) 
      //     p.fv = Lino.fields2array(
      //         this.fields, this.status_field_values);
      // }
      //~ console.log("20120203 add_param_values added pv",pv,"to",p);
  }
  ,get_field_values : function() {
      return Lino.fields2array(this.fields);
  }
  ,set_field_values : function(pv) {
      // console.log('20160516 MainPanel.set_param_values', pv);
      // if Action.keep_user_values, we receive an empty dict ({})
      this.status_field_values = pv;
      if (pv) {
          this.form.my_loadRecord(pv);
          var record = { data: pv };
          this.before_row_edit(record);
      } else {
          this.form.reset(); 
          this.before_row_edit();
      }
  }
  ,config_containing_window : function(wincfg) { 
      wincfg.title = this.window_title;
      wincfg.keys = [
        { key: Ext.EventObject.ENTER, fn: this.on_ok, scope: this }
      ];
      
      if (!wincfg.defaultButton) this.getForm().items.each(function(f){
          if(f.isFormField){ 
              wincfg.defaultButton = f;
              return false;
          }
      });

  }
});

    
Lino.fields2array = function(fields, values) {
    // console.log('20160517 fields2array gonna loop on', fields, values);
    var pv = Array(fields.length);
    for(var i=0; i < fields.length;i++) {
        var f = fields[i]
        if (values) 
          var v = values[f.name];
        else 
          var v = f.getValue();
        if (f.formatDate) {
            pv[i] = f.formatDate(v); 
        } else {
            pv[i] = v; // f.getValue(); 
        }
    }
    // console.log('20160517 fields2array returns', pv);
    return pv;
}


Lino.FormPanel = Ext.extend(Ext.form.FormPanel,Lino.MainPanel);
Lino.FormPanel = Ext.extend(Lino.FormPanel,Lino.PanelMixin);
Lino.FormPanel = Ext.extend(Lino.FormPanel,{
  params_panel_hidden : false,
  save_action_name : null, 
  //~ base_params : {},
  //~ trackResetOnLoad : true,
  //~ query_params : {},
  //~ 20110119b quick_search_text : '',
  constructor : function(config,params){
    if (params) Ext.apply(config,params);
    this.base_params = {};
    //~ ww.config.base_params.query = ''; // 20111018
    //~ console.log(config);
    //~ console.log('FormPanel.constructor() 1',config)
    //~ Ext.applyIf(config,{base_params:{}});
    //~ console.log('FormPanel.constructor() 2',config)
      
    config.trackResetOnLoad = true;
  
    Lino.FormPanel.superclass.constructor.call(this, config);

    //~ this.set_base_param('$URL_PARAM_FILTER',null); // 20111018
    //~ this.set_base_param('$URL_PARAM_FILTER',''); // 20111018
      
  },
  initComponent : function(){
    
    this.containing_panel = this;

    //~ console.log("20111201 containing_window",this.containing_window,this);
    var actions = Lino.build_buttons(this, this.ls_bbar_actions);
    if (actions) {
        this.bbar = actions.bbar;
        // console.log("20160829 tooltip", actions.bbar);
    //~ } else {
        //~ this.bbar = [];
    }
    //~ Ext.apply(config,Lino.build_buttons(this,config.ls_bbar_actions));
    //~ config.bbar = Lino.build_buttons(this,config.ls_bbar_actions);
    //~ var config = this;
    
    //~ if (this.containing_window instanceof Lino.DetailWrapper) {
    
    //~ console.log('20120121 initComponent', this.action_name);
    //~ if (this.action_name == 'detail' | this.action_name == 'show') {
    //~ if (this.action_name != 'insert') {
    if (! this.hide_top_toolbar) {
      this.tbar = [];
      // 20111015    
      if (! this.hide_navigator) {
        this.record_selector = new Lino.RemoteComboFieldElement({
          store: new Lino.ComplexRemoteComboStore({
            //~ baseParams: this.containing_window.config.base_params,
            baseParams: this.get_base_params(),
            //~ value: this.containing_window.config.base_params.query,
            proxy: new Ext.data.HttpProxy({
              url: '/choices' + this.ls_url,
              method:'GET'
            })
          }),
          pageSize:25,
          listeners: { 
            scope:this, 
            select:function(combo,record,index) {
              //~ console.log('jumpto_select',arguments);
              this.goto_record_id(record.id);
            }
          },
          emptyText: "Gehe zu Datensatz"
        })
        this.tbar = this.tbar.concat([this.record_selector]);
        
        this.tbar = this.tbar.concat([
          this.first = new Ext.Toolbar.Button({
              tooltip:"Erster",disabled:true,
              handler:this.moveFirst,scope:this,iconCls:'x-tbar-page-first'}),
          this.prev = new Ext.Toolbar.Button({
              tooltip:"Voriger",disabled:true,
              handler:this.movePrev,scope:this,iconCls:'x-tbar-page-prev'}),
          this.next = new Ext.Toolbar.Button({
              tooltip:"Nächster",disabled:true,
              handler:this.moveNext,scope:this,iconCls:'x-tbar-page-next'}),
          this.last = new Ext.Toolbar.Button({
              tooltip:"Letzter",disabled:true,
              handler:this.moveLast,scope:this,iconCls:'x-tbar-page-last'})
        ]);
      }
      this.tbar = this.add_params_panel(this.tbar);
      
      this.tbar = this.tbar.concat([
        {
            handler:function(){ this.do_when_clean(
                false, this.refresh.createDelegate(this)) },
          iconCls: 'x-tbar-loading',
          tooltip:"Datensatz neu laden",
          scope:this}
      ]);
          
      if (this.bbar) { // since 20121016
        if (this.tbar) {
            this.tbar = this.tbar.concat(['-']) ;
        } else {
          this.tbar = [];
        }
        this.tbar = this.tbar.concat(this.bbar) ;
        this.bbar = undefined;
      }
    
      this.tbar = this.tbar.concat([
          '->',
          this.displayItem = new Ext.Toolbar.TextItem({})
      ]);
          
    }
    //~ if (this.content_type && this.action_name != 'insert') {
      //~ this.bbar = this.bbar.concat([
        //~ '->',
        //~ { text: "[$_('Help Text Editor')]",
          //~ handler: Lino.help_text_editor,
          //~ qtip: "$_('Edit help texts for fields on this model.')",
          //~ scope: this}
      //~ ])
    //~ }
    //~ this.before_row_edit = config.before_row_edit.createDelegate(this);
      
    //~ if (this.master_panel) {
        //~ this.set_base_params(this.master_panel.get_master_params());
    //~ }
      
    Lino.FormPanel.superclass.initComponent.call(this);

    // this.on('show',
    //         function(){ this.init_focus();}, 
    //         this);
    
    this.on('render',function(){
      this.loadMask = new Ext.LoadMask(this.bwrap,{msg:"Bitte warten..."});
    },this);
    
    
    if (this.action_name == 'insert') {
      this.cascade(function(cmp){
        if (cmp.disabled_in_insert_window) {
            // console.log('20110613 disabled_in_insert_window', cmp);
            //~ cmp.disable();
            cmp.hide();
        }
      });
      
    }
    
  },
  
  unused_init_focus : function(){ 
    // set focus to the first field
    console.log("20140205 Lino.FormPanel.init_focus");
    // Lino.FormPanel.superclass.focus.call(this);
    this.getForm().items.each(function(f){
        if(f.isFormField && f.rendered){ 
            f.focus();
            console.log("20140205 focus", f);
            return false;
        }
    });
  },

  /* FormPanel */
  get_status : function(){
      var st = {
        base_params: this.get_base_params(),
        // data_record : this.get_current_record()
      }
      var rec = this.get_current_record();
      if (rec) st.record_id = rec.id;
      // 20140917 : get_status must not store the whole data_record
      // because that would prevent the form to actually reload
      // when set_status is called after a child window closed.
      
      var tp = this.items.get(0);
      if (tp instanceof Ext.TabPanel) {
        st.active_tab = tp.getActiveTab();
      }
      st.param_values = this.status_param_values;
      return st;
  },

  /* FormPanel */
  set_status : function(status, rp){
    this.requesting_panel = Ext.getCmp(rp);
    // console.log('20140917 FormPanel.set_status()', status);
    this.clear_base_params();
    if (status == undefined) status = {};
    //~ if (status.param_values) 
    this.set_param_values(status.param_values);
    if (status.base_params) this.set_base_params(status.base_params);
    var tp = this.items.get(0);
    if (tp instanceof Ext.TabPanel) {
      if (status.active_tab) {
        //~ console.log('20111201 active_tab',this.active_tab,this.items.get(0));
        //~ tp.activeTab = status.active_tab;
        tp.setActiveTab(status.active_tab);
        //~ this.main_item.items.get(0).activate(status.active_tab);
      } else {
        if (! status.data_record) {  // 20141206
            tp.setActiveTab(0);
        }
      }
    }
    
    if (status.data_record) {
      /* defer because set_window_title() didn't work otherwise */
      // 20140421 removed defer for bughunting to simplify side effects
      // this.set_current_record.createDelegate(
      //     this, [status.data_record]).defer(100);
      this.set_current_record(status.data_record);
      //~ return;
    } else {
        var record_id = status.record_id || this.default_record_id;
        if (record_id != undefined) { 
          /* possible values include 0 and null, 0 being a valid record id, 
          null the equivalent of undefined
          */
          this.load_record_id(record_id);
        } else {
            this.set_current_record(undefined);
        }
    }
    // this.init_focus()
  }
  ,get_base_params : function() {  /* FormPanel */
    // needed for insert_action
    var p = Ext.apply({}, this.base_params);
    Lino.insert_subst_user(p);
    return p;
  }
  ,set_base_params : function(p) {
    //~ this.base_params = Ext.apply({},this.base_params); // make sure it is an instance variable
    delete p['query'] // 20120725
    Ext.apply(this.base_params,p);
    if (this.record_selector) {
        var store = this.record_selector.getStore();
        for (k in p) store.setBaseParam(k,p[k]);
        delete this.record_selector.lastQuery;
        //~ console.log("20120725 record_selector.setBaseParam",p)
    }
  }
  ,clear_base_params : function() {
      this.base_params = {};
      Lino.insert_subst_user(this.base_params);
  }
  ,set_base_param : function(k,v) {
    this.base_params[k] = v;
  }
  ,after_delete : function() {
    if (this.current_record.navinfo.next)
      this.moveNext();
    else if (this.current_record.navinfo.prev)
      this.movePrev();
    else 
      this.abandon();
  }
  ,moveFirst : function() {this.goto_record_id(
      this.current_record.navinfo.first)}
  ,movePrev : function() {this.goto_record_id(
      this.current_record.navinfo.prev)}
  ,moveNext : function() {this.goto_record_id(
      this.current_record.navinfo.next)}
  ,moveLast : function() {this.goto_record_id(
      this.current_record.navinfo.last)}
  
  ,refresh : function(unused) { 
      this.refresh_with_after();
  }
  /* FormPanel */
  ,refresh_with_after : function(after) { 
    // console.log('20140917 Lino.FormPanel.refresh_with_after()',this);
    if (this.current_record) {
        this.load_record_id(this.current_record.id, after);
    } else {
        this.set_current_record(undefined, after);
    }
  }
  
  ,do_when_clean : function(auto_save, todo) {
    var this_ = this;
    if (this.form.isDirty()) {
        // console.log('20140421 do_when_clean : form is dirty')
        if (auto_save) {
            this_.save(todo);
        } else {
          //~ console.log('20111217 do_when_clean() form is dirty',this.form);
          var config = {title:"Bestätigung"};
          config.buttons = Ext.MessageBox.YESNOCANCEL;
          config.msg = "Änderungen in diesem Datensatz speichern?";
          config.fn = function(buttonId,text,opt) {
            //~ console.log('do_when_clean',buttonId)
            if (buttonId == "yes") {
                //~ Lino.submit_detail(this_,undefined,todo);
                //~ this_.containing_window.save(todo);
                this_.save(todo);
            } else if (buttonId == "no") { 
              todo();
            }
          }
          Ext.MessageBox.show(config);
        }
    }else{
      // console.log('20140421 do_when_clean : now!')
      todo();
    }
  }
  
  ,goto_record_id : function(record_id) {
    // console.log('20140917 Lino.FormPanel.goto_record_id()',record_id);
    //~ var this_ = this;
    //~ this.do_when_clean(function() { this_.load_record_id(record_id) }
    this.do_when_clean(
        true, this.load_record_id.createDelegate(this, [record_id]));
  }
  
  ,load_record_id : function(record_id, after) {
    var this_ = this;
    var p = Ext.apply({}, this.get_base_params());
    if (this.action_name)
        p.an = this.action_name;
    p.rp = this.getId();
    p.fmt = 'json';
    this.add_param_values(p);
    if (this.loadMask) this.loadMask.show();
    Ext.Ajax.request({ 
      waitMsg: 'Loading record...',
      method: 'GET',
      params: p,
      scope: this,
      url: this.get_record_url(record_id),
      success: function(response) {   
        // todo: convert to Lino.action_handler.... but result 
        if (this.loadMask) this.loadMask.hide();
        if (response.responseText) {
          var rec = Ext.decode(response.responseText);
          // console.log('20150905 load_record_id success', rec);
          this.set_param_values(rec.param_values);
          this.set_current_record(rec, after);
        }
      },
      failure: Lino.ajax_error_handler(this)
    });
  }

  ,abandon : function () {
    Ext.MessageBox.alert('Note',
      "Keine weiteren Datensätze zu sehen. Detail-Fenster wird geschlossen.");
    Lino.close_window();
  }
  
  ,set_current_record : function(record, after) {
    // console.log('20160825 set_current_record', record);
    if (this.record_selector) {
        this.record_selector.clearValue();
        // e.g. InsertWrapper FormPanel doesn't have a record_selector
    }
    this.current_record = record;
    if (record && record.data) {
      this.enable();
      this.form.my_loadRecord(record.data);
      this.set_window_title(record.title);
      //~ this.getBottomToolbar().enable();
      var da = record.data.disabled_fields;
      if (da) {
          //~ console.log('20120528 disabled_fields =',da,this.getBottomToolbar());
          //~ 20121016 this.getBottomToolbar().items.each(function(item,index,length){
          if(this.hide_top_toolbar) {
              var tb = this.getBottomToolbar();
          } else {
              var tb = this.getTopToolbar();
          }
          if (tb) tb.items.each(function(item,index,length){
              //~ console.log('20120528 ',item.itemId,'-->',da[item.itemId]);
              if (da[item.itemId]) item.disable(); else item.enable();
          });
      };
      if (this.disable_editing | record.data.disable_editing) {
          //~ console.log("20120202 disable_editing",record.title);
          this.form.items.each(function(cmp){
            if (!cmp.always_enabled) cmp.disable();
          },this);
      } else {
          this.form.items.each(function(cmp){
            //~ console.log("20120202",cmp);
            if (record.data.disabled_fields[cmp.name]) cmp.disable();
            else cmp.enable();
          },this);
        
          //~ if (record.data.disabled_fields) {
              //~ for (i = 0; i < record.data.disabled_fields.length; i++) {
                  //~ var flds = this.find('name',record.data.disabled_fields[i]);
                  //~ if (flds.length == 1) { 
                    //~ flds[0].disable(); 
                  //~ }
              //~ }
          //~ }
      };
      if (this.first) {
        if (record.navinfo  && ! this.hide_navigator) {
          this.first.setDisabled(!record.navinfo.first);
          this.prev.setDisabled(!record.navinfo.prev);
          this.next.setDisabled(!record.navinfo.next);
          this.last.setDisabled(!record.navinfo.last);
          this.displayItem.setText(record.navinfo.message);
        } else {
          this.first.setDisabled(true);
          this.prev.setDisabled(true);
          this.next.setDisabled(true);
          this.last.setDisabled(true);
        }
      }
    } else {
      if (this.form.rendered) 
        this.form.reset(); /* FileUploadField would fail when resetting a non-rendered form */
      //~ this.disable();
      //~ this.getBottomToolbar().disable();
      this.form.items.each(function(cmp){
        cmp.disable();
      },this);
      this.set_window_title(this.empty_title);
      //~ this.containing_window.window.setTitle(this.empty_title);
      if (!this.hide_navigator) {
        this.first.disable();
        this.prev.disable();
        this.next.disable();
        this.last.disable();
      }
    }
    // console.log('20140917 gonna call before_row_edit', record);
        var current_focus_fields = false;
        for (var i = 0; i < this.form.items.items.length;i++) {
            if (this.form.items.items[i].hasFocus) current_focus_fields = i;
        }
    this.before_row_edit(record);
        if (current_focus_fields != false){
            this.form.items.items[current_focus_fields].focus();
        }
    // console.log('20140917 gonna call after', after);
    if (after) after();
  },
  
  /* FormPanel */
  before_row_edit : function(record) {},
  search_change : function(field,oldValue,newValue) {
    //~ console.log('search_change',field.getValue(),oldValue,newValue)
    this.set_base_param('query',field.getValue()); 
    this.refresh();
  },
  
  get_selected : function() { return [ this.current_record ] },
  get_current_record : function() {  
    //~ console.log(20100714,this.current_record);
    return this.current_record 
  },
  
  get_permalink_url : function() {
      var rec = this.get_current_record();
      if (rec && ! rec.phantom && rec.id != -99998)
          return '/api' 
              + this.ls_url + '/' + rec.id;
      return '/api' + this.ls_url;
    
  },
  add_param_tab : function(p) {
    var main = this.items.get(0);
    if (main.activeTab) {
      var tab = main.items.indexOf(main.activeTab);
      // console.log('20150130 main.activeTab', tab, main.activeTab);
      if (tab) p.tab = tab;
    // } else {
    //   console.log('20150130 no main.activeTab');
    }
  },
  get_permalink_params : function() {
    var p = {};
    //~ var p = {an:'detail'};
    if (this.action_name)
        p.an = this.action_name;
    this.add_param_tab(p)
    this.add_param_values(p)
    return p;
  }
  
  ,validate_form : function() {  // not used. see actions.ValidateForm
      // var ov = {};
      // this.form.items.each(function(f){
      //     ov[f.name] = f.originalValue
      // });

      // console.log('20140509 FormPanel.validate_form', ov);
      // var after = function() { 
      //     this.form.items.each(function(f){
      //         f.originalValue = ov[f.name];
      //     });
      // }
      // this.save2(null, 'validate', after);
      this.save2(null, 'validate');
  }

  /* Lino.FormPanel */
  ,save : function(after) {
    var action_name = this.save_action_name;
    if (!action_name) 
        action_name = this.action_name;
    // console.log('20140503 FormPanel.save', action_name);
    this.save2(after, action_name);
  }

  ,save2 : function(after, action_name) {
    var rec = this.get_current_record();
    if (!rec) { 
        Lino.notify("Sorry, no current record."); 
        return; 
    }
    var panel = this;
    if (this.has_file_upload) this.form.fileUpload = true;
    this.loadMask.show();
    var p = {};
    Ext.apply(p, this.get_base_params());
    p.rp = this.getId();
    p.an = action_name;
    this.add_param_tab(p)
    // console.log('20150216 FormPanel.save()', rec, this.form);
    var submit_config = {
        params: p, 
        scope: this,
        success: function(form, action) {
          this.loadMask.hide();
          Lino.notify(action.result.message);
          Lino.handle_action_result(this, action.result, after);
        },
        failure: function(form,action) { 
          this.loadMask.hide();
          Lino.on_submit_failure(form, action);
        },
        clientValidation: true
    };
    if (rec.phantom) {  // it's a new record
      Ext.apply(submit_config, {
        url: '/api' + this.ls_url,
        method: 'POST'
      });
      // panel.refresh();
      // temporarily disabled. See 20151002
    } else {  // submit on existing row
      Ext.apply(submit_config, {
        url: '/api' 
              + this.ls_url + '/' + rec.id,
        method: 'PUT'
      })
    }
    this.form.submit(submit_config);
  }
  
  ,on_cancel : function() { 
    this.get_containing_window().close();
  }
  ,on_ok : function() { 
      // console.log("20140424");
      // this.save(null, true, this.save_action_name);
      this.save();
  }
  ,config_containing_window : function(wincfg) { 

      // Note that defaultButton means: which component should receive
      // focus when Window is focussed.  If no defaultButton set,
      // specify the first form field.

      if (!wincfg.defaultButton) this.getForm().items.each(function(f){
          if(f.isFormField){ 
              wincfg.defaultButton = f;
              // console.log("20140205 defaultButton", f);
              return false;
          }
      });

      wincfg.keys = [];

      wincfg.keys.push({
          key: Ext.EventObject.ESCAPE, 
          handler: this.on_cancel, scope:this });
      wincfg.keys.push({
          key: 's', ctrl: true, 
             stopEvent: true, handler: this.on_ok, scope:this });
  }

});



Lino.getRowClass = function(record, rowIndex, rowParams, store) {
    //~ console.log(20130816,record);
    //~ return 'x-grid3-row-green';
    //~ return record.data.row_class + ' auto-height';
    return record.data.row_class;
  //~ if (true) {
      //~ return 'x-grid3-row-red';
  //~ }
  //~ if (record.phantom) {
    //~ console.log(20101009,record);
    //~ rowParams.bodyStyle = "color:red;background-color:blue";
    //~ return 'lino-phantom-row';
    //~ }
  //~ console.log('20101009 not a phantom:',record);
  //~ return '';
}

//~ FOO = 0;



Lino.GridStore = Ext.extend(Ext.data.ArrayStore,{ 
  autoLoad: false
  ,load: function(options) {
    //~ foo.bar = baz; // 20120213
    if (!options) options = {};
    if (!options.params) options.params = {};
    options.params.fmt = 'json';
    options.params.rp = this.grid_panel.getId();
    Lino.insert_subst_user(options.params); // since 20121016
      
    var start = this.grid_panel.start_at_bottom ? -1 : 0;
    if (this.grid_panel.hide_top_toolbar) {
        //~ console.log("20120206 GridStore.load() toolbar is hidden");
        options.params.start = start;
        if (this.grid_panel.preview_limit) {
          options.params.limit = this.grid_panel.preview_limit;
        }
    } else {
        var ps = this.grid_panel.calculatePageSize();
        if (!ps) {
          // console.log("GridStore.load() failed to calculate pagesize");
          return false;
        } 
        options.params.limit = ps;
      
        this.grid_panel.getTopToolbar().pageSize =  ps;
        if (options.params.start == undefined)
            // if (start != -1) 
            //     start = this.grid_panel.getTopToolbar().cursor
            options.params.start = start;
      
        // console.log("20141108 GridStore.load() ", options.params);
    }
      
    this.grid_panel.add_param_values(options.params);
    //~ Lino.insert_subst_user(options.params);
    //~ console.log("20120814 GridStore.load()",options.params,this.baseParams);
    return Lino.GridStore.superclass.load.call(this, options);
  }
  // ,insert : function(index, records) {
  //   return Ext.data.Store.prototype.insert.call(this, index, records)
    // return Lino.GridStore.superclass.insert.call(this, index, records);
  // }
});

Lino.get_current_grid_config = function(panel) {
    return panel.get_current_grid_config();
}


// Like the default value for GridView.cellTpl but adds a class "lino-auto-height"
Lino.auto_height_cell_template = new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
    '<div class="lino-auto-height x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" {attr}>{value}</div>',
'</td>'
);

Lino.GridPanel = Ext.extend(Ext.grid.EditorGridPanel, Lino.MainPanel);
Lino.GridPanel = Ext.extend(Lino.GridPanel, Lino.PanelMixin);
Lino.GridPanel = Ext.extend(Lino.GridPanel, {
  quick_search_text : '',
  start_at_bottom : false,
  is_searching : false,
  disabled_in_insert_window : true,
  clicksToEdit:2,
  enableColLock: false,
  autoHeight: false,
  params_panel_hidden : false,
  preview_limit : undefined, 
  // fake_row_content: '<br>',
  row_height: 1,
  //~ loadMask: true,
  //~ viewConfig: {
          //~ getRowClass: Lino.getRowClass,
          //~ emptyText:"$_('No data to display.')"
        //~ },
        
        
  loadMask: {msg:"Bitte warten..."},
  
  constructor : function(config){

    config.plugins = [new Lino.GridFilters()];
    
    
    Lino.GridPanel.superclass.constructor.call(this,config);
    
    //~ if (this.containing_window) {
        //~ console.log("20111206 install refresh");
        //~ this.containing_window.on('show',this.refresh,this);
    //~ }
    
  },
  
  init_containing_window : function(win) { 
    //~ console.log("20111206 install refresh");
    //~ win.on('show',this.refresh,this);
  }

  ,handle_key_event : function(e) {
    // console.log("20140514 handle_key_event", e, this.keyhandlers);
    var h = this.keyhandlers[e.keyCode];
    if (h) {
        h(this);
        e.stopEvent();
    }
  }
  
  ,initComponent : function(){
    
    /* 
    Problem 20111206:
    When a GridPanel is the main item of the window, then it doesn't 
    have it's own header but uses the window's header bar.
    We must do this in initComponent because e.g. in beforerender 
    it's already to late: a header element has been created because 
    there was a title.
    But Lino.Window adds itself as `this.containing_window` 
    only after the GridPanel has been initialized.
    Workaround is to generate a line "params.containing_window = true;" 
    in the handler function.
    */ 
    if (this.is_main_window) {
        //~ console.log(20111206, 'delete title',this.title,'from',this);
        this.tools = undefined;  
        this.title = undefined;  /* simply deleting it 
          isn't enough because that would only 
          unhide the title defined in some base class. */
    } 
    //~ else console.log(20111206, 'dont delete title',this.title,'from',this);
    
    /* e.g. when slave gridwindow called from a permalink */
    //~ if (this.base_params) Ext.apply(bp,this.base_params);  
    
    var proxy = new Ext.data.HttpProxy({ 
      // 20120814 
      url: '/api' + this.ls_url
      ,method: "GET"
      //~ ,url: ADMIN_URL + '/restful' + this.ls_url
      //~ ,restful: true 
      //~ ,listeners: {load:on_proxy_load} 
      //~ ,listeners: {write:on_proxy_write} 
    });
    //~ config.store = new Ext.data.JsonStore({ 
    //~ this.store = new Ext.data.ArrayStore({ 
    this.store = new Lino.GridStore({ 
      grid_panel: this
      ,listeners: { exception: Lino.on_store_exception }
      ,remoteSort: true
      ,totalProperty: "count"
      ,root: "rows"
      //~ ,id: "id" 
      ,proxy: proxy
      //~ autoLoad: this.containing_window ? true : false
      ,idIndex: this.pk_index
      //~ ,baseParams: bp
      ,fields: this.ls_store_fields
      ,idProperty: this.ls_id_property 
      // 20120814
      //~ ,writer : new Ext.data.JsonWriter({
        //~ writeAllFields: false
        //~ ,listful: true
      //~ })
      //~ ,restful : true
    });
      
    //~ console.log('config.pk_index',config.pk_index,config.store),
    delete this.ls_store_fields;
      
    var this_ = this;
    //~ var grid = this;
    this.store.on('load', function() {
        //~ console.log('20120814 GridStore.on(load)',this_.store);
        this_.set_param_values(this_.store.reader.arrayData.param_values);
        //~ this_.set_status(this_.store.reader.arrayData.status);
        //~ 20120918
        this.getView().getRowClass = Lino.getRowClass;
        
        if (this_.store.reader.arrayData.no_data_text) {
            //~ this.viewConfig.emptyText = this_.store.reader.arrayData.no_data_text;
            this.getView().emptyText = this_.store.reader.arrayData.no_data_text;
            this.getView().refresh();
        }
        if (this_.containing_window)
            this_.set_window_title(this_.store.reader.arrayData.title);
            //~ this_.containing_window.setTitle(this_.store.reader.arrayData.title);
        if (!this.is_searching) { // disabled 20121025: quick_search_field may not lose focus
          this.is_searching = false;
          if (this_.selModel.getSelectedCell){
              if (this_.getStore().getCount()) // there may be no data
                  this_.selModel.select(0,0); 
          } else {
              this_.selModel.selectFirstRow();
              this_.getView().focusEl.focus();
          }
        } 
        //~ else console.log("is_searching -> no focussing");
        //~ var t = this.getTopToolbar();
        //~ var activePage = Math.ceil((t.cursor + t.pageSize) / t.pageSize);
        //~ this.quick_search_field.focus(); // 20121024
      }, this
    );
    var actions = Lino.build_buttons(this, this.ls_bbar_actions);
    //~ Ext.apply(config,Lino.build_buttons(this,config.ls_bbar_actions));
    //~ config.bbar, this.cmenu = Lino.build_buttons(this,config.ls_bbar_actions);
    //~ this.cmenu = new Ext.menu.Menu({items: config.bbar});
    delete this.ls_bbar_actions
    if (actions) {
        this.cmenu = actions.cmenu;
        this.keyhandlers = actions.keyhandlers;
    }
    
    if (!this.hide_top_toolbar) {  
      var tbar = [ 
        this.quick_search_field = new Ext.form.TextField({ 
          //~ fieldLabel: "Search"
          listeners: { 
            scope:this_
            //~ ,change:this_.search_change
            
            ,render: Lino.quicktip_renderer("Schnellsuche","Hier Text eingeben für Schnellsuche.")
            
            //~ ,keypress: this.search_keypress 
            ,blur: function() { this.is_searching = false}
          }
          ,validator:function(value) { return this_.search_validate(value) }
          //~ ,tooltip: "Enter a quick search text, then press TAB"
          //~ value: text
          //~ scope:this, 
          //~ ,enableKeyEvents: true
          //~ listeners: { keypress: this.search_keypress }, 
          //~ id: "seachString" 
      })];
      tbar = this.add_params_panel(tbar);
      var menu = [];
      var set_gc = function(index) {
        return function() {
          //~ console.log('set_gc() 20100812');
          this.getColumnModel().setConfig(
              this.apply_grid_config(index,this.ls_grid_configs,this.ls_columns));
        }
      }
      for (var i = 0; i < this.ls_grid_configs.length;i++) {
        var gc = this.ls_grid_configs[i];
        menu.push({text:gc.label,handler:set_gc(i),scope:this})
      }
      if(menu.length > 1) {
        tbar = tbar.concat([
          { text:"Ansicht",
            menu: menu,
            tooltip:"Andere Ansicht auswählen"
          }
        ]);
      }
      
      if (actions) {
        tbar = tbar.concat(actions.bbar);
          //~ this.bbar = actions.bbar;
      }
      
      this.tbar = new Ext.PagingToolbar({ 
        store: this.store, 
        prependButtons: true, 
        //~ pageSize: this.page_length, 
        pageSize: 1, 
        displayInfo: true, 
        beforePageText: "Seite",
        afterPageText: "von {0}",
        displayMsg: "Zeilen {0} bis {1} von {2}",
        firstText: "Erste Seite",
        lastText: "Letzte Seite",
        prevText: "Vorige Seite",
        nextText: "Nächste Seite",
        items: tbar
      });
    }
      
    if (this.cell_edit) {
      this.selModel = new Ext.grid.CellSelectionModel()
      this.get_selected = function() {
        //~ console.log(this.getSelectionModel().selection);
        if (this.selModel.selection)
            return [ this.selModel.selection.record ];
        return [this.store.getAt(0)];
      };
      this.get_current_record = function() { 
        if (this.getSelectionModel().selection) 
          return this.selModel.selection.record;
        return this.store.getAt(0);
      };
    } else { 
      this.selModel = new Ext.grid.RowSelectionModel() 
      this.get_selected = function() {
        var sels = this.selModel.getSelections();
        if (sels.length == 0) sels = [this.store.getAt(0)];
        return sels
      };
      this.get_current_record = function() { 
        var rec = this.selModel.getSelected();
        if (rec == undefined) rec = this.store.getAt(0);
        return rec
      };
    };
    this.columns  = this.apply_grid_config(this.gc_name,this.ls_grid_configs,this.ls_columns);
    
    Lino.GridPanel.superclass.initComponent.call(this);
    
    this.on('resize', function(){
      //~ console.log("20120213 resize",arguments)
      this.refresh();
      },this);
    this.on('viewready', function(){
      //~ console.log("20120213 resize",arguments);
      this.view_is_ready = true;
      this.refresh(); // removed 20130911
      },this);
    this.on('afteredit', this.on_afteredit); // 20120814
    this.on('beforeedit', this.on_beforeedit);
    this.on('beforeedit',function(e) { this.before_row_edit(e.record)},this);
    if (this.cell_edit) {
        this.on('cellcontextmenu', Lino.cell_context_menu, this);
    } else {
        this.on('rowcontextmenu', Lino.row_context_menu, this);
    }
    //~ this.on('contextmenu', Lino.grid_context_menu, this);
    
    delete this.cell_edit;
    
  },
  
  //~ onResize : function(){
      //~ console.log("20120206 GridPanel.onResize",arguments);
      //~ Lino.GridPanel.superclass.onResize.apply(this, arguments);
      //~ this.refresh();
  //~ },
  
  
  get_status : function(){
    var st = { base_params : this.get_base_params()};
    if (!this.hide_top_toolbar) {
        // #866
        if (this.getStore().lastOptions != undefined && this.getStore().lastOptions.params != undefined){
            st.current_page = Math.round(this.getStore().lastOptions.params.start / this.getStore().lastOptions.params.limit ) + 1 ;
        }
    }
    st.param_values = this.status_param_values;
    //~ console.log("20120213 GridPanel.get_status",st);
    return st;
  },
  
  /* 
  Lino.GridPanel.set_status() 
  */
  set_status : function(status, rp){
    this.requesting_panel = Ext.getCmp(rp);
    // console.log("20140527 GridPanel.set_status", status);
    this.clear_base_params();
    if (status == undefined) status = {base_params:{}};
    this.set_param_values(status.param_values);
    if (status.base_params) { 
      this.set_base_params(status.base_params);
    }
    if (status.show_params_panel != undefined) {
        if (this.toggle_params_panel_btn) {
            //~ this.toggle_params_panel_btn.toggle(status.show_params_panel=='true');
            this.toggle_params_panel_btn.toggle(status.show_params_panel);
        }
    }
    if (!this.hide_top_toolbar) {
      //~ console.log("20120213 GridPanel.getTopToolbar().changePage",
          //~ status.current_page || 1);
      this.getTopToolbar().changePage(status.current_page || 1);
    }
    //~ this.fireEvent('resize');
    //~ this.refresh.defer(100,this); 
    //~ this.onResize.defer(100,this); 
    //~ this.refresh(); 
    //~ this.doLayout(); 
    //~ this.onResize(); 
    //~ this.store.load();
  },
  
  refresh : function(unused) { 
    this.refresh_with_after();
  },
  /* GridPanel */
  refresh_with_after : function(after) { 
    // console.log('20140504 Lino.GridPanel.refresh '+ this.store.proxy.url);
    //~ var bp = { fmt:'json' }
    if (! this.view_is_ready) return;
    
    if (this.containing_panel) {
        //~ Ext.apply(p,this.master_panel.get_master_params());
        //~ Ext.apply(options.params,this.containing_panel.get_master_params());
        this.set_base_params(this.containing_panel.get_master_params());
        // 20130911
        if (!this.store.baseParams.mk) {  
            return;
        }
    }
    
    //~ console.log('20130911 Lino.GridPanel.refresh_with_after',this.containing_panel.get_master_params());
    
    var options = {};
    if (after) {
        options.callback = function(r,options,success) {if(success) after()}
    }
      
    //~ if (!this.rendered) {
        //~ console.log("20120206 GridPanel.refresh() must wait until rendered",options);
        //~ this.grid_panel.on('render',this.load.createDelegate(this,options))
        //~ return;
    //~ }
    // Ticket 802
    if (this.store.lastOptions != undefined){
        var params = {};
        params.limit = this.store.lastOptions.params.limit;
        params.start = this.store.lastOptions.params.start;
        options.params = params;
    }
    this.store.load(options);
  },
  
  /* pageSize depends on grid height (Trying to remove scrollbar)
  Thanks to 
  - Christophe Badoit on http://www.sencha.com/forum/showthread.php?82647
  - http://www.sencha.com/forum/archive/index.php/t-37231.html
  */
  calculatePageSize : function(second_attempt) {
    //~ if (!this.rendered) { 
    if (!this.view_is_ready) { 
      //~ console.log('Cannot calculatePageSize() : not rendered');
      return false; }
    //~ if (!this.isVisible()) { 
      //~ console.log('calculatePageSize : not visible');
      //~ return false; }
      
    //~ console.log('getFrameHeight() is',this.getFrameHeight());
    //~ console.log('getView().scroller.getHeight() is',this.getView().scroller.getHeight());
    //~ console.log('mainBody.getHeight() is',this.getView().mainBody.getHeight());
    //~ console.log('getInnerHeight() is',this.getInnerHeight());
    //~ console.log('getHeight() is',this.getHeight());
    //~ console.log('el.getHeight() is',this.getEl().getHeight());
    //~ console.log('getGridEl().getHeight() is',this.getGridEl().getHeight());
    //~ console.log('getOuterSize().height is',this.getOuterSize().height);
    //~ console.log('getBox().height is',this.getBox().height);
    //~ console.log('getResizeEl.getHeight() is',this.getResizeEl().getHeight());
    //~ console.log('getLayoutTarget().getHeight() is',this.getLayoutTarget().getHeight());
      
    // var rowHeight = this.row_height * 11; experimental value 11
    // same as in ext_renderer.py that's not enough because it is the
    // height of one text line. But here we need the outer height of a
    // grid row containing that many text lines.

    var row_content = '&nbsp;'
    for (var i = 0; i < this.row_height;i++) {
        row_content += '<br>';
    }

    var Element = Ext.Element;
    var gv = this.view;
    var fakeBody = new Element(Element.fly(gv.scroller).child('div.x-grid3-body'));
    var rowTemplate = gv.templates.row;
    var cellTemplate = gv.templates.cell;
    var tstyle  = 'width:' + gv.getGridInnerWidth() + 'px;';
    // console.log("20160615", this.fake_row_content);
    var cells = cellTemplate.apply({value:row_content});
    var markup = rowTemplate.apply({
            tstyle: tstyle,
            cols  : 1,
            cells : cells,
            alt   : ''
        });        
    fakeBody.dom.innerHTML = gv.templates.body.apply({rows: markup});
    var row = fakeBody.dom.childNodes[0];
    var rowHeight = Ext.get(row).getHeight();

    //~ console.log('rowHeight is ',rowHeight,this,caller);
    //~ this.getView().syncScroll();
    //~ this.getView().initTemplates();
    var height = this.getView().scroller.getHeight();

    //~ console.log('getView().scroller.getHeight() is',this.getView().scroller.getHeight());
    //~ console.log('getInnerHeight() - getFrameHeight() is',
      //~ this.getInnerHeight(), '-',
      //~ this.getFrameHeight(), '=',
      //~ this.getInnerHeight() - this.getFrameHeight());
    //~ var height = this.getView().mainBody.getHeight();
    //~ var height = this.getView().mainWrap.getHeight();
    //~ var height = this.getView().resizeMarker.getHeight();
    //~ this.syncSize();
    //~ var height = this.getInnerHeight() - this.getFrameHeight();
    //~ var height = this.getHeight() - this.getFrameHeight();
    height -= Ext.getScrollBarWidth(); // leave room for a possible horizontal scrollbar... 
    //~ height -= this.getView().scrollOffset;
    var ps = Math.floor(height / rowHeight);
    //~ console.log('20130816 calculatePageSize():',height,'/',rowHeight,'->',ps);
    ps -= 1; // leave room for a possible phantom row
    //~ return (ps > 1 ? ps : false);
    if (ps > 1) return ps;
    //~ console.log('calculatePageSize() found less than 1 row:',height,'/',rowHeight,'->',ps);
    //~ foo.bar = baz; // 20120213
    return 5; // preview_limit
    //~ if (second_attempt) {
        //~ console.log('calculatePageSize() abandons after second attempt:',
          //~ height,'/',rowHeight,'->',ps);
      //~ return 5;
    //~ }
    //~ return this.calculatePageSize.defer(500,this,[true]);
  },
  
  onCellDblClick : function(grid, row, col){
      //~ console.log("20120307 onCellDblClick",this,grid, row, col);
      if (this.ls_detail_handler) {
          //~ Lino.notify('show detail');
          Lino.show_detail(this);
          return false;
      }else{
        //~ console.log('startEditing');
        this.startEditing(row,col);
      }
  },
  get_base_params : function() {  /* Lino.GridPanel */
    var p = Ext.apply({}, this.store.baseParams);
    Lino.insert_subst_user(p);
    // if (this.quick_search_field)
    //     if (this.quick_search_field.getValue())
    //         p.query = this.quick_search_field.getValue();
    return p;
  },
  set_base_params : function(p) {
    // console.log('20130911 GridPanel.set_base_params',p)
    for (k in p) this.store.setBaseParam(k,p[k]);
    //~ this.store.baseParams = p;
    if (this.quick_search_field)
      this.quick_search_field.setValue(p.query || "");
    //~ if (p.param_values) 
        //~ this.set_param_values(p.param_values);  
  },
  clear_base_params : function() {
      this.store.baseParams = {};
      Lino.insert_subst_user(this.store.baseParams);
  },
  set_base_param : function(k,v) {
    this.store.setBaseParam(k,v);
  },
  
  //~ get_permalink_params : function() {
    //~ var p = {};
    //~ return p;
  //~ },
  
  before_row_edit : function(record) {},
    
  //~ search_keypress : function(){
    //~ console.log("2012124 search_keypress",arguments);
  //~ },
  search_validate : function(value) {
    if (value == this.quick_search_text) return true;
    this.is_searching = true;
    //~ console.log('search_validate',value)
    this.quick_search_text = value;
    this.set_base_param('query',value); 
    //~ this.getTopToolbar().changePage(1);
    this.getTopToolbar().moveFirst();
    //~ this.refresh();
    return true;
  },
  
  search_change : function(field,oldValue,newValue) {
    //~ console.log('search_change',field.getValue(),oldValue,newValue)
    this.set_base_param('query',field.getValue()); 
    this.getTopToolbar().moveFirst();
    //~ this.refresh();
  },
  
  apply_grid_config : function(index,grid_configs,rpt_columns) {
    //~ var rpt_columns = this.ls_columns;
    var gc = grid_configs[index];    
    //~ console.log('apply_grid_config() 20100812',name,gc);
    this.gc_name = index;
    if (gc == undefined) {
      return rpt_columns;
      //~ config.columns = config.ls_columns;
      //~ return;
    } 
    //~ delete config.ls_filters
    
    //~ console.log(20100805,config.ls_columns);
    var columns = Array(gc.columns.length);
    for (var j = 0; j < rpt_columns.length;j++) {
      var col = rpt_columns[j];
      for (var i = 0; i < gc.columns.length; i++) {
        if (col.dataIndex == gc.ci[i]) {
          col.width = gc.cw[i];
          col.hidden = gc.ch[i];
          columns[i] = col;
          break;
        }
      }
    }
    
    //~ var columns = Array(rpt_columns.length);
    //~ for (var i = 0; i < rpt_columns.length; i++) {
      //~ columns[i] = rpt_columns[gc.columns[i]];
      //~ columns[i].width = gc.widths[i];
    //~ }
    
    //~ if (gc.hidden_cols) {
      //~ for (var i = 0; i < gc.hidden_cols.length; i++) {
        //~ var hc = gc.hidden_cols[i];
        //~ for (var j = 0; j < columns.length;j++) {
          //~ var col = columns[j];
          //~ if (col.dataIndex == hc) {
            //~ col.hidden = true;
            //~ break
          //~ }
        //~ }
      //~ }
    //~ }
    if (gc.filters) {
      //~ console.log(20100811,'config.ls_filters',config.ls_filters);
      //~ console.log(20100811,'config.ls_grid_config.filters',config.ls_grid_config.filters);
      for (var i = 0; i < gc.filters.length; i++) {
        var fv = gc.filters[i];
        for (var j = 0; j < columns.length;j++) {
          var col = columns[j];
          if (col.dataIndex == fv.field) {
            //~ console.log(20100811, f,' == ',fv);
            if (fv.type == 'string') {
              col.filter.value = fv.value;
              //~ if (fv.comparison !== undefined) f.comparison = fv.comparison;
            } else {
              //~ console.log(20100811, fv);
              col.filter.value = {};
              col.filter.value[fv.comparison] = fv.value;
            }
            break;
          }
        };
      }
    }
    
    return columns;
    //~ config.columns = cols;
    //~ delete config.ls_columns
  },
  
  get_current_grid_config : function () {
    var cm = this.getColumnModel();
    var widths = Array(cm.config.length);
    var hiddens = Array(cm.config.length);
    //~ var hiddens = Array(cm.config.length);
    var columns = Array(cm.config.length);
    //~ var columns = Array(cm.config.length);
    //~ var hidden_cols = [];
    //~ var filters = this.filters.getFilterValues();
    var p = this.filters.buildQuery(this.filters.getFilterData())
    for (var i = 0; i < cm.config.length; i++) {
      var col = cm.config[i];
      columns[i] = col.dataIndex;
      //~ hiddens[i] = col.hidden;
      widths[i] = col.width;
      hiddens[i] = col.hidden;
      //~ if (col.hidden) hidden_cols.push(col.dataIndex);
    }
    //~ p['hidden_cols'] = hidden_cols;
    p.cw = widths;
    p.ch = hiddens;
    p.ci = columns;
    //~ p['widths'] = widths;
    //~ p['hiddens'] = hiddens;
    //~ p['columns'] = columns;
    p['name'] = this.gc_name;
    //~ var gc = this.ls_grid_configs[this.gc_name];
    //~ if (gc !== undefined) 
        //~ p['label'] = gc.label
    //~ console.log('20100810 save_grid_config',p);
    return p;
  },
  
  unused_manage_grid_configs : function() {
    var data = [];
    for (k in this.ls_grid_configs) {
      var v = this.ls_grid_configs[k];
      var i = [k,String(v.columns),String(v.hidden_cols),String(v.filters)];
      data.push(i)
    }
    if (this.ls_grid_configs[this.gc_name] == undefined) {
      var v = this.get_current_grid_config();
      var i = [k,String(v.columns),String(v.hidden_cols),String(v.filters)];
      data.push(i);
    }
    //~ console.log(20100811, data);
    var main = new Ext.grid.GridPanel({
      store: new Ext.data.ArrayStore({
        idIndex:0,
        fields:['name','columns','hidden_cols','filters'],
        autoDestroy:true,
        data: data}),
      //~ autoHeight:true,
      selModel: new Ext.grid.RowSelectionModel(),
      listeners: { 
        rowdblclick: function(grid,rowIndex,e) {
          console.log('row doubleclicked',grid, rowIndex,e);
        },
        rowclick: function(grid,rowIndex,e) {
          console.log('row clicked',grid, rowIndex,e);
        }
      },
      columns: [ 
        {dataIndex:'name',header:'Name'}, 
        {dataIndex:'columns',header:'columns'}, 
        {dataIndex:'hidden_cols',header:'hidden columns'}, 
        {dataIndex:'filters',header:'filters'} 
      ]
    });
    var win = new Ext.Window({title:'GridConfigs Manager',layout:'fit',items:main,height:200});
    win.show();
  },
  
  unused_edit_grid_config : function(name) {
    gc = this.ls_grid_configs[name];
    var win = new Ext.Window({
      title:'Edit Grid Config',layout:'vbox', 
      //~ layoutConfig:'stretch'
      items:[
        {xtype:'text', value: gc.name},
        {xtype:'text', value: gc.columns},
        {xtype:'text', value: gc.hidden_cols},
        {xtype:'text', value: gc.filters}
      ]
    });
    win.show();
  },
  
  unused_save_grid_config : function () {
    //~ console.log('TODO: save_grid_config',this);
    //~ p.column_widths = Ext.pluck(this.colModel.columns,'width');
    var a = { 
      params:this.get_current_grid_config(), 
      method:'PUT',
      url:'/grid_config' + this.ls_url,
      success: Lino.action_handler(this),
      scope: this,
      failure: Lino.ajax_error_handler(this)
    };
    this.loadMask.show(); // 20120211
    Ext.Ajax.request(a);
    //~ Lino.do_action(this,a);
  },
  
  on_beforeedit : function(e) {
    //~ console.log('20130128 GridPanel.on_beforeedit()',e,e.record.data.disable_editing);
    if(this.disable_editing | e.record.data.disable_editing) {
      e.cancel = true;
      Lino.notify("Dieser Datensatz ist deaktiviert");
      return;
    }
    if(e.record.data.disabled_fields && e.record.data.disabled_fields[e.field]) {
      e.cancel = true;
      Lino.notify("Dieses Feld ist deaktiviert");
      return;
    }
    //~ if (e.record.data.disabled_fields) {
      //~ for (i in e.record.data.disabled_fields) {
        //~ if(e.record.data.disabled_fields[i] == e.field) {
          //~ e.cancel = true;
          //~ Lino.notify(String.format('Field "{0}" is disabled for this record',e.field));
          //~ return
        //~ }
      //~ }
    //~ }
  },
  save_grid_data : function() {
      //~ console.log("20120814 save_grid_data");
      this.getStore().commitChanges();
  },
  on_afteredit : function(e) {
    /*
    e.grid - The grid that fired the event
    e.record - The record being edited
    e.field - The field name being edited
    e.value - The value being set
    e.originalValue - The original value for the field, before the edit.
    e.row - The grid row index
    e.column - The grid column index
    */
    var p = {};
    // console.log('20140403 afteredit: ',e.record);
    //~ console.log('20101130 value: ',e.value);
    //~ var p = e.record.getChanges();
    //~ console.log('20101130 getChanges: ',e.record.getChanges());
    //~ this.before_row_edit(e.record);

    for(k in e.record.getChanges()) {
        var v = e.record.get(k);
    //~ for(k in e.record.modified) {
        //~ console.log('20101130',k,'=',v);
        //~ var cm = e.grid.getColumnModel();
        //~ var di = cm.getDataIndex(k);
        var f = e.record.fields.get(k);
        //~ console.log('20101130 f = ',f);
        //~ var v = e.record.get(di);
        if (f.type.type == 'date') {
            p[k] = Ext.util.Format.date(v, f.dateFormat);
        }else{
            p[k] = v;
            var v = e.record.get(k+'Hidden');
            if (v !== undefined) {
              p[k+'Hidden'] = v;
            }
        }
    }
    // add value used by ForeignKeyStoreField CHOICES_HIDDEN_SUFFIX
    // not sure whether this is still needed:
    p[e.field+'Hidden'] = e.value;
    //~ p.su = Lino.subst_user;
    Lino.insert_subst_user(p);
    // this one is needed so that this field can serve as choice context:
    e.record.data[e.field+'Hidden'] = e.value;
    // p[pk] = e.record.data[pk];
    // console.log("grid_afteredit:",e.field,'=',e.value);
    Ext.apply(p, this.get_base_params()); // needed for POST, ignored for PUT
    //~ Ext.apply(p,this.containing_window.config.base_params);
    //~ 20121109 p['$constants.URL_PARAM_ACTION_NAME'] = 'grid';
    var self = this;
    var req = {
        params:p,
        waitMsg: 'Saving your data...',
        success: Lino.action_handler( this, function(result) {
          // console.log("20140728 afteredit.success got ", result);
          //~ if (result.data_record) {
          if (result.refresh_all) {
              var cw = self.get_containing_window();
              if (cw) {
                  cw.main_item.refresh();
              }
              else console.log("20120123 cannot refresh_all",self);
          } else if (result.rows) {
              //~ self.getStore().loadData(result,true);
              var r = self.getStore().reader.readRecords(result);
              if (e.record.phantom) {
                  // console.log("20140728 gonna call Store.insert()", self.getStore(), e.row, r.records);
                  self.getStore().insert(e.row, r.records);
              }else{
                  // console.log("20140728 afteredit.success doUpdate", r.records[0]);
                  self.getStore().doUpdate(r.records[0]);
              }
              self.getStore().rejectChanges(); 
              /* 
              get rid of the red triangles without saving the record again
              */
              //~ self.getStore().commitChanges(); // get rid of the red triangles
          } else {
              self.getStore().commitChanges(); // get rid of the red triangles
              self.getStore().reload();        // reload our datastore.
          }
          }),
        scope: this,
        failure: Lino.ajax_error_handler(this)
    };
    if (e.record.phantom) {
      req.params.an = 'grid_post'; // CreateRow.action_name
      Ext.apply(req,{
        method: 'POST',
        url: '/api' + this.ls_url
      });
    } else {
      req.params.an = 'grid_put'; // SaveRow.action_name
      Ext.apply(req,{
        method: 'PUT',
        url: '/api' + this.ls_url + '/' + e.record.id
      });
    }
    //~ console.log('20110406 on_afteredit',req);
    this.loadMask.show(); // 20120211
    Ext.Ajax.request(req);
  },

  afterRender : function() {
    Lino.GridPanel.superclass.afterRender.call(this);
    // this.getView().mainBody.focus();
    // console.log(20100114,this.getView().getRows());
    // if (this.getView().getRows().length > 0) {
    //  this.getView().focusRow(1);
    // }
    //~ this.my_load_mask = new Ext.LoadMask(this.getEl(), {
        //~ msg:'$_("Please wait...")',
        //~ store:this.store});
      
    var tbar = this.getTopToolbar();
    // tbar.on('change',function() {this.getView().focusRow(1);},this);
    // tbar.on('change',function() {this.getSelectionModel().selectFirstRow();this.getView().mainBody.focus();},this);
    // tbar.on('change',function() {this.getView().mainBody.focus();},this);
    // tbar.on('change',function() {this.getView().focusRow(1);},this);
    this.nav = new Ext.KeyNav(this.getEl(),{
      pageUp: function() {tbar.movePrevious(); },
      pageDown: function() {tbar.moveNext(); },
      home: function() {tbar.moveFirst(); },
      end: function() {tbar.moveLast(); },
      scope: this
    });

  },
  after_delete : function() {
    //~ console.log('Lino.GridPanel.after_delete');
    this.refresh();
  },
  add_row_listener : function(fn,scope) {
    this.getSelectionModel().addListener('rowselect',fn,scope);
  },
  postEditValue : function(value, originalValue, r, field){
    value = Lino.GridPanel.superclass.postEditValue.call(this,value,originalValue,r,field);
    //~ console.log('GridPanel.postEdit()',value, originalValue, r, field);
    return value;
  },
  
  set_start_value : function(v) {
      this.start_value = v;
  },
  preEditValue : function(r, field){
      if (this.start_value) {
        var v = this.start_value;
        delete this.start_value;
        this.activeEditor.selectOnFocus = false;
        return v;
      }
      var value = r.data[field];
      return this.autoEncode && Ext.isString(value) ? Ext.util.Format.htmlDecode(value) : value;
  },
  
  on_master_changed : function() {
    //~ if (! this.enabled) return;
    //~ cmp = this;
    //~ console.log('20130911 Lino.GridPanel.on_master_changed()',this.title,this.rendered);
    if (! this.rendered) return; // 20120213
    var todo = function() {
      if (this.disabled) return;
      //~ if (this.disabled) return;
      //~ if (this.enabled) {
          //~ var src = caller.config.url_data + "/" + record.id + ".jpg"
          //~ console.log(20111125, this.containing_window);
          //~ for (k in p) this.getStore().setBaseParam(k,p[k]);
          //~ console.log('Lino.GridPanel.on_master_changed()',this.title,p);
          this.refresh();
          //~ this.set_base_params(this.master_panel.get_master_params());
          //~ this.getStore().load(); 
      //~ }
    };
    Lino.do_when_visible(this,todo.createDelegate(this));
  },
  load_record_id : function(record_id,after) {
      Lino.run_detail_handler(this,record_id)
  }
  
});
  

//~ Lino.MainPanelMixin = {
  //~ tbar_items : function() {
      //~ return ;
  //~ }
//~ };

//~ Ext.override(Lino.GridPanel,Lino.MainPanelMixin);
//~ Ext.override(Lino.FormPanel,Lino.MainPanelMixin);

//~ Lino.grid_context_menu = function(e) {
  //~ console.log('contextmenu',arguments);
//~ }

Lino.row_context_menu = function(grid,row,col,e) {
  console.log('20130927 rowcontextmenu',grid,row,col,e,grid.store.reader.arrayData.rows[row]);
}

Lino.cell_context_menu = function(grid,row,col,e) {
  //~ console.log('20120531 cellcontextmenu',grid,row,col,e,grid.store.reader.arrayData.rows[row]);
  e.stopEvent();
  //~ grid.getView().focusCell(row,col);
  grid.getSelectionModel().select(row,col);
  //~ console.log(grid.store.getAt(row));
  //~ grid.getView().focusRow(row);
  //~ return;
  if(!grid.cmenu.el){grid.cmenu.render(); }
  //~ if(e.record.data.disabled_fields) {

  if (grid.disabled_fields_index) {
      var da = grid.store.reader.arrayData.rows[row][grid.disabled_fields_index];
      if (da) {
          this.cmenu.cascade(function(item){ 
            //~ console.log(20120531, item.itemId, da[item.itemId]);
            if (da[item.itemId]) item.disable(); else item.enable();
          });
      }
  };
  
  var xy = e.getXY();
  xy[1] -= grid.cmenu.el.getHeight();
  grid.cmenu.showAt(xy);
}


Lino.chooser_handler = function(combo,name) {
  return function(cmp, newValue, oldValue) {
    //~ console.log('Lino.chooser_handler()',cmp,oldValue,newValue);
    combo.setContextValue(name, newValue);
  }
};



Lino.ComboBox = Ext.extend(Ext.form.ComboBox,{
  forceSelection: "yes but select on tab",
  // forceSelection: true,
  triggerAction: 'all',
  minListWidth:280, // 20131022
  autoSelect: false,
  selectOnFocus: true, // select any existing text in the field immediately on focus.
  submitValue: true,
  displayField: 'text', // 'text', 
  valueField: 'value', // 'value',
  
  //~ initComponent : Ext.form.ComboBox.prototype.initComponent.createSequence(function() {
  initComponent : function(){
      this.contextParams = {};
      //~ Ext.form.ComboBox.initComponent(this);
      Lino.ComboBox.superclass.initComponent.call(this);
  },
  setValue : function(v, record_data){
      /*
      Based on feature request developed in http://extjs.net/forum/showthread.php?t=75751
      */
      /* `record_data` is used to get the text corresponding to this value */
      //~ if(this.name == 'city') 
      //~ console.log('20120203', this.name,'.setValue(', v ,') this=', this,'record_data=',record_data);
      var text = v;
      if(this.valueField){
        if(v == null || v == '') { 
            //~ if (this.name == 'birth_country') 
                //~ console.log(this.name,'.setValue',v,'no lookup needed, value is empty');
            //~ v = undefined;
            v = '';
            //~ text = '';
        } else if (Ext.isDefined(record_data)) {
          text = record_data[this.name];
          //~ if (this.name == 'birth_country') 
            //~ console.log(this.name,'.setValue',v,'got text ',text,' from record ',record);
        } else {
          // if(this.mode == 'remote' && !Ext.isDefined(this.store.totalLength)){
          if(this.mode == 'remote' && ( this.lastQuery === null || (!Ext.isDefined(this.store.totalLength)))){
              //~ if (this.name == 'birth_country') console.log(this.name,'.setValue',v,'store not yet loaded');
              this.store.on('load', this.setValue.createDelegate(this, arguments), null, {single: true});
              if(this.store.lastOptions === null || this.lastQuery === null){
                  var params;
                  if(this.valueParam){
                      params = {};
                      params[this.valueParam] = v;
                  }else{
                      var q = this.allQuery;
                      this.lastQuery = q;
                      this.store.setBaseParam(this.queryParam, q);
                      params = this.getParams(q);
                  }
                  //~ if (this.name == 'birth_country') 
                    //~ console.log(this.name,'.setValue',v,' : call load() with params ',params);
                  this.store.load({params: params});
              //~ }else{
                  //~ if (this.name == 'birth_country') 
                    //~ console.log(this.name,'.setValue',v,' : but store is loading',this.store.lastOptions);
              }
              return;
          //~ }else{
              //~ if (this.name == 'birth_country') 
                //~ console.log(this.name,'.setValue',v,' : store is loaded, lastQuery is "',this.lastQuery,'"');
          }
          var r = this.findRecord(this.valueField, v);
          if(r){
              text = r.data[this.displayField];
          }else if(this.valueNotFoundText !== undefined){
              text = this.valueNotFoundText;
          }
        }
      }
      this.lastSelectionText = text;
      //~ this.lastSelectionText = v;
      if(this.hiddenField){
          //~ this.hiddenField.originalValue = v;
          this.hiddenField.value = v;
      }
      Ext.form.ComboBox.superclass.setValue.call(this, text);
      this.value = v; // needed for grid.afteredit
  },
  
  getParams : function(q){
    // p = Ext.form.ComboBox.superclass.getParams.call(this, q);
    // causes "Ext.form.ComboBox.superclass.getParams is undefined"
    var p = {};
    if(this.pageSize){
        p['start'] = 0;
        p['limit'] = this.pageSize;
    }
    // now my code:
    if(this.contextParams) Ext.apply(p, this.contextParams);
    return p;
  },
  setContextValue : function(name,value) {
    //~ console.log('setContextValue',this,this.name,':',name,'=',value);
    //~ if (this.contextValues === undefined) {
        //~ this.contextValues = Array(); // this.contextParams.length);
    //~ }
    if (this.contextParams[name] != value) {
      //~ console.log('setContextValue 1',this.contextParams);
      this.contextParams[name] = value;
      this.lastQuery = null;
      //~ console.log('setContextValue 2',this.contextParams);
    }
  }
});

Lino.ChoicesFieldElement = Ext.extend(Lino.ComboBox,{
  mode: 'local'
});


Lino.SimpleRemoteComboStore = Ext.extend(Ext.data.JsonStore,{
  // forceSelection: true,  20140206 why was this here?
  constructor: function(config){
      Lino.SimpleRemoteComboStore.superclass.constructor.call(this, Ext.apply(config, {
          totalProperty: 'count',
          root: 'rows',
          id: 'value', // 'value'
          fields: ['value' ], 
          listeners: { exception: Lino.on_store_exception }
      }));
  }
});

Lino.ComplexRemoteComboStore = Ext.extend(Ext.data.JsonStore,{
  constructor: function(config){
      Lino.ComplexRemoteComboStore.superclass.constructor.call(this, Ext.apply(config, {
          totalProperty: 'count',
          root: 'rows',
          id: 'value', // constants.CHOICES_VALUE_FIELD
          fields: ['value','text'], // constants.CHOICES_VALUE_FIELD, // constants.CHOICES_TEXT_FIELD
          listeners: { exception: Lino.on_store_exception }
      }));
  }
});

Lino.RemoteComboFieldElement = Ext.extend(Lino.ComboBox,{
  mode: 'remote',
  //~ forceSelection:false,
  minChars: 2, // default 4 is too much
  queryDelay: 300, // default 500 is maybe slow
  queryParam: 'query', 
  //~ typeAhead: true,
  //~ selectOnFocus: true, // select any existing text in the field immediately on focus.
  resizable: true
  ,initList : function() {
      Lino.RemoteComboFieldElement.superclass.initList.call(this);
      if (this.pageTb) {
          
          var me = this;
          this.pageTb.on("beforechange", function(toolbar, o){
              if(me.contextParams)
                  Ext.apply(o, me.contextParams);
          });
          
          //~ 
          //~ var btn = ls_buttons
          //~ this.pageTb.items = this.pageTb.items.concat([btn]);
          //~ console.log("20131022 pageTb.items is", this.pageTb.items)
      }
  }
});

/*
Thanks to Animal for posting the basic idea:
http://www.sencha.com/forum/showthread.php?15842-2.0-SOLVED-Combobox-twintrigger-clear&p=76130&viewfull=1#post76130

*/
Lino.TwinCombo = Ext.extend(Lino.RemoteComboFieldElement,{
    trigger2Class : 'x-form-search-trigger',
    //~ trigger2Class : 'x-tbar-detail',
    initComponent : function() {
        //~ Lino.TwinCombo.superclass.initComponent.call(this);
        Lino.ComboBox.prototype.initComponent.call(this);
        Ext.form.TwinTriggerField.prototype.initComponent.call(this);
    },
    onTrigger2Click : function() {
        //~ console.log('onTrigger2Click',this,arguments);
    }
  });
//~ Lino.TwinCombo.prototype.initComponent = Ext.form.TwinTriggerField.prototype.initComponent;
Lino.TwinCombo.prototype.getTrigger = Ext.form.TwinTriggerField.prototype.getTrigger;
Lino.TwinCombo.prototype.getOuterSize = Ext.form.TwinTriggerField.prototype.getOuterSize;
Lino.TwinCombo.prototype.initTrigger = Ext.form.TwinTriggerField.prototype.initTrigger;
Lino.TwinCombo.prototype.onTrigger1Click = Ext.form.ComboBox.prototype.onTriggerClick;
//~ Lino.TwinCombo.prototype.onTrigger2Click = function() {
    //~ console.log('onTrigger2Click',arguments);
//~ };



Lino.SimpleRemoteComboFieldElement = Ext.extend(Lino.RemoteComboFieldElement,{
  displayField: 'value', 
  valueField: null,
  forceSelection: false
});




Lino.Window = Ext.extend(Ext.Window,{
  //~ layout: "fit", 
  closeAction : 'hide',
  renderTo: 'main_area', 
  constrain: true,
  maximized: true,
  draggable: false,
  width: 700,
  height: 500,
  maximizable: false,
  constructor : function (config) {
    if (config.main_item.params_panel) {
        config.layout = 'border';
        config.main_item.region = 'center';
        config.main_item.params_panel.region = 'north';
        //~ config.main_item.params_panel.autoHeight = false; // 20130924
        config.main_item.params_panel.hidden = config.main_item.params_panel_hidden;
        config.items = [config.main_item.params_panel, config.main_item];
        //~ 20130923b
    } else {
        config.layout = 'fit';
        config.items = config.main_item;
    }
    this.main_item = config.main_item; 

    if (typeof config.width == "string" && config.width.slice(-1) == "%") {
        config.width = Lino.perc2width(parseInt(config.width.slice(0, -1)));
    }
    
    delete config.main_item;
    //~ delete config.params_item;
    
    //~ this.main_item = config.items.get(0);
    this.main_item.containing_window = this;
    
    //~ console.log('20120110 Lino.Window.constructor() 1');
    //~ if (Lino.current_window) { // all windows except the top are closable
    if (this.main_item.hide_window_title) { 
      config.closable = false;
      config.frame = false;
      config.shadow = false;
      //~ config.border = true;
      //~ config.title = undefined;
      //~ config.tools = null;
      delete config.title;
      delete config.tools;
    } else {
      config.title = this.main_item.empty_title;
      config.closable = true;
      config.tools = [ 
        { qtip: 'permalink', handler: Lino.permalink_handler(this), id: "pin" }
      ];
      if (this.main_item.content_type && this.main_item.action_name != 'insert') {
        config.tools = [ {
          handler: Lino.help_text_editor,
          qtip: "Hilfetexte der Eingabefelder dieser Tabelle bearbeiten",
          scope: this.main_item,
          id: "gear"
        }].concat(config.tools);
      }
        
    //~ { qtip: '', handler: Lino.save_wc_handler(this), id: "save" }, 
    //~ { qtip: this.config.qtip, handler: Lino.save_wc_handler(this), id: "save" }, 
    //~ { qtip: 'Call doLayout() on main Container.', handler: Lino.refresh_handler(this), id: "refresh" },
    //~ if (this.main_item.params_panel) {
        //~ config.tools = config.tools.concat([ 
          //~ { qtip: 'Show/hide parameter panel', handler: this.toggle_params_panel, id: "gear", scope:this } 
        //~ ]);
    //~ }
    //~ if (config.closable !== false) {
      // if undefined, will take default behaviour
      //~ config.tools = config.tools.concat([ 
        //~ { qtip: 'close', handler: this.hide, id: "close", scope:this } 
      //~ ]);
    }
    
    this.main_item.config_containing_window(config);
    
    // console.log('20150514 Lino.Window.constructor() 2');
    Lino.Window.superclass.constructor.call(this, config);
    
    //~ console.log('20120110 Lino.Window.constructor() 3');
    
  },
  initComponent : function() {
    this.main_item.init_containing_window(this);
    Lino.Window.superclass.initComponent.call(this);
  
  },
  hide : function() { 
      this.main_item.do_when_clean(false,function() { 
        Lino.close_window(); });
  },
  hide_really : function() { 
    Lino.Window.superclass.hide.call(this);
  },
  onRender : function(ct, position){
    // console.log('20140829 Lino.Window.onRender() 1');
    Lino.Window.superclass.onRender.call(this, ct, position);
    var main_area = Ext.getCmp('main_area')
    //~ console.log('20120110 Lino.Window.onRender() 2');
  
    this.on('show', function(win) {
        // console.log('20140829 Lino.Window.on(show) : add resize handler');
        main_area.on('resize', win.onWindowResize, win);
    });
    this.on('hide', function(win) {
        // console.log('20140829 Lino.Window.on(hide) : remove resize handler');
        main_area.un('resize', win.onWindowResize, win);
    });
    // console.log('20140829 Lino.Window.onRender() 3');
  }
});


Ext.override(Ext.form.BasicForm,{
    my_loadRecord : function(record_data){
    //~ loadRecord : function(record){
        /* Same as ExtJS's loadRecord() (setValues()), except that we
        forward also the record_data to field.setValue(). This second
        parameter is used by Lino.Combobox.
        */
        //~ console.log('20120918 my_loadRecord', record_data)
        if(Ext.isArray(record_data)){ 
            for(var i = 0, len = record_data.length; i < len; i++){
                var v = record_data[i];
                var f = this.findField(v.id);
                if(f){
                    f.setValue(v.value, record_data);
                    if(this.trackResetOnLoad){
                        f.originalValue = f.getValue();
                    }
                }
            }
        }else{ 
            var field, id;
            for(id in record_data){
                if(!Ext.isFunction(record_data[id]) && (field = this.findField(id))){
                    field.setValue(record_data[id], record_data);
                    if(this.trackResetOnLoad){
                        field.originalValue = field.getValue();
                        //~ if (field.hiddenField) {
                          //~ field.hiddenField.originalValue = field.hiddenField.value;
                        //~ }
                    }
                }
            }
        }
        return this;
    }
});




function initializeFooBarDropZone(cmp) {
    //~ console.log('initializeFooBarDropZone',cmp);
    cmp.dropTarget = new Ext.dd.DropTarget(cmp.bwrap, {
      //~ ddGroup     : 'gridDDGroup',
      notifyEnter : function(ddSource, e, data) {
        console.log('notifyEnter',ddSource,e,data);
        //Add some flare to invite drop.
        cmp.body.stopFx();
        cmp.body.highlight();
      },
      notifyDrop  : function(ddSource, e, data){
        console.log('notifyDrop',ddSource,e,data);
        // Reference the record (single selection) for readability
        //~ var selectedRecord = ddSource.dragData.selections[0];


        // Load the record into the form
        //~ formPanel.getForm().my_loadRecord(selectedRecord);


        // Delete record from the grid.  not really required.
        //~ ddSource.grid.store.remove(selectedRecord);

        return(true);
      }
    })
}



Lino.show_mti_child = function(fieldname,detail_handler) {
  //~ console.log('show_mti_child',this);
  //~ console.log('show_mti_child',panel.find("main_area"));
  rec = Lino.current_window.main_item.get_current_record();
  //~ rec = panel.get_current_record();
  if (rec) {
    //~ console.log('show_mti_child',Lino.current_window,rec);
    if (rec.phantom) {
      Lino.notify('Not allowed on phantom record.');
    }else if (rec.data[fieldname]) {
      //~ console.log('show_mti_child',rec.id);
      //~ detail_handler(Lino.current_window.main_item,{},{record_id:rec.id});
      detail_handler.run(null,{record_id:rec.id});
      //~ window.open(urlroot + '/' + rec.id);
      //~ document.location = urlroot + '/' + rec.id;
      //~ window.open(urlroot + '/' + rec.id,'_blank');
    } else {
      Lino.alert("Kann MTI-Kind nicht anzeigen wenn Checkbox abgeschlatet ist.");
    }
  } else {
    Lino.notify('No current record.');
  }
};


/*
captureEvents utility by Aaron Conran
<http://www.sencha.com/learn/grid-faq/>

Ext.onReady(function(){
    var grid = new Ext.grid.GridPanel({
        ... 
    });
    captureEvents(grid);
});
*/
function captureEvents(observable) {
    Ext.util.Observable.capture(
        observable,
        function(eventName) {
            console.info(eventName);
        },
        this
    );		
}

// settings.SITE.get_plugin_snippets()




// from lino_xl.lib.beid (media_name=eidreader):beid/eidreader.js


Lino.beid_read_card_processor = function() {
    var card = document.applets.EIDReader.readCard();
    // if (!card) {
    //     Lino.alert("Could not find any card on your reader.");
    //     return null;
    // } 
    // console.log(20140301, card);
    return { card_data: card };
}


// from lino_xl.lib.sepa:iban/uppercasetextfield.js

Lino.UppercaseTextField = Ext.extend(Ext.form.TextField,{
  style: 'text-transform:uppercase;',
  listeners:{
    change: function(field, newValue, oldValue){
      // console.log("20140403 UppercaseTextField",newValue, newValue.toUpperCase());
      field.setRawValue(newValue.toUpperCase());
    }
  }
});


Lino.iban_renderer = function(
    value, metaData, record, rowIndex, colIndex, store) 
{
    var reg = new RegExp(".{4}", "g");
    if(value) {
        return value.replace(reg, function (a) { return a + ' '; });
    }
    return value;
}




// from lino_xl.lib.extensible (media_name=extensible-1.0.1):snippets/extensible.js

/*
  This is the `extensible.js` snippet. 
  Used in lino.modlib.extensible.App.site_js_snippets
*/

/*
Mappings towards lino.modlib.extensible.models.PanelCalendars
*/
// Sset SS = Ssite.modules.extensible.PanelCalendars.get_handle(Sui).store
Ext.ensible.cal.CalendarMappings = {
    CalendarId:   {name:'ID',       mapping: 'id', type: 'int'},
    Title:        {name:'CalTitle', mapping: 'summary', type: 'string'},
    Description:  {name:'Desc',     mapping: 'description', type: 'string'},
    ColorId:      {name:'Color',    mapping: 'color', type: 'int'},
    IsHidden:     {name:'Hidden',   mapping: 'is_hidden', type: 'boolean'},    
};
Ext.ensible.cal.CalendarRecord.reconfigure();  


/*
Mappings towards lino.modlib.extensible.models.PanelEvents 
*/
// Sset SS = Ssite.modules.extensible.PanelEvents.get_handle(Sui).store
Ext.ensible.cal.EventMappings = {
    EventId:     {name: 'ID',        mapping: 'id', type:'int'},
    CalendarId:  {name: 'CalID',     mapping: 'calendarHidden', type: 'int'},
    Title:       {name: 'EvtTitle',  mapping: 'summary'},
    StartDate:   {name: 'StartDt',   mapping: 'start_dt', 
      type: 'date', 
      dateFormat: "Y-m-d\TH:i:s" },
    EndDate:     {name: 'EndDt',     mapping: 'end_dt', 
      type: 'date', 
      dateFormat: "Y-m-d\TH:i:s"},
    RRule:       {name: 'RecurRule', mapping: 'rsetHidden'},
    Location:    {name: 'Location',  mapping: 'placeHidden'},
    Notes:       {name: 'Desc',      mapping: 'description'},
    Url:         {name: 'LinkUrl',   mapping: 'url'},
    IsAllDay:    {name: 'AllDay',    mapping: 'all_day', type: 'boolean'},
    Reminder:    {name: 'Reminder',  mapping: 'reminder'}
    
};
Ext.ensible.cal.EventRecord.reconfigure();


//~ Lino.on_eventclick = 
    
Lino.on_editdetails = 

Lino.format_time = function(dt) {
    return dt.getHours() + ':' + dt.getMinutes();
}
    
Lino.on_eventdelete = function() {
  //~ console.log("Lino.on_eventdelete",arguments);
};

Lino.on_eventadd  = function(cp,rec,el) {
  //~ console.log("Lino.on_eventadd ",arguments);
  return false;
}
    
Lino.on_eventresize  = function(cp,rec,el) {
  //~ console.log("Lino.on_eventresize ",arguments);
  //~ Lino.cal.Events.insert(cp);
  //~ return false;
}
    
Lino.on_eventupdate  = function(cp,rec,el) {
  //~ console.log("Lino.on_eventupdate",arguments);
  //~ Lino.cal.Events.insert(cp);
  //~ return false;
}
    

//~ Lino.eventStore = new Ext.ensible.cal.EventStore({ 
//~ Lino.eventStore = new Ext.data.ArrayStore({ 
Lino.unused_eventStore = new Ext.data.JsonStore({ 
  listeners: { exception: Lino.on_store_exception }
  ,url: '/restful/extensible/PanelEvents'
  ,restful : true
  ,proxy: new Ext.data.HttpProxy({ 
      url: '/restful/extensible/PanelEvents', 
      disableCaching: false // no need for cache busting when loading via Ajax
      //~ disableCaching:true,
  })
  ,fields: Ext.ensible.cal.EventRecord.prototype.fields.getRange()
  ,totalProperty: "count"
  ,root: "rows"
  ,idProperty: Ext.ensible.cal.EventMappings.EventId.mapping
  ,writer : new Ext.data.JsonWriter({
    writeAllFields: false
  })
  ,load: function(options) {
    //~ foo.bar = baz; // 20120213
      if (!options) options = {};
      if (!options.params) options.params = {};
      //~ options.params.$constants.URL_PARAM_TEAM_VIEW = Lino.calendar_app.team_view_button.pressed;
      
      var view = this.cal_panel.getActiveView();
      var bounds = view.getViewBounds();
      //~ var p = {sd:'05.02.2012',ed:'11.02.2012'};
      //~ var p = {};
      options.params[view.dateParamStart] = bounds.start.format(view.dateParamFormat);
      options.params[view.dateParamEnd] = bounds.end.format(view.dateParamFormat);
      Lino.insert_subst_user(options.params);
      //~ Ext.apply(options.params,p)
      //~ console.log('20120710 eventStore.load()',this.baseParams,options);
    
    return Ext.data.JsonStore.prototype.load.call(this,options);
  }
});


Lino.CalendarCfg = {
    dateParamFormat: 'd.m.Y',
    dateParamStart:'sd',
    dateParamEnd:'ed'
};
//~ 20120704 Lino.CalendarPanel = Ext.extend(Ext.ensible.cal.CalendarPanel,Lino.MainPanel);
//~ Lino.CalendarPanel = Ext.extend(Lino.CalendarPanel,{
Ext.override(Ext.ensible.cal.CalendarPanel,Lino.MainPanel);
Ext.override(Ext.ensible.cal.CalendarPanel,{
  //~ empty_title : "\$ui.get_actor('cal.Panel').report.label",
  empty_title : "Kalender"
  ,activeItem: 1 // 0: day, 1: week
  ,ls_url: '/extensible/CalendarPanel'
  //~ ,disableCaching:true
  //~ ,eventStore: Lino.eventStore
  //~ ,calendarStore: Lino.calendarStore
  //~ ,initComponent : function(){
    //~ Ext.ensible.cal.CalendarPanel.superclass.initComponent.call(this);
    //~ this.eventStore.on('load',function(){
      //~ console.log("20130808",Lino.eventStore);
      //~ if (this.eventStore.reader.jsonData) {
        //~ console.log("20130808 b",this.eventStore.reader.jsonData.title);
        //~ this.set_window_title(this.eventStore.reader.jsonData.title);
      //~ }
    //~ },this);
  //~ }
  ,listeners: { 
    editdetails: function(cp,rec,el) {
      //~ console.log("Lino.on_editdetails",arguments);
      if (rec.data.ID)
          Lino.extensible.PanelEvents.detail.run(null,{
              record_id:rec.data.ID,
              base_params:this.app_instance.event_store.baseParams});
      return false;
    }
    ,eventclick: function(cp,rec,el) {
      //~ console.log("Lino.on_eventclick",arguments);
      //~ Lino.cal.Events.detail_action.run({record_id:rec.data.ID});
      Lino.extensible.PanelEvents.detail.run(null,{
            record_id:rec.data.ID,
                base_params:this.app_instance.event_store.baseParams});
      return false;
    }
    //~ ,eventadd: Lino.on_eventadd
    //~ ,eventdelete: Lino.on_eventdelete
    //~ ,eventresize: Lino.on_eventresize
    ,afterrender : function(config) {
      // console.log("20140402 CalendarPanel.afterrender");
      this.app_instance.calendar_store.cal_panel = this;
      // 20140402 this.app_instance.calendar_store.load();
      //~ console.log("20120704 afterrender calls eventStore.load()",p);
      this.app_instance.event_store.cal_panel = this;
      //~ Lino.eventStore.load({params:p});
      //~ 20130905 removed: this.app_instance.event_store.load();
      //~ Lino.CalendarPanel.superclass.constructor.call(this, config);
      //~ console.log(20120118, config,this);
    }
    }
  ,enableEditDetails: false
  //~ ,monthViewCfg: Lino.CalendarCfg
  //~ ,weekViewCfg: Lino.CalendarCfg
  //~ ,multiDayViewCfg: Lino.CalendarCfg
  //~ ,multiWeekViewCfg: Lino.CalendarCfg
  //~ ,dayViewCfg: Lino.CalendarCfg
  //~ ,initComponent : function() {
    //~ // this.on('eventadd',Lino.on_eventadd);
    //~ Lino.CalendarPanel.superclass.initComponent.call(this);
  //~ }
});




Lino.CalendarAppPanel = Ext.extend(Ext.Panel,Lino.MainPanel);
Lino.CalendarAppPanel = Ext.extend(Lino.CalendarAppPanel,Lino.PanelMixin);
Lino.CalendarAppPanel = Ext.extend(Lino.CalendarAppPanel,{
  app_instance : null
  //~ empty_title : "\$ui.get_actor('cal.Panel').report.label",
  ,empty_title : "Kalender"
  ,ls_url: '/extensible/CalendarPanel'
  ,set_status : function(status,rp) { 
      // console.log('20140402 CalendarAppPanel.set_status()', status);
      this.requesting_panel = Ext.getCmp(rp);
      this.clear_base_params();
      if (status == undefined) status = {};
      //~ if (status.param_values) 
      //~ this.set_field_values(status.field_values);
      if (status.base_params) this.set_base_params(status.base_params);
      this.refresh();
      }
  ,refresh : function() {
      //~ this.app_instance.event_store.reload(); 20130905
      this.app_instance.calendar_store.load();  // added 20140402
      this.app_instance.event_store.load();
  }
  ,layout: 'fit'
  ,get_base_params : function() {
    // console.log('20140402 getbase_params has', this.base_params);
    var p = Ext.apply({}, this.base_params);
    Lino.insert_subst_user(p);
    // console.log('20140402 getbase_params returns', p);
    return p;
  }
  ,set_base_params : function(p) {
    this.base_params = Ext.apply(this.app_instance.event_store.baseParams,p);
    this.app_instance.event_store.baseParams = this.base_params;
    // console.log('20140402 this.base_params is', this.base_params);
  }
  ,clear_base_params : function() {
      this.base_params = {};
      Lino.insert_subst_user(this.base_params);
  }
  ,set_base_param : function(k,v) {
      if (!this.base_params) this.base_params = {};
      this.base_params[k] = v;
  }
});

Lino.CalendarApp = function() { return {
  team_view_button : null 
  ,get_main_panel : function() {
      var cap = null;
      this.event_store = new Ext.data.JsonStore({ 
          listeners: { exception: Lino.on_store_exception }
          ,url: '/restful/extensible/PanelEvents'
          ,restful : true
          ,proxy: new Ext.data.HttpProxy({ 
              url: '/restful/extensible/PanelEvents', 
              disableCaching: false // no need for cache busting when loading via Ajax
              //~ disableCaching:true,
          })
          ,fields: Ext.ensible.cal.EventRecord.prototype.fields.getRange()
          ,totalProperty: "count"
          ,root: "rows"
          ,idProperty: Ext.ensible.cal.EventMappings.EventId.mapping
          ,writer : new Ext.data.JsonWriter({
            writeAllFields: false
          })
          ,load: function(options) {
            //~ foo.bar = baz; // 20120213
              if (!options) options = {};
              if (!options.params) options.params = {};
              //~ options.params.$constants.URL_PARAM_TEAM_VIEW = Lino.calendar_app.team_view_button.pressed;
              
              var view = this.cal_panel.getActiveView();
              var bounds = view.getViewBounds();
              //~ var p = {sd:'05.02.2012',ed:'11.02.2012'};
              //~ var p = {};
              options.params[view.dateParamStart] = bounds.start.format(view.dateParamFormat);
              options.params[view.dateParamEnd] = bounds.end.format(view.dateParamFormat);
              Lino.insert_subst_user(options.params);
              Ext.apply(options.params, cap.get_base_params());
              //~ this.cal_panel.base_params.su.toString();
              //~ if (this.cal_panel) {
                  // Ext.apply(options.params,this.cal_panel.base_params);
              //~ }
              //~ Ext.apply(options.params,p)
              //~ console.log('20130905 eventStore.load()',this.cal_panel,this.baseParams,options.params);
            
            return Ext.data.JsonStore.prototype.load.call(this,options);
          }
      });

      //~ Lino.calendarStore
      this.calendar_store = new Ext.data.JsonStore({ 
          listeners: { exception: Lino.on_store_exception }
          ,restful : true
          ,proxy: new Ext.data.HttpProxy({ 
              url: '/restful/extensible/PanelCalendars?fmt=json', 
              disableCaching: false // no need for cache busting when loading via Ajax
              //~ restful : true
              //~ method: "GET"
          })
          //~ ,autoLoad: true
          //~ ,remoteSort: true
          //~ ,baseParams: bp
          ,totalProperty: "count"
          ,root: "rows"
          ,fields: Ext.ensible.cal.CalendarRecord.prototype.fields.getRange()
          ,idProperty: Ext.ensible.cal.CalendarMappings.CalendarId.mapping
          //~ ,idIndex: Ext.ensible.cal.CalendarMappings.CalendarId.mapping
          ,load: function(options) {
              // new since 20140402 add substitute user when calling
              // calendars
              if (!options) options = {};
              if (!options.params) options.params = {};
              // Lino.insert_subst_user(options.params);
              Ext.apply(options.params, cap.get_base_params());
              // console.log("20140402 calendar_store.load", options.params, 
              //             this.cal_panel, cap.get_base_params());
            return Ext.data.JsonStore.prototype.load.call(this,options);
          }
      });
      
      cap = new Lino.CalendarAppPanel({ 
          app_instance: this, 
          items : 
        //~ [{
          //~ id: 'app-header',
          //~ region: 'north',
          //~ height: 35,
          //~ border: false,
          // contentEl: 'app-header-content'
        //~ },
      {
          id: 'app-center',
          title: '...', // will be updated to the current view's date range
          region: 'center',
          layout: 'border',
          listeners: {
              'afterrender': function(){
                  Ext.getCmp('app-center').header.addClass('app-center-header');
              }
          },
          items: [{
              id:'app-west',
              region: 'west',
              width: 176,
              border: false,
              items: [{
                  xtype: 'datepicker',
                  id: 'app-nav-picker',
                  cls: 'ext-cal-nav-picker',
                  listeners: {
                      'select': {
                          fn: function(dp, dt){
                              // console.log("20131017",dp);
                              //~ Lino.calendarPanel.setStartDate(dt);
                              //~ cap.setStartDate(dt);
                              Ext.getCmp('app-calendar').setStartDate(dt);
                          },
                          //~ scope: this
                      }
                  }
              //~ },{ 
                //~ layout:'fit',
                //~ items: [
                  //~ new Ext.form.Checkbox({
                    //~ boxLabel:"$_('Team view')",
                    //~ hideLabel:true
                    //~ listeners: { click: }
                  //~ })
                //~ ]
              //~ },{ 
                //~ layout:'form',
                //~ items: [
                  //~ this.team_view_button = new Ext.Button({
                    //~ text:"Team view",
                    //~ enableToggle:true,
                    //~ pressed:false,
                    //~ toggleHandler: function(btn,state) { 
                      //~ // console.log('20120716 teamView.toggle()');
                      //~ this.event_store.setBaseParam('tv',state);
                      //~ this.event_store.load();
                      //~ // console.log("team view",state);
                    //~ }
                  //~ })
                //~ ]
              },{
                  xtype: 'extensible.calendarlist',
                  store: this.calendar_store,
                  border: false,
                  width: 175
              }]
          },{
              xtype: 'extensible.calendarpanel', // Ext.ensible.cal.CalendarPanel
              eventStore: this.event_store,
              app_instance: this,
              calendarStore: this.calendar_store,
              border: false,
              id:'app-calendar',
              region: 'center',
              //~ activeItem: 3, // month view
              
              // Any generic view options that should be applied to all sub views:
              viewConfig: {
                  // Lino.CalendarCfg
                  dateParamFormat: 'd.m.Y',
                  dateParamStart:'sd',
                  dateParamEnd:'ed',
                
                  //enableFx: false,
                  //ddIncrement: 10, //only applies to DayView and subclasses, but convenient to put it here
                  viewStartHour: 9, // 8
                  viewEndHour: 21 // 18
                  //minEventDisplayMinutes: 15
              },
              
              // View options specific to a certain view (if the same options exist in viewConfig
              // they will be overridden by the view-specific config):
              monthViewCfg: {
                  showHeader: true,
                  showWeekLinks: true,
                  showWeekNumbers: true,
                  eventBodyMarkup: ['{Title}',
                    //~ '<tpl if="url">',
                        //~ '<a href="{url}">XX</a>',
                    //~ '</tpl>',
                    '<tpl if="_isReminder">',
                        '<i class="ext-cal-ic ext-cal-ic-rem">&#160;</i>',
                    '</tpl>',
                    '<tpl if="_isRecurring">',
                        '<i class="ext-cal-ic ext-cal-ic-rcr">&#160;</i>',
                    '</tpl>',
                    '<tpl if="spanLeft">',
                        '<i class="ext-cal-spl">&#160;</i>',
                    '</tpl>',
                    '<tpl if="spanRight">',
                        '<i class="ext-cal-spr">&#160;</i>',
                    '</tpl>'
                ].join('')
              },
              
              multiWeekViewCfg: {
                  //weekCount: 3
              },
              
              // Some optional CalendarPanel configs to experiment with:
              //readOnly: true,
              //showDayView: false,
              //showMultiDayView: true,
              //showWeekView: false,
              //showMultiWeekView: false,
              //showMonthView: false,
              //showNavBar: false,
              //showTodayText: false,
              //showTime: false,
              //editModal: true,
              //enableEditDetails: false,
              //title: 'My Calendar', // the header of the calendar, could be a subtitle for the app
              
              // Once this component inits it will set a reference to itself as an application
              // member property for easy reference in other functions within App.
              //~ initComponent: function() {
                  //~ Lino.calendarPanel = this;
                  //~ this.constructor.prototype.initComponent.apply(this, arguments);
              //~ },
              
              listeners: {
                  //~ 'eventclick': {
                      //~ fn: function(vw, rec, el){
                          //~ this.clearMsg();
                      //~ },
                      //~ scope: this
                  //~ },
                  'eventover': function(vw, rec, el){
                      //console.log('Entered evt rec='+rec.data[Ext.ensible.cal.EventMappings.Title.name]', view='+ vw.id +', el='+el.id);
                  },
                  'eventout': function(vw, rec, el){
                      //console.log('Leaving evt rec='+rec.data[Ext.ensible.cal.EventMappings.Title.name]+', view='+ vw.id +', el='+el.id);
                  },
                  'eventadd': {
                      fn: function(cp, rec){
                          this.showMsg('Event '+ rec.data[Ext.ensible.cal.EventMappings.Title.name] +' was added');
                      },
                      scope: this
                  },
                  'eventupdate': {
                      fn: function(cp, rec){
                          this.showMsg('Event '+ rec.data[Ext.ensible.cal.EventMappings.Title.name] +' was updated');
                      },
                      scope: this
                  },
                  'eventdelete': {
                      fn: function(cp, rec){
                          //this.eventStore.remove(rec);
                          this.showMsg('Event '+ rec.data[Ext.ensible.cal.EventMappings.Title.name] +' was deleted');
                      },
                      scope: this
                  },
                  'eventcancel': {
                      fn: function(cp, rec){
                          // edit canceled
                      },
                      scope: this
                  },
                  'viewchange': {
                      fn: function(p, vw, dateInfo){
                          if(this.editWin){
                              this.editWin.hide();
                          };
                          if(dateInfo !== null){
                              // will be null when switching to the event edit form so ignore
                              Ext.getCmp('app-nav-picker').setValue(dateInfo.activeDate);
                              this.updateTitle(dateInfo.viewStart, dateInfo.viewEnd);
                          }
                          
                      },
                      scope: this
                  },
                  'dayclick': {
                      fn: function(vw, dt, ad, el){
                          this.clearMsg();
                      },
                      scope: this
                  },
                  'rangeselect': {
                      fn: function(vw, dates, onComplete){
                          this.clearMsg();
                      },
                      scope: this
                  },
                  'eventmove': {
                      fn: function(vw, rec){
                          rec.commit();
                          var time = rec.data[Ext.ensible.cal.EventMappings.IsAllDay.name] ? '' : ' \\a\\t g:i a';
                          this.showMsg('Event '+ rec.data[Ext.ensible.cal.EventMappings.Title.name] +' was moved to '+
                              rec.data[Ext.ensible.cal.EventMappings.StartDate.name].format('F jS'+time));
                      },
                      scope: this
                  },
                  'eventresize': {
                      fn: function(vw, rec){
                          rec.commit();
                          this.showMsg('Event '+ rec.data[Ext.ensible.cal.EventMappings.Title.name] +' was updated');
                      },
                      scope: this
                  },
                  'eventdelete': {
                      fn: function(win, rec){
                          this.event_store.remove(rec);
                          this.showMsg('Event '+ rec.data[Ext.ensible.cal.EventMappings.Title.name] +' was deleted');
                      },
                      scope: this
                  },
                  'initdrag': {
                      fn: function(vw){
                          if(this.editWin && this.editWin.isVisible()){
                              this.editWin.hide();
                          }
                      },
                      scope: this
                  }
              }
          }]
        }
        //~ ]
        
      });
      
      this.event_store.on('load',function(){
        //~ console.log("20130905 on event_store load",this.event_store.reader.jsonData);
        if (this.event_store.reader.jsonData) {
          //~ console.log("20130808 b",this.event_store.reader.jsonData.title);
          //~ console.log("20130808 c",this);
          cap.set_window_title(this.event_store.reader.jsonData.title);
        }
      },this);
      
      //~ cap.app_instance = this;
      return cap;
      
  }
  ,updateTitle: function(startDt, endDt){
      var p = Ext.getCmp('app-center');
      
      if(startDt.clearTime().getTime() == endDt.clearTime().getTime()){
          p.setTitle(startDt.format('F j, Y'));
      }
      else if(startDt.getFullYear() == endDt.getFullYear()){
          if(startDt.getMonth() == endDt.getMonth()){
              p.setTitle(startDt.format('F j') + ' - ' + endDt.format('j, Y'));
          }
          else{
              p.setTitle(startDt.format('F j') + ' - ' + endDt.format('F j, Y'));
          }
      }
      else{
          p.setTitle(startDt.format('F j, Y') + ' - ' + endDt.format('F j, Y'));
      }
  }
  // This is an application-specific way to communicate CalendarPanel event messages back to the user.
  // This could be replaced with a function to do "toast" style messages, growl messages, etc. This will
  // vary based on application requirements, which is why it's not baked into the CalendarPanel.
  ,showMsg: function(msg){
      Lino.notify(msg);
      //~ Ext.fly('app-msg').update(msg).removeClass('x-hidden');
  }
  
  ,clearMsg: function(){
      Lino.notify('');
      //~ Ext.fly('app-msg').update('').addClass('x-hidden');
  }
}
};

Lino.main_menu = [ { "menu": { "items": [ { "handler": function() {Lino.contacts.Persons.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all persons.") }, "text": "Personen" }, { "handler": function() {Lino.contacts.Companies.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","An organisation.  The verbose name is \"Organization\" while the\ninternal name is \"Company\" because the latter easier to type and\nfor historical reasons.") }, "text": "Organisationen" }, { "handler": function() {Lino.lists.Lists.grid.run(null)}, "text": "Partnerlisten" } ] }, "text": "Kontakte" }, { "menu": { "items": [ { "handler": function() {Lino.plausibility.MyProblems.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows the plausibility problems assigned to this user.") }, "text": "Meine Datenkontrollliste" }, { "handler": function() {Lino.notify.MyMessages.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows messages emitted to you.") }, "text": "Meine Benachrichtigungen" }, { "handler": function() {Lino.notes.MyNotes.grid.run(null)}, "text": "Meine Notizen" }, { "handler": function() {Lino.uploads.MyUploads.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows only my Uploads (i.e. those whose author is current user).") }, "text": "Meine Uploads" }, { "handler": function() {Lino.outbox.MyOutbox.grid.run(null)}, "text": "Mein E-Mail-Ausgang" }, { "handler": function() {Lino.excerpts.MyExcerpts.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base class for all tables on Excerpt.") }, "text": "Meine Ausz\u00fcge" } ] }, "text": "B\u00fcro" }, { "menu": { "items": [ { "handler": function() {Lino.cal.MyEntries.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Table which shows today's and all future appointments of the\nrequesting user.  The default filter parameters are set to show\nonly appointments.") }, "text": "Meine Termine" }, { "handler": function() {Lino.cal.OverdueAppointments.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows overdue appointments, i.e. appointments whose date is\nover but who are still in a nonstable state.") }, "text": "\u00dcberf\u00e4llige Termine" }, { "handler": function() {Lino.cal.MyUnconfirmedAppointments.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows my appointments in the near future which are in suggested or\ndraft state.") }, "text": "Unbest\u00e4tigte Termine" }, { "handler": function() {Lino.cal.MyTasks.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Alle meine Aufgaben") }, "text": "Meine Aufgaben" }, { "handler": function() {Lino.cal.MyGuests.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The default table for Guest.") }, "text": "Meine G\u00e4ste" }, { "handler": function() {Lino.cal.MyPresences.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all my presences in calendar events, independently of their\nstate.") }, "text": "Meine Anwesenheiten" }, { "handler": function() {Lino.cal.MyOverdueAppointments.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Like OverdueAppointments, but only for myself.") }, "text": "Meine \u00fcberf\u00e4lligen Termine" }, { "handler": function() {Lino.rooms.Bookings.grid.run(null)}, "text": "Buchungen" }, { "handler": function() {Lino.extensible.CalendarPanel.grid.run(null)}, "iconCls": "x-tbar-calendar", "listeners": { "render": Lino.quicktip_renderer("Foo","Displays your events in a \"calendar view\"     with the possibility to switch between daily, weekly, monthly view.") }, "text": "Kalender" } ] }, "text": "Kalender" }, { "menu": { "items": [ { "menu": { "items": [ { "handler": function() {Lino.sales.InvoicesByJournal.grid.run(null,{ "base_params": { "mk": 1, "mt": 37 }, "param_values": { "cleared": null, "clearedHidden": null, "partner": null, "partnerHidden": null, "state": null, "stateHidden": null, "year": null, "yearHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all invoices of a given journal (whose voucher_type must be\nVatProductInvoice)") }, "text": "Verkaufsrechnungen (SLS)" }, { "handler": function() {Lino.sales.InvoicesByJournal.grid.run(null,{ "base_params": { "mk": 2, "mt": 37 }, "param_values": { "cleared": null, "clearedHidden": null, "partner": null, "partnerHidden": null, "state": null, "stateHidden": null, "year": null, "yearHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all invoices of a given journal (whose voucher_type must be\nVatProductInvoice)") }, "text": "Gutschriften Verkauf (SLC)" } ] }, "text": "Verkauf" }, { "menu": { "items": [ { "handler": function() {Lino.vat.InvoicesByJournal.grid.run(null,{ "base_params": { "mk": 3, "mt": 37 }, "param_values": { "end_period": null, "end_periodHidden": null, "partner": null, "partnerHidden": null, "start_period": null, "start_periodHidden": null, "state": null, "stateHidden": null, "user": null, "userHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all invoices of a given journal (whose\nvoucher_type\nmust be lino_xl.lib.vat.models.VatAccountInvoice)") }, "text": "Einkaufsrechnungen (PRC)" } ] }, "text": "Einkauf" }, { "menu": { "items": [ { "handler": function() {Lino.finan.PaymentOrdersByJournal.grid.run(null,{ "base_params": { "mk": 4, "mt": 37 }, "param_values": { "end_period": null, "end_periodHidden": null, "start_period": null, "start_periodHidden": null, "state": null, "stateHidden": null, "user": null, "userHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Mixin for journal-based tables of vouchers.") }, "text": "Zahlungsauftr\u00e4ge (PMO)" }, { "handler": function() {Lino.finan.BankStatementsByJournal.grid.run(null,{ "base_params": { "mk": 5, "mt": 37 }, "param_values": { "end_period": null, "end_periodHidden": null, "start_period": null, "start_periodHidden": null, "state": null, "stateHidden": null, "user": null, "userHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Mixin for journal-based tables of vouchers.") }, "text": "Kasse (CSH)" }, { "handler": function() {Lino.finan.BankStatementsByJournal.grid.run(null,{ "base_params": { "mk": 6, "mt": 37 }, "param_values": { "end_period": null, "end_periodHidden": null, "start_period": null, "start_periodHidden": null, "state": null, "stateHidden": null, "user": null, "userHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Mixin for journal-based tables of vouchers.") }, "text": "Bestbank (BNK)" }, { "handler": function() {Lino.finan.JournalEntriesByJournal.grid.run(null,{ "base_params": { "mk": 7, "mt": 37 }, "param_values": { "end_period": null, "end_periodHidden": null, "start_period": null, "start_periodHidden": null, "state": null, "stateHidden": null, "user": null, "userHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Mixin for journal-based tables of vouchers.") }, "text": "Diverse Buchungen (MSC)" } ] }, "text": "Finanzjournale" }, { "handler": function() {Lino.list_action_handler('/invoicing/Plans','start_invoicing','POST',null)()}, "iconCls": "x-tbar-basket", "listeners": { "render": Lino.quicktip_renderer("Foo","Base for StartInvoicingForJournal,\nStartInvoicingForPartner.") }, "text": "Rechnungen erstellen" } ] }, "text": "Buchhaltung" }, { "menu": { "items": [ { "handler": function() {Lino.courses.Pupils.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The global list of all pupils.") }, "text": "Teilnehmer" }, { "handler": function() {Lino.courses.Teachers.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all persons.") }, "text": "Kursleiter" }, "-", { "handler": function() {Lino.courses.Courses.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base table for all activities.") }, "text": "Kurse" }, { "handler": function() {Lino.courses.Hikes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base table for all activities.") }, "text": "Ausfahrten" }, { "handler": function() {Lino.courses.Journeys.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base table for all activities.") }, "text": "Reisen" }, "-", { "handler": function() {Lino.courses.Topics.grid.run(null)}, "text": "Themen" }, { "handler": function() {Lino.courses.Lines.grid.run(null)}, "text": "Aktivit\u00e4tenreihen" }, "-", { "handler": function() {Lino.courses.PendingRequestedEnrolments.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Show all requested enrolments.") }, "text": "Offene Einschreibungsanfragen" }, { "handler": function() {Lino.courses.PendingConfirmedEnrolments.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Show all confirmed enrolments.") }, "text": "Auszustellende Teilnahmebescheinigungen" } ] }, "text": "Aktivit\u00e4ten" }, { "menu": { "items": [ { "menu": { "items": [ { "handler": function() {Lino.ledger.AccountingReport.show.run(null,{ "record_id": -99998 })}, "listeners": { "render": Lino.quicktip_renderer("Foo","A combined report which produces a series of reports for a given\nperiod as one action.") }, "text": "Accounting Report" }, { "handler": function() {Lino.ledger.GeneralAccountsBalance.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","An AccountsBalance for general accounts.") }, "text": "Saldenliste Generalkonten" }, { "handler": function() {Lino.ledger.CustomerAccountsBalance.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","A PartnerAccountsBalance for the TradeType \"sales\".") }, "text": "Saldenliste Kunden" }, { "handler": function() {Lino.ledger.SupplierAccountsBalance.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","An AccountsBalance for partner accounts.") }, "text": "Saldenliste Lieferanten" }, { "handler": function() {Lino.ledger.Debtors.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","List of partners who are in debt towards us (usually customers).") }, "text": "Schuldner" }, { "handler": function() {Lino.ledger.Creditors.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","List of partners who are giving credit to us (usually suppliers).") }, "text": "Gl\u00e4ubiger" }, { "handler": function() {Lino.vat.PrintableInvoicesByJournal.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Mixin for journal-based tables of vouchers.") }, "text": "Purchase journal" }, { "handler": function() {Lino.vat.IntracomPurchases.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Show a list of all purchase invoices whose vat_regime is\nintra-Community.") }, "text": "Intra-Community purchases" }, { "handler": function() {Lino.vat.IntracomSales.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Show a list of all sales invoices whose vat_regime is\nintra-Community.") }, "text": "Intra-Community sales" }, { "handler": function() {Lino.sales.DueInvoices.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all due product invoices.") }, "text": "Offene Rechnungen" }, { "handler": function() {Lino.sales.PrintableInvoicesByJournal.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Mixin for journal-based tables of vouchers.") }, "text": "Sales invoice journal" } ] }, "text": "Buchhaltung" }, { "menu": { "items": [ { "handler": function() {Lino.courses.StatusReport.show.run(null,{ "record_id": -99998 })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Gives an overview about what's up today .") }, "text": "Statusbericht" } ] }, "text": "Aktivit\u00e4ten" } ] }, "text": "Berichte" }, { "menu": { "items": [ { "menu": { "items": [ { "handler": function() {Lino.system.SiteConfigs.detail.run(null,{ "record_id": 1 })}, "iconCls": "x-tbar-application_form", "text": "Site-Parameter" }, { "handler": function() {Lino.users.AllUsers.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows the list of all users on this site.") }, "text": "Benutzer" }, { "handler": function() {Lino.gfks.HelpTexts.grid.run(null)}, "text": "Hilfetexte" } ] }, "text": "System" }, { "menu": { "items": [ { "handler": function() {Lino.countries.Countries.grid.run(null)}, "text": "L\u00e4nder" }, { "handler": function() {Lino.countries.Places.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","\n    The table of known geographical places.\n    A geographical place can be a city, a town, a suburb,\n    a province, a lake... any named geographic entity,\n    except for countries because these have their own table.\n    ") }, "text": "Orte" } ] }, "text": "Orte" }, { "menu": { "items": [ { "handler": function() {Lino.contacts.CompanyTypes.grid.run(null)}, "text": "Organisationsarten" }, { "handler": function() {Lino.contacts.RoleTypes.grid.run(null)}, "text": "Funktionen" }, { "handler": function() {Lino.lists.ListTypes.grid.run(null)}, "text": "Listenarten" } ] }, "text": "Kontakte" }, { "menu": { "items": [ { "handler": function() {Lino.cal.Calendars.grid.run(null)}, "text": "Kalenderliste" }, { "handler": function() {Lino.cal.AllRooms.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","List of rooms where calendar events can happen.") }, "text": "R\u00e4ume" }, { "handler": function() {Lino.cal.Priorities.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","List of possible priorities of calendar events.") }, "text": "Priorit\u00e4ten" }, { "handler": function() {Lino.cal.RecurrentEvents.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The list of all recurrent events (RecurrentEvent).") }, "text": "Regelm\u00e4\u00dfige Ereignisse" }, { "handler": function() {Lino.cal.GuestRoles.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The role of a guest expresses what the partner is going to do there.") }, "text": "Gastrollen" }, { "handler": function() {Lino.cal.EventTypes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The list of Event Types defined on this system.\n    An EventType is a list of events which have certain things in common,\n    especially they are displayed in the same colour in the calendar panel.\n    ") }, "text": "Kalendereintragsarten" }, { "handler": function() {Lino.cal.EventPolicies.grid.run(null)}, "text": "Wiederholungsregeln" }, { "handler": function() {Lino.cal.RemoteCalendars.grid.run(null)}, "text": "Externe Kalender" } ] }, "text": "Kalender" }, { "menu": { "items": [ { "handler": function() {Lino.products.Products.grid.run(null)}, "text": "Tarife" }, { "handler": function() {Lino.products.ProductCats.grid.run(null)}, "text": "Tarifkategorien" } ] }, "text": "Tarife" }, { "menu": { "items": [ { "handler": function() {Lino.accounts.Groups.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The global table of all account groups.") }, "text": "Kontengruppen" }, { "handler": function() {Lino.accounts.Accounts.grid.run(null)}, "text": "Konten" }, { "handler": function() {Lino.ledger.Journals.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The default table showing all instances of Journal.") }, "text": "Journale" }, { "handler": function() {Lino.ledger.AccountingPeriods.grid.run(null)}, "text": "Buchungsperioden" }, { "handler": function() {Lino.ledger.PaymentTerms.grid.run(null)}, "text": "Zahlungsbedingungen" } ] }, "text": "Buchhaltung" }, { "menu": { "items": [ { "handler": function() {Lino.vat.VatRules.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The table of all lino_xl.lib.vat.models.VatRule objects.") }, "text": "MwSt-Regeln" }, { "handler": function() {Lino.sales.PaperTypes.grid.run(null)}, "text": "Papierarten" } ] }, "text": "MwSt." }, { "menu": { "items": [ { "handler": function() {Lino.courses.CourseTypes.grid.run(null)}, "text": "Aktivit\u00e4tsarten" }, { "handler": function() {Lino.courses.TeacherTypes.grid.run(null)}, "text": "Kursleiterarten" }, { "handler": function() {Lino.courses.PupilTypes.grid.run(null)}, "text": "Teilnehmerarten" }, { "handler": function() {Lino.courses.Slots.grid.run(null)}, "text": "Timetable Slots" } ] }, "text": "Aktivit\u00e4ten" }, { "menu": { "items": [ { "handler": function() {Lino.notes.NoteTypes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Displays all rows of NoteType.") }, "text": "Notizarten" }, { "handler": function() {Lino.notes.EventTypes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","List of all Event Types.") }, "text": "Ereignisarten" }, { "handler": function() {Lino.uploads.UploadTypes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The table with all existing upload types.") }, "text": "Upload-Arten" }, { "handler": function() {Lino.excerpts.ExcerptTypes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Displays all rows of ExcerptType.") }, "text": "Auszugsarten" } ] }, "text": "B\u00fcro" } ] }, "text": "Konfigurierung" }, { "menu": { "items": [ { "menu": { "items": [ { "handler": function() {Lino.users.Authorities.grid.run(null)}, "text": "Vollmachten" }, { "handler": function() {Lino.users.UserTypes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The list of user types available in this application.") }, "text": "Benutzerarten" }, { "handler": function() {Lino.gfks.ContentTypes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Default table for django.contrib.ContentType.") }, "text": "Datenbankmodelle" }, { "handler": function() {Lino.plausibility.Checkers.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The list of plausibility problem types known by this application.") }, "text": "Datentests" }, { "handler": function() {Lino.plausibility.AllProblems.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Show all plausibility problems.") }, "text": "Datenprobleme" }, { "handler": function() {Lino.notify.AllMessages.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The gobal list of all messages.") }, "text": "Benachrichtigungen" }, { "handler": function() {Lino.changes.Changes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The default table for Change.") }, "text": "\u00c4nderungen" } ] }, "text": "System" }, { "menu": { "items": [ { "handler": function() {Lino.contacts.Roles.grid.run(null)}, "text": "Kontaktpersonen" }, { "handler": function() {Lino.contacts.Partners.grid.run(null)}, "text": "Partner" }, { "handler": function() {Lino.lists.AllMembers.grid.run(null)}, "text": "Listenmitgliedschaften" } ] }, "text": "Kontakte" }, { "menu": { "items": [ { "handler": function() {Lino.cal.AllEntries.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Table which shows all calendar events.") }, "text": "Kalendereintr\u00e4ge" }, { "handler": function() {Lino.cal.Tasks.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","A calendar task is something you need to do.") }, "text": "Aufgaben" }, { "handler": function() {Lino.cal.AllGuests.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The default table for Guest.") }, "text": "Anwesenheiten" }, { "handler": function() {Lino.cal.Subscriptions.grid.run(null)}, "text": "Abonnements" }, { "handler": function() {Lino.cal.EntryStates.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The possible states of a calendar entry.") }, "text": "Termin-Zust\u00e4nde" }, { "handler": function() {Lino.cal.GuestStates.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Possible values for the state of a Guest. The list of choices for\nthe Guest.state field.") }, "text": "Gast-Zust\u00e4nde" }, { "handler": function() {Lino.cal.TaskStates.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Possible values for the state of a Task. The list of\nchoices for the Task.state field. By default it contains\nthe following values (which can be redefined in\nworkflows_module):") }, "text": "Aufgaben-Zust\u00e4nde" } ] }, "text": "Kalender" }, { "menu": { "items": [ { "handler": function() {Lino.ledger.MatchRules.grid.run(null)}, "text": "Begleichungsregeln" }, { "handler": function() {Lino.ledger.AllVouchers.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The base table for all tables working on Voucher.") }, "text": "Belege" }, { "handler": function() {Lino.ledger.VoucherTypes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","A list of the voucher types available in this application. Items\nare instances of :class:VoucherType`.") }, "text": "Belegarten" }, { "handler": function() {Lino.ledger.AllMovements.grid.run(null)}, "text": "Bewegungen" }, { "handler": function() {Lino.ledger.FiscalYears.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","A choicelist with the fiscal years available in this database.") }, "text": "Gesch\u00e4ftsjahre" }, { "handler": function() {Lino.ledger.TradeTypes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The type of trade: usually either `sales` or `purchases`.") }, "text": "Handelsarten" }, { "handler": function() {Lino.ledger.JournalGroups.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The list of possible journal groups.") }, "text": "Journalgruppen" } ] }, "text": "Buchhaltung" }, { "menu": { "items": [ { "handler": function() {Lino.vat.VatRegimes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Determines how the VAT is being handled,         i.e. whether and how it is to be paid.") }, "text": "MwSt.-Regimes" }, { "handler": function() {Lino.vat.VatClasses.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The global list of VAT classes.") }, "text": "MwSt.-Klassen" }, { "handler": function() {Lino.vat.VatColumns.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The global list of VAT columns.") }, "text": "VAT columns" }, { "handler": function() {Lino.vat.Invoices.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The table of all\nVatAccountInvoice\nobjects.") }, "text": "Rechnungen" }, { "handler": function() {Lino.sales.Invoices.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base class for tables of partner vouchers.") }, "text": "Produktrechnungen" }, { "handler": function() {Lino.sales.InvoiceItems.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all sales invoice items.") }, "text": "Produktrechnungszeilen" }, { "handler": function() {Lino.invoicing.AllPlans.grid.run(null)}, "text": "Fakturationspl\u00e4ne" } ] }, "text": "MwSt." }, { "menu": { "items": [ { "handler": function() {Lino.courses.AllActivities.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base table for all activities.") }, "text": "Aktivit\u00e4ten" }, { "handler": function() {Lino.courses.AllEnrolments.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Show global list of all enrolments.") }, "text": "Einschreibungen" }, { "handler": function() {Lino.courses.EnrolmentStates.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The list of possible states of an enrolment.") }, "text": "Einschreibungs-Zust\u00e4nde" } ] }, "text": "Aktivit\u00e4ten" }, { "menu": { "items": [ { "handler": function() {Lino.finan.AllBankStatements.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The base table of all tables on BankStatement.") }, "text": "Kontoausz\u00fcge" }, { "handler": function() {Lino.finan.AllJournalEntries.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base class for the default tables of all other financial voucher\ntypes (JournalEntries , PaymentOrders and\nBankStatements).") }, "text": "Diverse Buchungen" }, { "handler": function() {Lino.finan.AllPaymentOrders.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The base table of all tables on PaymentOrder.") }, "text": "Zahlungsauftr\u00e4ge" } ] }, "text": "Finanzjournale" }, { "menu": { "items": [ { "handler": function() {Lino.sepa.Accounts.grid.run(null)}, "text": "Bankkonten" } ] }, "text": "SEPA" }, { "menu": { "items": [ { "handler": function() {Lino.notes.AllNotes.grid.run(null)}, "text": "Notizen" }, { "handler": function() {Lino.uploads.AllUploads.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all Uploads") }, "text": "Uploads" }, { "handler": function() {Lino.uploads.UploadAreas.grid.run(null)}, "text": "Upload-Bereiche" }, { "handler": function() {Lino.outbox.Mails.grid.run(null)}, "text": "E-Mail-Ausg\u00e4nge" }, { "handler": function() {Lino.outbox.Attachments.grid.run(null)}, "text": "Anh\u00e4nge" }, { "handler": function() {Lino.excerpts.AllExcerpts.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base class for all tables on Excerpt.") }, "text": "Ausz\u00fcge" } ] }, "text": "B\u00fcro" } ] }, "text": "Explorer" }, { "menu": { "items": [ { "handler": function() {Lino.about.About.show.run(null,{ "record_id": -99998 })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Zeigt Informationen \u00fcber diese Site an.") }, "text": "Info" }, { "handler": function() {Lino.ipdict.Connections.grid.run(null)}, "text": "Connections" } ] }, "text": "Site" }, { "handler": function() {Lino.handle_home_button()}, "text": "Startseite" } ];
Ext.namespace('Lino.system.SiteConfigs')
Ext.namespace('Lino.countries.Countries')
Ext.namespace('Lino.countries.Places')
Ext.namespace('Lino.contacts.Partners')
Ext.namespace('Lino.contacts.Persons')
Ext.namespace('Lino.contacts.CompanyTypes')
Ext.namespace('Lino.contacts.Companies')
Ext.namespace('Lino.contacts.RoleTypes')
Ext.namespace('Lino.contacts.Roles')
Ext.namespace('Lino.ledger.Journals')
Ext.namespace('Lino.ledger.AccountingPeriods')
Ext.namespace('Lino.ledger.PaymentTerms')
Ext.namespace('Lino.ledger.Vouchers')
Ext.namespace('Lino.ledger.AllVouchers')
Ext.namespace('Lino.ledger.MatchRules')
Ext.namespace('Lino.ledger.PartnerVouchers')
Ext.namespace('Lino.ledger.GeneralAccountsBalance')
Ext.namespace('Lino.ledger.PartnerAccountsBalance')
Ext.namespace('Lino.ledger.CustomerAccountsBalance')
Ext.namespace('Lino.ledger.SupplierAccountsBalance')
Ext.namespace('Lino.ledger.Movements')
Ext.namespace('Lino.ledger.AllMovements')
Ext.namespace('Lino.lists.ListTypes')
Ext.namespace('Lino.lists.Lists')
Ext.namespace('Lino.lists.Members')
Ext.namespace('Lino.lists.AllMembers')
Ext.namespace('Lino.gfks.ContentTypes')
Ext.namespace('Lino.gfks.HelpTexts')
Ext.namespace('Lino.plausibility.Problems')
Ext.namespace('Lino.plausibility.AllProblems')
Ext.namespace('Lino.plausibility.MyProblems')
Ext.namespace('Lino.cal.RemoteCalendars')
Ext.namespace('Lino.cal.AllRooms')
Ext.namespace('Lino.cal.Priorities')
Ext.namespace('Lino.cal.Calendars')
Ext.namespace('Lino.cal.Subscriptions')
Ext.namespace('Lino.cal.Tasks')
Ext.namespace('Lino.cal.MyTasks')
Ext.namespace('Lino.cal.GuestRoles')
Ext.namespace('Lino.cal.Guests')
Ext.namespace('Lino.cal.AllGuests')
Ext.namespace('Lino.cal.MyPresences')
Ext.namespace('Lino.cal.MyPendingPresences')
Ext.namespace('Lino.cal.MyGuests')
Ext.namespace('Lino.cal.EventTypes')
Ext.namespace('Lino.cal.RecurrentEvents')
Ext.namespace('Lino.cal.Events')
Ext.namespace('Lino.cal.AllEntries')
Ext.namespace('Lino.cal.PublicEntries')
Ext.namespace('Lino.cal.EntriesByDay')
Ext.namespace('Lino.cal.OneEvent')
Ext.namespace('Lino.cal.MyEntriesToday')
Ext.namespace('Lino.cal.MyAssignedEvents')
Ext.namespace('Lino.cal.OverdueAppointments')
Ext.namespace('Lino.cal.MyOverdueAppointments')
Ext.namespace('Lino.cal.MyUnconfirmedAppointments')
Ext.namespace('Lino.cal.EventPolicies')
Ext.namespace('Lino.cal.Rooms')
Ext.namespace('Lino.cal.MyEntries')
Ext.namespace('Lino.products.ProductCats')
Ext.namespace('Lino.products.Products')
Ext.namespace('Lino.rooms.Bookings')
Ext.namespace('Lino.accounts.Groups')
Ext.namespace('Lino.accounts.Accounts')
Ext.namespace('Lino.sales.PaperTypes')
Ext.namespace('Lino.sales.SalesDocuments')
Ext.namespace('Lino.sales.Invoices')
Ext.namespace('Lino.sales.DueInvoices')
Ext.namespace('Lino.sales.InvoiceItems')
Ext.namespace('Lino.sales.DocumentsToSign')
Ext.namespace('Lino.invoicing.Plans')
Ext.namespace('Lino.invoicing.MyPlans')
Ext.namespace('Lino.invoicing.AllPlans')
Ext.namespace('Lino.invoicing.Items')
Ext.namespace('Lino.finan.FinancialVouchers')
Ext.namespace('Lino.finan.JournalEntries')
Ext.namespace('Lino.finan.PaymentOrders')
Ext.namespace('Lino.finan.BankStatements')
Ext.namespace('Lino.finan.AllBankStatements')
Ext.namespace('Lino.finan.AllJournalEntries')
Ext.namespace('Lino.finan.AllPaymentOrders')
Ext.namespace('Lino.sepa.Accounts')
Ext.namespace('Lino.notify.Messages')
Ext.namespace('Lino.notify.AllMessages')
Ext.namespace('Lino.notify.MyMessages')
Ext.namespace('Lino.notes.NoteTypes')
Ext.namespace('Lino.notes.EventTypes')
Ext.namespace('Lino.notes.Notes')
Ext.namespace('Lino.notes.AllNotes')
Ext.namespace('Lino.notes.MyNotes')
Ext.namespace('Lino.uploads.UploadTypes')
Ext.namespace('Lino.uploads.Uploads')
Ext.namespace('Lino.uploads.AllUploads')
Ext.namespace('Lino.uploads.MyUploads')
Ext.namespace('Lino.uploads.AreaUploads')
Ext.namespace('Lino.outbox.Recipients')
Ext.namespace('Lino.outbox.Mails')
Ext.namespace('Lino.outbox.Attachments')
Ext.namespace('Lino.excerpts.ExcerptTypes')
Ext.namespace('Lino.excerpts.Excerpts')
Ext.namespace('Lino.excerpts.AllExcerpts')
Ext.namespace('Lino.excerpts.MyExcerpts')
Ext.namespace('Lino.extensible.PanelCalendars')
Ext.namespace('Lino.extensible.PanelEvents')
Ext.namespace('Lino.changes.Changes')
Ext.namespace('Lino.users.Users')
Ext.namespace('Lino.users.AllUsers')
Ext.namespace('Lino.users.UsersOverview')
Ext.namespace('Lino.users.MySettings')
Ext.namespace('Lino.users.Authorities')
Ext.namespace('Lino.vat.VatRules')
Ext.namespace('Lino.vat.Invoices')
Ext.namespace('Lino.vat.IntracomInvoices')
Ext.namespace('Lino.vat.IntracomSales')
Ext.namespace('Lino.vat.IntracomPurchases')
Ext.namespace('Lino.courses.Slots')
Ext.namespace('Lino.courses.Topics')
Ext.namespace('Lino.courses.Lines')
Ext.namespace('Lino.courses.Activities')
Ext.namespace('Lino.courses.Courses')
Ext.namespace('Lino.courses.AllActivities')
Ext.namespace('Lino.courses.MyActivities')
Ext.namespace('Lino.courses.DraftCourses')
Ext.namespace('Lino.courses.ActiveCourses')
Ext.namespace('Lino.courses.InactiveCourses')
Ext.namespace('Lino.courses.ClosedCourses')
Ext.namespace('Lino.courses.Enrolments')
Ext.namespace('Lino.courses.AllEnrolments')
Ext.namespace('Lino.courses.PendingConfirmedEnrolments')
Ext.namespace('Lino.courses.TeacherTypes')
Ext.namespace('Lino.courses.PupilTypes')
Ext.namespace('Lino.courses.CourseTypes')
Ext.namespace('Lino.courses.PendingRequestedEnrolments')
Ext.namespace('Lino.courses.Teachers')
Ext.namespace('Lino.courses.Pupils')
Ext.namespace('Lino.courses.Hikes')
Ext.namespace('Lino.courses.Journeys')
Ext.namespace('Lino.vat.InvoiceItemTable')
Ext.namespace('Lino.finan.JournalEntryItemTable')
Ext.namespace('Lino.finan.BankStatementItemTable')
Ext.namespace('Lino.finan.PaymentOrderItemTable')
Ext.namespace('Lino.sessions.SessionTable')
Ext.namespace('Lino.countries.PlacesByPlace')
Ext.namespace('Lino.countries.PlacesByCountry')
Ext.namespace('Lino.contacts.PartnersByCity')
Ext.namespace('Lino.contacts.PartnersByCountry')
Ext.namespace('Lino.contacts.RolesByCompany')
Ext.namespace('Lino.contacts.RolesByPerson')
Ext.namespace('Lino.ledger.MatchRulesByAccount')
Ext.namespace('Lino.ledger.MatchRulesByJournal')
Ext.namespace('Lino.ledger.MovementsByVoucher')
Ext.namespace('Lino.ledger.MovementsByPartner')
Ext.namespace('Lino.ledger.MovementsByAccount')
Ext.namespace('Lino.ledger.MovementsByMatch')
Ext.namespace('Lino.lists.MembersByList')
Ext.namespace('Lino.lists.MembersByPartner')
Ext.namespace('Lino.plausibility.ProblemsByChecker')
Ext.namespace('Lino.cal.SubscriptionsByUser')
Ext.namespace('Lino.cal.SubscriptionsByCalendar')
Ext.namespace('Lino.cal.TasksByUser')
Ext.namespace('Lino.cal.GuestsByEvent')
Ext.namespace('Lino.cal.GuestsByRole')
Ext.namespace('Lino.cal.GuestsByPartner')
Ext.namespace('Lino.cal.EntriesByType')
Ext.namespace('Lino.cal.ConflictingEvents')
Ext.namespace('Lino.cal.EntriesByRoom')
Ext.namespace('Lino.products.ProductsByCategory')
Ext.namespace('Lino.rooms.BookingsByCompany')
Ext.namespace('Lino.accounts.AccountsByGroup')
Ext.namespace('Lino.sales.PartnersByInvoiceRecipient')
Ext.namespace('Lino.sales.InvoicesByJournal')
Ext.namespace('Lino.sales.PrintableInvoicesByJournal')
Ext.namespace('Lino.sales.ItemsByInvoice')
Ext.namespace('Lino.sales.ItemsByInvoicePrint')
Ext.namespace('Lino.sales.ItemsByInvoicePrintNoQtyColumn')
Ext.namespace('Lino.sales.InvoiceItemsByProduct')
Ext.namespace('Lino.sales.InvoicesByPartner')
Ext.namespace('Lino.invoicing.ItemsByPlan')
Ext.namespace('Lino.finan.PaymentOrdersByJournal')
Ext.namespace('Lino.finan.JournalEntriesByJournal')
Ext.namespace('Lino.finan.BankStatementsByJournal')
Ext.namespace('Lino.finan.ItemsByJournalEntry')
Ext.namespace('Lino.finan.ItemsByBankStatement')
Ext.namespace('Lino.finan.ItemsByPaymentOrder')
Ext.namespace('Lino.sepa.AccountsByPartner')
Ext.namespace('Lino.notes.NotesByType')
Ext.namespace('Lino.notes.NotesByEventType')
Ext.namespace('Lino.notes.NotesByCompany')
Ext.namespace('Lino.notes.NotesByPerson')
Ext.namespace('Lino.uploads.UploadsByType')
Ext.namespace('Lino.outbox.RecipientsByMail')
Ext.namespace('Lino.outbox.MyOutbox')
Ext.namespace('Lino.outbox.MailsByUser')
Ext.namespace('Lino.outbox.SentByPartner')
Ext.namespace('Lino.outbox.AttachmentsByMail')
Ext.namespace('Lino.excerpts.ExcerptsByType')
Ext.namespace('Lino.users.AuthoritiesGiven')
Ext.namespace('Lino.users.AuthoritiesTaken')
Ext.namespace('Lino.vat.InvoicesByJournal')
Ext.namespace('Lino.vat.PrintableInvoicesByJournal')
Ext.namespace('Lino.vat.ItemsByInvoice')
Ext.namespace('Lino.courses.LinesByTopic')
Ext.namespace('Lino.courses.EntriesByTeacher')
Ext.namespace('Lino.courses.CoursesByTeacher')
Ext.namespace('Lino.courses.MyCoursesGiven')
Ext.namespace('Lino.courses.CoursesBySlot')
Ext.namespace('Lino.courses.EnrolmentsByOption')
Ext.namespace('Lino.courses.EnrolmentsByPupil')
Ext.namespace('Lino.courses.EnrolmentsByCourse')
Ext.namespace('Lino.courses.EnrolmentsByFee')
Ext.namespace('Lino.courses.TeachersByType')
Ext.namespace('Lino.courses.PupilsByType')
Ext.namespace('Lino.courses.CoursesByTopic')
Ext.namespace('Lino.courses.CoursesByLine')
Ext.namespace('Lino.courses.LinesByType')
Ext.namespace('Lino.courses.EnrolmentsAndPaymentsByCourse')
Ext.namespace('Lino.courses.EnrolmentsByHike')
Ext.namespace('Lino.courses.EnrolmentsByJourney')
Ext.namespace('Lino.uploads.UploadsByController')
Ext.namespace('Lino.changes.ChangesByObject')
Ext.namespace('Lino.invoicing.InvoicingsByInvoiceable')
Ext.namespace('Lino.notes.NotesByOwner')
Ext.namespace('Lino.cal.TasksByController')
Ext.namespace('Lino.gfks.HelpTextsByModel')
Ext.namespace('Lino.outbox.MailsByController')
Ext.namespace('Lino.plausibility.ProblemsByOwner')
Ext.namespace('Lino.changes.ChangesByMaster')
Ext.namespace('Lino.cal.EntriesByController')
Ext.namespace('Lino.outbox.AttachmentsByController')
Ext.namespace('Lino.courses.EntriesByCourse')
Ext.namespace('Lino.excerpts.ExcerptsByOwner')
Ext.namespace('Lino.about.Models')
Ext.namespace('Lino.about.FieldsByModel')
Ext.namespace('Lino.about.Inspector')
Ext.namespace('Lino.about.SourceFiles')
Ext.namespace('Lino.ipdict.Connections')
Ext.namespace('Lino.ledger.VouchersByPartnerBase')
Ext.namespace('Lino.ledger.ExpectedMovements')
Ext.namespace('Lino.ledger.DebtsByAccount')
Ext.namespace('Lino.ledger.DebtsByPartner')
Ext.namespace('Lino.ledger.Debtors')
Ext.namespace('Lino.ledger.Creditors')
Ext.namespace('Lino.gfks.BrokenGFKs')
Ext.namespace('Lino.gfks.BrokenGFKsByModel')
Ext.namespace('Lino.finan.SuggestionsByVoucher')
Ext.namespace('Lino.finan.SuggestionsByJournalEntry')
Ext.namespace('Lino.finan.SuggestionsByPaymentOrder')
Ext.namespace('Lino.finan.SuggestionsByBankStatement')
Ext.namespace('Lino.finan.SuggestionsByVoucherItem')
Ext.namespace('Lino.finan.SuggestionsByBankStatementItem')
Ext.namespace('Lino.finan.SuggestionsByPaymentOrderItem')
Ext.namespace('Lino.vat.VouchersByPartner')
Ext.namespace('Lino.about.About')
Ext.namespace('Lino.ledger.Situation')
Ext.namespace('Lino.ledger.ActivityReport')
Ext.namespace('Lino.ledger.AccountingReport')
Ext.namespace('Lino.extensible.CalendarPanel')
Ext.namespace('Lino.courses.StatusReport')
Ext.namespace('Lino.plausibility.Checkers')
Ext.namespace('Lino.notes.SpecialTypes')
Ext.namespace('Lino.notify.MailModes')
Ext.namespace('Lino.vat.VatClasses')
Ext.namespace('Lino.beid.CivilStates')
Ext.namespace('Lino.ledger.TradeTypes')
Ext.namespace('Lino.changes.ChangeTypes')
Ext.namespace('Lino.cal.DurationUnits')
Ext.namespace('Lino.courses.Sections')
Ext.namespace('Lino.system.YesNo')
Ext.namespace('Lino.cal.Weekdays')
Ext.namespace('Lino.rooms.BookingStates')
Ext.namespace('Lino.accounts.AccountTypes')
Ext.namespace('Lino.beid.BeIdCardTypes')
Ext.namespace('Lino.excerpts.Shortcuts')
Ext.namespace('Lino.system.PeriodEvents')
Ext.namespace('Lino.notify.MessageTypes')
Ext.namespace('Lino.beid.ResidenceTypes')
Ext.namespace('Lino.ledger.FiscalYears')
Ext.namespace('Lino.vat.DeclarationFieldsBase')
Ext.namespace('Lino.ledger.JournalGroups')
Ext.namespace('Lino.system.Genders')
Ext.namespace('Lino.uploads.Shortcuts')
Ext.namespace('Lino.cal.Recurrencies')
Ext.namespace('Lino.cal.EntryStates')
Ext.namespace('Lino.ledger.PeriodStates')
Ext.namespace('Lino.cal.EventEvents')
Ext.namespace('Lino.cal.GuestStates')
Ext.namespace('Lino.products.DeliveryUnit')
Ext.namespace('Lino.vat.VatRegimes')
Ext.namespace('Lino.courses.EnrolmentStates')
Ext.namespace('Lino.ledger.VoucherTypes')
Ext.namespace('Lino.printing.BuildMethods')
Ext.namespace('Lino.cal.AccessClasses')
Ext.namespace('Lino.uploads.UploadAreas')
Ext.namespace('Lino.outbox.RecipientTypes')
Ext.namespace('Lino.ledger.VoucherStates')
Ext.namespace('Lino.cal.TaskStates')
Ext.namespace('Lino.courses.CourseAreas')
Ext.namespace('Lino.users.UserTypes')
Ext.namespace('Lino.vat.VatColumns')
Ext.namespace('Lino.contacts.PartnerEvents')
Ext.namespace('Lino.courses.CourseStates')
Ext.namespace('Lino.countries.PlaceTypes')

// ChoiceLists: 
Lino.plausibility.Checkers = [ [ "printing.CachedPrintableChecker", "Check for missing target files" ], [ "countries.PlaceChecker", "Check plausibility of geographical places." ], [ "ledger.VoucherChecker", "Check integrity of ledger movements" ], [ "sepa.BankAccountChecker", "Check for partner mismatches in bank accounts" ], [ "beid.BeIdCardHolderChecker", "Check for invalid SSINs" ], [ "cal.EventGuestChecker", "Termine ohne Teilnehmer" ], [ "cal.ConflictingEventsChecker", "Auf Termin\u00fcberschneidungen pr\u00fcfen" ], [ "cal.ObsoleteEventTypeChecker", "Obsolete event type of generated entries" ], [ "cal.LongEntryChecker", "Dauer \u00fcberschreitende Kalendereintr\u00e4ge" ], [ "courses.MemberChecker", "Mitgliedsbeitragszahlungen pr\u00fcfen" ] ];
Lino.notes.SpecialTypes = [  ];
Lino.notify.MailModes = [ [ "never", "Nie" ], [ "often", "H\u00e4ufig" ], [ "daily", "T\u00e4glich" ], [ "weekly", "W\u00f6chentlich" ] ];
Lino.vat.VatClasses = [ [ "0", "Befreit von MwSt." ], [ "1", "Erm\u00e4\u00dfigter MwSt.-Satz" ], [ "2", "Normaler MwSt-Satz" ] ];
Lino.beid.CivilStates = [ [ "10", "Ledig" ], [ "20", "Verheiratet" ], [ "30", "Verwitwet" ], [ "40", "Geschieden" ], [ "50", "Getrennt von Tisch und Bett" ], [ "51", "Faktisch getrennt" ], [ "60", "Zusammenwohnend" ] ];
Lino.ledger.TradeTypes = [ [ "S", "Verkauf" ], [ "P", "Einkauf" ], [ "W", "L\u00f6hne und Geh\u00e4lter" ], [ "T", "Taxes" ], [ "C", "Begleichungen" ] ];
Lino.changes.ChangeTypes = [ [ "C", "Erstellen" ], [ "U", "Aktualisierung" ], [ "D", "L\u00f6schen" ], [ "R", "Remove child" ], [ "A", "Add child" ], [ "M", "Fusionieren" ] ];
Lino.cal.DurationUnits = [ [ "s", "Sekunden" ], [ "m", "Minuten" ], [ "h", "Stunden" ], [ "D", "Tage" ], [ "W", "Wochen" ], [ "M", "Monate" ], [ "Y", "Jahre" ] ];
Lino.courses.Sections = [ [ "eupen", "Eupen" ], [ "nidrum", "Nidrum" ], [ "walhorn", "Walhorn" ], [ "herresbach", "Herresbach" ], [ "eynatten", "Eynatten" ], [ "kelmis", "Kelmis" ], [ "hergenrath", "Hergenrath" ], [ "hauset", "Hauset" ], [ "elsenborn", "Elsenborn" ], [ "weywertz", "Weywertz" ], [ "etc", "Sonstige" ] ];
Lino.system.YesNo = [ [ "y", "Ja" ], [ "n", "Nein" ] ];
Lino.cal.Weekdays = [ [ "1", "Montag" ], [ "2", "Dienstag" ], [ "3", "Mittwoch" ], [ "4", "Donnerstag" ], [ "5", "Freitag" ], [ "6", "Samstag" ], [ "7", "Sonntag" ] ];
Lino.rooms.BookingStates = [ [ "10", "Entwurf" ], [ "20", "Option" ], [ "30", "Registriert" ], [ "40", "Storniert" ] ];
Lino.accounts.AccountTypes = [ [ "A", "Verm\u00f6gen" ], [ "L", "Verpflichtungen" ], [ "I", "Eink\u00fcnfte" ], [ "E", "Ausgaben" ], [ "C", "Kapital" ], [ "B", "Bankkonten" ] ];
Lino.beid.BeIdCardTypes = [ [ "1", "Belgischer Staatsb\u00fcrger" ], [ "6", "Kind unter 12 Jahren" ], [ "11", "A (Bescheinigung der Eintragung im Ausl\u00e4nderregister - Vor\u00fcbergehender Aufenthalt)" ], [ "12", "B (Bescheinigung der Eintragung im Ausl\u00e4nderregister)" ], [ "13", "C (Personalausweis f\u00fcr Ausl\u00e4nder)" ], [ "14", "D (Daueraufenthalt - EG)" ], [ "15", "E (Anmeldebescheinigung)" ], [ "16", "E+" ], [ "17", "F (Aufenthaltskarte f\u00fcr Familienangeh\u00f6rige eines Unionsb\u00fcrgers)" ], [ "18", "F+" ], [ "99", "Eintragungsbescheinigung (Orange Karte)" ] ];
Lino.excerpts.Shortcuts = [  ];
Lino.system.PeriodEvents = [ [ "10", "Beginnt" ], [ "20", "Ist aktiv" ], [ "30", "Ended" ] ];
Lino.notify.MessageTypes = [ [ "100", "Systemereignis" ], [ "200", "\u00c4nderung" ], [ "300", "Action" ] ];
Lino.beid.ResidenceTypes = [ [ "1", "Bev\u00f6lkerungsregister" ], [ "2", "Fremdenregister" ], [ "3", "Warteregister" ] ];
Lino.ledger.FiscalYears = [ [ "14", "2014" ], [ "15", "2015" ], [ "16", "2016" ], [ "17", "2017" ], [ "18", "2018" ], [ "19", "2019" ], [ "20", "2020" ] ];
Lino.vat.DeclarationFieldsBase = [  ];
Lino.ledger.JournalGroups = [ [ "10", "Verkauf" ], [ "20", "Einkauf" ], [ "30", "L\u00f6hne und Geh\u00e4lter" ], [ "40", "Finanzjournale" ], [ "50", "MwSt." ] ];
Lino.system.Genders = [ [ "M", "M\u00e4nnlich" ], [ "F", "Weiblich" ] ];
Lino.uploads.Shortcuts = [  ];
Lino.cal.Recurrencies = [ [ "O", "einmalig" ], [ "D", "t\u00e4glich" ], [ "W", "w\u00f6chentlich" ], [ "M", "monatlich" ], [ "Y", "j\u00e4hrlich" ], [ "P", "pro Wochentag" ], [ "E", "Beweglich mit Ostern" ] ];
Lino.cal.EntryStates = [ [ "10", "Vorschlag" ], [ "20", "Entwurf" ], [ "50", "Stattgefunden" ], [ "70", "Storniert" ] ];
Lino.ledger.PeriodStates = [ [ "10", "In Bearbeitung" ], [ "20", "Abgeschlossen" ] ];
Lino.cal.EventEvents = [ [ "10", "Stabil" ], [ "20", "Unstabil" ] ];
Lino.cal.GuestStates = [ [ "10", "Eingeladen" ], [ "40", "Anwesend" ], [ "50", "Abwesend" ], [ "60", "Entschuldigt" ] ];
Lino.products.DeliveryUnit = [ [ "10", "Stunde" ], [ "20", "Piece" ], [ "30", "Kg" ] ];
Lino.vat.VatRegimes = [ [ "10", "Privatperson" ], [ "20", "MwSt.-pflichtig" ], [ "30", "Innergemeinschaftlich" ] ];
Lino.courses.EnrolmentStates = [ [ "10", "Angefragt" ], [ "11", "Test" ], [ "20", "Best\u00e4tigt" ], [ "30", "Storniert" ] ];
Lino.ledger.VoucherTypes = [ [ "sales.InvoicesByJournal", "Produktrechnung (sales.InvoicesByJournal)" ], [ "finan.JournalEntriesByJournal", "Diverse Buchung (finan.JournalEntriesByJournal)" ], [ "finan.PaymentOrdersByJournal", "Zahlungsauftrag (finan.PaymentOrdersByJournal)" ], [ "finan.BankStatementsByJournal", "Kontoauszug (finan.BankStatementsByJournal)" ], [ "vat.InvoicesByJournal", "Rechnung (vat.InvoicesByJournal)" ] ];
Lino.printing.BuildMethods = [ [ "latex", "LatexBuildMethod" ], [ "pisa", "PisaBuildMethod" ], [ "rtf", "RtfBuildMethod" ], [ "xml", "XmlBuildMethod" ], [ "weasy2html", "WeasyHtmlBuildMethod" ], [ "weasy2pdf", "WeasyPdfBuildMethod" ], [ "wkhtmltopdf", "WkBuildMethod" ], [ "appyodt", "AppyOdtBuildMethod" ], [ "appydoc", "AppyDocBuildMethod" ], [ "appypdf", "AppyPdfBuildMethod" ], [ "appyrtf", "AppyRtfBuildMethod" ] ];
Lino.cal.AccessClasses = [ [ "10", "Privat" ], [ "20", "halb \u00f6ffentlich (\"Besch\u00e4ftigt\")" ], [ "30", "\u00d6ffentlich" ] ];
Lino.uploads.UploadAreas = [ [ "90", "Uploads" ] ];
Lino.outbox.RecipientTypes = [ [ "to", "Empf\u00e4nger" ], [ "cc", "Kopie an" ], [ "bcc", "Blindkopie an" ] ];
Lino.ledger.VoucherStates = [ [ "10", "Entwurf" ], [ "20", "Registriert" ], [ "30", "Unterschrieben" ], [ "40", "Storniert" ] ];
Lino.cal.TaskStates = [ [ "10", "Zu tun" ], [ "15", "Wichtig" ], [ "20", "Begonnen" ], [ "30", "Erledigt" ], [ "50", "Storniert" ] ];
Lino.courses.CourseAreas = [ [ "C", "Kurse" ], [ "H", "Ausfahrten" ], [ "J", "Reisen" ] ];
Lino.users.UserTypes = [ [ "000", "000 (Anonym)" ], [ "100", "100 (Benutzer)" ], [ "200", "200 (Secretary)" ], [ "300", "300 (Teacher)" ], [ "900", "900 (Verwalter)" ] ];
Lino.vat.VatColumns = [  ];
Lino.contacts.PartnerEvents = [ [ "has_open_movements", "Has open movements" ] ];
Lino.courses.CourseStates = [ [ "10", "Entwurf" ], [ "20", "Gestartet" ], [ "30", "Inaktiv" ], [ "40", "Abgeschlossen" ] ];
Lino.countries.PlaceTypes = [ [ "10", "Bundesland" ], [ "11", "Division" ], [ "12", "Region" ], [ "13", "Gemeinschaft" ], [ "14", "Territorium" ], [ "20", "Regierungsbezirk" ], [ "21", "Provinz" ], [ "22", "Grafschaft" ], [ "23", "Unterregion" ], [ "24", "Departement" ], [ "25", "Arrondissement" ], [ "26", "Pr\u00e4fektur" ], [ "27", "Distrikt" ], [ "28", "Sektor" ], [ "50", "Stadt" ], [ "51", "Kleinstadt" ], [ "52", "Gemeinde" ], [ "54", "Pfarre" ], [ "55", "Stadtteil" ], [ "56", "Viertel" ], [ "61", "Ortschaft" ], [ "62", "Kleine Ortschaft" ], [ "70", "Dorf" ] ];

Lino.finan.FinancialVouchers.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var pjournal1 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "Journal", "hiddenName": "pjournalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(finan.FinancialVouchers.pjournal) ") }, "name": "pjournal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/pjournal" }) }) });
    var pyear2 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Gesch\u00e4ftsjahr", "forceSelection": true, "hiddenName": "pyearHidden", "listeners": { "render": Lino.quicktip_renderer("Fiscal Year","(finan.FinancialVouchers.pyear) ") }, "name": "pyear", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.FiscalYears) });
    this.items = [ { "autoHeight": true, "flex": 74, "items": pjournal1, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": pyear2, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ pjournal1, pyear2 ];
    Lino.finan.FinancialVouchers.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.users.Authorities.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 63,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var user6 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Autor</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(users.Authorities.user) The user who gives the right of representation. author of this\nauthority") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/Authorities/user" }) }), "value": null });
    this.items = [ { "autoHeight": true, "items": user6, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user6 ];
    Lino.users.Authorities.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Activities.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  autoHeight: true,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var topic9 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Thema ausw\u00e4hlen...", "fieldLabel": "Thema", "hiddenName": "topicHidden", "listeners": { "render": Lino.quicktip_renderer("Topic","(courses.Activities.topic) ") }, "name": "topic", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Topics.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/topic" }) }) });
    var line10 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "fieldLabel": "Aktivit\u00e4tenreihe", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Activity line","(courses.Activities.line) ") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/line" }) }) });
    var user11 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.Activities.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/user" }) }), "value": null });
    var teacher12 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kursleiter ausw\u00e4hlen...", "fieldLabel": "Kursleiter", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor","(courses.Activities.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/teacher" }) }) });
    var state13 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zustand", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(courses.Activities.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.CourseStates) });
    var main_1_panel14 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 21, "items": topic9, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": line10, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": user11, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": teacher12, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": state13, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room20 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Raum ausw\u00e4hlen...", "fieldLabel": "Raum", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(courses.Activities.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/room" }) }), "value": null });
    var can_enroll21 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "can enroll", "forceSelection": true, "hiddenName": "can_enrollHidden", "listeners": { "render": Lino.quicktip_renderer("can enroll","(courses.Activities.can_enroll) ") }, "name": "can_enroll", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var start_date22 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum von</span>", "listeners": { "render": Lino.quicktip_renderer("Date from","(courses.Activities.start_date) Start of observed date range") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date23 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(courses.Activities.end_date) End of observed date range") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var show_active24 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Aktiv</span>", "forceSelection": true, "hiddenName": "show_activeHidden", "listeners": { "render": Lino.quicktip_renderer("Active","(courses.Activities.show_active) Whether to show rows in some active state") }, "name": "show_active", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var main_2_panel25 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 28, "items": room20, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": can_enroll21, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": start_date22, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": end_date23, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": show_active24, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel14, main_2_panel25 ];
    this.fields = [ topic9, line10, user11, teacher12, state13, room20, can_enroll21, start_date22, end_date23, show_active24 ];
    Lino.courses.Activities.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.users.Users.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 90,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var user_type32 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Benutzerart", "forceSelection": true, "hiddenName": "user_typeHidden", "listeners": { "render": Lino.quicktip_renderer("User type","(users.Users.user_type) ") }, "name": "user_type", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.users.UserTypes) });
    this.items = [ { "autoHeight": true, "items": user_type32, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user_type32 ];
    Lino.users.Users.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.PartnerVouchers.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 198,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var partner35 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(ledger.PartnerVouchers.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerVouchers/partner" }) }) });
    var state36 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zustand", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(ledger.PartnerVouchers.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates) });
    var journal37 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "Journal", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(ledger.PartnerVouchers.journal) ") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerVouchers/journal" }) }) });
    var start_period38 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(ledger.PartnerVouchers.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerVouchers/start_period" }) }) });
    var end_period39 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period until</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period until","(ledger.PartnerVouchers.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerVouchers/end_period" }) }) });
    var cleared40 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beglichene Bewegungen zeigen", "forceSelection": true, "hiddenName": "clearedHidden", "listeners": { "render": Lino.quicktip_renderer("Show cleared vouchers","(ledger.PartnerVouchers.cleared) ") }, "name": "cleared", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 18, "items": partner35, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": state36, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": journal37, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": start_period38, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": end_period39, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": cleared40, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ partner35, state36, journal37, start_period38, end_period39, cleared40 ];
    Lino.ledger.PartnerVouchers.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.CoursesByTopic.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 126,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var line48 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "fieldLabel": "Aktivit\u00e4tenreihe", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Activity line","(courses.CoursesByTopic.line) ") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/line" }) }) });
    var teacher49 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kursleiter ausw\u00e4hlen...", "fieldLabel": "Kursleiter", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor","(courses.CoursesByTopic.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/teacher" }) }) });
    var user50 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.CoursesByTopic.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/user" }) }), "value": null });
    var state51 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zustand", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(courses.CoursesByTopic.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.CourseStates) });
    var can_enroll52 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "can enroll", "forceSelection": true, "hiddenName": "can_enrollHidden", "listeners": { "render": Lino.quicktip_renderer("can enroll","(courses.CoursesByTopic.can_enroll) ") }, "name": "can_enroll", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 24, "items": line48, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": teacher49, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": user50, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": state51, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": can_enroll52, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ line48, teacher49, user50, state51, can_enroll52 ];
    Lino.courses.CoursesByTopic.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Vouchers.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 117,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var journal59 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "Journal", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(ledger.Vouchers.journal) ") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Vouchers/journal" }) }) });
    var start_period60 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(ledger.Vouchers.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Vouchers/start_period" }) }) });
    var end_period61 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period until</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period until","(ledger.Vouchers.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Vouchers/end_period" }) }) });
    var state62 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(ledger.Vouchers.state) The workflow state of this voucher. Choices are defined in\nVoucherStates") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates), "value": null });
    var user63 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(ledger.Vouchers.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Vouchers/user" }) }), "value": null });
    this.items = [ { "autoHeight": true, "flex": 21, "items": journal59, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": start_period60, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": end_period61, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": state62, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": user63, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ journal59, start_period60, end_period61, state62, user63 ];
    Lino.ledger.Vouchers.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Partners.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 135,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var partner_list70 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partnerliste ausw\u00e4hlen...", "fieldLabel": "Partnerliste", "hiddenName": "partner_listHidden", "listeners": { "render": Lino.quicktip_renderer("Partner List","(contacts.Partners.partner_list) ") }, "name": "partner_list", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.lists.Lists.detail,Lino.lists.Lists.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/partner_list" }) }) });
    var end_date71 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(contacts.Partners.end_date) End of observed date range") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var show_raviva72 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Raviva", "forceSelection": true, "hiddenName": "show_ravivaHidden", "listeners": { "render": Lino.quicktip_renderer("Raviva","(contacts.Partners.show_raviva) ") }, "name": "show_raviva", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var course73 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Activity ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Activity</span>", "hiddenName": "courseHidden", "listeners": { "render": Lino.quicktip_renderer("Activity","(contacts.Partners.course) Show only pupils who participate in the given course.") }, "name": "course", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Activities.detail,Lino.courses.Activities.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/course" }) }) });
    var gender74 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Geschlecht</span>", "forceSelection": true, "hiddenName": "genderHidden", "listeners": { "render": Lino.quicktip_renderer("Gender","(contacts.Partners.gender) The sex of this person (male or female).") }, "name": "gender", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders), "value": null });
    var observed_event75 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Beobachtungskriterium</span>", "forceSelection": true, "hiddenName": "observed_eventHidden", "listeners": { "render": Lino.quicktip_renderer("Observed event","(contacts.Partners.observed_event) Extended filter criteria") }, "name": "observed_event", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.contacts.PartnerEvents) });
    var aged_from76 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Alter von</span>", "listeners": { "render": Lino.quicktip_renderer("Aged from","(contacts.Partners.aged_from) Select only persons aged at least the given number of years.") }, "name": "aged_from", "selectOnFocus": true });
    var enrolment_state77 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zustand", "forceSelection": true, "hiddenName": "enrolment_stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(contacts.Partners.enrolment_state) ") }, "name": "enrolment_state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.EnrolmentStates) });
    var show_members78 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Mitglieder</span>", "forceSelection": true, "hiddenName": "show_membersHidden", "listeners": { "render": Lino.quicktip_renderer("Members","(contacts.Partners.show_members) Show those whose 'Member until' is after today.") }, "name": "show_members", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var show_lfv79 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "LFV", "forceSelection": true, "hiddenName": "show_lfvHidden", "listeners": { "render": Lino.quicktip_renderer("LFV","(contacts.Partners.show_lfv) ") }, "name": "show_lfv", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var show_ckk80 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "CKK", "forceSelection": true, "hiddenName": "show_ckkHidden", "listeners": { "render": Lino.quicktip_renderer("CKK","(contacts.Partners.show_ckk) ") }, "name": "show_ckk", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var start_date81 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum von</span>", "listeners": { "render": Lino.quicktip_renderer("Date from","(contacts.Partners.start_date) Start of observed date range") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var aged_to82 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Alter bis</span>", "listeners": { "render": Lino.quicktip_renderer("Aged to","(contacts.Partners.aged_to) Select only persons aged at most the given number of years.") }, "name": "aged_to", "selectOnFocus": true });
    this.items = [ { "autoHeight": true, "flex": 11, "items": partner_list70, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": end_date71, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": show_raviva72, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": course73, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 5, "items": gender74, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": observed_event75, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 2, "items": aged_from76, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": enrolment_state77, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": show_members78, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": show_lfv79, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": show_ckk80, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": start_date81, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 2, "items": aged_to82, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ partner_list70, end_date71, show_raviva72, course73, gender74, observed_event75, aged_from76, enrolment_state77, show_members78, show_lfv79, show_ckk80, start_date81, aged_to82 ];
    Lino.contacts.Partners.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Situation.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 117,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var today97 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Situation am</span>", "listeners": { "render": Lino.quicktip_renderer("Situation on","(ledger.Situation.today) Date of observation") }, "name": "today", "selectOnFocus": true });
    this.items = [ { "autoHeight": true, "items": today97, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ today97 ];
    Lino.ledger.Situation.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.InvoicesByJournal.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 117,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var partner100 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(vat.InvoicesByJournal.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/partner" }) }) });
    var state101 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zustand", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(vat.InvoicesByJournal.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates) });
    var start_period102 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(vat.InvoicesByJournal.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/start_period" }) }) });
    var end_period103 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period until</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period until","(vat.InvoicesByJournal.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/end_period" }) }) });
    var user104 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(vat.InvoicesByJournal.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/user" }) }), "value": null });
    this.items = [ { "autoHeight": true, "flex": 21, "items": partner100, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": state101, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": start_period102, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": end_period103, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": user104, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ partner100, state101, start_period102, end_period103, user104 ];
    Lino.vat.InvoicesByJournal.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.rooms.Bookings.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 117,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var company111 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Organisation ausw\u00e4hlen...", "fieldLabel": "Organisation", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Organization","(rooms.Bookings.company) ") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/company" }) }) });
    var state112 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zustand", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(rooms.Bookings.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.rooms.BookingStates) });
    this.items = [ { "autoHeight": true, "flex": 60, "items": company111, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 39, "items": state112, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ company111, state112 ];
    Lino.rooms.Bookings.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.notify.Messages.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 90,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var user116 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "disabled": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Empf\u00e4nger</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Recipient","(notify.Messages.user) The recipient.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "store": new Lino.ComplexRemoteComboStore({  }), "value": null });
    var show_seen117 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Gelesen", "forceSelection": true, "hiddenName": "show_seenHidden", "listeners": { "render": Lino.quicktip_renderer("Seen","(notify.Messages.show_seen) ") }, "name": "show_seen", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var start_date118 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum von</span>", "listeners": { "render": Lino.quicktip_renderer("Date from","(notify.Messages.start_date) Start of observed date range") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date119 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(notify.Messages.end_date) End of observed date range") }, "name": "end_date", "selectOnFocus": true, "value": null });
    this.items = [ { "autoHeight": true, "flex": 32, "items": user116, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": show_seen117, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": start_date118, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": end_date119, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user116, show_seen117, start_date118, end_date119 ];
    Lino.notify.Messages.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.ExpectedMovements.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 117,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var trade_type125 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Handelsart", "forceSelection": true, "hiddenName": "trade_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Trade type","(ledger.ExpectedMovements.trade_type) ") }, "name": "trade_type", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.TradeTypes) });
    var date_until126 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Datum bis", "listeners": { "render": Lino.quicktip_renderer("Date until","(ledger.ExpectedMovements.date_until) ") }, "name": "date_until", "selectOnFocus": true });
    var from_journal127 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "Journal", "hiddenName": "from_journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(ledger.ExpectedMovements.from_journal) ") }, "name": "from_journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/ExpectedMovements/from_journal" }) }) });
    var for_journal128 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "Begleichbar durch", "hiddenName": "for_journalHidden", "listeners": { "render": Lino.quicktip_renderer("Clearable by","(ledger.ExpectedMovements.for_journal) ") }, "name": "for_journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/ExpectedMovements/for_journal" }) }) });
    var partner129 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(ledger.ExpectedMovements.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/ExpectedMovements/partner" }) }) });
    var account130 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Konto ausw\u00e4hlen...", "fieldLabel": "Konto", "hiddenName": "accountHidden", "listeners": { "render": Lino.quicktip_renderer("Account","(ledger.ExpectedMovements.account) ") }, "name": "account", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/ExpectedMovements/account" }) }) });
    var show_sepa131 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "show sepa", "forceSelection": true, "hiddenName": "show_sepaHidden", "listeners": { "render": Lino.quicktip_renderer("show sepa","(ledger.ExpectedMovements.show_sepa) ") }, "name": "show_sepa", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 10, "items": trade_type125, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": date_until126, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": from_journal127, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": for_journal128, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": partner129, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": account130, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": show_sepa131, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ trade_type125, date_until126, from_journal127, for_journal128, partner129, account130, show_sepa131 ];
    Lino.ledger.ExpectedMovements.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Creditors.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 117,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var today140 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Situation am</span>", "listeners": { "render": Lino.quicktip_renderer("Situation on","(ledger.Creditors.today) Date of observation") }, "name": "today", "selectOnFocus": true });
    this.items = [ { "autoHeight": true, "items": today140, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ today140 ];
    Lino.ledger.Creditors.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Tasks.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var start_date143 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum von</span>", "listeners": { "render": Lino.quicktip_renderer("Date from","(cal.Tasks.start_date) Start of observed date range") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date144 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(cal.Tasks.end_date) End of observed date range") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var user145 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Verwaltet durch</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Managed by","(cal.Tasks.user) Only rows managed by this user.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Tasks/user" }) }) });
    var state146 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(cal.Tasks.state) Only rows having this state.") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.TaskStates) });
    var main_1_panel147 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 22, "items": start_date143, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": end_date144, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": user145, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": state146, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel147 ];
    this.fields = [ start_date143, end_date144, user145, state146 ];
    Lino.cal.Tasks.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.plausibility.Problems.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 189,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var user153 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Verantwortlicher</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible","(plausibility.Problems.user) The user reponsible\nfor fixing this problem.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/Problems/user" }) }), "value": null });
    var checker154 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datentest</span>", "forceSelection": true, "hiddenName": "checkerHidden", "listeners": { "render": Lino.quicktip_renderer("Plausibility checker","(plausibility.Problems.checker) The Checker which reported\nthis problem.") }, "name": "checker", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.plausibility.Checkers), "value": null });
    this.items = [ { "autoHeight": true, "flex": 50, "items": user153, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": checker154, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user153, checker154 ];
    Lino.plausibility.Problems.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.GeneralAccountsBalance.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_period158 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(ledger.GeneralAccountsBalance.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/GeneralAccountsBalance/start_period" }) }) });
    var end_period159 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("until","(ledger.GeneralAccountsBalance.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/GeneralAccountsBalance/end_period" }) }) });
    this.items = [ { "autoHeight": true, "flex": 50, "items": start_period158, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": end_period159, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_period158, end_period159 ];
    Lino.ledger.GeneralAccountsBalance.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Subscriptions.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 63,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var user163 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(cal.Subscriptions.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Subscriptions/user" }) }), "value": null });
    this.items = [ { "autoHeight": true, "items": user163, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user163 ];
    Lino.cal.Subscriptions.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.PaymentOrdersByJournal.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 117,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_period166 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(finan.PaymentOrdersByJournal.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrdersByJournal/start_period" }) }) });
    var end_period167 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period until</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period until","(finan.PaymentOrdersByJournal.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrdersByJournal/end_period" }) }) });
    var state168 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(finan.PaymentOrdersByJournal.state) The workflow state of this voucher. Choices are defined in\nVoucherStates") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates), "value": null });
    var user169 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(finan.PaymentOrdersByJournal.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrdersByJournal/user" }) }), "value": null });
    this.items = [ { "autoHeight": true, "flex": 27, "items": start_period166, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": end_period167, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 17, "items": state168, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": user169, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_period166, end_period167, state168, user169 ];
    Lino.finan.PaymentOrdersByJournal.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.changes.Changes.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var date175 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Only changes from", "listeners": { "render": Lino.quicktip_renderer("Only changes from","(changes.Changes.date) ") }, "name": "date", "selectOnFocus": true });
    var user176 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Benutzer", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("User","(changes.Changes.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/user" }) }) });
    var change_type177 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "\u00c4nderungsart", "forceSelection": false, "hiddenName": "change_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Change Type","(changes.Changes.change_type) ") }, "name": "change_type", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.changes.ChangeTypes) });
    var object_type178 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Datenbankmodell ausw\u00e4hlen...", "fieldLabel": "Object type", "hiddenName": "object_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Object type","(changes.Changes.object_type) ") }, "name": "object_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.gfks.ContentTypes.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/object_type" }) }) });
    var object_id179 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Object ID", "hiddenName": "object_idHidden", "listeners": { "render": Lino.quicktip_renderer("Object ID","(changes.Changes.object_id) ") }, "name": "object_id", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/object_id" }) }) });
    var main_1_panel180 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 16, "items": date175, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": user176, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": change_type177, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": object_type178, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": object_id179, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel180 ];
    this.fields = [ date175, user176, change_type177, object_type178, object_id179 ];
    Lino.changes.Changes.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.invoicing.Plans.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 63,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var user187 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(invoicing.Plans.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/user" }) }), "value": null });
    this.items = [ { "autoHeight": true, "items": user187, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user187 ];
    Lino.invoicing.Plans.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.Invoices.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 198,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var partner190 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(vat.Invoices.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/partner" }) }) });
    var state191 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zustand", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(vat.Invoices.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates) });
    var journal192 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "Journal", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(vat.Invoices.journal) ") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/journal" }) }) });
    var start_period193 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(vat.Invoices.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/start_period" }) }) });
    var end_period194 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period until</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period until","(vat.Invoices.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/end_period" }) }) });
    var cleared195 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beglichene Bewegungen zeigen", "forceSelection": true, "hiddenName": "clearedHidden", "listeners": { "render": Lino.quicktip_renderer("Show cleared vouchers","(vat.Invoices.cleared) ") }, "name": "cleared", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 18, "items": partner190, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": state191, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": journal192, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": start_period193, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": end_period194, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": cleared195, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ partner190, state191, journal192, start_period193, end_period194, cleared195 ];
    Lino.vat.Invoices.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.IntracomInvoices.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 198,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var partner203 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(vat.IntracomInvoices.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/IntracomInvoices/partner" }) }) });
    var state204 = new Lino.ChoicesFieldElement({ "fieldLabel": "Zustand", "flex": 12, "forceSelection": true, "hidden": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(vat.IntracomInvoices.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates) });
    var journal205 = new Lino.TwinCombo({ "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "Journal", "flex": 18, "hidden": true, "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(vat.IntracomInvoices.journal) ") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/IntracomInvoices/journal" }) }) });
    var start_period206 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(vat.IntracomInvoices.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/IntracomInvoices/start_period" }) }) });
    var end_period207 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period until</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period until","(vat.IntracomInvoices.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/IntracomInvoices/end_period" }) }) });
    var cleared208 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beglichene Bewegungen zeigen", "forceSelection": true, "hiddenName": "clearedHidden", "listeners": { "render": Lino.quicktip_renderer("Show cleared vouchers","(vat.IntracomInvoices.cleared) ") }, "name": "cleared", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 18, "items": partner203, "labelAlign": "top", "layout": "form", "xtype": "panel" }, state204, journal205, { "autoHeight": true, "flex": 18, "items": start_period206, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": end_period207, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": cleared208, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ partner203, start_period206, end_period207, cleared208 ];
    Lino.vat.IntracomInvoices.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Debtors.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 117,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var today214 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Situation am</span>", "listeners": { "render": Lino.quicktip_renderer("Situation on","(ledger.Debtors.today) Date of observation") }, "name": "today", "selectOnFocus": true });
    this.items = [ { "autoHeight": true, "items": today214, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ today214 ];
    Lino.ledger.Debtors.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.sales.Invoices.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 198,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var partner217 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(sales.Invoices.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/partner" }) }) });
    var state218 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zustand", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(sales.Invoices.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates) });
    var journal219 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "Journal", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(sales.Invoices.journal) ") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/journal" }) }) });
    var start_period220 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(sales.Invoices.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/start_period" }) }) });
    var end_period221 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period until</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period until","(sales.Invoices.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/end_period" }) }) });
    var cleared222 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beglichene Bewegungen zeigen", "forceSelection": true, "hiddenName": "clearedHidden", "listeners": { "render": Lino.quicktip_renderer("Show cleared vouchers","(sales.Invoices.cleared) ") }, "name": "cleared", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 18, "items": partner217, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": state218, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": journal219, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": start_period220, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": end_period221, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": cleared222, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ partner217, state218, journal219, start_period220, end_period221, cleared222 ];
    Lino.sales.Invoices.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.VatRules.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_date230 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(vat.VatRules.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date231 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(vat.VatRules.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    this.items = [ { "autoHeight": true, "flex": 50, "items": start_date230, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": end_date231, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_date230, end_date231 ];
    Lino.vat.VatRules.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.about.Inspector.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 153,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var inspected235 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Inspected object", "listeners": { "render": Lino.quicktip_renderer("Inspected object","(about.Inspector.inspected) ") }, "maxLength": 100, "name": "inspected", "selectOnFocus": true });
    var show_callables236 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "show callables", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("show callables","(about.Inspector.show_callables) ") }, "name": "show_callables", "selectOnFocus": true });
    this.items = [ { "autoHeight": true, "flex": 67, "items": inspected235, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": show_callables236, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ inspected235, show_callables236 ];
    Lino.about.Inspector.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.PartnerAccountsBalance.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_period240 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(ledger.PartnerAccountsBalance.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerAccountsBalance/start_period" }) }) });
    var end_period241 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("until","(ledger.PartnerAccountsBalance.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerAccountsBalance/end_period" }) }) });
    this.items = [ { "autoHeight": true, "flex": 50, "items": start_period240, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": end_period241, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_period240, end_period241 ];
    Lino.ledger.PartnerAccountsBalance.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.sales.InvoicesByJournal.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 198,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var partner245 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(sales.InvoicesByJournal.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/partner" }) }) });
    var year246 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Gesch\u00e4ftsjahr", "forceSelection": true, "hiddenName": "yearHidden", "listeners": { "render": Lino.quicktip_renderer("Fiscal Year","(sales.InvoicesByJournal.year) ") }, "name": "year", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.FiscalYears) });
    var state247 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zustand", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(sales.InvoicesByJournal.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates) });
    var cleared248 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beglichene Bewegungen zeigen", "forceSelection": true, "hiddenName": "clearedHidden", "listeners": { "render": Lino.quicktip_renderer("Show cleared vouchers","(sales.InvoicesByJournal.cleared) ") }, "name": "cleared", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 36, "items": partner245, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": year246, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": state247, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": cleared248, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ partner245, year246, state247, cleared248 ];
    Lino.sales.InvoicesByJournal.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.AccountingReport.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  autoHeight: true,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var start_period254 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(ledger.AccountingReport.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/AccountingReport/start_period" }) }) });
    var end_period255 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("until","(ledger.AccountingReport.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/AccountingReport/end_period" }) }) });
    var with_balances256 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Balances", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Balances","(ledger.AccountingReport.with_balances) ") }, "name": "with_balances", "selectOnFocus": true });
    var with_activity257 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Activity", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Activity","(ledger.AccountingReport.with_activity) ") }, "name": "with_activity", "selectOnFocus": true });
    var main_1_panel258 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": start_period254, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": end_period255, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": with_balances256, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": with_activity257, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var with_general263 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Allgemein", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("General","(ledger.AccountingReport.with_general) ") }, "name": "with_general", "selectOnFocus": true });
    var with_sales264 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Verkauf", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Sales","(ledger.AccountingReport.with_sales) ") }, "name": "with_sales", "selectOnFocus": true });
    var with_purchases265 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Einkauf", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Purchases","(ledger.AccountingReport.with_purchases) ") }, "name": "with_purchases", "selectOnFocus": true });
    var with_wages266 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "L\u00f6hne und Geh\u00e4lter", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wages","(ledger.AccountingReport.with_wages) ") }, "name": "with_wages", "selectOnFocus": true });
    var with_taxes267 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Taxes", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Taxes","(ledger.AccountingReport.with_taxes) ") }, "name": "with_taxes", "selectOnFocus": true });
    var with_clearings268 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Begleichungen", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Clearings","(ledger.AccountingReport.with_clearings) ") }, "name": "with_clearings", "selectOnFocus": true });
    var main_2_panel269 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 16, "items": with_general263, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": with_sales264, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": with_purchases265, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": with_wages266, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": with_taxes267, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": with_clearings268, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel258, main_2_panel269 ];
    this.fields = [ start_period254, end_period255, with_balances256, with_activity257, with_general263, with_sales264, with_purchases265, with_wages266, with_taxes267, with_clearings268 ];
    Lino.ledger.AccountingReport.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.OneEvent.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  autoHeight: true,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var start_date277 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum von</span>", "listeners": { "render": Lino.quicktip_renderer("Date from","(cal.OneEvent.start_date) Start of observed date range") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date278 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(cal.OneEvent.end_date) End of observed date range") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var observed_event279 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beobachtungskriterium", "forceSelection": true, "hiddenName": "observed_eventHidden", "listeners": { "render": Lino.quicktip_renderer("Observed event","(cal.OneEvent.observed_event) ") }, "name": "observed_event", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.EventEvents) });
    var state280 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(cal.OneEvent.state) Only rows having this state.") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.EntryStates) });
    var main_1_panel281 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 26, "items": start_date277, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": end_date278, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": observed_event279, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": state280, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var user286 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Verwaltet durch</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Managed by","(cal.OneEvent.user) Only rows managed by this user.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/user" }) }) });
    var assigned_to287 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zugewiesen zu</span>", "hiddenName": "assigned_toHidden", "listeners": { "render": Lino.quicktip_renderer("Assigned to","(cal.OneEvent.assigned_to) Only events assigned to this user.") }, "name": "assigned_to", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/assigned_to" }) }) });
    var event_type288 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "fieldLabel": "Kalendereintragsart", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(cal.OneEvent.event_type) ") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/event_type" }) }) });
    var room289 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Raum ausw\u00e4hlen...", "fieldLabel": "Raum", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(cal.OneEvent.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/room" }) }) });
    var show_appointments290 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Termine</span>", "forceSelection": true, "hiddenName": "show_appointmentsHidden", "listeners": { "render": Lino.quicktip_renderer("Appointments","(cal.OneEvent.show_appointments) Whether only appointments should be\nshown.  \"Yes\" means only appointments, \"No\"\nmeans no appointments and leaving it to blank shows both types\nof events.") }, "name": "show_appointments", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var main_2_panel291 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 21, "items": user286, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": assigned_to287, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": event_type288, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": room289, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": show_appointments290, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel281, main_2_panel291 ];
    this.fields = [ start_date277, end_date278, observed_event279, state280, user286, assigned_to287, event_type288, room289, show_appointments290 ];
    Lino.cal.OneEvent.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Guests.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  autoHeight: true,
  border: false,
  labelWidth: 63,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var start_date298 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum von</span>", "listeners": { "render": Lino.quicktip_renderer("Date from","(cal.Guests.start_date) Start of observed date range") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date299 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(cal.Guests.end_date) End of observed date range") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var user300 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Verantwortlicher</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible user","(cal.Guests.user) Only rows managed by this user.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/user" }) }) });
    var event_state301 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand Termin</span>", "forceSelection": true, "hiddenName": "event_stateHidden", "listeners": { "render": Lino.quicktip_renderer("Event state","(cal.Guests.event_state) Only rows having this event state.") }, "name": "event_state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.EntryStates) });
    var guest_state302 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand Gast</span>", "forceSelection": true, "hiddenName": "guest_stateHidden", "listeners": { "render": Lino.quicktip_renderer("Guest state","(cal.Guests.guest_state) Only rows having this guest state.") }, "name": "guest_state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.GuestStates) });
    var main_1_panel303 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 18, "items": start_date298, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": end_date299, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": user300, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": event_state301, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": guest_state302, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var partner309 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Person ausw\u00e4hlen...", "fieldLabel": "Person", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Person","(cal.Guests.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/partner" }) }) });
    this.items = [ main_1_panel303, { "anchor": "-20", "autoHeight": true, "items": partner309, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_date298, end_date299, user300, event_state301, guest_state302, partner309 ];
    Lino.cal.Guests.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.sales.PrintableInvoicesByJournal.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 117,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var journal312 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "Journal", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(sales.PrintableInvoicesByJournal.journal) ") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PrintableInvoicesByJournal/journal" }) }) });
    var start_period313 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(sales.PrintableInvoicesByJournal.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PrintableInvoicesByJournal/start_period" }) }) });
    var end_period314 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period until</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period until","(sales.PrintableInvoicesByJournal.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PrintableInvoicesByJournal/end_period" }) }) });
    var state315 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zustand", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(sales.PrintableInvoicesByJournal.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates) });
    this.items = [ { "autoHeight": true, "flex": 27, "items": journal312, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": start_period313, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": end_period314, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 17, "items": state315, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ journal312, start_period313, end_period314, state315 ];
    Lino.sales.PrintableInvoicesByJournal.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Pupils.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 117,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var course321 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Activity ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Activity</span>", "hiddenName": "courseHidden", "listeners": { "render": Lino.quicktip_renderer("Activity","(courses.Pupils.course) Show only pupils who participate in the given course.") }, "name": "course", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Activities.detail,Lino.courses.Activities.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/course" }) }) });
    var partner_list322 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partnerliste ausw\u00e4hlen...", "fieldLabel": "Partnerliste", "hiddenName": "partner_listHidden", "listeners": { "render": Lino.quicktip_renderer("Partner List","(courses.Pupils.partner_list) ") }, "name": "partner_list", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.lists.Lists.detail,Lino.lists.Lists.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/partner_list" }) }) });
    var gender323 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Geschlecht</span>", "forceSelection": true, "hiddenName": "genderHidden", "listeners": { "render": Lino.quicktip_renderer("Gender","(courses.Pupils.gender) The sex of this person (male or female).") }, "name": "gender", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders), "value": null });
    var show_members324 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Mitglieder</span>", "forceSelection": true, "hiddenName": "show_membersHidden", "listeners": { "render": Lino.quicktip_renderer("Members","(courses.Pupils.show_members) Show those whose 'Member until' is after today.") }, "name": "show_members", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var show_lfv325 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "LFV", "forceSelection": true, "hiddenName": "show_lfvHidden", "listeners": { "render": Lino.quicktip_renderer("LFV","(courses.Pupils.show_lfv) ") }, "name": "show_lfv", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var show_ckk326 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "CKK", "forceSelection": true, "hiddenName": "show_ckkHidden", "listeners": { "render": Lino.quicktip_renderer("CKK","(courses.Pupils.show_ckk) ") }, "name": "show_ckk", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var show_raviva327 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Raviva", "forceSelection": true, "hiddenName": "show_ravivaHidden", "listeners": { "render": Lino.quicktip_renderer("Raviva","(courses.Pupils.show_raviva) ") }, "name": "show_raviva", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 18, "items": course321, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": partner_list322, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": gender323, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": show_members324, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": show_lfv325, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": show_ckk326, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": show_raviva327, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ course321, partner_list322, gender323, show_members324, show_lfv325, show_ckk326, show_raviva327 ];
    Lino.courses.Pupils.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.ActivityReport.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 90,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_date336 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum von</span>", "listeners": { "render": Lino.quicktip_renderer("Date from","(ledger.ActivityReport.start_date) Start of observed date range") }, "name": "start_date", "selectOnFocus": true });
    var end_date337 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(ledger.ActivityReport.end_date) End of observed date range") }, "name": "end_date", "selectOnFocus": true });
    this.items = [ { "autoHeight": true, "flex": 50, "items": start_date336, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": end_date337, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_date336, end_date337 ];
    Lino.ledger.ActivityReport.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.notes.Notes.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 63,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var user341 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(notes.Notes.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/user" }) }), "value": null });
    this.items = [ { "autoHeight": true, "items": user341, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user341 ];
    Lino.notes.Notes.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.JournalEntriesByJournal.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 117,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_period344 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(finan.JournalEntriesByJournal.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntriesByJournal/start_period" }) }) });
    var end_period345 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period until</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period until","(finan.JournalEntriesByJournal.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntriesByJournal/end_period" }) }) });
    var state346 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(finan.JournalEntriesByJournal.state) The workflow state of this voucher. Choices are defined in\nVoucherStates") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates), "value": null });
    var user347 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(finan.JournalEntriesByJournal.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntriesByJournal/user" }) }), "value": null });
    this.items = [ { "autoHeight": true, "flex": 27, "items": start_period344, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": end_period345, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 17, "items": state346, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": user347, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_period344, end_period345, state346, user347 ];
    Lino.finan.JournalEntriesByJournal.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Events.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  autoHeight: true,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var start_date353 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum von</span>", "listeners": { "render": Lino.quicktip_renderer("Date from","(cal.Events.start_date) Start of observed date range") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date354 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(cal.Events.end_date) End of observed date range") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var observed_event355 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beobachtungskriterium", "forceSelection": true, "hiddenName": "observed_eventHidden", "listeners": { "render": Lino.quicktip_renderer("Observed event","(cal.Events.observed_event) ") }, "name": "observed_event", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.EventEvents) });
    var state356 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(cal.Events.state) Only rows having this state.") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.EntryStates) });
    var main_1_panel357 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 26, "items": start_date353, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": end_date354, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": observed_event355, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": state356, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var user362 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Verwaltet durch</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Managed by","(cal.Events.user) Only rows managed by this user.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/user" }) }) });
    var assigned_to363 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zugewiesen zu</span>", "hiddenName": "assigned_toHidden", "listeners": { "render": Lino.quicktip_renderer("Assigned to","(cal.Events.assigned_to) Only events assigned to this user.") }, "name": "assigned_to", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/assigned_to" }) }) });
    var event_type364 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "fieldLabel": "Kalendereintragsart", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(cal.Events.event_type) ") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/event_type" }) }) });
    var room365 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Raum ausw\u00e4hlen...", "fieldLabel": "Raum", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(cal.Events.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/room" }) }) });
    var show_appointments366 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Termine</span>", "forceSelection": true, "hiddenName": "show_appointmentsHidden", "listeners": { "render": Lino.quicktip_renderer("Appointments","(cal.Events.show_appointments) Whether only appointments should be\nshown.  \"Yes\" means only appointments, \"No\"\nmeans no appointments and leaving it to blank shows both types\nof events.") }, "name": "show_appointments", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var main_2_panel367 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 21, "items": user362, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": assigned_to363, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": event_type364, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": room365, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": show_appointments366, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel357, main_2_panel367 ];
    this.fields = [ start_date353, end_date354, observed_event355, state356, user362, assigned_to363, event_type364, room365, show_appointments366 ];
    Lino.cal.Events.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.PrintableInvoicesByJournal.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 117,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var journal374 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "Journal", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(vat.PrintableInvoicesByJournal.journal) ") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/PrintableInvoicesByJournal/journal" }) }) });
    var start_period375 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(vat.PrintableInvoicesByJournal.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/PrintableInvoicesByJournal/start_period" }) }) });
    var end_period376 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period until</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period until","(vat.PrintableInvoicesByJournal.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/PrintableInvoicesByJournal/end_period" }) }) });
    var state377 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zustand", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(vat.PrintableInvoicesByJournal.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates) });
    this.items = [ { "autoHeight": true, "flex": 27, "items": journal374, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": start_period375, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": end_period376, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 17, "items": state377, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ journal374, start_period375, end_period376, state377 ];
    Lino.vat.PrintableInvoicesByJournal.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.BankStatementsByJournal.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 117,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_period383 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(finan.BankStatementsByJournal.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementsByJournal/start_period" }) }) });
    var end_period384 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period until</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period until","(finan.BankStatementsByJournal.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementsByJournal/end_period" }) }) });
    var state385 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(finan.BankStatementsByJournal.state) The workflow state of this voucher. Choices are defined in\nVoucherStates") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates), "value": null });
    var user386 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(finan.BankStatementsByJournal.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementsByJournal/user" }) }), "value": null });
    this.items = [ { "autoHeight": true, "flex": 27, "items": start_period383, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": end_period384, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 17, "items": state385, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": user386, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_period383, end_period384, state385, user386 ];
    Lino.finan.BankStatementsByJournal.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Enrolments.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 162,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_date392 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(courses.Enrolments.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date393 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(courses.Enrolments.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var author394 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Benutzer", "hiddenName": "authorHidden", "listeners": { "render": Lino.quicktip_renderer("User","(courses.Enrolments.author) ") }, "name": "author", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/author" }) }) });
    var state395 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zustand", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(courses.Enrolments.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.EnrolmentStates) });
    var course_state396 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zustand Kurs", "forceSelection": true, "hiddenName": "course_stateHidden", "listeners": { "render": Lino.quicktip_renderer("Course state","(courses.Enrolments.course_state) ") }, "name": "course_state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.CourseStates) });
    var participants_only397 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Nur Teilnehmer", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Participants only","(courses.Enrolments.participants_only) Hide cancelled enrolments. Ignored if you specify an explicit enrolment state.") }, "name": "participants_only", "selectOnFocus": true });
    this.items = [ { "autoHeight": true, "flex": 16, "items": start_date392, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": end_date393, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": author394, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": state395, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": course_state396, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": participants_only397, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_date392, end_date393, author394, state395, course_state396, participants_only397 ];
    Lino.courses.Enrolments.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.AccountingPeriods.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_date405 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(ledger.AccountingPeriods.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date406 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(ledger.AccountingPeriods.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    this.items = [ { "autoHeight": true, "flex": 50, "items": start_date405, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": end_date406, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_date405, end_date406 ];
    Lino.ledger.AccountingPeriods.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.outbox.Mails.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 63,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var user410 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Absender", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Sender","(outbox.Mails.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/Mails/user" }) }), "value": null });
    this.items = [ { "autoHeight": true, "items": user410, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user410 ];
    Lino.outbox.Mails.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.uploads.Uploads.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_date413 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum von</span>", "listeners": { "render": Lino.quicktip_renderer("Date from","(uploads.Uploads.start_date) Start of observed date range") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date414 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(uploads.Uploads.end_date) End of observed date range") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var user415 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Hochgeladen durch", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Uploaded by","(uploads.Uploads.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/user" }) }), "value": null });
    var upload_type416 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Upload-Art ausw\u00e4hlen...", "fieldLabel": "Upload-Art", "hiddenName": "upload_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Type","(uploads.Uploads.upload_type) ") }, "name": "upload_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.uploads.UploadTypes.detail,Lino.uploads.UploadTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/upload_type" }) }) });
    this.items = [ { "autoHeight": true, "flex": 19, "items": start_date413, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": end_date414, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": user415, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": upload_type416, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_date413, end_date414, user415, upload_type416 ];
    Lino.uploads.Uploads.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.excerpts.Excerpts.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  autoHeight: true,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var start_date422 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum von</span>", "listeners": { "render": Lino.quicktip_renderer("Date from","(excerpts.Excerpts.start_date) Start of observed date range") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date423 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(excerpts.Excerpts.end_date) End of observed date range") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var pcertifying424 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Certifying excerpts", "forceSelection": true, "hiddenName": "pcertifyingHidden", "listeners": { "render": Lino.quicktip_renderer("Certifying excerpts","(excerpts.Excerpts.pcertifying) ") }, "name": "pcertifying", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var main_1_panel425 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 31, "items": start_date422, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": end_date423, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 36, "items": pcertifying424, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var user429 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(excerpts.Excerpts.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/user" }) }), "value": null });
    var excerpt_type430 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Auszugsart ausw\u00e4hlen...", "fieldLabel": "Auszugsart", "hiddenName": "excerpt_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Excerpt Type","(excerpts.Excerpts.excerpt_type) ") }, "name": "excerpt_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.excerpts.ExcerptTypes.detail,Lino.excerpts.ExcerptTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/excerpt_type" }) }) });
    var main_2_panel431 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": user429, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": excerpt_type430, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel425, main_2_panel431 ];
    this.fields = [ start_date422, end_date423, pcertifying424, user429, excerpt_type430 ];
    Lino.excerpts.Excerpts.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.RecurrentEvents.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 63,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var user435 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(cal.RecurrentEvents.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/RecurrentEvents/user" }) }), "value": null });
    this.items = [ { "autoHeight": true, "items": user435, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user435 ];
    Lino.cal.RecurrentEvents.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Movements.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  autoHeight: true,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var start_period438 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Periode vom</span>", "hiddenName": "start_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period from","(ledger.Movements.start_period) Start of observed period range") }, "name": "start_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/start_period" }) }) });
    var end_period439 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period until</span>", "hiddenName": "end_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Period until","(ledger.Movements.end_period) Optional end of observed period range. Leave empty to consider only the Start period.") }, "name": "end_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/end_period" }) }) });
    var start_date440 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum von</span>", "listeners": { "render": Lino.quicktip_renderer("Date from","(ledger.Movements.start_date) Start of observed date range") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date441 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(ledger.Movements.end_date) End of observed date range") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var cleared442 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beglichene Bewegungen zeigen", "forceSelection": true, "hiddenName": "clearedHidden", "listeners": { "render": Lino.quicktip_renderer("Show cleared movements","(ledger.Movements.cleared) ") }, "name": "cleared", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var main_1_panel443 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 24, "items": start_period438, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": end_period439, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": start_date440, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": end_date441, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": cleared442, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 207, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var journal_group449 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Journalgruppe", "forceSelection": true, "hiddenName": "journal_groupHidden", "listeners": { "render": Lino.quicktip_renderer("Journal group","(ledger.Movements.journal_group) ") }, "name": "journal_group", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.JournalGroups) });
    var journal450 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "Journal", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(ledger.Movements.journal) ") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/journal" }) }) });
    var year451 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Gesch\u00e4ftsjahr", "forceSelection": true, "hiddenName": "yearHidden", "listeners": { "render": Lino.quicktip_renderer("Fiscal Year","(ledger.Movements.year) ") }, "name": "year", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.FiscalYears) });
    var partner452 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(ledger.Movements.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/partner" }) }) });
    var account453 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Konto ausw\u00e4hlen...", "fieldLabel": "Konto", "hiddenName": "accountHidden", "listeners": { "render": Lino.quicktip_renderer("Account","(ledger.Movements.account) ") }, "name": "account", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/account" }) }) });
    var main_2_panel454 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 15, "items": journal_group449, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": journal450, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": year451, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": partner452, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": account453, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel443, main_2_panel454 ];
    this.fields = [ start_period438, end_period439, start_date440, end_date441, cleared442, journal_group449, journal450, year451, partner452, account453 ];
    Lino.ledger.Movements.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.users.UsersOverview.sign_in_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 81,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "left",
  action_name: 'sign_in',
  ls_url: "/users/UsersOverview",
  window_title: "Sign in",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.username495 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Benutzername", "listeners": { "render": Lino.quicktip_renderer("Username","(Sign in.username) ") }, "maxLength": null, "name": "username", "selectOnFocus": true });
    this.password496 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Passwort", "inputType": "password", "listeners": { "render": Lino.quicktip_renderer("Password","(Sign in.password) ") }, "maxLength": null, "name": "password", "selectOnFocus": true });
    this.items = [ { "anchor": "-20", "autoHeight": true, "items": this.username495, "labelAlign": "left", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.password496, "labelAlign": "left", "layout": "form", "xtype": "panel" } ];
    this.fields = [ this.username495, this.password496 ];
    Lino.users.UsersOverview.sign_in_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Activities.print_presence_sheet_html_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 117,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  action_name: 'print_presence_sheet_html',
  ls_url: "/courses/Activities",
  window_title: "Anwesenheitsliste (HTML)",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.start_date500 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum von</span>", "listeners": { "render": Lino.quicktip_renderer("Date from","(Presence sheet (HTML).start_date) Start of observed date range") }, "name": "start_date", "selectOnFocus": true });
    this.end_date501 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(Presence sheet (HTML).end_date) End of observed date range") }, "name": "end_date", "selectOnFocus": true });
    this.show_remarks502 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Bemerkungen drucken", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Show remarks","(Presence sheet (HTML).show_remarks) ") }, "name": "show_remarks", "selectOnFocus": true });
    this.show_states503 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Einschreibestatus drucken", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Show states","(Presence sheet (HTML).show_states) ") }, "name": "show_states", "selectOnFocus": true });
    this.items = [ { "anchor": "-20", "autoHeight": true, "items": this.start_date500, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.end_date501, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.show_remarks502, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.show_states503, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ this.start_date500, this.end_date501, this.show_remarks502, this.show_states503 ];
    Lino.courses.Activities.print_presence_sheet_html_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Pupils.merge_row_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 351,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  action_name: 'merge_row',
  ls_url: "/courses/Pupils",
  window_title: "Fusionieren",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.merge_to518 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Teilnehmer ausw\u00e4hlen...", "fieldLabel": "nach...", "hiddenName": "merge_toHidden", "listeners": { "render": Lino.quicktip_renderer("into...","(Merge.merge_to) ") }, "name": "merge_to", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Pupils.detail,Lino.courses.Pupils.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/apchoices/courses/Pupils/merge_row/merge_to" }) }) });
    this.sepa_Account519 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Auch verg\u00e4ngliche verkn\u00fcpfte Objekte \u00fcberweisen", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(Merge.sepa_Account) ") }, "name": "sepa_Account", "selectOnFocus": true });
    this.reason520 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Begr\u00fcndung", "listeners": { "render": Lino.quicktip_renderer("Reason","(Merge.reason) ") }, "maxLength": 100, "name": "reason", "selectOnFocus": true });
    this.items = [ { "anchor": "-20", "autoHeight": true, "items": this.merge_to518, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.sepa_Account519, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.reason520, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ this.merge_to518, this.sepa_Account519, this.reason520 ];
    Lino.courses.Pupils.merge_row_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.sales.Invoices.make_copy_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 81,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  action_name: 'make_copy',
  ls_url: "/sales/Invoices",
  window_title: "Make copy",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.entry_date468 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Buchungsdatum", "listeners": { "render": Lino.quicktip_renderer("Entry date","(Make copy.entry_date) ") }, "name": "entry_date", "selectOnFocus": true });
    this.partner469 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(Make copy.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/apchoices/sales/Invoices/make_copy/partner" }) }) });
    var main_1_panel470 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": this.entry_date468, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 60, "items": this.partner469, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.your_ref473 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Your ref", "listeners": { "render": Lino.quicktip_renderer("Your ref","(Make copy.your_ref) ") }, "maxLength": 200, "name": "your_ref", "selectOnFocus": true });
    this.subject474 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Betreff", "listeners": { "render": Lino.quicktip_renderer("Subject","(Make copy.subject) ") }, "maxLength": 200, "name": "subject", "selectOnFocus": true });
    this.product475 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarif ausw\u00e4hlen...", "fieldLabel": "Tarif", "hiddenName": "productHidden", "listeners": { "render": Lino.quicktip_renderer("Tariff","(Make copy.product) ") }, "name": "product", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/apchoices/sales/Invoices/make_copy/product" }) }) });
    this.total_incl476 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "Total incl VAT", "listeners": { "render": Lino.quicktip_renderer("Total incl VAT","(Make copy.total_incl) ") }, "name": "total_incl", "selectOnFocus": true });
    var main_4_panel477 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 62, "items": this.product475, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 37, "items": this.total_incl476, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel470, { "anchor": "-20", "autoHeight": true, "items": this.your_ref473, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.subject474, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_4_panel477 ];
    this.fields = [ this.entry_date468, this.partner469, this.your_ref473, this.subject474, this.product475, this.total_incl476 ];
    Lino.sales.Invoices.make_copy_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.users.Users.change_password_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 171,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  action_name: 'change_password',
  ls_url: "/users/Users",
  window_title: "Passwort \u00e4ndern",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.current483 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Aktuelles Passwort", "inputType": "password", "listeners": { "render": Lino.quicktip_renderer("Current password","(Change password.current) ") }, "maxLength": null, "name": "current", "selectOnFocus": true });
    this.new1484 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Neues Passwort", "inputType": "password", "listeners": { "render": Lino.quicktip_renderer("New password","(Change password.new1) ") }, "maxLength": null, "name": "new1", "selectOnFocus": true });
    this.new2485 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Neues Passwort nochmal", "inputType": "password", "listeners": { "render": Lino.quicktip_renderer("New password again","(Change password.new2) ") }, "maxLength": null, "name": "new2", "selectOnFocus": true });
    this.items = [ { "anchor": "-20", "autoHeight": true, "items": this.current483, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.new1484, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.new2485, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ this.current483, this.new1484, this.new2485 ];
    Lino.users.Users.change_password_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Companies.merge_row_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 351,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  action_name: 'merge_row',
  ls_url: "/contacts/Companies",
  window_title: "Fusionieren",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.merge_to461 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Organisation ausw\u00e4hlen...", "fieldLabel": "nach...", "hiddenName": "merge_toHidden", "listeners": { "render": Lino.quicktip_renderer("into...","(Merge.merge_to) ") }, "name": "merge_to", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/apchoices/contacts/Companies/merge_row/merge_to" }) }) });
    this.sepa_Account462 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Auch verg\u00e4ngliche verkn\u00fcpfte Objekte \u00fcberweisen", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(Merge.sepa_Account) ") }, "name": "sepa_Account", "selectOnFocus": true });
    this.reason463 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Begr\u00fcndung", "listeners": { "render": Lino.quicktip_renderer("Reason","(Merge.reason) ") }, "maxLength": 100, "name": "reason", "selectOnFocus": true });
    this.items = [ { "anchor": "-20", "autoHeight": true, "items": this.merge_to461, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.sepa_Account462, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.reason463, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ this.merge_to461, this.sepa_Account462, this.reason463 ];
    Lino.contacts.Companies.merge_row_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Activities.print_presence_sheet_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 117,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  action_name: 'print_presence_sheet',
  ls_url: "/courses/Activities",
  window_title: "Anwesenheitsliste",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.start_date509 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum von</span>", "listeners": { "render": Lino.quicktip_renderer("Date from","(Presence sheet.start_date) Start of observed date range") }, "name": "start_date", "selectOnFocus": true });
    this.end_date510 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">bis</span>", "listeners": { "render": Lino.quicktip_renderer("until","(Presence sheet.end_date) End of observed date range") }, "name": "end_date", "selectOnFocus": true });
    this.show_remarks511 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Bemerkungen drucken", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Show remarks","(Presence sheet.show_remarks) ") }, "name": "show_remarks", "selectOnFocus": true });
    this.show_states512 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Einschreibestatus drucken", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Show states","(Presence sheet.show_states) ") }, "name": "show_states", "selectOnFocus": true });
    this.items = [ { "anchor": "-20", "autoHeight": true, "items": this.start_date509, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.end_date510, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.show_remarks511, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.show_states512, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ this.start_date509, this.end_date510, this.show_remarks511, this.show_states512 ];
    Lino.courses.Activities.print_presence_sheet_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.users.AllUsers.send_welcome_email_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 135,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  action_name: 'send_welcome_email',
  ls_url: "/users/AllUsers",
  window_title: "Welcome mail",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.email490 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "E-Mail-Adresse", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(Welcome mail.email) ") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    this.subject491 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Betreff", "listeners": { "render": Lino.quicktip_renderer("Subject","(Welcome mail.subject) ") }, "maxLength": 250, "name": "subject", "selectOnFocus": true });
    this.items = [ { "anchor": "-20", "autoHeight": true, "items": this.email490, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.subject491, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ this.email490, this.subject491 ];
    Lino.users.AllUsers.send_welcome_email_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.lists.Lists.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 14,
  initComponent : function() {
    var ref1150 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Referenz</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(lists.Lists.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var list_type1151 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Listenart ausw\u00e4hlen...", "fieldLabel": "Listenart", "hiddenName": "list_typeHidden", "listeners": { "render": Lino.quicktip_renderer("List Type","(lists.Lists.list_type) ") }, "name": "list_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/Lists/list_type" }) }) });
    var main_1_panel1152 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 51, "items": ref1150, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 48, "items": list_type1151, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var designation1155 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(lists.Lists.designation) ") }, "maxLength": 200, "name": "designation", "selectOnFocus": true });
    var designation_de1156 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(lists.Lists.designation_de) ") }, "maxLength": 200, "name": "designation_de", "selectOnFocus": true });
    var designation_fr1157 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(lists.Lists.designation_fr) ") }, "maxLength": 200, "name": "designation_fr", "selectOnFocus": true });
    var main_2_panel1158 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": designation1155, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": designation_de1156, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": designation_fr1157, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks1162 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkungen", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(lists.Lists.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var main_panel1163 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1152, main_2_panel1158, { "flex": 71, "items": remarks1162, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 72, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1163;
    this.before_row_edit = function(record) {
    }
    Lino.lists.Lists.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.EnrolmentsByPupil.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 53,
  initComponent : function() {
    var course_area1165 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Layout", "forceSelection": true, "hiddenName": "course_areaHidden", "listeners": { "render": Lino.quicktip_renderer("Layout","(courses.EnrolmentsByPupil.course_area) ") }, "name": "course_area", "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var course1166 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Activity ausw\u00e4hlen...", "fieldLabel": "Activity", "hiddenName": "courseHidden", "listeners": { "render": Lino.quicktip_renderer("Activity","(courses.EnrolmentsByPupil.course) ") }, "name": "course", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Activities.detail,Lino.courses.Activities.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/course" }) }) });
    var places1167 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Anz. Pl\u00e4tze</span>", "listeners": { "render": Lino.quicktip_renderer("Places used","(courses.EnrolmentsByPupil.places) The number of participants in this enrolment.") }, "name": "places", "selectOnFocus": true, "value": 1 });
    var option1168 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarif ausw\u00e4hlen...", "fieldLabel": "Option", "hiddenName": "optionHidden", "listeners": { "render": Lino.quicktip_renderer("Option","(courses.EnrolmentsByPupil.option) ") }, "name": "option", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/option" }) }) });
    var main_3_panel1169 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 20, "items": places1167, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 80, "items": option1168, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remark1172 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bemerkung", "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.EnrolmentsByPupil.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var request_date1173 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Datum der Anfrage", "listeners": { "render": Lino.quicktip_renderer("Date of request","(courses.EnrolmentsByPupil.request_date) ") }, "name": "request_date", "selectOnFocus": true });
    var user1174 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.EnrolmentsByPupil.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/user" }) }) });
    var main_5_panel1175 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": request_date1173, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 60, "items": user1174, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel1178 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": course_area1165, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": course1166, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_3_panel1169, { "anchor": "-20", "autoHeight": true, "items": remark1172, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_5_panel1175 ], "labelAlign": "top", "labelWidth": 81, "layout": "form" });
    this.items = main_panel1178;
    this.before_row_edit = function(record) {
      course1166.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course1166.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      option1168.setContextValue('course', record ? record.data['courseHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      course_area1165.on('change',Lino.chooser_handler(course1166,'course_area'));
      request_date1173.on('change',Lino.chooser_handler(course1166,'request_date'));
      course1166.on('change',Lino.chooser_handler(option1168,'course'));
      Lino.courses.EnrolmentsByPupil.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.EnrolmentsByPupil.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.EventTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 22,
  initComponent : function() {
    var name1182 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.EventTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de1183 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.EventTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr1184 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.EventTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel1185 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name1182, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de1183, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr1184, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var event_label1189 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung Termin</span>", "listeners": { "render": Lino.quicktip_renderer("Entry label","(cal.EventTypes.event_label) Default text for summary of new entries.") }, "maxLength": 200, "name": "event_label", "selectOnFocus": true });
    var event_label_de1190 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung Termin (de)", "listeners": { "render": Lino.quicktip_renderer("Entry label (de)","(cal.EventTypes.event_label_de) ") }, "maxLength": 200, "name": "event_label_de", "selectOnFocus": true });
    var event_label_fr1191 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung Termin (fr)", "listeners": { "render": Lino.quicktip_renderer("Entry label (fr)","(cal.EventTypes.event_label_fr) ") }, "maxLength": 200, "name": "event_label_fr", "selectOnFocus": true });
    var main_2_panel1192 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": event_label1189, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": event_label_de1190, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": event_label_fr1191, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var start_date1196 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Start date","(cal.EventTypes.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var max_days1197 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Tage maximal</span>", "listeners": { "render": Lino.quicktip_renderer("Maximum days","(cal.EventTypes.max_days) The maximal number of days allowed as duration.") }, "name": "max_days", "selectOnFocus": true, "value": 1 });
    var id1198 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.EventTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var main_3_panel1199 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 56, "items": start_date1196, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": max_days1197, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": id1198, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var email_template1203 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">E-Mail-Vorlage</span>", "listeners": { "render": Lino.quicktip_renderer("Email template","(cal.EventTypes.email_template) The name of the file to be used as template when creating an email from a mailable of this type.") }, "name": "email_template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EventTypes/email_template" }) }) });
    var attach_to_email1204 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "als Anhang per E-Mail", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Attach to email","(cal.EventTypes.attach_to_email) Whether the printable file should be attached to the email\nwhen creating an email from a mailable of this type.\n") }, "name": "attach_to_email", "selectOnFocus": true });
    var main_4_panel1205 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": email_template1203, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": attach_to_email1204, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var is_appointment1208 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Termin", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Appointment","(cal.EventTypes.is_appointment) Whether entries of this type should be considered\n\"appointments\" (i.e. whose time and place have been agreed\nupon with other users or external parties).") }, "name": "is_appointment", "selectOnFocus": true });
    var all_rooms1209 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Blockiert alle R\u00e4ume", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Locks all rooms","(cal.EventTypes.all_rooms) ") }, "name": "all_rooms", "selectOnFocus": true });
    var locks_user1210 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Blockiert den Autor", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Locks the user","(cal.EventTypes.locks_user) Whether calendar entries of this type make the user\nunavailable for other locking events at the same time.") }, "name": "locks_user", "selectOnFocus": true });
    var max_conflicting1211 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Gleichzeitige Termine</span>", "listeners": { "render": Lino.quicktip_renderer("Simultaneous entries","(cal.EventTypes.max_conflicting) How many conflicting events should be tolerated.") }, "name": "max_conflicting", "selectOnFocus": true, "value": 1 });
    var main_5_panel1212 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 28, "items": is_appointment1208, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": all_rooms1209, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": locks_user1210, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": max_conflicting1211, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 189, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EntriesByType_grid1253 = new Lino.cal.EntriesByType.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(cal.cal.EntriesByType) Table which shows all calendar events.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.cal.EntriesByType.grid) ] });
    var main_panel1254 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1185, main_2_panel1192, main_3_panel1199, main_4_panel1205, main_5_panel1212, EntriesByType_grid1253 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1254;
    this.before_row_edit = function(record) {
      EntriesByType_grid1253.on_master_changed();
    }
    Lino.cal.EventTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.RecurrentEvents.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 21,
  initComponent : function() {
    var name1255 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.RecurrentEvents.name) See lino.utils.mldbc.mixins.BabelNamed.name.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de1256 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.RecurrentEvents.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr1257 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.RecurrentEvents.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel1258 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name1255, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de1256, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr1257, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var start_date1262 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Start date","(cal.RecurrentEvents.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var end_date1263 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(cal.RecurrentEvents.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var every_unit1264 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Wiederholung</span>", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(cal.RecurrentEvents.every_unit) Inherited from RecurrentSet.every_unit.") }, "name": "every_unit", "selectOnFocus": true, "store": Lino.cal.Recurrencies });
    var event_type1265 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "fieldLabel": "Kalendereintragsart", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(cal.RecurrentEvents.event_type) ") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/RecurrentEvents/event_type" }) }) });
    var main_2_panel1266 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 19, "items": start_date1262, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": end_date1263, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": every_unit1264, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": event_type1265, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel1271 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1258, main_2_panel1266 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel1271;
    this.before_row_edit = function(record) {
    }
    Lino.cal.RecurrentEvents.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.EventTypes.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 22,
  initComponent : function() {
    var name1272 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.EventTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de1273 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.EventTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr1274 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.EventTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel1275 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name1272, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de1273, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr1274, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var event_label1279 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung Termin</span>", "listeners": { "render": Lino.quicktip_renderer("Entry label","(cal.EventTypes.event_label) Default text for summary of new entries.") }, "maxLength": 200, "name": "event_label", "selectOnFocus": true });
    var event_label_de1280 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung Termin (de)", "listeners": { "render": Lino.quicktip_renderer("Entry label (de)","(cal.EventTypes.event_label_de) ") }, "maxLength": 200, "name": "event_label_de", "selectOnFocus": true });
    var event_label_fr1281 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung Termin (fr)", "listeners": { "render": Lino.quicktip_renderer("Entry label (fr)","(cal.EventTypes.event_label_fr) ") }, "maxLength": 200, "name": "event_label_fr", "selectOnFocus": true });
    var main_2_panel1282 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": event_label1279, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": event_label_de1280, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": event_label_fr1281, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel1286 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1275, main_2_panel1282 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel1286;
    this.before_row_edit = function(record) {
    }
    Lino.cal.EventTypes.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.outbox.Mails.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 72,
  initComponent : function() {
    var subject1287 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Betreff", "listeners": { "render": Lino.quicktip_renderer("Subject","(outbox.Mails.subject) ") }, "maxLength": 200, "name": "subject", "selectOnFocus": true });
    var date1288 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datum</span>", "listeners": { "render": Lino.quicktip_renderer("Date","(outbox.Mails.date) \n        The official date to be printed on the document.\n        ") }, "name": "date", "selectOnFocus": true });
    var main_1_panel1289 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 61, "items": subject1287, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": date1288, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 72, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var user1292 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Absender", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Sender","(outbox.Mails.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/Mails/user" }) }) });
    var sent1293 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "sent", "listeners": { "render": Lino.quicktip_renderer("sent","(outbox.Mails.sent) ") }, "name": "sent", "value": "<br>" });
    var id1294 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(outbox.Mails.id) ") }, "name": "id", "selectOnFocus": true });
    var owner_disp1295 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Verkn\u00fcpft mit", "name": "owner" });
    var main_2_panel1296 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": user1292, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": sent1293, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 9, "items": id1294, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": owner_disp1295, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var RecipientsByMail_grid1311 = new Lino.outbox.RecipientsByMail.GridPanel({ "containing_panel": this, "flex": 55, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Recipients","(outbox.outbox.RecipientsByMail) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.outbox.RecipientsByMail.grid) ] });
    var outbox_AttachmentsByMail_htmlbox1312 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 22, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Attachments","(outbox.Mails.outbox_AttachmentsByMail) ") }, "master_panel": this, "name": "outbox_AttachmentsByMail", "title": "Anh\u00e4nge", "tools": [ Lino.show_in_own_window_button(Lino.outbox.AttachmentsByMail.grid) ], "value": "<br/>" });
    var uploads_UploadsByController_htmlbox1313 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 22, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Uploads","(outbox.Mails.uploads_UploadsByController) Shows all Uploads") }, "master_panel": this, "name": "uploads_UploadsByController", "title": "Uploads", "tools": [ Lino.show_in_own_window_button(Lino.uploads.UploadsByController.grid) ], "value": "<br/>" });
    var main_3_panel1314 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 29, "frame": false, "hideCheckBoxLabels": true, "items": [ RecipientsByMail_grid1311, outbox_AttachmentsByMail_htmlbox1312, uploads_UploadsByController_htmlbox1313 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var body1315 = new Ext.form.HtmlEditor({ "fieldLabel": "Inhalt", "flex": 58, "listeners": { "render": Lino.quicktip_renderer("Body","(outbox.Mails.body) ") }, "name": "body", "selectOnFocus": true });
    var main_panel1316 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1289, main_2_panel1296, main_3_panel1314, body1315 ], "labelAlign": "top", "labelWidth": 45, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1316;
    this.before_row_edit = function(record) {
      RecipientsByMail_grid1311.on_master_changed();
      outbox_AttachmentsByMail_htmlbox1312.refresh();
      uploads_UploadsByController_htmlbox1313.refresh();
    }
    Lino.outbox.Mails.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Events.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 23,
  initComponent : function() {
    var start_date723 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Beginnt am","(cal.Events.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var start_time724 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(cal.Events.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var start_panel725 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 61, "items": start_date723, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": start_time724, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var end_date728 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(cal.Events.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var end_time729 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Endet um</span>", "listeners": { "render": Lino.quicktip_renderer("Endet um","(cal.Events.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.") }, "name": "end_time", "selectOnFocus": true });
    var end_panel730 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 61, "items": end_date728, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": end_time729, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_1_panel733 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ start_panel725, end_panel730 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room734 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Raum ausw\u00e4hlen...", "fieldLabel": "Raum", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Raum","(cal.Events.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/room" }) }) });
    var main_panel735 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel733, { "anchor": "-20", "autoHeight": true, "items": room734, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 45, "layout": "form" });
    this.items = main_panel735;
    this.before_row_edit = function(record) {
    }
    Lino.cal.Events.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.InvoicesByJournal.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 41,
  initComponent : function() {
    var partner1317 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(vat.InvoicesByJournal.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/partner" }) }) });
    var entry_date1318 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsdatum</span>", "listeners": { "render": Lino.quicktip_renderer("Entry date","(vat.InvoicesByJournal.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.") }, "name": "entry_date", "selectOnFocus": true });
    var total_incl1319 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total inkl. MwSt.</span>", "listeners": { "render": Lino.quicktip_renderer("Total incl. VAT","(vat.InvoicesByJournal.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.") }, "name": "total_incl", "selectOnFocus": true });
    var main_2_panel1320 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 52, "items": entry_date1318, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 48, "items": total_incl1319, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel1323 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": partner1317, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_2_panel1320 ], "labelAlign": "top", "labelWidth": 72, "layout": "form" });
    this.items = main_panel1323;
    this.before_row_edit = function(record) {
    }
    Lino.vat.InvoicesByJournal.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.notes.NoteTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 69,
  initComponent : function() {
    var id1325 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(notes.NoteTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var name1326 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(notes.NoteTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de1327 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(notes.NoteTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr1328 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(notes.NoteTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel1329 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id1325, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name1326, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de1327, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr1328, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var build_method1334 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Konstruktionsmethode", "forceSelection": true, "hiddenName": "build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Build method","(notes.NoteTypes.build_method) ") }, "name": "build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var template1335 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Vorlage", "listeners": { "render": Lino.quicktip_renderer("Template","(notes.NoteTypes.template) ") }, "name": "template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NoteTypes/template" }) }) });
    var special_type1336 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(5), "fieldLabel": "Sondernotizart", "listeners": { "render": Lino.quicktip_renderer("Special note type","(notes.NoteTypes.special_type) ") }, "maxLength": 5, "name": "special_type", "selectOnFocus": true });
    var email_template1337 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">E-Mail-Vorlage</span>", "listeners": { "render": Lino.quicktip_renderer("Email template","(notes.NoteTypes.email_template) The name of the file to be used as template when creating an email from a mailable of this type.") }, "name": "email_template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NoteTypes/email_template" }) }) });
    var attach_to_email1338 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "als Anhang per E-Mail", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Attach to email","(notes.NoteTypes.attach_to_email) Whether the printable file should be attached to the email\nwhen creating an email from a mailable of this type.\n") }, "name": "attach_to_email", "selectOnFocus": true });
    var main_2_panel1339 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 38, "items": build_method1334, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": template1335, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": special_type1336, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": email_template1337, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": attach_to_email1338, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remark1345 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkung", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remark","(notes.NoteTypes.remark) ") }, "name": "remark", "selectOnFocus": true });
    var notes_NotesByType_grid1367 = new Lino.notes.NotesByType.GridPanel({ "containing_panel": this, "flex": 41, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notes","(notes.notes.NotesByType) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByType.grid) ] });
    var main_panel1368 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1329, main_2_panel1339, { "flex": 41, "items": remark1345, "labelAlign": "top", "layout": "form", "xtype": "panel" }, notes_NotesByType_grid1367 ], "labelAlign": "top", "labelWidth": 63, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1368;
    this.before_row_edit = function(record) {
      template1335.setContextValue('build_method', record ? record.data['build_methodHidden'] : undefined);
      notes_NotesByType_grid1367.on_master_changed();
    }
    this.onRender = function(ct, position) {
      build_method1334.on('change',Lino.chooser_handler(template1335,'build_method'));
      Lino.notes.NoteTypes.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.notes.NoteTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.lists.Lists.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 14,
  initComponent : function() {
    var ref1370 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Referenz</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(lists.Lists.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var list_type1371 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Listenart ausw\u00e4hlen...", "fieldLabel": "Listenart", "hiddenName": "list_typeHidden", "listeners": { "render": Lino.quicktip_renderer("List Type","(lists.Lists.list_type) ") }, "name": "list_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/Lists/list_type" }) }) });
    var id1372 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(lists.Lists.id) ") }, "name": "id", "selectOnFocus": true });
    var main_1_panel1373 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 45, "items": ref1370, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": list_type1371, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": id1372, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var designation1377 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(lists.Lists.designation) ") }, "maxLength": 200, "name": "designation", "selectOnFocus": true });
    var designation_de1378 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(lists.Lists.designation_de) ") }, "maxLength": 200, "name": "designation_de", "selectOnFocus": true });
    var designation_fr1379 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(lists.Lists.designation_fr) ") }, "maxLength": 200, "name": "designation_fr", "selectOnFocus": true });
    var main_2_panel1380 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": designation1377, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": designation_de1378, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": designation_fr1379, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks1384 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkungen", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(lists.Lists.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var MembersByList_grid1395 = new Lino.lists.MembersByList.GridPanel({ "containing_panel": this, "flex": 41, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Members","(lists.lists.MembersByList) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.lists.MembersByList.grid) ] });
    var main_panel1396 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1373, main_2_panel1380, { "flex": 41, "items": remarks1384, "labelAlign": "top", "layout": "form", "xtype": "panel" }, MembersByList_grid1395 ], "labelAlign": "top", "labelWidth": 72, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1396;
    this.before_row_edit = function(record) {
      MembersByList_grid1395.on_master_changed();
    }
    Lino.lists.Lists.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Partners.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 10,
  initComponent : function() {
    var overview_disp1398 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Beschreibung", "listeners": { "render": Lino.quicktip_renderer("Description","(contacts.Partners.overview) ") }, "name": "overview", "value": "<br/>" });
    var email1399 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">E-Mail-Adresse</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(contacts.Partners.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var phone1400 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Telefon</span>", "listeners": { "render": Lino.quicktip_renderer("Phone","(contacts.Partners.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.") }, "maxLength": 200, "name": "phone", "selectOnFocus": true });
    var gsm1401 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">GSM</span>", "listeners": { "render": Lino.quicktip_renderer("GSM","(contacts.Partners.gsm) The primary mobile phone number.") }, "maxLength": 200, "name": "gsm", "selectOnFocus": true });
    var contact_box_panel1402 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 37, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": email1399, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": phone1400, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": gsm1401, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    var lists_MembersByPartner_grid1416 = new Lino.lists.MembersByPartner.GridPanel({ "containing_panel": this, "flex": 25, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("List memberships","(lists.lists.MembersByPartner) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.lists.MembersByPartner.grid) ] });
    var general_1_panel1417 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 37, "items": overview_disp1398, "labelAlign": "top", "layout": "form", "xtype": "panel" }, contact_box_panel1402, lists_MembersByPartner_grid1416 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks1419 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkungen", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(contacts.Partners.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var plausibility_ProblemsByOwner_htmlbox1420 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 37, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Plausibility problems","(contacts.Partners.plausibility_ProblemsByOwner) Show data problems related to this database object.") }, "master_panel": this, "name": "plausibility_ProblemsByOwner", "title": "Datenprobleme", "tools": [ Lino.show_in_own_window_button(Lino.plausibility.ProblemsByOwner.grid) ], "value": "<br/>" });
    var bottom_box_1_panel1421 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 62, "items": remarks1419, "labelAlign": "top", "layout": "form", "xtype": "panel" }, plausibility_ProblemsByOwner_htmlbox1420 ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var general_panel1423 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel1417, bottom_box_1_panel1421 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var name1424 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Name</span>", "listeners": { "render": Lino.quicktip_renderer("Name","(contacts.Partners.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var street1425 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Street","(contacts.Partners.street) ") }, "maxLength": 200, "name": "street", "selectOnFocus": true });
    var street_box1426 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Box", "listeners": { "render": Lino.quicktip_renderer("Box","(contacts.Partners.street_box) ") }, "maxLength": 10, "name": "street_box", "selectOnFocus": true });
    var address_box_2_panel1427 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 69, "items": street1425, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": street_box1426, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr21430 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresszeile nach Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Address line after street","(contacts.Partners.addr2) ") }, "maxLength": 200, "name": "addr2", "selectOnFocus": true });
    var country1431 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Land ausw\u00e4hlen...", "fieldLabel": "Land", "hiddenName": "countryHidden", "listeners": { "render": Lino.quicktip_renderer("Country","(contacts.Partners.country) ") }, "name": "country", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Countries.detail,Lino.countries.Countries.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/country" }) }) });
    var zip_code1432 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Postleitzahl", "listeners": { "render": Lino.quicktip_renderer("Zip code","(contacts.Partners.zip_code) ") }, "maxLength": 10, "name": "zip_code", "selectOnFocus": true });
    var city1433 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Ort ausw\u00e4hlen...", "fieldLabel": "Locality", "forceSelection": false, "hiddenName": "cityHidden", "listeners": { "render": Lino.quicktip_renderer("Locality","(contacts.Partners.city) ") }, "name": "city", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Places.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/city" }) }) });
    var address_box_4_panel1434 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": country1431, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": zip_code1432, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": city1433, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_panel1438 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": name1424, "labelAlign": "top", "layout": "form", "xtype": "panel" }, address_box_2_panel1427, { "anchor": "-20", "autoHeight": true, "items": addr21430, "labelAlign": "top", "layout": "form", "xtype": "panel" }, address_box_4_panel1434 ], "labelAlign": "top", "labelWidth": 234, "layout": "form" });
    var sepa_AccountsByPartner_grid1460 = new Lino.sepa.AccountsByPartner.GridPanel({ "containing_panel": this, "flex": 55, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(sepa.sepa.AccountsByPartner) Show the bank account(s) defined for a given partner. To be\nincluded to a detail window on partner.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sepa.AccountsByPartner.grid) ] });
    var address_panel1461 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_panel1438, sepa_AccountsByPartner_grid1460 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Adresse" });
    var id1462 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(contacts.Partners.id) ") }, "name": "id", "selectOnFocus": true });
    var language1463 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Sprache</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(contacts.Partners.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var more_1_panel1464 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 20, "items": id1462, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 80, "items": language1463, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr11467 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresszeile vor Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Address line before street","(contacts.Partners.addr1) ") }, "maxLength": 200, "name": "addr1", "selectOnFocus": true });
    var url1468 = new Lino.URLField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresse (URL)", "listeners": { "render": Lino.quicktip_renderer("URL","(contacts.Partners.url) ") }, "maxLength": 200, "name": "url", "selectOnFocus": true });
    var more_2_panel1469 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": addr11467, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": url1468, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 243, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var changes_ChangesByMaster_grid1504 = new Lino.changes.ChangesByMaster.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Changes","(changes.changes.ChangesByMaster) Slave Table showing the changes related to the current object,\nincluding those applied to \"child\" objects.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.changes.ChangesByMaster.grid) ] });
    var excerpts_ExcerptsByOwner_htmlbox1505 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Existing excerpts","(contacts.Partners.excerpts_ExcerptsByOwner) History of excerpts based on this data record.") }, "master_panel": this, "name": "excerpts_ExcerptsByOwner", "title": "Bestehende Ausz\u00fcge", "tools": [ Lino.show_in_own_window_button(Lino.excerpts.ExcerptsByOwner.grid) ], "value": "<br/>" });
    var cal_GuestsByPartner_htmlbox1506 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Presences","(contacts.Partners.cal_GuestsByPartner) The default table for Guest.") }, "master_panel": this, "name": "cal_GuestsByPartner", "title": "Anwesenheiten", "tools": [ Lino.show_in_own_window_button(Lino.cal.GuestsByPartner.grid) ], "value": "<br/>" });
    var more_5_panel1507 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 30, "frame": false, "hideCheckBoxLabels": true, "items": [ excerpts_ExcerptsByOwner_htmlbox1505, cal_GuestsByPartner_htmlbox1506 ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var more_panel1508 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel1464, more_2_panel1469, changes_ChangesByMaster_grid1504, more_5_panel1507 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var invoice_recipient1509 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Fakturationsadresse</span>", "hiddenName": "invoice_recipientHidden", "listeners": { "render": Lino.quicktip_renderer("Invoicing address","(contacts.Partners.invoice_recipient) Redirect to another partner all invoices which should go to this partner.") }, "name": "invoice_recipient", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/invoice_recipient" }) }) });
    var vat_regime1510 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "MwSt.-Regime", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(contacts.Partners.vat_regime) ") }, "name": "vat_regime", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var ledger_a_1_panel1511 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 52, "items": invoice_recipient1509, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 47, "items": vat_regime1510, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var payment_term1514 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zahlungsbedingung</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(contacts.Partners.payment_term) The default payment term for sales invoices to this customer.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/payment_term" }) }) });
    var paper_type1515 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Papierart ausw\u00e4hlen...", "fieldLabel": "Papierart", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(contacts.Partners.paper_type) ") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/paper_type" }) }) });
    var ledger_a_2_panel1516 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": payment_term1514, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": paper_type1515, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ledger_a_panel1519 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 57, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_a_1_panel1511, ledger_a_2_panel1516 ], "labelAlign": "top", "layout": "form" });
    var ledger_MovementsByPartner_htmlbox1520 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 42, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(contacts.Partners.ledger_MovementsByPartner) ") }, "master_panel": this, "name": "ledger_MovementsByPartner", "title": "Bewegungen", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByPartner.grid) ], "value": "<br/>" });
    var ledger_1_panel1521 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ ledger_a_panel1519, ledger_MovementsByPartner_htmlbox1520 ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var sales_InvoicesByPartner_grid1681 = new Lino.sales.InvoicesByPartner.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Product invoices","(sales.sales.InvoicesByPartner) Base class for tables of partner vouchers.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sales.InvoicesByPartner.grid) ] });
    var ledger_panel1682 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel1521, sales_InvoicesByPartner_grid1681 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Buchhaltung" });
    var main_panel1683 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel1423, address_panel1461, more_panel1508, ledger_panel1682 ], "labelAlign": "top", "split": true });
    this.items = main_panel1683;
    this.before_row_edit = function(record) {
      lists_MembersByPartner_grid1416.on_master_changed();
      plausibility_ProblemsByOwner_htmlbox1420.refresh();
      city1433.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city1433.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      sepa_AccountsByPartner_grid1460.on_master_changed();
      changes_ChangesByMaster_grid1504.on_master_changed();
      excerpts_ExcerptsByOwner_htmlbox1505.refresh();
      cal_GuestsByPartner_htmlbox1506.refresh();
      ledger_MovementsByPartner_htmlbox1520.refresh();
      sales_InvoicesByPartner_grid1681.on_master_changed();
    }
    this.onRender = function(ct, position) {
      country1431.on('change',Lino.chooser_handler(city1433,'country'));
      Lino.contacts.Partners.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.contacts.Partners.DetailFormPanel.superclass.initComponent.call(this);
    // active_fields:
    city1433.on("change", function(){ this.save() }, this);
    zip_code1432.on("change", function(){ this.save() }, this);
  }
});


Lino.cal.Rooms.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 20,
  initComponent : function() {
    var id1684 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.Rooms.id) ") }, "name": "id", "selectOnFocus": true });
    var name1685 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.Rooms.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de1686 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.Rooms.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr1687 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.Rooms.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel1688 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id1684, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name1685, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de1686, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr1687, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var company1693 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Organisation ausw\u00e4hlen...", "fieldLabel": "Verantwortlicher", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible","(cal.Rooms.company) ") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/company" }) }) });
    var contact_person1694 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Person ausw\u00e4hlen...", "fieldLabel": "Kontaktperson", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Contact person","(cal.Rooms.contact_person) ") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/contact_person" }) }) });
    var main_panel1695 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1688, { "anchor": "-20", "autoHeight": true, "items": company1693, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": contact_person1694, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    this.items = main_panel1695;
    this.before_row_edit = function(record) {
      contact_person1694.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      company1693.on('change',Lino.chooser_handler(contact_person1694,'company'));
      Lino.cal.Rooms.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.cal.Rooms.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.PupilTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 50,
  initComponent : function() {
    var id1698 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.PupilTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var name1699 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.PupilTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de1700 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(courses.PupilTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr1701 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(courses.PupilTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel1702 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id1698, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name1699, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de1700, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr1701, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_PupilsByType_grid1981 = new Lino.courses.PupilsByType.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Participants","(courses.courses.PupilsByType) The global list of all pupils.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.courses.PupilsByType.grid) ] });
    var main_panel1982 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1702, courses_PupilsByType_grid1981 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1982;
    this.before_row_edit = function(record) {
      courses_PupilsByType_grid1981.on_master_changed();
    }
    Lino.courses.PupilTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Persons.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 8,
  initComponent : function() {
    var first_name1983 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Vorname</span>", "listeners": { "render": Lino.quicktip_renderer("First name","(contacts.Persons.first_name) The first name, also known as given name.") }, "maxLength": 200, "name": "first_name", "selectOnFocus": true });
    var last_name1984 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Familienname</span>", "listeners": { "render": Lino.quicktip_renderer("Last name","(contacts.Persons.last_name) The last name, also known as family name.") }, "maxLength": 200, "name": "last_name", "selectOnFocus": true });
    var main_1_panel1985 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": first_name1983, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": last_name1984, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var gender1988 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Geschlecht</span>", "forceSelection": true, "hiddenName": "genderHidden", "listeners": { "render": Lino.quicktip_renderer("Gender","(contacts.Persons.gender) The sex of this person (male or female).") }, "name": "gender", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var email1989 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">E-Mail-Adresse</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(contacts.Persons.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var main_2_panel1990 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": gender1988, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 70, "items": email1989, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel1993 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1985, main_2_panel1990 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel1993;
    this.before_row_edit = function(record) {
    }
    Lino.contacts.Persons.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.products.ProductCats.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 30,
  initComponent : function() {
    var id1994 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(products.ProductCats.id) ") }, "name": "id", "selectOnFocus": true });
    var name1995 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(products.ProductCats.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de1996 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(products.ProductCats.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr1997 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(products.ProductCats.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel1998 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id1994, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name1995, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de1996, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr1997, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" }, "region": "north", "split": true });
    var description2003 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "description", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("description","(products.ProductCats.description) ") }, "name": "description", "selectOnFocus": true });
    var ProductsByCategory_grid2106 = new Lino.products.ProductsByCategory.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Tariffs","(products.products.ProductsByCategory) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "south", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.products.ProductsByCategory.grid) ] });
    var main_panel2107 = new Lino.VBorderPanel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1998, { "flex": 5, "items": description2003, "labelAlign": "top", "layout": "form", "region": "center", "split": true, "xtype": "panel" }, ProductsByCategory_grid2106 ], "labelAlign": "top", "labelWidth": 108 });
    this.items = main_panel2107;
    this.before_row_edit = function(record) {
      ProductsByCategory_grid2106.on_master_changed();
    }
    Lino.products.ProductCats.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Rooms.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 20,
  initComponent : function() {
    var id2109 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.Rooms.id) ") }, "name": "id", "selectOnFocus": true });
    var name2110 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.Rooms.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2111 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.Rooms.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2112 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.Rooms.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var calendar2113 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kalender ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kalender</span>", "hiddenName": "calendarHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar","(cal.Rooms.calendar) Calendar where events in this room are published.") }, "name": "calendar", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.Calendars.detail,Lino.cal.Calendars.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/calendar" }) }) });
    var main_1_panel2114 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 5, "items": id2109, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": name2110, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": name_de2111, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": name_fr2112, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": calendar2113, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var fee2120 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarif ausw\u00e4hlen...", "fieldLabel": "Tarif", "hiddenName": "feeHidden", "listeners": { "render": Lino.quicktip_renderer("Tariff","(cal.Rooms.fee) ") }, "name": "fee", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/fee" }) }) });
    var company2121 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Organisation ausw\u00e4hlen...", "fieldLabel": "Verantwortlicher", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible","(cal.Rooms.company) ") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/company" }) }) });
    var contact_person2122 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Person ausw\u00e4hlen...", "fieldLabel": "Kontaktperson", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Contact person","(cal.Rooms.contact_person) ") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/contact_person" }) }) });
    var contact_role2123 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Funktion ausw\u00e4hlen...", "fieldLabel": "in seiner Eigenschaft als", "hiddenName": "contact_roleHidden", "listeners": { "render": Lino.quicktip_renderer("represented as","(cal.Rooms.contact_role) ") }, "name": "contact_role", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/contact_role" }) }) });
    var main_2_panel2124 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 25, "items": fee2120, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": company2121, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": contact_person2122, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": contact_role2123, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var cal_EntriesByRoom_grid2165 = new Lino.cal.EntriesByRoom.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(cal.cal.EntriesByRoom) Displays the Events at a given Room.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.cal.EntriesByRoom.grid) ] });
    var main_panel2166 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2114, main_2_panel2124, cal_EntriesByRoom_grid2165 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2166;
    this.before_row_edit = function(record) {
      contact_person2122.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      cal_EntriesByRoom_grid2165.on_master_changed();
    }
    this.onRender = function(ct, position) {
      company2121.on('change',Lino.chooser_handler(contact_person2122,'company'));
      Lino.cal.Rooms.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.cal.Rooms.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Hikes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 52,
  initComponent : function() {
    var ref2167 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Referenz</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(courses.Hikes.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.") }, "maxLength": 40, "name": "ref", "preferred_with": 6, "selectOnFocus": true });
    var line2168 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Aktivit\u00e4tenreihe</span>", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Activity line","(courses.Hikes.line) Pointer to the course series.") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/line" }) }) });
    var teacher2169 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kursleiter ausw\u00e4hlen...", "fieldLabel": "Kursleiter", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor","(courses.Hikes.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/teacher" }) }) });
    var workflow_buttons_disp2170 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(courses.Hikes.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_1_panel2171 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 23, "items": ref2167, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": line2168, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": teacher2169, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": workflow_buttons_disp2170, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room2176 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Raum ausw\u00e4hlen...", "fieldLabel": "Raum", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(courses.Hikes.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/room" }) }) });
    var start_date2177 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Start date","(courses.Hikes.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var end_date2178 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(courses.Hikes.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var start_time2179 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(courses.Hikes.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time2180 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Endet um", "listeners": { "render": Lino.quicktip_renderer("End Time","(courses.Hikes.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var general_2_panel2181 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 32, "items": room2176, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": start_date2177, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": end_date2178, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": start_time2179, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": end_time2180, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name2187 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Hikes.name) A short designation for this course. An extension of the\nref.") }, "maxLength": 100, "name": "name", "selectOnFocus": true });
    var remark2188 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkung", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.Hikes.remark) ") }, "name": "remark", "selectOnFocus": true });
    var general_panel2189 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel2171, general_2_panel2181, { "autoHeight": true, "items": name2187, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 50, "items": remark2188, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var every_unit2192 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Wiederholung", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(courses.Hikes.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every2193 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "... alle", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(courses.Hikes.every) ") }, "name": "every", "selectOnFocus": true });
    var max_date2194 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Termine generieren bis", "listeners": { "render": Lino.quicktip_renderer("Generate events until","(courses.Hikes.max_date) ") }, "name": "max_date", "selectOnFocus": true });
    var max_events2195 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Anzahl Termine", "listeners": { "render": Lino.quicktip_renderer("Number of events","(courses.Hikes.max_events) ") }, "name": "max_events", "selectOnFocus": true });
    var events_1_panel2196 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 47, "items": every_unit2192, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": every2193, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": max_date2194, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": max_events2195, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var monday2201 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Montag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Monday","(courses.Hikes.monday) ") }, "name": "monday", "selectOnFocus": true });
    var tuesday2202 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Dienstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Tuesday","(courses.Hikes.tuesday) ") }, "name": "tuesday", "selectOnFocus": true });
    var wednesday2203 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Mittwoch", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wednesday","(courses.Hikes.wednesday) ") }, "name": "wednesday", "selectOnFocus": true });
    var thursday2204 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Donnerstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Thursday","(courses.Hikes.thursday) ") }, "name": "thursday", "selectOnFocus": true });
    var friday2205 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Freitag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Friday","(courses.Hikes.friday) ") }, "name": "friday", "selectOnFocus": true });
    var saturday2206 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Samstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Saturday","(courses.Hikes.saturday) ") }, "name": "saturday", "selectOnFocus": true });
    var sunday2207 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Sonntag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Sunday","(courses.Hikes.sunday) ") }, "name": "sunday", "selectOnFocus": true });
    var events_2_panel2208 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": monday2201, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": tuesday2202, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": wednesday2203, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": thursday2204, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": friday2205, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": saturday2206, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": sunday2207, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_EntriesByCourse_htmlbox2216 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 60, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(courses.Hikes.courses_EntriesByCourse) Shows the events linked to this course.") }, "master_panel": this, "name": "courses_EntriesByCourse", "title": "Kalendereintr\u00e4ge", "tools": [ Lino.show_in_own_window_button(Lino.courses.EntriesByCourse.grid) ], "value": "<br/>" });
    var events_panel2217 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ events_1_panel2196, events_2_panel2208, courses_EntriesByCourse_htmlbox2216 ], "labelAlign": "top", "labelWidth": 153, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Veranstaltungen" });
    var enrolments_until2218 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Einschreibung m\u00f6glich bis", "listeners": { "render": Lino.quicktip_renderer("Enrolments until","(courses.Hikes.enrolments_until) ") }, "name": "enrolments_until", "selectOnFocus": true });
    var fee2219 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarif ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Standard-Teilnehmahmegeb\u00fchr</span>", "hiddenName": "feeHidden", "listeners": { "render": Lino.quicktip_renderer("Default participation fee","(courses.Hikes.fee) The default participation fee to apply for new enrolments.") }, "name": "fee", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/fee" }) }) });
    var max_places2220 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Verf\u00fcgbare Pl\u00e4tze</span>", "listeners": { "render": Lino.quicktip_renderer("Available places","(courses.Hikes.max_places) Maximum number of participants") }, "name": "max_places", "selectOnFocus": true });
    var confirmed2221 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Best\u00e4tigt", "listeners": { "render": Lino.quicktip_renderer("Confirmed","(courses.Hikes.confirmed) ") }, "name": "confirmed" });
    var free_places2222 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Freie Pl\u00e4tze", "listeners": { "render": Lino.quicktip_renderer("Free places","(courses.Hikes.free_places) ") }, "name": "free_places" });
    var print_actions_disp2223 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Drucken", "listeners": { "render": Lino.quicktip_renderer("Print","(courses.Hikes.print_actions) ") }, "name": "print_actions", "value": "<br/>" });
    var enrolments_top_panel2224 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 19, "items": enrolments_until2218, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": fee2219, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": max_places2220, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": confirmed2221, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": free_places2222, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": print_actions_disp2223, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 234, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EnrolmentsByHike_htmlbox2231 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Enrolments","(courses.Hikes.EnrolmentsByHike) The Voga version of EnrolmentsByCourse.") }, "ls_bbar_actions": [ { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" } ], "ls_insert_handler": Lino.courses.EnrolmentsByHike.insert, "master_panel": this, "name": "EnrolmentsByHike", "title": "Einschreibungen", "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByHike.grid) ], "value": "<br/>" });
    var enrolments_panel2232 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ enrolments_top_panel2224, EnrolmentsByHike_htmlbox2231 ], "labelAlign": "top", "labelWidth": 99, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Einschreibungen" });
    var state2233 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(courses.Hikes.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".") }, "name": "state", "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var user2234 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.Hikes.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/user" }) }) });
    var payment_term2235 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zahlungsbedingung</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(courses.Hikes.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/payment_term" }) }) });
    var paper_type2236 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Papierart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Papierart</span>", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(courses.Hikes.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/paper_type" }) }) });
    var id2237 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Hikes.id) ") }, "name": "id", "selectOnFocus": true });
    var more_1_panel2238 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": state2233, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": user2234, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": payment_term2235, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": paper_type2236, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": id2237, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var invoicing_InvoicingsByInvoiceable_grid2244 = new Lino.invoicing.InvoicingsByInvoiceable.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Invoicings","(invoicing.invoicing.InvoicingsByInvoiceable) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.invoicing.InvoicingsByInvoiceable.grid) ] });
    var more_panel2245 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel2238, invoicing_InvoicingsByInvoiceable_grid2244 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var main_panel2246 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel2189, events_panel2217, enrolments_panel2232, more_panel2245 ], "labelAlign": "top", "split": true });
    this.items = main_panel2246;
    this.before_row_edit = function(record) {
      courses_EntriesByCourse_htmlbox2216.refresh();
      fee2219.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      EnrolmentsByHike_htmlbox2231.refresh();
      invoicing_InvoicingsByInvoiceable_grid2244.on_master_changed();
    }
    this.onRender = function(ct, position) {
      line2168.on('change',Lino.chooser_handler(fee2219,'line'));
      Lino.courses.Hikes.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Hikes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.accounts.Groups.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 34,
  initComponent : function() {
    var ref2247 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ref", "listeners": { "render": Lino.quicktip_renderer("ref","(accounts.Groups.ref) ") }, "maxLength": 20, "name": "ref", "selectOnFocus": true });
    var name2248 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(accounts.Groups.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2249 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(accounts.Groups.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2250 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(accounts.Groups.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel2251 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 25, "items": ref2247, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name2248, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_de2249, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_fr2250, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var account_type2256 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Kontenart", "forceSelection": true, "hiddenName": "account_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Account Type","(accounts.Groups.account_type) ") }, "name": "account_type", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.accounts.AccountTypes) });
    var id2257 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(accounts.Groups.id) ") }, "name": "id", "selectOnFocus": true });
    var main_2_panel2258 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 76, "items": account_type2256, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": id2257, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var AccountsByGroup_grid2323 = new Lino.accounts.AccountsByGroup.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Accounts","(accounts.accounts.AccountsByGroup) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.accounts.AccountsByGroup.grid) ] });
    var main_panel2324 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2251, main_2_panel2258, AccountsByGroup_grid2323 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2324;
    this.before_row_edit = function(record) {
      AccountsByGroup_grid2323.on_master_changed();
    }
    Lino.accounts.Groups.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.rooms.Bookings.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 32,
  initComponent : function() {
    var start_date2325 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Start date","(rooms.Bookings.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var start_time2326 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(rooms.Bookings.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_date2327 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(rooms.Bookings.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var end_time2328 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Endet um", "listeners": { "render": Lino.quicktip_renderer("End Time","(rooms.Bookings.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var general_1_panel2329 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": start_date2325, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": start_time2326, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": end_date2327, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": end_time2328, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room2334 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Raum ausw\u00e4hlen...", "fieldLabel": "Raum", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(rooms.Bookings.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/room" }) }) });
    var event_type2335 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kalendereintragsart</span>", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(rooms.Bookings.event_type) The Event Type to which events will be generated.") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/event_type" }) }) });
    var workflow_buttons_disp2336 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(rooms.Bookings.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_2_panel2337 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 28, "items": room2334, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": event_type2335, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 42, "items": workflow_buttons_disp2336, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var max_events2341 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Anzahl Termine", "listeners": { "render": Lino.quicktip_renderer("Number of events","(rooms.Bookings.max_events) ") }, "name": "max_events", "selectOnFocus": true });
    var max_date2342 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Termine generieren bis", "listeners": { "render": Lino.quicktip_renderer("Generate events until","(rooms.Bookings.max_date) ") }, "name": "max_date", "selectOnFocus": true });
    var every_unit2343 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Wiederholung", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(rooms.Bookings.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every2344 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "... alle", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(rooms.Bookings.every) ") }, "name": "every", "selectOnFocus": true, "value": 1 });
    var general_3_panel2345 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 11, "items": max_events2341, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": max_date2342, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 47, "items": every_unit2343, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": every2344, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var monday2350 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Montag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Monday","(rooms.Bookings.monday) ") }, "name": "monday", "selectOnFocus": true });
    var tuesday2351 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Dienstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Tuesday","(rooms.Bookings.tuesday) ") }, "name": "tuesday", "selectOnFocus": true });
    var wednesday2352 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Mittwoch", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wednesday","(rooms.Bookings.wednesday) ") }, "name": "wednesday", "selectOnFocus": true });
    var thursday2353 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Donnerstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Thursday","(rooms.Bookings.thursday) ") }, "name": "thursday", "selectOnFocus": true });
    var friday2354 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Freitag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Friday","(rooms.Bookings.friday) ") }, "name": "friday", "selectOnFocus": true });
    var saturday2355 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Samstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Saturday","(rooms.Bookings.saturday) ") }, "name": "saturday", "selectOnFocus": true });
    var sunday2356 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Sonntag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Sunday","(rooms.Bookings.sunday) ") }, "name": "sunday", "selectOnFocus": true });
    var general_4_panel2357 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": monday2350, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": tuesday2351, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": wednesday2352, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": thursday2353, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": friday2354, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": saturday2355, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": sunday2356, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var company2365 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Organisation ausw\u00e4hlen...", "fieldLabel": "Veranstalter", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Organizer","(rooms.Bookings.company) ") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/company" }) }) });
    var contact_person2366 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Person ausw\u00e4hlen...", "fieldLabel": "Kontaktperson", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Contact person","(rooms.Bookings.contact_person) ") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/contact_person" }) }) });
    var user2367 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(rooms.Bookings.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/user" }) }) });
    var id2368 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(rooms.Bookings.id) ") }, "name": "id", "selectOnFocus": true });
    var general_5_panel2369 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 29, "items": company2365, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": contact_person2366, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": user2367, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": id2368, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var cal_EntriesByController_htmlbox2374 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 30, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(rooms.Bookings.cal_EntriesByController) Shows the events linked to this database object.") }, "master_panel": this, "name": "cal_EntriesByController", "title": "Kalendereintr\u00e4ge", "tools": [ Lino.show_in_own_window_button(Lino.cal.EntriesByController.grid) ], "value": "<br/>" });
    var general_panel2375 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel2329, general_2_panel2337, general_3_panel2345, general_4_panel2357, general_5_panel2369, cal_EntriesByController_htmlbox2374 ], "labelAlign": "top", "labelWidth": 153, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var invoicing_InvoicingsByInvoiceable_grid2376 = new Lino.invoicing.InvoicingsByInvoiceable.GridPanel({ "containing_panel": this, "hide_top_toolbar": true, "listeners": { "activate": Lino.on_tab_activate }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "title": "Fakturierungen", "tools": [ Lino.show_in_own_window_button(Lino.invoicing.InvoicingsByInvoiceable.grid) ] });
    var main_panel2377 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel2375, invoicing_InvoicingsByInvoiceable_grid2376 ], "labelAlign": "top", "split": true });
    this.items = main_panel2377;
    this.before_row_edit = function(record) {
      contact_person2366.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      cal_EntriesByController_htmlbox2374.refresh();
      invoicing_InvoicingsByInvoiceable_grid2376.on_master_changed();
    }
    this.onRender = function(ct, position) {
      company2365.on('change',Lino.chooser_handler(contact_person2366,'company'));
      Lino.rooms.Bookings.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.rooms.Bookings.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.uploads.Uploads.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 71,
  initComponent : function() {
    var file2378 = Lino.file_field_handler(this,{ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datei</span>", "listeners": { "render": Lino.quicktip_renderer("File","(uploads.Uploads.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file") }, "maxLength": 100, "name": "file", "selectOnFocus": true });
    var user2379 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Hochgeladen durch", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Uploaded by","(uploads.Uploads.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/user" }) }) });
    var main_1_panel2380 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 51, "items": file2378, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 48, "items": user2379, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var upload_area2383 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Upload-Bereich", "forceSelection": true, "hiddenName": "upload_areaHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Area","(uploads.Uploads.upload_area) ") }, "name": "upload_area", "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var type2384 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Upload-Art ausw\u00e4hlen...", "fieldLabel": "Upload-Art", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Type","(uploads.Uploads.type) ") }, "name": "type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.uploads.UploadTypes.detail,Lino.uploads.UploadTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/type" }) }) });
    var description2385 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Beschreibung</span>", "listeners": { "render": Lino.quicktip_renderer("Description","(uploads.Uploads.description) A short description entered manually by the user.") }, "maxLength": 200, "name": "description", "selectOnFocus": true });
    var main_2_panel2386 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 19, "items": upload_area2383, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 39, "items": type2384, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 41, "items": description2385, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var owner_disp2390 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Verkn\u00fcpft mit", "name": "owner" });
    var main_panel2391 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2380, main_2_panel2386, { "anchor": "-20", "autoHeight": true, "items": owner_disp2390, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "form" });
    this.items = main_panel2391;
    this.before_row_edit = function(record) {
      type2384.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      upload_area2383.on('change',Lino.chooser_handler(type2384,'upload_area'));
      Lino.uploads.Uploads.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.uploads.Uploads.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.users.Users.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 2,
  initComponent : function() {
    var username1132 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Benutzername</span>", "listeners": { "render": Lino.quicktip_renderer("Benutzername","(users.Users.username) Must be unique and cannot be empty.") }, "maxLength": 30, "name": "username", "selectOnFocus": true });
    var email1133 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "E-Mail-Adresse", "listeners": { "render": Lino.quicktip_renderer("E-Mail-Adresse","(users.Users.email) ") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var main_1_panel1134 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": username1132, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": email1133, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var first_name1137 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Vorname", "listeners": { "render": Lino.quicktip_renderer("Vorname","(users.Users.first_name) ") }, "maxLength": 30, "name": "first_name", "selectOnFocus": true });
    var last_name1138 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Familienname", "listeners": { "render": Lino.quicktip_renderer("Familienname","(users.Users.last_name) ") }, "maxLength": 30, "name": "last_name", "selectOnFocus": true });
    var main_2_panel1139 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": first_name1137, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": last_name1138, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var partner1142 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Partner</span>", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(users.Users.partner) Pointer to the Partner instance related to\nthis user.") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/Users/partner" }) }) });
    var language1143 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Sprache", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Sprache","(users.Users.language) ") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var user_type1144 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Benutzerart</span>", "forceSelection": true, "hiddenName": "user_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Benutzerart","(users.Users.user_type) The user_type of a user is what defines her or his permissions.") }, "name": "user_type", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.users.UserTypes) });
    var main_4_panel1145 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 47, "items": language1143, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 52, "items": user_type1144, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel1148 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1134, main_2_panel1139, { "anchor": "-20", "autoHeight": true, "items": partner1142, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_4_panel1145 ], "labelAlign": "top", "labelWidth": 72, "layout": "form" });
    this.items = main_panel1148;
    this.before_row_edit = function(record) {
    }
    Lino.users.Users.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.products.Products.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 31,
  initComponent : function() {
    var cat2096 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarifkategorie ausw\u00e4hlen...", "fieldLabel": "Kategorie", "hiddenName": "catHidden", "listeners": { "render": Lino.quicktip_renderer("Category","(products.Products.cat) ") }, "name": "cat", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.ProductCats.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/Products/cat" }) }) });
    var name2097 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(products.Products.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2098 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(products.Products.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2099 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(products.Products.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel2100 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2097, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2098, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2099, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2104 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": cat2096, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_2_panel2100 ], "labelAlign": "top", "labelWidth": 81, "layout": "form" });
    this.items = main_panel2104;
    this.before_row_edit = function(record) {
    }
    Lino.products.Products.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Activities.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 52,
  initComponent : function() {
    var line994 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Aktivit\u00e4tenreihe</span>", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Aktivit\u00e4tenreihe","(courses.Activities.line) Pointer to the course series.") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/line" }) }) });
    var teacher995 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kursleiter ausw\u00e4hlen...", "fieldLabel": "Kursleiter", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Kursleiter","(courses.Activities.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/teacher" }) }) });
    var main_1_panel996 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": line994, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": teacher995, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name999 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung</span>", "listeners": { "render": Lino.quicktip_renderer("Bezeichnung","(courses.Activities.name) A short designation for this course. An extension of the\nref.") }, "maxLength": 100, "name": "name", "selectOnFocus": true });
    var start_date1000 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Beginnt am","(courses.Activities.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var main_2_panel1001 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 61, "items": name999, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": start_date1000, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel1004 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel996, main_2_panel1001 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel1004;
    this.before_row_edit = function(record) {
    }
    Lino.courses.Activities.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.countries.Countries.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 4,
  initComponent : function() {
    var isocode2393 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(4), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">ISO-Code</span>", "listeners": { "render": Lino.quicktip_renderer("ISO code","(countries.Countries.isocode)         The two-letter code for this country as defined by ISO 3166-1.\n        For countries that no longer exist it may be a 4-letter code.") }, "maxLength": 4, "name": "isocode", "selectOnFocus": true });
    var name2394 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(countries.Countries.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2395 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(countries.Countries.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2396 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(countries.Countries.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var short_code2397 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(4), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Short code</span>", "listeners": { "render": Lino.quicktip_renderer("Short code","(countries.Countries.short_code) A short abbreviation for regional usage. Obsolete.") }, "maxLength": 4, "name": "short_code", "selectOnFocus": true });
    var main_1_panel2398 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 12, "items": isocode2393, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name2394, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_de2395, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_fr2396, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": short_code2397, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var countries_PlacesByCountry_grid2472 = new Lino.countries.PlacesByCountry.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Places","(countries.countries.PlacesByCountry) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.countries.PlacesByCountry.grid) ] });
    var main_panel2473 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2398, countries_PlacesByCountry_grid2472 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2473;
    this.before_row_edit = function(record) {
      countries_PlacesByCountry_grid2472.on_master_changed();
    }
    Lino.countries.Countries.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.sales.Invoices.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 45,
  initComponent : function() {
    var entry_date1554 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsdatum</span>", "listeners": { "render": Lino.quicktip_renderer("Entry date","(sales.Invoices.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.") }, "name": "entry_date", "selectOnFocus": true });
    var partner1555 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(sales.Invoices.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/partner" }) }) });
    var vat_regime1556 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "MwSt.-Regime", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(sales.Invoices.vat_regime) ") }, "name": "vat_regime", "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var invoice_header_1_panel1557 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 25, "items": entry_date1554, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 39, "items": partner1555, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 35, "items": vat_regime1556, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var subject1561 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Betreff", "listeners": { "render": Lino.quicktip_renderer("Subject line","(sales.Invoices.subject) ") }, "maxLength": 200, "name": "subject", "selectOnFocus": true });
    var your_ref1562 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Ihr Zeichen", "listeners": { "render": Lino.quicktip_renderer("Your reference","(sales.Invoices.your_ref) ") }, "maxLength": 200, "name": "your_ref", "selectOnFocus": true });
    var match1563 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Match</span>", "listeners": { "render": Lino.quicktip_renderer("Match","(sales.Invoices.match) The movement to be matched.") }, "name": "match", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/match" }) }) });
    var invoice_header_2_panel1564 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": subject1561, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": your_ref1562, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": match1563, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var payment_term1568 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zahlungsbedingung</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(sales.Invoices.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/payment_term" }) }) });
    var due_date1569 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zahlungsziel", "listeners": { "render": Lino.quicktip_renderer("Due date","(sales.Invoices.due_date) ") }, "name": "due_date", "selectOnFocus": true });
    var paper_type1570 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Papierart ausw\u00e4hlen...", "fieldLabel": "Papierart", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(sales.Invoices.paper_type) ") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/paper_type" }) }) });
    var printed_disp1571 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Ausgedruckt", "listeners": { "render": Lino.quicktip_renderer("Printed","(sales.Invoices.printed) ") }, "name": "printed", "value": "<br/>" });
    var invoice_header_3_panel1572 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 22, "items": payment_term1568, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": due_date1569, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": paper_type1570, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": printed_disp1571, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var invoice_header_panel1577 = new Ext.form.FieldSet({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 75, "frame": true, "hideCheckBoxLabels": true, "items": [ invoice_header_1_panel1557, invoice_header_2_panel1564, invoice_header_3_panel1572 ], "labelAlign": "top", "layout": "form", "title": "Kopfdaten" });
    var total_incl1578 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total inkl. MwSt.</span>", "listeners": { "render": Lino.quicktip_renderer("Total incl. VAT","(sales.Invoices.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.") }, "name": "total_incl", "selectOnFocus": true });
    var balance_before1579 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "fieldLabel": "Saldo vorher", "listeners": { "render": Lino.quicktip_renderer("Balance before","(sales.Invoices.balance_before) ") }, "name": "balance_before" });
    var balance_to_pay1580 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "fieldLabel": "Saldo zu zahlen", "listeners": { "render": Lino.quicktip_renderer("Balance to pay","(sales.Invoices.balance_to_pay) ") }, "name": "balance_to_pay" });
    var workflow_buttons_disp1581 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(sales.Invoices.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var totals_panel1582 = new Ext.form.FieldSet({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 25, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": total_incl1578, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": balance_before1579, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": balance_to_pay1580, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": workflow_buttons_disp1581, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "form", "title": "Summen" });
    var general_1_panel1587 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ invoice_header_panel1577, totals_panel1582 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ItemsByInvoice_grid1649 = new Lino.sales.ItemsByInvoice.GridPanel({ "containing_panel": this, "flex": 45, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Content","(sales.sales.ItemsByInvoice) Shows all sales invoice items.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sales.ItemsByInvoice.grid) ] });
    var general_panel1650 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel1587, ItemsByInvoice_grid1649 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var id1651 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(sales.Invoices.id) ") }, "name": "id", "selectOnFocus": true });
    var user1652 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(sales.Invoices.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/user" }) }) });
    var language1653 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Sprache", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(sales.Invoices.language) ") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var more_1_panel1654 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 11, "items": id1651, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 44, "items": user1652, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 44, "items": language1653, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var intro1658 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Introductive Text", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Introductive Text","(sales.Invoices.intro) ") }, "name": "intro", "selectOnFocus": true });
    var more_panel1659 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel1654, { "flex": 83, "items": intro1658, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var journal1661 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(sales.Invoices.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/journal" }) }) });
    var accounting_period1662 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsperiode</span>", "hiddenName": "accounting_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Accounting period","(sales.Invoices.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.") }, "name": "accounting_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/accounting_period" }) }) });
    var number1663 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Nr.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(sales.Invoices.number) The sequence number of this voucher in the journal.") }, "name": "number", "selectOnFocus": true });
    var narration1664 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Beschreibung</span>", "listeners": { "render": Lino.quicktip_renderer("Narration","(sales.Invoices.narration) A short explanation which ascertains the subject matter of\nthis journal entry.") }, "maxLength": 200, "name": "narration", "selectOnFocus": true });
    var ledger_1_panel1665 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": journal1661, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": accounting_period1662, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": number1663, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": narration1664, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MovementsByVoucher_htmlbox1670 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 75, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(sales.Invoices.MovementsByVoucher) ") }, "master_panel": this, "name": "MovementsByVoucher", "title": "Bewegungen", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByVoucher.grid) ], "value": "<br/>" });
    var ledger_panel1671 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel1665, MovementsByVoucher_htmlbox1670 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Buchhaltung" });
    var main_panel1672 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel1650, more_panel1659, ledger_panel1671 ], "labelAlign": "top", "split": true });
    this.items = main_panel1672;
    this.before_row_edit = function(record) {
      match1563.setContextValue('journal', record ? record.data['journalHidden'] : undefined);
      match1563.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
      ItemsByInvoice_grid1649.on_master_changed();
      MovementsByVoucher_htmlbox1670.refresh();
    }
    this.onRender = function(ct, position) {
      journal1661.on('change',Lino.chooser_handler(match1563,'journal'));
      partner1555.on('change',Lino.chooser_handler(match1563,'partner'));
      Lino.sales.Invoices.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.sales.Invoices.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Companies.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 7,
  initComponent : function() {
    var overview_disp2474 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Beschreibung", "listeners": { "render": Lino.quicktip_renderer("Description","(contacts.Companies.overview) ") }, "name": "overview", "value": "<br/>" });
    var email2475 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">E-Mail-Adresse</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(contacts.Companies.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var phone2476 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Telefon</span>", "listeners": { "render": Lino.quicktip_renderer("Phone","(contacts.Companies.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.") }, "maxLength": 200, "name": "phone", "selectOnFocus": true });
    var gsm2477 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">GSM</span>", "listeners": { "render": Lino.quicktip_renderer("GSM","(contacts.Companies.gsm) The primary mobile phone number.") }, "maxLength": 200, "name": "gsm", "selectOnFocus": true });
    var fax2478 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Fax", "listeners": { "render": Lino.quicktip_renderer("Fax","(contacts.Companies.fax) ") }, "maxLength": 200, "name": "fax", "selectOnFocus": true });
    var contact_box_panel2479 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 37, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": email2475, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": phone2476, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": gsm2477, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": fax2478, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    var lists_MembersByPartner_grid2484 = new Lino.lists.MembersByPartner.GridPanel({ "containing_panel": this, "flex": 25, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("List memberships","(lists.lists.MembersByPartner) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.lists.MembersByPartner.grid) ] });
    var general_1_panel2485 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 37, "items": overview_disp2474, "labelAlign": "top", "layout": "form", "xtype": "panel" }, contact_box_panel2479, lists_MembersByPartner_grid2484 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks2487 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkungen", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(contacts.Companies.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var plausibility_ProblemsByOwner_htmlbox2488 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 37, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Plausibility problems","(contacts.Companies.plausibility_ProblemsByOwner) Show data problems related to this database object.") }, "master_panel": this, "name": "plausibility_ProblemsByOwner", "title": "Datenprobleme", "tools": [ Lino.show_in_own_window_button(Lino.plausibility.ProblemsByOwner.grid) ], "value": "<br/>" });
    var bottom_box_1_panel2489 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 62, "items": remarks2487, "labelAlign": "top", "layout": "form", "xtype": "panel" }, plausibility_ProblemsByOwner_htmlbox2488 ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var general_panel2491 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel2485, bottom_box_1_panel2489 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var prefix2492 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Name prefix</span>", "listeners": { "render": Lino.quicktip_renderer("Name prefix","(contacts.Companies.prefix) An optional name prefix. For organisations this is inserted\nbefore the name, for persons this is inserted between first\nname and last name (see\nlino.mixins.human.Human.get_last_name_prefix()).") }, "maxLength": 200, "name": "prefix", "selectOnFocus": true });
    var name2493 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Name</span>", "listeners": { "render": Lino.quicktip_renderer("Name","(contacts.Companies.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var address_box_1_panel2494 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": prefix2492, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": name2493, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var street2497 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Street","(contacts.Companies.street) ") }, "maxLength": 200, "name": "street", "selectOnFocus": true });
    var street_box2498 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Box", "listeners": { "render": Lino.quicktip_renderer("Box","(contacts.Companies.street_box) ") }, "maxLength": 10, "name": "street_box", "selectOnFocus": true });
    var address_box_2_panel2499 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 69, "items": street2497, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": street_box2498, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr22502 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresszeile nach Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Address line after street","(contacts.Companies.addr2) ") }, "maxLength": 200, "name": "addr2", "selectOnFocus": true });
    var country2503 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Land ausw\u00e4hlen...", "fieldLabel": "Land", "hiddenName": "countryHidden", "listeners": { "render": Lino.quicktip_renderer("Country","(contacts.Companies.country) ") }, "name": "country", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Countries.detail,Lino.countries.Countries.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/country" }) }) });
    var zip_code2504 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Postleitzahl", "listeners": { "render": Lino.quicktip_renderer("Zip code","(contacts.Companies.zip_code) ") }, "maxLength": 10, "name": "zip_code", "selectOnFocus": true });
    var city2505 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Ort ausw\u00e4hlen...", "fieldLabel": "Locality", "forceSelection": false, "hiddenName": "cityHidden", "listeners": { "render": Lino.quicktip_renderer("Locality","(contacts.Companies.city) ") }, "name": "city", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Places.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/city" }) }) });
    var address_box_4_panel2506 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": country2503, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": zip_code2504, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": city2505, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_panel2510 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_1_panel2494, address_box_2_panel2499, { "anchor": "-20", "autoHeight": true, "items": addr22502, "labelAlign": "top", "layout": "form", "xtype": "panel" }, address_box_4_panel2506 ], "labelAlign": "top", "labelWidth": 234, "layout": "form" });
    var contacts_RolesByCompany_grid2520 = new Lino.contacts.RolesByCompany.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Contact persons","(contacts.contacts.RolesByCompany) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.contacts.RolesByCompany.grid) ] });
    var sepa_AccountsByPartner_grid2521 = new Lino.sepa.AccountsByPartner.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(sepa.sepa.AccountsByPartner) Show the bank account(s) defined for a given partner. To be\nincluded to a detail window on partner.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sepa.AccountsByPartner.grid) ] });
    var address_2_panel2522 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 55, "frame": false, "hideCheckBoxLabels": true, "items": [ contacts_RolesByCompany_grid2520, sepa_AccountsByPartner_grid2521 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var address_panel2523 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_panel2510, address_2_panel2522 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Adresse" });
    var id2524 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(contacts.Companies.id) ") }, "name": "id", "selectOnFocus": true });
    var language2525 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Sprache</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(contacts.Companies.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var type2526 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Organisationsart ausw\u00e4hlen...", "fieldLabel": "Organisationsart", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Organization type","(contacts.Companies.type) ") }, "name": "type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/type" }) }) });
    var vat_id2527 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "MwSt.-Nr.", "listeners": { "render": Lino.quicktip_renderer("VAT id","(contacts.Companies.vat_id) ") }, "maxLength": 200, "name": "vat_id", "selectOnFocus": true });
    var more_1_panel2528 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id2524, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": language2525, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": type2526, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": vat_id2527, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr12533 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresszeile vor Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Address line before street","(contacts.Companies.addr1) ") }, "maxLength": 200, "name": "addr1", "selectOnFocus": true });
    var url2534 = new Lino.URLField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresse (URL)", "listeners": { "render": Lino.quicktip_renderer("URL","(contacts.Companies.url) ") }, "maxLength": 200, "name": "url", "selectOnFocus": true });
    var more_2_panel2535 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": addr12533, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": url2534, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 243, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var rooms_BookingsByCompany_grid2587 = new Lino.rooms.BookingsByCompany.GridPanel({ "containing_panel": this, "flex": 41, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Bookings","(rooms.rooms.BookingsByCompany) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.rooms.BookingsByCompany.grid) ] });
    var notes_NotesByCompany_grid2609 = new Lino.notes.NotesByCompany.GridPanel({ "containing_panel": this, "flex": 41, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notes","(notes.notes.NotesByCompany) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByCompany.grid) ] });
    var more_panel2610 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel2528, more_2_panel2535, rooms_BookingsByCompany_grid2587, notes_NotesByCompany_grid2609 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var invoice_recipient2611 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Fakturationsadresse</span>", "hiddenName": "invoice_recipientHidden", "listeners": { "render": Lino.quicktip_renderer("Invoicing address","(contacts.Companies.invoice_recipient) Redirect to another partner all invoices which should go to this partner.") }, "name": "invoice_recipient", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/invoice_recipient" }) }) });
    var vat_regime2612 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "MwSt.-Regime", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(contacts.Companies.vat_regime) ") }, "name": "vat_regime", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var ledger_a_1_panel2613 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 52, "items": invoice_recipient2611, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 47, "items": vat_regime2612, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var payment_term2616 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zahlungsbedingung</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(contacts.Companies.payment_term) The default payment term for sales invoices to this customer.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/payment_term" }) }) });
    var paper_type2617 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Papierart ausw\u00e4hlen...", "fieldLabel": "Papierart", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(contacts.Companies.paper_type) ") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/paper_type" }) }) });
    var ledger_a_2_panel2618 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": payment_term2616, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": paper_type2617, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ledger_a_panel2621 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 57, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_a_1_panel2613, ledger_a_2_panel2618 ], "labelAlign": "top", "layout": "form" });
    var ledger_MovementsByPartner_htmlbox2622 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 42, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(contacts.Companies.ledger_MovementsByPartner) ") }, "master_panel": this, "name": "ledger_MovementsByPartner", "title": "Bewegungen", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByPartner.grid) ], "value": "<br/>" });
    var ledger_1_panel2623 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ ledger_a_panel2621, ledger_MovementsByPartner_htmlbox2622 ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var sales_InvoicesByPartner_grid2624 = new Lino.sales.InvoicesByPartner.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Product invoices","(sales.sales.InvoicesByPartner) Base class for tables of partner vouchers.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sales.InvoicesByPartner.grid) ] });
    var ledger_panel2625 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel2623, sales_InvoicesByPartner_grid2624 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Buchhaltung" });
    var main_panel2626 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel2491, address_panel2523, more_panel2610, ledger_panel2625 ], "labelAlign": "top", "split": true });
    this.items = main_panel2626;
    this.before_row_edit = function(record) {
      lists_MembersByPartner_grid2484.on_master_changed();
      plausibility_ProblemsByOwner_htmlbox2488.refresh();
      city2505.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city2505.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      contacts_RolesByCompany_grid2520.on_master_changed();
      sepa_AccountsByPartner_grid2521.on_master_changed();
      rooms_BookingsByCompany_grid2587.on_master_changed();
      notes_NotesByCompany_grid2609.on_master_changed();
      ledger_MovementsByPartner_htmlbox2622.refresh();
      sales_InvoicesByPartner_grid2624.on_master_changed();
    }
    this.onRender = function(ct, position) {
      country2503.on('change',Lino.chooser_handler(city2505,'country'));
      Lino.contacts.Companies.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.contacts.Companies.DetailFormPanel.superclass.initComponent.call(this);
    // active_fields:
    city2505.on("change", function(){ this.save() }, this);
    zip_code2504.on("change", function(){ this.save() }, this);
  }
});


Lino.sales.InvoiceItems.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 44,
  initComponent : function() {
    var seqno1609 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Nr.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(sales.InvoiceItems.seqno) The sequence number of this item with its parent.") }, "name": "seqno", "selectOnFocus": true });
    var product1610 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarif ausw\u00e4hlen...", "fieldLabel": "Tarif", "hiddenName": "productHidden", "listeners": { "render": Lino.quicktip_renderer("Tariff","(sales.InvoiceItems.product) ") }, "name": "product", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoiceItems/product" }) }) });
    var discount1611 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "Erm\u00e4\u00dfigung", "listeners": { "render": Lino.quicktip_renderer("Discount","(sales.InvoiceItems.discount) ") }, "name": "discount", "selectOnFocus": true });
    var main_1_panel1612 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 15, "items": seqno1609, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 62, "items": product1610, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": discount1611, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var unit_price1616 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "St\u00fcckpreis", "listeners": { "render": Lino.quicktip_renderer("Unit price","(sales.InvoiceItems.unit_price) ") }, "name": "unit_price", "selectOnFocus": true });
    var qty1617 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(6), "fieldLabel": "Menge", "listeners": { "render": Lino.quicktip_renderer("Quantity","(sales.InvoiceItems.qty) ") }, "maxLength": 6, "name": "qty", "selectOnFocus": true });
    var total_base1618 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total zzgl. MwSt.</span>", "listeners": { "render": Lino.quicktip_renderer("Total excl. VAT","(sales.InvoiceItems.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.") }, "name": "total_base", "selectOnFocus": true });
    var total_vat1619 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">MwSt.</span>", "listeners": { "render": Lino.quicktip_renderer("VAT","(sales.InvoiceItems.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.") }, "name": "total_vat", "selectOnFocus": true });
    var total_incl1620 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total inkl. MwSt.</span>", "listeners": { "render": Lino.quicktip_renderer("Total incl. VAT","(sales.InvoiceItems.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.") }, "name": "total_incl", "selectOnFocus": true });
    var main_2_panel1621 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 21, "items": unit_price1616, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": qty1617, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": total_base1618, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": total_vat1619, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": total_incl1620, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var title1627 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "\u00dcberschrift", "listeners": { "render": Lino.quicktip_renderer("Heading","(sales.InvoiceItems.title) ") }, "maxLength": 200, "name": "title", "selectOnFocus": true });
    var invoiceable_type1628 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Datenbankmodell ausw\u00e4hlen...", "fieldLabel": "Fakturiertes Objekt (Modell)", "hiddenName": "invoiceable_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Invoiced object (type)","(sales.InvoiceItems.invoiceable_type) ") }, "name": "invoiceable_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.gfks.ContentTypes.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoiceItems/invoiceable_type" }) }) });
    var invoiceable_id1629 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Fakturiertes Objekt (Objekt)", "hiddenName": "invoiceable_idHidden", "listeners": { "render": Lino.quicktip_renderer("Invoiced object (object)","(sales.InvoiceItems.invoiceable_id) ") }, "name": "invoiceable_id", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoiceItems/invoiceable_id" }) }) });
    var invoiceable_disp1630 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Fakturiertes Objekt", "name": "invoiceable" });
    var main_4_panel1631 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 18, "items": invoiceable_type1628, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": invoiceable_id1629, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 62, "items": invoiceable_disp1630, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 225, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description1635 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Beschreibung</span>", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description","(sales.InvoiceItems.description) A multi-line rich text to be printed in the resulting printable\ndocument.") }, "name": "description", "selectOnFocus": true });
    var main_panel1636 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1612, main_2_panel1621, { "autoHeight": true, "items": title1627, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_4_panel1631, { "flex": 55, "items": description1635, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1636;
    this.before_row_edit = function(record) {
      invoiceable_id1629.setContextValue('invoiceable_type', record ? record.data['invoiceable_typeHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      invoiceable_type1628.on('change',Lino.chooser_handler(invoiceable_id1629,'invoiceable_type'));
      Lino.sales.InvoiceItems.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.sales.InvoiceItems.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.notes.Notes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 67,
  initComponent : function() {
    var date690 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Datum", "listeners": { "render": Lino.quicktip_renderer("Datum","(notes.Notes.date) ") }, "name": "date", "selectOnFocus": true });
    var time691 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zeit", "listeners": { "render": Lino.quicktip_renderer("Zeit","(notes.Notes.time) ") }, "name": "time", "selectOnFocus": true });
    var event_type692 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Event Type ausw\u00e4hlen...", "fieldLabel": "Ereignisart (Form)", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Ereignisart (Form)","(notes.Notes.event_type) ") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.notes.EventTypes.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/event_type" }) }) });
    var type693 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Notizart ausw\u00e4hlen...", "fieldLabel": "Notizart (Inhalt)", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Notizart (Inhalt)","(notes.Notes.type) ") }, "name": "type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.notes.NoteTypes.detail,Lino.notes.NoteTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/type" }) }) });
    var main_1_panel694 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": date690, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": time691, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 36, "items": event_type692, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 36, "items": type693, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 171, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var subject699 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Betreff", "listeners": { "render": Lino.quicktip_renderer("Betreff","(notes.Notes.subject) ") }, "maxLength": 200, "name": "subject", "selectOnFocus": true });
    var company700 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Organisation ausw\u00e4hlen...", "fieldLabel": "Empf\u00e4nger (Organisation)", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Empf\u00e4nger (Organisation)","(notes.Notes.company) ") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/company" }) }) });
    var contact_person701 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Person ausw\u00e4hlen...", "fieldLabel": "Empf\u00e4nger (Person)", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Empf\u00e4nger (Person)","(notes.Notes.contact_person) ") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/contact_person" }) }) });
    var contact_role702 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Funktion ausw\u00e4hlen...", "fieldLabel": "in seiner Eigenschaft als", "hiddenName": "contact_roleHidden", "listeners": { "render": Lino.quicktip_renderer("in seiner Eigenschaft als","(notes.Notes.contact_role) ") }, "name": "contact_role", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/contact_role" }) }) });
    var main_3_panel703 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": company700, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": contact_person701, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": contact_role702, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 234, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var id707 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(notes.Notes.id) ") }, "name": "id", "selectOnFocus": true });
    var user708 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Autor","(notes.Notes.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/user" }) }) });
    var language709 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Sprache", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Sprache","(notes.Notes.language) ") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var build_time710 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Druckdatum", "listeners": { "render": Lino.quicktip_renderer("Druckdatum","(notes.Notes.build_time) ") }, "name": "build_time", "value": "<br>" });
    var main_4_panel711 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 12, "items": id707, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": user708, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": language709, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 41, "items": build_time710, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var body716 = new Ext.form.HtmlEditor({ "fieldLabel": "Inhalt", "flex": 55, "listeners": { "render": Lino.quicktip_renderer("Inhalt","(notes.Notes.body) ") }, "name": "body", "selectOnFocus": true });
    var main_panel717 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel694, { "autoHeight": true, "items": subject699, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_3_panel703, main_4_panel711, body716 ], "labelAlign": "top", "labelWidth": 72, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel717;
    this.before_row_edit = function(record) {
      contact_person701.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      company700.on('change',Lino.chooser_handler(contact_person701,'company'));
      Lino.notes.Notes.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.notes.Notes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Calendars.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 27,
  initComponent : function() {
    var name2627 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.Calendars.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2628 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.Calendars.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2629 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.Calendars.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var color2630 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Farbe", "listeners": { "render": Lino.quicktip_renderer("color","(cal.Calendars.color) ") }, "name": "color", "selectOnFocus": true });
    var id2631 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.Calendars.id) ") }, "name": "id", "selectOnFocus": true });
    var main_1_panel2632 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 28, "items": name2627, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": name_de2628, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": name_fr2629, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": color2630, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": id2631, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description2638 = new Ext.form.HtmlEditor({ "fieldLabel": "Beschreibung", "flex": 33, "listeners": { "render": Lino.quicktip_renderer("Description","(cal.Calendars.description) ") }, "name": "description", "selectOnFocus": true });
    var SubscriptionsByCalendar_grid2647 = new Lino.cal.SubscriptionsByCalendar.GridPanel({ "containing_panel": this, "flex": 66, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Subscriptions","(cal.cal.SubscriptionsByCalendar) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.cal.SubscriptionsByCalendar.grid) ] });
    var main_2_panel2648 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 83, "frame": false, "hideCheckBoxLabels": true, "items": [ description2638, SubscriptionsByCalendar_grid2647 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var main_panel2649 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2632, main_2_panel2648 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2649;
    this.before_row_edit = function(record) {
      SubscriptionsByCalendar_grid2647.on_master_changed();
    }
    Lino.cal.Calendars.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.GuestRoles.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 26,
  initComponent : function() {
    var id2650 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.GuestRoles.id) ") }, "name": "id", "selectOnFocus": true });
    var name2651 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.GuestRoles.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2652 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.GuestRoles.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2653 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.GuestRoles.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel2654 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id2650, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name2651, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de2652, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr2653, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var cal_GuestsByRole_grid2670 = new Lino.cal.GuestsByRole.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Presences","(cal.cal.GuestsByRole) The default table for Guest.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.cal.GuestsByRole.grid) ] });
    var main_panel2671 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2654, cal_GuestsByRole_grid2670 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2671;
    this.before_row_edit = function(record) {
      cal_GuestsByRole_grid2670.on_master_changed();
    }
    Lino.cal.GuestRoles.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Tasks.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 18,
  initComponent : function() {
    var summary764 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Kurzbeschreibung", "listeners": { "render": Lino.quicktip_renderer("Kurzbeschreibung","(cal.Tasks.summary) ") }, "maxLength": 200, "name": "summary", "selectOnFocus": true });
    var user765 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Autor","(cal.Tasks.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Tasks/user" }) }) });
    var main_panel766 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": summary764, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": user765, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "form" });
    this.items = main_panel766;
    this.before_row_edit = function(record) {
    }
    Lino.cal.Tasks.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Events.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 23,
  initComponent : function() {
    var event_type591 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kalendereintragsart</span>", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Kalendereintragsart","(cal.Events.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/event_type" }) }) });
    var summary592 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kurzbeschreibung</span>", "listeners": { "render": Lino.quicktip_renderer("Kurzbeschreibung","(cal.Events.summary) A one-line descriptive text.") }, "maxLength": 200, "name": "summary", "selectOnFocus": true });
    var user593 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Verantwortlicher</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Verantwortlicher","(cal.Events.user) Der verantwortliche Benutzer.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/user" }) }) });
    var general_1_panel594 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 32, "items": event_type591, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": summary592, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": user593, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var start_date598 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Beginnt am","(cal.Events.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var start_time599 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(cal.Events.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var start_panel600 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 61, "items": start_date598, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": start_time599, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var end_date603 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(cal.Events.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var end_time604 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Endet um</span>", "listeners": { "render": Lino.quicktip_renderer("Endet um","(cal.Events.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.") }, "name": "end_time", "selectOnFocus": true });
    var end_panel605 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 61, "items": end_date603, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": end_time604, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var general_2_panel608 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ start_panel600, end_panel605 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room609 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Raum ausw\u00e4hlen...", "fieldLabel": "Raum", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Raum","(cal.Events.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/room" }) }) });
    var priority610 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "fieldLabel": "Priorit\u00e4t", "hiddenName": "priorityHidden", "listeners": { "render": Lino.quicktip_renderer("Priorit\u00e4t","(cal.Events.priority) ") }, "name": "priority", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/priority" }) }) });
    var access_class611 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zugriffsklasse</span>", "forceSelection": true, "hiddenName": "access_classHidden", "listeners": { "render": Lino.quicktip_renderer("Zugriffsklasse","(cal.Events.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist") }, "name": "access_class", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var transparent612 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "nicht blockierend", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("nicht blockierend","(cal.Events.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.") }, "name": "transparent", "selectOnFocus": true });
    var general_3_panel613 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 32, "items": room609, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": priority610, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": access_class611, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": transparent612, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var owner_disp618 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Verkn\u00fcpft mit", "name": "owner" });
    var workflow_buttons_disp619 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(cal.Events.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_4_panel620 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": owner_disp618, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": workflow_buttons_disp619, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description623 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Beschreibung</span>", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Beschreibung","(cal.Events.description) A longer descriptive text.") }, "name": "description", "selectOnFocus": true });
    var general_panel624 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel594, general_2_panel608, general_3_panel613, general_4_panel620, { "flex": 45, "items": description623, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var id626 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.Events.id) ") }, "name": "id", "selectOnFocus": true });
    var created627 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Erstellt</span>", "listeners": { "render": Lino.quicktip_renderer("Erstellt","(cal.Events.created) The timestame when this object was created.") }, "name": "created", "value": "<br>" });
    var modified628 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Bearbeitet", "listeners": { "render": Lino.quicktip_renderer("Bearbeitet","(cal.Events.modified) ") }, "name": "modified", "value": "<br>" });
    var state629 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("Zustand","(cal.Events.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.") }, "name": "state", "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var more_1_panel630 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 8, "items": id626, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": created627, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": modified628, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": state629, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var cal_GuestsByEvent_grid668 = new Lino.cal.GuestsByEvent.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Anwesenheiten","(cal.cal.GuestsByEvent) The default table for Guest.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.cal.GuestsByEvent.grid) ] });
    var notes_NotesByOwner_grid719 = new Lino.notes.NotesByOwner.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notizen","(notes.notes.NotesByOwner) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByOwner.grid) ] });
    var more_2_panel720 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 83, "frame": false, "hideCheckBoxLabels": true, "items": [ cal_GuestsByEvent_grid668, notes_NotesByOwner_grid719 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var more_panel721 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel630, more_2_panel720 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var main_panel722 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel624, more_panel721 ], "labelAlign": "top", "split": true });
    this.items = main_panel722;
    this.before_row_edit = function(record) {
      cal_GuestsByEvent_grid668.on_master_changed();
      notes_NotesByOwner_grid719.on_master_changed();
    }
    Lino.cal.Events.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.AccountingReport.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  disable_editing: true,
  auto_apply_params: false,
  initComponent : function() {
    var body_htmlbox2672 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer(null,"(ledger.AccountingReport.body) ") }, "name": "body", "value": "<br/>" });
    var main_panel2673 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ body_htmlbox2672 ], "labelAlign": "top", "labelWidth": 0, "layout": "fit" });
    this.items = main_panel2673;
    this.before_row_edit = function(record) {
      body_htmlbox2672.refresh();
    }
    Lino.ledger.AccountingReport.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Activities.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 52,
  initComponent : function() {
    var ref890 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Referenz</span>", "listeners": { "render": Lino.quicktip_renderer("Referenz","(courses.Activities.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.") }, "maxLength": 40, "name": "ref", "preferred_with": 6, "selectOnFocus": true });
    var line891 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Aktivit\u00e4tenreihe</span>", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Aktivit\u00e4tenreihe","(courses.Activities.line) Pointer to the course series.") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/line" }) }) });
    var teacher892 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kursleiter ausw\u00e4hlen...", "fieldLabel": "Kursleiter", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Kursleiter","(courses.Activities.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/teacher" }) }) });
    var workflow_buttons_disp893 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(courses.Activities.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_1_panel894 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 23, "items": ref890, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": line891, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": teacher892, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": workflow_buttons_disp893, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room899 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Raum ausw\u00e4hlen...", "fieldLabel": "Raum", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Raum","(courses.Activities.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/room" }) }) });
    var start_date900 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Beginnt am","(courses.Activities.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var end_date901 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(courses.Activities.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var start_time902 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(courses.Activities.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time903 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Endet um", "listeners": { "render": Lino.quicktip_renderer("Endet um","(courses.Activities.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var general_2_panel904 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 32, "items": room899, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": start_date900, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": end_date901, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": start_time902, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": end_time903, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name910 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung</span>", "listeners": { "render": Lino.quicktip_renderer("Bezeichnung","(courses.Activities.name) A short designation for this course. An extension of the\nref.") }, "maxLength": 100, "name": "name", "selectOnFocus": true });
    var remark911 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkung", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Bemerkung","(courses.Activities.remark) ") }, "name": "remark", "selectOnFocus": true });
    var general_panel912 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel894, general_2_panel904, { "autoHeight": true, "items": name910, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 50, "items": remark911, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var every_unit915 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Wiederholung", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Wiederholung","(courses.Activities.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every916 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "... alle", "listeners": { "render": Lino.quicktip_renderer("... alle","(courses.Activities.every) ") }, "name": "every", "selectOnFocus": true });
    var max_date917 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Termine generieren bis", "listeners": { "render": Lino.quicktip_renderer("Termine generieren bis","(courses.Activities.max_date) ") }, "name": "max_date", "selectOnFocus": true });
    var max_events918 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Anzahl Termine", "listeners": { "render": Lino.quicktip_renderer("Anzahl Termine","(courses.Activities.max_events) ") }, "name": "max_events", "selectOnFocus": true });
    var events_1_panel919 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 47, "items": every_unit915, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": every916, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": max_date917, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": max_events918, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 207, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var monday924 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Montag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Montag","(courses.Activities.monday) ") }, "name": "monday", "selectOnFocus": true });
    var tuesday925 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Dienstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Dienstag","(courses.Activities.tuesday) ") }, "name": "tuesday", "selectOnFocus": true });
    var wednesday926 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Mittwoch", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Mittwoch","(courses.Activities.wednesday) ") }, "name": "wednesday", "selectOnFocus": true });
    var thursday927 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Donnerstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Donnerstag","(courses.Activities.thursday) ") }, "name": "thursday", "selectOnFocus": true });
    var friday928 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Freitag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Freitag","(courses.Activities.friday) ") }, "name": "friday", "selectOnFocus": true });
    var saturday929 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Samstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Samstag","(courses.Activities.saturday) ") }, "name": "saturday", "selectOnFocus": true });
    var sunday930 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Sonntag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Sonntag","(courses.Activities.sunday) ") }, "name": "sunday", "selectOnFocus": true });
    var events_2_panel931 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": monday924, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": tuesday925, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": wednesday926, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": thursday927, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": friday928, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": saturday929, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": sunday930, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_EntriesByCourse_htmlbox939 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 60, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Kalendereintr\u00e4ge","(courses.Activities.courses_EntriesByCourse) Shows the events linked to this course.") }, "master_panel": this, "name": "courses_EntriesByCourse", "title": "Kalendereintr\u00e4ge", "tools": [ Lino.show_in_own_window_button(Lino.courses.EntriesByCourse.grid) ], "value": "<br/>" });
    var events_panel940 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ events_1_panel919, events_2_panel931, courses_EntriesByCourse_htmlbox939 ], "labelAlign": "top", "labelWidth": 153, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Veranstaltungen" });
    var enrolments_until941 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Einschreibung m\u00f6glich bis", "listeners": { "render": Lino.quicktip_renderer("Einschreibung m\u00f6glich bis","(courses.Activities.enrolments_until) ") }, "name": "enrolments_until", "selectOnFocus": true });
    var fee942 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarif ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Standard-Teilnehmahmegeb\u00fchr</span>", "hiddenName": "feeHidden", "listeners": { "render": Lino.quicktip_renderer("Standard-Teilnehmahmegeb\u00fchr","(courses.Activities.fee) The default participation fee to apply for new enrolments.") }, "name": "fee", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/fee" }) }) });
    var max_places943 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Verf\u00fcgbare Pl\u00e4tze</span>", "listeners": { "render": Lino.quicktip_renderer("Verf\u00fcgbare Pl\u00e4tze","(courses.Activities.max_places) Maximum number of participants") }, "name": "max_places", "selectOnFocus": true });
    var confirmed944 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Best\u00e4tigt", "listeners": { "render": Lino.quicktip_renderer("Best\u00e4tigt","(courses.Activities.confirmed) ") }, "name": "confirmed" });
    var free_places945 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Freie Pl\u00e4tze", "listeners": { "render": Lino.quicktip_renderer("Freie Pl\u00e4tze","(courses.Activities.free_places) ") }, "name": "free_places" });
    var print_actions_disp946 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Drucken", "listeners": { "render": Lino.quicktip_renderer("Drucken","(courses.Activities.print_actions) ") }, "name": "print_actions", "value": "<br/>" });
    var enrolments_top_panel947 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 19, "items": enrolments_until941, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": fee942, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": max_places943, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": confirmed944, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": free_places945, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": print_actions_disp946, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 252, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EnrolmentsByCourse_htmlbox954 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Einschreibungen","(courses.Activities.EnrolmentsByCourse) The Voga version of EnrolmentsByCourse.") }, "ls_bbar_actions": [ { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" } ], "ls_insert_handler": Lino.courses.EnrolmentsByCourse.insert, "master_panel": this, "name": "EnrolmentsByCourse", "title": "Einschreibungen", "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByCourse.grid) ], "value": "<br/>" });
    var enrolments_panel955 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ enrolments_top_panel947, EnrolmentsByCourse_htmlbox954 ], "labelAlign": "top", "labelWidth": 144, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Einschreibungen" });
    var state956 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("Zustand","(courses.Activities.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".") }, "name": "state", "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var user957 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Autor","(courses.Activities.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/user" }) }) });
    var payment_term958 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zahlungsbedingung</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Zahlungsbedingung","(courses.Activities.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/payment_term" }) }) });
    var paper_type959 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Papierart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Papierart</span>", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Papierart","(courses.Activities.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/paper_type" }) }) });
    var id960 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Activities.id) ") }, "name": "id", "selectOnFocus": true });
    var more_1_panel961 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": state956, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": user957, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": payment_term958, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": paper_type959, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": id960, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var invoicing_InvoicingsByInvoiceable_grid991 = new Lino.invoicing.InvoicingsByInvoiceable.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Fakturierungen","(invoicing.invoicing.InvoicingsByInvoiceable) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.invoicing.InvoicingsByInvoiceable.grid) ] });
    var more_panel992 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel961, invoicing_InvoicingsByInvoiceable_grid991 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var main_panel993 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel912, events_panel940, enrolments_panel955, more_panel992 ], "labelAlign": "top", "split": true });
    this.items = main_panel993;
    this.before_row_edit = function(record) {
      courses_EntriesByCourse_htmlbox939.refresh();
      fee942.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      EnrolmentsByCourse_htmlbox954.refresh();
      invoicing_InvoicingsByInvoiceable_grid991.on_master_changed();
    }
    this.onRender = function(ct, position) {
      line891.on('change',Lino.chooser_handler(fee942,'line'));
      Lino.courses.Activities.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Activities.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.RecurrentEvents.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 21,
  initComponent : function() {
    var name2674 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.RecurrentEvents.name) See lino.utils.mldbc.mixins.BabelNamed.name.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2675 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.RecurrentEvents.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2676 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.RecurrentEvents.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel2677 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2674, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2675, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2676, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var id2681 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.RecurrentEvents.id) ") }, "name": "id", "selectOnFocus": true });
    var user2682 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(cal.RecurrentEvents.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/RecurrentEvents/user" }) }) });
    var event_type2683 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "fieldLabel": "Kalendereintragsart", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(cal.RecurrentEvents.event_type) ") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/RecurrentEvents/event_type" }) }) });
    var main_2_panel2684 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 11, "items": id2681, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 44, "items": user2682, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 44, "items": event_type2683, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var start_date2688 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Start date","(cal.RecurrentEvents.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var start_time2689 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(cal.RecurrentEvents.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_date2690 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(cal.RecurrentEvents.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var end_time2691 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Endet um", "listeners": { "render": Lino.quicktip_renderer("End Time","(cal.RecurrentEvents.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var main_3_panel2692 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": start_date2688, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": start_time2689, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": end_date2690, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": end_time2691, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var every_unit2697 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Wiederholung</span>", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(cal.RecurrentEvents.every_unit) Inherited from RecurrentSet.every_unit.") }, "name": "every_unit", "selectOnFocus": true, "store": Lino.cal.Recurrencies });
    var every2698 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "... alle", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(cal.RecurrentEvents.every) ") }, "name": "every", "selectOnFocus": true, "value": 1 });
    var max_events2699 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Anzahl Termine", "listeners": { "render": Lino.quicktip_renderer("Number of events","(cal.RecurrentEvents.max_events) ") }, "name": "max_events", "selectOnFocus": true });
    var main_4_panel2700 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 67, "items": every_unit2697, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": every2698, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": max_events2699, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var monday2704 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Montag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Monday","(cal.RecurrentEvents.monday) ") }, "name": "monday", "selectOnFocus": true });
    var tuesday2705 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Dienstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Tuesday","(cal.RecurrentEvents.tuesday) ") }, "name": "tuesday", "selectOnFocus": true });
    var wednesday2706 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Mittwoch", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wednesday","(cal.RecurrentEvents.wednesday) ") }, "name": "wednesday", "selectOnFocus": true });
    var thursday2707 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Donnerstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Thursday","(cal.RecurrentEvents.thursday) ") }, "name": "thursday", "selectOnFocus": true });
    var friday2708 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Freitag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Friday","(cal.RecurrentEvents.friday) ") }, "name": "friday", "selectOnFocus": true });
    var saturday2709 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Samstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Saturday","(cal.RecurrentEvents.saturday) ") }, "name": "saturday", "selectOnFocus": true });
    var sunday2710 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Sonntag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Sunday","(cal.RecurrentEvents.sunday) ") }, "name": "sunday", "selectOnFocus": true });
    var main_5_panel2711 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": monday2704, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": tuesday2705, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": wednesday2706, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": thursday2707, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": friday2708, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": saturday2709, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": sunday2710, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description2719 = new Ext.form.HtmlEditor({ "fieldLabel": "Beschreibung", "flex": 66, "listeners": { "render": Lino.quicktip_renderer("Description","(cal.RecurrentEvents.description) ") }, "name": "description", "selectOnFocus": true });
    var cal_EntriesByController_htmlbox2720 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 33, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(cal.RecurrentEvents.cal_EntriesByController) Shows the events linked to this database object.") }, "master_panel": this, "name": "cal_EntriesByController", "title": "Kalendereintr\u00e4ge", "tools": [ Lino.show_in_own_window_button(Lino.cal.EntriesByController.grid) ], "value": "<br/>" });
    var main_6_panel2721 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ description2719, cal_EntriesByController_htmlbox2720 ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var main_panel2722 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2677, main_2_panel2684, main_3_panel2692, main_4_panel2700, main_5_panel2711, main_6_panel2721 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2722;
    this.before_row_edit = function(record) {
      cal_EntriesByController_htmlbox2720.refresh();
    }
    Lino.cal.RecurrentEvents.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Tasks.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 18,
  initComponent : function() {
    var start_date741 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Beginnt am","(cal.Tasks.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var due_date742 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zahlungsziel", "listeners": { "render": Lino.quicktip_renderer("Zahlungsziel","(cal.Tasks.due_date) ") }, "name": "due_date", "selectOnFocus": true });
    var id743 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.Tasks.id) ") }, "name": "id", "selectOnFocus": true });
    var workflow_buttons_disp744 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(cal.Tasks.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var main_1_panel745 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 21, "items": start_date741, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": due_date742, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": id743, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 49, "items": workflow_buttons_disp744, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var summary750 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Kurzbeschreibung", "listeners": { "render": Lino.quicktip_renderer("Kurzbeschreibung","(cal.Tasks.summary) ") }, "maxLength": 200, "name": "summary", "selectOnFocus": true });
    var user751 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Autor","(cal.Tasks.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Tasks/user" }) }) });
    var owner_disp752 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Verkn\u00fcpft mit", "name": "owner" });
    var created753 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Erstellt</span>", "listeners": { "render": Lino.quicktip_renderer("Erstellt","(cal.Tasks.created) The timestame when this object was created.") }, "name": "created", "value": "<br>" });
    var modified754 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Bearbeitet", "listeners": { "render": Lino.quicktip_renderer("Bearbeitet","(cal.Tasks.modified) ") }, "name": "modified", "value": "<br>" });
    var main_4_panel755 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 20, "items": owner_disp752, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": created753, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": modified754, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description759 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Beschreibung", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Beschreibung","(cal.Tasks.description) ") }, "name": "description", "selectOnFocus": true });
    var main_panel760 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel745, { "autoHeight": true, "items": summary750, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "items": user751, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_4_panel755, { "flex": 45, "items": description759, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel760;
    this.before_row_edit = function(record) {
    }
    Lino.cal.Tasks.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Slots.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 49,
  initComponent : function() {
    var name2723 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Name", "listeners": { "render": Lino.quicktip_renderer("Name","(courses.Slots.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var start_time2724 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt um", "listeners": { "render": Lino.quicktip_renderer("Start Time","(courses.Slots.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time2725 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Endet um", "listeners": { "render": Lino.quicktip_renderer("End Time","(courses.Slots.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var main_1_panel2726 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 56, "items": name2723, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": start_time2724, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": end_time2725, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_CoursesBySlot_grid2779 = new Lino.courses.CoursesBySlot.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Activities","(courses.courses.CoursesBySlot) Base table for all activities.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.courses.CoursesBySlot.grid) ] });
    var main_panel2780 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2726, courses_CoursesBySlot_grid2779 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2780;
    this.before_row_edit = function(record) {
      courses_CoursesBySlot_grid2779.on_master_changed();
    }
    Lino.courses.Slots.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.plausibility.Checkers.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  disable_editing: true,
  initComponent : function() {
    var value2781 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Wert", "listeners": { "render": Lino.quicktip_renderer("value","(plausibility.Checkers.value) ") }, "maxLength": 20, "name": "value" });
    var text2782 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Text", "listeners": { "render": Lino.quicktip_renderer("text","(plausibility.Checkers.text) ") }, "maxLength": 50, "name": "text" });
    var main_1_panel2783 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": value2781, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": text2782, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 54, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var plausibility_ProblemsByChecker_grid2797 = new Lino.plausibility.ProblemsByChecker.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Plausibility problems","(plausibility.plausibility.ProblemsByChecker) Show the plausibility problems by checker.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.plausibility.ProblemsByChecker.grid) ] });
    var main_panel2798 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2783, plausibility_ProblemsByChecker_grid2797 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2798;
    this.before_row_edit = function(record) {
      plausibility_ProblemsByChecker_grid2797.on_master_changed();
    }
    Lino.plausibility.Checkers.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.about.Models.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  disable_editing: true,
  initComponent : function() {
    var app_disp2799 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "app_label", "listeners": { "render": Lino.quicktip_renderer("app_label","(about.Models.app) ") }, "name": "app", "value": "<br/>" });
    var name_disp2800 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "name", "listeners": { "render": Lino.quicktip_renderer("name","(about.Models.name) ") }, "name": "name", "value": "<br/>" });
    var docstring_disp2801 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "docstring", "listeners": { "render": Lino.quicktip_renderer("docstring","(about.Models.docstring) ") }, "name": "docstring", "value": "<br/>" });
    var rows2802 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Zeilen", "listeners": { "render": Lino.quicktip_renderer("Rows","(about.Models.rows) ") }, "name": "rows" });
    var main_1_panel2803 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 31, "items": app_disp2799, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": name_disp2800, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": docstring_disp2801, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 5, "items": rows2802, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var about_FieldsByModel_grid2812 = new Lino.about.FieldsByModel.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Fields","(about.about.FieldsByModel) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.about.FieldsByModel.grid) ] });
    var main_panel2813 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2803, about_FieldsByModel_grid2812 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2813;
    this.before_row_edit = function(record) {
      about_FieldsByModel_grid2812.on_master_changed();
    }
    Lino.about.Models.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Teachers.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 58,
  initComponent : function() {
    var overview_disp2814 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Beschreibung", "listeners": { "render": Lino.quicktip_renderer("Description","(courses.Teachers.overview) ") }, "name": "overview", "value": "<br/>" });
    var email2815 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">E-Mail-Adresse</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(courses.Teachers.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var phone2816 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Telefon</span>", "listeners": { "render": Lino.quicktip_renderer("Phone","(courses.Teachers.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.") }, "maxLength": 200, "name": "phone", "selectOnFocus": true });
    var gsm2817 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">GSM</span>", "listeners": { "render": Lino.quicktip_renderer("GSM","(courses.Teachers.gsm) The primary mobile phone number.") }, "maxLength": 200, "name": "gsm", "selectOnFocus": true });
    var contact_box_panel2818 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 37, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": email2815, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": phone2816, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": gsm2817, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    var lists_MembersByPartner_grid2822 = new Lino.lists.MembersByPartner.GridPanel({ "containing_panel": this, "flex": 25, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("List memberships","(lists.lists.MembersByPartner) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.lists.MembersByPartner.grid) ] });
    var general_1_panel2823 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 37, "items": overview_disp2814, "labelAlign": "top", "layout": "form", "xtype": "panel" }, contact_box_panel2818, lists_MembersByPartner_grid2822 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks2825 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkungen", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(courses.Teachers.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var plausibility_ProblemsByOwner_htmlbox2826 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 37, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Plausibility problems","(courses.Teachers.plausibility_ProblemsByOwner) Show data problems related to this database object.") }, "master_panel": this, "name": "plausibility_ProblemsByOwner", "title": "Datenprobleme", "tools": [ Lino.show_in_own_window_button(Lino.plausibility.ProblemsByOwner.grid) ], "value": "<br/>" });
    var bottom_box_1_panel2827 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 62, "items": remarks2825, "labelAlign": "top", "layout": "form", "xtype": "panel" }, plausibility_ProblemsByOwner_htmlbox2826 ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var general_panel2829 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel2823, bottom_box_1_panel2827 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var last_name2830 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Familienname</span>", "listeners": { "render": Lino.quicktip_renderer("Last name","(courses.Teachers.last_name) The last name, also known as family name.") }, "maxLength": 200, "name": "last_name", "selectOnFocus": true });
    var first_name2831 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Vorname</span>", "listeners": { "render": Lino.quicktip_renderer("First name","(courses.Teachers.first_name) The first name, also known as given name.") }, "maxLength": 200, "name": "first_name", "selectOnFocus": true });
    var gender2832 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Geschlecht</span>", "forceSelection": true, "hiddenName": "genderHidden", "listeners": { "render": Lino.quicktip_renderer("Gender","(courses.Teachers.gender) The sex of this person (male or female).") }, "name": "gender", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var address_box_1_panel2833 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 46, "items": last_name2830, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": first_name2831, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": gender2832, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var street2837 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Street","(courses.Teachers.street) ") }, "maxLength": 200, "name": "street", "selectOnFocus": true });
    var street_box2838 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Box", "listeners": { "render": Lino.quicktip_renderer("Box","(courses.Teachers.street_box) ") }, "maxLength": 10, "name": "street_box", "selectOnFocus": true });
    var address_box_2_panel2839 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 69, "items": street2837, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": street_box2838, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var country2842 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Land ausw\u00e4hlen...", "fieldLabel": "Land", "hiddenName": "countryHidden", "listeners": { "render": Lino.quicktip_renderer("Country","(courses.Teachers.country) ") }, "name": "country", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Countries.detail,Lino.countries.Countries.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/country" }) }) });
    var zip_code2843 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Postleitzahl", "listeners": { "render": Lino.quicktip_renderer("Zip code","(courses.Teachers.zip_code) ") }, "maxLength": 10, "name": "zip_code", "selectOnFocus": true });
    var city2844 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Ort ausw\u00e4hlen...", "fieldLabel": "Locality", "forceSelection": false, "hiddenName": "cityHidden", "listeners": { "render": Lino.quicktip_renderer("Locality","(courses.Teachers.city) ") }, "name": "city", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Places.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/city" }) }) });
    var address_box_3_panel2845 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": country2842, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": zip_code2843, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": city2844, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var birth_date2849 = new Lino.IncompleteDateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Geburtsdatum</span>", "listeners": { "render": Lino.quicktip_renderer("Birth date","(courses.Teachers.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".") }, "name": "birth_date", "selectOnFocus": true });
    var age_disp2850 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Alter", "listeners": { "render": Lino.quicktip_renderer("Age","(courses.Teachers.age) ") }, "name": "age", "value": "<br/>" });
    var teacher_type2851 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kursleiterart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kursleiterart</span>", "hiddenName": "teacher_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor Type","(courses.Teachers.teacher_type) Pointer to TeacherType.") }, "name": "teacher_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.TeacherTypes.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/teacher_type" }) }) });
    var national_id2852 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">NR-Nummer</span>", "listeners": { "render": Lino.quicktip_renderer("National ID","(courses.Teachers.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.") }, "maxLength": 200, "name": "national_id", "selectOnFocus": true });
    var personal_panel2853 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 65, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 48, "items": teacher_type2851, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 51, "items": national_id2852, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_4_panel2856 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 19, "items": birth_date2849, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": age_disp2850, "labelAlign": "top", "layout": "form", "xtype": "panel" }, personal_panel2853 ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_panel2859 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_1_panel2833, address_box_2_panel2839, address_box_3_panel2845, address_box_4_panel2856 ], "labelAlign": "top", "layout": "form" });
    var contacts_RolesByPerson_grid2860 = new Lino.contacts.RolesByPerson.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Contact for","(contacts.contacts.RolesByPerson) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.contacts.RolesByPerson.grid) ] });
    var sepa_AccountsByPartner_grid2861 = new Lino.sepa.AccountsByPartner.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(sepa.sepa.AccountsByPartner) Show the bank account(s) defined for a given partner. To be\nincluded to a detail window on partner.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sepa.AccountsByPartner.grid) ] });
    var address_2_panel2862 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 45, "frame": false, "hideCheckBoxLabels": true, "items": [ contacts_RolesByPerson_grid2860, sepa_AccountsByPartner_grid2861 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var address_panel2863 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_panel2859, address_2_panel2862 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Adresse" });
    var invoice_recipient2864 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Fakturationsadresse</span>", "hiddenName": "invoice_recipientHidden", "listeners": { "render": Lino.quicktip_renderer("Invoicing address","(courses.Teachers.invoice_recipient) Redirect to another partner all invoices which should go to this partner.") }, "name": "invoice_recipient", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/invoice_recipient" }) }) });
    var vat_regime2865 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "MwSt.-Regime", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(courses.Teachers.vat_regime) ") }, "name": "vat_regime", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var ledger_a_1_panel2866 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 52, "items": invoice_recipient2864, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 47, "items": vat_regime2865, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var payment_term2869 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zahlungsbedingung</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(courses.Teachers.payment_term) The default payment term for sales invoices to this customer.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/payment_term" }) }) });
    var paper_type2870 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Papierart ausw\u00e4hlen...", "fieldLabel": "Papierart", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(courses.Teachers.paper_type) ") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/paper_type" }) }) });
    var ledger_a_2_panel2871 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": payment_term2869, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": paper_type2870, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ledger_a_panel2874 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 57, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_a_1_panel2866, ledger_a_2_panel2871 ], "labelAlign": "top", "layout": "form" });
    var ledger_MovementsByPartner_htmlbox2875 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 42, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(courses.Teachers.ledger_MovementsByPartner) ") }, "master_panel": this, "name": "ledger_MovementsByPartner", "title": "Bewegungen", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByPartner.grid) ], "value": "<br/>" });
    var ledger_1_panel2876 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ ledger_a_panel2874, ledger_MovementsByPartner_htmlbox2875 ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var sales_InvoicesByPartner_grid2877 = new Lino.sales.InvoicesByPartner.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Product invoices","(sales.sales.InvoicesByPartner) Base class for tables of partner vouchers.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sales.InvoicesByPartner.grid) ] });
    var ledger_panel2878 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel2876, sales_InvoicesByPartner_grid2877 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Buchhaltung" });
    var id2879 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Teachers.id) ") }, "name": "id", "selectOnFocus": true });
    var language2880 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Sprache</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(courses.Teachers.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var url2881 = new Lino.URLField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresse (URL)", "listeners": { "render": Lino.quicktip_renderer("URL","(courses.Teachers.url) ") }, "maxLength": 200, "name": "url", "selectOnFocus": true });
    var more_1_panel2882 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 10, "items": id2879, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": language2880, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 45, "items": url2881, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr12886 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresszeile vor Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Address line before street","(courses.Teachers.addr1) ") }, "maxLength": 200, "name": "addr1", "selectOnFocus": true });
    var addr22887 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresszeile nach Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Address line after street","(courses.Teachers.addr2) ") }, "maxLength": 200, "name": "addr2", "selectOnFocus": true });
    var more_2_panel2888 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": addr12886, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": addr22887, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 243, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var notes_NotesByPerson_grid2891 = new Lino.notes.NotesByPerson.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notes","(notes.notes.NotesByPerson) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByPerson.grid) ] });
    var more_panel2892 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel2882, more_2_panel2888, notes_NotesByPerson_grid2891 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var courses_EntriesByTeacher_grid2898 = new Lino.courses.EntriesByTeacher.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(courses.courses.EntriesByTeacher) Show calendar entries of activities led by this teacher") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "north", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.courses.EntriesByTeacher.grid) ] });
    var courses_CoursesByTeacher_grid2948 = new Lino.courses.CoursesByTeacher.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Activities","(courses.courses.CoursesByTeacher) Base table for all activities.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "center", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.courses.CoursesByTeacher.grid) ] });
    var courses_panel2949 = new Lino.VBorderPanel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ courses_EntriesByTeacher_grid2898, courses_CoursesByTeacher_grid2948 ], "labelAlign": "top", "listeners": { "activate": Lino.on_tab_activate }, "title": "Aktivit\u00e4ten" });
    var main_panel2950 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel2829, address_panel2863, ledger_panel2878, more_panel2892, courses_panel2949 ], "labelAlign": "top", "split": true });
    this.items = main_panel2950;
    this.before_row_edit = function(record) {
      lists_MembersByPartner_grid2822.on_master_changed();
      plausibility_ProblemsByOwner_htmlbox2826.refresh();
      city2844.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city2844.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      contacts_RolesByPerson_grid2860.on_master_changed();
      sepa_AccountsByPartner_grid2861.on_master_changed();
      ledger_MovementsByPartner_htmlbox2875.refresh();
      sales_InvoicesByPartner_grid2877.on_master_changed();
      notes_NotesByPerson_grid2891.on_master_changed();
      courses_EntriesByTeacher_grid2898.on_master_changed();
      courses_CoursesByTeacher_grid2948.on_master_changed();
    }
    this.onRender = function(ct, position) {
      country2842.on('change',Lino.chooser_handler(city2844,'country'));
      Lino.courses.Teachers.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Teachers.DetailFormPanel.superclass.initComponent.call(this);
    // active_fields:
    city2844.on("change", function(){ this.save() }, this);
    zip_code2843.on("change", function(){ this.save() }, this);
  }
});


Lino.countries.Countries.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 4,
  initComponent : function() {
    var isocode2951 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(4), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">ISO-Code</span>", "listeners": { "render": Lino.quicktip_renderer("ISO code","(countries.Countries.isocode)         The two-letter code for this country as defined by ISO 3166-1.\n        For countries that no longer exist it may be a 4-letter code.") }, "maxLength": 4, "name": "isocode", "selectOnFocus": true });
    var short_code2952 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(4), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Short code</span>", "listeners": { "render": Lino.quicktip_renderer("Short code","(countries.Countries.short_code) A short abbreviation for regional usage. Obsolete.") }, "maxLength": 4, "name": "short_code", "selectOnFocus": true });
    var main_1_panel2953 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": isocode2951, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": short_code2952, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name2956 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(countries.Countries.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2957 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(countries.Countries.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2958 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(countries.Countries.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel2959 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2956, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2957, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2958, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2963 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2953, main_2_panel2959 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel2963;
    this.before_row_edit = function(record) {
    }
    Lino.countries.Countries.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.users.Users.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 2,
  initComponent : function() {
    var username1098 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Benutzername</span>", "listeners": { "render": Lino.quicktip_renderer("Benutzername","(users.Users.username) Must be unique and cannot be empty.") }, "maxLength": 30, "name": "username", "selectOnFocus": true });
    var user_type1099 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Benutzerart</span>", "forceSelection": true, "hiddenName": "user_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Benutzerart","(users.Users.user_type) The user_type of a user is what defines her or his permissions.") }, "name": "user_type", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.users.UserTypes) });
    var partner1100 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Partner</span>", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(users.Users.partner) Pointer to the Partner instance related to\nthis user.") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/Users/partner" }) }) });
    var box1_1_panel1101 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 34, "items": username1098, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": user_type1099, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": partner1100, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var first_name1105 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Vorname", "listeners": { "render": Lino.quicktip_renderer("Vorname","(users.Users.first_name) ") }, "maxLength": 30, "name": "first_name", "selectOnFocus": true });
    var last_name1106 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Familienname", "listeners": { "render": Lino.quicktip_renderer("Familienname","(users.Users.last_name) ") }, "maxLength": 30, "name": "last_name", "selectOnFocus": true });
    var initials1107 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Initialien</span>", "listeners": { "render": Lino.quicktip_renderer("Initialien","(users.Users.initials) The nickname or initials of this user. This does not need to\nbe unique but should provide a reasonably identifying\nfunction.") }, "maxLength": 10, "name": "initials", "selectOnFocus": true });
    var box1_2_panel1108 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": first_name1105, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 39, "items": last_name1106, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": initials1107, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var email1112 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "E-Mail-Adresse", "listeners": { "render": Lino.quicktip_renderer("E-Mail-Adresse","(users.Users.email) ") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var language1113 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Sprache", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Sprache","(users.Users.language) ") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var box1_3_panel1114 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 51, "items": email1112, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 48, "items": language1113, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var id1117 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(users.Users.id) ") }, "name": "id", "selectOnFocus": true });
    var created1118 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Erstellt</span>", "listeners": { "render": Lino.quicktip_renderer("Erstellt","(users.Users.created) The timestame when this object was created.") }, "name": "created", "value": "<br>" });
    var modified1119 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Bearbeitet", "listeners": { "render": Lino.quicktip_renderer("Bearbeitet","(users.Users.modified) ") }, "name": "modified", "value": "<br>" });
    var box1_4_panel1120 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 13, "items": id1117, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": created1118, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": modified1119, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var box1_panel1124 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ box1_1_panel1101, box1_2_panel1108, box1_3_panel1114, box1_4_panel1120 ], "labelAlign": "top", "layout": "form" });
    var remarks1125 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkungen", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Bemerkungen","(users.Users.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var AuthoritiesGiven_grid1128 = new Lino.users.AuthoritiesGiven.GridPanel({ "containing_panel": this, "flex": 33, "hideHeaders": true, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Erteilte Vollmachten","(users.users.AuthoritiesGiven) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.users.AuthoritiesGiven.grid) ] });
    var main_2_panel1129 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 55, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 66, "items": remarks1125, "labelAlign": "top", "layout": "form", "xtype": "panel" }, AuthoritiesGiven_grid1128 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var main_panel1131 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ box1_panel1124, main_2_panel1129 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1131;
    this.before_row_edit = function(record) {
      AuthoritiesGiven_grid1128.on_master_changed();
    }
    Lino.users.Users.DetailFormPanel.superclass.initComponent.call(this);
    // active_fields:
    partner1100.on("change", function(){ this.save() }, this);
  }
});


Lino.cal.Guests.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 19,
  initComponent : function() {
    var event646 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Kalendereintrag ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kalendereintrag</span>", "hiddenName": "eventHidden", "listeners": { "render": Lino.quicktip_renderer("Kalendereintrag","(cal.Guests.event) The calendar event to which this presence applies.") }, "name": "event", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.OneEvent.detail,Lino.cal.OneEvent.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/event" }) }) });
    var partner647 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Person ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Person</span>", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Person","(cal.Guests.partner) The partner to which this presence applies.") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/partner" }) }) });
    var role648 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Gastrolle ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Rolle</span>", "hiddenName": "roleHidden", "listeners": { "render": Lino.quicktip_renderer("Rolle","(cal.Guests.role) The role of this partner in this presence.") }, "name": "role", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.GuestRoles.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/role" }) }) });
    var main_1_panel649 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": event646, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": partner647, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": role648, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var state653 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("Zustand","(cal.Guests.state) The state of this presence.") }, "name": "state", "selectOnFocus": true, "store": Lino.cal.GuestStates });
    var remark654 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bemerkung", "listeners": { "render": Lino.quicktip_renderer("Bemerkung","(cal.Guests.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var workflow_buttons_disp655 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(cal.Guests.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var main_2_panel656 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 16, "items": state653, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": remark654, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 49, "items": workflow_buttons_disp655, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel660 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel649, main_2_panel656 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel660;
    this.before_row_edit = function(record) {
    }
    Lino.cal.Guests.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Pupils.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 56,
  initComponent : function() {
    var first_name1956 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Vorname</span>", "listeners": { "render": Lino.quicktip_renderer("First name","(courses.Pupils.first_name) The first name, also known as given name.") }, "maxLength": 200, "name": "first_name", "selectOnFocus": true });
    var last_name1957 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Familienname</span>", "listeners": { "render": Lino.quicktip_renderer("Last name","(courses.Pupils.last_name) The last name, also known as family name.") }, "maxLength": 200, "name": "last_name", "selectOnFocus": true });
    var main_1_panel1958 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": first_name1956, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": last_name1957, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var gender1961 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Geschlecht</span>", "forceSelection": true, "hiddenName": "genderHidden", "listeners": { "render": Lino.quicktip_renderer("Gender","(courses.Pupils.gender) The sex of this person (male or female).") }, "name": "gender", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var language1962 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Sprache</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(courses.Pupils.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var main_2_panel1963 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 31, "items": gender1961, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 68, "items": language1962, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var pupil_type1966 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Teilnehmerart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Teilnehmerart</span>", "hiddenName": "pupil_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Participant Type","(courses.Pupils.pupil_type) Pointer to PupilType.") }, "name": "pupil_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.PupilTypes.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/pupil_type" }) }) });
    var section1967 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Sektion", "forceSelection": true, "hiddenName": "sectionHidden", "listeners": { "render": Lino.quicktip_renderer("Section","(courses.Pupils.section) ") }, "name": "section", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.Sections) });
    var member_until1968 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Mitglied bis", "listeners": { "render": Lino.quicktip_renderer("Mitglied bis","(courses.Pupils.member_until) ") }, "name": "member_until", "selectOnFocus": true });
    var main_3_panel1969 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 43, "items": pupil_type1966, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": section1967, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": member_until1968, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var is_lfv1973 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "LFV", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("LFV","(courses.Pupils.is_lfv) ") }, "name": "is_lfv", "selectOnFocus": true });
    var is_ckk1974 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "CKK", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("CKK","(courses.Pupils.is_ckk) ") }, "name": "is_ckk", "selectOnFocus": true });
    var is_raviva1975 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Raviva", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Raviva","(courses.Pupils.is_raviva) ") }, "name": "is_raviva", "selectOnFocus": true });
    var main_4_panel1976 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": is_lfv1973, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": is_ckk1974, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": is_raviva1975, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel1980 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1958, main_2_panel1963, main_3_panel1969, main_4_panel1976 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel1980;
    this.before_row_edit = function(record) {
    }
    Lino.courses.Pupils.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.outbox.Mails.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 72,
  initComponent : function() {
    var subject2964 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Betreff", "listeners": { "render": Lino.quicktip_renderer("Subject","(outbox.Mails.subject) ") }, "maxLength": 200, "name": "subject", "selectOnFocus": true });
    var body2965 = new Ext.form.HtmlEditor({ "fieldLabel": "Inhalt", "flex": 83, "listeners": { "render": Lino.quicktip_renderer("Body","(outbox.Mails.body) ") }, "name": "body", "selectOnFocus": true });
    var main_panel2966 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "items": subject2964, "labelAlign": "top", "layout": "form", "xtype": "panel" }, body2965 ], "labelAlign": "top", "labelWidth": 72, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2966;
    this.before_row_edit = function(record) {
    }
    Lino.outbox.Mails.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.Invoices.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 41,
  initComponent : function() {
    var journal2968 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(vat.Invoices.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/journal" }) }) });
    var partner2969 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(vat.Invoices.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/partner" }) }) });
    var main_1_panel2970 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": journal2968, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": partner2969, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 72, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var entry_date2973 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsdatum</span>", "listeners": { "render": Lino.quicktip_renderer("Entry date","(vat.Invoices.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.") }, "name": "entry_date", "selectOnFocus": true });
    var total_incl2974 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total inkl. MwSt.</span>", "listeners": { "render": Lino.quicktip_renderer("Total incl. VAT","(vat.Invoices.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.") }, "name": "total_incl", "selectOnFocus": true });
    var main_2_panel2975 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 52, "items": entry_date2973, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 48, "items": total_incl2974, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2978 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2970, main_2_panel2975 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel2978;
    this.before_row_edit = function(record) {
    }
    Lino.vat.Invoices.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.excerpts.ExcerptTypes.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 75,
  initComponent : function() {
    var name2979 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(excerpts.ExcerptTypes.name) The designation of this excerpt type.\nOne field for every language.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2980 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(excerpts.ExcerptTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2981 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(excerpts.ExcerptTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel2982 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2979, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2980, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2981, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var content_type2986 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Datenbankmodell ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Modell</span>", "hiddenName": "content_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Model","(excerpts.ExcerptTypes.content_type) The model that can issue printouts of this type.") }, "name": "content_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.gfks.ContentTypes.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/content_type" }) }) });
    var primary2987 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Prim\u00e4r", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Primary","(excerpts.ExcerptTypes.primary) Whether this is the default type to use for this model. There's at most one primary type per model. Enabling this field will automatically make the other types non-primary.") }, "name": "primary", "selectOnFocus": true });
    var certifying2988 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Bescheinigend", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Certifying","(excerpts.ExcerptTypes.certifying) Whether an excerpt of this type is a unique printout.") }, "name": "certifying", "selectOnFocus": true });
    var main_2_panel2989 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": content_type2986, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": primary2987, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": certifying2988, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var build_method2993 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Konstruktionsmethode</span>", "forceSelection": true, "hiddenName": "build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Build method","(excerpts.ExcerptTypes.build_method) See lino.modlib.printing.mixins.PrintableType.build_method.") }, "name": "build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var template2994 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Vorlage</span>", "listeners": { "render": Lino.quicktip_renderer("Template","(excerpts.ExcerptTypes.template) The main template to be used when printing an excerpt of this type.") }, "name": "template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/template" }) }) });
    var body_template2995 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Textk\u00f6rper-Vorlage</span>", "listeners": { "render": Lino.quicktip_renderer("Body template","(excerpts.ExcerptTypes.body_template) The body template to be used when         rendering a printable of this type. This is a list of files         with extension `.body.html`.") }, "name": "body_template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/body_template" }) }) });
    var main_3_panel2996 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 53, "items": build_method2993, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": template2994, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": body_template2995, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3000 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2982, main_2_panel2989, main_3_panel2996 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel3000;
    this.before_row_edit = function(record) {
      template2994.setContextValue('build_method', record ? record.data['build_methodHidden'] : undefined);
      template2994.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
      body_template2995.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      build_method2993.on('change',Lino.chooser_handler(template2994,'build_method'));
      content_type2986.on('change',Lino.chooser_handler(template2994,'content_type'));
      content_type2986.on('change',Lino.chooser_handler(body_template2995,'content_type'));
      Lino.excerpts.ExcerptTypes.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.excerpts.ExcerptTypes.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.PaymentTerms.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 39,
  initComponent : function() {
    var ref3001 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Referenz</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(ledger.PaymentTerms.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var months3002 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Monate</span>", "listeners": { "render": Lino.quicktip_renderer("Months","(ledger.PaymentTerms.months) Number of months to add to voucher_date.") }, "name": "months", "selectOnFocus": true, "value": 0 });
    var days3003 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Tage</span>", "listeners": { "render": Lino.quicktip_renderer("Days","(ledger.PaymentTerms.days) Number of days to add to voucher_date.") }, "name": "days", "selectOnFocus": true, "value": 0 });
    var end_of_month3004 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Monatsende", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("End of month","(ledger.PaymentTerms.end_of_month) Whether to move voucher_date to the end of month.") }, "name": "end_of_month", "selectOnFocus": true });
    var main_1_panel3005 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 51, "items": ref3001, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": months3002, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": days3003, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": end_of_month3004, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name3010 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(ledger.PaymentTerms.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3011 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(ledger.PaymentTerms.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3012 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(ledger.PaymentTerms.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel3013 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3010, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3011, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3012, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var printed_text3017 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Printed text</span>", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Printed text","(ledger.PaymentTerms.printed_text) Used in sales/VatProductInvoice/trailer.html as\nfollows:") }, "name": "printed_text", "selectOnFocus": true });
    var printed_text_de3018 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Printed text (de)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Printed text (de)","(ledger.PaymentTerms.printed_text_de) ") }, "name": "printed_text_de", "selectOnFocus": true });
    var printed_text_fr3019 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Printed text (fr)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Printed text (fr)","(ledger.PaymentTerms.printed_text_fr) ") }, "name": "printed_text_fr", "selectOnFocus": true });
    var main_3_panel3020 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 71, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 33, "items": printed_text3017, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": printed_text_de3018, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": printed_text_fr3019, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var main_panel3024 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3005, main_2_panel3013, main_3_panel3020 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3024;
    this.before_row_edit = function(record) {
    }
    Lino.ledger.PaymentTerms.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.plausibility.Problems.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 17,
  disable_editing: true,
  initComponent : function() {
    var checker543 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datentest</span>", "forceSelection": true, "hiddenName": "checkerHidden", "listeners": { "render": Lino.quicktip_renderer("Datentest","(plausibility.Problems.checker) The Checker which reported\nthis problem.") }, "name": "checker", "selectOnFocus": true, "store": Lino.plausibility.Checkers });
    var owner_disp544 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Verkn\u00fcpft mit", "name": "owner" });
    var message545 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Meldung</span>", "listeners": { "render": Lino.quicktip_renderer("Meldung","(plausibility.Problems.message) The message text. This is a concatenation of all messages that\nwere yeld by the checker.") }, "maxLength": 250, "name": "message", "selectOnFocus": true });
    var user546 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Verantwortlicher</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Verantwortlicher","(plausibility.Problems.user) The user reponsible\nfor fixing this problem.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/Problems/user" }) }) });
    var id547 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(plausibility.Problems.id) ") }, "name": "id", "selectOnFocus": true });
    var main_4_panel548 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 66, "items": user546, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": id547, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel551 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": checker543, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": owner_disp544, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": message545, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_4_panel548 ], "labelAlign": "top", "labelWidth": 126, "layout": "form" });
    this.items = main_panel551;
    this.before_row_edit = function(record) {
    }
    Lino.plausibility.Problems.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Courses.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 52,
  initComponent : function() {
    var ref3025 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Referenz</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(courses.Courses.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.") }, "maxLength": 40, "name": "ref", "preferred_with": 6, "selectOnFocus": true });
    var line3026 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Aktivit\u00e4tenreihe</span>", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Activity line","(courses.Courses.line) Pointer to the course series.") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/line" }) }) });
    var teacher3027 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kursleiter ausw\u00e4hlen...", "fieldLabel": "Kursleiter", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor","(courses.Courses.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/teacher" }) }) });
    var workflow_buttons_disp3028 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(courses.Courses.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_1_panel3029 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 23, "items": ref3025, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": line3026, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": teacher3027, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": workflow_buttons_disp3028, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room3034 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Raum ausw\u00e4hlen...", "fieldLabel": "Raum", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(courses.Courses.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/room" }) }) });
    var start_date3035 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Start date","(courses.Courses.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var end_date3036 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(courses.Courses.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var start_time3037 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(courses.Courses.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time3038 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Endet um", "listeners": { "render": Lino.quicktip_renderer("End Time","(courses.Courses.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var general_2_panel3039 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 32, "items": room3034, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": start_date3035, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": end_date3036, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": start_time3037, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": end_time3038, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name3045 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Courses.name) A short designation for this course. An extension of the\nref.") }, "maxLength": 100, "name": "name", "selectOnFocus": true });
    var remark3046 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkung", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.Courses.remark) ") }, "name": "remark", "selectOnFocus": true });
    var general_panel3047 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel3029, general_2_panel3039, { "autoHeight": true, "items": name3045, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 50, "items": remark3046, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var every_unit3050 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Wiederholung", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(courses.Courses.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every3051 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "... alle", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(courses.Courses.every) ") }, "name": "every", "selectOnFocus": true });
    var max_date3052 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Termine generieren bis", "listeners": { "render": Lino.quicktip_renderer("Generate events until","(courses.Courses.max_date) ") }, "name": "max_date", "selectOnFocus": true });
    var max_events3053 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Anzahl Termine", "listeners": { "render": Lino.quicktip_renderer("Number of events","(courses.Courses.max_events) ") }, "name": "max_events", "selectOnFocus": true });
    var events_1_panel3054 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 47, "items": every_unit3050, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": every3051, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": max_date3052, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": max_events3053, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var monday3059 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Montag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Monday","(courses.Courses.monday) ") }, "name": "monday", "selectOnFocus": true });
    var tuesday3060 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Dienstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Tuesday","(courses.Courses.tuesday) ") }, "name": "tuesday", "selectOnFocus": true });
    var wednesday3061 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Mittwoch", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wednesday","(courses.Courses.wednesday) ") }, "name": "wednesday", "selectOnFocus": true });
    var thursday3062 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Donnerstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Thursday","(courses.Courses.thursday) ") }, "name": "thursday", "selectOnFocus": true });
    var friday3063 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Freitag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Friday","(courses.Courses.friday) ") }, "name": "friday", "selectOnFocus": true });
    var saturday3064 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Samstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Saturday","(courses.Courses.saturday) ") }, "name": "saturday", "selectOnFocus": true });
    var sunday3065 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Sonntag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Sunday","(courses.Courses.sunday) ") }, "name": "sunday", "selectOnFocus": true });
    var events_2_panel3066 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": monday3059, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": tuesday3060, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": wednesday3061, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": thursday3062, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": friday3063, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": saturday3064, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": sunday3065, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_EntriesByCourse_htmlbox3074 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 60, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(courses.Courses.courses_EntriesByCourse) Shows the events linked to this course.") }, "master_panel": this, "name": "courses_EntriesByCourse", "title": "Kalendereintr\u00e4ge", "tools": [ Lino.show_in_own_window_button(Lino.courses.EntriesByCourse.grid) ], "value": "<br/>" });
    var events_panel3075 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ events_1_panel3054, events_2_panel3066, courses_EntriesByCourse_htmlbox3074 ], "labelAlign": "top", "labelWidth": 153, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Veranstaltungen" });
    var enrolments_until3076 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Einschreibung m\u00f6glich bis", "listeners": { "render": Lino.quicktip_renderer("Enrolments until","(courses.Courses.enrolments_until) ") }, "name": "enrolments_until", "selectOnFocus": true });
    var fee3077 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarif ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Standard-Teilnehmahmegeb\u00fchr</span>", "hiddenName": "feeHidden", "listeners": { "render": Lino.quicktip_renderer("Default participation fee","(courses.Courses.fee) The default participation fee to apply for new enrolments.") }, "name": "fee", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/fee" }) }) });
    var max_places3078 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Verf\u00fcgbare Pl\u00e4tze</span>", "listeners": { "render": Lino.quicktip_renderer("Available places","(courses.Courses.max_places) Maximum number of participants") }, "name": "max_places", "selectOnFocus": true });
    var confirmed3079 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Best\u00e4tigt", "listeners": { "render": Lino.quicktip_renderer("Confirmed","(courses.Courses.confirmed) ") }, "name": "confirmed" });
    var free_places3080 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Freie Pl\u00e4tze", "listeners": { "render": Lino.quicktip_renderer("Free places","(courses.Courses.free_places) ") }, "name": "free_places" });
    var print_actions_disp3081 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Drucken", "listeners": { "render": Lino.quicktip_renderer("Print","(courses.Courses.print_actions) ") }, "name": "print_actions", "value": "<br/>" });
    var enrolments_top_panel3082 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 19, "items": enrolments_until3076, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": fee3077, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": max_places3078, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": confirmed3079, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": free_places3080, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": print_actions_disp3081, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 234, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EnrolmentsByCourse_htmlbox3089 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Enrolments","(courses.Courses.EnrolmentsByCourse) The Voga version of EnrolmentsByCourse.") }, "ls_bbar_actions": [ { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" } ], "ls_insert_handler": Lino.courses.EnrolmentsByCourse.insert, "master_panel": this, "name": "EnrolmentsByCourse", "title": "Einschreibungen", "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByCourse.grid) ], "value": "<br/>" });
    var enrolments_panel3090 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ enrolments_top_panel3082, EnrolmentsByCourse_htmlbox3089 ], "labelAlign": "top", "labelWidth": 99, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Einschreibungen" });
    var state3091 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(courses.Courses.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".") }, "name": "state", "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var user3092 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.Courses.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/user" }) }) });
    var payment_term3093 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zahlungsbedingung</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(courses.Courses.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/payment_term" }) }) });
    var paper_type3094 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Papierart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Papierart</span>", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(courses.Courses.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/paper_type" }) }) });
    var id3095 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Courses.id) ") }, "name": "id", "selectOnFocus": true });
    var more_1_panel3096 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": state3091, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": user3092, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": payment_term3093, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": paper_type3094, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": id3095, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var invoicing_InvoicingsByInvoiceable_grid3102 = new Lino.invoicing.InvoicingsByInvoiceable.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Invoicings","(invoicing.invoicing.InvoicingsByInvoiceable) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.invoicing.InvoicingsByInvoiceable.grid) ] });
    var more_panel3103 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel3096, invoicing_InvoicingsByInvoiceable_grid3102 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var main_panel3104 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel3047, events_panel3075, enrolments_panel3090, more_panel3103 ], "labelAlign": "top", "split": true });
    this.items = main_panel3104;
    this.before_row_edit = function(record) {
      courses_EntriesByCourse_htmlbox3074.refresh();
      fee3077.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      EnrolmentsByCourse_htmlbox3089.refresh();
      invoicing_InvoicingsByInvoiceable_grid3102.on_master_changed();
    }
    this.onRender = function(ct, position) {
      line3026.on('change',Lino.chooser_handler(fee3077,'line'));
      Lino.courses.Courses.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Courses.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Enrolments.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 53,
  initComponent : function() {
    var id1865 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Enrolments.id) ") }, "name": "id", "selectOnFocus": true });
    var course1866 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Activity ausw\u00e4hlen...", "fieldLabel": "Activity", "hiddenName": "courseHidden", "listeners": { "render": Lino.quicktip_renderer("Activity","(courses.Enrolments.course) ") }, "name": "course", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Activities.detail,Lino.courses.Activities.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/course" }) }) });
    var pupil1867 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Teilnehmer ausw\u00e4hlen...", "fieldLabel": "Teilnehmer", "forceSelection": false, "hiddenName": "pupilHidden", "listeners": { "render": Lino.quicktip_renderer("Participant","(courses.Enrolments.pupil) ") }, "name": "pupil", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Pupils.detail,Lino.courses.Pupils.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/pupil" }) }) });
    var request_date1868 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Datum der Anfrage", "listeners": { "render": Lino.quicktip_renderer("Date of request","(courses.Enrolments.request_date) ") }, "name": "request_date", "selectOnFocus": true });
    var user1869 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.Enrolments.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/user" }) }) });
    var main_1_panel1870 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 6, "items": id1865, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": course1866, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": pupil1867, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": request_date1868, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": user1869, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var start_date1876 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Start date","(courses.Enrolments.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var end_date1877 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Enddatum", "listeners": { "render": Lino.quicktip_renderer("End date","(courses.Enrolments.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var places1878 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Anz. Pl\u00e4tze</span>", "listeners": { "render": Lino.quicktip_renderer("Places used","(courses.Enrolments.places) The number of participants in this enrolment.") }, "name": "places", "selectOnFocus": true, "value": 1 });
    var fee1879 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarif ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Tarif</span>", "hiddenName": "feeHidden", "listeners": { "render": Lino.quicktip_renderer("Tariff","(courses.Enrolments.fee) The participation fee to apply for this enrolment.") }, "name": "fee", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/fee" }) }) });
    var free_events1880 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Free events</span>", "listeners": { "render": Lino.quicktip_renderer("Free events","(courses.Enrolments.free_events) Number of events to add for first invoicing for this enrolment.") }, "name": "free_events", "selectOnFocus": true });
    var amount1881 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Betrag</span>", "listeners": { "render": Lino.quicktip_renderer("Amount","(courses.Enrolments.amount) The total amount to pay for this enrolment. This is\nplaces * fee.") }, "name": "amount", "selectOnFocus": true });
    var main_2_panel1882 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 17, "items": start_date1876, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 17, "items": end_date1877, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": places1878, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": fee1879, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": free_events1880, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": amount1881, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remark1889 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bemerkung", "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.Enrolments.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var workflow_buttons_disp1890 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(courses.Enrolments.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var printed_disp1891 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Ausgedruckt", "listeners": { "render": Lino.quicktip_renderer("Printed","(courses.Enrolments.printed) ") }, "name": "printed", "value": "<br/>" });
    var invoicing_info_disp1892 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Info Fakturation", "listeners": { "render": Lino.quicktip_renderer("Invoicing info","(courses.Enrolments.invoicing_info) ") }, "name": "invoicing_info", "value": "<br/>" });
    var main_3_panel1893 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 18, "items": remark1889, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": workflow_buttons_disp1890, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": printed_disp1891, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": invoicing_info_disp1892, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var confirmation_details1898 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Details Best\u00e4tigung", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Confirmation details","(courses.Enrolments.confirmation_details) ") }, "name": "confirmation_details", "selectOnFocus": true });
    var invoicing_InvoicingsByInvoiceable_grid1899 = new Lino.invoicing.InvoicingsByInvoiceable.GridPanel({ "containing_panel": this, "flex": 66, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Invoicings","(invoicing.invoicing.InvoicingsByInvoiceable) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.invoicing.InvoicingsByInvoiceable.grid) ] });
    var main_4_panel1900 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 33, "items": confirmation_details1898, "labelAlign": "top", "layout": "form", "xtype": "panel" }, invoicing_InvoicingsByInvoiceable_grid1899 ], "labelAlign": "top", "labelWidth": 189, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var main_panel1902 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1870, main_2_panel1882, main_3_panel1893, main_4_panel1900 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1902;
    this.before_row_edit = function(record) {
      course1866.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course1866.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil1867.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee1879.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      invoicing_InvoicingsByInvoiceable_grid1899.on_master_changed();
    }
    this.onRender = function(ct, position) {
      request_date1868.on('change',Lino.chooser_handler(course1866,'request_date'));
      course1866.on('change',Lino.chooser_handler(pupil1867,'course'));
      course1866.on('change',Lino.chooser_handler(fee1879,'course'));
      Lino.courses.Enrolments.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Enrolments.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.uploads.UploadsByController.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 71,
  initComponent : function() {
    var file3105 = Lino.file_field_handler(this,{ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datei</span>", "listeners": { "render": Lino.quicktip_renderer("File","(uploads.UploadsByController.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file") }, "maxLength": 100, "name": "file", "selectOnFocus": true });
    var type3106 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Upload-Art ausw\u00e4hlen...", "fieldLabel": "Upload-Art", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Type","(uploads.UploadsByController.type) ") }, "name": "type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.uploads.UploadTypes.detail,Lino.uploads.UploadTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByController/type" }) }) });
    var description3107 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Beschreibung</span>", "listeners": { "render": Lino.quicktip_renderer("Description","(uploads.UploadsByController.description) A short description entered manually by the user.") }, "maxLength": 200, "name": "description", "selectOnFocus": true });
    var main_panel3108 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": file3105, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": type3106, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": description3107, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "form" });
    this.items = main_panel3108;
    this.before_row_edit = function(record) {
      type3106.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
    }
    Lino.uploads.UploadsByController.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Journals.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 37,
  initComponent : function() {
    var name3112 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(ledger.Journals.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3113 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(ledger.Journals.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3114 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(ledger.Journals.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var ref3115 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Referenz</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(ledger.Journals.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var main_1_panel3116 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": name3112, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de3113, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr3114, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": ref3115, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var trade_type3121 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Handelsart</span>", "forceSelection": true, "hiddenName": "trade_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Trade type","(ledger.Journals.trade_type) Pointer to TradeTypes.") }, "name": "trade_type", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.TradeTypes) });
    var seqno3122 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Nr.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(ledger.Journals.seqno) The sequence number of this item with its parent.") }, "name": "seqno", "selectOnFocus": true });
    var id3123 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(ledger.Journals.id) ") }, "name": "id", "selectOnFocus": true });
    var voucher_type3124 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Belegart</span>", "forceSelection": true, "hiddenName": "voucher_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Voucher type","(ledger.Journals.voucher_type) Pointer to an item of VoucherTypes.") }, "name": "voucher_type", "selectOnFocus": true, "store": Lino.ledger.VoucherTypes });
    var journal_group3125 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journalgruppe</span>", "forceSelection": true, "hiddenName": "journal_groupHidden", "listeners": { "render": Lino.quicktip_renderer("Journal group","(ledger.Journals.journal_group) Pointer to an item of JournalGroups.") }, "name": "journal_group", "selectOnFocus": true, "store": Lino.ledger.JournalGroups });
    var main_2_panel3126 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 28, "items": trade_type3121, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": seqno3122, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": id3123, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": voucher_type3124, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": journal_group3125, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var account3132 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Konto ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Konto</span>", "hiddenName": "accountHidden", "listeners": { "render": Lino.quicktip_renderer("Account","(ledger.Journals.account) The account to use for the counter-movements generated by\nvouchers in this journal.") }, "name": "account", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Journals/account" }) }) });
    var build_method3133 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Konstruktionsmethode", "forceSelection": true, "hiddenName": "build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Build method","(ledger.Journals.build_method) ") }, "name": "build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var template3134 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Vorlage</span>", "listeners": { "render": Lino.quicktip_renderer("Template","(ledger.Journals.template) See PrintableType.template.") }, "name": "template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Journals/template" }) }) });
    var main_3_panel3135 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 37, "items": account3132, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": build_method3133, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": template3134, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var dc3139 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Prim\u00e4re Buchungsrichtung", "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Primary booking direction","(ledger.Journals.dc) Debit (checked) or Credit (not checked)") }, "name": "dc", "selectOnFocus": true });
    var force_sequence3140 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Chronologische Reihenfolge", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Force chronological sequence","(ledger.Journals.force_sequence) ") }, "name": "force_sequence", "selectOnFocus": true });
    var yearly_numbering3141 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Yearly numbering", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Yearly numbering","(ledger.Journals.yearly_numbering) Whether the\nnumber of\nvouchers should restart at 1 every year.") }, "name": "yearly_numbering", "selectOnFocus": true });
    var auto_fill_suggestions3142 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Fill suggestions", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Fill suggestions","(ledger.Journals.auto_fill_suggestions) Whether to automatically fill voucher item from due payments\nof the partner when entering a financial voucher.") }, "name": "auto_fill_suggestions", "selectOnFocus": true });
    var auto_check_clearings3143 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Begleichung pr\u00fcfen", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Check clearing","(ledger.Journals.auto_check_clearings) Whether to automatically check and update the 'cleared' status\nof involved transactions when (de)registering a voucher of\nthis journal.") }, "name": "auto_check_clearings", "selectOnFocus": true });
    var must_declare3144 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "must declare", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("must declare","(ledger.Journals.must_declare) ") }, "name": "must_declare", "selectOnFocus": true });
    var main_4_panel3145 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 16, "items": dc3139, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": force_sequence3140, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": yearly_numbering3141, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": auto_fill_suggestions3142, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": auto_check_clearings3143, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": must_declare3144, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 261, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var printed_name3152 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Dokumentbezeichnung Ausdruck", "listeners": { "render": Lino.quicktip_renderer("Printed document designation","(ledger.Journals.printed_name) ") }, "maxLength": 100, "name": "printed_name", "selectOnFocus": true });
    var printed_name_de3153 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Dokumentbezeichnung Ausdruck (de)", "listeners": { "render": Lino.quicktip_renderer("Printed document designation (de)","(ledger.Journals.printed_name_de) ") }, "maxLength": 100, "name": "printed_name_de", "selectOnFocus": true });
    var printed_name_fr3154 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Dokumentbezeichnung Ausdruck (fr)", "listeners": { "render": Lino.quicktip_renderer("Printed document designation (fr)","(ledger.Journals.printed_name_fr) ") }, "maxLength": 100, "name": "printed_name_fr", "selectOnFocus": true });
    var main_5_panel3155 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": printed_name3152, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": printed_name_de3153, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": printed_name_fr3154, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 306, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MatchRulesByJournal_grid3166 = new Lino.ledger.MatchRulesByJournal.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Match rules","(ledger.ledger.MatchRulesByJournal) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.ledger.MatchRulesByJournal.grid) ] });
    var main_panel3167 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3116, main_2_panel3126, main_3_panel3135, main_4_panel3145, main_5_panel3155, MatchRulesByJournal_grid3166 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3167;
    this.before_row_edit = function(record) {
      template3134.setContextValue('build_method', record ? record.data['build_methodHidden'] : undefined);
      template3134.setContextValue('voucher_type', record ? record.data['voucher_typeHidden'] : undefined);
      MatchRulesByJournal_grid3166.on_master_changed();
    }
    this.onRender = function(ct, position) {
      build_method3133.on('change',Lino.chooser_handler(template3134,'build_method'));
      voucher_type3124.on('change',Lino.chooser_handler(template3134,'voucher_type'));
      Lino.ledger.Journals.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.ledger.Journals.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Persons.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 8,
  initComponent : function() {
    var overview_disp3168 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Beschreibung", "listeners": { "render": Lino.quicktip_renderer("Description","(contacts.Persons.overview) ") }, "name": "overview", "value": "<br/>" });
    var email3169 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">E-Mail-Adresse</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(contacts.Persons.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var phone3170 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Telefon</span>", "listeners": { "render": Lino.quicktip_renderer("Phone","(contacts.Persons.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.") }, "maxLength": 200, "name": "phone", "selectOnFocus": true });
    var gsm3171 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">GSM</span>", "listeners": { "render": Lino.quicktip_renderer("GSM","(contacts.Persons.gsm) The primary mobile phone number.") }, "maxLength": 200, "name": "gsm", "selectOnFocus": true });
    var contact_box_panel3172 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 37, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": email3169, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": phone3170, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": gsm3171, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    var lists_MembersByPartner_grid3176 = new Lino.lists.MembersByPartner.GridPanel({ "containing_panel": this, "flex": 25, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("List memberships","(lists.lists.MembersByPartner) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.lists.MembersByPartner.grid) ] });
    var general_1_panel3177 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 37, "items": overview_disp3168, "labelAlign": "top", "layout": "form", "xtype": "panel" }, contact_box_panel3172, lists_MembersByPartner_grid3176 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks3179 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkungen", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(contacts.Persons.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var plausibility_ProblemsByOwner_htmlbox3180 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 37, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Plausibility problems","(contacts.Persons.plausibility_ProblemsByOwner) Show data problems related to this database object.") }, "master_panel": this, "name": "plausibility_ProblemsByOwner", "title": "Datenprobleme", "tools": [ Lino.show_in_own_window_button(Lino.plausibility.ProblemsByOwner.grid) ], "value": "<br/>" });
    var bottom_box_1_panel3181 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 62, "items": remarks3179, "labelAlign": "top", "layout": "form", "xtype": "panel" }, plausibility_ProblemsByOwner_htmlbox3180 ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var general_panel3183 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel3177, bottom_box_1_panel3181 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var last_name3184 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Familienname</span>", "listeners": { "render": Lino.quicktip_renderer("Last name","(contacts.Persons.last_name) The last name, also known as family name.") }, "maxLength": 200, "name": "last_name", "selectOnFocus": true });
    var first_name3185 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Vorname</span>", "listeners": { "render": Lino.quicktip_renderer("First name","(contacts.Persons.first_name) The first name, also known as given name.") }, "maxLength": 200, "name": "first_name", "selectOnFocus": true });
    var gender3186 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Geschlecht</span>", "forceSelection": true, "hiddenName": "genderHidden", "listeners": { "render": Lino.quicktip_renderer("Gender","(contacts.Persons.gender) The sex of this person (male or female).") }, "name": "gender", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var address_box_1_panel3187 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 46, "items": last_name3184, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": first_name3185, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": gender3186, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var street3191 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Street","(contacts.Persons.street) ") }, "maxLength": 200, "name": "street", "selectOnFocus": true });
    var street_box3192 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Box", "listeners": { "render": Lino.quicktip_renderer("Box","(contacts.Persons.street_box) ") }, "maxLength": 10, "name": "street_box", "selectOnFocus": true });
    var address_box_2_panel3193 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 69, "items": street3191, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": street_box3192, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var country3196 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Land ausw\u00e4hlen...", "fieldLabel": "Land", "hiddenName": "countryHidden", "listeners": { "render": Lino.quicktip_renderer("Country","(contacts.Persons.country) ") }, "name": "country", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Countries.detail,Lino.countries.Countries.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/country" }) }) });
    var zip_code3197 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Postleitzahl", "listeners": { "render": Lino.quicktip_renderer("Zip code","(contacts.Persons.zip_code) ") }, "maxLength": 10, "name": "zip_code", "selectOnFocus": true });
    var city3198 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Ort ausw\u00e4hlen...", "fieldLabel": "Locality", "forceSelection": false, "hiddenName": "cityHidden", "listeners": { "render": Lino.quicktip_renderer("Locality","(contacts.Persons.city) ") }, "name": "city", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Places.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/city" }) }) });
    var address_box_3_panel3199 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": country3196, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": zip_code3197, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": city3198, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var birth_date3203 = new Lino.IncompleteDateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Geburtsdatum</span>", "listeners": { "render": Lino.quicktip_renderer("Birth date","(contacts.Persons.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".") }, "name": "birth_date", "selectOnFocus": true });
    var age_disp3204 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Alter", "listeners": { "render": Lino.quicktip_renderer("Age","(contacts.Persons.age) ") }, "name": "age", "value": "<br/>" });
    var national_id3205 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">NR-Nummer</span>", "listeners": { "render": Lino.quicktip_renderer("National ID","(contacts.Persons.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.") }, "maxLength": 200, "name": "national_id", "selectOnFocus": true });
    var card_number3206 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "eID-Kartennummer", "listeners": { "render": Lino.quicktip_renderer("eID card number","(contacts.Persons.card_number) ") }, "maxLength": 20, "name": "card_number", "selectOnFocus": true });
    var personal_panel3207 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 65, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": national_id3205, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": card_number3206, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_4_panel3210 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 18, "items": birth_date3203, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": age_disp3204, "labelAlign": "top", "layout": "form", "xtype": "panel" }, personal_panel3207 ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_panel3213 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_1_panel3187, address_box_2_panel3193, address_box_3_panel3199, address_box_4_panel3210 ], "labelAlign": "top", "layout": "form" });
    var contacts_RolesByPerson_grid3214 = new Lino.contacts.RolesByPerson.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Contact for","(contacts.contacts.RolesByPerson) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.contacts.RolesByPerson.grid) ] });
    var sepa_AccountsByPartner_grid3215 = new Lino.sepa.AccountsByPartner.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(sepa.sepa.AccountsByPartner) Show the bank account(s) defined for a given partner. To be\nincluded to a detail window on partner.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sepa.AccountsByPartner.grid) ] });
    var address_2_panel3216 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 45, "frame": false, "hideCheckBoxLabels": true, "items": [ contacts_RolesByPerson_grid3214, sepa_AccountsByPartner_grid3215 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var address_panel3217 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_panel3213, address_2_panel3216 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Adresse" });
    var invoice_recipient3218 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Fakturationsadresse</span>", "hiddenName": "invoice_recipientHidden", "listeners": { "render": Lino.quicktip_renderer("Invoicing address","(contacts.Persons.invoice_recipient) Redirect to another partner all invoices which should go to this partner.") }, "name": "invoice_recipient", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/invoice_recipient" }) }) });
    var vat_regime3219 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "MwSt.-Regime", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(contacts.Persons.vat_regime) ") }, "name": "vat_regime", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var ledger_a_1_panel3220 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 52, "items": invoice_recipient3218, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 47, "items": vat_regime3219, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var payment_term3223 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zahlungsbedingung</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(contacts.Persons.payment_term) The default payment term for sales invoices to this customer.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/payment_term" }) }) });
    var paper_type3224 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Papierart ausw\u00e4hlen...", "fieldLabel": "Papierart", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(contacts.Persons.paper_type) ") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/paper_type" }) }) });
    var ledger_a_2_panel3225 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": payment_term3223, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": paper_type3224, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ledger_a_panel3228 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 57, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_a_1_panel3220, ledger_a_2_panel3225 ], "labelAlign": "top", "layout": "form" });
    var ledger_MovementsByPartner_htmlbox3229 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 42, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(contacts.Persons.ledger_MovementsByPartner) ") }, "master_panel": this, "name": "ledger_MovementsByPartner", "title": "Bewegungen", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByPartner.grid) ], "value": "<br/>" });
    var ledger_1_panel3230 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ ledger_a_panel3228, ledger_MovementsByPartner_htmlbox3229 ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var sales_InvoicesByPartner_grid3231 = new Lino.sales.InvoicesByPartner.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Product invoices","(sales.sales.InvoicesByPartner) Base class for tables of partner vouchers.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sales.InvoicesByPartner.grid) ] });
    var ledger_panel3232 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel3230, sales_InvoicesByPartner_grid3231 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Buchhaltung" });
    var id3233 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(contacts.Persons.id) ") }, "name": "id", "selectOnFocus": true });
    var language3234 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Sprache</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(contacts.Persons.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var url3235 = new Lino.URLField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresse (URL)", "listeners": { "render": Lino.quicktip_renderer("URL","(contacts.Persons.url) ") }, "maxLength": 200, "name": "url", "selectOnFocus": true });
    var more_1_panel3236 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 10, "items": id3233, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": language3234, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 45, "items": url3235, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr13240 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresszeile vor Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Address line before street","(contacts.Persons.addr1) ") }, "maxLength": 200, "name": "addr1", "selectOnFocus": true });
    var addr23241 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresszeile nach Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Address line after street","(contacts.Persons.addr2) ") }, "maxLength": 200, "name": "addr2", "selectOnFocus": true });
    var more_2_panel3242 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": addr13240, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": addr23241, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 243, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var notes_NotesByPerson_grid3245 = new Lino.notes.NotesByPerson.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notes","(notes.notes.NotesByPerson) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByPerson.grid) ] });
    var more_panel3246 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel3236, more_2_panel3242, notes_NotesByPerson_grid3245 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var main_panel3247 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel3183, address_panel3217, ledger_panel3232, more_panel3246 ], "labelAlign": "top", "split": true });
    this.items = main_panel3247;
    this.before_row_edit = function(record) {
      lists_MembersByPartner_grid3176.on_master_changed();
      plausibility_ProblemsByOwner_htmlbox3180.refresh();
      city3198.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city3198.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      contacts_RolesByPerson_grid3214.on_master_changed();
      sepa_AccountsByPartner_grid3215.on_master_changed();
      ledger_MovementsByPartner_htmlbox3229.refresh();
      sales_InvoicesByPartner_grid3231.on_master_changed();
      notes_NotesByPerson_grid3245.on_master_changed();
    }
    this.onRender = function(ct, position) {
      country3196.on('change',Lino.chooser_handler(city3198,'country'));
      Lino.contacts.Persons.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.contacts.Persons.DetailFormPanel.superclass.initComponent.call(this);
    // active_fields:
    city3198.on("change", function(){ this.save() }, this);
    zip_code3197.on("change", function(){ this.save() }, this);
  }
});


Lino.sales.InvoiceItems.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 44,
  initComponent : function() {
    var product1639 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarif ausw\u00e4hlen...", "fieldLabel": "Tarif", "hiddenName": "productHidden", "listeners": { "render": Lino.quicktip_renderer("Tariff","(sales.InvoiceItems.product) ") }, "name": "product", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoiceItems/product" }) }) });
    var discount1640 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "Erm\u00e4\u00dfigung", "listeners": { "render": Lino.quicktip_renderer("Discount","(sales.InvoiceItems.discount) ") }, "name": "discount", "selectOnFocus": true });
    var qty1641 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(6), "fieldLabel": "Menge", "listeners": { "render": Lino.quicktip_renderer("Quantity","(sales.InvoiceItems.qty) ") }, "maxLength": 6, "name": "qty", "selectOnFocus": true });
    var main_1_panel1642 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 58, "items": product1639, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": discount1640, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": qty1641, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var title1646 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "\u00dcberschrift", "listeners": { "render": Lino.quicktip_renderer("Heading","(sales.InvoiceItems.title) ") }, "maxLength": 200, "name": "title", "selectOnFocus": true });
    var main_panel1647 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1642, { "anchor": "-20", "autoHeight": true, "items": title1646, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 72, "layout": "form" });
    this.items = main_panel1647;
    this.before_row_edit = function(record) {
    }
    Lino.sales.InvoiceItems.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Journals.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 37,
  initComponent : function() {
    var ref3248 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Referenz</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(ledger.Journals.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var name3249 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(ledger.Journals.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3250 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(ledger.Journals.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3251 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(ledger.Journals.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3252 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 25, "items": ref3248, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name3249, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_de3250, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_fr3251, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var journal_group3257 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journalgruppe</span>", "forceSelection": true, "hiddenName": "journal_groupHidden", "listeners": { "render": Lino.quicktip_renderer("Journal group","(ledger.Journals.journal_group) Pointer to an item of JournalGroups.") }, "name": "journal_group", "selectOnFocus": true, "store": Lino.ledger.JournalGroups });
    var voucher_type3258 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Belegart</span>", "forceSelection": true, "hiddenName": "voucher_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Voucher type","(ledger.Journals.voucher_type) Pointer to an item of VoucherTypes.") }, "name": "voucher_type", "selectOnFocus": true, "store": Lino.ledger.VoucherTypes });
    var main_panel3259 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3252, { "anchor": "-20", "autoHeight": true, "items": journal_group3257, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": voucher_type3258, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "form" });
    this.items = main_panel3259;
    this.before_row_edit = function(record) {
    }
    Lino.ledger.Journals.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Enrolments.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 53,
  initComponent : function() {
    var request_date2080 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Datum der Anfrage", "listeners": { "render": Lino.quicktip_renderer("Date of request","(courses.Enrolments.request_date) ") }, "name": "request_date", "selectOnFocus": true });
    var user2081 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.Enrolments.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/user" }) }) });
    var main_1_panel2082 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": request_date2080, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 60, "items": user2081, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var course2085 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Activity ausw\u00e4hlen...", "fieldLabel": "Activity", "hiddenName": "courseHidden", "listeners": { "render": Lino.quicktip_renderer("Activity","(courses.Enrolments.course) ") }, "name": "course", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Activities.detail,Lino.courses.Activities.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/course" }) }) });
    var pupil2086 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Teilnehmer ausw\u00e4hlen...", "fieldLabel": "Teilnehmer", "forceSelection": false, "hiddenName": "pupilHidden", "listeners": { "render": Lino.quicktip_renderer("Participant","(courses.Enrolments.pupil) ") }, "name": "pupil", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Pupils.detail,Lino.courses.Pupils.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/pupil" }) }) });
    var main_2_panel2087 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": course2085, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": pupil2086, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remark2090 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bemerkung", "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.Enrolments.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var main_panel2091 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2082, main_2_panel2087, { "anchor": "-20", "autoHeight": true, "items": remark2090, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "form" });
    this.items = main_panel2091;
    this.before_row_edit = function(record) {
      course2085.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course2085.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil2086.setContextValue('course', record ? record.data['courseHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      request_date2080.on('change',Lino.chooser_handler(course2085,'request_date'));
      course2085.on('change',Lino.chooser_handler(pupil2086,'course'));
      Lino.courses.Enrolments.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Enrolments.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.accounts.Groups.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 34,
  initComponent : function() {
    var name3262 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(accounts.Groups.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3263 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(accounts.Groups.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3264 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(accounts.Groups.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3265 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3262, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3263, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3264, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var account_type3269 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Kontenart", "forceSelection": true, "hiddenName": "account_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Account Type","(accounts.Groups.account_type) ") }, "name": "account_type", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.accounts.AccountTypes) });
    var ref3270 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ref", "listeners": { "render": Lino.quicktip_renderer("ref","(accounts.Groups.ref) ") }, "maxLength": 20, "name": "ref", "selectOnFocus": true });
    var main_2_panel3271 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 43, "items": account_type3269, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 56, "items": ref3270, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3274 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3265, main_2_panel3271 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel3274;
    this.before_row_edit = function(record) {
    }
    Lino.accounts.Groups.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.accounts.Accounts.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 33,
  initComponent : function() {
    var ref2283 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Referenz</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(accounts.Accounts.ref) An optional unique name which can be used to reference a given\naccount.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var group2284 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kontengruppe ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kontengruppe</span>", "hiddenName": "groupHidden", "listeners": { "render": Lino.quicktip_renderer("Account Group","(accounts.Accounts.group) The account group to which this account belongs.  Points to\nan instance of Group.  If this field is empty, the\naccount won't appear in certain reports.") }, "name": "group", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.accounts.Groups.detail,Lino.accounts.Groups.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/accounts/Accounts/group" }) }) });
    var type2285 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kontenart</span>", "forceSelection": true, "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Account Type","(accounts.Accounts.type) The account type of this account.  This points to an item of\nAccountTypes.") }, "name": "type", "selectOnFocus": true, "store": Lino.accounts.AccountTypes });
    var id2286 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(accounts.Accounts.id) ") }, "name": "id", "selectOnFocus": true });
    var main_1_panel2287 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": ref2283, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": group2284, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": type2285, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": id2286, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name2292 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(accounts.Accounts.name) The multilingual designation of this account, as the users see\nit.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2293 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(accounts.Accounts.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2294 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(accounts.Accounts.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel2295 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2292, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2293, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2294, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var needs_partner2299 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Braucht Partner", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Needs partner","(accounts.Accounts.needs_partner) Whether bookings to this account need a partner specified.") }, "name": "needs_partner", "selectOnFocus": true });
    var clearable2300 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Auszugleichen", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Clearable","(accounts.Accounts.clearable) ") }, "name": "clearable", "selectOnFocus": true });
    var default_amount2301 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Vorschlag Betrag</span>", "listeners": { "render": Lino.quicktip_renderer("Default amount","(accounts.Accounts.default_amount) The default amount to book in bank statements or journal\nentries when this account has been selected manually. The\ndefault booking direction is that of the type.") }, "name": "default_amount", "selectOnFocus": true });
    var main_3_panel2302 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 42, "items": needs_partner2299, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 42, "items": clearable2300, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": default_amount2301, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MovementsByAccount_htmlbox2306 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(accounts.Accounts.MovementsByAccount) ") }, "master_panel": this, "name": "MovementsByAccount", "title": "Bewegungen", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByAccount.grid) ], "value": "<br/>" });
    var main_panel2307 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2287, main_2_panel2295, main_3_panel2302, MovementsByAccount_htmlbox2306 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2307;
    this.before_row_edit = function(record) {
      MovementsByAccount_htmlbox2306.refresh();
    }
    Lino.accounts.Accounts.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Pupils.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 56,
  initComponent : function() {
    var overview_disp1767 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Beschreibung", "listeners": { "render": Lino.quicktip_renderer("Description","(courses.Pupils.overview) ") }, "name": "overview", "value": "<br/>" });
    var email1768 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">E-Mail-Adresse</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(courses.Pupils.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var phone1769 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Telefon</span>", "listeners": { "render": Lino.quicktip_renderer("Phone","(courses.Pupils.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.") }, "maxLength": 200, "name": "phone", "selectOnFocus": true });
    var gsm1770 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">GSM</span>", "listeners": { "render": Lino.quicktip_renderer("GSM","(courses.Pupils.gsm) The primary mobile phone number.") }, "maxLength": 200, "name": "gsm", "selectOnFocus": true });
    var contact_box_panel1771 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 37, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": email1768, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": phone1769, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": gsm1770, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    var lists_MembersByPartner_grid1775 = new Lino.lists.MembersByPartner.GridPanel({ "containing_panel": this, "flex": 25, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("List memberships","(lists.lists.MembersByPartner) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.lists.MembersByPartner.grid) ] });
    var general_1_panel1776 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 37, "items": overview_disp1767, "labelAlign": "top", "layout": "form", "xtype": "panel" }, contact_box_panel1771, lists_MembersByPartner_grid1775 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks1778 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkungen", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(courses.Pupils.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var plausibility_ProblemsByOwner_htmlbox1779 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 37, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Plausibility problems","(courses.Pupils.plausibility_ProblemsByOwner) Show data problems related to this database object.") }, "master_panel": this, "name": "plausibility_ProblemsByOwner", "title": "Datenprobleme", "tools": [ Lino.show_in_own_window_button(Lino.plausibility.ProblemsByOwner.grid) ], "value": "<br/>" });
    var bottom_box_1_panel1780 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 62, "items": remarks1778, "labelAlign": "top", "layout": "form", "xtype": "panel" }, plausibility_ProblemsByOwner_htmlbox1779 ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var general_panel1782 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel1776, bottom_box_1_panel1780 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var last_name1783 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Familienname</span>", "listeners": { "render": Lino.quicktip_renderer("Last name","(courses.Pupils.last_name) The last name, also known as family name.") }, "maxLength": 200, "name": "last_name", "selectOnFocus": true });
    var first_name1784 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Vorname</span>", "listeners": { "render": Lino.quicktip_renderer("First name","(courses.Pupils.first_name) The first name, also known as given name.") }, "maxLength": 200, "name": "first_name", "selectOnFocus": true });
    var gender1785 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Geschlecht</span>", "forceSelection": true, "hiddenName": "genderHidden", "listeners": { "render": Lino.quicktip_renderer("Gender","(courses.Pupils.gender) The sex of this person (male or female).") }, "name": "gender", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var address_box_1_panel1786 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 46, "items": last_name1783, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": first_name1784, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": gender1785, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var street1790 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Street","(courses.Pupils.street) ") }, "maxLength": 200, "name": "street", "selectOnFocus": true });
    var street_box1791 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Box", "listeners": { "render": Lino.quicktip_renderer("Box","(courses.Pupils.street_box) ") }, "maxLength": 10, "name": "street_box", "selectOnFocus": true });
    var address_box_2_panel1792 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 69, "items": street1790, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": street_box1791, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var country1795 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Land ausw\u00e4hlen...", "fieldLabel": "Land", "hiddenName": "countryHidden", "listeners": { "render": Lino.quicktip_renderer("Country","(courses.Pupils.country) ") }, "name": "country", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Countries.detail,Lino.countries.Countries.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/country" }) }) });
    var zip_code1796 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Postleitzahl", "listeners": { "render": Lino.quicktip_renderer("Zip code","(courses.Pupils.zip_code) ") }, "maxLength": 10, "name": "zip_code", "selectOnFocus": true });
    var city1797 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Ort ausw\u00e4hlen...", "fieldLabel": "Locality", "forceSelection": false, "hiddenName": "cityHidden", "listeners": { "render": Lino.quicktip_renderer("Locality","(courses.Pupils.city) ") }, "name": "city", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Places.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/city" }) }) });
    var address_box_3_panel1798 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": country1795, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": zip_code1796, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": city1797, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var birth_date1802 = new Lino.IncompleteDateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Geburtsdatum</span>", "listeners": { "render": Lino.quicktip_renderer("Birth date","(courses.Pupils.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".") }, "name": "birth_date", "selectOnFocus": true });
    var age_disp1803 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Alter", "listeners": { "render": Lino.quicktip_renderer("Age","(courses.Pupils.age) ") }, "name": "age", "value": "<br/>" });
    var pupil_type1804 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Teilnehmerart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Teilnehmerart</span>", "hiddenName": "pupil_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Participant Type","(courses.Pupils.pupil_type) Pointer to PupilType.") }, "name": "pupil_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.PupilTypes.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/pupil_type" }) }) });
    var national_id1805 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">NR-Nummer</span>", "listeners": { "render": Lino.quicktip_renderer("National ID","(courses.Pupils.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.") }, "maxLength": 200, "name": "national_id", "selectOnFocus": true });
    var card_number1806 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "eID-Kartennummer", "listeners": { "render": Lino.quicktip_renderer("eID card number","(courses.Pupils.card_number) ") }, "maxLength": 20, "name": "card_number", "selectOnFocus": true });
    var personal_panel1807 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 73, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 32, "items": pupil_type1804, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": national_id1805, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": card_number1806, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_4_panel1811 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": birth_date1802, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": age_disp1803, "labelAlign": "top", "layout": "form", "xtype": "panel" }, personal_panel1807 ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_panel1814 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_1_panel1786, address_box_2_panel1792, address_box_3_panel1798, address_box_4_panel1811 ], "labelAlign": "top", "layout": "form" });
    var contacts_RolesByPerson_grid1823 = new Lino.contacts.RolesByPerson.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Contact for","(contacts.contacts.RolesByPerson) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.contacts.RolesByPerson.grid) ] });
    var sepa_AccountsByPartner_grid1824 = new Lino.sepa.AccountsByPartner.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(sepa.sepa.AccountsByPartner) Show the bank account(s) defined for a given partner. To be\nincluded to a detail window on partner.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sepa.AccountsByPartner.grid) ] });
    var address_2_panel1825 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 45, "frame": false, "hideCheckBoxLabels": true, "items": [ contacts_RolesByPerson_grid1823, sepa_AccountsByPartner_grid1824 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var address_panel1826 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_panel1814, address_2_panel1825 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Adresse" });
    var legacy_id1827 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Alte Nr.", "listeners": { "render": Lino.quicktip_renderer("Legacy ID","(courses.Pupils.legacy_id) ") }, "maxLength": 12, "name": "legacy_id", "selectOnFocus": true });
    var member_until1828 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Mitglied bis", "listeners": { "render": Lino.quicktip_renderer("Mitglied bis","(courses.Pupils.member_until) ") }, "name": "member_until", "selectOnFocus": true });
    var section1829 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Sektion", "forceSelection": true, "hiddenName": "sectionHidden", "listeners": { "render": Lino.quicktip_renderer("Section","(courses.Pupils.section) ") }, "name": "section", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.Sections) });
    var is_lfv1830 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "LFV", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("LFV","(courses.Pupils.is_lfv) ") }, "name": "is_lfv", "selectOnFocus": true });
    var is_ckk1831 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "CKK", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("CKK","(courses.Pupils.is_ckk) ") }, "name": "is_ckk", "selectOnFocus": true });
    var is_raviva1832 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Raviva", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Raviva","(courses.Pupils.is_raviva) ") }, "name": "is_raviva", "selectOnFocus": true });
    var courses_1_panel1833 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 18, "items": legacy_id1827, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": member_until1828, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": section1829, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": is_lfv1830, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": is_ckk1831, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": is_raviva1832, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_EnrolmentsByPupil_grid1903 = new Lino.courses.EnrolmentsByPupil.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Enrolments","(courses.courses.EnrolmentsByPupil) Show all enrolments of a given pupil.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByPupil.grid) ] });
    var courses_panel1904 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ courses_1_panel1833, courses_EnrolmentsByPupil_grid1903 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Aktivit\u00e4ten" });
    var invoice_recipient1905 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Fakturationsadresse</span>", "hiddenName": "invoice_recipientHidden", "listeners": { "render": Lino.quicktip_renderer("Invoicing address","(courses.Pupils.invoice_recipient) Redirect to another partner all invoices which should go to this partner.") }, "name": "invoice_recipient", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/invoice_recipient" }) }) });
    var vat_regime1906 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "MwSt.-Regime", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(courses.Pupils.vat_regime) ") }, "name": "vat_regime", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var ledger_a_1_panel1907 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 52, "items": invoice_recipient1905, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 47, "items": vat_regime1906, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var payment_term1910 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zahlungsbedingung</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(courses.Pupils.payment_term) The default payment term for sales invoices to this customer.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/payment_term" }) }) });
    var paper_type1911 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Papierart ausw\u00e4hlen...", "fieldLabel": "Papierart", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(courses.Pupils.paper_type) ") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/paper_type" }) }) });
    var ledger_a_2_panel1912 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": payment_term1910, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": paper_type1911, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ledger_a_panel1915 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 57, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_a_1_panel1907, ledger_a_2_panel1912 ], "labelAlign": "top", "layout": "form" });
    var ledger_MovementsByPartner_htmlbox1916 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 42, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(courses.Pupils.ledger_MovementsByPartner) ") }, "master_panel": this, "name": "ledger_MovementsByPartner", "title": "Bewegungen", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByPartner.grid) ], "value": "<br/>" });
    var ledger_1_panel1917 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ ledger_a_panel1915, ledger_MovementsByPartner_htmlbox1916 ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var sales_InvoicesByPartner_grid1918 = new Lino.sales.InvoicesByPartner.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Product invoices","(sales.sales.InvoicesByPartner) Base class for tables of partner vouchers.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sales.InvoicesByPartner.grid) ] });
    var ledger_panel1919 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel1917, sales_InvoicesByPartner_grid1918 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Buchhaltung" });
    var id1920 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Pupils.id) ") }, "name": "id", "selectOnFocus": true });
    var language1921 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Sprache</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(courses.Pupils.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var url1922 = new Lino.URLField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresse (URL)", "listeners": { "render": Lino.quicktip_renderer("URL","(courses.Pupils.url) ") }, "maxLength": 200, "name": "url", "selectOnFocus": true });
    var more_1_panel1923 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 10, "items": id1920, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": language1921, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 45, "items": url1922, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr11927 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresszeile vor Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Address line before street","(courses.Pupils.addr1) ") }, "maxLength": 200, "name": "addr1", "selectOnFocus": true });
    var addr21928 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Adresszeile nach Stra\u00dfe", "listeners": { "render": Lino.quicktip_renderer("Address line after street","(courses.Pupils.addr2) ") }, "maxLength": 200, "name": "addr2", "selectOnFocus": true });
    var more_2_panel1929 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": addr11927, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": addr21928, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 243, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var notes_NotesByPerson_grid1953 = new Lino.notes.NotesByPerson.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notes","(notes.notes.NotesByPerson) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByPerson.grid) ] });
    var more_panel1954 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel1923, more_2_panel1929, notes_NotesByPerson_grid1953 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var main_panel1955 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel1782, address_panel1826, courses_panel1904, ledger_panel1919, more_panel1954 ], "labelAlign": "top", "split": true });
    this.items = main_panel1955;
    this.before_row_edit = function(record) {
      lists_MembersByPartner_grid1775.on_master_changed();
      plausibility_ProblemsByOwner_htmlbox1779.refresh();
      city1797.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city1797.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      contacts_RolesByPerson_grid1823.on_master_changed();
      sepa_AccountsByPartner_grid1824.on_master_changed();
      courses_EnrolmentsByPupil_grid1903.on_master_changed();
      ledger_MovementsByPartner_htmlbox1916.refresh();
      sales_InvoicesByPartner_grid1918.on_master_changed();
      notes_NotesByPerson_grid1953.on_master_changed();
    }
    this.onRender = function(ct, position) {
      country1795.on('change',Lino.chooser_handler(city1797,'country'));
      Lino.courses.Pupils.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Pupils.DetailFormPanel.superclass.initComponent.call(this);
    // active_fields:
    city1797.on("change", function(){ this.save() }, this);
    zip_code1796.on("change", function(){ this.save() }, this);
  }
});


Lino.accounts.Accounts.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 33,
  initComponent : function() {
    var ref2308 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Referenz</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(accounts.Accounts.ref) An optional unique name which can be used to reference a given\naccount.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var group2309 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kontengruppe ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kontengruppe</span>", "hiddenName": "groupHidden", "listeners": { "render": Lino.quicktip_renderer("Account Group","(accounts.Accounts.group) The account group to which this account belongs.  Points to\nan instance of Group.  If this field is empty, the\naccount won't appear in certain reports.") }, "name": "group", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.accounts.Groups.detail,Lino.accounts.Groups.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/accounts/Accounts/group" }) }) });
    var type2310 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kontenart</span>", "forceSelection": true, "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Account Type","(accounts.Accounts.type) The account type of this account.  This points to an item of\nAccountTypes.") }, "name": "type", "selectOnFocus": true, "store": Lino.accounts.AccountTypes });
    var main_1_panel2311 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 36, "items": ref2308, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 35, "items": group2309, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": type2310, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name2315 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(accounts.Accounts.name) The multilingual designation of this account, as the users see\nit.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2316 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(accounts.Accounts.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2317 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(accounts.Accounts.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel2318 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2315, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2316, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2317, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2322 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2311, main_2_panel2318 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel2322;
    this.before_row_edit = function(record) {
    }
    Lino.accounts.Accounts.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.about.About.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  disable_editing: true,
  initComponent : function() {
    var server_status_disp3276 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Server-Status", "listeners": { "render": Lino.quicktip_renderer("Server status","(about.About.server_status) ") }, "name": "server_status", "value": "<br/>" });
    var main_panel3277 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "flex": 25, "html": "<div class=\"htmlText\"><span>This is <a href=\"http://voga.lino-framework.org\" target=\"_blank\">Lino Voga</a> 2017.7.0 using <a href=\"http://www.lino-framework.org\" target=\"_blank\">Lino</a> 2016.12.0, <a href=\"http://www.djangoproject.com\" target=\"_blank\">Django</a> 1.11.5, <a href=\"http://www.python.org/\" target=\"_blank\">Python</a> 2.7.12, <a href=\"http://babel.edgewall.org/\" target=\"_blank\">Babel</a> 2.5.1, <a href=\"http://jinja.pocoo.org/\" target=\"_blank\">Jinja</a> 2.9.6, <a href=\"http://labix.org/python-dateutil\" target=\"_blank\">python-dateutil</a> 2.6.0, <a href=\"http://getbootstrap.com\" target=\"_blank\">Bootstrap</a> 3.3.4, <a href=\"http://www.sencha.com\" target=\"_blank\">ExtJS</a> <a href=\"#\" onclick=\"alert('ExtJS client version is ' + Ext.version);\" title=\"Click to see ExtJS client version\">(version)</a>, <a href=\"http://www.famfamfam.com/lab/icons/silk/\" target=\"_blank\">Silk Icons</a> 1.3, <a href=\"https://github.com/django/channels\" target=\"_blank\">Channels (inactive)</a> 1.1.3, <a href=\"http://ext.ensible.com/products/calendar/\" target=\"_blank\">Ext.ensible adapter</a> <a href=\"#\" onclick=\"alert('Extensible Calendar version is '             + Ext.ensible.version);\" title=\"Click to see Extensible Calendar version\">(version)</a>, <a href=\"http://appyframework.org/pod.html\" target=\"_blank\">Appy</a> 0.9.9 (2017/09/14 14:40)</span><p>Languages: en, de, fr</p><p>Server uptime : <b>04/10/2017 at 10:39</b> (None)</p><p>This is a Lino demo site.</p><p>We are running with simulated date set to Friday, 22 May 2015.</p><p>Source timestamps:</p><ul><li>django : <b>26/09/2017 at 08:10</b></li><li>atelier : <b>30/09/2017 at 15:10</b></li><li>lino_cosi : <b>04/10/2017 at 07:09</b></li><li>lino_xl : <b>04/10/2017 at 10:04</b></li><li>lino_voga : <b>04/10/2017 at 10:37</b></li><li>lino : <b>04/10/2017 at 10:39</b></li></ul></div>", "xtype": "label" }, { "autoHeight": true, "items": server_status_disp3276, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3277;
    this.before_row_edit = function(record) {
    }
    Lino.about.About.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.changes.Changes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 77,
  disable_editing: true,
  initComponent : function() {
    var time1488 = new Ext.form.DisplayField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "time", "listeners": { "render": Lino.quicktip_renderer("time","(changes.Changes.time) ") }, "name": "time", "selectOnFocus": true, "value": "<br>" });
    var user1489 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Benutzer", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("User","(changes.Changes.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/user" }) }) });
    var type1490 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "\u00c4nderungsart", "forceSelection": true, "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Change Type","(changes.Changes.type) ") }, "name": "type", "selectOnFocus": true, "store": Lino.changes.ChangeTypes });
    var master_disp1491 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Stammdaten</span>", "name": "master" });
    var object_disp1492 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Object</span>", "name": "object" });
    var id1493 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(changes.Changes.id) ") }, "name": "id", "selectOnFocus": true });
    var main_1_panel1494 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 21, "items": time1488, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": user1489, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": type1490, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": master_disp1491, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": object_disp1492, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": id1493, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var diff1501 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "\u00c4nderungen", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Changes","(changes.Changes.diff) ") }, "name": "diff", "selectOnFocus": true });
    var main_panel1502 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1494, { "flex": 83, "items": diff1501, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 72, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1502;
    this.before_row_edit = function(record) {
    }
    Lino.changes.Changes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.Invoices.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 41,
  initComponent : function() {
    var id3279 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(vat.Invoices.id) ") }, "name": "id", "selectOnFocus": true });
    var entry_date3280 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsdatum</span>", "listeners": { "render": Lino.quicktip_renderer("Entry date","(vat.Invoices.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.") }, "name": "entry_date", "selectOnFocus": true });
    var partner3281 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(vat.Invoices.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/partner" }) }) });
    var user3282 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(vat.Invoices.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/user" }) }) });
    var general_1_panel3283 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 8, "items": id3279, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": entry_date3280, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": partner3281, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": user3282, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var due_date3288 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Zahlungsziel", "listeners": { "render": Lino.quicktip_renderer("Due date","(vat.Invoices.due_date) ") }, "name": "due_date", "selectOnFocus": true });
    var your_ref3289 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Ihr Zeichen", "listeners": { "render": Lino.quicktip_renderer("Your reference","(vat.Invoices.your_ref) ") }, "maxLength": 200, "name": "your_ref", "selectOnFocus": true });
    var vat_regime3290 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "MwSt.-Regime", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(vat.Invoices.vat_regime) ") }, "name": "vat_regime", "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var general_2_panel3291 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 25, "items": due_date3288, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": your_ref3289, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": vat_regime3290, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ItemsByInvoice_htmlbox3295 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 75, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Content","(vat.Invoices.ItemsByInvoice) ") }, "master_panel": this, "name": "ItemsByInvoice", "title": "Inhalt", "tools": [ Lino.show_in_own_window_button(Lino.vat.ItemsByInvoice.grid) ], "value": "<br/>" });
    var total_base3296 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total zzgl. MwSt.</span>", "listeners": { "render": Lino.quicktip_renderer("Total excl. VAT","(vat.Invoices.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.") }, "name": "total_base", "selectOnFocus": true });
    var total_vat3297 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">MwSt.</span>", "listeners": { "render": Lino.quicktip_renderer("VAT","(vat.Invoices.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.") }, "name": "total_vat", "selectOnFocus": true });
    var total_incl3298 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total inkl. MwSt.</span>", "listeners": { "render": Lino.quicktip_renderer("Total incl. VAT","(vat.Invoices.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.") }, "name": "total_incl", "selectOnFocus": true });
    var workflow_buttons_disp3299 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(vat.Invoices.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var totals_panel3300 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 25, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": total_base3296, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": total_vat3297, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": total_incl3298, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": workflow_buttons_disp3299, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "form" });
    var general_3_panel3305 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ ItemsByInvoice_htmlbox3295, totals_panel3300 ], "labelAlign": "top", "labelWidth": 72, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var general_panel3306 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel3283, general_2_panel3291, general_3_panel3305 ], "labelAlign": "top", "layout": "form", "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var journal3307 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(vat.Invoices.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/journal" }) }) });
    var accounting_period3308 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsperiode</span>", "hiddenName": "accounting_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Accounting period","(vat.Invoices.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.") }, "name": "accounting_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/accounting_period" }) }) });
    var number3309 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Nr.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(vat.Invoices.number) The sequence number of this voucher in the journal.") }, "name": "number", "selectOnFocus": true });
    var narration3310 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Beschreibung</span>", "listeners": { "render": Lino.quicktip_renderer("Narration","(vat.Invoices.narration) A short explanation which ascertains the subject matter of\nthis journal entry.") }, "maxLength": 200, "name": "narration", "selectOnFocus": true });
    var ledger_1_panel3311 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": journal3307, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": accounting_period3308, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": number3309, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": narration3310, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MovementsByVoucher_htmlbox3316 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 75, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(vat.Invoices.MovementsByVoucher) ") }, "master_panel": this, "name": "MovementsByVoucher", "title": "Bewegungen", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByVoucher.grid) ], "value": "<br/>" });
    var ledger_panel3317 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel3311, MovementsByVoucher_htmlbox3316 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Buchhaltung" });
    var main_panel3318 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel3306, ledger_panel3317 ], "labelAlign": "top", "split": true });
    this.items = main_panel3318;
    this.before_row_edit = function(record) {
      ItemsByInvoice_htmlbox3295.refresh();
      MovementsByVoucher_htmlbox3316.refresh();
    }
    Lino.vat.Invoices.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.sepa.AccountsByPartner.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 65,
  initComponent : function() {
    var iban1452 = new Lino.UppercaseTextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "IBAN", "listeners": { "render": Lino.quicktip_renderer("IBAN","(sepa.AccountsByPartner.iban) ") }, "maxLength": 34, "name": "iban", "selectOnFocus": true });
    var bic1453 = new Lino.UppercaseTextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "BIC", "listeners": { "render": Lino.quicktip_renderer("BIC","(sepa.AccountsByPartner.bic) ") }, "maxLength": 11, "name": "bic", "selectOnFocus": true });
    var main_1_panel1454 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 63, "items": iban1452, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 36, "items": bic1453, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 45, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remark1457 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bemerkung", "listeners": { "render": Lino.quicktip_renderer("Remark","(sepa.AccountsByPartner.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var main_panel1458 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1454, { "anchor": "-20", "autoHeight": true, "items": remark1457, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "form" });
    this.items = main_panel1458;
    this.before_row_edit = function(record) {
    }
    Lino.sepa.AccountsByPartner.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.system.SiteConfigs.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 1,
  initComponent : function() {
    var site_company3319 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Organisation ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Site owner</span>", "hiddenName": "site_companyHidden", "listeners": { "render": Lino.quicktip_renderer("Site owner","(system.SiteConfigs.site_company) The organisation who runs this site.  This is used e.g. when\nprinting your address in certain documents or reports.  Or\nnewly created partners inherit the country of the site owner.") }, "name": "site_company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/site_company" }) }) });
    var next_partner_id3320 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">N\u00e4chste Partnernummer</span>", "listeners": { "render": Lino.quicktip_renderer("Next partner id","(system.SiteConfigs.next_partner_id) The next automatic id for any new partner.") }, "name": "next_partner_id", "selectOnFocus": true, "value": 100 });
    var main_1_panel3321 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 66, "items": site_company3319, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": next_partner_id3320, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var default_build_method3324 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Standard-Konstruktionsmethode</span>", "forceSelection": true, "hiddenName": "default_build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Default build method","(system.SiteConfigs.default_build_method) The default build method to use when rendering printable documents.") }, "name": "default_build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var simulate_today3325 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Simulated date</span>", "listeners": { "render": Lino.quicktip_renderer("Simulated date","(system.SiteConfigs.simulate_today) A constant user-defined date to be substituted as current\nsystem date.") }, "name": "simulate_today", "selectOnFocus": true });
    var main_2_panel3326 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 63, "items": default_build_method3324, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 36, "items": simulate_today3325, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 189, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var clients_account3329 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Konto ausw\u00e4hlen...", "fieldLabel": "Konto f\u00fcr Kunden", "hiddenName": "clients_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Clients account","(system.SiteConfigs.clients_account) ") }, "name": "clients_account", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/clients_account" }) }) });
    var sales_account3330 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Konto ausw\u00e4hlen...", "fieldLabel": "Konto f\u00fcr Basisbetrag Verk\u00e4ufe", "hiddenName": "sales_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Sales Base account","(system.SiteConfigs.sales_account) ") }, "name": "sales_account", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/sales_account" }) }) });
    var main_3_panel3331 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": clients_account3329, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": sales_account3330, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 171, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var suppliers_account3334 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Konto ausw\u00e4hlen...", "fieldLabel": "Konto f\u00fcr Lieferanten", "hiddenName": "suppliers_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Suppliers account","(system.SiteConfigs.suppliers_account) ") }, "name": "suppliers_account", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/suppliers_account" }) }) });
    var purchases_account3335 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Konto ausw\u00e4hlen...", "fieldLabel": "Basis Einkauf", "hiddenName": "purchases_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Purchases Base account","(system.SiteConfigs.purchases_account) ") }, "name": "purchases_account", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/purchases_account" }) }) });
    var tax_offices_account3336 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Konto ausw\u00e4hlen...", "fieldLabel": "Tax offices account", "hiddenName": "tax_offices_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Tax offices account","(system.SiteConfigs.tax_offices_account) ") }, "name": "tax_offices_account", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/tax_offices_account" }) }) });
    var main_4_panel3337 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": suppliers_account3334, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": purchases_account3335, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": tax_offices_account3336, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 207, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var site_calendar3341 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kalender ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Site Calendar</span>", "hiddenName": "site_calendarHidden", "listeners": { "render": Lino.quicktip_renderer("Site Calendar","(system.SiteConfigs.site_calendar) The default calendar of this site.") }, "name": "site_calendar", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.Calendars.detail,Lino.cal.Calendars.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/site_calendar" }) }) });
    var default_event_type3342 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Standard-Kalenderintragsart</span>", "hiddenName": "default_event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Default Event Type","(system.SiteConfigs.default_event_type) The default type of events on this site.") }, "name": "default_event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/default_event_type" }) }) });
    var pupil_guestrole3343 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Gastrolle ausw\u00e4hlen...", "fieldLabel": "Guest role for pupils", "hiddenName": "pupil_guestroleHidden", "listeners": { "render": Lino.quicktip_renderer("Guest role for pupils","(system.SiteConfigs.pupil_guestrole) ") }, "name": "pupil_guestrole", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.GuestRoles.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/pupil_guestrole" }) }) });
    var main_5_panel3344 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": site_calendar3341, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": default_event_type3342, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": pupil_guestrole3343, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var max_auto_events3348 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Max automatic events</span>", "listeners": { "render": Lino.quicktip_renderer("Max automatic events","(system.SiteConfigs.max_auto_events) Maximum number of automatic events to be generated.") }, "name": "max_auto_events", "selectOnFocus": true, "value": 72 });
    var hide_events_before3349 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Hide events before</span>", "listeners": { "render": Lino.quicktip_renderer("Hide events before","(system.SiteConfigs.hide_events_before) If this is specified, certain tables show only \nevents after the given date.") }, "name": "hide_events_before", "selectOnFocus": true });
    var main_6_panel3350 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 27, "items": max_auto_events3348, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 72, "items": hide_events_before3349, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 189, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3353 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3321, main_2_panel3326, main_3_panel3331, main_4_panel3337, main_5_panel3344, main_6_panel3350 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel3353;
    this.before_row_edit = function(record) {
    }
    Lino.system.SiteConfigs.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Guests.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 19,
  initComponent : function() {
    var event661 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Kalendereintrag ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kalendereintrag</span>", "hiddenName": "eventHidden", "listeners": { "render": Lino.quicktip_renderer("Kalendereintrag","(cal.Guests.event) The calendar event to which this presence applies.") }, "name": "event", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.OneEvent.detail,Lino.cal.OneEvent.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/event" }) }) });
    var partner662 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Person ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Person</span>", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Person","(cal.Guests.partner) The partner to which this presence applies.") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/partner" }) }) });
    var role663 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Gastrolle ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Rolle</span>", "hiddenName": "roleHidden", "listeners": { "render": Lino.quicktip_renderer("Rolle","(cal.Guests.role) The role of this partner in this presence.") }, "name": "role", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.GuestRoles.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/role" }) }) });
    var main_panel664 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": event661, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": partner662, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": role663, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "form" });
    this.items = main_panel664;
    this.before_row_edit = function(record) {
    }
    Lino.cal.Guests.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.gfks.ContentTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 15,
  initComponent : function() {
    var id3354 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(gfks.ContentTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var app_label3355 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "app label", "listeners": { "render": Lino.quicktip_renderer("app label","(gfks.ContentTypes.app_label) ") }, "maxLength": 100, "name": "app_label", "selectOnFocus": true });
    var model3356 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Python Modell-Klassenname", "listeners": { "render": Lino.quicktip_renderer("python model class name","(gfks.ContentTypes.model) ") }, "maxLength": 100, "name": "model", "selectOnFocus": true });
    var base_classes_disp3357 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Base classes", "listeners": { "render": Lino.quicktip_renderer("Base classes","(gfks.ContentTypes.base_classes) ") }, "name": "base_classes", "value": "<br/>" });
    var main_1_panel3358 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 6, "items": id3354, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": app_label3355, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": model3356, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": base_classes_disp3357, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 216, "layout": "hbox", "layoutConfig": { "align": "stretchmax" }, "region": "north", "split": true });
    var HelpTextsByModel_grid3369 = new Lino.gfks.HelpTextsByModel.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Help Texts","(gfks.gfks.HelpTextsByModel) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "center", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.gfks.HelpTextsByModel.grid) ] });
    var BrokenGFKsByModel_grid3374 = new Lino.gfks.BrokenGFKsByModel.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Broken GFKs","(gfks.gfks.BrokenGFKsByModel) Shows all database objects (model instances) who have a broken\nGeneriForeignKey field.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "south", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.gfks.BrokenGFKsByModel.grid) ] });
    var main_panel3375 = new Lino.VBorderPanel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3358, HelpTextsByModel_grid3369, BrokenGFKsByModel_grid3374 ], "labelAlign": "top" });
    this.items = main_panel3375;
    this.before_row_edit = function(record) {
      HelpTextsByModel_grid3369.on_master_changed();
      BrokenGFKsByModel_grid3374.on_master_changed();
    }
    Lino.gfks.ContentTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.BankStatements.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 61,
  initComponent : function() {
    var entry_date3376 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsdatum</span>", "listeners": { "render": Lino.quicktip_renderer("Entry date","(finan.BankStatements.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.") }, "name": "entry_date", "selectOnFocus": true });
    var balance13377 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Alter Saldo</span>", "listeners": { "render": Lino.quicktip_renderer("Old balance","(finan.BankStatements.balance1) The old (or start) balance.") }, "name": "balance1", "selectOnFocus": true, "value": 0 });
    var main_panel3378 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": entry_date3376, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": balance13377, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "form" });
    this.items = main_panel3378;
    this.before_row_edit = function(record) {
    }
    Lino.finan.BankStatements.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.notes.NoteTypes.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 69,
  initComponent : function() {
    var name3381 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(notes.NoteTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3382 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(notes.NoteTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3383 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(notes.NoteTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3384 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3381, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3382, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3383, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var build_method3388 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Konstruktionsmethode", "forceSelection": true, "hiddenName": "build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Build method","(notes.NoteTypes.build_method) ") }, "name": "build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var main_panel3389 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3384, { "anchor": "-20", "autoHeight": true, "items": build_method3388, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "form" });
    this.items = main_panel3389;
    this.before_row_edit = function(record) {
    }
    Lino.notes.NoteTypes.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.CourseTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 51,
  initComponent : function() {
    var id3391 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.CourseTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var name3392 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.CourseTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3393 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(courses.CourseTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3394 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(courses.CourseTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3395 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id3391, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name3392, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de3393, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr3394, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_LinesByType_grid3556 = new Lino.courses.LinesByType.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Activity lines","(courses.courses.LinesByType) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.courses.LinesByType.grid) ] });
    var main_panel3557 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3395, courses_LinesByType_grid3556 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3557;
    this.before_row_edit = function(record) {
      courses_LinesByType_grid3556.on_master_changed();
    }
    Lino.courses.CourseTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.sales.Invoices.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 45,
  initComponent : function() {
    var partner1673 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(sales.Invoices.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/partner" }) }) });
    var entry_date1674 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsdatum</span>", "listeners": { "render": Lino.quicktip_renderer("Entry date","(sales.Invoices.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.") }, "name": "entry_date", "selectOnFocus": true });
    var main_1_panel1675 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 60, "items": partner1673, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 39, "items": entry_date1674, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var subject1678 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Betreff", "listeners": { "render": Lino.quicktip_renderer("Subject line","(sales.Invoices.subject) ") }, "maxLength": 200, "name": "subject", "selectOnFocus": true });
    var main_panel1679 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1675, { "anchor": "-20", "autoHeight": true, "items": subject1678, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "form" });
    this.items = main_panel1679;
    this.before_row_edit = function(record) {
    }
    Lino.sales.Invoices.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.TeacherTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 55,
  initComponent : function() {
    var id3558 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.TeacherTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var name3559 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.TeacherTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3560 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(courses.TeacherTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3561 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(courses.TeacherTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3562 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id3558, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name3559, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de3560, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr3561, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_TeachersByType_grid3620 = new Lino.courses.TeachersByType.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Instructors","(courses.courses.TeachersByType) Shows all persons.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.courses.TeachersByType.grid) ] });
    var main_panel3621 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3562, courses_TeachersByType_grid3620 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3621;
    this.before_row_edit = function(record) {
      courses_TeachersByType_grid3620.on_master_changed();
    }
    Lino.courses.TeacherTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.ActivityReport.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  disable_editing: true,
  initComponent : function() {
    var body_htmlbox3622 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer(null,"(ledger.ActivityReport.body) ") }, "name": "body", "value": "<br/>" });
    var main_panel3623 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ body_htmlbox3622 ], "labelAlign": "top", "labelWidth": 0, "layout": "fit" });
    this.items = main_panel3623;
    this.before_row_edit = function(record) {
      body_htmlbox3622.refresh();
    }
    Lino.ledger.ActivityReport.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.excerpts.Excerpts.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 76,
  initComponent : function() {
    var id3624 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(excerpts.Excerpts.id) ") }, "name": "id", "selectOnFocus": true });
    var excerpt_type3625 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Auszugsart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Auszugsart</span>", "hiddenName": "excerpt_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Excerpt Type","(excerpts.Excerpts.excerpt_type) The type of this excerpt (ForeignKey to ExcerptType).") }, "name": "excerpt_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.excerpts.ExcerptTypes.detail,Lino.excerpts.ExcerptTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/excerpt_type" }) }) });
    var main_1_panel3626 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 16, "items": id3624, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 83, "items": excerpt_type3625, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var user3629 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(excerpts.Excerpts.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/user" }) }) });
    var build_method3630 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Konstruktionsmethode", "forceSelection": true, "hiddenName": "build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Build method","(excerpts.Excerpts.build_method) ") }, "name": "build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var main_2_panel3631 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": user3629, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 69, "items": build_method3630, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var company3634 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Organisation ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Empf\u00e4nger (Organisation)</span>", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Recipient (Organization)","(excerpts.Excerpts.company) The optional company of the recipient of this\nexcerpt.  See ContactRelated.company.") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/company" }) }) });
    var contact_person3635 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Person ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Empf\u00e4nger (Person)</span>", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Recipient (Person)","(excerpts.Excerpts.contact_person) The optional contact person of the recipient of this\nexcerpt.  See ContactRelated.contact_person.") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/contact_person" }) }) });
    var language3636 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Sprache</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(excerpts.Excerpts.language) The language used for printing this excerpt.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var main_3_panel3637 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": company3634, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": contact_person3635, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": language3636, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 225, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var owner_disp3641 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Verkn\u00fcpft mit</span>", "name": "owner" });
    var build_time3642 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Druckdatum", "listeners": { "render": Lino.quicktip_renderer("build time","(excerpts.Excerpts.build_time) ") }, "name": "build_time", "value": "<br>" });
    var main_4_panel3643 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 38, "items": owner_disp3641, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 61, "items": build_time3642, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3646 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3626, main_2_panel3631, main_3_panel3637, main_4_panel3643 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel3646;
    this.before_row_edit = function(record) {
      excerpt_type3625.setContextValue('owner', record ? record.data['owner'] : undefined);
      contact_person3635.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      owner_disp3641.on('change',Lino.chooser_handler(excerpt_type3625,'owner'));
      company3634.on('change',Lino.chooser_handler(contact_person3635,'company'));
      Lino.excerpts.Excerpts.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.excerpts.Excerpts.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.notes.EventTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 68,
  initComponent : function() {
    var id3647 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(notes.EventTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var name3648 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(notes.EventTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3649 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(notes.EventTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3650 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(notes.EventTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3651 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id3647, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name3648, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de3649, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr3650, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" }, "region": "north", "split": true });
    var remark3656 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkung", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remark","(notes.EventTypes.remark) ") }, "name": "remark", "selectOnFocus": true });
    var notes_NotesByEventType_grid3678 = new Lino.notes.NotesByEventType.GridPanel({ "containing_panel": this, "flex": 6, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notes","(notes.notes.NotesByEventType) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "south", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByEventType.grid) ] });
    var main_panel3679 = new Lino.VBorderPanel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3651, { "flex": 3, "items": remark3656, "labelAlign": "top", "layout": "form", "region": "center", "split": true, "xtype": "panel" }, notes_NotesByEventType_grid3678 ], "labelAlign": "top", "labelWidth": 63 });
    this.items = main_panel3679;
    this.before_row_edit = function(record) {
      notes_NotesByEventType_grid3678.on_master_changed();
    }
    Lino.notes.EventTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.products.Products.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 31,
  initComponent : function() {
    var id2023 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(products.Products.id) ") }, "name": "id", "selectOnFocus": true });
    var cat2024 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarifkategorie ausw\u00e4hlen...", "fieldLabel": "Kategorie", "hiddenName": "catHidden", "listeners": { "render": Lino.quicktip_renderer("Category","(products.Products.cat) ") }, "name": "cat", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.ProductCats.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/Products/cat" }) }) });
    var sales_price2025 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "Verkaufspreis", "listeners": { "render": Lino.quicktip_renderer("Sales price","(products.Products.sales_price) ") }, "name": "sales_price", "selectOnFocus": true });
    var number_of_events2026 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Anzahl Termine</span>", "listeners": { "render": Lino.quicktip_renderer("Number of events","(products.Products.number_of_events) Number of calendar events paid per invoicing.") }, "name": "number_of_events", "selectOnFocus": true });
    var min_asset2027 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Schwellenwert n\u00e4chste Rechnung</span>", "listeners": { "render": Lino.quicktip_renderer("Invoice threshold","(products.Products.min_asset) Minimum quantity to pay in advance.") }, "name": "min_asset", "selectOnFocus": true, "value": 1 });
    var general_1_panel2028 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 8, "items": id2023, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 35, "items": cat2024, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": sales_price2025, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 17, "items": number_of_events2026, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 17, "items": min_asset2027, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var vat_class2034 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "MwSt.-Klasse", "forceSelection": true, "hiddenName": "vat_classHidden", "listeners": { "render": Lino.quicktip_renderer("VAT Class","(products.Products.vat_class) ") }, "name": "vat_class", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var delivery_unit2035 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Delivery unit", "forceSelection": true, "hiddenName": "delivery_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Delivery unit","(products.Products.delivery_unit) ") }, "name": "delivery_unit", "selectOnFocus": true, "store": Lino.products.DeliveryUnit, "value": "20" });
    var general_2_panel2036 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 55, "items": vat_class2034, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 44, "items": delivery_unit2035, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name2039 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(products.Products.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2040 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(products.Products.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2041 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(products.Products.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var general_3_panel2042 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2039, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2040, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2041, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description2046 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Long description", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Long description","(products.Products.description) ") }, "name": "description", "selectOnFocus": true });
    var description_de2047 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Long description (de)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Long description (de)","(products.Products.description_de) ") }, "name": "description_de", "selectOnFocus": true });
    var description_fr2048 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Long description (fr)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Long description (fr)","(products.Products.description_fr) ") }, "name": "description_fr", "selectOnFocus": true });
    var general_4_panel2049 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 62, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 33, "items": description2046, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_de2047, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_fr2048, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var general_panel2053 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel2028, general_2_panel2036, general_3_panel2042, general_4_panel2049 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var EnrolmentsByFee_htmlbox2054 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 3, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Enrolments using this fee","(products.Products.EnrolmentsByFee) The Voga version of EnrolmentsByCourse.") }, "ls_bbar_actions": [ { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" } ], "ls_insert_handler": Lino.courses.EnrolmentsByFee.insert, "master_panel": this, "name": "EnrolmentsByFee", "region": "north", "split": true, "title": "Einschreibungen mit diesem Tarif", "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByFee.grid) ], "value": "<br/>" });
    var courses_EnrolmentsByOption_grid2093 = new Lino.courses.EnrolmentsByOption.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Enrolments using this option","(courses.courses.EnrolmentsByOption) Base class for all enrolment tables.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "center", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByOption.grid) ] });
    var courses_panel2094 = new Lino.VBorderPanel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ EnrolmentsByFee_htmlbox2054, courses_EnrolmentsByOption_grid2093 ], "labelAlign": "top", "labelWidth": 234, "listeners": { "activate": Lino.on_tab_activate }, "title": "Einschreibungen" });
    var main_panel2095 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel2053, courses_panel2094 ], "labelAlign": "top", "split": true });
    this.items = main_panel2095;
    this.before_row_edit = function(record) {
      EnrolmentsByFee_htmlbox2054.refresh();
      courses_EnrolmentsByOption_grid2093.on_master_changed();
    }
    Lino.products.Products.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.EnrolmentsByHike.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 53,
  initComponent : function() {
    var pupil3681 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Teilnehmer ausw\u00e4hlen...", "fieldLabel": "Teilnehmer", "forceSelection": false, "hiddenName": "pupilHidden", "listeners": { "render": Lino.quicktip_renderer("Participant","(courses.EnrolmentsByHike.pupil) ") }, "name": "pupil", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Pupils.detail,Lino.courses.Pupils.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/pupil" }) }) });
    var places3682 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Anz. Pl\u00e4tze</span>", "listeners": { "render": Lino.quicktip_renderer("Places used","(courses.EnrolmentsByHike.places) The number of participants in this enrolment.") }, "name": "places", "selectOnFocus": true, "value": 1 });
    var option3683 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarif ausw\u00e4hlen...", "fieldLabel": "Option", "hiddenName": "optionHidden", "listeners": { "render": Lino.quicktip_renderer("Option","(courses.EnrolmentsByHike.option) ") }, "name": "option", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/option" }) }) });
    var main_2_panel3684 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 20, "items": places3682, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 80, "items": option3683, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remark3687 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bemerkung", "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.EnrolmentsByHike.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var request_date3688 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Datum der Anfrage", "listeners": { "render": Lino.quicktip_renderer("Date of request","(courses.EnrolmentsByHike.request_date) ") }, "name": "request_date", "selectOnFocus": true });
    var user3689 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.EnrolmentsByHike.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/user" }) }) });
    var main_4_panel3690 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": request_date3688, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 60, "items": user3689, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3693 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": pupil3681, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_2_panel3684, { "anchor": "-20", "autoHeight": true, "items": remark3687, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_4_panel3690 ], "labelAlign": "top", "labelWidth": 108, "layout": "form" });
    this.items = main_panel3693;
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      pupil3681.setContextValue('mk',bp['mk']);
      pupil3681.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      option3683.setContextValue('mk',bp['mk']);
      option3683.setContextValue('mt',bp['mt']);
    }
    Lino.courses.EnrolmentsByHike.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Calendars.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 27,
  initComponent : function() {
    var name3696 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.Calendars.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3697 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.Calendars.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3698 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.Calendars.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3699 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3696, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3697, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3698, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var color3703 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Farbe", "listeners": { "render": Lino.quicktip_renderer("color","(cal.Calendars.color) ") }, "name": "color", "selectOnFocus": true });
    var main_panel3704 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3699, { "anchor": "-20", "autoHeight": true, "items": color3703, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 54, "layout": "form" });
    this.items = main_panel3704;
    this.before_row_edit = function(record) {
    }
    Lino.cal.Calendars.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.invoicing.Plans.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 48,
  initComponent : function() {
    var user3706 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(invoicing.Plans.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/user" }) }) });
    var journal3707 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(invoicing.Plans.journal) The journal where to create invoices.  When this field is\nempty, you can fill the plan with suggestions but cannot\nexecute the plan.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/journal" }) }) });
    var today3708 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Rechnungsdatum", "listeners": { "render": Lino.quicktip_renderer("Invoicing date","(invoicing.Plans.today) ") }, "name": "today", "selectOnFocus": true });
    var max_date3709 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Fakturierbare bis", "listeners": { "render": Lino.quicktip_renderer("Invoiceables until","(invoicing.Plans.max_date) ") }, "name": "max_date", "selectOnFocus": true });
    var main_1_panel3710 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": user3706, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": journal3707, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": today3708, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": max_date3709, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 171, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var partner3715 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Partner ausw\u00e4hlen...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(invoicing.Plans.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/partner" }) }) });
    var course3716 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Activity ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Activity</span>", "hiddenName": "courseHidden", "listeners": { "render": Lino.quicktip_renderer("Activity","(invoicing.Plans.course) If this field is nonempty, select only enrolments of that\ngiven course.") }, "name": "course", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Activities.detail,Lino.courses.Activities.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/course" }) }) });
    var main_2_panel3717 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": partner3715, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": course3716, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var invoicing_ItemsByPlan_grid3734 = new Lino.invoicing.ItemsByPlan.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Invoicing suggestions","(invoicing.invoicing.ItemsByPlan) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.invoicing.ItemsByPlan.grid) ] });
    var main_panel3735 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3710, main_2_panel3717, invoicing_ItemsByPlan_grid3734 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3735;
    this.before_row_edit = function(record) {
      invoicing_ItemsByPlan_grid3734.on_master_changed();
    }
    Lino.invoicing.Plans.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Companies.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 7,
  initComponent : function() {
    var name3736 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Name</span>", "listeners": { "render": Lino.quicktip_renderer("Name","(contacts.Companies.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var email3737 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">E-Mail-Adresse</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(contacts.Companies.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var type3738 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Organisationsart ausw\u00e4hlen...", "fieldLabel": "Organisationsart", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Organization type","(contacts.Companies.type) ") }, "name": "type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/type" }) }) });
    var id3739 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(contacts.Companies.id) ") }, "name": "id", "selectOnFocus": true });
    var main_3_panel3740 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 80, "items": type3738, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": id3739, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3743 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": name3736, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": email3737, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_3_panel3740 ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    this.items = main_panel3743;
    this.before_row_edit = function(record) {
    }
    Lino.contacts.Companies.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Lines.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 57,
  initComponent : function() {
    var id3429 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Lines.id) ") }, "name": "id", "selectOnFocus": true });
    var name3430 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Lines.name) The designation of this activity line as seen by the user\ne.g. when selecting the line.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3431 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(courses.Lines.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3432 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(courses.Lines.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var ref3433 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Referenz</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(courses.Lines.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var main_1_panel3434 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 5, "items": id3429, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": name3430, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": name_de3431, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": name_fr3432, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": ref3433, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var course_area3440 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Layout</span>", "forceSelection": true, "hiddenName": "course_areaHidden", "listeners": { "render": Lino.quicktip_renderer("Layout","(courses.Lines.course_area) Pointer to CourseAreas.  This is used only when an\napplication defines several variants of\nEnrolmentsByPupil.") }, "name": "course_area", "selectOnFocus": true, "store": Lino.courses.CourseAreas });
    var topic3441 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Thema ausw\u00e4hlen...", "fieldLabel": "Thema", "hiddenName": "topicHidden", "listeners": { "render": Lino.quicktip_renderer("Topic","(courses.Lines.topic) ") }, "name": "topic", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Topics.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/topic" }) }) });
    var fees_cat3442 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarifkategorie ausw\u00e4hlen...", "fieldLabel": "Kategorie f\u00fcr Teilnahmegeb\u00fchren", "hiddenName": "fees_catHidden", "listeners": { "render": Lino.quicktip_renderer("Fees category","(courses.Lines.fees_cat) ") }, "name": "fees_cat", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.ProductCats.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/fees_cat" }) }) });
    var fee3443 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarif ausw\u00e4hlen...", "fieldLabel": "Teilnahmegeb\u00fchr", "hiddenName": "feeHidden", "listeners": { "render": Lino.quicktip_renderer("Participation fee","(courses.Lines.fee) ") }, "name": "fee", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/fee" }) }) });
    var options_cat3444 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarifkategorie ausw\u00e4hlen...", "fieldLabel": "Kategorie f\u00fcr Optionen", "hiddenName": "options_catHidden", "listeners": { "render": Lino.quicktip_renderer("Options category","(courses.Lines.options_cat) ") }, "name": "options_cat", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.ProductCats.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/options_cat" }) }) });
    var body_template3445 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Textk\u00f6rper-Vorlage</span>", "listeners": { "render": Lino.quicktip_renderer("Body template","(courses.Lines.body_template) The body template to use when printing a course of this series. Leave empty to use the site's default.") }, "name": "body_template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/body_template" }) }) });
    var main_2_panel3446 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 12, "items": course_area3440, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": topic3441, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": fees_cat3442, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": fee3443, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": options_cat3444, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 9, "items": body_template3445, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var course_type3453 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Aktivit\u00e4tsart ausw\u00e4hlen...", "fieldLabel": "Aktivit\u00e4tsart", "hiddenName": "course_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Activity type","(courses.Lines.course_type) ") }, "name": "course_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.CourseTypes.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/course_type" }) }) });
    var event_type3454 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kalendereintragsart</span>", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(courses.Lines.event_type) The type of calendar entries to be generated. If this is empty, no calendar entries will be generated.") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/event_type" }) }) });
    var guest_role3455 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Gastrolle ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Anwesenheiten erfassen als</span>", "hiddenName": "guest_roleHidden", "listeners": { "render": Lino.quicktip_renderer("Manage presences as","(courses.Lines.guest_role) The default guest role for particpants of calendar entries for activities in this series. Leave empty if you don't want any presences management.") }, "name": "guest_role", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.GuestRoles.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/guest_role" }) }) });
    var every_unit3456 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Wiederholung", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(courses.Lines.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every3457 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "... alle", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(courses.Lines.every) ") }, "name": "every", "selectOnFocus": true, "value": 1 });
    var main_3_panel3458 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 23, "items": course_type3453, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": event_type3454, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": guest_role3455, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": every_unit3456, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 5, "items": every3457, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description3464 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Beschreibung", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description","(courses.Lines.description) ") }, "name": "description", "selectOnFocus": true });
    var description_de3465 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Beschreibung (de)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description (de)","(courses.Lines.description_de) ") }, "name": "description_de", "selectOnFocus": true });
    var description_fr3466 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Beschreibung (fr)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description (fr)","(courses.Lines.description_fr) ") }, "name": "description_fr", "selectOnFocus": true });
    var main_4_panel3467 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 35, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 33, "items": description3464, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_de3465, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_fr3466, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var excerpt_title3471 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Excerpt title</span>", "listeners": { "render": Lino.quicktip_renderer("Excerpt title","(courses.Lines.excerpt_title) The title to be used when printing an excerpt.") }, "maxLength": 200, "name": "excerpt_title", "selectOnFocus": true });
    var excerpt_title_de3472 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Excerpt title (de)", "listeners": { "render": Lino.quicktip_renderer("Excerpt title (de)","(courses.Lines.excerpt_title_de) ") }, "maxLength": 200, "name": "excerpt_title_de", "selectOnFocus": true });
    var excerpt_title_fr3473 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Excerpt title (fr)", "listeners": { "render": Lino.quicktip_renderer("Excerpt title (fr)","(courses.Lines.excerpt_title_fr) ") }, "maxLength": 200, "name": "excerpt_title_fr", "selectOnFocus": true });
    var main_5_panel3474 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": excerpt_title3471, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": excerpt_title_de3472, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": excerpt_title_fr3473, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 171, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_CoursesByLine_grid3527 = new Lino.courses.CoursesByLine.GridPanel({ "containing_panel": this, "flex": 35, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Activities","(courses.courses.CoursesByLine) Like lino_xl.lib.courses.CoursesByLine, but with other\ndefault values in the filter parameters. In Voga we want to see\nonly courses for which new enrolments can happen.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.courses.CoursesByLine.grid) ] });
    var main_panel3528 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3434, main_2_panel3446, main_3_panel3458, main_4_panel3467, main_5_panel3474, courses_CoursesByLine_grid3527 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3528;
    this.before_row_edit = function(record) {
      fee3443.setContextValue('fees_cat', record ? record.data['fees_catHidden'] : undefined);
      courses_CoursesByLine_grid3527.on_master_changed();
    }
    this.onRender = function(ct, position) {
      fees_cat3442.on('change',Lino.chooser_handler(fee3443,'fees_cat'));
      Lino.courses.Lines.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Lines.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.StatusReport.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  disable_editing: true,
  initComponent : function() {
    var body_htmlbox1005 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer(null,"(courses.StatusReport.body) ") }, "name": "body", "value": "<br/>" });
    var main_panel1006 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ body_htmlbox1005 ], "labelAlign": "top", "labelWidth": 0, "layout": "fit" });
    this.items = main_panel1006;
    this.before_row_edit = function(record) {
      body_htmlbox1005.refresh();
    }
    Lino.courses.StatusReport.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.FinancialVouchers.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 63,
  initComponent : function() {
    var entry_date3746 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsdatum</span>", "listeners": { "render": Lino.quicktip_renderer("Entry date","(finan.FinancialVouchers.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.") }, "name": "entry_date", "selectOnFocus": true });
    var number3747 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Nr.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(finan.FinancialVouchers.number) The sequence number of this voucher in the journal.") }, "name": "number", "selectOnFocus": true });
    var workflow_buttons_disp3748 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(finan.FinancialVouchers.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_1_panel3749 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 26, "items": entry_date3746, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": number3747, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 61, "items": workflow_buttons_disp3748, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var narration3753 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Beschreibung</span>", "listeners": { "render": Lino.quicktip_renderer("Narration","(finan.FinancialVouchers.narration) A short explanation which ascertains the subject matter of\nthis journal entry.") }, "maxLength": 200, "name": "narration", "selectOnFocus": true });
    var ItemsByJournalEntry_htmlbox3754 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 42, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Content","(finan.FinancialVouchers.ItemsByJournalEntry) ") }, "master_panel": this, "name": "ItemsByJournalEntry", "title": "Inhalt", "tools": [ Lino.show_in_own_window_button(Lino.finan.ItemsByJournalEntry.grid) ], "value": "<br/>" });
    var general_panel3755 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel3749, { "autoHeight": true, "items": narration3753, "labelAlign": "top", "layout": "form", "xtype": "panel" }, ItemsByJournalEntry_htmlbox3754 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var journal3757 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(finan.FinancialVouchers.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/journal" }) }) });
    var accounting_period3758 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsperiode</span>", "hiddenName": "accounting_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Accounting period","(finan.FinancialVouchers.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.") }, "name": "accounting_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/accounting_period" }) }) });
    var user3759 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(finan.FinancialVouchers.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/user" }) }) });
    var id3760 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(finan.FinancialVouchers.id) ") }, "name": "id", "selectOnFocus": true });
    var more_1_panel3761 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": journal3757, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": accounting_period3758, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": user3759, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": id3760, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var item_account3766 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Konto ausw\u00e4hlen...", "fieldLabel": "Standardwert Konto", "hiddenName": "item_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Default account","(finan.FinancialVouchers.item_account) ") }, "name": "item_account", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/item_account" }) }) });
    var item_remark3767 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Ihr Zeichen", "listeners": { "render": Lino.quicktip_renderer("Your reference","(finan.FinancialVouchers.item_remark) ") }, "maxLength": 200, "name": "item_remark", "selectOnFocus": true });
    var more_2_panel3768 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 48, "items": item_account3766, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 51, "items": item_remark3767, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MovementsByVoucher_htmlbox3771 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 60, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(finan.FinancialVouchers.MovementsByVoucher) ") }, "master_panel": this, "name": "MovementsByVoucher", "title": "Bewegungen", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByVoucher.grid) ], "value": "<br/>" });
    var more_panel3772 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel3761, more_2_panel3768, MovementsByVoucher_htmlbox3771 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var main_panel3773 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel3755, more_panel3772 ], "labelAlign": "top", "split": true });
    this.items = main_panel3773;
    this.before_row_edit = function(record) {
      ItemsByJournalEntry_htmlbox3754.refresh();
      MovementsByVoucher_htmlbox3771.refresh();
    }
    Lino.finan.FinancialVouchers.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.FinancialVouchers.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 63,
  initComponent : function() {
    var entry_date3774 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsdatum</span>", "listeners": { "render": Lino.quicktip_renderer("Entry date","(finan.FinancialVouchers.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.") }, "name": "entry_date", "selectOnFocus": true });
    var narration3775 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Beschreibung</span>", "listeners": { "render": Lino.quicktip_renderer("Narration","(finan.FinancialVouchers.narration) A short explanation which ascertains the subject matter of\nthis journal entry.") }, "maxLength": 200, "name": "narration", "selectOnFocus": true });
    var main_panel3776 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": entry_date3774, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": narration3775, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "form" });
    this.items = main_panel3776;
    this.before_row_edit = function(record) {
    }
    Lino.finan.FinancialVouchers.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.uploads.UploadTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 70,
  initComponent : function() {
    var id3779 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(uploads.UploadTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var upload_area3780 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Upload-Bereich", "forceSelection": true, "hiddenName": "upload_areaHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Area","(uploads.UploadTypes.upload_area) ") }, "name": "upload_area", "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var wanted3781 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Wanted", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wanted","(uploads.UploadTypes.wanted) Add a (+) button when there is no upload of this type.") }, "name": "wanted", "selectOnFocus": true });
    var max_number3782 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Max. number</span>", "listeners": { "render": Lino.quicktip_renderer("Max. number","(uploads.UploadTypes.max_number) No need to upload more uploads than N of this type.\n-1 means no limit.") }, "name": "max_number", "selectOnFocus": true, "value": -1 });
    var shortcut3783 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Upload shortcut</span>", "listeners": { "render": Lino.quicktip_renderer("Upload shortcut","(uploads.UploadTypes.shortcut) Optional pointer to a virtual upload shortcut field.  If\nthis is not empty, then the given shortcut field will manage\nuploads of this type.  See also Shortcuts.") }, "maxLength": 50, "name": "shortcut", "selectOnFocus": true });
    var main_1_panel3784 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 9, "items": id3779, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": upload_area3780, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": wanted3781, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 9, "items": max_number3782, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 41, "items": shortcut3783, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name3790 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(uploads.UploadTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3791 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(uploads.UploadTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3792 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(uploads.UploadTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel3793 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3790, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3791, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3792, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var uploads_UploadsByType_grid3821 = new Lino.uploads.UploadsByType.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Uploads","(uploads.uploads.UploadsByType) Shows all Uploads") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.uploads.UploadsByType.grid) ] });
    var main_panel3822 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3784, main_2_panel3793, uploads_UploadsByType_grid3821 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3822;
    this.before_row_edit = function(record) {
      uploads_UploadsByType_grid3821.on_master_changed();
    }
    Lino.uploads.UploadTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Topics.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 54,
  initComponent : function() {
    var id3823 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Topics.id) ") }, "name": "id", "selectOnFocus": true });
    var name3824 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Topics.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3825 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(courses.Topics.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3826 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(courses.Topics.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3827 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id3823, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name3824, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de3825, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr3826, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" }, "region": "north", "split": true });
    var courses_LinesByTopic_grid3861 = new Lino.courses.LinesByTopic.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Activity lines","(courses.courses.LinesByTopic) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "center", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.courses.LinesByTopic.grid) ] });
    var courses_CoursesByTopic_grid3862 = new Lino.courses.CoursesByTopic.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Activities","(courses.courses.CoursesByTopic) Shows the courses of a given topic.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "south", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.courses.CoursesByTopic.grid) ] });
    var main_panel3863 = new Lino.VBorderPanel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3827, courses_LinesByTopic_grid3861, courses_CoursesByTopic_grid3862 ], "labelAlign": "top" });
    this.items = main_panel3863;
    this.before_row_edit = function(record) {
      courses_LinesByTopic_grid3861.on_master_changed();
      courses_CoursesByTopic_grid3862.on_master_changed();
    }
    Lino.courses.Topics.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Journeys.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 52,
  initComponent : function() {
    var ref3864 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Referenz</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(courses.Journeys.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.") }, "maxLength": 40, "name": "ref", "preferred_with": 6, "selectOnFocus": true });
    var line3865 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Aktivit\u00e4tenreihe</span>", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Activity line","(courses.Journeys.line) Pointer to the course series.") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/line" }) }) });
    var teacher3866 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kursleiter ausw\u00e4hlen...", "fieldLabel": "Kursleiter", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor","(courses.Journeys.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/teacher" }) }) });
    var workflow_buttons_disp3867 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(courses.Journeys.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_1_panel3868 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 23, "items": ref3864, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": line3865, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": teacher3866, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": workflow_buttons_disp3867, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room3873 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Raum ausw\u00e4hlen...", "fieldLabel": "Raum", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(courses.Journeys.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/room" }) }) });
    var start_date3874 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Start date","(courses.Journeys.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var end_date3875 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(courses.Journeys.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var start_time3876 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(courses.Journeys.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time3877 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Endet um", "listeners": { "render": Lino.quicktip_renderer("End Time","(courses.Journeys.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var general_2_panel3878 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 32, "items": room3873, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": start_date3874, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": end_date3875, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": start_time3876, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": end_time3877, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name3884 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Journeys.name) A short designation for this course. An extension of the\nref.") }, "maxLength": 100, "name": "name", "selectOnFocus": true });
    var remark3885 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Bemerkung", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.Journeys.remark) ") }, "name": "remark", "selectOnFocus": true });
    var general_panel3886 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel3868, general_2_panel3878, { "autoHeight": true, "items": name3884, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 50, "items": remark3885, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var every_unit3889 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Wiederholung", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(courses.Journeys.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every3890 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "... alle", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(courses.Journeys.every) ") }, "name": "every", "selectOnFocus": true });
    var max_date3891 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Termine generieren bis", "listeners": { "render": Lino.quicktip_renderer("Generate events until","(courses.Journeys.max_date) ") }, "name": "max_date", "selectOnFocus": true });
    var max_events3892 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Anzahl Termine", "listeners": { "render": Lino.quicktip_renderer("Number of events","(courses.Journeys.max_events) ") }, "name": "max_events", "selectOnFocus": true });
    var events_1_panel3893 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 47, "items": every_unit3889, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": every3890, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": max_date3891, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": max_events3892, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var monday3898 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Montag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Monday","(courses.Journeys.monday) ") }, "name": "monday", "selectOnFocus": true });
    var tuesday3899 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Dienstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Tuesday","(courses.Journeys.tuesday) ") }, "name": "tuesday", "selectOnFocus": true });
    var wednesday3900 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Mittwoch", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wednesday","(courses.Journeys.wednesday) ") }, "name": "wednesday", "selectOnFocus": true });
    var thursday3901 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Donnerstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Thursday","(courses.Journeys.thursday) ") }, "name": "thursday", "selectOnFocus": true });
    var friday3902 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Freitag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Friday","(courses.Journeys.friday) ") }, "name": "friday", "selectOnFocus": true });
    var saturday3903 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Samstag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Saturday","(courses.Journeys.saturday) ") }, "name": "saturday", "selectOnFocus": true });
    var sunday3904 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Sonntag", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Sunday","(courses.Journeys.sunday) ") }, "name": "sunday", "selectOnFocus": true });
    var events_2_panel3905 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": monday3898, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": tuesday3899, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": wednesday3900, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": thursday3901, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": friday3902, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": saturday3903, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": sunday3904, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_EntriesByCourse_htmlbox3913 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 60, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(courses.Journeys.courses_EntriesByCourse) Shows the events linked to this course.") }, "master_panel": this, "name": "courses_EntriesByCourse", "title": "Kalendereintr\u00e4ge", "tools": [ Lino.show_in_own_window_button(Lino.courses.EntriesByCourse.grid) ], "value": "<br/>" });
    var events_panel3914 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ events_1_panel3893, events_2_panel3905, courses_EntriesByCourse_htmlbox3913 ], "labelAlign": "top", "labelWidth": 153, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Veranstaltungen" });
    var enrolments_until3915 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Einschreibung m\u00f6glich bis", "listeners": { "render": Lino.quicktip_renderer("Enrolments until","(courses.Journeys.enrolments_until) ") }, "name": "enrolments_until", "selectOnFocus": true });
    var fee3916 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Tarif ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Standard-Teilnehmahmegeb\u00fchr</span>", "hiddenName": "feeHidden", "listeners": { "render": Lino.quicktip_renderer("Default participation fee","(courses.Journeys.fee) The default participation fee to apply for new enrolments.") }, "name": "fee", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/fee" }) }) });
    var max_places3917 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Verf\u00fcgbare Pl\u00e4tze</span>", "listeners": { "render": Lino.quicktip_renderer("Available places","(courses.Journeys.max_places) Maximum number of participants") }, "name": "max_places", "selectOnFocus": true });
    var confirmed3918 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Best\u00e4tigt", "listeners": { "render": Lino.quicktip_renderer("Confirmed","(courses.Journeys.confirmed) ") }, "name": "confirmed" });
    var free_places3919 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Freie Pl\u00e4tze", "listeners": { "render": Lino.quicktip_renderer("Free places","(courses.Journeys.free_places) ") }, "name": "free_places" });
    var print_actions_disp3920 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Drucken", "listeners": { "render": Lino.quicktip_renderer("Print","(courses.Journeys.print_actions) ") }, "name": "print_actions", "value": "<br/>" });
    var enrolments_top_panel3921 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 19, "items": enrolments_until3915, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": fee3916, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": max_places3917, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": confirmed3918, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": free_places3919, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": print_actions_disp3920, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 234, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EnrolmentsByJourney_htmlbox3928 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Enrolments","(courses.Journeys.EnrolmentsByJourney) The Voga version of EnrolmentsByCourse.") }, "ls_bbar_actions": [ { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" } ], "ls_insert_handler": Lino.courses.EnrolmentsByJourney.insert, "master_panel": this, "name": "EnrolmentsByJourney", "title": "Einschreibungen", "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByJourney.grid) ], "value": "<br/>" });
    var enrolments_panel3929 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ enrolments_top_panel3921, EnrolmentsByJourney_htmlbox3928 ], "labelAlign": "top", "labelWidth": 99, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Einschreibungen" });
    var state3930 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zustand</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(courses.Journeys.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".") }, "name": "state", "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var user3931 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.Journeys.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/user" }) }) });
    var payment_term3932 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Zahlungsbedingung</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(courses.Journeys.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/payment_term" }) }) });
    var paper_type3933 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Papierart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Papierart</span>", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(courses.Journeys.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/paper_type" }) }) });
    var id3934 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Journeys.id) ") }, "name": "id", "selectOnFocus": true });
    var more_1_panel3935 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": state3930, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": user3931, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": payment_term3932, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": paper_type3933, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": id3934, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var invoicing_InvoicingsByInvoiceable_grid3941 = new Lino.invoicing.InvoicingsByInvoiceable.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Invoicings","(invoicing.invoicing.InvoicingsByInvoiceable) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.invoicing.InvoicingsByInvoiceable.grid) ] });
    var more_panel3942 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel3935, invoicing_InvoicingsByInvoiceable_grid3941 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var main_panel3943 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel3886, events_panel3914, enrolments_panel3929, more_panel3942 ], "labelAlign": "top", "split": true });
    this.items = main_panel3943;
    this.before_row_edit = function(record) {
      courses_EntriesByCourse_htmlbox3913.refresh();
      fee3916.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      EnrolmentsByJourney_htmlbox3928.refresh();
      invoicing_InvoicingsByInvoiceable_grid3941.on_master_changed();
    }
    this.onRender = function(ct, position) {
      line3865.on('change',Lino.chooser_handler(fee3916,'line'));
      Lino.courses.Journeys.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Journeys.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.excerpts.ExcerptTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 75,
  initComponent : function() {
    var id3944 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(excerpts.ExcerptTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var name3945 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(excerpts.ExcerptTypes.name) The designation of this excerpt type.\nOne field for every language.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3946 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(excerpts.ExcerptTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3947 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(excerpts.ExcerptTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3948 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id3944, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name3945, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de3946, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr3947, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var content_type3953 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Datenbankmodell ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Modell</span>", "hiddenName": "content_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Model","(excerpts.ExcerptTypes.content_type) The model that can issue printouts of this type.") }, "name": "content_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.gfks.ContentTypes.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/content_type" }) }) });
    var build_method3954 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Konstruktionsmethode</span>", "forceSelection": true, "hiddenName": "build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Build method","(excerpts.ExcerptTypes.build_method) See lino.modlib.printing.mixins.PrintableType.build_method.") }, "name": "build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var template3955 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Vorlage</span>", "listeners": { "render": Lino.quicktip_renderer("Template","(excerpts.ExcerptTypes.template) The main template to be used when printing an excerpt of this type.") }, "name": "template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/template" }) }) });
    var body_template3956 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Textk\u00f6rper-Vorlage</span>", "listeners": { "render": Lino.quicktip_renderer("Body template","(excerpts.ExcerptTypes.body_template) The body template to be used when         rendering a printable of this type. This is a list of files         with extension `.body.html`.") }, "name": "body_template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/body_template" }) }) });
    var email_template3957 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">E-Mail-Vorlage</span>", "listeners": { "render": Lino.quicktip_renderer("Email template","(excerpts.ExcerptTypes.email_template) The name of the file to be used as template when creating an email from a mailable of this type.") }, "name": "email_template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/email_template" }) }) });
    var shortcut3958 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Excerpt shortcut</span>", "listeners": { "render": Lino.quicktip_renderer("Excerpt shortcut","(excerpts.ExcerptTypes.shortcut) Optional pointer to a shortcut field.  If this is not empty, then\nthe given shortcut field will manage excerpts of this type.") }, "maxLength": 50, "name": "shortcut", "selectOnFocus": true });
    var main_2_panel3959 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 15, "items": content_type3953, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": build_method3954, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": template3955, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": body_template3956, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": email_template3957, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": shortcut3958, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var primary3966 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Prim\u00e4r", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Primary","(excerpts.ExcerptTypes.primary) Whether this is the default type to use for this model. There's at most one primary type per model. Enabling this field will automatically make the other types non-primary.") }, "name": "primary", "selectOnFocus": true });
    var print_directly3967 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Print directly", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Print directly","(excerpts.ExcerptTypes.print_directly) ") }, "name": "print_directly", "selectOnFocus": true });
    var certifying3968 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Bescheinigend", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Certifying","(excerpts.ExcerptTypes.certifying) Whether an excerpt of this type is a unique printout.") }, "name": "certifying", "selectOnFocus": true });
    var print_recipient3969 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Empf\u00e4nger drucken", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Print recipient","(excerpts.ExcerptTypes.print_recipient) Whether to print a recipient field in document.") }, "name": "print_recipient", "selectOnFocus": true });
    var backward_compat3970 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Backward compatible", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Backward compatible","(excerpts.ExcerptTypes.backward_compat) Check this to have `this` in template context point to owner instead of excerpt.") }, "name": "backward_compat", "selectOnFocus": true });
    var attach_to_email3971 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "als Anhang per E-Mail", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Attach to email","(excerpts.ExcerptTypes.attach_to_email) Whether the printable file should be attached to the email\nwhen creating an email from a mailable of this type.\n") }, "name": "attach_to_email", "selectOnFocus": true });
    var main_3_panel3972 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 16, "items": primary3966, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": print_directly3967, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": certifying3968, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": print_recipient3969, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": backward_compat3970, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": attach_to_email3971, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var excerpts_ExcerptsByType_grid4005 = new Lino.excerpts.ExcerptsByType.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Excerpts","(excerpts.excerpts.ExcerptsByType) Base class for all tables on Excerpt.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.excerpts.ExcerptsByType.grid) ] });
    var main_panel4006 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3948, main_2_panel3959, main_3_panel3972, excerpts_ExcerptsByType_grid4005 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel4006;
    this.before_row_edit = function(record) {
      template3955.setContextValue('build_method', record ? record.data['build_methodHidden'] : undefined);
      template3955.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
      body_template3956.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
      email_template3957.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
      excerpts_ExcerptsByType_grid4005.on_master_changed();
    }
    this.onRender = function(ct, position) {
      build_method3954.on('change',Lino.chooser_handler(template3955,'build_method'));
      content_type3953.on('change',Lino.chooser_handler(template3955,'content_type'));
      content_type3953.on('change',Lino.chooser_handler(body_template3956,'content_type'));
      content_type3953.on('change',Lino.chooser_handler(email_template3957,'content_type'));
      Lino.excerpts.ExcerptTypes.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.excerpts.ExcerptTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.PaymentOrders.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 64,
  initComponent : function() {
    var entry_date4007 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsdatum</span>", "listeners": { "render": Lino.quicktip_renderer("Entry date","(finan.PaymentOrders.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.") }, "name": "entry_date", "selectOnFocus": true });
    var number4008 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Nr.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(finan.PaymentOrders.number) The sequence number of this voucher in the journal.") }, "name": "number", "selectOnFocus": true });
    var total4009 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "Total", "listeners": { "render": Lino.quicktip_renderer("Total","(finan.PaymentOrders.total) ") }, "name": "total", "selectOnFocus": true });
    var execution_date4010 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Ausf\u00fchrungsdatum", "listeners": { "render": Lino.quicktip_renderer("Execution date","(finan.PaymentOrders.execution_date) ") }, "name": "execution_date", "selectOnFocus": true });
    var workflow_buttons_disp4011 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(finan.PaymentOrders.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_1_panel4012 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 17, "items": entry_date4007, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": number4008, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": total4009, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 17, "items": execution_date4010, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": workflow_buttons_disp4011, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var narration4018 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Beschreibung</span>", "listeners": { "render": Lino.quicktip_renderer("Narration","(finan.PaymentOrders.narration) A short explanation which ascertains the subject matter of\nthis journal entry.") }, "maxLength": 200, "name": "narration", "selectOnFocus": true });
    var ItemsByPaymentOrder_htmlbox4019 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 42, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Content","(finan.PaymentOrders.ItemsByPaymentOrder) ") }, "master_panel": this, "name": "ItemsByPaymentOrder", "title": "Inhalt", "tools": [ Lino.show_in_own_window_button(Lino.finan.ItemsByPaymentOrder.grid) ], "value": "<br/>" });
    var general_panel4020 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel4012, { "autoHeight": true, "items": narration4018, "labelAlign": "top", "layout": "form", "xtype": "panel" }, ItemsByPaymentOrder_htmlbox4019 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var journal4022 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(finan.PaymentOrders.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/journal" }) }) });
    var accounting_period4023 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsperiode</span>", "hiddenName": "accounting_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Accounting period","(finan.PaymentOrders.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.") }, "name": "accounting_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/accounting_period" }) }) });
    var user4024 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(finan.PaymentOrders.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/user" }) }) });
    var id4025 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(finan.PaymentOrders.id) ") }, "name": "id", "selectOnFocus": true });
    var more_1_panel4026 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": journal4022, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": accounting_period4023, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": user4024, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": id4025, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var item_account4031 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Konto ausw\u00e4hlen...", "fieldLabel": "Standardwert Konto", "hiddenName": "item_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Default account","(finan.PaymentOrders.item_account) ") }, "name": "item_account", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/item_account" }) }) });
    var item_remark4032 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Ihr Zeichen", "listeners": { "render": Lino.quicktip_renderer("Your reference","(finan.PaymentOrders.item_remark) ") }, "maxLength": 200, "name": "item_remark", "selectOnFocus": true });
    var more_2_panel4033 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 48, "items": item_account4031, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 51, "items": item_remark4032, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MovementsByVoucher_htmlbox4036 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 60, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(finan.PaymentOrders.MovementsByVoucher) ") }, "master_panel": this, "name": "MovementsByVoucher", "title": "Bewegungen", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByVoucher.grid) ], "value": "<br/>" });
    var more_panel4037 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel4026, more_2_panel4033, MovementsByVoucher_htmlbox4036 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var main_panel4038 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel4020, more_panel4037 ], "labelAlign": "top", "split": true });
    this.items = main_panel4038;
    this.before_row_edit = function(record) {
      ItemsByPaymentOrder_htmlbox4019.refresh();
      MovementsByVoucher_htmlbox4036.refresh();
    }
    Lino.finan.PaymentOrders.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.uploads.UploadTypes.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 70,
  initComponent : function() {
    var name4039 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(uploads.UploadTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de4040 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(uploads.UploadTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr4041 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(uploads.UploadTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel4042 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name4039, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de4040, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr4041, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var upload_area4046 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Upload-Bereich", "forceSelection": true, "hiddenName": "upload_areaHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Area","(uploads.UploadTypes.upload_area) ") }, "name": "upload_area", "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var main_panel4047 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel4042, { "anchor": "-20", "autoHeight": true, "items": upload_area4046, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "form" });
    this.items = main_panel4047;
    this.before_row_edit = function(record) {
    }
    Lino.uploads.UploadTypes.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.BankStatements.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 61,
  initComponent : function() {
    var entry_date4049 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsdatum</span>", "listeners": { "render": Lino.quicktip_renderer("Entry date","(finan.BankStatements.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.") }, "name": "entry_date", "selectOnFocus": true });
    var number4050 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Nr.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(finan.BankStatements.number) The sequence number of this voucher in the journal.") }, "name": "number", "selectOnFocus": true });
    var balance14051 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Alter Saldo</span>", "listeners": { "render": Lino.quicktip_renderer("Old balance","(finan.BankStatements.balance1) The old (or start) balance.") }, "name": "balance1", "selectOnFocus": true, "value": 0 });
    var balance24052 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Neuer Saldo</span>", "listeners": { "render": Lino.quicktip_renderer("New balance","(finan.BankStatements.balance2) The new (or end) balance.") }, "name": "balance2", "selectOnFocus": true, "value": 0 });
    var workflow_buttons_disp4053 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Workflow", "listeners": { "render": Lino.quicktip_renderer("Workflow","(finan.BankStatements.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_1_panel4054 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 17, "items": entry_date4049, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": number4050, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": balance14051, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": balance24052, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 41, "items": workflow_buttons_disp4053, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ItemsByBankStatement_htmlbox4060 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Content","(finan.BankStatements.ItemsByBankStatement) ") }, "master_panel": this, "name": "ItemsByBankStatement", "title": "Inhalt", "tools": [ Lino.show_in_own_window_button(Lino.finan.ItemsByBankStatement.grid) ], "value": "<br/>" });
    var general_panel4061 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel4054, ItemsByBankStatement_htmlbox4060 ], "labelAlign": "top", "labelWidth": 72, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Allgemein" });
    var journal4062 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Journal ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(finan.BankStatements.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/journal" }) }) });
    var accounting_period4063 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Buchungsperiode ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Buchungsperiode</span>", "hiddenName": "accounting_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Accounting period","(finan.BankStatements.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.") }, "name": "accounting_period", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/accounting_period" }) }) });
    var user4064 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(finan.BankStatements.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/user" }) }) });
    var id4065 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(finan.BankStatements.id) ") }, "name": "id", "selectOnFocus": true });
    var more_1_panel4066 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": journal4062, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": accounting_period4063, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": user4064, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": id4065, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var item_account4071 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Konto ausw\u00e4hlen...", "fieldLabel": "Standardwert Konto", "hiddenName": "item_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Default account","(finan.BankStatements.item_account) ") }, "name": "item_account", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/item_account" }) }) });
    var item_remark4072 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Ihr Zeichen", "listeners": { "render": Lino.quicktip_renderer("Your reference","(finan.BankStatements.item_remark) ") }, "maxLength": 200, "name": "item_remark", "selectOnFocus": true });
    var more_2_panel4073 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 48, "items": item_account4071, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 51, "items": item_remark4072, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MovementsByVoucher_htmlbox4076 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 60, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(finan.BankStatements.MovementsByVoucher) ") }, "master_panel": this, "name": "MovementsByVoucher", "title": "Bewegungen", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByVoucher.grid) ], "value": "<br/>" });
    var more_panel4077 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel4066, more_2_panel4073, MovementsByVoucher_htmlbox4076 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Mehr" });
    var main_panel4078 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel4061, more_panel4077 ], "labelAlign": "top", "split": true });
    this.items = main_panel4078;
    this.before_row_edit = function(record) {
      ItemsByBankStatement_htmlbox4060.refresh();
      MovementsByVoucher_htmlbox4076.refresh();
    }
    Lino.finan.BankStatements.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Partners.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 10,
  initComponent : function() {
    var name4079 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Name</span>", "listeners": { "render": Lino.quicktip_renderer("Name","(contacts.Partners.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var email4080 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">E-Mail-Adresse</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(contacts.Partners.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var main_panel4081 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": name4079, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": email4080, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    this.items = main_panel4081;
    this.before_row_edit = function(record) {
    }
    Lino.contacts.Partners.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.countries.Places.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 5,
  initComponent : function() {
    var name2418 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(countries.Places.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2419 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(countries.Places.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2420 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(countries.Places.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var country2421 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Land ausw\u00e4hlen...", "fieldLabel": "Land", "hiddenName": "countryHidden", "listeners": { "render": Lino.quicktip_renderer("Country","(countries.Places.country) ") }, "name": "country", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Countries.detail,Lino.countries.Countries.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/Places/country" }) }) });
    var main_1_panel2422 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 25, "items": name2418, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_de2419, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_fr2420, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": country2421, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var type2427 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Ortsart", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Place Type","(countries.Places.type) ") }, "name": "type", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/Places/type" }) }) });
    var parent2428 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Ort ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Teil von</span>", "hiddenName": "parentHidden", "listeners": { "render": Lino.quicktip_renderer("Part of","(countries.Places.parent) The superordinate geographic place of which this place is a part.") }, "name": "parent", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Places.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/Places/parent" }) }) });
    var zip_code2429 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(8), "fieldLabel": "zip code", "listeners": { "render": Lino.quicktip_renderer("zip code","(countries.Places.zip_code) ") }, "maxLength": 8, "name": "zip_code", "selectOnFocus": true });
    var id2430 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(countries.Places.id) ") }, "name": "id", "selectOnFocus": true });
    var main_2_panel2431 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 22, "items": type2427, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 45, "items": parent2428, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": zip_code2429, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": id2430, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var PlacesByPlace_grid2470 = new Lino.countries.PlacesByPlace.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Subdivisions","(countries.countries.PlacesByPlace) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.countries.PlacesByPlace.grid) ] });
    var main_panel2471 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2422, main_2_panel2431, PlacesByPlace_grid2470 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2471;
    this.before_row_edit = function(record) {
      type2427.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      PlacesByPlace_grid2470.on_master_changed();
    }
    this.onRender = function(ct, position) {
      country2421.on('change',Lino.chooser_handler(type2427,'country'));
      Lino.countries.Places.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.countries.Places.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.AllRooms.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 20,
  initComponent : function() {
    var id4084 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.AllRooms.id) ") }, "name": "id", "selectOnFocus": true });
    var name4085 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.AllRooms.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de4086 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.AllRooms.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr4087 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.AllRooms.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel4088 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id4084, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name4085, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de4086, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr4087, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var company4093 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Organisation ausw\u00e4hlen...", "fieldLabel": "Verantwortlicher", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible","(cal.AllRooms.company) ") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllRooms/company" }) }) });
    var contact_person4094 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Person ausw\u00e4hlen...", "fieldLabel": "Kontaktperson", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Contact person","(cal.AllRooms.contact_person) ") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllRooms/contact_person" }) }) });
    var main_2_panel4095 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": company4093, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": contact_person4094, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description4098 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Beschreibung", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description","(cal.AllRooms.description) ") }, "name": "description", "selectOnFocus": true });
    var cal_EntriesByRoom_grid4099 = new Lino.cal.EntriesByRoom.GridPanel({ "containing_panel": this, "flex": 41, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(cal.cal.EntriesByRoom) Displays the Events at a given Room.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.cal.EntriesByRoom.grid) ] });
    var main_panel4100 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel4088, main_2_panel4095, { "flex": 41, "items": description4098, "labelAlign": "top", "layout": "form", "xtype": "panel" }, cal_EntriesByRoom_grid4099 ], "labelAlign": "top", "labelWidth": 108, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel4100;
    this.before_row_edit = function(record) {
      contact_person4094.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      cal_EntriesByRoom_grid4099.on_master_changed();
    }
    this.onRender = function(ct, position) {
      company4093.on('change',Lino.chooser_handler(contact_person4094,'company'));
      Lino.cal.AllRooms.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.cal.AllRooms.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Slots.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 49,
  initComponent : function() {
    var start_time4102 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt um", "listeners": { "render": Lino.quicktip_renderer("Start Time","(courses.Slots.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time4103 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Endet um", "listeners": { "render": Lino.quicktip_renderer("End Time","(courses.Slots.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var main_1_panel4104 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": start_time4102, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": end_time4103, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name4107 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Name", "listeners": { "render": Lino.quicktip_renderer("Name","(courses.Slots.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var main_panel4108 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel4104, { "anchor": "-20", "autoHeight": true, "items": name4107, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 45, "layout": "form" });
    this.items = main_panel4108;
    this.before_row_edit = function(record) {
    }
    Lino.courses.Slots.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.excerpts.Excerpts.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 76,
  initComponent : function() {
    var excerpt_type3997 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Auszugsart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Auszugsart</span>", "hiddenName": "excerpt_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Excerpt Type","(excerpts.Excerpts.excerpt_type) The type of this excerpt (ForeignKey to ExcerptType).") }, "name": "excerpt_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.excerpts.ExcerptTypes.detail,Lino.excerpts.ExcerptTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/excerpt_type" }) }) });
    var company3998 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Organisation ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Empf\u00e4nger (Organisation)</span>", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Recipient (Organization)","(excerpts.Excerpts.company) The optional company of the recipient of this\nexcerpt.  See ContactRelated.company.") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/company" }) }) });
    var contact_person3999 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Person ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Empf\u00e4nger (Person)</span>", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Recipient (Person)","(excerpts.Excerpts.contact_person) The optional contact person of the recipient of this\nexcerpt.  See ContactRelated.contact_person.") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/contact_person" }) }) });
    var main_2_panel4000 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": company3998, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": contact_person3999, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 225, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel4003 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": excerpt_type3997, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_2_panel4000 ], "labelAlign": "top", "labelWidth": 117, "layout": "form" });
    this.items = main_panel4003;
    this.before_row_edit = function(record) {
      excerpt_type3997.setContextValue('owner', record ? record.data['owner'] : undefined);
      contact_person3999.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      company3998.on('change',Lino.chooser_handler(contact_person3999,'company'));
      Lino.excerpts.Excerpts.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.excerpts.Excerpts.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Situation.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  disable_editing: true,
  initComponent : function() {
    var body_htmlbox4110 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer(null,"(ledger.Situation.body) ") }, "name": "body", "value": "<br/>" });
    var main_panel4111 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ body_htmlbox4110 ], "labelAlign": "top", "labelWidth": 0, "layout": "fit" });
    this.items = main_panel4111;
    this.before_row_edit = function(record) {
      body_htmlbox4110.refresh();
    }
    Lino.ledger.Situation.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.rooms.Bookings.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 32,
  initComponent : function() {
    var start_date2569 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Beginnt am", "listeners": { "render": Lino.quicktip_renderer("Start date","(rooms.Bookings.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var start_time2570 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(rooms.Bookings.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time2571 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Endet um", "listeners": { "render": Lino.quicktip_renderer("End Time","(rooms.Bookings.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var main_1_panel2572 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 44, "items": start_date2569, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": start_time2570, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": end_time2571, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room2576 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Raum ausw\u00e4hlen...", "fieldLabel": "Raum", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(rooms.Bookings.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/room" }) }) });
    var event_type2577 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kalendereintragsart</span>", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(rooms.Bookings.event_type) The Event Type to which events will be generated.") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/event_type" }) }) });
    var main_2_panel2578 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": room2576, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": event_type2577, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var company2581 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Organisation ausw\u00e4hlen...", "fieldLabel": "Veranstalter", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Organizer","(rooms.Bookings.company) ") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/company" }) }) });
    var contact_person2582 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Person ausw\u00e4hlen...", "fieldLabel": "Kontaktperson", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Contact person","(rooms.Bookings.contact_person) ") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/contact_person" }) }) });
    var main_3_panel2583 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": company2581, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": contact_person2582, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2586 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2572, main_2_panel2578, main_3_panel2583 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel2586;
    this.before_row_edit = function(record) {
      contact_person2582.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      company2581.on('change',Lino.chooser_handler(contact_person2582,'company'));
      Lino.rooms.Bookings.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.rooms.Bookings.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Lines.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 57,
  initComponent : function() {
    var name3529 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Bezeichnung</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Lines.name) The designation of this activity line as seen by the user\ne.g. when selecting the line.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3530 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(courses.Lines.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3531 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(courses.Lines.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3532 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3529, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3530, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3531, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ref3536 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Referenz</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(courses.Lines.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var topic3537 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Thema ausw\u00e4hlen...", "fieldLabel": "Thema", "hiddenName": "topicHidden", "listeners": { "render": Lino.quicktip_renderer("Topic","(courses.Lines.topic) ") }, "name": "topic", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Topics.detail,null)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/topic" }) }) });
    var main_2_panel3538 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 51, "items": ref3536, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 48, "items": topic3537, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var every_unit3541 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Wiederholung", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(courses.Lines.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every3542 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "... alle", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(courses.Lines.every) ") }, "name": "every", "selectOnFocus": true, "value": 1 });
    var event_type3543 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Kalendereintragsart</span>", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(courses.Lines.event_type) The type of calendar entries to be generated. If this is empty, no calendar entries will be generated.") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/event_type" }) }) });
    var main_3_panel3544 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 45, "items": every_unit3541, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": every3542, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": event_type3543, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description3548 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Beschreibung", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description","(courses.Lines.description) ") }, "name": "description", "selectOnFocus": true });
    var description_de3549 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Beschreibung (de)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description (de)","(courses.Lines.description_de) ") }, "name": "description_de", "selectOnFocus": true });
    var description_fr3550 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Beschreibung (fr)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description (fr)","(courses.Lines.description_fr) ") }, "name": "description_fr", "selectOnFocus": true });
    var main_4_panel3551 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 62, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 33, "items": description3548, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_de3549, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_fr3550, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var main_panel3555 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3532, main_2_panel3538, main_3_panel3544, main_4_panel3551 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3555;
    this.before_row_edit = function(record) {
    }
    Lino.courses.Lines.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.AllRooms.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 20,
  initComponent : function() {
    var id4112 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.AllRooms.id) ") }, "name": "id", "selectOnFocus": true });
    var name4113 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.AllRooms.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de4114 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.AllRooms.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr4115 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bezeichnung (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.AllRooms.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel4116 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id4112, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name4113, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de4114, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr4115, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var company4121 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Organisation ausw\u00e4hlen...", "fieldLabel": "Verantwortlicher", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible","(cal.AllRooms.company) ") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllRooms/company" }) }) });
    var contact_person4122 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Person ausw\u00e4hlen...", "fieldLabel": "Kontaktperson", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Contact person","(cal.AllRooms.contact_person) ") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllRooms/contact_person" }) }) });
    var main_panel4123 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel4116, { "anchor": "-20", "autoHeight": true, "items": company4121, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": contact_person4122, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    this.items = main_panel4123;
    this.before_row_edit = function(record) {
      contact_person4122.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      company4121.on('change',Lino.chooser_handler(contact_person4122,'company'));
      Lino.cal.AllRooms.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.cal.AllRooms.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.EnrolmentsByCourse.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 53,
  initComponent : function() {
    var pupil4126 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Teilnehmer ausw\u00e4hlen...", "fieldLabel": "Teilnehmer", "forceSelection": false, "hiddenName": "pupilHidden", "listeners": { "render": Lino.quicktip_renderer("Participant","(courses.EnrolmentsByCourse.pupil) ") }, "name": "pupil", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Pupils.detail,Lino.courses.Pupils.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/pupil" }) }) });
    var remark4127 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Bemerkung", "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.EnrolmentsByCourse.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var request_date4128 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Datum der Anfrage", "listeners": { "render": Lino.quicktip_renderer("Date of request","(courses.EnrolmentsByCourse.request_date) ") }, "name": "request_date", "selectOnFocus": true });
    var user4129 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Autor", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.EnrolmentsByCourse.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/user" }) }) });
    var main_3_panel4130 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": request_date4128, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 60, "items": user4129, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel4133 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": pupil4126, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": remark4127, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_3_panel4130 ], "labelAlign": "top", "labelWidth": 108, "layout": "form" });
    this.items = main_panel4133;
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      pupil4126.setContextValue('mk',bp['mk']);
      pupil4126.setContextValue('mt',bp['mt']);
    }
    Lino.courses.EnrolmentsByCourse.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.uploads.Uploads.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 71,
  initComponent : function() {
    var type3812 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Upload-Art ausw\u00e4hlen...", "fieldLabel": "Upload-Art", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Type","(uploads.Uploads.type) ") }, "name": "type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.uploads.UploadTypes.detail,Lino.uploads.UploadTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/type" }) }) });
    var description3813 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Beschreibung</span>", "listeners": { "render": Lino.quicktip_renderer("Description","(uploads.Uploads.description) A short description entered manually by the user.") }, "maxLength": 200, "name": "description", "selectOnFocus": true });
    var file3814 = Lino.file_field_handler(this,{ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Datei</span>", "listeners": { "render": Lino.quicktip_renderer("File","(uploads.Uploads.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file") }, "maxLength": 100, "name": "file", "selectOnFocus": true });
    var user3815 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Benutzer ausw\u00e4hlen...", "fieldLabel": "Hochgeladen durch", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Uploaded by","(uploads.Uploads.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/user" }) }) });
    var main_panel3816 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": type3812, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": description3813, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": file3814, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": user3815, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "form" });
    this.items = main_panel3816;
    this.before_row_edit = function(record) {
      type3812.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
    }
    Lino.uploads.Uploads.InsertFormPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Companies.merge_row = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.contacts.Companies.merge_row_ActionFormPanel({});
});
Lino.sales.Invoices.make_copy = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.Invoices.make_copy_ActionFormPanel({});
});
Lino.users.Users.change_password = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.users.Users.change_password_ActionFormPanel({});
});
Lino.users.AllUsers.send_welcome_email = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.users.AllUsers.send_welcome_email_ActionFormPanel({});
});
Lino.users.UsersOverview.sign_in = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.users.UsersOverview.sign_in_ActionFormPanel({});
});
Lino.courses.Activities.print_presence_sheet_html = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Activities.print_presence_sheet_html_ActionFormPanel({});
});
Lino.courses.Activities.print_presence_sheet = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Activities.print_presence_sheet_ActionFormPanel({});
});
Lino.courses.Pupils.merge_row = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Pupils.merge_row_ActionFormPanel({});
});

// js_render_GridPanel_class system.SiteConfigs
Lino.system.SiteConfigs.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 34,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/system/SiteConfigs",
  ls_bbar_actions : [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "do_build", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Rebuild the site cache.\nThis action is available on About.") }, "menu_item_text": "Site-Cache rekonstruieren", "overflowText": "Site-Cache rekonstruieren", "panel_btn_handler": Lino.row_action_handler('do_build','GET',null), "text": "Site-Cache rekonstruieren" } ],
  cell_edit : true,
  title : "Site-Konfigurations",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "default_build_method" }, 'default_build_methodHidden', { "dateFormat": "d.m.Y", "name": "simulate_today", "type": "date" }, { "name": "site_company" }, 'site_companyHidden', { "name": "next_partner_id", "type": "int", "useNull": true }, { "name": "default_event_type" }, 'default_event_typeHidden', { "name": "site_calendar" }, 'site_calendarHidden', { "name": "max_auto_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "hide_events_before", "type": "date" }, { "name": "pupil_guestrole" }, 'pupil_guestroleHidden', { "name": "system_note_type" }, 'system_note_typeHidden', { "name": "clients_account" }, 'clients_accountHidden', { "name": "sales_account" }, 'sales_accountHidden', { "name": "suppliers_account" }, 'suppliers_accountHidden', { "name": "purchases_account" }, 'purchases_accountHidden', { "name": "wages_account" }, 'wages_accountHidden', { "name": "tax_offices_account" }, 'tax_offices_accountHidden', { "name": "clearings_account" }, 'clearings_accountHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 1,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.system.SiteConfigs.detail;
    var ww = this.containing_window;
    var id10067 = new Ext.form.NumberField({ "selectOnFocus": true });
    var default_build_method10068 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var simulate_today10069 = new Lino.DateField({ "selectOnFocus": true });
    var site_company10070 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/site_company" }) }) });
    var next_partner_id10071 = new Ext.form.NumberField({ "selectOnFocus": true, "value": 100 });
    var default_event_type10072 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/default_event_type" }) }) });
    var site_calendar10073 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalender ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/site_calendar" }) }) });
    var max_auto_events10074 = new Ext.form.NumberField({ "selectOnFocus": true, "value": 72 });
    var hide_events_before10075 = new Lino.DateField({ "selectOnFocus": true });
    var pupil_guestrole10076 = new Lino.RemoteComboFieldElement({ "emptyText": "Gastrolle ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/pupil_guestrole" }) }) });
    var system_note_type10077 = new Lino.RemoteComboFieldElement({ "emptyText": "Event Type ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/system_note_type" }) }) });
    var clients_account10078 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/clients_account" }) }) });
    var sales_account10079 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/sales_account" }) }) });
    var suppliers_account10080 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/suppliers_account" }) }) });
    var purchases_account10081 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/purchases_account" }) }) });
    var wages_account10082 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/wages_account" }) }) });
    var tax_offices_account10083 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/tax_offices_account" }) }) });
    var clearings_account10084 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/clearings_account" }) }) });
    var mobile_item_disp10085 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10086 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10087 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10067, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(system.SiteConfigs.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "default_build_method", "editable": true, "editor": default_build_method10068, "filter": { "type": "string" }, "header": "Standard-Konstruktionsmethode", "sortable": false, "tooltip": "(system.SiteConfigs.default_build_method) The default build method to use when rendering printable documents.", "width": Lino.chars2width(24) }, { "colIndex": 2, "dataIndex": "simulate_today", "editable": true, "editor": simulate_today10069, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Simulated date", "sortable": true, "tooltip": "(system.SiteConfigs.simulate_today) A constant user-defined date to be substituted as current\nsystem date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "site_company", "editable": true, "editor": site_company10070, "filter": { "type": "string" }, "header": "Site owner", "renderer": Lino.fk_renderer('site_companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(system.SiteConfigs.site_company) The organisation who runs this site.  This is used e.g. when\nprinting your address in certain documents or reports.  Or\nnewly created partners inherit the country of the site owner.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "next_partner_id", "editable": true, "editor": next_partner_id10071, "filter": { "type": "numeric" }, "format": "0", "header": "N\u00e4chste Partnernummer", "sortable": true, "tooltip": "(system.SiteConfigs.next_partner_id) N\u00e4chste Partnernummer", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "default_event_type", "editable": true, "editor": default_event_type10072, "filter": { "type": "string" }, "header": "Standard-Kalenderintragsart", "renderer": Lino.fk_renderer('default_event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(system.SiteConfigs.default_event_type) The default type of events on this site.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "site_calendar", "editable": true, "editor": site_calendar10073, "filter": { "type": "string" }, "header": "Site Calendar", "renderer": Lino.fk_renderer('site_calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(system.SiteConfigs.site_calendar) The default calendar of this site.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 7, "dataIndex": "max_auto_events", "editable": true, "editor": max_auto_events10074, "filter": { "type": "numeric" }, "format": "0", "header": "Max automatic events", "sortable": true, "tooltip": "(system.SiteConfigs.max_auto_events) Maximum number of automatic events to be generated.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "hide_events_before", "editable": true, "editor": hide_events_before10075, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Hide events before", "sortable": true, "tooltip": "(system.SiteConfigs.hide_events_before) If this is specified, certain tables show only \nevents after the given date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "pupil_guestrole", "editable": true, "editor": pupil_guestrole10076, "filter": { "type": "string" }, "header": "Guest role for pupils", "renderer": Lino.fk_renderer('pupil_guestroleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(system.SiteConfigs.pupil_guestrole) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "system_note_type", "editable": true, "editor": system_note_type10077, "filter": { "type": "string" }, "header": "Default system note type", "renderer": Lino.fk_renderer('system_note_typeHidden','Lino.notes.EventTypes.detail'), "sortable": false, "tooltip": "(system.SiteConfigs.system_note_type) Note Type used by system notes.\nIf this is empty, then system notes won't create any entry to the Notes table.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "clients_account", "editable": true, "editor": clients_account10078, "filter": { "type": "string" }, "header": "Konto f\u00fcr Kunden", "sortable": false, "tooltip": "(system.SiteConfigs.clients_account) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "sales_account", "editable": true, "editor": sales_account10079, "filter": { "type": "string" }, "header": "Konto f\u00fcr Basisbetrag Verk\u00e4ufe", "sortable": false, "tooltip": "(system.SiteConfigs.sales_account) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "suppliers_account", "editable": true, "editor": suppliers_account10080, "filter": { "type": "string" }, "header": "Konto f\u00fcr Lieferanten", "sortable": false, "tooltip": "(system.SiteConfigs.suppliers_account) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "purchases_account", "editable": true, "editor": purchases_account10081, "filter": { "type": "string" }, "header": "Basis Einkauf", "sortable": false, "tooltip": "(system.SiteConfigs.purchases_account) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "wages_account", "editable": true, "editor": wages_account10082, "filter": { "type": "string" }, "header": "Konto f\u00fcr L\u00f6hne und Geh\u00e4lter", "sortable": false, "tooltip": "(system.SiteConfigs.wages_account) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "tax_offices_account", "editable": true, "editor": tax_offices_account10083, "filter": { "type": "string" }, "header": "Tax offices account", "sortable": false, "tooltip": "(system.SiteConfigs.tax_offices_account) ", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "clearings_account", "editable": true, "editor": clearings_account10084, "filter": { "type": "string" }, "header": "Konto f\u00fcr Ausgleichungen", "sortable": false, "tooltip": "(system.SiteConfigs.clearings_account) ", "width": Lino.chars2width(21) }, { "colIndex": 18, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(system.SiteConfigs.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(system.SiteConfigs.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(system.SiteConfigs.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.system.SiteConfigs.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.system.SiteConfigs.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/SiteConfigs", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/SiteConfigs", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/SiteConfigs", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/SiteConfigs", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/SiteConfigs", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/SiteConfigs", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/SiteConfigs", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/SiteConfigs", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.system.SiteConfigs.detailPanel = Ext.extend(Lino.system.SiteConfigs.DetailFormPanel,{
  empty_title: "Site-Konfigurations",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "do_build", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Rebuild the site cache.\nThis action is available on About.") }, "menu_item_text": "Site-Cache rekonstruieren", "overflowText": "Site-Cache rekonstruieren", "panel_btn_handler": Lino.row_action_handler('do_build','GET',null), "text": "Site-Cache rekonstruieren" } ],
  ls_url: "/system/SiteConfigs",
  initComponent : function() {
    this.ls_detail_handler = Lino.system.SiteConfigs.detail;
    Lino.system.SiteConfigs.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.system.SiteConfigs.detail = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.system.SiteConfigs.detailPanel(p);
});

Lino.system.SiteConfigs.detailPanel = Ext.extend(Lino.system.SiteConfigs.DetailFormPanel,{
  empty_title: "Site-Konfigurations",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "do_build", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Rebuild the site cache.\nThis action is available on About.") }, "menu_item_text": "Site-Cache rekonstruieren", "overflowText": "Site-Cache rekonstruieren", "panel_btn_handler": Lino.row_action_handler('do_build','GET',null), "text": "Site-Cache rekonstruieren" } ],
  ls_url: "/system/SiteConfigs",
  initComponent : function() {
    this.ls_detail_handler = Lino.system.SiteConfigs.detail;
    Lino.system.SiteConfigs.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.system.SiteConfigs.detail = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.system.SiteConfigs.detailPanel(p);
});
Lino.system.SiteConfigs.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/SiteConfigs", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.do_build = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/SiteConfigs", "GET", pk, "do_build", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class countries.Countries
Lino.countries.Countries.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 9,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/countries/Countries",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/countries/Countries','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/countries/Countries','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/countries/Countries','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/countries/Countries','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/countries/Countries','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "L\u00e4nder",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "isocode" }, { "name": "short_code" }, { "name": "iso3" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 4,
  ls_id_property : "isocode",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.Countries.detail;
    this.ls_insert_handler = Lino.countries.Countries.insert;
    var ww = this.containing_window;
    var name10089 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10090 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10091 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var isocode10092 = new Ext.form.TextField({ "allowBlank": false, "boxMinWidth": Lino.chars2width(4), "maxLength": 4, "selectOnFocus": true });
    var short_code10093 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(4), "hidden": true, "maxLength": 4, "selectOnFocus": true });
    var iso310094 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(3), "hidden": true, "maxLength": 3, "selectOnFocus": true });
    var mobile_item_disp10095 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10096 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10097 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name10089, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(countries.Countries.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de10090, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(countries.Countries.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr10091, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(countries.Countries.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "isocode", "editable": true, "editor": isocode10092, "filter": { "type": "string" }, "header": "ISO-Code", "sortable": true, "tooltip": "(countries.Countries.isocode)         The two-letter code for this country as defined by ISO 3166-1.\n        For countries that no longer exist it may be a 4-letter code.", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "short_code", "editable": true, "editor": short_code10093, "filter": { "type": "string" }, "header": "Short code", "hidden": true, "sortable": true, "tooltip": "(countries.Countries.short_code) A short abbreviation for regional usage. Obsolete.", "width": Lino.chars2width(11) }, { "colIndex": 5, "dataIndex": "iso3", "editable": true, "editor": iso310094, "filter": { "type": "string" }, "header": "ISO3-Code", "hidden": true, "sortable": true, "tooltip": "(countries.Countries.iso3) The three-letter code for this country as defined by ISO 3166-1.", "width": Lino.chars2width(5) }, { "colIndex": 6, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(countries.Countries.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(countries.Countries.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(countries.Countries.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.countries.Countries.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.Countries.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Countries", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Countries", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Countries", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Countries", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Countries", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.countries.Countries.insertPanel = Ext.extend(Lino.countries.Countries.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/countries/Countries",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.Countries.detail;
    this.ls_insert_handler = Lino.countries.Countries.insert;
    Lino.countries.Countries.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.Countries.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.countries.Countries.insertPanel(p);
});
Lino.countries.Countries.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Countries", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Countries", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Countries", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.countries.Countries.detailPanel = Ext.extend(Lino.countries.Countries.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/countries/Countries",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.Countries.detail;
    this.ls_insert_handler = Lino.countries.Countries.insert;
    Lino.countries.Countries.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.Countries.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.Countries.detailPanel(p);
});
Lino.countries.Countries.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Countries", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.Countries.GridPanel(p);
});
Lino.countries.Countries.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Countries", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class countries.Places
Lino.countries.Places.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 16,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/countries/Places",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/countries/Places','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/countries/Places','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/countries/Places','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/countries/Places','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/countries/Places','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Orte",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "country" }, 'countryHidden', { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "type" }, 'typeHidden', { "name": "zip_code" }, { "name": "parent" }, 'parentHidden', { "name": "id", "type": "int" }, { "name": "show_type", "type": "boolean" }, { "name": "children_summary" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 5,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.Places.detail;
    var ww = this.containing_window;
    var country10099 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Land ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/Places/country" }) }) });
    var name10100 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10101 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10102 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var type10103 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/Places/type" }) }) });
    var zip_code10104 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(8), "maxLength": 8, "selectOnFocus": true });
    var parent10105 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/Places/parent" }) }) });
    var id10106 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var show_type10107 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var children_summary_disp10108 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp10109 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10110 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10111 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      type10103.setContextValue('country', record ? record.data['countryHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      country10099.on('change',Lino.chooser_handler(type10103,'country'));
      Lino.countries.Places.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "country", "editable": true, "editor": country10099, "filter": { "type": "string" }, "header": "Land", "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(countries.Places.country) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name10100, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(countries.Places.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de10101, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(countries.Places.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr10102, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(countries.Places.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "type", "editable": true, "editor": type10103, "filter": { "type": "string" }, "header": "Ortsart", "sortable": false, "tooltip": "(countries.Places.type) ", "width": Lino.chars2width(11) }, { "colIndex": 5, "dataIndex": "zip_code", "editable": true, "editor": zip_code10104, "filter": { "type": "string" }, "header": "zip code", "sortable": true, "tooltip": "(countries.Places.zip_code) ", "width": Lino.chars2width(10) }, { "colIndex": 6, "dataIndex": "parent", "editable": true, "editor": parent10105, "filter": { "type": "string" }, "header": "Teil von", "renderer": Lino.fk_renderer('parentHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(countries.Places.parent) The superordinate geographic place of which this place is a part.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id10106, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(countries.Places.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "show_type", "editable": true, "filter": { "type": "boolean" }, "header": "Show type", "hidden": true, "sortable": false, "tooltip": "(countries.Places.show_type) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 9, "dataIndex": "children_summary", "editable": false, "header": "Kinder", "hidden": true, "sortable": false, "tooltip": "(countries.Places.children_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(countries.Places.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(countries.Places.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(countries.Places.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.countries.Places.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.Places.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Places", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Places", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Places", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Places", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Places", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Places", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Places", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Places", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Places", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.countries.Places.detailPanel = Ext.extend(Lino.countries.Places.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/countries/Places",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.Places.detail;
    Lino.countries.Places.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.Places.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.Places.detailPanel(p);
});
Lino.countries.Places.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Places", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.Places.GridPanel(p);
});
Lino.countries.Places.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Places", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Places", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/Places", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.Partners
Lino.contacts.Partners.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 40,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/Partners",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/Partners','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/Partners','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/Partners','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/contacts/Partners','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/Partners','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/Partners','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" } ],
  cell_edit : true,
  title : "Partner",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "prefix" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_id" }, { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "debit_balance" }, { "name": "name_column" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "mti_navigator" }, { "name": "address_column" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 39,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Partners.detail;
    this.ls_insert_handler = Lino.contacts.Partners.insert;
    var ww = this.containing_window;
    var name4258 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var email4259 = new Ext.form.TextField({ "maxLength": 254, "selectOnFocus": true });
    var language4260 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var url4261 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone4262 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm4263 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax4264 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country4265 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/country" }) }) });
    var city4266 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/city" }) }) });
    var zip_code4267 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region4268 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/region" }) }) });
    var addr14269 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix4270 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street4271 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no4272 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box4273 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr24274 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var prefix4275 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks4276 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term4277 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/payment_term" }) }) });
    var vat_regime4278 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_id4279 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var invoice_recipient4280 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/invoice_recipient" }) }) });
    var paper_type4281 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/paper_type" }) }) });
    var debit_balance4282 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var name_column_disp4283 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4284 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4285 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4286 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp4287 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var address_column_disp4288 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var id4289 = new Ext.form.NumberField({ "selectOnFocus": true });
    this.before_row_edit = function(record) {
      city4266.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city4266.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region4268.setContextValue('country', record ? record.data['countryHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      country4265.on('change',Lino.chooser_handler(city4266,'country'));
      region4268.on('change',Lino.chooser_handler(city4266,'region'));
      country4265.on('change',Lino.chooser_handler(region4268,'country'));
      Lino.contacts.Partners.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name4258, "filter": { "type": "string" }, "header": "Name", "sortable": true, "tooltip": "(contacts.Partners.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "email", "editable": true, "editor": email4259, "filter": { "type": "string" }, "header": "E-Mail-Adresse", "sortable": true, "tooltip": "(contacts.Partners.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "language", "editable": true, "editor": language4260, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "url", "editable": true, "editor": url4261, "filter": { "type": "string" }, "header": "Adresse (URL)", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.url) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "phone", "editable": true, "editor": phone4262, "filter": { "type": "string" }, "header": "Telefon", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "gsm", "editable": true, "editor": gsm4263, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "fax", "editable": true, "editor": fax4264, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "country", "editable": true, "editor": country4265, "filter": { "type": "string" }, "header": "Land", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.Partners.country) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "city", "editable": true, "editor": city4266, "filter": { "type": "string" }, "header": "Locality", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.Partners.city) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "zip_code", "editable": true, "editor": zip_code4267, "filter": { "type": "string" }, "header": "Postleitzahl", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 10, "dataIndex": "region", "editable": true, "editor": region4268, "filter": { "type": "string" }, "header": "Regierungsbezirk", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.Partners.region) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "addr1", "editable": true, "editor": addr14269, "filter": { "type": "string" }, "header": "Adresszeile vor Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.addr1) ", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix4270, "filter": { "type": "string" }, "header": "Pr\u00e4fix Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.street_prefix) ", "width": Lino.chars2width(22) }, { "colIndex": 13, "dataIndex": "street", "editable": true, "editor": street4271, "filter": { "type": "string" }, "header": "Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.street) ", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "street_no", "editable": true, "editor": street_no4272, "filter": { "type": "string" }, "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.street_no) ", "width": Lino.chars2width(12) }, { "colIndex": 15, "dataIndex": "street_box", "editable": true, "editor": street_box4273, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.street_box) ", "width": Lino.chars2width(12) }, { "colIndex": 16, "dataIndex": "addr2", "editable": true, "editor": addr24274, "filter": { "type": "string" }, "header": "Adresszeile nach Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.addr2) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "prefix", "editable": true, "editor": prefix4275, "filter": { "type": "string" }, "header": "Name prefix", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.prefix) An optional name prefix. For organisations this is inserted\nbefore the name, for persons this is inserted between first\nname and last name (see\nlino.mixins.human.Human.get_last_name_prefix()).", "width": Lino.chars2width(22) }, { "colIndex": 18, "dataIndex": "remarks", "editable": true, "editor": remarks4276, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 19, "dataIndex": "payment_term", "editable": true, "editor": payment_term4277, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(contacts.Partners.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 20, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime4278, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 21, "dataIndex": "vat_id", "editable": true, "editor": vat_id4279, "filter": { "type": "string" }, "header": "MwSt.-Nr.", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 22, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient4280, "filter": { "type": "string" }, "header": "Fakturationsadresse", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(contacts.Partners.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "paper_type", "editable": true, "editor": paper_type4281, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 24, "dataIndex": "debit_balance", "editable": false, "format": "0.000,00/i", "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.debit_balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 25, "dataIndex": "name_column", "editable": false, "header": "Name", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "mti_navigator", "editable": false, "header": "Ansicht als ", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.mti_navigator) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "address_column", "editable": false, "header": "Adresse", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.address_column) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 31, "dataIndex": "id", "editable": true, "editor": id4289, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(contacts.Partners.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" } ];
    Lino.contacts.Partners.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Partners.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.Partners.insertPanel = Ext.extend(Lino.contacts.Partners.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/contacts/Partners",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Partners.detail;
    this.ls_insert_handler = Lino.contacts.Partners.insert;
    Lino.contacts.Partners.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Partners.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.contacts.Partners.insertPanel(p);
});
Lino.contacts.Partners.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.Partners.detailPanel = Ext.extend(Lino.contacts.Partners.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" } ],
  ls_url: "/contacts/Partners",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Partners.detail;
    this.ls_insert_handler = Lino.contacts.Partners.insert;
    Lino.contacts.Partners.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Partners.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.Partners.detailPanel(p);
});
Lino.contacts.Partners.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.create_excerpt1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.show_invoice_partners = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.contacts.Partners.GridPanel(p);
});
Lino.contacts.Partners.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.ins_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.del_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.ins_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.del_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.del_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.ins_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.del_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.ins_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.del_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.ins_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Partners", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.Persons
Lino.contacts.Persons.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 63,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/Persons",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/Persons','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/Persons','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/Persons','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/contacts/Persons','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/Persons','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/Persons','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Personen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name_column" }, { "name": "address_column" }, { "name": "email" }, { "name": "phone" }, { "name": "gsm" }, { "name": "id", "type": "int" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "prefix" }, { "name": "name" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_id" }, { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "title" }, { "name": "first_name" }, { "name": "middle_name" }, { "name": "last_name" }, { "name": "gender" }, 'genderHidden', { "name": "birth_date" }, { "name": "national_id" }, { "name": "birth_country" }, 'birth_countryHidden', { "name": "birth_place" }, { "name": "nationality" }, 'nationalityHidden', { "name": "card_number" }, { "dateFormat": "d.m.Y", "name": "card_valid_from", "type": "date" }, { "dateFormat": "d.m.Y", "name": "card_valid_until", "type": "date" }, { "name": "card_type" }, 'card_typeHidden', { "name": "card_issuer" }, { "name": "noble_condition" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "age" }, { "name": "mti_navigator" }, { "name": "debit_balance" }, { "name": "image" }, { "name": "eid_info" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Persons.detail;
    this.ls_insert_handler = Lino.contacts.Persons.insert;
    var ww = this.containing_window;
    var name_column_disp4291 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var address_column_disp4292 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var email4293 = new Ext.form.TextField({ "maxLength": 254, "selectOnFocus": true });
    var phone4294 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var gsm4295 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id4296 = new Ext.form.NumberField({ "selectOnFocus": true });
    var language4297 = new Lino.ChoicesFieldElement({ "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var url4298 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax4299 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country4300 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/country" }) }) });
    var city4301 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/city" }) }) });
    var zip_code4302 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region4303 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/region" }) }) });
    var addr14304 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix4305 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street4306 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no4307 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box4308 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr24309 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var prefix4310 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name4311 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks4312 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term4313 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/payment_term" }) }) });
    var vat_regime4314 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_id4315 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var invoice_recipient4316 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/invoice_recipient" }) }) });
    var paper_type4317 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/paper_type" }) }) });
    var title4318 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var first_name4319 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var middle_name4320 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_name4321 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gender4322 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var birth_date4323 = new Lino.IncompleteDateField({ "hidden": true, "selectOnFocus": true });
    var national_id4324 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var birth_country4325 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/birth_country" }) }) });
    var birth_place4326 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var nationality4327 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/nationality" }) }) });
    var card_number4328 = new Ext.form.TextField({ "hidden": true, "maxLength": 20, "selectOnFocus": true });
    var card_valid_from4329 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_valid_until4330 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_type4331 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.beid.BeIdCardTypes) });
    var card_issuer4332 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var noble_condition4333 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var mobile_item_disp4334 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4335 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4336 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var age_disp4337 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp4338 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var debit_balance4339 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var image_htmlbox4340 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "image", "value": "<br/>" });
    var eid_info_disp4341 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      city4301.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city4301.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region4303.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      image_htmlbox4340.refresh();
    };
    this.onRender = function(ct, position) {
      country4300.on('change',Lino.chooser_handler(city4301,'country'));
      region4303.on('change',Lino.chooser_handler(city4301,'region'));
      country4300.on('change',Lino.chooser_handler(region4303,'country'));
      Lino.contacts.Persons.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name_column", "editable": false, "header": "Name", "sortable": false, "tooltip": "(contacts.Persons.name_column) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "address_column", "editable": false, "header": "Adresse", "sortable": false, "tooltip": "(contacts.Persons.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "email", "editable": true, "editor": email4293, "filter": { "type": "string" }, "header": "E-Mail-Adresse", "sortable": true, "tooltip": "(contacts.Persons.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "phone", "editable": true, "editor": phone4294, "filter": { "type": "string" }, "header": "Telefon", "sortable": true, "tooltip": "(contacts.Persons.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "gsm", "editable": true, "editor": gsm4295, "filter": { "type": "string" }, "header": "GSM", "sortable": true, "tooltip": "(contacts.Persons.gsm) The primary mobile phone number.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4296, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(contacts.Persons.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "language", "editable": true, "editor": language4297, "filter": { "type": "string" }, "header": "Sprache", "sortable": false, "tooltip": "(contacts.Persons.language) The language to use when communicating with this partner.", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "url", "editable": true, "editor": url4298, "filter": { "type": "string" }, "header": "Adresse (URL)", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.url) ", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "fax", "editable": true, "editor": fax4299, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "country", "editable": true, "editor": country4300, "filter": { "type": "string" }, "header": "Land", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.Persons.country) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "city", "editable": true, "editor": city4301, "filter": { "type": "string" }, "header": "Locality", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.Persons.city) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "zip_code", "editable": true, "editor": zip_code4302, "filter": { "type": "string" }, "header": "Postleitzahl", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "region", "editable": true, "editor": region4303, "filter": { "type": "string" }, "header": "Regierungsbezirk", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.Persons.region) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "addr1", "editable": true, "editor": addr14304, "filter": { "type": "string" }, "header": "Adresszeile vor Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.addr1) ", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix4305, "filter": { "type": "string" }, "header": "Pr\u00e4fix Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.street_prefix) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "street", "editable": true, "editor": street4306, "filter": { "type": "string" }, "header": "Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.street) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "street_no", "editable": true, "editor": street_no4307, "filter": { "type": "string" }, "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.street_no) ", "width": Lino.chars2width(12) }, { "colIndex": 17, "dataIndex": "street_box", "editable": true, "editor": street_box4308, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.street_box) ", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "addr2", "editable": true, "editor": addr24309, "filter": { "type": "string" }, "header": "Adresszeile nach Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.addr2) ", "width": Lino.chars2width(22) }, { "colIndex": 19, "dataIndex": "prefix", "editable": true, "editor": prefix4310, "filter": { "type": "string" }, "header": "Name prefix", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.prefix) An optional name prefix. For organisations this is inserted\nbefore the name, for persons this is inserted between first\nname and last name (see\nlino.mixins.human.Human.get_last_name_prefix()).", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "name", "editable": true, "editor": name4311, "filter": { "type": "string" }, "header": "Name", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 21, "dataIndex": "remarks", "editable": true, "editor": remarks4312, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 22, "dataIndex": "payment_term", "editable": true, "editor": payment_term4313, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(contacts.Persons.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime4314, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 24, "dataIndex": "vat_id", "editable": true, "editor": vat_id4315, "filter": { "type": "string" }, "header": "MwSt.-Nr.", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 25, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient4316, "filter": { "type": "string" }, "header": "Fakturationsadresse", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(contacts.Persons.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "paper_type", "editable": true, "editor": paper_type4317, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "title", "editable": true, "editor": title4318, "filter": { "type": "string" }, "header": "Titel", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.title) Used to specify a professional position or academic\nqualification like \"Dr.\" or \"PhD\".", "width": Lino.chars2width(22) }, { "colIndex": 28, "dataIndex": "first_name", "editable": true, "editor": first_name4319, "filter": { "type": "string" }, "header": "Vorname", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.first_name) The first name, also known as given name.", "width": Lino.chars2width(22) }, { "colIndex": 29, "dataIndex": "middle_name", "editable": true, "editor": middle_name4320, "filter": { "type": "string" }, "header": "Zwischenname", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.middle_name) A space-separated list of all middle names.", "width": Lino.chars2width(22) }, { "colIndex": 30, "dataIndex": "last_name", "editable": true, "editor": last_name4321, "filter": { "type": "string" }, "header": "Familienname", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.last_name) The last name, also known as family name.", "width": Lino.chars2width(22) }, { "colIndex": 31, "dataIndex": "gender", "editable": true, "editor": gender4322, "filter": { "type": "string" }, "header": "Geschlecht", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.gender) The sex of this person (male or female).", "width": Lino.chars2width(10) }, { "colIndex": 32, "dataIndex": "birth_date", "editable": true, "editor": birth_date4323, "filter": { "type": "string" }, "header": "Geburtsdatum", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".", "width": Lino.chars2width(13) }, { "colIndex": 33, "dataIndex": "national_id", "editable": true, "editor": national_id4324, "filter": { "type": "string" }, "header": "NR-Nummer", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.", "width": Lino.chars2width(22) }, { "colIndex": 34, "dataIndex": "birth_country", "editable": true, "editor": birth_country4325, "filter": { "type": "string" }, "header": "Geburtsland", "hidden": true, "renderer": Lino.fk_renderer('birth_countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.Persons.birth_country) ", "width": Lino.chars2width(21) }, { "colIndex": 35, "dataIndex": "birth_place", "editable": true, "editor": birth_place4326, "filter": { "type": "string" }, "header": "Geburtsort", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.birth_place) ", "width": Lino.chars2width(22) }, { "colIndex": 36, "dataIndex": "nationality", "editable": true, "editor": nationality4327, "filter": { "type": "string" }, "header": "Staatsangeh\u00f6rigkeit", "hidden": true, "renderer": Lino.fk_renderer('nationalityHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.Persons.nationality) The nationality. This is a pointer to\ncountries.Country which should\ncontain also entries for refugee statuses.", "width": Lino.chars2width(21) }, { "colIndex": 37, "dataIndex": "card_number", "editable": true, "editor": card_number4328, "filter": { "type": "string" }, "header": "eID-Kartennummer", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.card_number) ", "width": Lino.chars2width(22) }, { "colIndex": 38, "dataIndex": "card_valid_from", "editable": true, "editor": card_valid_from4329, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "ID-Karte g\u00fcltig von", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.card_valid_from) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 39, "dataIndex": "card_valid_until", "editable": true, "editor": card_valid_until4330, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "bis", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.card_valid_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 40, "dataIndex": "card_type", "editable": true, "editor": card_type4331, "filter": { "type": "string" }, "header": "eID-Kartenart", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.card_type) ", "width": Lino.chars2width(42) }, { "colIndex": 41, "dataIndex": "card_issuer", "editable": true, "editor": card_issuer4332, "filter": { "type": "string" }, "header": "eID-Karte ausgestellt durch", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.card_issuer) ", "width": Lino.chars2width(22) }, { "colIndex": 42, "dataIndex": "noble_condition", "editable": true, "editor": noble_condition4333, "filter": { "type": "string" }, "header": "Adelstitel", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.noble_condition) Eventueller Adelstitel", "width": Lino.chars2width(22) }, { "colIndex": 43, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 44, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "age", "editable": false, "header": "Alter", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.age) ", "width": Lino.chars2width(31) }, { "colIndex": 47, "dataIndex": "mti_navigator", "editable": false, "header": "Ansicht als ", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.mti_navigator) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 48, "dataIndex": "debit_balance", "editable": false, "format": "0.000,00/i", "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.debit_balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 49, "dataIndex": "image", "editable": false, "header": "image", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.image) ", "width": Lino.chars2width(31) }, { "colIndex": 50, "dataIndex": "eid_info", "editable": false, "header": "eID-Karte", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.eid_info) ", "width": Lino.chars2width(31) } ];
    Lino.contacts.Persons.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Persons.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.Persons.insertPanel = Ext.extend(Lino.contacts.Persons.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/contacts/Persons",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Persons.detail;
    this.ls_insert_handler = Lino.contacts.Persons.insert;
    Lino.contacts.Persons.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Persons.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.contacts.Persons.insertPanel(p);
});
Lino.contacts.Persons.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.Persons.detailPanel = Ext.extend(Lino.contacts.Persons.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/contacts/Persons",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Persons.detail;
    this.ls_insert_handler = Lino.contacts.Persons.insert;
    Lino.contacts.Persons.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Persons.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.Persons.detailPanel(p);
});
Lino.contacts.Persons.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.create_excerpt1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.show_invoice_partners = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.contacts.Persons.GridPanel(p);
});
Lino.contacts.Persons.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.ins_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.del_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.read_beid = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "POST", pk, "read_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.ins_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.del_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.del_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.ins_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.del_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.ins_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.del_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.ins_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.find_by_beid = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Persons", "POST", pk, "find_by_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.CompanyTypes
Lino.contacts.CompanyTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 10,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/CompanyTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/CompanyTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/CompanyTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/CompanyTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/CompanyTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/CompanyTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Organisationsarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "id", "type": "int" }, { "name": "abbr" }, { "name": "abbr_de" }, { "name": "abbr_fr" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 11,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var name10113 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10114 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10115 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id10116 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var abbr10117 = new Ext.form.TextField({ "hidden": true, "maxLength": 30, "selectOnFocus": true });
    var abbr_de10118 = new Ext.form.TextField({ "hidden": true, "maxLength": 30, "selectOnFocus": true });
    var abbr_fr10119 = new Ext.form.TextField({ "hidden": true, "maxLength": 30, "selectOnFocus": true });
    var mobile_item_disp10120 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10121 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10122 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name10113, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(contacts.CompanyTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de10114, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(contacts.CompanyTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr10115, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(contacts.CompanyTypes.name_fr) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id10116, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(contacts.CompanyTypes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "abbr", "editable": true, "editor": abbr10117, "filter": { "type": "string" }, "header": "Abk\u00fcrzung", "hidden": true, "sortable": true, "tooltip": "(contacts.CompanyTypes.abbr) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "abbr_de", "editable": true, "editor": abbr_de10118, "filter": { "type": "string" }, "header": "Abk\u00fcrzung (de)", "hidden": true, "sortable": true, "tooltip": "(contacts.CompanyTypes.abbr_de) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "abbr_fr", "editable": true, "editor": abbr_fr10119, "filter": { "type": "string" }, "header": "Abk\u00fcrzung (fr)", "hidden": true, "sortable": true, "tooltip": "(contacts.CompanyTypes.abbr_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.CompanyTypes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.CompanyTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(contacts.CompanyTypes.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.contacts.CompanyTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.CompanyTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/CompanyTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/CompanyTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/CompanyTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/CompanyTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/CompanyTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/CompanyTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/CompanyTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/CompanyTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.CompanyTypes.GridPanel(p);
});

// js_render_GridPanel_class contacts.Companies
Lino.contacts.Companies.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 42,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/Companies",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/Companies','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/Companies','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/Companies','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/contacts/Companies','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/Companies','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/Companies','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-arrow_join", "itemId": "merge_row", "menu_item_text": "Fusionieren", "overflowText": "Fusionieren", "panel_btn_handler": Lino.param_action_handler(Lino.contacts.Companies.merge_row), "tooltip": "Dieses Objekt in ein anderes Objekt der gleichen Klasse fusionieren." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" } ],
  cell_edit : true,
  title : "Organisationen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name_column" }, { "name": "address_column" }, { "name": "email" }, { "name": "phone" }, { "name": "gsm" }, { "name": "id", "type": "int" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "prefix" }, { "name": "name" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_id" }, { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "type" }, 'typeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "mti_navigator" }, { "name": "debit_balance" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Companies.detail;
    this.ls_insert_handler = Lino.contacts.Companies.insert;
    var ww = this.containing_window;
    var name_column_disp4343 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var address_column_disp4344 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var email4345 = new Ext.form.TextField({ "maxLength": 254, "selectOnFocus": true });
    var phone4346 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var gsm4347 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id4348 = new Ext.form.NumberField({ "selectOnFocus": true });
    var language4349 = new Lino.ChoicesFieldElement({ "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var url4350 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax4351 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country4352 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/country" }) }) });
    var city4353 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/city" }) }) });
    var zip_code4354 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region4355 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/region" }) }) });
    var addr14356 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix4357 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street4358 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no4359 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box4360 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr24361 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var prefix4362 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name4363 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks4364 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term4365 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/payment_term" }) }) });
    var vat_regime4366 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_id4367 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var invoice_recipient4368 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/invoice_recipient" }) }) });
    var paper_type4369 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/paper_type" }) }) });
    var type4370 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisationsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/type" }) }) });
    var mobile_item_disp4371 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4372 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4373 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp4374 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var debit_balance4375 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      city4353.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city4353.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region4355.setContextValue('country', record ? record.data['countryHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      country4352.on('change',Lino.chooser_handler(city4353,'country'));
      region4355.on('change',Lino.chooser_handler(city4353,'region'));
      country4352.on('change',Lino.chooser_handler(region4355,'country'));
      Lino.contacts.Companies.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name_column", "editable": false, "header": "Name", "sortable": false, "tooltip": "(contacts.Companies.name_column) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "address_column", "editable": false, "header": "Adresse", "sortable": false, "tooltip": "(contacts.Companies.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "email", "editable": true, "editor": email4345, "filter": { "type": "string" }, "header": "E-Mail-Adresse", "sortable": true, "tooltip": "(contacts.Companies.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "phone", "editable": true, "editor": phone4346, "filter": { "type": "string" }, "header": "Telefon", "sortable": true, "tooltip": "(contacts.Companies.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "gsm", "editable": true, "editor": gsm4347, "filter": { "type": "string" }, "header": "GSM", "sortable": true, "tooltip": "(contacts.Companies.gsm) The primary mobile phone number.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4348, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(contacts.Companies.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "language", "editable": true, "editor": language4349, "filter": { "type": "string" }, "header": "Sprache", "sortable": false, "tooltip": "(contacts.Companies.language) The language to use when communicating with this partner.", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "url", "editable": true, "editor": url4350, "filter": { "type": "string" }, "header": "Adresse (URL)", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.url) ", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "fax", "editable": true, "editor": fax4351, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "country", "editable": true, "editor": country4352, "filter": { "type": "string" }, "header": "Land", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.Companies.country) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "city", "editable": true, "editor": city4353, "filter": { "type": "string" }, "header": "Locality", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.Companies.city) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "zip_code", "editable": true, "editor": zip_code4354, "filter": { "type": "string" }, "header": "Postleitzahl", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "region", "editable": true, "editor": region4355, "filter": { "type": "string" }, "header": "Regierungsbezirk", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.Companies.region) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "addr1", "editable": true, "editor": addr14356, "filter": { "type": "string" }, "header": "Adresszeile vor Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.addr1) ", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix4357, "filter": { "type": "string" }, "header": "Pr\u00e4fix Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.street_prefix) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "street", "editable": true, "editor": street4358, "filter": { "type": "string" }, "header": "Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.street) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "street_no", "editable": true, "editor": street_no4359, "filter": { "type": "string" }, "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.street_no) ", "width": Lino.chars2width(12) }, { "colIndex": 17, "dataIndex": "street_box", "editable": true, "editor": street_box4360, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.street_box) ", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "addr2", "editable": true, "editor": addr24361, "filter": { "type": "string" }, "header": "Adresszeile nach Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.addr2) ", "width": Lino.chars2width(22) }, { "colIndex": 19, "dataIndex": "prefix", "editable": true, "editor": prefix4362, "filter": { "type": "string" }, "header": "Name prefix", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.prefix) An optional name prefix. For organisations this is inserted\nbefore the name, for persons this is inserted between first\nname and last name (see\nlino.mixins.human.Human.get_last_name_prefix()).", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "name", "editable": true, "editor": name4363, "filter": { "type": "string" }, "header": "Name", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 21, "dataIndex": "remarks", "editable": true, "editor": remarks4364, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 22, "dataIndex": "payment_term", "editable": true, "editor": payment_term4365, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(contacts.Companies.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime4366, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 24, "dataIndex": "vat_id", "editable": true, "editor": vat_id4367, "filter": { "type": "string" }, "header": "MwSt.-Nr.", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 25, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient4368, "filter": { "type": "string" }, "header": "Fakturationsadresse", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(contacts.Companies.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "paper_type", "editable": true, "editor": paper_type4369, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "type", "editable": true, "editor": type4370, "filter": { "type": "string" }, "header": "Organisationsart", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.type) ", "width": Lino.chars2width(21) }, { "colIndex": 28, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "mti_navigator", "editable": false, "header": "Ansicht als ", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.mti_navigator) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 32, "dataIndex": "debit_balance", "editable": false, "format": "0.000,00/i", "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.debit_balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.contacts.Companies.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Companies.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.Companies.insertPanel = Ext.extend(Lino.contacts.Companies.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/contacts/Companies",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Companies.detail;
    this.ls_insert_handler = Lino.contacts.Companies.insert;
    Lino.contacts.Companies.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Companies.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.contacts.Companies.insertPanel(p);
});
Lino.contacts.Companies.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.Companies.detailPanel = Ext.extend(Lino.contacts.Companies.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-arrow_join", "itemId": "merge_row", "menu_item_text": "Fusionieren", "overflowText": "Fusionieren", "panel_btn_handler": Lino.param_action_handler(Lino.contacts.Companies.merge_row), "tooltip": "Dieses Objekt in ein anderes Objekt der gleichen Klasse fusionieren." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" } ],
  ls_url: "/contacts/Companies",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Companies.detail;
    this.ls_insert_handler = Lino.contacts.Companies.insert;
    Lino.contacts.Companies.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Companies.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.Companies.detailPanel(p);
});
Lino.contacts.Companies.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.create_excerpt1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.show_invoice_partners = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.contacts.Companies.GridPanel(p);
});
Lino.contacts.Companies.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.ins_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.del_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.ins_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.del_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.del_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.ins_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.del_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.ins_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.del_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.ins_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Companies", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.RoleTypes
Lino.contacts.RoleTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 7,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/RoleTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/RoleTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/RoleTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/RoleTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/RoleTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/RoleTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Funktionen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 6,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id10124 = new Ext.form.NumberField({ "selectOnFocus": true });
    var name10125 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10126 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10127 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var mobile_item_disp10128 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10129 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10130 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10124, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(contacts.RoleTypes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name10125, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(contacts.RoleTypes.name) A translatable designation. Used e.g. in document templates\nfor contracts.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de10126, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(contacts.RoleTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr10127, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(contacts.RoleTypes.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.RoleTypes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.RoleTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(contacts.RoleTypes.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.contacts.RoleTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.RoleTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RoleTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RoleTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RoleTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RoleTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RoleTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RoleTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RoleTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RoleTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.RoleTypes.GridPanel(p);
});

// js_render_GridPanel_class contacts.Roles
Lino.contacts.Roles.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 10,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/Roles",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/Roles','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/Roles','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/Roles','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/contacts/Roles','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/Roles','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/Roles','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Kontaktpersonen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "type" }, 'typeHidden', { "name": "person" }, 'personHidden', { "name": "company" }, 'companyHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 9,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id10132 = new Ext.form.NumberField({ "selectOnFocus": true });
    var type10133 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Roles/type" }) }) });
    var person10134 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Person ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Roles/person" }) }) });
    var company10135 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Organisation ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Roles/company" }) }) });
    var mobile_item_disp10136 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10137 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10138 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10132, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(contacts.Roles.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type10133, "filter": { "type": "string" }, "header": "Funktion", "sortable": false, "tooltip": "(contacts.Roles.type) The function of this person in this company.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "person", "editable": true, "editor": person10134, "filter": { "type": "string" }, "header": "Person", "renderer": Lino.fk_renderer('personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(contacts.Roles.person) The person having this role in this company.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "company", "editable": true, "editor": company10135, "filter": { "type": "string" }, "header": "Organisation", "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(contacts.Roles.company) The organization where this person has this role.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.Roles.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.Roles.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(contacts.Roles.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.contacts.Roles.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Roles.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Roles", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Roles", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Roles", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Roles", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Roles", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Roles", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Roles", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Roles", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/Roles", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.Roles.GridPanel(p);
});

// js_render_GridPanel_class ledger.Journals
Lino.ledger.Journals.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 34,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/ledger/Journals",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/Journals','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Journals','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Journals','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Journals','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/Journals','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Journale",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "trade_type" }, 'trade_typeHidden', { "name": "journal_group" }, 'journal_groupHidden', { "name": "voucher_type" }, 'voucher_typeHidden', { "name": "force_sequence", "type": "boolean" }, { "name": "build_method" }, 'build_methodHidden', { "name": "template" }, { "name": "auto_check_clearings", "type": "boolean" }, { "name": "auto_fill_suggestions", "type": "boolean" }, { "name": "account" }, 'accountHidden', { "name": "partner" }, 'partnerHidden', { "name": "printed_name" }, { "name": "printed_name_de" }, { "name": "printed_name_fr" }, { "name": "dc", "type": "boolean" }, { "name": "yearly_numbering", "type": "boolean" }, { "name": "must_declare", "type": "boolean" }, { "name": "sepa_account" }, 'sepa_accountHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "move_buttons" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 33,
  ls_grid_configs : [  ],
  content_type : 37,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.Journals.detail;
    this.ls_insert_handler = Lino.ledger.Journals.insert;
    var ww = this.containing_window;
    var ref10140 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name10141 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10142 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10143 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var trade_type10144 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.TradeTypes) });
    var journal_group10145 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.ledger.JournalGroups });
    var voucher_type10146 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.ledger.VoucherTypes });
    var force_sequence10147 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var build_method10148 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var template10149 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Journals/template" }) }) });
    var auto_check_clearings10150 = new Ext.form.Checkbox({ "checked": true, "hidden": true, "selectOnFocus": true });
    var auto_fill_suggestions10151 = new Ext.form.Checkbox({ "checked": true, "hidden": true, "selectOnFocus": true });
    var account10152 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Journals/account" }) }) });
    var partner10153 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Journals/partner" }) }) });
    var printed_name10154 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var printed_name_de10155 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var printed_name_fr10156 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var dc10157 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var yearly_numbering10158 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var must_declare10159 = new Ext.form.Checkbox({ "checked": true, "hidden": true, "selectOnFocus": true });
    var sepa_account10160 = new Lino.RemoteComboFieldElement({ "emptyText": "Bankkonto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Journals/sepa_account" }) }) });
    var mobile_item_disp10161 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10162 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10163 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp10164 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var seqno10165 = new Ext.form.NumberField({ "selectOnFocus": true });
    var id10166 = new Ext.form.NumberField({ "selectOnFocus": true });
    this.before_row_edit = function(record) {
      template10149.setContextValue('build_method', record ? record.data['build_methodHidden'] : undefined);
      template10149.setContextValue('voucher_type', record ? record.data['voucher_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      build_method10148.on('change',Lino.chooser_handler(template10149,'build_method'));
      voucher_type10146.on('change',Lino.chooser_handler(template10149,'voucher_type'));
      Lino.ledger.Journals.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref10140, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(ledger.Journals.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name10141, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(ledger.Journals.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de10142, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(ledger.Journals.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr10143, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(ledger.Journals.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "trade_type", "editable": true, "editor": trade_type10144, "filter": { "type": "string" }, "header": "Handelsart", "sortable": false, "tooltip": "(ledger.Journals.trade_type) Pointer to TradeTypes.", "width": Lino.chars2width(13) }, { "colIndex": 5, "dataIndex": "journal_group", "editable": true, "editor": journal_group10145, "filter": { "type": "string" }, "header": "Journalgruppe", "sortable": false, "tooltip": "(ledger.Journals.journal_group) Pointer to an item of JournalGroups.", "width": Lino.chars2width(13) }, { "colIndex": 6, "dataIndex": "voucher_type", "editable": true, "editor": voucher_type10146, "filter": { "type": "string" }, "header": "Belegart", "sortable": false, "tooltip": "(ledger.Journals.voucher_type) Pointer to an item of VoucherTypes.", "width": Lino.chars2width(50) }, { "colIndex": 7, "dataIndex": "force_sequence", "editable": true, "filter": { "type": "boolean" }, "header": "Chronologische Reihenfolge", "sortable": false, "tooltip": "(ledger.Journals.force_sequence) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 8, "dataIndex": "build_method", "editable": true, "editor": build_method10148, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(ledger.Journals.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 9, "dataIndex": "template", "editable": true, "editor": template10149, "filter": { "type": "string" }, "header": "Vorlage", "hidden": true, "sortable": false, "tooltip": "(ledger.Journals.template) See PrintableType.template.", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "auto_check_clearings", "editable": true, "filter": { "type": "boolean" }, "header": "Begleichung pr\u00fcfen", "hidden": true, "sortable": false, "tooltip": "(ledger.Journals.auto_check_clearings) Whether to automatically check and update the 'cleared' status\nof involved transactions when (de)registering a voucher of\nthis journal.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 11, "dataIndex": "auto_fill_suggestions", "editable": true, "filter": { "type": "boolean" }, "header": "Fill suggestions", "hidden": true, "sortable": false, "tooltip": "(ledger.Journals.auto_fill_suggestions) Whether to automatically fill voucher item from due payments\nof the partner when entering a financial voucher.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 12, "dataIndex": "account", "editable": true, "editor": account10152, "filter": { "type": "string" }, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(ledger.Journals.account) The account to use for the counter-movements generated by\nvouchers in this journal.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "partner", "editable": true, "editor": partner10153, "filter": { "type": "string" }, "header": "Organisation", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(ledger.Journals.partner) The partner to use as default partner for all vouchers in this\njournal.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "printed_name", "editable": true, "editor": printed_name10154, "filter": { "type": "string" }, "header": "Dokumentbezeichnung Ausdruck", "hidden": true, "sortable": true, "tooltip": "(ledger.Journals.printed_name) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "printed_name_de", "editable": true, "editor": printed_name_de10155, "filter": { "type": "string" }, "header": "Dokumentbezeichnung Ausdruck (de)", "hidden": true, "sortable": true, "tooltip": "(ledger.Journals.printed_name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "printed_name_fr", "editable": true, "editor": printed_name_fr10156, "filter": { "type": "string" }, "header": "Dokumentbezeichnung Ausdruck (fr)", "hidden": true, "sortable": true, "tooltip": "(ledger.Journals.printed_name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "Prim\u00e4re Buchungsrichtung", "hidden": true, "sortable": false, "tooltip": "(ledger.Journals.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "yearly_numbering", "editable": true, "filter": { "type": "boolean" }, "header": "Yearly numbering", "hidden": true, "sortable": false, "tooltip": "(ledger.Journals.yearly_numbering) Whether the\nnumber of\nvouchers should restart at 1 every year.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "must_declare", "editable": true, "filter": { "type": "boolean" }, "header": "must declare", "hidden": true, "sortable": false, "tooltip": "(ledger.Journals.must_declare) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 20, "dataIndex": "sepa_account", "editable": true, "editor": sepa_account10160, "filter": { "type": "string" }, "header": "Bankkonto", "hidden": true, "sortable": false, "tooltip": "(ledger.Journals.sepa_account) Your bank account to specify in payment order.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.Journals.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.Journals.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.Journals.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 24, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(ledger.Journals.move_buttons) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 25, "dataIndex": "seqno", "editable": true, "editor": seqno10165, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(ledger.Journals.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 26, "dataIndex": "id", "editable": true, "editor": id10166, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(ledger.Journals.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" } ];
    Lino.ledger.Journals.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Journals.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Journals", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Journals.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Journals", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Journals.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Journals", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Journals.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Journals", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Journals.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Journals", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.ledger.Journals.insertPanel = Ext.extend(Lino.ledger.Journals.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/ledger/Journals",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.Journals.detail;
    this.ls_insert_handler = Lino.ledger.Journals.insert;
    Lino.ledger.Journals.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Journals.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.ledger.Journals.insertPanel(p);
});
Lino.ledger.Journals.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Journals", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Journals.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Journals", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Journals.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Journals", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Journals.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Journals", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.ledger.Journals.detailPanel = Ext.extend(Lino.ledger.Journals.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/ledger/Journals",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.Journals.detail;
    this.ls_insert_handler = Lino.ledger.Journals.insert;
    Lino.ledger.Journals.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Journals.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.Journals.detailPanel(p);
});
Lino.ledger.Journals.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Journals", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Journals.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.Journals.GridPanel(p);
});
Lino.ledger.Journals.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Journals", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Journals.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Journals", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Journals.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Journals", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class ledger.AccountingPeriods
Lino.ledger.AccountingPeriods.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 12,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/ledger/AccountingPeriods",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/AccountingPeriods','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/AccountingPeriods','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/AccountingPeriods','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/AccountingPeriods','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/AccountingPeriods','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Buchungsperioden",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "year" }, 'yearHidden', { "name": "state" }, 'stateHidden', { "name": "remark" }, { "name": "id", "type": "int" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 35,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var ref10168 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var start_date10169 = new Lino.DateField({ "selectOnFocus": true });
    var end_date10170 = new Lino.DateField({ "selectOnFocus": true });
    var year10171 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.FiscalYears) });
    var state10172 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.ledger.PeriodStates, "value": "10" });
    var remark10173 = new Ext.form.TextField({ "maxLength": 250, "selectOnFocus": true });
    var id10174 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10175 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10176 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10177 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref10168, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(ledger.AccountingPeriods.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(7) }, { "colIndex": 1, "dataIndex": "start_date", "editable": true, "editor": start_date10169, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(ledger.AccountingPeriods.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "end_date", "editable": true, "editor": end_date10170, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enddatum", "sortable": true, "tooltip": "(ledger.AccountingPeriods.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "year", "editable": true, "editor": year10171, "filter": { "type": "string" }, "header": "Gesch\u00e4ftsjahr", "sortable": false, "tooltip": "(ledger.AccountingPeriods.year) ", "width": Lino.chars2width(8) }, { "colIndex": 4, "dataIndex": "state", "editable": true, "editor": state10172, "filter": { "type": "string" }, "header": "Zustand", "sortable": false, "tooltip": "(ledger.AccountingPeriods.state) ", "width": Lino.chars2width(10) }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark10173, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(ledger.AccountingPeriods.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id10174, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.AccountingPeriods.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.AccountingPeriods.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.AccountingPeriods.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.AccountingPeriods.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.AccountingPeriods.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.AccountingPeriods.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AccountingPeriods", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AccountingPeriods.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AccountingPeriods", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AccountingPeriods.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AccountingPeriods", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AccountingPeriods.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AccountingPeriods", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AccountingPeriods.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AccountingPeriods", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AccountingPeriods.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AccountingPeriods", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AccountingPeriods.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AccountingPeriods", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AccountingPeriods.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AccountingPeriods", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AccountingPeriods.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.AccountingPeriods.ParamsPanel({});
  return new Lino.ledger.AccountingPeriods.GridPanel(p);
});

// js_render_GridPanel_class ledger.PaymentTerms
Lino.ledger.PaymentTerms.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 14,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/ledger/PaymentTerms",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/PaymentTerms','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/PaymentTerms','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/PaymentTerms','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/PaymentTerms','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/PaymentTerms','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Zahlungsbedingungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "months", "type": "int", "useNull": true }, { "name": "days", "type": "int", "useNull": true }, { "name": "end_of_month", "type": "boolean" }, { "name": "id", "type": "int" }, { "name": "printed_text" }, { "name": "printed_text_de" }, { "name": "printed_text_fr" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 39,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.PaymentTerms.detail;
    var ww = this.containing_window;
    var ref10179 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name10180 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10181 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10182 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var months10183 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 0 });
    var days10184 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 0 });
    var end_of_month10185 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var id10186 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var printed_text10187 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var printed_text_de10188 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var printed_text_fr10189 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10190 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10191 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10192 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref10179, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(ledger.PaymentTerms.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name10180, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(ledger.PaymentTerms.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de10181, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(ledger.PaymentTerms.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr10182, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(ledger.PaymentTerms.name_fr) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 4, "dataIndex": "months", "editable": true, "editor": months10183, "filter": { "type": "numeric" }, "format": "0", "header": "Monate", "sortable": true, "tooltip": "(ledger.PaymentTerms.months) Number of months to add to voucher_date.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "days", "editable": true, "editor": days10184, "filter": { "type": "numeric" }, "format": "0", "header": "Tage", "sortable": true, "tooltip": "(ledger.PaymentTerms.days) Number of days to add to voucher_date.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "end_of_month", "editable": true, "filter": { "type": "boolean" }, "header": "Monatsende", "sortable": false, "tooltip": "(ledger.PaymentTerms.end_of_month) Whether to move voucher_date to the end of month.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id10186, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.PaymentTerms.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "printed_text", "editable": true, "editor": printed_text10187, "filter": { "type": "string" }, "header": "Printed text", "hidden": true, "sortable": false, "tooltip": "(ledger.PaymentTerms.printed_text) Used in sales/VatProductInvoice/trailer.html as\nfollows:", "width": Lino.chars2width(61) }, { "colIndex": 9, "dataIndex": "printed_text_de", "editable": true, "editor": printed_text_de10188, "filter": { "type": "string" }, "header": "Printed text (de)", "hidden": true, "sortable": false, "tooltip": "(ledger.PaymentTerms.printed_text_de) ", "width": Lino.chars2width(61) }, { "colIndex": 10, "dataIndex": "printed_text_fr", "editable": true, "editor": printed_text_fr10189, "filter": { "type": "string" }, "header": "Printed text (fr)", "hidden": true, "sortable": false, "tooltip": "(ledger.PaymentTerms.printed_text_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 11, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.PaymentTerms.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.PaymentTerms.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.PaymentTerms.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.PaymentTerms.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.PaymentTerms.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PaymentTerms", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PaymentTerms.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PaymentTerms", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PaymentTerms.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PaymentTerms", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PaymentTerms.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PaymentTerms", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PaymentTerms.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PaymentTerms", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PaymentTerms.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PaymentTerms", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PaymentTerms.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PaymentTerms", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PaymentTerms.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PaymentTerms", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.ledger.PaymentTerms.detailPanel = Ext.extend(Lino.ledger.PaymentTerms.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/ledger/PaymentTerms",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.PaymentTerms.detail;
    Lino.ledger.PaymentTerms.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.PaymentTerms.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.PaymentTerms.detailPanel(p);
});
Lino.ledger.PaymentTerms.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PaymentTerms", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PaymentTerms.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.PaymentTerms.GridPanel(p);
});
Lino.ledger.PaymentTerms.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PaymentTerms", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class ledger.Vouchers
Lino.ledger.Vouchers.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/Vouchers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/Vouchers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Vouchers','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Vouchers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Vouchers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/Vouchers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Belege",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "number_with_year" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var entry_date4377 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var number4378 = new Ext.form.NumberField({ "selectOnFocus": true });
    var id4379 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user4380 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Vouchers/user" }) }) });
    var journal4381 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Vouchers/journal" }) }) });
    var voucher_date4382 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period4383 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Vouchers/accounting_period" }) }) });
    var narration4384 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state4385 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var number_with_year_disp4386 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4387 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4388 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4389 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "entry_date", "editable": true, "editor": entry_date4377, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(ledger.Vouchers.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "number", "editable": true, "editor": number4378, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(ledger.Vouchers.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id4379, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.Vouchers.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user4380, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(ledger.Vouchers.user) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "journal", "editable": true, "editor": journal4381, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(ledger.Vouchers.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4382, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(ledger.Vouchers.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4383, "filter": { "type": "string" }, "header": "Buchungsperiode", "hidden": true, "sortable": false, "tooltip": "(ledger.Vouchers.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "narration", "editable": true, "editor": narration4384, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(ledger.Vouchers.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "state", "editable": true, "editor": state4385, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(ledger.Vouchers.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 9, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "hidden": true, "sortable": false, "tooltip": "(ledger.Vouchers.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.Vouchers.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.Vouchers.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.Vouchers.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.Vouchers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Vouchers.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Vouchers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Vouchers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Vouchers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Vouchers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Vouchers", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Vouchers", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Vouchers.ParamsPanel({});
  return new Lino.ledger.Vouchers.GridPanel(p);
});
Lino.ledger.Vouchers.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Vouchers", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Vouchers", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Vouchers", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class ledger.AllVouchers
Lino.ledger.AllVouchers.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/AllVouchers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/AllVouchers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/AllVouchers','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/AllVouchers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/AllVouchers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/AllVouchers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Belege",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "number_with_year" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var entry_date10194 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var number10195 = new Ext.form.NumberField({ "selectOnFocus": true });
    var id10196 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user10197 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/AllVouchers/user" }) }) });
    var journal10198 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/AllVouchers/journal" }) }) });
    var voucher_date10199 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period10200 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/AllVouchers/accounting_period" }) }) });
    var narration10201 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state10202 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var number_with_year_disp10203 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp10204 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10205 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10206 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "entry_date", "editable": true, "editor": entry_date10194, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(ledger.AllVouchers.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "number", "editable": true, "editor": number10195, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(ledger.AllVouchers.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id10196, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.AllVouchers.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user10197, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(ledger.AllVouchers.user) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "journal", "editable": true, "editor": journal10198, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(ledger.AllVouchers.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date10199, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(ledger.AllVouchers.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period10200, "filter": { "type": "string" }, "header": "Buchungsperiode", "hidden": true, "sortable": false, "tooltip": "(ledger.AllVouchers.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "narration", "editable": true, "editor": narration10201, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(ledger.AllVouchers.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "state", "editable": true, "editor": state10202, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(ledger.AllVouchers.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 9, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "hidden": true, "sortable": false, "tooltip": "(ledger.AllVouchers.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.AllVouchers.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.AllVouchers.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.AllVouchers.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.AllVouchers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.AllVouchers.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllVouchers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllVouchers.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllVouchers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllVouchers.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllVouchers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllVouchers.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllVouchers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllVouchers.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllVouchers", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllVouchers.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllVouchers", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllVouchers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Vouchers.ParamsPanel({});
  return new Lino.ledger.AllVouchers.GridPanel(p);
});
Lino.ledger.AllVouchers.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllVouchers", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllVouchers.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllVouchers", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllVouchers.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllVouchers", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class ledger.MatchRules
Lino.ledger.MatchRules.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 8,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/ledger/MatchRules",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRules','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRules','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRules','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRules','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRules','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Begleichungsregeln",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "account" }, 'accountHidden', { "name": "journal" }, 'journalHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 36,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id10208 = new Ext.form.NumberField({ "selectOnFocus": true });
    var account10209 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MatchRules/account" }) }) });
    var journal10210 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MatchRules/journal" }) }) });
    var mobile_item_disp10211 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10212 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10213 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10208, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(ledger.MatchRules.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "account", "editable": true, "editor": account10209, "filter": { "type": "string" }, "header": "Konto", "sortable": false, "tooltip": "(ledger.MatchRules.account) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "journal", "editable": true, "editor": journal10210, "filter": { "type": "string" }, "header": "Journal", "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(ledger.MatchRules.journal) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRules.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRules.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRules.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.MatchRules.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.MatchRules.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRules", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRules.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRules", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRules.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRules", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRules.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRules", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRules.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRules", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRules.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRules", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRules.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRules", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRules.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRules", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRules.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.MatchRules.GridPanel(p);
});

// js_render_GridPanel_class ledger.PartnerVouchers
Lino.ledger.PartnerVouchers.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 17,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/ledger/PartnerVouchers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerVouchers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerVouchers','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerVouchers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerVouchers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerVouchers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Belege",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "number_with_year" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var entry_date4391 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var number4392 = new Ext.form.NumberField({ "selectOnFocus": true });
    var id4393 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user4394 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerVouchers/user" }) }) });
    var journal4395 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerVouchers/journal" }) }) });
    var voucher_date4396 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period4397 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerVouchers/accounting_period" }) }) });
    var narration4398 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state4399 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var number_with_year_disp4400 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4401 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4402 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4403 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "entry_date", "editable": true, "editor": entry_date4391, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(ledger.PartnerVouchers.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "number", "editable": true, "editor": number4392, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(ledger.PartnerVouchers.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id4393, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.PartnerVouchers.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user4394, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(ledger.PartnerVouchers.user) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "journal", "editable": true, "editor": journal4395, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(ledger.PartnerVouchers.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4396, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(ledger.PartnerVouchers.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4397, "filter": { "type": "string" }, "header": "Buchungsperiode", "hidden": true, "sortable": false, "tooltip": "(ledger.PartnerVouchers.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "narration", "editable": true, "editor": narration4398, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(ledger.PartnerVouchers.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "state", "editable": true, "editor": state4399, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(ledger.PartnerVouchers.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 9, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "hidden": true, "sortable": false, "tooltip": "(ledger.PartnerVouchers.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.PartnerVouchers.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.PartnerVouchers.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.PartnerVouchers.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.PartnerVouchers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.PartnerVouchers.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerVouchers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerVouchers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerVouchers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerVouchers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerVouchers", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerVouchers", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerVouchers", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerVouchers", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.PartnerVouchers.ParamsPanel({});
  return new Lino.ledger.PartnerVouchers.GridPanel(p);
});
Lino.ledger.PartnerVouchers.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerVouchers", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerVouchers", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerVouchers", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class ledger.GeneralAccountsBalance
Lino.ledger.GeneralAccountsBalance.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/GeneralAccountsBalance",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/GeneralAccountsBalance','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/GeneralAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/GeneralAccountsBalance','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/GeneralAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/GeneralAccountsBalance','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Saldenliste Generalkonten",
  page_length : 20,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "description" }, { "name": "old_d" }, { "name": "old_c" }, { "name": "empty_column" }, { "name": "during_d" }, { "name": "during_c" }, { "name": "new_d" }, { "name": "new_c" }, { "name": "id", "type": "int" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 33,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var description_disp4405 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var old_d4406 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var old_c4407 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var empty_column_disp4408 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var during_d4409 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var during_c4410 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var empty_column_disp4408 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var new_d4411 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var new_c4412 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "description", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "old_d", "editable": false, "format": "0.000,00/i", "header": "Debit\nvorher", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.old_d) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "old_c", "editable": false, "format": "0.000,00/i", "header": "Kredit\nvorher", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.old_c) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "empty_column", "editable": false, "header": "", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.empty_column) ", "width": Lino.chars2width(2) }, { "align": "right", "colIndex": 4, "dataIndex": "during_d", "editable": false, "format": "0.000,00/i", "header": "Debit", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.during_d) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "during_c", "editable": false, "format": "0.000,00/i", "header": "Kredit", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.during_c) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "empty_column", "editable": false, "header": "", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.empty_column) ", "width": Lino.chars2width(2) }, { "align": "right", "colIndex": 7, "dataIndex": "new_d", "editable": false, "format": "0.000,00/i", "header": "Debit\nnachher", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.new_d) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "new_c", "editable": false, "format": "0.000,00/i", "header": "Kredit\nnachher", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.new_c) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.ledger.GeneralAccountsBalance.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.GeneralAccountsBalance.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/GeneralAccountsBalance", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.GeneralAccountsBalance.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/GeneralAccountsBalance", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.GeneralAccountsBalance.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/GeneralAccountsBalance", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.GeneralAccountsBalance.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/GeneralAccountsBalance", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.GeneralAccountsBalance.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/GeneralAccountsBalance", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.GeneralAccountsBalance.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/GeneralAccountsBalance", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.GeneralAccountsBalance.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/GeneralAccountsBalance", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.GeneralAccountsBalance.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/GeneralAccountsBalance", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.GeneralAccountsBalance.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.GeneralAccountsBalance.ParamsPanel({});
  return new Lino.ledger.GeneralAccountsBalance.GridPanel(p);
});
Lino.ledger.GeneralAccountsBalance.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/GeneralAccountsBalance", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.GeneralAccountsBalance.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/GeneralAccountsBalance", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class ledger.PartnerAccountsBalance
Lino.ledger.PartnerAccountsBalance.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/PartnerAccountsBalance",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerAccountsBalance','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerAccountsBalance','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerAccountsBalance','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerAccountsBalance','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" } ],
  cell_edit : true,
  title : "Partner",
  page_length : 20,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "description" }, { "name": "old_d" }, { "name": "old_c" }, { "name": "empty_column" }, { "name": "during_d" }, { "name": "during_c" }, { "name": "new_d" }, { "name": "new_c" }, { "name": "id", "type": "int" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var description_disp4414 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var old_d4415 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var old_c4416 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var empty_column_disp4417 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var during_d4418 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var during_c4419 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var empty_column_disp4417 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var new_d4420 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var new_c4421 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "description", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "old_d", "editable": false, "format": "0.000,00/i", "header": "Debit\nvorher", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.old_d) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "old_c", "editable": false, "format": "0.000,00/i", "header": "Kredit\nvorher", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.old_c) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "empty_column", "editable": false, "header": "", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.empty_column) ", "width": Lino.chars2width(2) }, { "align": "right", "colIndex": 4, "dataIndex": "during_d", "editable": false, "format": "0.000,00/i", "header": "Debit", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.during_d) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "during_c", "editable": false, "format": "0.000,00/i", "header": "Kredit", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.during_c) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "empty_column", "editable": false, "header": "", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.empty_column) ", "width": Lino.chars2width(2) }, { "align": "right", "colIndex": 7, "dataIndex": "new_d", "editable": false, "format": "0.000,00/i", "header": "Debit\nnachher", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.new_d) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "new_c", "editable": false, "format": "0.000,00/i", "header": "Kredit\nnachher", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.new_c) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.ledger.PartnerAccountsBalance.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.PartnerAccountsBalance.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.create_excerpt1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.show_invoice_partners = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.PartnerAccountsBalance.ParamsPanel({});
  return new Lino.ledger.PartnerAccountsBalance.GridPanel(p);
});
Lino.ledger.PartnerAccountsBalance.ins_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.del_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.ins_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.del_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.ins_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.del_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.ins_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.del_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.del_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.ins_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PartnerAccountsBalance", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class ledger.CustomerAccountsBalance
Lino.ledger.CustomerAccountsBalance.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/CustomerAccountsBalance",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/CustomerAccountsBalance','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/CustomerAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/CustomerAccountsBalance','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/ledger/CustomerAccountsBalance','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/CustomerAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/CustomerAccountsBalance','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" } ],
  cell_edit : true,
  title : "Saldenliste Kunden",
  page_length : 20,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "description" }, { "name": "old_d" }, { "name": "old_c" }, { "name": "empty_column" }, { "name": "during_d" }, { "name": "during_c" }, { "name": "new_d" }, { "name": "new_c" }, { "name": "id", "type": "int" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var description_disp4423 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var old_d4424 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var old_c4425 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var empty_column_disp4426 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var during_d4427 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var during_c4428 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var empty_column_disp4426 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var new_d4429 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var new_c4430 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "description", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "old_d", "editable": false, "format": "0.000,00/i", "header": "Debit\nvorher", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.old_d) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "old_c", "editable": false, "format": "0.000,00/i", "header": "Kredit\nvorher", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.old_c) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "empty_column", "editable": false, "header": "", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.empty_column) ", "width": Lino.chars2width(2) }, { "align": "right", "colIndex": 4, "dataIndex": "during_d", "editable": false, "format": "0.000,00/i", "header": "Debit", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.during_d) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "during_c", "editable": false, "format": "0.000,00/i", "header": "Kredit", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.during_c) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "empty_column", "editable": false, "header": "", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.empty_column) ", "width": Lino.chars2width(2) }, { "align": "right", "colIndex": 7, "dataIndex": "new_d", "editable": false, "format": "0.000,00/i", "header": "Debit\nnachher", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.new_d) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "new_c", "editable": false, "format": "0.000,00/i", "header": "Kredit\nnachher", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.new_c) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.ledger.CustomerAccountsBalance.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.CustomerAccountsBalance.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.create_excerpt1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.show_invoice_partners = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.PartnerAccountsBalance.ParamsPanel({});
  return new Lino.ledger.CustomerAccountsBalance.GridPanel(p);
});
Lino.ledger.CustomerAccountsBalance.ins_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.ins_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.del_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.ins_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.del_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.ins_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.del_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.ins_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.del_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.del_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/CustomerAccountsBalance", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class ledger.SupplierAccountsBalance
Lino.ledger.SupplierAccountsBalance.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/SupplierAccountsBalance",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/SupplierAccountsBalance','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/SupplierAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/SupplierAccountsBalance','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/ledger/SupplierAccountsBalance','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/SupplierAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/SupplierAccountsBalance','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" } ],
  cell_edit : true,
  title : "Saldenliste Lieferanten",
  page_length : 20,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "description" }, { "name": "old_d" }, { "name": "old_c" }, { "name": "empty_column" }, { "name": "during_d" }, { "name": "during_c" }, { "name": "new_d" }, { "name": "new_c" }, { "name": "id", "type": "int" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var description_disp4432 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var old_d4433 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var old_c4434 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var empty_column_disp4435 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var during_d4436 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var during_c4437 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var empty_column_disp4435 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var new_d4438 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var new_c4439 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "description", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "old_d", "editable": false, "format": "0.000,00/i", "header": "Debit\nvorher", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.old_d) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "old_c", "editable": false, "format": "0.000,00/i", "header": "Kredit\nvorher", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.old_c) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "empty_column", "editable": false, "header": "", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.empty_column) ", "width": Lino.chars2width(2) }, { "align": "right", "colIndex": 4, "dataIndex": "during_d", "editable": false, "format": "0.000,00/i", "header": "Debit", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.during_d) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "during_c", "editable": false, "format": "0.000,00/i", "header": "Kredit", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.during_c) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "empty_column", "editable": false, "header": "", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.empty_column) ", "width": Lino.chars2width(2) }, { "align": "right", "colIndex": 7, "dataIndex": "new_d", "editable": false, "format": "0.000,00/i", "header": "Debit\nnachher", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.new_d) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "new_c", "editable": false, "format": "0.000,00/i", "header": "Kredit\nnachher", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.new_c) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.ledger.SupplierAccountsBalance.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.SupplierAccountsBalance.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.create_excerpt1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.show_invoice_partners = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.PartnerAccountsBalance.ParamsPanel({});
  return new Lino.ledger.SupplierAccountsBalance.GridPanel(p);
});
Lino.ledger.SupplierAccountsBalance.ins_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.ins_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.del_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.ins_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.del_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.ins_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.del_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.ins_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.del_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.del_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/SupplierAccountsBalance", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class ledger.Movements
Lino.ledger.Movements.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/Movements",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/Movements','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Movements','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Movements','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Movements','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/Movements','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Bewegungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "value_date", "type": "date" }, { "name": "voucher_link" }, { "name": "description" }, { "name": "debit" }, { "name": "credit" }, { "name": "match_link" }, { "name": "cleared", "type": "boolean" }, { "name": "id", "type": "int" }, { "name": "voucher" }, 'voucherHidden', { "name": "partner" }, 'partnerHidden', { "name": "seqno", "type": "int", "useNull": true }, { "name": "account" }, 'accountHidden', { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "match" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_class" }, 'vat_classHidden', { "name": "voucher_partner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value_date4441 = new Lino.DateField({ "selectOnFocus": true });
    var voucher_link_disp4442 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description_disp4443 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var debit4444 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var credit4445 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var match_link_disp4446 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var cleared4447 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var id4448 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var voucher4449 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Beleg ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/voucher" }) }) });
    var partner4450 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/partner" }) }) });
    var seqno4451 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var account4452 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/account" }) }) });
    var amount4453 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc4454 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var match4455 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/match" }) }) });
    var vat_regime4456 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_class4457 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var voucher_partner_disp4458 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4459 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4460 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4461 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      partner4450.on('change',Lino.chooser_handler(match4455,'partner'));
      account4452.on('change',Lino.chooser_handler(match4455,'account'));
      Lino.ledger.Movements.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value_date", "editable": true, "editor": value_date4441, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Valuta", "sortable": true, "tooltip": "(ledger.Movements.value_date) The date at which this movement is to be entered into the\nledger.  This is usually the voucher's entry_date, except\ne.g. for bank statements where each item can have its own\nvalue date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "voucher_link", "editable": false, "header": "Beleg", "sortable": false, "tooltip": "(ledger.Movements.voucher_link) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "description", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(ledger.Movements.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "debit", "editable": false, "format": "0.000,00/i", "header": "Debit", "sortable": false, "tooltip": "(ledger.Movements.debit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "credit", "editable": false, "format": "0.000,00/i", "header": "Kredit", "sortable": false, "tooltip": "(ledger.Movements.credit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "match_link", "editable": false, "header": "Match", "sortable": false, "tooltip": "(ledger.Movements.match_link) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "cleared", "editable": true, "filter": { "type": "boolean" }, "header": "Beglichen", "sortable": false, "tooltip": "(ledger.Movements.cleared) Whether", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id4448, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.Movements.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "voucher", "editable": true, "editor": voucher4449, "filter": { "type": "string" }, "header": "Beleg", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.voucher) Pointer to the Voucher who caused this movement.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "partner", "editable": true, "editor": partner4450, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.Movements.partner) Pointer to the partner involved in this movement. This may be\nblank.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 10, "dataIndex": "seqno", "editable": true, "editor": seqno4451, "filter": { "type": "numeric" }, "format": "0", "header": "Seq.-Nr.", "hidden": true, "sortable": true, "tooltip": "(ledger.Movements.seqno) Sequential number within a voucher.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "account", "editable": true, "editor": account4452, "filter": { "type": "string" }, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.account) Pointer to the Account that is being moved by this movement.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 12, "dataIndex": "amount", "editable": true, "editor": amount4453, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "amount", "hidden": true, "sortable": true, "tooltip": "(ledger.Movements.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 13, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "match", "editable": true, "editor": match4455, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.match) Pointer to the Movement that is being cleared by this\nmovement.", "width": Lino.chars2width(11) }, { "colIndex": 15, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime4456, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 16, "dataIndex": "vat_class", "editable": true, "editor": vat_class4457, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 17, "dataIndex": "voucher_partner", "editable": false, "header": "Partner", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.voucher_partner) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.Movements.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Movements.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Movements", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Movements.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Movements", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Movements.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Movements", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Movements.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Movements", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Movements.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Movements", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Movements.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Movements", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Movements.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Movements.ParamsPanel({});
  return new Lino.ledger.Movements.GridPanel(p);
});

// js_render_GridPanel_class ledger.AllMovements
Lino.ledger.AllMovements.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/AllMovements",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/AllMovements','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/AllMovements','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/AllMovements','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/AllMovements','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/AllMovements','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Bewegungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "value_date", "type": "date" }, { "name": "voucher_link" }, { "name": "description" }, { "name": "debit" }, { "name": "credit" }, { "name": "match_link" }, { "name": "cleared", "type": "boolean" }, { "name": "id", "type": "int" }, { "name": "voucher" }, 'voucherHidden', { "name": "partner" }, 'partnerHidden', { "name": "seqno", "type": "int", "useNull": true }, { "name": "account" }, 'accountHidden', { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "match" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_class" }, 'vat_classHidden', { "name": "voucher_partner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value_date10215 = new Lino.DateField({ "selectOnFocus": true });
    var voucher_link_disp10216 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description_disp10217 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var debit10218 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var credit10219 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var match_link_disp10220 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var cleared10221 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var id10222 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var voucher10223 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Beleg ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/AllMovements/voucher" }) }) });
    var partner10224 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/AllMovements/partner" }) }) });
    var seqno10225 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var account10226 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/AllMovements/account" }) }) });
    var amount10227 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc10228 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var match10229 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/AllMovements/match" }) }) });
    var vat_regime10230 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_class10231 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var voucher_partner_disp10232 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp10233 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10234 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10235 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      partner10224.on('change',Lino.chooser_handler(match10229,'partner'));
      account10226.on('change',Lino.chooser_handler(match10229,'account'));
      Lino.ledger.AllMovements.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value_date", "editable": true, "editor": value_date10215, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Valuta", "sortable": true, "tooltip": "(ledger.AllMovements.value_date) The date at which this movement is to be entered into the\nledger.  This is usually the voucher's entry_date, except\ne.g. for bank statements where each item can have its own\nvalue date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "voucher_link", "editable": false, "header": "Beleg", "sortable": false, "tooltip": "(ledger.AllMovements.voucher_link) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "description", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(ledger.AllMovements.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "debit", "editable": false, "format": "0.000,00/i", "header": "Debit", "sortable": false, "tooltip": "(ledger.AllMovements.debit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "credit", "editable": false, "format": "0.000,00/i", "header": "Kredit", "sortable": false, "tooltip": "(ledger.AllMovements.credit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "match_link", "editable": false, "header": "Match", "sortable": false, "tooltip": "(ledger.AllMovements.match_link) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "cleared", "editable": true, "filter": { "type": "boolean" }, "header": "Beglichen", "sortable": false, "tooltip": "(ledger.AllMovements.cleared) Whether", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id10222, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.AllMovements.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "voucher", "editable": true, "editor": voucher10223, "filter": { "type": "string" }, "header": "Beleg", "hidden": true, "sortable": false, "tooltip": "(ledger.AllMovements.voucher) Pointer to the Voucher who caused this movement.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "partner", "editable": true, "editor": partner10224, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.AllMovements.partner) Pointer to the partner involved in this movement. This may be\nblank.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 10, "dataIndex": "seqno", "editable": true, "editor": seqno10225, "filter": { "type": "numeric" }, "format": "0", "header": "Seq.-Nr.", "hidden": true, "sortable": true, "tooltip": "(ledger.AllMovements.seqno) Sequential number within a voucher.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "account", "editable": true, "editor": account10226, "filter": { "type": "string" }, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(ledger.AllMovements.account) Pointer to the Account that is being moved by this movement.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 12, "dataIndex": "amount", "editable": true, "editor": amount10227, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "amount", "hidden": true, "sortable": true, "tooltip": "(ledger.AllMovements.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 13, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(ledger.AllMovements.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "match", "editable": true, "editor": match10229, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(ledger.AllMovements.match) Pointer to the Movement that is being cleared by this\nmovement.", "width": Lino.chars2width(11) }, { "colIndex": 15, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime10230, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(ledger.AllMovements.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 16, "dataIndex": "vat_class", "editable": true, "editor": vat_class10231, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "hidden": true, "sortable": false, "tooltip": "(ledger.AllMovements.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 17, "dataIndex": "voucher_partner", "editable": false, "header": "Partner", "hidden": true, "sortable": false, "tooltip": "(ledger.AllMovements.voucher_partner) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.AllMovements.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.AllMovements.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.AllMovements.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.AllMovements.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.AllMovements.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllMovements", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllMovements.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllMovements", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllMovements.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllMovements", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllMovements.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllMovements", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllMovements.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllMovements", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllMovements.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AllMovements", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.AllMovements.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Movements.ParamsPanel({});
  return new Lino.ledger.AllMovements.GridPanel(p);
});

// js_render_GridPanel_class lists.ListTypes
Lino.lists.ListTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 7,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/lists/ListTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/lists/ListTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/lists/ListTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/lists/ListTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/lists/ListTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/lists/ListTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Listenarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "designation" }, { "name": "designation_de" }, { "name": "designation_fr" }, { "name": "id", "type": "int" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 12,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var designation10237 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var designation_de10238 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var designation_fr10239 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id10240 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10241 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10242 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10243 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "designation", "editable": true, "editor": designation10237, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(lists.ListTypes.designation) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "designation_de", "editable": true, "editor": designation_de10238, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(lists.ListTypes.designation_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "designation_fr", "editable": true, "editor": designation_fr10239, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(lists.ListTypes.designation_fr) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id10240, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(lists.ListTypes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(lists.ListTypes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(lists.ListTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(lists.ListTypes.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.lists.ListTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.ListTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/ListTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/ListTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/ListTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/ListTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/ListTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/ListTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/ListTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/ListTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.ListTypes.GridPanel(p);
});

// js_render_GridPanel_class lists.Lists
Lino.lists.Lists.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 11,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/lists/Lists",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/lists/Lists','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/lists/Lists','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/lists/Lists','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/lists/Lists','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/lists/Lists','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/lists/Lists','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Partnerlisten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "ref" }, { "name": "overview" }, { "name": "list_type" }, 'list_typeHidden', { "name": "id", "type": "int" }, { "name": "designation" }, { "name": "designation_de" }, { "name": "designation_fr" }, { "name": "remarks" }, { "name": "mobile_item" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 14,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.lists.Lists.detail;
    this.ls_insert_handler = Lino.lists.Lists.insert;
    var ww = this.containing_window;
    var ref4463 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var overview_disp4464 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var list_type4465 = new Lino.RemoteComboFieldElement({ "emptyText": "Listenart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/Lists/list_type" }) }) });
    var id4466 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var designation4467 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var designation_de4468 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var designation_fr4469 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks4470 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var mobile_item_disp4471 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4472 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref4463, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(lists.Lists.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(lists.Lists.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "list_type", "editable": true, "editor": list_type4465, "filter": { "type": "string" }, "header": "Listenart", "sortable": false, "tooltip": "(lists.Lists.list_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id4466, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(lists.Lists.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "designation", "editable": true, "editor": designation4467, "filter": { "type": "string" }, "header": "Bezeichnung", "hidden": true, "sortable": true, "tooltip": "(lists.Lists.designation) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "designation_de", "editable": true, "editor": designation_de4468, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "hidden": true, "sortable": true, "tooltip": "(lists.Lists.designation_de) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "designation_fr", "editable": true, "editor": designation_fr4469, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "hidden": true, "sortable": true, "tooltip": "(lists.Lists.designation_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "remarks", "editable": true, "editor": remarks4470, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(lists.Lists.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 8, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(lists.Lists.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(lists.Lists.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.lists.Lists.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.Lists.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Lists", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Lists", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Lists", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Lists", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Lists", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Lists", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.lists.Lists.insertPanel = Ext.extend(Lino.lists.Lists.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/lists/Lists",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.lists.Lists.detail;
    this.ls_insert_handler = Lino.lists.Lists.insert;
    Lino.lists.Lists.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.Lists.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(12), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.lists.Lists.insertPanel(p);
});
Lino.lists.Lists.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Lists", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Lists", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Lists", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.lists.Lists.detailPanel = Ext.extend(Lino.lists.Lists.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/lists/Lists",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.lists.Lists.detail;
    this.ls_insert_handler = Lino.lists.Lists.insert;
    Lino.lists.Lists.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.Lists.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.Lists.detailPanel(p);
});
Lino.lists.Lists.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Lists", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.Lists.GridPanel(p);
});
Lino.lists.Lists.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Lists", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class lists.Members
Lino.lists.Members.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 11,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/lists/Members",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/lists/Members','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/lists/Members','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/lists/Members','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/lists/Members','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/lists/Members','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Listenmitgliedschaften",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "list" }, 'listHidden', { "name": "partner" }, 'partnerHidden', { "name": "remark" }, { "name": "move_buttons" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 13,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id4474 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno4475 = new Ext.form.NumberField({ "selectOnFocus": true });
    var list4476 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Partnerliste ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/Members/list" }) }) });
    var partner4477 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/Members/partner" }) }) });
    var remark4478 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var move_buttons_disp4479 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4480 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4481 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4482 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4474, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(lists.Members.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno4475, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(lists.Members.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "list", "editable": true, "editor": list4476, "filter": { "type": "string" }, "header": "Partnerliste", "renderer": Lino.fk_renderer('listHidden','Lino.lists.Lists.detail'), "sortable": false, "tooltip": "(lists.Members.list) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "partner", "editable": true, "editor": partner4477, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(lists.Members.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "remark", "editable": true, "editor": remark4478, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(lists.Members.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(lists.Members.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(lists.Members.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(lists.Members.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(lists.Members.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.lists.Members.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.Members.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Members", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Members", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Members", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Members", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Members", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Members", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Members", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Members", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Members", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.Members.GridPanel(p);
});
Lino.lists.Members.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Members", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/Members", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class lists.AllMembers
Lino.lists.AllMembers.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 11,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/lists/AllMembers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/lists/AllMembers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/lists/AllMembers','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/lists/AllMembers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/lists/AllMembers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/lists/AllMembers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Listenmitgliedschaften",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "list" }, 'listHidden', { "name": "partner" }, 'partnerHidden', { "name": "remark" }, { "name": "move_buttons" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 13,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id10245 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno10246 = new Ext.form.NumberField({ "selectOnFocus": true });
    var list10247 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Partnerliste ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/AllMembers/list" }) }) });
    var partner10248 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/AllMembers/partner" }) }) });
    var remark10249 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var move_buttons_disp10250 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp10251 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10252 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10253 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10245, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(lists.AllMembers.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno10246, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(lists.AllMembers.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "list", "editable": true, "editor": list10247, "filter": { "type": "string" }, "header": "Partnerliste", "renderer": Lino.fk_renderer('listHidden','Lino.lists.Lists.detail'), "sortable": false, "tooltip": "(lists.AllMembers.list) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "partner", "editable": true, "editor": partner10248, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(lists.AllMembers.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "remark", "editable": true, "editor": remark10249, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(lists.AllMembers.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(lists.AllMembers.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(lists.AllMembers.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(lists.AllMembers.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(lists.AllMembers.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.lists.AllMembers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.AllMembers.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/AllMembers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/AllMembers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/AllMembers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/AllMembers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/AllMembers", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/AllMembers", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/AllMembers", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/AllMembers", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/AllMembers", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.AllMembers.GridPanel(p);
});
Lino.lists.AllMembers.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/AllMembers", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/AllMembers", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class gfks.ContentTypes
Lino.gfks.ContentTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 3,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/gfks/ContentTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/gfks/ContentTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/ContentTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/ContentTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/ContentTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/gfks/ContentTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Datenbankmodelle",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "app_label" }, { "name": "model" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 15,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.gfks.ContentTypes.detail;
    var ww = this.containing_window;
    var id10255 = new Ext.form.NumberField({ "selectOnFocus": true });
    var app_label10256 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 100, "selectOnFocus": true });
    var model10257 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 100, "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10255, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(gfks.ContentTypes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "app_label", "editable": true, "editor": app_label10256, "filter": { "type": "string" }, "header": "app label", "sortable": true, "tooltip": "(gfks.ContentTypes.app_label) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "model", "editable": true, "editor": model10257, "filter": { "type": "string" }, "header": "Python Modell-Klassenname", "sortable": true, "tooltip": "(gfks.ContentTypes.model) ", "width": Lino.chars2width(22) } ];
    Lino.gfks.ContentTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.gfks.ContentTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/ContentTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/ContentTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/ContentTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/ContentTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/ContentTypes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/ContentTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/ContentTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/ContentTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.gfks.ContentTypes.detailPanel = Ext.extend(Lino.gfks.ContentTypes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/gfks/ContentTypes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.gfks.ContentTypes.detail;
    Lino.gfks.ContentTypes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.gfks.ContentTypes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.gfks.ContentTypes.detailPanel(p);
});
Lino.gfks.ContentTypes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/ContentTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.gfks.ContentTypes.GridPanel(p);
});
Lino.gfks.ContentTypes.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/ContentTypes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class gfks.HelpTexts
Lino.gfks.HelpTexts.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 6,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/gfks/HelpTexts",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTexts','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTexts','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTexts','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTexts','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTexts','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Hilfetexte",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "field" }, { "name": "verbose_name" }, { "name": "help_text" }, { "name": "id", "type": "int" }, { "name": "content_type" }, 'content_typeHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 16,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var field10259 = new Lino.SimpleRemoteComboFieldElement({ "allowBlank": false, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/gfks/HelpTexts/field" }) }) });
    var verbose_name10260 = new Ext.form.TextField({ "disabled": true, "maxLength": 200 });
    var help_text10261 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var id10262 = new Ext.form.NumberField({ "selectOnFocus": true });
    var content_type10263 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Datenbankmodell ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/gfks/HelpTexts/content_type" }) }) });
    this.before_row_edit = function(record) {
      field10259.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      content_type10263.on('change',Lino.chooser_handler(field10259,'content_type'));
      Lino.gfks.HelpTexts.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "field", "editable": true, "editor": field10259, "filter": { "type": "string" }, "header": "Feld", "sortable": false, "tooltip": "(gfks.HelpTexts.field) ", "width": Lino.chars2width(11) }, { "colIndex": 1, "dataIndex": "verbose_name", "editable": false, "header": "Feldbezeichnung", "sortable": false, "tooltip": "(gfks.HelpTexts.verbose_name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "help_text", "editable": true, "editor": help_text10261, "filter": { "type": "string" }, "header": "Hilfetext", "sortable": false, "tooltip": "(gfks.HelpTexts.help_text) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id10262, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(gfks.HelpTexts.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "content_type", "editable": true, "editor": content_type10263, "filter": { "type": "string" }, "header": "Modell", "renderer": Lino.fk_renderer('content_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(gfks.HelpTexts.content_type) ", "width": Lino.chars2width(21) } ];
    Lino.gfks.HelpTexts.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.gfks.HelpTexts.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTexts", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTexts", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTexts", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTexts", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTexts", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTexts", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTexts", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTexts", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.gfks.HelpTexts.GridPanel(p);
});

// js_render_GridPanel_class plausibility.Problems
Lino.plausibility.Problems.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/plausibility/Problems",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/plausibility/Problems','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/Problems','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/Problems','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/Problems','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/plausibility/Problems','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Datenkontrolle durchf\u00fchren" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Datenprobleme reparieren" } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : false,
  title : "Datenprobleme",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "message" }, { "name": "checker" }, 'checkerHidden', { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 17,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.Problems.detail;
    var ww = this.containing_window;
    var user4484 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/Problems/user" }) }) });
    var owner_disp4485 = new Ext.form.DisplayField({ "disabled": true });
    var message4486 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 250, "selectOnFocus": true });
    var checker4487 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.plausibility.Checkers });
    var id4488 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type4489 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/Problems/owner_type" }) }) });
    var owner_id4490 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/Problems/owner_id" }) }) });
    var mobile_item_disp4491 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4492 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4493 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      owner_type4489.on('change',Lino.chooser_handler(owner_id4490,'owner_type'));
      Lino.plausibility.Problems.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "user", "editable": true, "editor": user4484, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(plausibility.Problems.user) The user reponsible\nfor fixing this problem.", "width": Lino.chars2width(11) }, { "colIndex": 1, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(plausibility.Problems.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "message", "editable": true, "editor": message4486, "filter": { "type": "string" }, "header": "Meldung", "sortable": true, "tooltip": "(plausibility.Problems.message) The message text. This is a concatenation of all messages that\nwere yeld by the checker.", "width": Lino.chars2width(51) }, { "colIndex": 3, "dataIndex": "checker", "editable": true, "editor": checker4487, "filter": { "type": "string" }, "header": "Datentest", "sortable": false, "tooltip": "(plausibility.Problems.checker) The Checker which reported\nthis problem.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id4488, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(plausibility.Problems.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "owner_type", "editable": true, "editor": owner_type4489, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(plausibility.Problems.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "owner_id", "editable": true, "editor": owner_id4490, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(plausibility.Problems.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(plausibility.Problems.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(plausibility.Problems.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(plausibility.Problems.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.plausibility.Problems.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.Problems.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/Problems", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Problems.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/Problems", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Problems.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/Problems", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Problems.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/Problems", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Problems.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/Problems", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Problems.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/Problems", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.plausibility.Problems.detailPanel = Ext.extend(Lino.plausibility.Problems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Datenkontrolle durchf\u00fchren" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Datenprobleme reparieren" } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/plausibility/Problems",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.Problems.detail;
    Lino.plausibility.Problems.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.Problems.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.Problems.detailPanel(p);
});
Lino.plausibility.Problems.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.plausibility.Problems.ParamsPanel({});
  return new Lino.plausibility.Problems.GridPanel(p);
});
Lino.plausibility.Problems.update_problem = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/Problems", "GET", pk, "update_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Problems.fix_problem = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/Problems", "GET", pk, "fix_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class plausibility.AllProblems
Lino.plausibility.AllProblems.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/plausibility/AllProblems",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/plausibility/AllProblems','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/AllProblems','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/AllProblems','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/AllProblems','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/plausibility/AllProblems','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Datenkontrolle durchf\u00fchren" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Datenprobleme reparieren" } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : false,
  title : "Datenprobleme",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "message" }, { "name": "checker" }, 'checkerHidden', { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 17,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.AllProblems.detail;
    var ww = this.containing_window;
    var user10265 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/AllProblems/user" }) }) });
    var owner_disp10266 = new Ext.form.DisplayField({ "disabled": true });
    var message10267 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 250, "selectOnFocus": true });
    var checker10268 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.plausibility.Checkers });
    var id10269 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type10270 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/AllProblems/owner_type" }) }) });
    var owner_id10271 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/AllProblems/owner_id" }) }) });
    var mobile_item_disp10272 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10273 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10274 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      owner_type10270.on('change',Lino.chooser_handler(owner_id10271,'owner_type'));
      Lino.plausibility.AllProblems.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "user", "editable": true, "editor": user10265, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(plausibility.AllProblems.user) The user reponsible\nfor fixing this problem.", "width": Lino.chars2width(11) }, { "colIndex": 1, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(plausibility.AllProblems.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "message", "editable": true, "editor": message10267, "filter": { "type": "string" }, "header": "Meldung", "sortable": true, "tooltip": "(plausibility.AllProblems.message) The message text. This is a concatenation of all messages that\nwere yeld by the checker.", "width": Lino.chars2width(51) }, { "colIndex": 3, "dataIndex": "checker", "editable": true, "editor": checker10268, "filter": { "type": "string" }, "header": "Datentest", "sortable": false, "tooltip": "(plausibility.AllProblems.checker) The Checker which reported\nthis problem.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id10269, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(plausibility.AllProblems.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "owner_type", "editable": true, "editor": owner_type10270, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(plausibility.AllProblems.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "owner_id", "editable": true, "editor": owner_id10271, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(plausibility.AllProblems.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(plausibility.AllProblems.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(plausibility.AllProblems.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(plausibility.AllProblems.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.plausibility.AllProblems.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.AllProblems.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/AllProblems", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.AllProblems.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/AllProblems", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.AllProblems.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/AllProblems", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.AllProblems.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/AllProblems", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.AllProblems.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/AllProblems", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.AllProblems.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/AllProblems", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.plausibility.AllProblems.detailPanel = Ext.extend(Lino.plausibility.Problems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Datenkontrolle durchf\u00fchren" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Datenprobleme reparieren" } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/plausibility/AllProblems",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.AllProblems.detail;
    Lino.plausibility.AllProblems.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.AllProblems.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.AllProblems.detailPanel(p);
});
Lino.plausibility.AllProblems.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.plausibility.Problems.ParamsPanel({});
  return new Lino.plausibility.AllProblems.GridPanel(p);
});
Lino.plausibility.AllProblems.update_problem = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/AllProblems", "GET", pk, "update_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.AllProblems.fix_problem = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/AllProblems", "GET", pk, "fix_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class plausibility.MyProblems
Lino.plausibility.MyProblems.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/plausibility/MyProblems",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/plausibility/MyProblems','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/MyProblems','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/MyProblems','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/MyProblems','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/plausibility/MyProblems','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Datenkontrolle durchf\u00fchren" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Datenprobleme reparieren" } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : false,
  title : "Meine Datenkontrollliste",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "message" }, { "name": "checker" }, 'checkerHidden', { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 17,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.MyProblems.detail;
    var ww = this.containing_window;
    var user532 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/MyProblems/user" }) }) });
    var owner_disp533 = new Ext.form.DisplayField({ "disabled": true });
    var message534 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 250, "selectOnFocus": true });
    var checker535 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.plausibility.Checkers });
    var id536 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type537 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/MyProblems/owner_type" }) }) });
    var owner_id538 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/MyProblems/owner_id" }) }) });
    var mobile_item_disp539 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp540 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp541 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      owner_type537.on('change',Lino.chooser_handler(owner_id538,'owner_type'));
      Lino.plausibility.MyProblems.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "user", "editable": true, "editor": user532, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(plausibility.MyProblems.user) The user reponsible\nfor fixing this problem.", "width": Lino.chars2width(11) }, { "colIndex": 1, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(plausibility.MyProblems.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "message", "editable": true, "editor": message534, "filter": { "type": "string" }, "header": "Meldung", "sortable": true, "tooltip": "(plausibility.MyProblems.message) The message text. This is a concatenation of all messages that\nwere yeld by the checker.", "width": Lino.chars2width(51) }, { "colIndex": 3, "dataIndex": "checker", "editable": true, "editor": checker535, "filter": { "type": "string" }, "header": "Datentest", "sortable": false, "tooltip": "(plausibility.MyProblems.checker) The Checker which reported\nthis problem.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id536, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(plausibility.MyProblems.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "owner_type", "editable": true, "editor": owner_type537, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(plausibility.MyProblems.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "owner_id", "editable": true, "editor": owner_id538, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(plausibility.MyProblems.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(plausibility.MyProblems.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(plausibility.MyProblems.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(plausibility.MyProblems.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.plausibility.MyProblems.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.MyProblems.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/MyProblems", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.MyProblems.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/MyProblems", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.MyProblems.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/MyProblems", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.MyProblems.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/MyProblems", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.MyProblems.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/MyProblems", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.MyProblems.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/MyProblems", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.plausibility.MyProblems.detailPanel = Ext.extend(Lino.plausibility.Problems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Datenkontrolle durchf\u00fchren" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Datenprobleme reparieren" } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/plausibility/MyProblems",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.MyProblems.detail;
    Lino.plausibility.MyProblems.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.MyProblems.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.MyProblems.detailPanel(p);
});
Lino.plausibility.MyProblems.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.plausibility.Problems.ParamsPanel({});
  return new Lino.plausibility.MyProblems.GridPanel(p);
});
Lino.plausibility.MyProblems.update_problem = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/MyProblems", "GET", pk, "update_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.MyProblems.fix_problem = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/MyProblems", "GET", pk, "fix_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.RemoteCalendars
Lino.cal.RemoteCalendars.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 12,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/RemoteCalendars",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/RemoteCalendars','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/RemoteCalendars','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/RemoteCalendars','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/RemoteCalendars','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/RemoteCalendars','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Externe Kalender",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "type" }, 'typeHidden', { "name": "url_template" }, { "name": "username" }, { "name": "password" }, { "name": "readonly", "type": "boolean" }, { "name": "move_buttons" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 25,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id10276 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno10277 = new Ext.form.NumberField({ "selectOnFocus": true });
    var type10278 = new Lino.ChoicesFieldElement({ "allowBlank": false, "selectOnFocus": true, "store": [ [ "local", "Local Calendar" ], [ "google", "Google Calendar" ] ], "value": "local" });
    var url_template10279 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var username10280 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var password10281 = new Ext.form.TextField({ "inputType": "password", "maxLength": 200, "selectOnFocus": true });
    var readonly10282 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var move_buttons_disp10283 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp10284 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10285 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10286 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10276, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.RemoteCalendars.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno10277, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(cal.RemoteCalendars.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "type", "editable": true, "editor": type10278, "filter": { "type": "string" }, "header": "Art", "sortable": false, "tooltip": "(cal.RemoteCalendars.type) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "url_template", "editable": true, "editor": url_template10279, "filter": { "type": "string" }, "header": "URL-Vorlage", "sortable": true, "tooltip": "(cal.RemoteCalendars.url_template) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "username", "editable": true, "editor": username10280, "filter": { "type": "string" }, "header": "Benutzername", "sortable": true, "tooltip": "(cal.RemoteCalendars.username) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "password", "editable": true, "editor": password10281, "filter": { "type": "string" }, "header": "Passwort", "sortable": true, "tooltip": "(cal.RemoteCalendars.password) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "readonly", "editable": true, "filter": { "type": "boolean" }, "header": "schreibgesch\u00fctzt", "sortable": false, "tooltip": "(cal.RemoteCalendars.readonly) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 7, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(cal.RemoteCalendars.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.RemoteCalendars.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.RemoteCalendars.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.RemoteCalendars.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.cal.RemoteCalendars.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.RemoteCalendars.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RemoteCalendars", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RemoteCalendars.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RemoteCalendars", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RemoteCalendars.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RemoteCalendars", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RemoteCalendars.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RemoteCalendars", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RemoteCalendars.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RemoteCalendars", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RemoteCalendars.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RemoteCalendars", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RemoteCalendars.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RemoteCalendars", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RemoteCalendars.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RemoteCalendars", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RemoteCalendars.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RemoteCalendars", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RemoteCalendars.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.RemoteCalendars.GridPanel(p);
});
Lino.cal.RemoteCalendars.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RemoteCalendars", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RemoteCalendars.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RemoteCalendars", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.AllRooms
Lino.cal.AllRooms.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 18,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/AllRooms",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/AllRooms','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/AllRooms','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/AllRooms','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/AllRooms','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/AllRooms','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "R\u00e4ume",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "description" }, { "name": "fee" }, 'feeHidden', { "name": "calendar" }, 'calendarHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 20,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllRooms.detail;
    this.ls_insert_handler = Lino.cal.AllRooms.insert;
    var ww = this.containing_window;
    var id10288 = new Ext.form.NumberField({ "selectOnFocus": true });
    var name10289 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10290 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10291 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var company10292 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllRooms/company" }) }) });
    var contact_person10293 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllRooms/contact_person" }) }) });
    var contact_role10294 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllRooms/contact_role" }) }) });
    var description10295 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var fee10296 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllRooms/fee" }) }) });
    var calendar10297 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalender ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllRooms/calendar" }) }) });
    var mobile_item_disp10298 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10299 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10300 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      contact_person10293.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company10292.on('change',Lino.chooser_handler(contact_person10293,'company'));
      Lino.cal.AllRooms.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10288, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.AllRooms.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name10289, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(cal.AllRooms.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de10290, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(cal.AllRooms.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr10291, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(cal.AllRooms.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "company", "editable": true, "editor": company10292, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(cal.AllRooms.company) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "contact_person", "editable": true, "editor": contact_person10293, "filter": { "type": "string" }, "header": "Kontaktperson", "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(cal.AllRooms.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "contact_role", "editable": true, "editor": contact_role10294, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "sortable": false, "tooltip": "(cal.AllRooms.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "description", "editable": true, "editor": description10295, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": false, "tooltip": "(cal.AllRooms.description) ", "width": Lino.chars2width(61) }, { "colIndex": 8, "dataIndex": "fee", "editable": true, "editor": fee10296, "filter": { "type": "string" }, "header": "Tarif", "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(cal.AllRooms.fee) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "calendar", "editable": true, "editor": calendar10297, "filter": { "type": "string" }, "header": "Kalender", "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.AllRooms.calendar) Calendar where events in this room are published.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.AllRooms.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.AllRooms.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.AllRooms.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.cal.AllRooms.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllRooms.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllRooms", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllRooms.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllRooms", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllRooms.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllRooms", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllRooms.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllRooms", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllRooms.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllRooms", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.AllRooms.insertPanel = Ext.extend(Lino.cal.AllRooms.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/AllRooms",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllRooms.detail;
    this.ls_insert_handler = Lino.cal.AllRooms.insert;
    Lino.cal.AllRooms.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllRooms.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.AllRooms.insertPanel(p);
});
Lino.cal.AllRooms.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllRooms", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllRooms.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllRooms", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllRooms.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllRooms", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.AllRooms.detailPanel = Ext.extend(Lino.cal.AllRooms.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/AllRooms",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllRooms.detail;
    this.ls_insert_handler = Lino.cal.AllRooms.insert;
    Lino.cal.AllRooms.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllRooms.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.AllRooms.detailPanel(p);
});
Lino.cal.AllRooms.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllRooms", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllRooms.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.AllRooms.GridPanel(p);
});
Lino.cal.AllRooms.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllRooms", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.Priorities
Lino.cal.Priorities.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 8,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/Priorities",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/Priorities','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Priorities','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Priorities','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Priorities','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/Priorities','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Priorit\u00e4ten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "id", "type": "int" }, { "name": "ref" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 24,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var name10302 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10303 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10304 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id10305 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref10306 = new Ext.form.TextField({ "allowBlank": false, "boxMinWidth": Lino.chars2width(1), "hidden": true, "maxLength": 1, "selectOnFocus": true });
    var mobile_item_disp10307 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10308 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10309 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name10302, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(cal.Priorities.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de10303, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(cal.Priorities.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr10304, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(cal.Priorities.name_fr) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id10305, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.Priorities.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "ref", "editable": true, "editor": ref10306, "filter": { "type": "string" }, "header": "ref", "hidden": true, "sortable": true, "tooltip": "(cal.Priorities.ref) ", "width": Lino.chars2width(5) }, { "colIndex": 5, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Priorities.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Priorities.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.Priorities.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.cal.Priorities.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Priorities.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Priorities", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Priorities.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Priorities", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Priorities.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Priorities", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Priorities.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Priorities", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Priorities.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Priorities", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Priorities.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Priorities", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Priorities.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Priorities", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Priorities.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Priorities", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Priorities.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.Priorities.GridPanel(p);
});

// js_render_GridPanel_class cal.Calendars
Lino.cal.Calendars.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 9,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/Calendars",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/Calendars','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Calendars','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Calendars','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Calendars','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/Calendars','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Kalenderliste",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "description" }, { "name": "color", "type": "int", "useNull": true }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 27,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Calendars.detail;
    this.ls_insert_handler = Lino.cal.Calendars.insert;
    var ww = this.containing_window;
    var id10311 = new Ext.form.NumberField({ "selectOnFocus": true });
    var name10312 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10313 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10314 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var description10315 = new Ext.form.HtmlEditor({ "selectOnFocus": true });
    var color10316 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true });
    var mobile_item_disp10317 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10318 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10319 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10311, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.Calendars.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name10312, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(cal.Calendars.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de10313, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(cal.Calendars.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr10314, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(cal.Calendars.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "description", "editable": true, "editor": description10315, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": false, "tooltip": "(cal.Calendars.description) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 5, "dataIndex": "color", "editable": true, "editor": color10316, "filter": { "type": "numeric" }, "format": "0", "header": "Farbe", "sortable": true, "tooltip": "(cal.Calendars.color) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Calendars.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Calendars.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.Calendars.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.cal.Calendars.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Calendars.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Calendars", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Calendars.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Calendars", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Calendars.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Calendars", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Calendars.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Calendars", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Calendars.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Calendars", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.Calendars.insertPanel = Ext.extend(Lino.cal.Calendars.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/Calendars",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Calendars.detail;
    this.ls_insert_handler = Lino.cal.Calendars.insert;
    Lino.cal.Calendars.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Calendars.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.Calendars.insertPanel(p);
});
Lino.cal.Calendars.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Calendars", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Calendars.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Calendars", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Calendars.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Calendars", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.Calendars.detailPanel = Ext.extend(Lino.cal.Calendars.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/Calendars",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Calendars.detail;
    this.ls_insert_handler = Lino.cal.Calendars.insert;
    Lino.cal.Calendars.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Calendars.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.Calendars.detailPanel(p);
});
Lino.cal.Calendars.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Calendars", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Calendars.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.Calendars.GridPanel(p);
});
Lino.cal.Calendars.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Calendars", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.Subscriptions
Lino.cal.Subscriptions.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 9,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/Subscriptions",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/Subscriptions','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Subscriptions','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Subscriptions','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Subscriptions','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/Subscriptions','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Abonnements",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "calendar" }, 'calendarHidden', { "name": "is_hidden", "type": "boolean" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 29,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id10321 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user10322 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Subscriptions/user" }) }) });
    var calendar10323 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Kalender ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Subscriptions/calendar" }) }) });
    var is_hidden10324 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var mobile_item_disp10325 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10326 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10327 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10321, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.Subscriptions.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user10322, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.Subscriptions.user) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "calendar", "editable": true, "editor": calendar10323, "filter": { "type": "string" }, "header": "Kalender", "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.Subscriptions.calendar) The calendar you want to subscribe to.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "is_hidden", "editable": true, "filter": { "type": "boolean" }, "header": "versteckt", "sortable": false, "tooltip": "(cal.Subscriptions.is_hidden) Whether this subscription should \"\n        \"initially be displayed as a hidden calendar.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 4, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Subscriptions.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Subscriptions.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.Subscriptions.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.cal.Subscriptions.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Subscriptions.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Subscriptions", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Subscriptions.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Subscriptions", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Subscriptions.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Subscriptions", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Subscriptions.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Subscriptions", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Subscriptions.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Subscriptions", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Subscriptions.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Subscriptions", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Subscriptions.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Subscriptions", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Subscriptions.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Subscriptions", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Subscriptions.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Subscriptions.ParamsPanel({});
  return new Lino.cal.Subscriptions.GridPanel(p);
});

// js_render_GridPanel_class cal.Tasks
Lino.cal.Tasks.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 27,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/Tasks",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/Tasks','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Tasks','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Tasks','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Tasks','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/Tasks','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Aufgaben",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "name": "start_time" }, { "name": "user" }, 'userHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "due_time" }, { "name": "percent", "type": "int", "useNull": true }, { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "created_natural" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 18,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Tasks.detail;
    this.ls_insert_handler = Lino.cal.Tasks.insert;
    var ww = this.containing_window;
    var start_date10329 = new Lino.DateField({ "selectOnFocus": true });
    var summary10330 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp10331 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id10332 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified10333 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created10334 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_time10335 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user10336 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Tasks/user" }) }) });
    var owner_type10337 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Tasks/owner_type" }) }) });
    var owner_id10338 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Tasks/owner_id" }) }) });
    var description10339 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class10340 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence10341 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type10342 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var due_date10343 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var due_time10344 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var percent10345 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state10346 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.TaskStates });
    var owner_disp10347 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp10348 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10349 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp10350 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      owner_id10338.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type10337.on('change',Lino.chooser_handler(owner_id10338,'owner_type'));
      Lino.cal.Tasks.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date10329, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(cal.Tasks.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "summary", "editable": true, "editor": summary10330, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.Tasks.summary) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.Tasks.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id10332, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.Tasks.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.Tasks.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 5, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.Tasks.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "start_time", "editable": true, "editor": start_time10335, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.Tasks.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user10336, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.Tasks.user) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_type", "editable": true, "editor": owner_type10337, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.Tasks.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "owner_id", "editable": true, "editor": owner_id10338, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.Tasks.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "description", "editable": true, "editor": description10339, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Tasks.description) ", "width": Lino.chars2width(61) }, { "colIndex": 11, "dataIndex": "access_class", "editable": true, "editor": access_class10340, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.Tasks.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 12, "dataIndex": "sequence", "editable": true, "editor": sequence10341, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.Tasks.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 13, "dataIndex": "auto_type", "editable": true, "editor": auto_type10342, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.Tasks.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 14, "dataIndex": "due_date", "editable": true, "editor": due_date10343, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Zahlungsziel", "hidden": true, "sortable": true, "tooltip": "(cal.Tasks.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 15, "dataIndex": "due_time", "editable": true, "editor": due_time10344, "header": "F\u00e4llig um", "hidden": true, "sortable": true, "tooltip": "(cal.Tasks.due_time) ", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 16, "dataIndex": "percent", "editable": true, "editor": percent10345, "filter": { "type": "numeric" }, "format": "0", "header": "Dauer (Anzahl)", "hidden": true, "sortable": true, "tooltip": "(cal.Tasks.percent) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 17, "dataIndex": "state", "editable": true, "editor": state10346, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.Tasks.state) The state of this Task. one of TaskStates.", "width": Lino.chars2width(13) }, { "colIndex": 18, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(cal.Tasks.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 19, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Tasks.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Tasks.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.Tasks.created_natural) ", "width": Lino.chars2width(31) } ];
    Lino.cal.Tasks.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Tasks.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Tasks.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Tasks.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Tasks.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Tasks.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.Tasks.insertPanel = Ext.extend(Lino.cal.Tasks.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/Tasks",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Tasks.detail;
    this.ls_insert_handler = Lino.cal.Tasks.insert;
    Lino.cal.Tasks.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Tasks.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.Tasks.insertPanel(p);
});
Lino.cal.Tasks.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Tasks.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Tasks.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.Tasks.detailPanel = Ext.extend(Lino.cal.Tasks.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/Tasks",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Tasks.detail;
    this.ls_insert_handler = Lino.cal.Tasks.insert;
    Lino.cal.Tasks.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Tasks.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.Tasks.detailPanel(p);
});
Lino.cal.Tasks.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Tasks.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Tasks.ParamsPanel({});
  return new Lino.cal.Tasks.GridPanel(p);
});
Lino.cal.Tasks.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Tasks.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Tasks.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Tasks.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Tasks.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Tasks", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyTasks
Lino.cal.MyTasks.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 4,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyTasks",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyTasks','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyTasks','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyTasks','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyTasks','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyTasks','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Meine Aufgaben",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 18,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyTasks.detail;
    this.ls_insert_handler = Lino.cal.MyTasks.insert;
    var ww = this.containing_window;
    var start_date737 = new Lino.DateField({ "selectOnFocus": true });
    var summary738 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp739 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date737, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(cal.MyTasks.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "summary", "editable": true, "editor": summary738, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.MyTasks.summary) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.MyTasks.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.cal.MyTasks.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyTasks.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyTasks.insertPanel = Ext.extend(Lino.cal.Tasks.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/MyTasks",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyTasks.detail;
    this.ls_insert_handler = Lino.cal.MyTasks.insert;
    Lino.cal.MyTasks.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyTasks.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyTasks.insertPanel(p);
});
Lino.cal.MyTasks.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyTasks.detailPanel = Ext.extend(Lino.cal.Tasks.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/MyTasks",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyTasks.detail;
    this.ls_insert_handler = Lino.cal.MyTasks.insert;
    Lino.cal.MyTasks.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyTasks.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyTasks.detailPanel(p);
});
Lino.cal.MyTasks.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Tasks.ParamsPanel({});
  return new Lino.cal.MyTasks.GridPanel(p);
});
Lino.cal.MyTasks.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyTasks", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.GuestRoles
Lino.cal.GuestRoles.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 7,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/GuestRoles",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/GuestRoles','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestRoles','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestRoles','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestRoles','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/GuestRoles','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Gastrollen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 26,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestRoles.detail;
    var ww = this.containing_window;
    var id10352 = new Ext.form.NumberField({ "selectOnFocus": true });
    var name10353 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10354 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10355 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var mobile_item_disp10356 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10357 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10358 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10352, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.GuestRoles.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name10353, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(cal.GuestRoles.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de10354, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(cal.GuestRoles.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr10355, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(cal.GuestRoles.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.GuestRoles.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.GuestRoles.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.GuestRoles.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.cal.GuestRoles.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestRoles.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestRoles", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestRoles", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestRoles", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestRoles", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestRoles", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestRoles", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestRoles", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestRoles", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestRoles.detailPanel = Ext.extend(Lino.cal.GuestRoles.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/GuestRoles",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestRoles.detail;
    Lino.cal.GuestRoles.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestRoles.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.GuestRoles.detailPanel(p);
});
Lino.cal.GuestRoles.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestRoles", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.GuestRoles.GridPanel(p);
});
Lino.cal.GuestRoles.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestRoles", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.Guests
Lino.cal.Guests.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 14,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/Guests",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/Guests','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Guests','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Guests','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Guests','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/Guests','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Anwesenheiten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "partner" }, 'partnerHidden', { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "remark" }, { "name": "event" }, 'eventHidden', { "name": "id", "type": "int" }, { "name": "state" }, 'stateHidden', { "name": "event_summary" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Guests.detail;
    this.ls_insert_handler = Lino.cal.Guests.insert;
    var ww = this.containing_window;
    var partner4495 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Person ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/partner" }) }) });
    var role4496 = new Lino.RemoteComboFieldElement({ "emptyText": "Gastrolle ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/role" }) }) });
    var workflow_buttons_disp4497 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark4498 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event4499 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Kalendereintrag ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/event" }) }) });
    var id4500 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state4501 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.GuestStates });
    var event_summary_disp4502 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4503 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4504 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "partner", "editable": true, "editor": partner4495, "filter": { "type": "string" }, "header": "Person", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(cal.Guests.partner) The partner to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "role", "editable": true, "editor": role4496, "filter": { "type": "string" }, "header": "Rolle", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.Guests.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.Guests.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark4498, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(cal.Guests.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "event", "editable": true, "editor": event4499, "filter": { "type": "string" }, "header": "Kalendereintrag", "renderer": Lino.fk_renderer('eventHidden','Lino.cal.OneEvent.detail'), "sortable": false, "tooltip": "(cal.Guests.event) The calendar event to which this presence applies.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4500, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.Guests.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "state", "editable": true, "editor": state4501, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.Guests.state) The state of this presence.", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "event_summary", "editable": false, "header": "Veranstaltung", "hidden": true, "sortable": false, "tooltip": "(cal.Guests.event_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Guests.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Guests.overview) ", "width": Lino.chars2width(31) } ];
    Lino.cal.Guests.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Guests.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.Guests.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/Guests",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Guests.detail;
    this.ls_insert_handler = Lino.cal.Guests.insert;
    Lino.cal.Guests.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Guests.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.Guests.insertPanel(p);
});
Lino.cal.Guests.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.Guests.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/Guests",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Guests.detail;
    this.ls_insert_handler = Lino.cal.Guests.insert;
    Lino.cal.Guests.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Guests.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.Guests.detailPanel(p);
});
Lino.cal.Guests.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.Guests.GridPanel(p);
});
Lino.cal.Guests.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Guests", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.AllGuests
Lino.cal.AllGuests.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 14,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/AllGuests",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/AllGuests','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/AllGuests','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/AllGuests','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/AllGuests','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/AllGuests','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Anwesenheiten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "partner" }, 'partnerHidden', { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "remark" }, { "name": "event" }, 'eventHidden', { "name": "id", "type": "int" }, { "name": "state" }, 'stateHidden', { "name": "event_summary" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllGuests.detail;
    this.ls_insert_handler = Lino.cal.AllGuests.insert;
    var ww = this.containing_window;
    var partner10360 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Person ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllGuests/partner" }) }) });
    var role10361 = new Lino.RemoteComboFieldElement({ "emptyText": "Gastrolle ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllGuests/role" }) }) });
    var workflow_buttons_disp10362 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark10363 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event10364 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Kalendereintrag ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllGuests/event" }) }) });
    var id10365 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state10366 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.GuestStates });
    var event_summary_disp10367 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp10368 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10369 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "partner", "editable": true, "editor": partner10360, "filter": { "type": "string" }, "header": "Person", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(cal.AllGuests.partner) The partner to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "role", "editable": true, "editor": role10361, "filter": { "type": "string" }, "header": "Rolle", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.AllGuests.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.AllGuests.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark10363, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(cal.AllGuests.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "event", "editable": true, "editor": event10364, "filter": { "type": "string" }, "header": "Kalendereintrag", "renderer": Lino.fk_renderer('eventHidden','Lino.cal.OneEvent.detail'), "sortable": false, "tooltip": "(cal.AllGuests.event) The calendar event to which this presence applies.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id10365, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.AllGuests.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "state", "editable": true, "editor": state10366, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.AllGuests.state) The state of this presence.", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "event_summary", "editable": false, "header": "Veranstaltung", "hidden": true, "sortable": false, "tooltip": "(cal.AllGuests.event_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.AllGuests.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.AllGuests.overview) ", "width": Lino.chars2width(31) } ];
    Lino.cal.AllGuests.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllGuests.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.AllGuests.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/AllGuests",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllGuests.detail;
    this.ls_insert_handler = Lino.cal.AllGuests.insert;
    Lino.cal.AllGuests.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllGuests.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.AllGuests.insertPanel(p);
});
Lino.cal.AllGuests.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.AllGuests.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/AllGuests",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllGuests.detail;
    this.ls_insert_handler = Lino.cal.AllGuests.insert;
    Lino.cal.AllGuests.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllGuests.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.AllGuests.detailPanel(p);
});
Lino.cal.AllGuests.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.AllGuests.GridPanel(p);
});
Lino.cal.AllGuests.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllGuests", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyPresences
Lino.cal.MyPresences.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 16,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyPresences",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyPresences','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyPresences','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyPresences','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyPresences','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyPresences','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Meine Anwesenheiten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "event__start_date", "type": "date" }, { "name": "event__start_time" }, { "name": "event_summary" }, { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "remark" }, { "name": "id", "type": "int" }, { "name": "event" }, 'eventHidden', { "name": "partner" }, 'partnerHidden', { "name": "state" }, 'stateHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyPresences.detail;
    this.ls_insert_handler = Lino.cal.MyPresences.insert;
    var ww = this.containing_window;
    var event__start_date4506 = new Lino.DateField({ "disabled": true, "sortable": false });
    var event__start_time4507 = new Lino.TimeField({ "disabled": true, "sortable": false });
    var event_summary_disp4508 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var role4509 = new Lino.RemoteComboFieldElement({ "emptyText": "Gastrolle ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyPresences/role" }) }) });
    var workflow_buttons_disp4510 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark4511 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id4512 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var event4513 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Kalendereintrag ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyPresences/event" }) }) });
    var partner4514 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyPresences/partner" }) }) });
    var state4515 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.GuestStates });
    var mobile_item_disp4516 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4517 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "event__start_date", "editable": false, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(cal.MyPresences.event__start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "event__start_time", "editable": false, "header": "Start time", "sortable": true, "tooltip": "(cal.MyPresences.event__start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_summary", "editable": false, "header": "Veranstaltung", "sortable": false, "tooltip": "(cal.MyPresences.event_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "role", "editable": true, "editor": role4509, "filter": { "type": "string" }, "header": "Rolle", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.MyPresences.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.MyPresences.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark4511, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(cal.MyPresences.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id4512, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyPresences.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "event", "editable": true, "editor": event4513, "filter": { "type": "string" }, "header": "Kalendereintrag", "hidden": true, "renderer": Lino.fk_renderer('eventHidden','Lino.cal.OneEvent.detail'), "sortable": false, "tooltip": "(cal.MyPresences.event) The calendar event to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "partner", "editable": true, "editor": partner4514, "filter": { "type": "string" }, "header": "Person", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(cal.MyPresences.partner) The partner to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "state", "editable": true, "editor": state4515, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.MyPresences.state) The state of this presence.", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyPresences.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyPresences.overview) ", "width": Lino.chars2width(31) } ];
    Lino.cal.MyPresences.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyPresences.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyPresences.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/MyPresences",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyPresences.detail;
    this.ls_insert_handler = Lino.cal.MyPresences.insert;
    Lino.cal.MyPresences.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyPresences.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyPresences.insertPanel(p);
});
Lino.cal.MyPresences.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyPresences.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/MyPresences",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyPresences.detail;
    this.ls_insert_handler = Lino.cal.MyPresences.insert;
    Lino.cal.MyPresences.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyPresences.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyPresences.detailPanel(p);
});
Lino.cal.MyPresences.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.MyPresences.GridPanel(p);
});
Lino.cal.MyPresences.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPresences", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyPendingPresences
Lino.cal.MyPendingPresences.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 6,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyPendingPresences",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyPendingPresences','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyPendingPresences','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyPendingPresences','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyPendingPresences','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyPendingPresences','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "My pending invitations",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "event__when_text" }, { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "remark" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyPendingPresences.detail;
    this.ls_insert_handler = Lino.cal.MyPendingPresences.insert;
    var ww = this.containing_window;
    var event__when_text_disp4519 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "sortable": false, "value": "<br/>" });
    var role4520 = new Lino.RemoteComboFieldElement({ "emptyText": "Gastrolle ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyPendingPresences/role" }) }) });
    var workflow_buttons_disp4521 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark4522 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "event__when_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(cal.MyPendingPresences.event__when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "role", "editable": true, "editor": role4520, "filter": { "type": "string" }, "header": "Rolle", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.MyPendingPresences.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.MyPendingPresences.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark4522, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(cal.MyPendingPresences.remark) ", "width": Lino.chars2width(22) } ];
    Lino.cal.MyPendingPresences.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyPendingPresences.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyPendingPresences.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/MyPendingPresences",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyPendingPresences.detail;
    this.ls_insert_handler = Lino.cal.MyPendingPresences.insert;
    Lino.cal.MyPendingPresences.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyPendingPresences.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyPendingPresences.insertPanel(p);
});
Lino.cal.MyPendingPresences.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyPendingPresences.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/MyPendingPresences",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyPendingPresences.detail;
    this.ls_insert_handler = Lino.cal.MyPendingPresences.insert;
    Lino.cal.MyPendingPresences.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyPendingPresences.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyPendingPresences.detailPanel(p);
});
Lino.cal.MyPendingPresences.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.MyPendingPresences.GridPanel(p);
});
Lino.cal.MyPendingPresences.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyPendingPresences", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyGuests
Lino.cal.MyGuests.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 16,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyGuests",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyGuests','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyGuests','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyGuests','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyGuests','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyGuests','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Meine G\u00e4ste",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "event__start_date", "type": "date" }, { "name": "event__start_time" }, { "name": "event_summary" }, { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "remark" }, { "name": "id", "type": "int" }, { "name": "event" }, 'eventHidden', { "name": "partner" }, 'partnerHidden', { "name": "state" }, 'stateHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyGuests.detail;
    this.ls_insert_handler = Lino.cal.MyGuests.insert;
    var ww = this.containing_window;
    var event__start_date4524 = new Lino.DateField({ "disabled": true, "sortable": false });
    var event__start_time4525 = new Lino.TimeField({ "disabled": true, "sortable": false });
    var event_summary_disp4526 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var role4527 = new Lino.RemoteComboFieldElement({ "emptyText": "Gastrolle ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyGuests/role" }) }) });
    var workflow_buttons_disp4528 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark4529 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id4530 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var event4531 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Kalendereintrag ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyGuests/event" }) }) });
    var partner4532 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyGuests/partner" }) }) });
    var state4533 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.GuestStates });
    var mobile_item_disp4534 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4535 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "event__start_date", "editable": false, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(cal.MyGuests.event__start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "event__start_time", "editable": false, "header": "Start time", "sortable": true, "tooltip": "(cal.MyGuests.event__start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_summary", "editable": false, "header": "Veranstaltung", "sortable": false, "tooltip": "(cal.MyGuests.event_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "role", "editable": true, "editor": role4527, "filter": { "type": "string" }, "header": "Rolle", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.MyGuests.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.MyGuests.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark4529, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(cal.MyGuests.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id4530, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyGuests.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "event", "editable": true, "editor": event4531, "filter": { "type": "string" }, "header": "Kalendereintrag", "hidden": true, "renderer": Lino.fk_renderer('eventHidden','Lino.cal.OneEvent.detail'), "sortable": false, "tooltip": "(cal.MyGuests.event) The calendar event to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "partner", "editable": true, "editor": partner4532, "filter": { "type": "string" }, "header": "Person", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(cal.MyGuests.partner) The partner to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "state", "editable": true, "editor": state4533, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.MyGuests.state) The state of this presence.", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyGuests.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyGuests.overview) ", "width": Lino.chars2width(31) } ];
    Lino.cal.MyGuests.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyGuests.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyGuests.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/MyGuests",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyGuests.detail;
    this.ls_insert_handler = Lino.cal.MyGuests.insert;
    Lino.cal.MyGuests.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyGuests.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyGuests.insertPanel(p);
});
Lino.cal.MyGuests.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyGuests.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/MyGuests",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyGuests.detail;
    this.ls_insert_handler = Lino.cal.MyGuests.insert;
    Lino.cal.MyGuests.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyGuests.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyGuests.detailPanel(p);
});
Lino.cal.MyGuests.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.MyGuests.GridPanel(p);
});
Lino.cal.MyGuests.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyGuests", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.EventTypes
Lino.cal.EventTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 21,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/EventTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/EventTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EventTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EventTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EventTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/EventTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Kalendereintragsarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "attach_to_email", "type": "boolean" }, { "name": "email_template" }, { "name": "description" }, { "name": "is_appointment", "type": "boolean" }, { "name": "all_rooms", "type": "boolean" }, { "name": "locks_user", "type": "boolean" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "event_label" }, { "name": "event_label_de" }, { "name": "event_label_fr" }, { "name": "max_conflicting", "type": "int", "useNull": true }, { "name": "max_days", "type": "int", "useNull": true }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "move_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 22,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EventTypes.detail;
    this.ls_insert_handler = Lino.cal.EventTypes.insert;
    var ww = this.containing_window;
    var name10371 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10372 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10373 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id10374 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var seqno10375 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var attach_to_email10376 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var email_template10377 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EventTypes/email_template" }) }) });
    var description10378 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var is_appointment10379 = new Ext.form.Checkbox({ "checked": true, "hidden": true, "selectOnFocus": true });
    var all_rooms10380 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var locks_user10381 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var start_date10382 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var event_label10383 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var event_label_de10384 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var event_label_fr10385 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var max_conflicting10386 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 1 });
    var max_days10387 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 1 });
    var mobile_item_disp10388 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10389 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10390 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp10391 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name10371, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(cal.EventTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de10372, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(cal.EventTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr10373, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(cal.EventTypes.name_fr) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id10374, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.EventTypes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "seqno", "editable": true, "editor": seqno10375, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.EventTypes.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "attach_to_email", "editable": true, "filter": { "type": "boolean" }, "header": "als Anhang per E-Mail", "hidden": true, "sortable": false, "tooltip": "(cal.EventTypes.attach_to_email) Whether the printable file should be attached to the email\nwhen creating an email from a mailable of this type.\n", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 6, "dataIndex": "email_template", "editable": true, "editor": email_template10377, "filter": { "type": "string" }, "header": "E-Mail-Vorlage", "hidden": true, "sortable": false, "tooltip": "(cal.EventTypes.email_template) The name of the file to be used as template when creating an email from a mailable of this type.", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "description", "editable": true, "editor": description10378, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EventTypes.description) ", "width": Lino.chars2width(61) }, { "colIndex": 8, "dataIndex": "is_appointment", "editable": true, "filter": { "type": "boolean" }, "header": "Termin", "hidden": true, "sortable": false, "tooltip": "(cal.EventTypes.is_appointment) Whether entries of this type should be considered\n\"appointments\" (i.e. whose time and place have been agreed\nupon with other users or external parties).", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 9, "dataIndex": "all_rooms", "editable": true, "filter": { "type": "boolean" }, "header": "Blockiert alle R\u00e4ume", "hidden": true, "sortable": false, "tooltip": "(cal.EventTypes.all_rooms) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 10, "dataIndex": "locks_user", "editable": true, "filter": { "type": "boolean" }, "header": "Blockiert den Autor", "hidden": true, "sortable": false, "tooltip": "(cal.EventTypes.locks_user) Whether calendar entries of this type make the user\nunavailable for other locking events at the same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 11, "dataIndex": "start_date", "editable": true, "editor": start_date10382, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.EventTypes.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 12, "dataIndex": "event_label", "editable": true, "editor": event_label10383, "filter": { "type": "string" }, "header": "Bezeichnung Termin", "hidden": true, "sortable": true, "tooltip": "(cal.EventTypes.event_label) Default text for summary of new entries.", "width": Lino.chars2width(22) }, { "colIndex": 13, "dataIndex": "event_label_de", "editable": true, "editor": event_label_de10384, "filter": { "type": "string" }, "header": "Bezeichnung Termin (de)", "hidden": true, "sortable": true, "tooltip": "(cal.EventTypes.event_label_de) ", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "event_label_fr", "editable": true, "editor": event_label_fr10385, "filter": { "type": "string" }, "header": "Bezeichnung Termin (fr)", "hidden": true, "sortable": true, "tooltip": "(cal.EventTypes.event_label_fr) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 15, "dataIndex": "max_conflicting", "editable": true, "editor": max_conflicting10386, "filter": { "type": "numeric" }, "format": "0", "header": "Gleichzeitige Termine", "hidden": true, "sortable": true, "tooltip": "(cal.EventTypes.max_conflicting) How many conflicting events should be tolerated.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 16, "dataIndex": "max_days", "editable": true, "editor": max_days10387, "filter": { "type": "numeric" }, "format": "0", "header": "Tage maximal", "hidden": true, "sortable": true, "tooltip": "(cal.EventTypes.max_days) The maximal number of days allowed as duration.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 17, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EventTypes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EventTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.EventTypes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(cal.EventTypes.move_buttons) ", "width": Lino.chars2width(6) } ];
    Lino.cal.EventTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EventTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventTypes.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventTypes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EventTypes.insertPanel = Ext.extend(Lino.cal.EventTypes.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/EventTypes",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EventTypes.detail;
    this.ls_insert_handler = Lino.cal.EventTypes.insert;
    Lino.cal.EventTypes.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EventTypes.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.EventTypes.insertPanel(p);
});
Lino.cal.EventTypes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventTypes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventTypes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventTypes.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventTypes", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EventTypes.detailPanel = Ext.extend(Lino.cal.EventTypes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/cal/EventTypes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EventTypes.detail;
    this.ls_insert_handler = Lino.cal.EventTypes.insert;
    Lino.cal.EventTypes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EventTypes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.EventTypes.detailPanel(p);
});
Lino.cal.EventTypes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.EventTypes.GridPanel(p);
});
Lino.cal.EventTypes.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventTypes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventTypes.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventTypes", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventTypes.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventTypes", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.RecurrentEvents
Lino.cal.RecurrentEvents.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 31,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/RecurrentEvents",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/RecurrentEvents','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/RecurrentEvents','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/RecurrentEvents','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/RecurrentEvents','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/RecurrentEvents','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Regelm\u00e4\u00dfige Ereignisse",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "every_unit" }, 'every_unitHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "id", "type": "int" }, { "name": "start_time" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "name": "description" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 21,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.RecurrentEvents.detail;
    this.ls_insert_handler = Lino.cal.RecurrentEvents.insert;
    var ww = this.containing_window;
    var start_date10393 = new Lino.DateField({ "selectOnFocus": true });
    var end_date10394 = new Lino.DateField({ "selectOnFocus": true });
    var name10395 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10396 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10397 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var every_unit10398 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.cal.Recurrencies });
    var event_type10399 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/RecurrentEvents/event_type" }) }) });
    var id10400 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_time10401 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_time10402 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user10403 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/RecurrentEvents/user" }) }) });
    var every10404 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 1 });
    var monday10405 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday10406 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday10407 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday10408 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday10409 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday10410 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday10411 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events10412 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var description10413 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10414 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10415 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10416 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp10417 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp10418 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp10419 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration10420 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date10393, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(cal.RecurrentEvents.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "end_date", "editable": true, "editor": end_date10394, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "sortable": true, "tooltip": "(cal.RecurrentEvents.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "name", "editable": true, "editor": name10395, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(cal.RecurrentEvents.name) See lino.utils.mldbc.mixins.BabelNamed.name.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_de", "editable": true, "editor": name_de10396, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(cal.RecurrentEvents.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "name_fr", "editable": true, "editor": name_fr10397, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(cal.RecurrentEvents.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "every_unit", "editable": true, "editor": every_unit10398, "filter": { "type": "string" }, "header": "Wiederholung", "sortable": false, "tooltip": "(cal.RecurrentEvents.every_unit) Inherited from RecurrentSet.every_unit.", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "event_type", "editable": true, "editor": event_type10399, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.RecurrentEvents.event_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id10400, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.RecurrentEvents.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time10401, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.RecurrentEvents.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_time", "editable": true, "editor": end_time10402, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(cal.RecurrentEvents.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "user", "editable": true, "editor": user10403, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.RecurrentEvents.user) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 11, "dataIndex": "every", "editable": true, "editor": every10404, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(cal.RecurrentEvents.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "max_events", "editable": true, "editor": max_events10412, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(cal.RecurrentEvents.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "description", "editable": true, "editor": description10413, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.description) ", "width": Lino.chars2width(61) }, { "colIndex": 21, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 24, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 25, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 27, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.RecurrentEvents.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.RecurrentEvents.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.RecurrentEvents.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RecurrentEvents", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RecurrentEvents.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RecurrentEvents", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RecurrentEvents.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RecurrentEvents", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RecurrentEvents.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RecurrentEvents", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RecurrentEvents.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RecurrentEvents", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.RecurrentEvents.insertPanel = Ext.extend(Lino.cal.RecurrentEvents.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/RecurrentEvents",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.RecurrentEvents.detail;
    this.ls_insert_handler = Lino.cal.RecurrentEvents.insert;
    Lino.cal.RecurrentEvents.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.RecurrentEvents.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.RecurrentEvents.insertPanel(p);
});
Lino.cal.RecurrentEvents.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RecurrentEvents", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RecurrentEvents.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RecurrentEvents", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RecurrentEvents.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RecurrentEvents", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.RecurrentEvents.detailPanel = Ext.extend(Lino.cal.RecurrentEvents.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/RecurrentEvents",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.RecurrentEvents.detail;
    this.ls_insert_handler = Lino.cal.RecurrentEvents.insert;
    Lino.cal.RecurrentEvents.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.RecurrentEvents.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.RecurrentEvents.detailPanel(p);
});
Lino.cal.RecurrentEvents.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RecurrentEvents", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RecurrentEvents.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.RecurrentEvents.ParamsPanel({});
  return new Lino.cal.RecurrentEvents.GridPanel(p);
});
Lino.cal.RecurrentEvents.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RecurrentEvents", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.RecurrentEvents.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/RecurrentEvents", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.Events
Lino.cal.Events.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/Events",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/Events','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Events','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Events','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Events','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/Events','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Kalendereintr\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "when_text" }, { "name": "user" }, 'userHidden', { "name": "summary" }, { "name": "event_type" }, 'event_typeHidden', { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Events.detail;
    this.ls_insert_handler = Lino.cal.Events.insert;
    var ww = this.containing_window;
    var when_text_disp10422 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var user10423 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/user" }) }) });
    var summary10424 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event_type10425 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/event_type" }) }) });
    var id10426 = new Ext.form.NumberField({ "selectOnFocus": true });
    var modified10427 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created10428 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date10429 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time10430 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date10431 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time10432 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time10433 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method10434 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var assigned_to10435 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/assigned_to" }) }) });
    var owner_type10436 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/owner_type" }) }) });
    var owner_id10437 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/owner_id" }) }) });
    var description10438 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class10439 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence10440 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type10441 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent10442 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room10443 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/room" }) }) });
    var priority10444 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/priority" }) }) });
    var state10445 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp10446 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar10447 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp10448 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp10449 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day10450 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp10451 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp10452 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10453 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10454 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp10455 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration10456 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id10437.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type10436.on('change',Lino.chooser_handler(owner_id10437,'owner_type'));
      Lino.cal.Events.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(cal.Events.when_text) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user10423, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.Events.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "summary", "editable": true, "editor": summary10424, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.Events.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "event_type", "editable": true, "editor": event_type10425, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.Events.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id10426, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.Events.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.Events.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.Events.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date10429, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.Events.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time10430, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.Events.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date10431, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.Events.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time10432, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(cal.Events.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.Events.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 12, "dataIndex": "build_method", "editable": true, "editor": build_method10434, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.Events.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 13, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to10435, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.Events.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_type", "editable": true, "editor": owner_type10436, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.Events.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_id", "editable": true, "editor": owner_id10437, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.Events.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description10438, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Events.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class10439, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.Events.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence10440, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.Events.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type10441, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.Events.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.Events.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 21, "dataIndex": "room", "editable": true, "editor": room10443, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.Events.room) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "priority", "editable": true, "editor": priority10444, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.Events.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "state", "editable": true, "editor": state10445, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.Events.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 24, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(cal.Events.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 25, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.Events.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.Events.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.Events.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.Events.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 29, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.Events.url) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Events.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Events.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.Events.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.Events.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.Events.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.Events.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Events.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.Events.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/Events",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Events.detail;
    this.ls_insert_handler = Lino.cal.Events.insert;
    Lino.cal.Events.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Events.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.Events.insertPanel(p);
});
Lino.cal.Events.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.Events.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/Events",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Events.detail;
    this.ls_insert_handler = Lino.cal.Events.insert;
    Lino.cal.Events.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Events.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.Events.detailPanel(p);
});
Lino.cal.Events.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.Events.GridPanel(p);
});
Lino.cal.Events.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Events.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Events", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.AllEntries
Lino.cal.AllEntries.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/AllEntries",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/AllEntries','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/AllEntries','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/AllEntries','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/AllEntries','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/AllEntries','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Kalendereintr\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "when_text" }, { "name": "user" }, 'userHidden', { "name": "summary" }, { "name": "event_type" }, 'event_typeHidden', { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllEntries.detail;
    this.ls_insert_handler = Lino.cal.AllEntries.insert;
    var ww = this.containing_window;
    var when_text_disp10458 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var user10459 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/user" }) }) });
    var summary10460 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event_type10461 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/event_type" }) }) });
    var id10462 = new Ext.form.NumberField({ "selectOnFocus": true });
    var modified10463 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created10464 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date10465 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time10466 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date10467 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time10468 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time10469 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method10470 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var assigned_to10471 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/assigned_to" }) }) });
    var owner_type10472 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/owner_type" }) }) });
    var owner_id10473 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/owner_id" }) }) });
    var description10474 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class10475 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence10476 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type10477 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent10478 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room10479 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/room" }) }) });
    var priority10480 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/priority" }) }) });
    var state10481 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp10482 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar10483 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp10484 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp10485 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day10486 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp10487 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp10488 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10489 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10490 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp10491 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration10492 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id10473.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type10472.on('change',Lino.chooser_handler(owner_id10473,'owner_type'));
      Lino.cal.AllEntries.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(cal.AllEntries.when_text) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user10459, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.AllEntries.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "summary", "editable": true, "editor": summary10460, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.AllEntries.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "event_type", "editable": true, "editor": event_type10461, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.AllEntries.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id10462, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.AllEntries.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date10465, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time10466, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date10467, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time10468, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 12, "dataIndex": "build_method", "editable": true, "editor": build_method10470, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 13, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to10471, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.AllEntries.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_type", "editable": true, "editor": owner_type10472, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.AllEntries.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_id", "editable": true, "editor": owner_id10473, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description10474, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class10475, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence10476, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type10477, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 21, "dataIndex": "room", "editable": true, "editor": room10479, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.AllEntries.room) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "priority", "editable": true, "editor": priority10480, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "state", "editable": true, "editor": state10481, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 24, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 25, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.AllEntries.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 29, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.url) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.AllEntries.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllEntries.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.AllEntries.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/AllEntries",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllEntries.detail;
    this.ls_insert_handler = Lino.cal.AllEntries.insert;
    Lino.cal.AllEntries.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllEntries.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.AllEntries.insertPanel(p);
});
Lino.cal.AllEntries.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.AllEntries.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/AllEntries",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllEntries.detail;
    this.ls_insert_handler = Lino.cal.AllEntries.insert;
    Lino.cal.AllEntries.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllEntries.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.AllEntries.detailPanel(p);
});
Lino.cal.AllEntries.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.AllEntries.GridPanel(p);
});
Lino.cal.AllEntries.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AllEntries", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.EntriesByDay
Lino.cal.EntriesByDay.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/EntriesByDay",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByDay','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByDay','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByDay','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByDay','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByDay','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Termine heute",
  page_length : 20,
  stripeRows : true,
  ls_store_fields : [ { "name": "start_time" }, { "name": "end_time" }, { "name": "duration" }, { "name": "room" }, 'roomHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "summary" }, { "name": "owner" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "when_text" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "created_natural" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByDay.detail;
    this.ls_insert_handler = Lino.cal.EntriesByDay.insert;
    var ww = this.containing_window;
    var start_time4537 = new Lino.TimeField({ "selectOnFocus": true });
    var end_time4538 = new Lino.TimeField({ "selectOnFocus": true });
    var duration4539 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "maxLength": 6 });
    var room4540 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/room" }) }) });
    var event_type4541 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/event_type" }) }) });
    var summary4542 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var owner_disp4543 = new Ext.form.DisplayField({ "disabled": true });
    var workflow_buttons_disp4544 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4545 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified4546 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created4547 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date4548 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date4549 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var build_time4550 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4551 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user4552 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/user" }) }) });
    var assigned_to4553 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/assigned_to" }) }) });
    var owner_type4554 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/owner_type" }) }) });
    var owner_id4555 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/owner_id" }) }) });
    var description4556 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class4557 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence4558 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type4559 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent4560 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var priority4561 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/priority" }) }) });
    var state4562 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var calendar4563 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp4564 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp4565 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var when_text_disp4566 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day4567 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp4568 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4569 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4570 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp4571 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      owner_id4555.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4554.on('change',Lino.chooser_handler(owner_id4555,'owner_type'));
      Lino.cal.EntriesByDay.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_time", "editable": true, "editor": start_time4537, "header": "Start time", "sortable": true, "tooltip": "(cal.EntriesByDay.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "end_time", "editable": true, "editor": end_time4538, "header": "Endet um", "sortable": true, "tooltip": "(cal.EntriesByDay.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 2, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "sortable": false, "tooltip": "(cal.EntriesByDay.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 3, "dataIndex": "room", "editable": true, "editor": room4540, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.EntriesByDay.room) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "event_type", "editable": true, "editor": event_type4541, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.EntriesByDay.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "summary", "editable": true, "editor": summary4542, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.EntriesByDay.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(cal.EntriesByDay.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.EntriesByDay.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id4545, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 9, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 10, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "start_date", "editable": true, "editor": start_date4548, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 12, "dataIndex": "end_date", "editable": true, "editor": end_date4549, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 13, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 14, "dataIndex": "build_method", "editable": true, "editor": build_method4551, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 15, "dataIndex": "user", "editable": true, "editor": user4552, "filter": { "type": "string" }, "header": "Verantwortlicher", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.EntriesByDay.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to4553, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.EntriesByDay.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "owner_type", "editable": true, "editor": owner_type4554, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.EntriesByDay.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 18, "dataIndex": "owner_id", "editable": true, "editor": owner_id4555, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 19, "dataIndex": "description", "editable": true, "editor": description4556, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 20, "dataIndex": "access_class", "editable": true, "editor": access_class4557, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 21, "dataIndex": "sequence", "editable": true, "editor": sequence4558, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 22, "dataIndex": "auto_type", "editable": true, "editor": auto_type4559, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 23, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 24, "dataIndex": "priority", "editable": true, "editor": priority4561, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "state", "editable": true, "editor": state4562, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 26, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.EntriesByDay.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "when_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 31, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.url) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 34, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.created_natural) ", "width": Lino.chars2width(31) } ];
    Lino.cal.EntriesByDay.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByDay.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EntriesByDay.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/EntriesByDay",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByDay.detail;
    this.ls_insert_handler = Lino.cal.EntriesByDay.insert;
    Lino.cal.EntriesByDay.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByDay.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.EntriesByDay.insertPanel(p);
});
Lino.cal.EntriesByDay.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EntriesByDay.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/EntriesByDay",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByDay.detail;
    this.ls_insert_handler = Lino.cal.EntriesByDay.insert;
    Lino.cal.EntriesByDay.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByDay.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.EntriesByDay.detailPanel(p);
});
Lino.cal.EntriesByDay.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.EntriesByDay.GridPanel(p);
});
Lino.cal.EntriesByDay.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByDay", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.OneEvent
Lino.cal.OneEvent.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/OneEvent",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/OneEvent','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/OneEvent','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/OneEvent','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/OneEvent','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/OneEvent','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Kalendereintr\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "when_text" }, { "name": "user" }, 'userHidden', { "name": "summary" }, { "name": "event_type" }, 'event_typeHidden', { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.OneEvent.detail;
    this.ls_insert_handler = Lino.cal.OneEvent.insert;
    var ww = this.containing_window;
    var when_text_disp4573 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var user4574 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/user" }) }) });
    var summary4575 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event_type4576 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/event_type" }) }) });
    var id4577 = new Ext.form.NumberField({ "selectOnFocus": true });
    var modified4578 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created4579 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date4580 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time4581 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date4582 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time4583 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time4584 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4585 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var assigned_to4586 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/assigned_to" }) }) });
    var owner_type4587 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/owner_type" }) }) });
    var owner_id4588 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/owner_id" }) }) });
    var description4589 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class4590 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence4591 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type4592 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent4593 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room4594 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/room" }) }) });
    var priority4595 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/priority" }) }) });
    var state4596 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp4597 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar4598 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp4599 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp4600 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day4601 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp4602 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4603 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4604 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4605 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp4606 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration4607 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id4588.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4587.on('change',Lino.chooser_handler(owner_id4588,'owner_type'));
      Lino.cal.OneEvent.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(cal.OneEvent.when_text) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user4574, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.OneEvent.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "summary", "editable": true, "editor": summary4575, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.OneEvent.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "event_type", "editable": true, "editor": event_type4576, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.OneEvent.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id4577, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.OneEvent.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date4580, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time4581, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date4582, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time4583, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 12, "dataIndex": "build_method", "editable": true, "editor": build_method4585, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 13, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to4586, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.OneEvent.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_type", "editable": true, "editor": owner_type4587, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.OneEvent.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_id", "editable": true, "editor": owner_id4588, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description4589, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class4590, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence4591, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type4592, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 21, "dataIndex": "room", "editable": true, "editor": room4594, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.OneEvent.room) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "priority", "editable": true, "editor": priority4595, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "state", "editable": true, "editor": state4596, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 24, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 25, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.OneEvent.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 29, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.url) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.OneEvent.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.OneEvent.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.OneEvent.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/OneEvent",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.OneEvent.detail;
    this.ls_insert_handler = Lino.cal.OneEvent.insert;
    Lino.cal.OneEvent.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.OneEvent.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.OneEvent.insertPanel(p);
});
Lino.cal.OneEvent.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.OneEvent.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/OneEvent",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.OneEvent.detail;
    this.ls_insert_handler = Lino.cal.OneEvent.insert;
    Lino.cal.OneEvent.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.OneEvent.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.OneEvent.detailPanel(p);
});
Lino.cal.OneEvent.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.OneEvent.ParamsPanel({});
  return new Lino.cal.OneEvent.GridPanel(p);
});
Lino.cal.OneEvent.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OneEvent", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyEntriesToday
Lino.cal.MyEntriesToday.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyEntriesToday",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntriesToday','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntriesToday','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntriesToday','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntriesToday','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntriesToday','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Meine Termine heute",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "start_time" }, { "name": "end_time" }, { "name": "event_type" }, 'event_typeHidden', { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "when_text" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyEntriesToday.detail;
    this.ls_insert_handler = Lino.cal.MyEntriesToday.insert;
    var ww = this.containing_window;
    var start_time4609 = new Lino.TimeField({ "selectOnFocus": true });
    var end_time4610 = new Lino.TimeField({ "selectOnFocus": true });
    var event_type4611 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/event_type" }) }) });
    var summary4612 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp4613 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4614 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified4615 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created4616 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date4617 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date4618 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var build_time4619 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4620 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user4621 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/user" }) }) });
    var assigned_to4622 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/assigned_to" }) }) });
    var owner_type4623 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/owner_type" }) }) });
    var owner_id4624 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/owner_id" }) }) });
    var description4625 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class4626 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence4627 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type4628 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent4629 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room4630 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/room" }) }) });
    var priority4631 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/priority" }) }) });
    var state4632 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp4633 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar4634 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp4635 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp4636 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var when_text_disp4637 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day4638 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp4639 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4640 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4641 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp4642 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration4643 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id4624.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4623.on('change',Lino.chooser_handler(owner_id4624,'owner_type'));
      Lino.cal.MyEntriesToday.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_time", "editable": true, "editor": start_time4609, "header": "Start time", "sortable": true, "tooltip": "(cal.MyEntriesToday.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "end_time", "editable": true, "editor": end_time4610, "header": "Endet um", "sortable": true, "tooltip": "(cal.MyEntriesToday.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type4611, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.MyEntriesToday.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "summary", "editable": true, "editor": summary4612, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.MyEntriesToday.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.MyEntriesToday.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4614, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "start_date", "editable": true, "editor": start_date4617, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date4618, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "build_method", "editable": true, "editor": build_method4620, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 12, "dataIndex": "user", "editable": true, "editor": user4621, "filter": { "type": "string" }, "header": "Verantwortlicher", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyEntriesToday.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to4622, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyEntriesToday.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_type", "editable": true, "editor": owner_type4623, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.MyEntriesToday.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_id", "editable": true, "editor": owner_id4624, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description4625, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class4626, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence4627, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type4628, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 21, "dataIndex": "room", "editable": true, "editor": room4630, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.MyEntriesToday.room) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "priority", "editable": true, "editor": priority4631, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "state", "editable": true, "editor": state4632, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 24, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 25, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.MyEntriesToday.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "when_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 30, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.url) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.MyEntriesToday.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyEntriesToday.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyEntriesToday.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/MyEntriesToday",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyEntriesToday.detail;
    this.ls_insert_handler = Lino.cal.MyEntriesToday.insert;
    Lino.cal.MyEntriesToday.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyEntriesToday.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyEntriesToday.insertPanel(p);
});
Lino.cal.MyEntriesToday.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyEntriesToday.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/MyEntriesToday",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyEntriesToday.detail;
    this.ls_insert_handler = Lino.cal.MyEntriesToday.insert;
    Lino.cal.MyEntriesToday.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyEntriesToday.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyEntriesToday.detailPanel(p);
});
Lino.cal.MyEntriesToday.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.MyEntriesToday.GridPanel(p);
});
Lino.cal.MyEntriesToday.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntriesToday", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyAssignedEvents
Lino.cal.MyAssignedEvents.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyAssignedEvents",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyAssignedEvents','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyAssignedEvents','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyAssignedEvents','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyAssignedEvents','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyAssignedEvents','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Events assigned to me",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "summary" }, { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "event_type" }, 'event_typeHidden', { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "when_text" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyAssignedEvents.detail;
    this.ls_insert_handler = Lino.cal.MyAssignedEvents.insert;
    var ww = this.containing_window;
    var overview_disp555 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var workflow_buttons_disp556 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id557 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified558 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created559 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date560 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time561 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date562 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time563 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time564 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method565 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user566 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/user" }) }) });
    var assigned_to567 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/assigned_to" }) }) });
    var owner_type568 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/owner_type" }) }) });
    var owner_id569 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/owner_id" }) }) });
    var summary570 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var description571 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class572 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence573 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type574 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var event_type575 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/event_type" }) }) });
    var transparent576 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room577 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/room" }) }) });
    var priority578 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/priority" }) }) });
    var state579 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp580 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar581 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp582 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp583 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var when_text_disp584 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day585 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp586 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp587 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp588 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration589 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id569.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type568.on('change',Lino.chooser_handler(owner_id569,'owner_type'));
      Lino.cal.MyAssignedEvents.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(cal.MyAssignedEvents.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.MyAssignedEvents.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id557, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 4, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 5, "dataIndex": "start_date", "editable": true, "editor": start_date560, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "start_time", "editable": true, "editor": start_time561, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 7, "dataIndex": "end_date", "editable": true, "editor": end_date562, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "end_time", "editable": true, "editor": end_time563, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 10, "dataIndex": "build_method", "editable": true, "editor": build_method565, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user566, "filter": { "type": "string" }, "header": "Verantwortlicher", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyAssignedEvents.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to567, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyAssignedEvents.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "owner_type", "editable": true, "editor": owner_type568, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.MyAssignedEvents.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_id", "editable": true, "editor": owner_id569, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 15, "dataIndex": "summary", "editable": true, "editor": summary570, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description571, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class572, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence573, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type574, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "event_type", "editable": true, "editor": event_type575, "filter": { "type": "string" }, "header": "Kalendereintragsart", "hidden": true, "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.MyAssignedEvents.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 22, "dataIndex": "room", "editable": true, "editor": room577, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.MyAssignedEvents.room) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "priority", "editable": true, "editor": priority578, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "state", "editable": true, "editor": state579, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 25, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 26, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.MyAssignedEvents.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "when_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 31, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.url) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.MyAssignedEvents.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyAssignedEvents.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyAssignedEvents.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/MyAssignedEvents",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyAssignedEvents.detail;
    this.ls_insert_handler = Lino.cal.MyAssignedEvents.insert;
    Lino.cal.MyAssignedEvents.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyAssignedEvents.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyAssignedEvents.insertPanel(p);
});
Lino.cal.MyAssignedEvents.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyAssignedEvents.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/MyAssignedEvents",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyAssignedEvents.detail;
    this.ls_insert_handler = Lino.cal.MyAssignedEvents.insert;
    Lino.cal.MyAssignedEvents.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyAssignedEvents.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyAssignedEvents.detailPanel(p);
});
Lino.cal.MyAssignedEvents.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.MyAssignedEvents.GridPanel(p);
});
Lino.cal.MyAssignedEvents.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyAssignedEvents", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.OverdueAppointments
Lino.cal.OverdueAppointments.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/OverdueAppointments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/OverdueAppointments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/OverdueAppointments','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/OverdueAppointments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/OverdueAppointments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/OverdueAppointments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "\u00dcberf\u00e4llige Termine",
  page_length : 20,
  stripeRows : true,
  ls_store_fields : [ { "name": "when_text" }, { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "event_type" }, 'event_typeHidden', { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.OverdueAppointments.detail;
    this.ls_insert_handler = Lino.cal.OverdueAppointments.insert;
    var ww = this.containing_window;
    var when_text_disp10494 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var user10495 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OverdueAppointments/user" }) }) });
    var owner_disp10496 = new Ext.form.DisplayField({ "disabled": true });
    var event_type10497 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OverdueAppointments/event_type" }) }) });
    var summary10498 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp10499 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id10500 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified10501 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created10502 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date10503 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time10504 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date10505 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time10506 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time10507 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method10508 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var assigned_to10509 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OverdueAppointments/assigned_to" }) }) });
    var owner_type10510 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OverdueAppointments/owner_type" }) }) });
    var owner_id10511 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OverdueAppointments/owner_id" }) }) });
    var description10512 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class10513 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence10514 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type10515 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent10516 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room10517 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OverdueAppointments/room" }) }) });
    var priority10518 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OverdueAppointments/priority" }) }) });
    var state10519 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var calendar10520 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp10521 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp10522 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day10523 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp10524 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp10525 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10526 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp10527 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration10528 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id10511.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type10510.on('change',Lino.chooser_handler(owner_id10511,'owner_type'));
      Lino.cal.OverdueAppointments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(cal.OverdueAppointments.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user10495, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.OverdueAppointments.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(cal.OverdueAppointments.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 3, "dataIndex": "event_type", "editable": true, "editor": event_type10497, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.OverdueAppointments.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "summary", "editable": true, "editor": summary10498, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.OverdueAppointments.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.OverdueAppointments.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id10500, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.OverdueAppointments.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.OverdueAppointments.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.OverdueAppointments.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 9, "dataIndex": "start_date", "editable": true, "editor": start_date10503, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.OverdueAppointments.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "start_time", "editable": true, "editor": start_time10504, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.OverdueAppointments.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "end_date", "editable": true, "editor": end_date10505, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.OverdueAppointments.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 12, "dataIndex": "end_time", "editable": true, "editor": end_time10506, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(cal.OverdueAppointments.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 13, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.OverdueAppointments.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 14, "dataIndex": "build_method", "editable": true, "editor": build_method10508, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 15, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to10509, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.OverdueAppointments.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "owner_type", "editable": true, "editor": owner_type10510, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.OverdueAppointments.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "owner_id", "editable": true, "editor": owner_id10511, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 18, "dataIndex": "description", "editable": true, "editor": description10512, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 19, "dataIndex": "access_class", "editable": true, "editor": access_class10513, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 20, "dataIndex": "sequence", "editable": true, "editor": sequence10514, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.OverdueAppointments.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 21, "dataIndex": "auto_type", "editable": true, "editor": auto_type10515, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.OverdueAppointments.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 22, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 23, "dataIndex": "room", "editable": true, "editor": room10517, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.OverdueAppointments.room) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "priority", "editable": true, "editor": priority10518, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "state", "editable": true, "editor": state10519, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 26, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.OverdueAppointments.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 30, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.url) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.OverdueAppointments.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.OverdueAppointments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.OverdueAppointments.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.OverdueAppointments.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/OverdueAppointments",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.OverdueAppointments.detail;
    this.ls_insert_handler = Lino.cal.OverdueAppointments.insert;
    Lino.cal.OverdueAppointments.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.OverdueAppointments.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.OverdueAppointments.insertPanel(p);
});
Lino.cal.OverdueAppointments.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.OverdueAppointments.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/OverdueAppointments",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.OverdueAppointments.detail;
    this.ls_insert_handler = Lino.cal.OverdueAppointments.insert;
    Lino.cal.OverdueAppointments.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.OverdueAppointments.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.OverdueAppointments.detailPanel(p);
});
Lino.cal.OverdueAppointments.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.OverdueAppointments.GridPanel(p);
});
Lino.cal.OverdueAppointments.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OverdueAppointments.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/OverdueAppointments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyOverdueAppointments
Lino.cal.MyOverdueAppointments.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyOverdueAppointments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyOverdueAppointments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyOverdueAppointments','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyOverdueAppointments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyOverdueAppointments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyOverdueAppointments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Meine \u00fcberf\u00e4lligen Termine",
  page_length : 20,
  stripeRows : true,
  ls_store_fields : [ { "name": "overview" }, { "name": "owner" }, { "name": "event_type" }, 'event_typeHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "summary" }, { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "when_text" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyOverdueAppointments.detail;
    this.ls_insert_handler = Lino.cal.MyOverdueAppointments.insert;
    var ww = this.containing_window;
    var overview_disp805 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var owner_disp806 = new Ext.form.DisplayField({ "disabled": true });
    var event_type807 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/event_type" }) }) });
    var workflow_buttons_disp808 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id809 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified810 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created811 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date812 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time813 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date814 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time815 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time816 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method817 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user818 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/user" }) }) });
    var assigned_to819 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/assigned_to" }) }) });
    var owner_type820 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/owner_type" }) }) });
    var owner_id821 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/owner_id" }) }) });
    var summary822 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var description823 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class824 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence825 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type826 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent827 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room828 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/room" }) }) });
    var priority829 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/priority" }) }) });
    var state830 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var calendar831 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp832 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp833 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var when_text_disp834 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day835 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp836 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp837 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp838 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration839 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id821.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type820.on('change',Lino.chooser_handler(owner_id821,'owner_type'));
      Lino.cal.MyOverdueAppointments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(cal.MyOverdueAppointments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(cal.MyOverdueAppointments.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type807, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.MyOverdueAppointments.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.MyOverdueAppointments.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id809, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date812, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time813, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date814, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time815, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 12, "dataIndex": "build_method", "editable": true, "editor": build_method817, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 13, "dataIndex": "user", "editable": true, "editor": user818, "filter": { "type": "string" }, "header": "Verantwortlicher", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyOverdueAppointments.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to819, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyOverdueAppointments.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_type", "editable": true, "editor": owner_type820, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.MyOverdueAppointments.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "owner_id", "editable": true, "editor": owner_id821, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 17, "dataIndex": "summary", "editable": true, "editor": summary822, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 18, "dataIndex": "description", "editable": true, "editor": description823, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 19, "dataIndex": "access_class", "editable": true, "editor": access_class824, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 20, "dataIndex": "sequence", "editable": true, "editor": sequence825, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 21, "dataIndex": "auto_type", "editable": true, "editor": auto_type826, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 22, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 23, "dataIndex": "room", "editable": true, "editor": room828, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.MyOverdueAppointments.room) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "priority", "editable": true, "editor": priority829, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "state", "editable": true, "editor": state830, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 26, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.MyOverdueAppointments.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "when_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 31, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.url) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.MyOverdueAppointments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyOverdueAppointments.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyOverdueAppointments.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/MyOverdueAppointments",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyOverdueAppointments.detail;
    this.ls_insert_handler = Lino.cal.MyOverdueAppointments.insert;
    Lino.cal.MyOverdueAppointments.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyOverdueAppointments.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyOverdueAppointments.insertPanel(p);
});
Lino.cal.MyOverdueAppointments.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyOverdueAppointments.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/MyOverdueAppointments",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyOverdueAppointments.detail;
    this.ls_insert_handler = Lino.cal.MyOverdueAppointments.insert;
    Lino.cal.MyOverdueAppointments.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyOverdueAppointments.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyOverdueAppointments.detailPanel(p);
});
Lino.cal.MyOverdueAppointments.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.MyOverdueAppointments.GridPanel(p);
});
Lino.cal.MyOverdueAppointments.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyOverdueAppointments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyUnconfirmedAppointments
Lino.cal.MyUnconfirmedAppointments.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyUnconfirmedAppointments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyUnconfirmedAppointments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyUnconfirmedAppointments','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyUnconfirmedAppointments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyUnconfirmedAppointments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyUnconfirmedAppointments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Unbest\u00e4tigte Termine",
  page_length : 20,
  stripeRows : true,
  ls_store_fields : [ { "name": "when_text" }, { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "event_type" }, 'event_typeHidden', { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyUnconfirmedAppointments.detail;
    this.ls_insert_handler = Lino.cal.MyUnconfirmedAppointments.insert;
    var ww = this.containing_window;
    var when_text_disp4645 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var summary4646 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp4647 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4648 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified4649 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created4650 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date4651 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time4652 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date4653 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time4654 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time4655 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4656 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user4657 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/user" }) }) });
    var assigned_to4658 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/assigned_to" }) }) });
    var owner_type4659 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/owner_type" }) }) });
    var owner_id4660 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/owner_id" }) }) });
    var description4661 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class4662 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence4663 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type4664 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var event_type4665 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/event_type" }) }) });
    var transparent4666 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room4667 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/room" }) }) });
    var priority4668 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/priority" }) }) });
    var state4669 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp4670 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar4671 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp4672 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp4673 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day4674 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp4675 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4676 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4677 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp4678 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration4679 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id4660.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4659.on('change',Lino.chooser_handler(owner_id4660,'owner_type'));
      Lino.cal.MyUnconfirmedAppointments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "summary", "editable": true, "editor": summary4646, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id4648, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 5, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "start_date", "editable": true, "editor": start_date4651, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "start_time", "editable": true, "editor": start_time4652, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 8, "dataIndex": "end_date", "editable": true, "editor": end_date4653, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "end_time", "editable": true, "editor": end_time4654, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "build_method", "editable": true, "editor": build_method4656, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 12, "dataIndex": "user", "editable": true, "editor": user4657, "filter": { "type": "string" }, "header": "Verantwortlicher", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to4658, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_type", "editable": true, "editor": owner_type4659, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_id", "editable": true, "editor": owner_id4660, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description4661, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class4662, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence4663, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type4664, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "event_type", "editable": true, "editor": event_type4665, "filter": { "type": "string" }, "header": "Kalendereintragsart", "hidden": true, "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 22, "dataIndex": "room", "editable": true, "editor": room4667, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.room) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "priority", "editable": true, "editor": priority4668, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "state", "editable": true, "editor": state4669, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 25, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 26, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 30, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.url) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.MyUnconfirmedAppointments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyUnconfirmedAppointments.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyUnconfirmedAppointments.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/MyUnconfirmedAppointments",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyUnconfirmedAppointments.detail;
    this.ls_insert_handler = Lino.cal.MyUnconfirmedAppointments.insert;
    Lino.cal.MyUnconfirmedAppointments.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyUnconfirmedAppointments.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyUnconfirmedAppointments.insertPanel(p);
});
Lino.cal.MyUnconfirmedAppointments.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyUnconfirmedAppointments.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/MyUnconfirmedAppointments",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyUnconfirmedAppointments.detail;
    this.ls_insert_handler = Lino.cal.MyUnconfirmedAppointments.insert;
    Lino.cal.MyUnconfirmedAppointments.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyUnconfirmedAppointments.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyUnconfirmedAppointments.detailPanel(p);
});
Lino.cal.MyUnconfirmedAppointments.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.MyUnconfirmedAppointments.GridPanel(p);
});
Lino.cal.MyUnconfirmedAppointments.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyUnconfirmedAppointments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.EventPolicies
Lino.cal.EventPolicies.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 28,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/EventPolicies",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/EventPolicies','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EventPolicies','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EventPolicies','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EventPolicies','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/EventPolicies','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Wiederholungsregeln",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "event_type" }, 'event_typeHidden', { "name": "max_events", "type": "int", "useNull": true }, { "name": "every", "type": "int", "useNull": true }, { "name": "every_unit" }, 'every_unitHidden', { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 16,
  ls_grid_configs : [  ],
  content_type : 28,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var name10530 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10531 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10532 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event_type10533 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EventPolicies/event_type" }) }) });
    var max_events10534 = new Ext.form.NumberField({ "selectOnFocus": true });
    var every10535 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var every_unit10536 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var monday10537 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var tuesday10538 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var wednesday10539 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var thursday10540 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var friday10541 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var saturday10542 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var sunday10543 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var id10544 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_date10545 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time10546 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date10547 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time10548 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10549 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10550 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10551 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp10552 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp10553 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp10554 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration10555 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name10530, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(cal.EventPolicies.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de10531, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(cal.EventPolicies.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr10532, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(cal.EventPolicies.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "event_type", "editable": true, "editor": event_type10533, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.EventPolicies.event_type) Generated calendar entries will have this type.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "max_events", "editable": true, "editor": max_events10534, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "sortable": true, "tooltip": "(cal.EventPolicies.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "every", "editable": true, "editor": every10535, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "sortable": true, "tooltip": "(cal.EventPolicies.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "every_unit", "editable": true, "editor": every_unit10536, "filter": { "type": "string" }, "header": "Wiederholung", "sortable": false, "tooltip": "(cal.EventPolicies.every_unit) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "sortable": false, "tooltip": "(cal.EventPolicies.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 8, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "sortable": false, "tooltip": "(cal.EventPolicies.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 9, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "sortable": false, "tooltip": "(cal.EventPolicies.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 10, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "sortable": false, "tooltip": "(cal.EventPolicies.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 11, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "sortable": false, "tooltip": "(cal.EventPolicies.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 12, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "sortable": false, "tooltip": "(cal.EventPolicies.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "sortable": false, "tooltip": "(cal.EventPolicies.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 14, "dataIndex": "id", "editable": true, "editor": id10544, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.EventPolicies.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 15, "dataIndex": "start_date", "editable": true, "editor": start_date10545, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.EventPolicies.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 16, "dataIndex": "start_time", "editable": true, "editor": start_time10546, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.EventPolicies.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 17, "dataIndex": "end_date", "editable": true, "editor": end_date10547, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.EventPolicies.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 18, "dataIndex": "end_time", "editable": true, "editor": end_time10548, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(cal.EventPolicies.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 19, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EventPolicies.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EventPolicies.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.EventPolicies.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EventPolicies.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.EventPolicies.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 24, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(cal.EventPolicies.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 25, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.EventPolicies.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.EventPolicies.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EventPolicies.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventPolicies", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventPolicies.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventPolicies", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventPolicies.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventPolicies", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventPolicies.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventPolicies", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventPolicies.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventPolicies", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventPolicies.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventPolicies", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventPolicies.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventPolicies", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventPolicies.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventPolicies", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventPolicies.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.EventPolicies.GridPanel(p);
});

// js_render_GridPanel_class cal.Rooms
Lino.cal.Rooms.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 20,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/Rooms",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/Rooms','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Rooms','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Rooms','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Rooms','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/Rooms','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "R\u00e4ume",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "calendar" }, 'calendarHidden', { "name": "fee" }, 'feeHidden', { "name": "company" }, 'companyHidden', { "name": "company__city" }, 'company__cityHidden', { "name": "id", "type": "int" }, { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "description" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 11,
  ls_grid_configs : [  ],
  content_type : 20,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Rooms.detail;
    this.ls_insert_handler = Lino.cal.Rooms.insert;
    var ww = this.containing_window;
    var name10557 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10558 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10559 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var calendar10560 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalender ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/calendar" }) }) });
    var fee10561 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/fee" }) }) });
    var company10562 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/company" }) }) });
    var company__city10563 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Ort ausw\u00e4hlen...", "pageSize": 20, "sortable": false, "store": new Lino.ComplexRemoteComboStore({  }) });
    var id10564 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var contact_person10565 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/contact_person" }) }) });
    var contact_role10566 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/contact_role" }) }) });
    var description10567 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10568 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10569 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10570 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      contact_person10565.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company10562.on('change',Lino.chooser_handler(contact_person10565,'company'));
      Lino.cal.Rooms.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name10557, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(cal.Rooms.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de10558, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(cal.Rooms.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr10559, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(cal.Rooms.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "calendar", "editable": true, "editor": calendar10560, "filter": { "type": "string" }, "header": "Kalender", "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.Rooms.calendar) Calendar where events in this room are published.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "fee", "editable": true, "editor": fee10561, "filter": { "type": "string" }, "header": "Tarif", "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(cal.Rooms.fee) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "company", "editable": true, "editor": company10562, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(cal.Rooms.company) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "company__city", "editable": false, "filter": { "type": "string" }, "header": "Locality", "sortable": false, "tooltip": "(cal.Rooms.company__city) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id10564, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.Rooms.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "contact_person", "editable": true, "editor": contact_person10565, "filter": { "type": "string" }, "header": "Kontaktperson", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(cal.Rooms.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "contact_role", "editable": true, "editor": contact_role10566, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(cal.Rooms.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "description", "editable": true, "editor": description10567, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Rooms.description) ", "width": Lino.chars2width(61) }, { "colIndex": 11, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Rooms.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.Rooms.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.Rooms.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.cal.Rooms.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Rooms.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Rooms", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Rooms.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Rooms", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Rooms.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Rooms", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Rooms.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Rooms", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Rooms.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Rooms", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.Rooms.insertPanel = Ext.extend(Lino.cal.Rooms.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/Rooms",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Rooms.detail;
    this.ls_insert_handler = Lino.cal.Rooms.insert;
    Lino.cal.Rooms.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Rooms.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.Rooms.insertPanel(p);
});
Lino.cal.Rooms.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Rooms", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Rooms.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Rooms", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Rooms.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Rooms", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.Rooms.detailPanel = Ext.extend(Lino.cal.Rooms.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/Rooms",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Rooms.detail;
    this.ls_insert_handler = Lino.cal.Rooms.insert;
    Lino.cal.Rooms.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Rooms.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.Rooms.detailPanel(p);
});
Lino.cal.Rooms.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Rooms", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Rooms.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.Rooms.GridPanel(p);
});
Lino.cal.Rooms.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Rooms", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyEntries
Lino.cal.MyEntries.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyEntries",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntries','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntries','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntries','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntries','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntries','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Meine Termine",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "when_text" }, { "name": "summary" }, { "name": "room" }, 'roomHidden', { "name": "owner" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "event_type" }, 'event_typeHidden', { "name": "transparent", "type": "boolean" }, { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyEntries.detail;
    this.ls_insert_handler = Lino.cal.MyEntries.insert;
    var ww = this.containing_window;
    var when_text_disp769 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var summary770 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var room771 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/room" }) }) });
    var owner_disp772 = new Ext.form.DisplayField({ "disabled": true });
    var workflow_buttons_disp773 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id774 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified775 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created776 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date777 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time778 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date779 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time780 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time781 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method782 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user783 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/user" }) }) });
    var assigned_to784 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/assigned_to" }) }) });
    var owner_type785 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/owner_type" }) }) });
    var owner_id786 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/owner_id" }) }) });
    var description787 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class788 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence789 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type790 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var event_type791 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/event_type" }) }) });
    var transparent792 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var priority793 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/priority" }) }) });
    var state794 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var calendar795 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp796 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp797 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day798 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp799 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp800 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp801 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp802 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration803 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id786.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type785.on('change',Lino.chooser_handler(owner_id786,'owner_type'));
      Lino.cal.MyEntries.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(cal.MyEntries.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "summary", "editable": true, "editor": summary770, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.MyEntries.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "room", "editable": true, "editor": room771, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.MyEntries.room) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(cal.MyEntries.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.MyEntries.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id774, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "start_date", "editable": true, "editor": start_date777, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "start_time", "editable": true, "editor": start_time778, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "end_date", "editable": true, "editor": end_date779, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "end_time", "editable": true, "editor": end_time780, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 12, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 13, "dataIndex": "build_method", "editable": true, "editor": build_method782, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 14, "dataIndex": "user", "editable": true, "editor": user783, "filter": { "type": "string" }, "header": "Verantwortlicher", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyEntries.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to784, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyEntries.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "owner_type", "editable": true, "editor": owner_type785, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.MyEntries.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "owner_id", "editable": true, "editor": owner_id786, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 18, "dataIndex": "description", "editable": true, "editor": description787, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 19, "dataIndex": "access_class", "editable": true, "editor": access_class788, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 20, "dataIndex": "sequence", "editable": true, "editor": sequence789, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 21, "dataIndex": "auto_type", "editable": true, "editor": auto_type790, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 22, "dataIndex": "event_type", "editable": true, "editor": event_type791, "filter": { "type": "string" }, "header": "Kalendereintragsart", "hidden": true, "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.MyEntries.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 24, "dataIndex": "priority", "editable": true, "editor": priority793, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "state", "editable": true, "editor": state794, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 26, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.MyEntries.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 30, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.url) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.MyEntries.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyEntries.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyEntries.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/MyEntries",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyEntries.detail;
    this.ls_insert_handler = Lino.cal.MyEntries.insert;
    Lino.cal.MyEntries.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyEntries.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyEntries.insertPanel(p);
});
Lino.cal.MyEntries.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyEntries.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/MyEntries",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyEntries.detail;
    this.ls_insert_handler = Lino.cal.MyEntries.insert;
    Lino.cal.MyEntries.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyEntries.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyEntries.detailPanel(p);
});
Lino.cal.MyEntries.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.MyEntries.GridPanel(p);
});
Lino.cal.MyEntries.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/MyEntries", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class products.ProductCats
Lino.products.ProductCats.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 8,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/products/ProductCats",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/products/ProductCats','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/products/ProductCats','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/products/ProductCats','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/products/ProductCats','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/products/ProductCats','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Tarifkategorien",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "description" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 30,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.products.ProductCats.detail;
    var ww = this.containing_window;
    var id10572 = new Ext.form.NumberField({ "selectOnFocus": true });
    var name10573 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10574 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10575 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var description10576 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var mobile_item_disp10577 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10578 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10579 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10572, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(products.ProductCats.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name10573, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(products.ProductCats.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de10574, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(products.ProductCats.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr10575, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(products.ProductCats.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "description", "editable": true, "editor": description10576, "filter": { "type": "string" }, "header": "description", "sortable": false, "tooltip": "(products.ProductCats.description) ", "width": Lino.chars2width(61) }, { "colIndex": 5, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(products.ProductCats.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(products.ProductCats.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(products.ProductCats.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.products.ProductCats.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.products.ProductCats.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductCats", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductCats", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductCats", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductCats", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductCats", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductCats", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductCats", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductCats", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.products.ProductCats.detailPanel = Ext.extend(Lino.products.ProductCats.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/products/ProductCats",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.products.ProductCats.detail;
    Lino.products.ProductCats.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.products.ProductCats.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.ProductCats.detailPanel(p);
});
Lino.products.ProductCats.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductCats", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.ProductCats.GridPanel(p);
});
Lino.products.ProductCats.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductCats", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class products.Products
Lino.products.Products.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 23,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/products/Products",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/products/Products','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/products/Products','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/products/Products','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/products/Products','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/products/Products','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Tarife",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "cat" }, 'catHidden', { "name": "vat_class" }, 'vat_classHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "delivery_unit" }, 'delivery_unitHidden', { "name": "number_of_events", "type": "int", "useNull": true }, { "name": "min_asset", "type": "int", "useNull": true }, { "name": "sales_account" }, 'sales_accountHidden', { "name": "sales_price" }, { "name": "purchases_account" }, 'purchases_accountHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 31,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.products.Products.detail;
    this.ls_insert_handler = Lino.products.Products.insert;
    var ww = this.containing_window;
    var id10581 = new Ext.form.NumberField({ "selectOnFocus": true });
    var name10582 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10583 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10584 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var cat10585 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarifkategorie ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/Products/cat" }) }) });
    var vat_class10586 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var description10587 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de10588 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr10589 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var delivery_unit10590 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.products.DeliveryUnit, "value": "20" });
    var number_of_events10591 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var min_asset10592 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true, "value": 1 });
    var sales_account10593 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/Products/sales_account" }) }) });
    var sales_price10594 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var purchases_account10595 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/Products/purchases_account" }) }) });
    var mobile_item_disp10596 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10597 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10598 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10581, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(products.Products.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name10582, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(products.Products.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de10583, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(products.Products.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr10584, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(products.Products.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "cat", "editable": true, "editor": cat10585, "filter": { "type": "string" }, "header": "Kategorie", "renderer": Lino.fk_renderer('catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(products.Products.cat) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "vat_class", "editable": true, "editor": vat_class10586, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "sortable": false, "tooltip": "(products.Products.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "description", "editable": true, "editor": description10587, "filter": { "type": "string" }, "header": "Long description", "hidden": true, "sortable": false, "tooltip": "(products.Products.description) ", "width": Lino.chars2width(61) }, { "colIndex": 7, "dataIndex": "description_de", "editable": true, "editor": description_de10588, "filter": { "type": "string" }, "header": "Long description (de)", "hidden": true, "sortable": false, "tooltip": "(products.Products.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 8, "dataIndex": "description_fr", "editable": true, "editor": description_fr10589, "filter": { "type": "string" }, "header": "Long description (fr)", "hidden": true, "sortable": false, "tooltip": "(products.Products.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 9, "dataIndex": "delivery_unit", "editable": true, "editor": delivery_unit10590, "filter": { "type": "string" }, "header": "Delivery unit", "hidden": true, "sortable": false, "tooltip": "(products.Products.delivery_unit) ", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 10, "dataIndex": "number_of_events", "editable": true, "editor": number_of_events10591, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(products.Products.number_of_events) Anzahl Termine pro fakturierter Einheit.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 11, "dataIndex": "min_asset", "editable": true, "editor": min_asset10592, "filter": { "type": "numeric" }, "format": "0", "header": "Schwellenwert n\u00e4chste Rechnung", "hidden": true, "sortable": true, "tooltip": "(products.Products.min_asset) Die Mindestzahl vorgesehener Termine, um eine Rechnung zu erstellen.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "sales_account", "editable": true, "editor": sales_account10593, "filter": { "type": "string" }, "header": "Konto f\u00fcr Basisbetrag Verk\u00e4ufe", "hidden": true, "sortable": false, "tooltip": "(products.Products.sales_account) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 13, "dataIndex": "sales_price", "editable": true, "editor": sales_price10594, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Verkaufspreis", "hidden": true, "sortable": true, "tooltip": "(products.Products.sales_price) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 14, "dataIndex": "purchases_account", "editable": true, "editor": purchases_account10595, "filter": { "type": "string" }, "header": "Basis Einkauf", "hidden": true, "sortable": false, "tooltip": "(products.Products.purchases_account) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(products.Products.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(products.Products.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(products.Products.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.products.Products.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.products.Products.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/Products", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/Products", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/Products", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/Products", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/Products", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.products.Products.insertPanel = Ext.extend(Lino.products.Products.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/products/Products",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.products.Products.detail;
    this.ls_insert_handler = Lino.products.Products.insert;
    Lino.products.Products.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.products.Products.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.products.Products.insertPanel(p);
});
Lino.products.Products.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/Products", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/Products", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/Products", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.products.Products.detailPanel = Ext.extend(Lino.products.Products.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/products/Products",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.products.Products.detail;
    this.ls_insert_handler = Lino.products.Products.insert;
    Lino.products.Products.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.products.Products.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.Products.detailPanel(p);
});
Lino.products.Products.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/Products", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.Products.GridPanel(p);
});
Lino.products.Products.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/Products", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class rooms.Bookings
Lino.rooms.Bookings.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 38,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/rooms/Bookings",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/rooms/Bookings','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/rooms/Bookings','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/rooms/Bookings','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/rooms/Bookings','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/rooms/Bookings','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Buchungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "company" }, 'companyHidden', { "name": "room" }, 'roomHidden', { "name": "id", "type": "int" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "state" }, 'stateHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 32,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.rooms.Bookings.detail;
    this.ls_insert_handler = Lino.rooms.Bookings.insert;
    var ww = this.containing_window;
    var start_date10600 = new Lino.DateField({ "selectOnFocus": true });
    var company10601 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/company" }) }) });
    var room10602 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/room" }) }) });
    var id10603 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_time10604 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date10605 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time10606 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user10607 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/user" }) }) });
    var contact_person10608 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/contact_person" }) }) });
    var contact_role10609 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/contact_role" }) }) });
    var every_unit10610 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every10611 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 1 });
    var monday10612 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday10613 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday10614 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday10615 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday10616 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday10617 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday10618 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events10619 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date10620 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var state10621 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.rooms.BookingStates });
    var event_type10622 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/event_type" }) }) });
    var mobile_item_disp10623 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10624 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10625 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp10626 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp10627 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp10628 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration10629 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      contact_person10608.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company10601.on('change',Lino.chooser_handler(contact_person10608,'company'));
      Lino.rooms.Bookings.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date10600, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(rooms.Bookings.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "company", "editable": true, "editor": company10601, "filter": { "type": "string" }, "header": "Veranstalter", "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(rooms.Bookings.company) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "room", "editable": true, "editor": room10602, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(rooms.Bookings.room) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id10603, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(rooms.Bookings.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "start_time", "editable": true, "editor": start_time10604, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(rooms.Bookings.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 5, "dataIndex": "end_date", "editable": true, "editor": end_date10605, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(rooms.Bookings.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "end_time", "editable": true, "editor": end_time10606, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(rooms.Bookings.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user10607, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(rooms.Bookings.user) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "contact_person", "editable": true, "editor": contact_person10608, "filter": { "type": "string" }, "header": "Kontaktperson", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(rooms.Bookings.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "contact_role", "editable": true, "editor": contact_role10609, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "every_unit", "editable": true, "editor": every_unit10610, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 11, "dataIndex": "every", "editable": true, "editor": every10611, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(rooms.Bookings.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "max_events", "editable": true, "editor": max_events10619, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(rooms.Bookings.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "max_date", "editable": true, "editor": max_date10620, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(rooms.Bookings.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 21, "dataIndex": "state", "editable": true, "editor": state10621, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 22, "dataIndex": "event_type", "editable": true, "editor": event_type10622, "filter": { "type": "string" }, "header": "Kalendereintragsart", "hidden": true, "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(rooms.Bookings.event_type) The Event Type to which events will be generated.", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 24, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 25, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 29, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(rooms.Bookings.duration) ", "width": Lino.chars2width(8) } ];
    Lino.rooms.Bookings.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.rooms.Bookings.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.Bookings.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.Bookings.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.Bookings.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.Bookings.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.rooms.Bookings.insertPanel = Ext.extend(Lino.rooms.Bookings.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/rooms/Bookings",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.rooms.Bookings.detail;
    this.ls_insert_handler = Lino.rooms.Bookings.insert;
    Lino.rooms.Bookings.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.rooms.Bookings.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.rooms.Bookings.insertPanel(p);
});
Lino.rooms.Bookings.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.Bookings.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.Bookings.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.rooms.Bookings.detailPanel = Ext.extend(Lino.rooms.Bookings.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/rooms/Bookings",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.rooms.Bookings.detail;
    this.ls_insert_handler = Lino.rooms.Bookings.insert;
    Lino.rooms.Bookings.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.rooms.Bookings.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.rooms.Bookings.detailPanel(p);
});
Lino.rooms.Bookings.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.Bookings.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.Bookings.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.rooms.Bookings.ParamsPanel({});
  return new Lino.rooms.Bookings.GridPanel(p);
});
Lino.rooms.Bookings.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.Bookings.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.Bookings.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.Bookings.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.Bookings.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.Bookings.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/Bookings", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class accounts.Groups
Lino.accounts.Groups.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 10,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/accounts/Groups",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/accounts/Groups','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/accounts/Groups','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/accounts/Groups','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/accounts/Groups','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/accounts/Groups','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Kontengruppen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "account_type" }, 'account_typeHidden', { "name": "id", "type": "int" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 34,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.accounts.Groups.detail;
    this.ls_insert_handler = Lino.accounts.Groups.insert;
    var ww = this.containing_window;
    var ref10631 = new Ext.form.TextField({ "maxLength": 20, "selectOnFocus": true });
    var name10632 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10633 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10634 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var account_type10635 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.accounts.AccountTypes) });
    var id10636 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10637 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10638 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10639 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref10631, "filter": { "type": "string" }, "header": "ref", "sortable": true, "tooltip": "(accounts.Groups.ref) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name10632, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(accounts.Groups.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de10633, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(accounts.Groups.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr10634, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(accounts.Groups.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "account_type", "editable": true, "editor": account_type10635, "filter": { "type": "string" }, "header": "Kontenart", "sortable": false, "tooltip": "(accounts.Groups.account_type) ", "width": Lino.chars2width(17) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id10636, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(accounts.Groups.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(accounts.Groups.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(accounts.Groups.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(accounts.Groups.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.accounts.Groups.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.Groups.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Groups", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Groups.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Groups", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Groups.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Groups", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Groups.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Groups", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Groups.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Groups", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.accounts.Groups.insertPanel = Ext.extend(Lino.accounts.Groups.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/accounts/Groups",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.accounts.Groups.detail;
    this.ls_insert_handler = Lino.accounts.Groups.insert;
    Lino.accounts.Groups.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.Groups.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.accounts.Groups.insertPanel(p);
});
Lino.accounts.Groups.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Groups", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Groups.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Groups", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Groups.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Groups", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.accounts.Groups.detailPanel = Ext.extend(Lino.accounts.Groups.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/accounts/Groups",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.accounts.Groups.detail;
    this.ls_insert_handler = Lino.accounts.Groups.insert;
    Lino.accounts.Groups.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.Groups.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.accounts.Groups.detailPanel(p);
});
Lino.accounts.Groups.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Groups", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Groups.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.accounts.Groups.GridPanel(p);
});
Lino.accounts.Groups.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Groups", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class accounts.Accounts
Lino.accounts.Accounts.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 23,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/accounts/Accounts",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/accounts/Accounts','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/accounts/Accounts','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/accounts/Accounts','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/accounts/Accounts','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/accounts/Accounts','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Konten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "group" }, 'groupHidden', { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "sales_allowed", "type": "boolean" }, { "name": "purchases_allowed", "type": "boolean" }, { "name": "wages_allowed", "type": "boolean" }, { "name": "taxes_allowed", "type": "boolean" }, { "name": "clearings_allowed", "type": "boolean" }, { "name": "vat_column" }, { "name": "type" }, 'typeHidden', { "name": "needs_partner", "type": "boolean" }, { "name": "clearable", "type": "boolean" }, { "name": "default_amount" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "move_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 33,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.accounts.Accounts.detail;
    this.ls_insert_handler = Lino.accounts.Accounts.insert;
    var ww = this.containing_window;
    var ref10641 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name10642 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10643 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10644 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var group10645 = new Lino.RemoteComboFieldElement({ "emptyText": "Kontengruppe ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/accounts/Accounts/group" }) }) });
    var id10646 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var seqno10647 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var sales_allowed10648 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var purchases_allowed10649 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wages_allowed10650 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var taxes_allowed10651 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var clearings_allowed10652 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var vat_column10653 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var type10654 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.accounts.AccountTypes });
    var needs_partner10655 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var clearable10656 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var default_amount10657 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10658 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10659 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10660 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp10661 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref10641, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(accounts.Accounts.ref) An optional unique name which can be used to reference a given\naccount.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name10642, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(accounts.Accounts.name) The multilingual designation of this account, as the users see\nit.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de10643, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(accounts.Accounts.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr10644, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(accounts.Accounts.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "group", "editable": true, "editor": group10645, "filter": { "type": "string" }, "header": "Kontengruppe", "renderer": Lino.fk_renderer('groupHidden','Lino.accounts.Groups.detail'), "sortable": false, "tooltip": "(accounts.Accounts.group) The account group to which this account belongs.  Points to\nan instance of Group.  If this field is empty, the\naccount won't appear in certain reports.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id10646, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(accounts.Accounts.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "seqno", "editable": true, "editor": seqno10647, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(accounts.Accounts.seqno) The sequence number of this account within its group.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "sales_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "Verkauf", "hidden": true, "sortable": false, "tooltip": "(accounts.Accounts.sales_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 8, "dataIndex": "purchases_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "Einkauf", "hidden": true, "sortable": false, "tooltip": "(accounts.Accounts.purchases_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 9, "dataIndex": "wages_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "L\u00f6hne und Geh\u00e4lter", "hidden": true, "sortable": false, "tooltip": "(accounts.Accounts.wages_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 10, "dataIndex": "taxes_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "Taxes", "hidden": true, "sortable": false, "tooltip": "(accounts.Accounts.taxes_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 11, "dataIndex": "clearings_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "Begleichungen", "hidden": true, "sortable": false, "tooltip": "(accounts.Accounts.clearings_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 12, "dataIndex": "vat_column", "editable": true, "editor": vat_column10653, "filter": { "type": "string" }, "header": "VAT column", "hidden": true, "sortable": true, "tooltip": "(accounts.Accounts.vat_column) ", "width": Lino.chars2width(12) }, { "colIndex": 13, "dataIndex": "type", "editable": true, "editor": type10654, "filter": { "type": "string" }, "header": "Kontenart", "hidden": true, "sortable": false, "tooltip": "(accounts.Accounts.type) The account type of this account.  This points to an item of\nAccountTypes.", "width": Lino.chars2width(17) }, { "colIndex": 14, "dataIndex": "needs_partner", "editable": true, "filter": { "type": "boolean" }, "header": "Braucht Partner", "hidden": true, "sortable": false, "tooltip": "(accounts.Accounts.needs_partner) Whether bookings to this account need a partner specified.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "clearable", "editable": true, "filter": { "type": "boolean" }, "header": "Auszugleichen", "hidden": true, "sortable": false, "tooltip": "(accounts.Accounts.clearable) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 16, "dataIndex": "default_amount", "editable": true, "editor": default_amount10657, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Vorschlag Betrag", "hidden": true, "sortable": true, "tooltip": "(accounts.Accounts.default_amount) The default amount to book in bank statements or journal\nentries when this account has been selected manually. The\ndefault booking direction is that of the type.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 17, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(accounts.Accounts.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(accounts.Accounts.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(accounts.Accounts.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(accounts.Accounts.move_buttons) ", "width": Lino.chars2width(6) } ];
    Lino.accounts.Accounts.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.Accounts.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Accounts.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Accounts.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Accounts.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Accounts.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.accounts.Accounts.insertPanel = Ext.extend(Lino.accounts.Accounts.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/accounts/Accounts",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.accounts.Accounts.detail;
    this.ls_insert_handler = Lino.accounts.Accounts.insert;
    Lino.accounts.Accounts.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.Accounts.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.accounts.Accounts.insertPanel(p);
});
Lino.accounts.Accounts.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Accounts.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Accounts.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Accounts.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.accounts.Accounts.detailPanel = Ext.extend(Lino.accounts.Accounts.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/accounts/Accounts",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.accounts.Accounts.detail;
    this.ls_insert_handler = Lino.accounts.Accounts.insert;
    Lino.accounts.Accounts.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.Accounts.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.accounts.Accounts.detailPanel(p);
});
Lino.accounts.Accounts.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Accounts.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Accounts.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.accounts.Accounts.GridPanel(p);
});
Lino.accounts.Accounts.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Accounts.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.Accounts.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/Accounts", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.PaperTypes
Lino.sales.PaperTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 8,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/PaperTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/PaperTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/PaperTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/PaperTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/PaperTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/PaperTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Papierarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "template" }, { "name": "id", "type": "int" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 46,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var name10663 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10664 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10665 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var template10666 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PaperTypes/template" }) }) });
    var id10667 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10668 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10669 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10670 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name10663, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(sales.PaperTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de10664, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(sales.PaperTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr10665, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(sales.PaperTypes.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "template", "editable": true, "editor": template10666, "filter": { "type": "string" }, "header": "Vorlage", "sortable": false, "tooltip": "(sales.PaperTypes.template) ", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id10667, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sales.PaperTypes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.PaperTypes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.PaperTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(sales.PaperTypes.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.sales.PaperTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.PaperTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PaperTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PaperTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PaperTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PaperTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PaperTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PaperTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PaperTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PaperTypes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PaperTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PaperTypes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PaperTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PaperTypes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PaperTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PaperTypes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PaperTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PaperTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.PaperTypes.GridPanel(p);
});

// js_render_GridPanel_class sales.SalesDocuments
Lino.sales.SalesDocuments.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 17,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/SalesDocuments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/SalesDocuments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/SalesDocuments','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/SalesDocuments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/SalesDocuments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/SalesDocuments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Belege",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "number_with_year" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var entry_date4681 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var number4682 = new Ext.form.NumberField({ "selectOnFocus": true });
    var id4683 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user4684 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/SalesDocuments/user" }) }) });
    var journal4685 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/SalesDocuments/journal" }) }) });
    var voucher_date4686 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period4687 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/SalesDocuments/accounting_period" }) }) });
    var narration4688 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state4689 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var number_with_year_disp4690 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4691 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4692 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4693 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "entry_date", "editable": true, "editor": entry_date4681, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(sales.SalesDocuments.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "number", "editable": true, "editor": number4682, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(sales.SalesDocuments.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id4683, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sales.SalesDocuments.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user4684, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(sales.SalesDocuments.user) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "journal", "editable": true, "editor": journal4685, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(sales.SalesDocuments.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4686, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(sales.SalesDocuments.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4687, "filter": { "type": "string" }, "header": "Buchungsperiode", "hidden": true, "sortable": false, "tooltip": "(sales.SalesDocuments.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "narration", "editable": true, "editor": narration4688, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(sales.SalesDocuments.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "state", "editable": true, "editor": state4689, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(sales.SalesDocuments.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 9, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "hidden": true, "sortable": false, "tooltip": "(sales.SalesDocuments.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.SalesDocuments.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.SalesDocuments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(sales.SalesDocuments.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.sales.SalesDocuments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.SalesDocuments.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/SalesDocuments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/SalesDocuments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/SalesDocuments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/SalesDocuments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/SalesDocuments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/SalesDocuments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/SalesDocuments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/SalesDocuments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.PartnerVouchers.ParamsPanel({});
  return new Lino.sales.SalesDocuments.GridPanel(p);
});
Lino.sales.SalesDocuments.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/SalesDocuments", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/SalesDocuments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/SalesDocuments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.Invoices
Lino.sales.Invoices.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 40,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/Invoices",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/Invoices','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/Invoices','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/Invoices','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/Invoices','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/Invoices','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Produktrechnungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "total_incl" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "your_ref" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "language" }, 'languageHidden', { "name": "subject" }, { "name": "intro" }, { "name": "paper_type" }, 'paper_typeHidden', { "name": "balance_before" }, { "name": "balance_to_pay" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "printed" }, { "name": "number_with_year" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.Invoices.detail;
    this.ls_insert_handler = Lino.sales.Invoices.insert;
    var ww = this.containing_window;
    var id4695 = new Ext.form.NumberField({ "selectOnFocus": true });
    var entry_date4696 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var partner4697 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/partner" }) }) });
    var total_incl4698 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var user4699 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/user" }) }) });
    var journal4700 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/journal" }) }) });
    var voucher_date4701 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period4702 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/accounting_period" }) }) });
    var number4703 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var narration4704 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state4705 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by4706 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var payment_term4707 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/payment_term" }) }) });
    var match4708 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/match" }) }) });
    var your_ref4709 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var due_date4710 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var total_base4711 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat4712 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_regime4713 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var language4714 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var subject4715 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var intro4716 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var paper_type4717 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/paper_type" }) }) });
    var balance_before4718 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var balance_to_pay4719 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var mobile_item_disp4720 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4721 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4722 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp4723 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var number_with_year_disp4724 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      match4708.setContextValue('journal', record ? record.data['journalHidden'] : undefined);
      match4708.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      journal4700.on('change',Lino.chooser_handler(match4708,'journal'));
      partner4697.on('change',Lino.chooser_handler(match4708,'partner'));
      Lino.sales.Invoices.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4695, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(sales.Invoices.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date4696, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(sales.Invoices.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "partner", "editable": true, "editor": partner4697, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sales.Invoices.partner) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "total_incl", "editable": true, "editor": total_incl4698, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(sales.Invoices.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user4699, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(sales.Invoices.user) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "journal", "editable": true, "editor": journal4700, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(sales.Invoices.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4701, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4702, "filter": { "type": "string" }, "header": "Buchungsperiode", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 8, "dataIndex": "number", "editable": true, "editor": number4703, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 9, "dataIndex": "narration", "editable": true, "editor": narration4704, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "state", "editable": true, "editor": state4705, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 11, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(sales.Invoices.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "payment_term", "editable": true, "editor": payment_term4707, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(sales.Invoices.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "match", "editable": true, "editor": match4708, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "your_ref", "editable": true, "editor": your_ref4709, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.your_ref) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "due_date", "editable": true, "editor": due_date4710, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Zahlungsziel", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 16, "dataIndex": "total_base", "editable": true, "editor": total_base4711, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 17, "dataIndex": "total_vat", "editable": true, "editor": total_vat4712, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 18, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime4713, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 19, "dataIndex": "language", "editable": true, "editor": language4714, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.language) ", "width": Lino.chars2width(21) }, { "colIndex": 20, "dataIndex": "subject", "editable": true, "editor": subject4715, "filter": { "type": "string" }, "header": "Betreff", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 21, "dataIndex": "intro", "editable": true, "editor": intro4716, "filter": { "type": "string" }, "header": "Introductive Text", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.intro) ", "width": Lino.chars2width(61) }, { "colIndex": 22, "dataIndex": "paper_type", "editable": true, "editor": paper_type4717, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 23, "dataIndex": "balance_before", "editable": false, "format": "0.000,00/i", "header": "Saldo vorher", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.balance_before) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 24, "dataIndex": "balance_to_pay", "editable": false, "format": "0.000,00/i", "header": "Saldo zu zahlen", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.balance_to_pay) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 25, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.number_with_year) ", "width": Lino.chars2width(9) } ];
    Lino.sales.Invoices.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.Invoices.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.Invoices.insertPanel = Ext.extend(Lino.sales.Invoices.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/sales/Invoices",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.Invoices.detail;
    this.ls_insert_handler = Lino.sales.Invoices.insert;
    Lino.sales.Invoices.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.Invoices.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.Invoices.insertPanel(p);
});
Lino.sales.Invoices.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.Invoices.detailPanel = Ext.extend(Lino.sales.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/sales/Invoices",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.Invoices.detail;
    this.ls_insert_handler = Lino.sales.Invoices.insert;
    Lino.sales.Invoices.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.Invoices.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.Invoices.detailPanel(p);
});
Lino.sales.Invoices.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.sales.Invoices.ParamsPanel({});
  return new Lino.sales.Invoices.GridPanel(p);
});
Lino.sales.Invoices.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/Invoices", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.DueInvoices
Lino.sales.DueInvoices.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 41,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/DueInvoices",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/DueInvoices','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/DueInvoices','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/DueInvoices','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/DueInvoices','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/DueInvoices','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Offene Rechnungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "journal__ref" }, { "name": "number", "type": "int", "useNull": true }, { "name": "partner" }, 'partnerHidden', { "name": "total_incl" }, { "name": "balance_before" }, { "name": "balance_to_pay" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "your_ref" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "language" }, 'languageHidden', { "name": "subject" }, { "name": "intro" }, { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "printed" }, { "name": "number_with_year" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.DueInvoices.detail;
    this.ls_insert_handler = Lino.sales.DueInvoices.insert;
    var ww = this.containing_window;
    var due_date4726 = new Lino.DateField({ "selectOnFocus": true });
    var journal__ref4727 = new Ext.form.TextField({ "disabled": true, "maxLength": 40, "sortable": false });
    var number4728 = new Ext.form.NumberField({ "selectOnFocus": true });
    var partner4729 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/partner" }) }) });
    var total_incl4730 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var balance_before4731 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var balance_to_pay4732 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var id4733 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user4734 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/user" }) }) });
    var journal4735 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/journal" }) }) });
    var entry_date4736 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var voucher_date4737 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period4738 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/accounting_period" }) }) });
    var narration4739 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state4740 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by4741 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var payment_term4742 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/payment_term" }) }) });
    var match4743 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/match" }) }) });
    var your_ref4744 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var total_base4745 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat4746 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_regime4747 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var language4748 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var subject4749 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var intro4750 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var paper_type4751 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/paper_type" }) }) });
    var mobile_item_disp4752 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4753 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4754 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp4755 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var number_with_year_disp4756 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      match4743.setContextValue('journal', record ? record.data['journalHidden'] : undefined);
      match4743.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      journal4735.on('change',Lino.chooser_handler(match4743,'journal'));
      partner4729.on('change',Lino.chooser_handler(match4743,'partner'));
      Lino.sales.DueInvoices.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "due_date", "editable": true, "editor": due_date4726, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": true, "tooltip": "(sales.DueInvoices.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "journal__ref", "editable": false, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(sales.DueInvoices.journal__ref) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 2, "dataIndex": "number", "editable": true, "editor": number4728, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(sales.DueInvoices.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "partner", "editable": true, "editor": partner4729, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sales.DueInvoices.partner) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "total_incl", "editable": true, "editor": total_incl4730, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(sales.DueInvoices.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "balance_before", "editable": false, "format": "0.000,00/i", "header": "Saldo vorher", "sortable": false, "tooltip": "(sales.DueInvoices.balance_before) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "balance_to_pay", "editable": false, "format": "0.000,00/i", "header": "Saldo zu zahlen", "sortable": false, "tooltip": "(sales.DueInvoices.balance_to_pay) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id4733, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user4734, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(sales.DueInvoices.user) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "journal", "editable": true, "editor": journal4735, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(sales.DueInvoices.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "entry_date", "editable": true, "editor": entry_date4736, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4737, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 12, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4738, "filter": { "type": "string" }, "header": "Buchungsperiode", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "narration", "editable": true, "editor": narration4739, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "state", "editable": true, "editor": state4740, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 15, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(sales.DueInvoices.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "payment_term", "editable": true, "editor": payment_term4742, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(sales.DueInvoices.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "match", "editable": true, "editor": match4743, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 18, "dataIndex": "your_ref", "editable": true, "editor": your_ref4744, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.your_ref) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 19, "dataIndex": "total_base", "editable": true, "editor": total_base4745, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 20, "dataIndex": "total_vat", "editable": true, "editor": total_vat4746, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 21, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime4747, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 22, "dataIndex": "language", "editable": true, "editor": language4748, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.language) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "subject", "editable": true, "editor": subject4749, "filter": { "type": "string" }, "header": "Betreff", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 24, "dataIndex": "intro", "editable": true, "editor": intro4750, "filter": { "type": "string" }, "header": "Introductive Text", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.intro) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "paper_type", "editable": true, "editor": paper_type4751, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.number_with_year) ", "width": Lino.chars2width(9) } ];
    Lino.sales.DueInvoices.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.DueInvoices.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.DueInvoices.insertPanel = Ext.extend(Lino.sales.Invoices.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/sales/DueInvoices",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.DueInvoices.detail;
    this.ls_insert_handler = Lino.sales.DueInvoices.insert;
    Lino.sales.DueInvoices.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.DueInvoices.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.DueInvoices.insertPanel(p);
});
Lino.sales.DueInvoices.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.DueInvoices.detailPanel = Ext.extend(Lino.sales.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/sales/DueInvoices",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.DueInvoices.detail;
    this.ls_insert_handler = Lino.sales.DueInvoices.insert;
    Lino.sales.DueInvoices.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.DueInvoices.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.DueInvoices.detailPanel(p);
});
Lino.sales.DueInvoices.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.sales.Invoices.ParamsPanel({});
  return new Lino.sales.DueInvoices.GridPanel(p);
});
Lino.sales.DueInvoices.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DueInvoices", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.InvoiceItems
Lino.sales.InvoiceItems.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 25,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/InvoiceItems",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/InvoiceItems','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoiceItems','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoiceItems','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoiceItems','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/InvoiceItems','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Produktrechnungszeilen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "product" }, 'productHidden', { "name": "title" }, { "name": "discount" }, { "name": "unit_price" }, { "name": "qty" }, { "name": "total_incl" }, { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_class" }, 'vat_classHidden', { "name": "description" }, { "name": "voucher" }, 'voucherHidden', { "name": "invoiceable_type" }, 'invoiceable_typeHidden', { "name": "invoiceable_id" }, 'invoiceable_idHidden', { "name": "invoiceable" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "move_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 44,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoiceItems.detail;
    this.ls_insert_handler = Lino.sales.InvoiceItems.insert;
    var ww = this.containing_window;
    var product10672 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoiceItems/product" }) }) });
    var title10673 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var discount10674 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var unit_price10675 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var qty10676 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "maxLength": 6, "selectOnFocus": true });
    var total_incl10677 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var id10678 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var seqno10679 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var total_base10680 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat10681 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_class10682 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var description10683 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var voucher10684 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Produktrechnung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoiceItems/voucher" }) }) });
    var invoiceable_type10685 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoiceItems/invoiceable_type" }) }) });
    var invoiceable_id10686 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoiceItems/invoiceable_id" }) }) });
    var invoiceable_disp10687 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp10688 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10689 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10690 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp10691 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      invoiceable_id10686.setContextValue('invoiceable_type', record ? record.data['invoiceable_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      invoiceable_type10685.on('change',Lino.chooser_handler(invoiceable_id10686,'invoiceable_type'));
      Lino.sales.InvoiceItems.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "product", "editable": true, "editor": product10672, "filter": { "type": "string" }, "header": "Tarif", "renderer": Lino.fk_renderer('productHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(sales.InvoiceItems.product) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "title", "editable": true, "editor": title10673, "filter": { "type": "string" }, "header": "\u00dcberschrift", "sortable": true, "tooltip": "(sales.InvoiceItems.title) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 2, "dataIndex": "discount", "editable": true, "editor": discount10674, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Erm\u00e4\u00dfigung", "sortable": true, "tooltip": "(sales.InvoiceItems.discount) ", "width": Lino.chars2width(8), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 3, "dataIndex": "unit_price", "editable": true, "editor": unit_price10675, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "St\u00fcckpreis", "sortable": true, "tooltip": "(sales.InvoiceItems.unit_price) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "qty", "editable": true, "editor": qty10676, "filter": { "type": "string" }, "format": "", "header": "Menge", "sortable": true, "tooltip": "(sales.InvoiceItems.qty) ", "width": Lino.chars2width(8) }, { "align": "right", "colIndex": 5, "dataIndex": "total_incl", "editable": true, "editor": total_incl10677, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(sales.InvoiceItems.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id10678, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sales.InvoiceItems.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "seqno", "editable": true, "editor": seqno10679, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(sales.InvoiceItems.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "total_base", "editable": true, "editor": total_base10680, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "hidden": true, "sortable": true, "tooltip": "(sales.InvoiceItems.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 9, "dataIndex": "total_vat", "editable": true, "editor": total_vat10681, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "hidden": true, "sortable": true, "tooltip": "(sales.InvoiceItems.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 10, "dataIndex": "vat_class", "editable": true, "editor": vat_class10682, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "hidden": true, "sortable": false, "tooltip": "(sales.InvoiceItems.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 11, "dataIndex": "description", "editable": true, "editor": description10683, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.InvoiceItems.description) A multi-line rich text to be printed in the resulting printable\ndocument.", "width": Lino.chars2width(61) }, { "colIndex": 12, "dataIndex": "voucher", "editable": true, "editor": voucher10684, "filter": { "type": "string" }, "header": "Produktrechnung", "hidden": true, "renderer": Lino.fk_renderer('voucherHidden','Lino.sales.Invoices.detail'), "sortable": false, "tooltip": "(sales.InvoiceItems.voucher) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "invoiceable_type", "editable": true, "editor": invoiceable_type10685, "filter": { "type": "string" }, "header": "Fakturiertes Objekt (Modell)", "hidden": true, "renderer": Lino.fk_renderer('invoiceable_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(sales.InvoiceItems.invoiceable_type) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "invoiceable_id", "editable": true, "editor": invoiceable_id10686, "filter": { "type": "string" }, "header": "Fakturiertes Objekt (Objekt)", "hidden": true, "sortable": false, "tooltip": "(sales.InvoiceItems.invoiceable_id) ", "width": Lino.chars2width(11) }, { "colIndex": 15, "dataIndex": "invoiceable", "editable": false, "header": "Fakturiertes Objekt", "hidden": true, "sortable": false, "tooltip": "(sales.InvoiceItems.invoiceable) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.InvoiceItems.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.InvoiceItems.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(sales.InvoiceItems.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(sales.InvoiceItems.move_buttons) ", "width": Lino.chars2width(6) } ];
    Lino.sales.InvoiceItems.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoiceItems.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItems", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItems.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItems", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItems.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItems", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItems.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItems", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItems.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItems", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.InvoiceItems.insertPanel = Ext.extend(Lino.sales.InvoiceItems.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/sales/InvoiceItems",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoiceItems.detail;
    this.ls_insert_handler = Lino.sales.InvoiceItems.insert;
    Lino.sales.InvoiceItems.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoiceItems.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.InvoiceItems.insertPanel(p);
});
Lino.sales.InvoiceItems.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItems", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItems.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItems", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItems.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItems", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItems.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItems", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.InvoiceItems.detailPanel = Ext.extend(Lino.sales.InvoiceItems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/sales/InvoiceItems",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoiceItems.detail;
    this.ls_insert_handler = Lino.sales.InvoiceItems.insert;
    Lino.sales.InvoiceItems.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoiceItems.detail = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.InvoiceItems.detailPanel(p);
});
Lino.sales.InvoiceItems.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItems", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItems.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.InvoiceItems.GridPanel(p);
});
Lino.sales.InvoiceItems.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItems", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItems.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItems", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItems.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItems", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.DocumentsToSign
Lino.sales.DocumentsToSign.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 9,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/DocumentsToSign",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/DocumentsToSign','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/DocumentsToSign','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/DocumentsToSign','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/DocumentsToSign','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/DocumentsToSign','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Produktrechnungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "number", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "subject" }, { "name": "total_incl" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "voucher_ptr" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 45,
  ls_id_property : "voucher_ptr",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.DocumentsToSign.detail;
    this.ls_insert_handler = Lino.sales.DocumentsToSign.insert;
    var ww = this.containing_window;
    var number4758 = new Ext.form.NumberField({ "selectOnFocus": true });
    var entry_date4759 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var partner4760 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DocumentsToSign/partner" }) }) });
    var subject4761 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var total_incl4762 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_base4763 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat4764 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "number", "editable": true, "editor": number4758, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(sales.DocumentsToSign.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(5), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date4759, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(sales.DocumentsToSign.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "partner", "editable": true, "editor": partner4760, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sales.DocumentsToSign.partner) ", "width": Lino.chars2width(11) }, { "colIndex": 3, "dataIndex": "subject", "editable": true, "editor": subject4761, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(sales.DocumentsToSign.subject) ", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 4, "dataIndex": "total_incl", "editable": true, "editor": total_incl4762, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(sales.DocumentsToSign.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "total_base", "editable": true, "editor": total_base4763, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "sortable": true, "tooltip": "(sales.DocumentsToSign.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "total_vat", "editable": true, "editor": total_vat4764, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "sortable": true, "tooltip": "(sales.DocumentsToSign.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.sales.DocumentsToSign.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.DocumentsToSign.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.DocumentsToSign.insertPanel = Ext.extend(Lino.sales.Invoices.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/sales/DocumentsToSign",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.DocumentsToSign.detail;
    this.ls_insert_handler = Lino.sales.DocumentsToSign.insert;
    Lino.sales.DocumentsToSign.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.DocumentsToSign.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.DocumentsToSign.insertPanel(p);
});
Lino.sales.DocumentsToSign.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.DocumentsToSign.detailPanel = Ext.extend(Lino.sales.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/sales/DocumentsToSign",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.DocumentsToSign.detail;
    this.ls_insert_handler = Lino.sales.DocumentsToSign.insert;
    Lino.sales.DocumentsToSign.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.DocumentsToSign.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.DocumentsToSign.detailPanel(p);
});
Lino.sales.DocumentsToSign.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.sales.Invoices.ParamsPanel({});
  return new Lino.sales.DocumentsToSign.GridPanel(p);
});
Lino.sales.DocumentsToSign.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/DocumentsToSign", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class invoicing.Plans
Lino.invoicing.Plans.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 14,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/invoicing/Plans",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/invoicing/Plans','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/Plans','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/Plans','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/Plans','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/invoicing/Plans','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "update_plan", "menu_item_text": "update_plan", "overflowText": "update_plan", "panel_btn_handler": Lino.row_action_handler('update_plan','GET',null), "tooltip": "Build a new list of suggestions. This will remove all current suggestions" }, { "auto_save": true, "iconCls": "x-tbar-money", "itemId": "execute_plan", "menu_item_text": "execute_plan", "overflowText": "execute_plan", "panel_btn_handler": Lino.row_action_handler('execute_plan','GET',null), "tooltip": "Execute this invoicing plan. Create an invoice for each selected suggestion." }, { "auto_save": true, "itemId": "toggle_selections", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Invert selection status for all suggestions.") }, "menu_item_text": "Auswahl umkehren", "overflowText": "Auswahl umkehren", "panel_btn_handler": Lino.row_action_handler('toggle_selections','GET',null), "text": "Auswahl umkehren" } ],
  cell_edit : true,
  title : "Fakturationspl\u00e4ne",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "today", "type": "date" }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "course" }, 'courseHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 48,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.invoicing.Plans.detail;
    var ww = this.containing_window;
    var id4766 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user4767 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/user" }) }) });
    var journal4768 = new Lino.RemoteComboFieldElement({ "emptyText": "Journal ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/journal" }) }) });
    var today4769 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var max_date4770 = new Lino.DateField({ "selectOnFocus": true });
    var partner4771 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/partner" }) }) });
    var course4772 = new Lino.RemoteComboFieldElement({ "emptyText": "Activity ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/course" }) }) });
    var mobile_item_disp4773 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4774 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4775 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4766, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(invoicing.Plans.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user4767, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(invoicing.Plans.user) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "journal", "editable": true, "editor": journal4768, "filter": { "type": "string" }, "header": "Journal", "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(invoicing.Plans.journal) The journal where to create invoices.  When this field is\nempty, you can fill the plan with suggestions but cannot\nexecute the plan.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "today", "editable": true, "editor": today4769, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Rechnungsdatum", "sortable": true, "tooltip": "(invoicing.Plans.today) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "max_date", "editable": true, "editor": max_date4770, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Fakturierbare bis", "sortable": true, "tooltip": "(invoicing.Plans.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "partner", "editable": true, "editor": partner4771, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(invoicing.Plans.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "course", "editable": true, "editor": course4772, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(invoicing.Plans.course) If this field is nonempty, select only enrolments of that\ngiven course.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(invoicing.Plans.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(invoicing.Plans.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(invoicing.Plans.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.invoicing.Plans.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.Plans.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.invoicing.Plans.detailPanel = Ext.extend(Lino.invoicing.Plans.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "update_plan", "menu_item_text": "update_plan", "overflowText": "update_plan", "panel_btn_handler": Lino.row_action_handler('update_plan','GET',null), "tooltip": "Build a new list of suggestions. This will remove all current suggestions" }, { "auto_save": true, "iconCls": "x-tbar-money", "itemId": "execute_plan", "menu_item_text": "execute_plan", "overflowText": "execute_plan", "panel_btn_handler": Lino.row_action_handler('execute_plan','GET',null), "tooltip": "Execute this invoicing plan. Create an invoice for each selected suggestion." }, { "auto_save": true, "itemId": "toggle_selections", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Invert selection status for all suggestions.") }, "menu_item_text": "Auswahl umkehren", "overflowText": "Auswahl umkehren", "panel_btn_handler": Lino.row_action_handler('toggle_selections','GET',null), "text": "Auswahl umkehren" } ],
  ls_url: "/invoicing/Plans",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.invoicing.Plans.detail;
    Lino.invoicing.Plans.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.Plans.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.invoicing.Plans.detailPanel(p);
});
Lino.invoicing.Plans.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.invoicing.Plans.ParamsPanel({});
  return new Lino.invoicing.Plans.GridPanel(p);
});
Lino.invoicing.Plans.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.update_plan = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "GET", pk, "update_plan", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.execute_plan = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "GET", pk, "execute_plan", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.toggle_selections = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Plans", "GET", pk, "toggle_selections", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class invoicing.MyPlans
Lino.invoicing.MyPlans.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 14,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/invoicing/MyPlans",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/invoicing/MyPlans','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/MyPlans','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/MyPlans','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/MyPlans','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/invoicing/MyPlans','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "update_plan", "menu_item_text": "update_plan", "overflowText": "update_plan", "panel_btn_handler": Lino.row_action_handler('update_plan','GET',null), "tooltip": "Build a new list of suggestions. This will remove all current suggestions" }, { "auto_save": true, "iconCls": "x-tbar-money", "itemId": "execute_plan", "menu_item_text": "execute_plan", "overflowText": "execute_plan", "panel_btn_handler": Lino.row_action_handler('execute_plan','GET',null), "tooltip": "Execute this invoicing plan. Create an invoice for each selected suggestion." }, { "auto_save": true, "itemId": "toggle_selections", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Invert selection status for all suggestions.") }, "menu_item_text": "Auswahl umkehren", "overflowText": "Auswahl umkehren", "panel_btn_handler": Lino.row_action_handler('toggle_selections','GET',null), "text": "Auswahl umkehren" } ],
  cell_edit : true,
  title : "Meine Fakturationspl\u00e4ne",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "today", "type": "date" }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "course" }, 'courseHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 48,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.invoicing.MyPlans.detail;
    var ww = this.containing_window;
    var id4777 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user4778 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/MyPlans/user" }) }) });
    var journal4779 = new Lino.RemoteComboFieldElement({ "emptyText": "Journal ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/MyPlans/journal" }) }) });
    var today4780 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var max_date4781 = new Lino.DateField({ "selectOnFocus": true });
    var partner4782 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/MyPlans/partner" }) }) });
    var course4783 = new Lino.RemoteComboFieldElement({ "emptyText": "Activity ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/MyPlans/course" }) }) });
    var mobile_item_disp4784 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4785 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4786 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4777, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(invoicing.MyPlans.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user4778, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(invoicing.MyPlans.user) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "journal", "editable": true, "editor": journal4779, "filter": { "type": "string" }, "header": "Journal", "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(invoicing.MyPlans.journal) The journal where to create invoices.  When this field is\nempty, you can fill the plan with suggestions but cannot\nexecute the plan.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "today", "editable": true, "editor": today4780, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Rechnungsdatum", "sortable": true, "tooltip": "(invoicing.MyPlans.today) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "max_date", "editable": true, "editor": max_date4781, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Fakturierbare bis", "sortable": true, "tooltip": "(invoicing.MyPlans.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "partner", "editable": true, "editor": partner4782, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(invoicing.MyPlans.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "course", "editable": true, "editor": course4783, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(invoicing.MyPlans.course) If this field is nonempty, select only enrolments of that\ngiven course.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(invoicing.MyPlans.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(invoicing.MyPlans.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(invoicing.MyPlans.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.invoicing.MyPlans.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.MyPlans.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.invoicing.MyPlans.detailPanel = Ext.extend(Lino.invoicing.Plans.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "update_plan", "menu_item_text": "update_plan", "overflowText": "update_plan", "panel_btn_handler": Lino.row_action_handler('update_plan','GET',null), "tooltip": "Build a new list of suggestions. This will remove all current suggestions" }, { "auto_save": true, "iconCls": "x-tbar-money", "itemId": "execute_plan", "menu_item_text": "execute_plan", "overflowText": "execute_plan", "panel_btn_handler": Lino.row_action_handler('execute_plan','GET',null), "tooltip": "Execute this invoicing plan. Create an invoice for each selected suggestion." }, { "auto_save": true, "itemId": "toggle_selections", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Invert selection status for all suggestions.") }, "menu_item_text": "Auswahl umkehren", "overflowText": "Auswahl umkehren", "panel_btn_handler": Lino.row_action_handler('toggle_selections','GET',null), "text": "Auswahl umkehren" } ],
  ls_url: "/invoicing/MyPlans",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.invoicing.MyPlans.detail;
    Lino.invoicing.MyPlans.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.MyPlans.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.invoicing.MyPlans.detailPanel(p);
});
Lino.invoicing.MyPlans.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.invoicing.Plans.ParamsPanel({});
  return new Lino.invoicing.MyPlans.GridPanel(p);
});
Lino.invoicing.MyPlans.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.update_plan = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "GET", pk, "update_plan", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.execute_plan = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "GET", pk, "execute_plan", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.toggle_selections = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/MyPlans", "GET", pk, "toggle_selections", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class invoicing.AllPlans
Lino.invoicing.AllPlans.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 14,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/invoicing/AllPlans",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/invoicing/AllPlans','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/AllPlans','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/AllPlans','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/AllPlans','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/invoicing/AllPlans','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "update_plan", "menu_item_text": "update_plan", "overflowText": "update_plan", "panel_btn_handler": Lino.row_action_handler('update_plan','GET',null), "tooltip": "Build a new list of suggestions. This will remove all current suggestions" }, { "auto_save": true, "iconCls": "x-tbar-money", "itemId": "execute_plan", "menu_item_text": "execute_plan", "overflowText": "execute_plan", "panel_btn_handler": Lino.row_action_handler('execute_plan','GET',null), "tooltip": "Execute this invoicing plan. Create an invoice for each selected suggestion." }, { "auto_save": true, "itemId": "toggle_selections", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Invert selection status for all suggestions.") }, "menu_item_text": "Auswahl umkehren", "overflowText": "Auswahl umkehren", "panel_btn_handler": Lino.row_action_handler('toggle_selections','GET',null), "text": "Auswahl umkehren" } ],
  cell_edit : true,
  title : "Fakturationspl\u00e4ne",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "today", "type": "date" }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "course" }, 'courseHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 48,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.invoicing.AllPlans.detail;
    var ww = this.containing_window;
    var id10693 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user10694 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/AllPlans/user" }) }) });
    var journal10695 = new Lino.RemoteComboFieldElement({ "emptyText": "Journal ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/AllPlans/journal" }) }) });
    var today10696 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var max_date10697 = new Lino.DateField({ "selectOnFocus": true });
    var partner10698 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/AllPlans/partner" }) }) });
    var course10699 = new Lino.RemoteComboFieldElement({ "emptyText": "Activity ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/AllPlans/course" }) }) });
    var mobile_item_disp10700 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10701 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10702 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10693, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(invoicing.AllPlans.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user10694, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(invoicing.AllPlans.user) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "journal", "editable": true, "editor": journal10695, "filter": { "type": "string" }, "header": "Journal", "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(invoicing.AllPlans.journal) The journal where to create invoices.  When this field is\nempty, you can fill the plan with suggestions but cannot\nexecute the plan.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "today", "editable": true, "editor": today10696, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Rechnungsdatum", "sortable": true, "tooltip": "(invoicing.AllPlans.today) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "max_date", "editable": true, "editor": max_date10697, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Fakturierbare bis", "sortable": true, "tooltip": "(invoicing.AllPlans.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "partner", "editable": true, "editor": partner10698, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(invoicing.AllPlans.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "course", "editable": true, "editor": course10699, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(invoicing.AllPlans.course) If this field is nonempty, select only enrolments of that\ngiven course.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(invoicing.AllPlans.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(invoicing.AllPlans.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(invoicing.AllPlans.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.invoicing.AllPlans.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.AllPlans.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.AllPlans.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.AllPlans.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.AllPlans.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.AllPlans.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.AllPlans.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.AllPlans.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.AllPlans.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.invoicing.AllPlans.detailPanel = Ext.extend(Lino.invoicing.Plans.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "update_plan", "menu_item_text": "update_plan", "overflowText": "update_plan", "panel_btn_handler": Lino.row_action_handler('update_plan','GET',null), "tooltip": "Build a new list of suggestions. This will remove all current suggestions" }, { "auto_save": true, "iconCls": "x-tbar-money", "itemId": "execute_plan", "menu_item_text": "execute_plan", "overflowText": "execute_plan", "panel_btn_handler": Lino.row_action_handler('execute_plan','GET',null), "tooltip": "Execute this invoicing plan. Create an invoice for each selected suggestion." }, { "auto_save": true, "itemId": "toggle_selections", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Invert selection status for all suggestions.") }, "menu_item_text": "Auswahl umkehren", "overflowText": "Auswahl umkehren", "panel_btn_handler": Lino.row_action_handler('toggle_selections','GET',null), "text": "Auswahl umkehren" } ],
  ls_url: "/invoicing/AllPlans",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.invoicing.AllPlans.detail;
    Lino.invoicing.AllPlans.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.AllPlans.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.invoicing.AllPlans.detailPanel(p);
});
Lino.invoicing.AllPlans.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.AllPlans.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.AllPlans.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.invoicing.Plans.ParamsPanel({});
  return new Lino.invoicing.AllPlans.GridPanel(p);
});
Lino.invoicing.AllPlans.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.AllPlans.update_plan = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "GET", pk, "update_plan", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.AllPlans.execute_plan = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "GET", pk, "execute_plan", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.AllPlans.toggle_selections = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/AllPlans", "GET", pk, "toggle_selections", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class invoicing.Items
Lino.invoicing.Items.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 16,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/invoicing/Items",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/invoicing/Items','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/Items','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/Items','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/Items','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/invoicing/Items','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Fakturationsvorschl\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "plan" }, 'planHidden', { "name": "partner" }, 'partnerHidden', { "dateFormat": "d.m.Y", "name": "first_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "last_date", "type": "date" }, { "name": "amount" }, { "name": "number_of_invoiceables", "type": "int", "useNull": true }, { "name": "preview" }, { "name": "selected", "type": "boolean" }, { "name": "invoice" }, 'invoiceHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 47,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id4788 = new Ext.form.NumberField({ "selectOnFocus": true });
    var plan4789 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Fakturationsplan ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Items/plan" }) }) });
    var partner4790 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Items/partner" }) }) });
    var first_date4791 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var last_date4792 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var amount4793 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var number_of_invoiceables4794 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 0 });
    var preview4795 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var selected4796 = new Ext.form.Checkbox({ "checked": true, "selectOnFocus": true });
    var invoice4797 = new Lino.RemoteComboFieldElement({ "emptyText": "Produktrechnung ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Items/invoice" }) }) });
    var mobile_item_disp4798 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4799 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4800 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4788, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(invoicing.Items.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "plan", "editable": true, "editor": plan4789, "filter": { "type": "string" }, "header": "Fakturationsplan", "renderer": Lino.fk_renderer('planHidden','Lino.invoicing.Plans.detail'), "sortable": false, "tooltip": "(invoicing.Items.plan) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "partner", "editable": true, "editor": partner4790, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(invoicing.Items.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "first_date", "editable": true, "editor": first_date4791, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Erstes Datum", "sortable": true, "tooltip": "(invoicing.Items.first_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "last_date", "editable": true, "editor": last_date4792, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Letztes Datum", "sortable": true, "tooltip": "(invoicing.Items.last_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "amount", "editable": true, "editor": amount4793, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "sortable": true, "tooltip": "(invoicing.Items.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "number_of_invoiceables", "editable": true, "editor": number_of_invoiceables4794, "filter": { "type": "numeric" }, "format": "0", "header": "Number", "sortable": true, "tooltip": "(invoicing.Items.number_of_invoiceables) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "preview", "editable": true, "editor": preview4795, "filter": { "type": "string" }, "header": "Vorschau", "sortable": false, "tooltip": "(invoicing.Items.preview) A textual preview of the invoiceable items to be included in\nthe invoice.", "width": Lino.chars2width(61) }, { "colIndex": 8, "dataIndex": "selected", "editable": true, "filter": { "type": "boolean" }, "header": "Selected", "sortable": false, "tooltip": "(invoicing.Items.selected) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 9, "dataIndex": "invoice", "editable": true, "editor": invoice4797, "filter": { "type": "string" }, "header": "Rechnung", "renderer": Lino.fk_renderer('invoiceHidden','Lino.sales.Invoices.detail'), "sortable": false, "tooltip": "(invoicing.Items.invoice) The invoice that has been generated. This field is empty for\nnew items. When an item has been executed, this field points\nto the generated invoice.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(invoicing.Items.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(invoicing.Items.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(invoicing.Items.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.invoicing.Items.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.Items.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Items", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Items", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Items", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Items", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Items", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Items", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Items", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Items", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.invoicing.Items.GridPanel(p);
});
Lino.invoicing.Items.exec_item = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/Items", "GET", pk, "exec_item", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.FinancialVouchers
Lino.finan.FinancialVouchers.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 24,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/FinancialVouchers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/FinancialVouchers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/FinancialVouchers','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/FinancialVouchers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/FinancialVouchers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/FinancialVouchers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Diverse Buchungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "dateFormat": "d.m.Y", "name": "last_item_date", "type": "date" }, { "name": "number_with_year" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.FinancialVouchers.detail;
    this.ls_insert_handler = Lino.finan.FinancialVouchers.insert;
    var ww = this.containing_window;
    var id4802 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user4803 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/user" }) }) });
    var journal4804 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/journal" }) }) });
    var entry_date4805 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var voucher_date4806 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var accounting_period4807 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/accounting_period" }) }) });
    var number4808 = new Ext.form.NumberField({ "selectOnFocus": true });
    var narration4809 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var state4810 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by4811 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account4812 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/item_account" }) }) });
    var item_remark4813 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var last_item_date4814 = new Lino.DateField({ "selectOnFocus": true });
    var number_with_year_disp4815 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4816 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4817 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4818 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp4819 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4802, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(finan.FinancialVouchers.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user4803, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.FinancialVouchers.user) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "journal", "editable": true, "editor": journal4804, "filter": { "type": "string" }, "header": "Journal", "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(finan.FinancialVouchers.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "entry_date", "editable": true, "editor": entry_date4805, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(finan.FinancialVouchers.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4806, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "sortable": true, "tooltip": "(finan.FinancialVouchers.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4807, "filter": { "type": "string" }, "header": "Buchungsperiode", "sortable": false, "tooltip": "(finan.FinancialVouchers.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "number", "editable": true, "editor": number4808, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(finan.FinancialVouchers.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "narration", "editable": true, "editor": narration4809, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(finan.FinancialVouchers.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "state", "editable": true, "editor": state4810, "filter": { "type": "string" }, "header": "Zustand", "sortable": false, "tooltip": "(finan.FinancialVouchers.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 9, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.FinancialVouchers.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "item_account", "editable": true, "editor": item_account4812, "filter": { "type": "string" }, "header": "Standardwert Konto", "sortable": false, "tooltip": "(finan.FinancialVouchers.item_account) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "item_remark", "editable": true, "editor": item_remark4813, "filter": { "type": "string" }, "header": "Ihr Zeichen", "sortable": true, "tooltip": "(finan.FinancialVouchers.item_remark) ", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "last_item_date", "editable": true, "editor": last_item_date4814, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "last item date", "sortable": true, "tooltip": "(finan.FinancialVouchers.last_item_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 13, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "hidden": true, "sortable": false, "tooltip": "(finan.FinancialVouchers.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 14, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.FinancialVouchers.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.FinancialVouchers.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(finan.FinancialVouchers.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(finan.FinancialVouchers.printed) ", "width": Lino.chars2width(31) } ];
    Lino.finan.FinancialVouchers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.FinancialVouchers.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.FinancialVouchers.insertPanel = Ext.extend(Lino.finan.FinancialVouchers.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/finan/FinancialVouchers",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.FinancialVouchers.detail;
    this.ls_insert_handler = Lino.finan.FinancialVouchers.insert;
    Lino.finan.FinancialVouchers.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.FinancialVouchers.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.FinancialVouchers.insertPanel(p);
});
Lino.finan.FinancialVouchers.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.FinancialVouchers.detailPanel = Ext.extend(Lino.finan.FinancialVouchers.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/FinancialVouchers",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.FinancialVouchers.detail;
    this.ls_insert_handler = Lino.finan.FinancialVouchers.insert;
    Lino.finan.FinancialVouchers.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.FinancialVouchers.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.FinancialVouchers.detailPanel(p);
});
Lino.finan.FinancialVouchers.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.FinancialVouchers.GridPanel(p);
});
Lino.finan.FinancialVouchers.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/FinancialVouchers", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.JournalEntries
Lino.finan.JournalEntries.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 24,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/JournalEntries",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntries','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntries','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntries','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntries','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntries','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Diverse Buchungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "narration" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "dateFormat": "d.m.Y", "name": "last_item_date", "type": "date" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.JournalEntries.detail;
    this.ls_insert_handler = Lino.finan.JournalEntries.insert;
    var ww = this.containing_window;
    var number_with_year_disp4821 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var entry_date4822 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var narration4823 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var accounting_period4824 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntries/accounting_period" }) }) });
    var workflow_buttons_disp4825 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4826 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user4827 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntries/user" }) }) });
    var journal4828 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntries/journal" }) }) });
    var voucher_date4829 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number4830 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state4831 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by4832 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account4833 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntries/item_account" }) }) });
    var item_remark4834 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_item_date4835 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp4836 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4837 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp4838 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "sortable": false, "tooltip": "(finan.JournalEntries.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date4822, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(finan.JournalEntries.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "narration", "editable": true, "editor": narration4823, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(finan.JournalEntries.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4824, "filter": { "type": "string" }, "header": "Buchungsperiode", "sortable": false, "tooltip": "(finan.JournalEntries.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(finan.JournalEntries.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4826, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntries.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "user", "editable": true, "editor": user4827, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.JournalEntries.user) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "journal", "editable": true, "editor": journal4828, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(finan.JournalEntries.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4829, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntries.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 9, "dataIndex": "number", "editable": true, "editor": number4830, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntries.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 10, "dataIndex": "state", "editable": true, "editor": state4831, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntries.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 11, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.JournalEntries.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "item_account", "editable": true, "editor": item_account4833, "filter": { "type": "string" }, "header": "Standardwert Konto", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntries.item_account) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "item_remark", "editable": true, "editor": item_remark4834, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntries.item_remark) ", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "last_item_date", "editable": true, "editor": last_item_date4835, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "last item date", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntries.last_item_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 15, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntries.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntries.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntries.printed) ", "width": Lino.chars2width(31) } ];
    Lino.finan.JournalEntries.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntries.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.JournalEntries.insertPanel = Ext.extend(Lino.finan.FinancialVouchers.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/finan/JournalEntries",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.JournalEntries.detail;
    this.ls_insert_handler = Lino.finan.JournalEntries.insert;
    Lino.finan.JournalEntries.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntries.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.JournalEntries.insertPanel(p);
});
Lino.finan.JournalEntries.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.JournalEntries.detailPanel = Ext.extend(Lino.finan.FinancialVouchers.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/JournalEntries",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.JournalEntries.detail;
    this.ls_insert_handler = Lino.finan.JournalEntries.insert;
    Lino.finan.JournalEntries.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntries.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.JournalEntries.detailPanel(p);
});
Lino.finan.JournalEntries.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.suggest = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.JournalEntries.GridPanel(p);
});
Lino.finan.JournalEntries.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntries", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.PaymentOrders
Lino.finan.PaymentOrders.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 26,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/PaymentOrders",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrders','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrders','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrders','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrders','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrders','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "write_xml", "menu_item_text": "Write XML", "overflowText": "Write XML", "panel_btn_handler": Lino.row_action_handler('write_xml','GET',null), "text": "Write XML" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Payment Order", "overflowText": "Payment Order", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Zahlungsauftr\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "narration" }, { "name": "total" }, { "dateFormat": "d.m.Y", "name": "execution_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "name": "print_actions" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.PaymentOrders.detail;
    this.ls_insert_handler = Lino.finan.PaymentOrders.insert;
    var ww = this.containing_window;
    var number_with_year_disp4840 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var entry_date4841 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var narration4842 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var total4843 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var execution_date4844 = new Lino.DateField({ "selectOnFocus": true });
    var accounting_period4845 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/accounting_period" }) }) });
    var workflow_buttons_disp4846 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4847 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user4848 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/user" }) }) });
    var journal4849 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/journal" }) }) });
    var voucher_date4850 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number4851 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state4852 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by4853 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account4854 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/item_account" }) }) });
    var item_remark4855 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var print_actions_disp4856 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4857 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4858 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp4859 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "sortable": false, "tooltip": "(finan.PaymentOrders.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date4841, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(finan.PaymentOrders.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "narration", "editable": true, "editor": narration4842, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(finan.PaymentOrders.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "total", "editable": true, "editor": total4843, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total", "sortable": true, "tooltip": "(finan.PaymentOrders.total) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "execution_date", "editable": true, "editor": execution_date4844, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Ausf\u00fchrungsdatum", "sortable": true, "tooltip": "(finan.PaymentOrders.execution_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4845, "filter": { "type": "string" }, "header": "Buchungsperiode", "sortable": false, "tooltip": "(finan.PaymentOrders.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(finan.PaymentOrders.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id4847, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrders.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user4848, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.PaymentOrders.user) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "journal", "editable": true, "editor": journal4849, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(finan.PaymentOrders.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4850, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrders.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 11, "dataIndex": "number", "editable": true, "editor": number4851, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrders.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "state", "editable": true, "editor": state4852, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrders.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 13, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.PaymentOrders.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "item_account", "editable": true, "editor": item_account4854, "filter": { "type": "string" }, "header": "Standardwert Konto", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrders.item_account) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "item_remark", "editable": true, "editor": item_remark4855, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrders.item_remark) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrders.print_actions) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrders.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrders.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrders.printed) ", "width": Lino.chars2width(31) } ];
    Lino.finan.PaymentOrders.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrders.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.PaymentOrders.insertPanel = Ext.extend(Lino.finan.FinancialVouchers.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/finan/PaymentOrders",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.PaymentOrders.detail;
    this.ls_insert_handler = Lino.finan.PaymentOrders.insert;
    Lino.finan.PaymentOrders.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrders.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.PaymentOrders.insertPanel(p);
});
Lino.finan.PaymentOrders.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.PaymentOrders.detailPanel = Ext.extend(Lino.finan.PaymentOrders.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "write_xml", "menu_item_text": "Write XML", "overflowText": "Write XML", "panel_btn_handler": Lino.row_action_handler('write_xml','GET',null), "text": "Write XML" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Payment Order", "overflowText": "Payment Order", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/PaymentOrders",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.PaymentOrders.detail;
    this.ls_insert_handler = Lino.finan.PaymentOrders.insert;
    Lino.finan.PaymentOrders.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrders.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.PaymentOrders.detailPanel(p);
});
Lino.finan.PaymentOrders.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.write_xml = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "write_xml", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.suggest = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.PaymentOrders.GridPanel(p);
});
Lino.finan.PaymentOrders.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrders", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.BankStatements
Lino.finan.BankStatements.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 26,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/BankStatements",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatements','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatements','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatements','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatements','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatements','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Bank Statement", "overflowText": "Bank Statement", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Kontoausz\u00fcge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "balance1" }, { "name": "balance2" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "dateFormat": "d.m.Y", "name": "last_item_date", "type": "date" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.BankStatements.detail;
    this.ls_insert_handler = Lino.finan.BankStatements.insert;
    var ww = this.containing_window;
    var number_with_year_disp4861 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var entry_date4862 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var balance14863 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var balance24864 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var accounting_period4865 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/accounting_period" }) }) });
    var workflow_buttons_disp4866 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4867 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user4868 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/user" }) }) });
    var journal4869 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/journal" }) }) });
    var voucher_date4870 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number4871 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var narration4872 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state4873 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by4874 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account4875 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/item_account" }) }) });
    var item_remark4876 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_item_date4877 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp4878 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4879 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp4880 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "sortable": false, "tooltip": "(finan.BankStatements.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date4862, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(finan.BankStatements.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "balance1", "editable": true, "editor": balance14863, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Alter Saldo", "sortable": true, "tooltip": "(finan.BankStatements.balance1) The old (or start) balance.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 3, "dataIndex": "balance2", "editable": true, "editor": balance24864, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Neuer Saldo", "sortable": true, "tooltip": "(finan.BankStatements.balance2) The new (or end) balance.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4865, "filter": { "type": "string" }, "header": "Buchungsperiode", "sortable": false, "tooltip": "(finan.BankStatements.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(finan.BankStatements.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id4867, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatements.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user4868, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.BankStatements.user) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "journal", "editable": true, "editor": journal4869, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(finan.BankStatements.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4870, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatements.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 10, "dataIndex": "number", "editable": true, "editor": number4871, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatements.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "narration", "editable": true, "editor": narration4872, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatements.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "state", "editable": true, "editor": state4873, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatements.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 13, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.BankStatements.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "item_account", "editable": true, "editor": item_account4875, "filter": { "type": "string" }, "header": "Standardwert Konto", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatements.item_account) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "item_remark", "editable": true, "editor": item_remark4876, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatements.item_remark) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "last_item_date", "editable": true, "editor": last_item_date4877, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "last item date", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatements.last_item_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 17, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatements.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatements.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatements.printed) ", "width": Lino.chars2width(31) } ];
    Lino.finan.BankStatements.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatements.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.BankStatements.insertPanel = Ext.extend(Lino.finan.BankStatements.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/finan/BankStatements",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.BankStatements.detail;
    this.ls_insert_handler = Lino.finan.BankStatements.insert;
    Lino.finan.BankStatements.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatements.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.BankStatements.insertPanel(p);
});
Lino.finan.BankStatements.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.BankStatements.detailPanel = Ext.extend(Lino.finan.BankStatements.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Bank Statement", "overflowText": "Bank Statement", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/BankStatements",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.BankStatements.detail;
    this.ls_insert_handler = Lino.finan.BankStatements.insert;
    Lino.finan.BankStatements.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatements.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.BankStatements.detailPanel(p);
});
Lino.finan.BankStatements.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.suggest = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.BankStatements.GridPanel(p);
});
Lino.finan.BankStatements.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatements", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.AllBankStatements
Lino.finan.AllBankStatements.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 26,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/AllBankStatements",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/AllBankStatements','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/AllBankStatements','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/AllBankStatements','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/AllBankStatements','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/AllBankStatements','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Bank Statement", "overflowText": "Bank Statement", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Kontoausz\u00fcge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "balance1" }, { "name": "balance2" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "dateFormat": "d.m.Y", "name": "last_item_date", "type": "date" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.AllBankStatements.detail;
    this.ls_insert_handler = Lino.finan.AllBankStatements.insert;
    var ww = this.containing_window;
    var number_with_year_disp10704 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var entry_date10705 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var balance110706 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var balance210707 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var accounting_period10708 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/AllBankStatements/accounting_period" }) }) });
    var workflow_buttons_disp10709 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id10710 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user10711 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/AllBankStatements/user" }) }) });
    var journal10712 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/AllBankStatements/journal" }) }) });
    var voucher_date10713 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number10714 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var narration10715 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state10716 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by10717 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account10718 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/AllBankStatements/item_account" }) }) });
    var item_remark10719 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_item_date10720 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10721 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10722 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp10723 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "sortable": false, "tooltip": "(finan.AllBankStatements.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date10705, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(finan.AllBankStatements.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "balance1", "editable": true, "editor": balance110706, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Alter Saldo", "sortable": true, "tooltip": "(finan.AllBankStatements.balance1) The old (or start) balance.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 3, "dataIndex": "balance2", "editable": true, "editor": balance210707, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Neuer Saldo", "sortable": true, "tooltip": "(finan.AllBankStatements.balance2) The new (or end) balance.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period10708, "filter": { "type": "string" }, "header": "Buchungsperiode", "sortable": false, "tooltip": "(finan.AllBankStatements.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(finan.AllBankStatements.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id10710, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.AllBankStatements.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user10711, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.AllBankStatements.user) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "journal", "editable": true, "editor": journal10712, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(finan.AllBankStatements.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date10713, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(finan.AllBankStatements.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 10, "dataIndex": "number", "editable": true, "editor": number10714, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(finan.AllBankStatements.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "narration", "editable": true, "editor": narration10715, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(finan.AllBankStatements.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "state", "editable": true, "editor": state10716, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(finan.AllBankStatements.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 13, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.AllBankStatements.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "item_account", "editable": true, "editor": item_account10718, "filter": { "type": "string" }, "header": "Standardwert Konto", "hidden": true, "sortable": false, "tooltip": "(finan.AllBankStatements.item_account) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "item_remark", "editable": true, "editor": item_remark10719, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(finan.AllBankStatements.item_remark) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "last_item_date", "editable": true, "editor": last_item_date10720, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "last item date", "hidden": true, "sortable": true, "tooltip": "(finan.AllBankStatements.last_item_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 17, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.AllBankStatements.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.AllBankStatements.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(finan.AllBankStatements.printed) ", "width": Lino.chars2width(31) } ];
    Lino.finan.AllBankStatements.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.AllBankStatements.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.AllBankStatements.insertPanel = Ext.extend(Lino.finan.BankStatements.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/finan/AllBankStatements",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.AllBankStatements.detail;
    this.ls_insert_handler = Lino.finan.AllBankStatements.insert;
    Lino.finan.AllBankStatements.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.AllBankStatements.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.AllBankStatements.insertPanel(p);
});
Lino.finan.AllBankStatements.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.AllBankStatements.detailPanel = Ext.extend(Lino.finan.BankStatements.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Bank Statement", "overflowText": "Bank Statement", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/AllBankStatements",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.AllBankStatements.detail;
    this.ls_insert_handler = Lino.finan.AllBankStatements.insert;
    Lino.finan.AllBankStatements.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.AllBankStatements.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.AllBankStatements.detailPanel(p);
});
Lino.finan.AllBankStatements.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.suggest = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.AllBankStatements.GridPanel(p);
});
Lino.finan.AllBankStatements.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllBankStatements.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllBankStatements", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.AllJournalEntries
Lino.finan.AllJournalEntries.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 24,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/AllJournalEntries",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/AllJournalEntries','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/AllJournalEntries','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/AllJournalEntries','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/AllJournalEntries','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/AllJournalEntries','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Diverse Buchungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "narration" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "dateFormat": "d.m.Y", "name": "last_item_date", "type": "date" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.AllJournalEntries.detail;
    this.ls_insert_handler = Lino.finan.AllJournalEntries.insert;
    var ww = this.containing_window;
    var number_with_year_disp10725 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var entry_date10726 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var narration10727 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var accounting_period10728 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/AllJournalEntries/accounting_period" }) }) });
    var workflow_buttons_disp10729 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id10730 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user10731 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/AllJournalEntries/user" }) }) });
    var journal10732 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/AllJournalEntries/journal" }) }) });
    var voucher_date10733 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number10734 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state10735 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by10736 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account10737 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/AllJournalEntries/item_account" }) }) });
    var item_remark10738 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_item_date10739 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10740 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10741 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp10742 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "sortable": false, "tooltip": "(finan.AllJournalEntries.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date10726, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(finan.AllJournalEntries.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "narration", "editable": true, "editor": narration10727, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(finan.AllJournalEntries.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period10728, "filter": { "type": "string" }, "header": "Buchungsperiode", "sortable": false, "tooltip": "(finan.AllJournalEntries.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(finan.AllJournalEntries.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id10730, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.AllJournalEntries.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "user", "editable": true, "editor": user10731, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.AllJournalEntries.user) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "journal", "editable": true, "editor": journal10732, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(finan.AllJournalEntries.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date10733, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(finan.AllJournalEntries.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 9, "dataIndex": "number", "editable": true, "editor": number10734, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(finan.AllJournalEntries.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 10, "dataIndex": "state", "editable": true, "editor": state10735, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(finan.AllJournalEntries.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 11, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.AllJournalEntries.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "item_account", "editable": true, "editor": item_account10737, "filter": { "type": "string" }, "header": "Standardwert Konto", "hidden": true, "sortable": false, "tooltip": "(finan.AllJournalEntries.item_account) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "item_remark", "editable": true, "editor": item_remark10738, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(finan.AllJournalEntries.item_remark) ", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "last_item_date", "editable": true, "editor": last_item_date10739, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "last item date", "hidden": true, "sortable": true, "tooltip": "(finan.AllJournalEntries.last_item_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 15, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.AllJournalEntries.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.AllJournalEntries.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(finan.AllJournalEntries.printed) ", "width": Lino.chars2width(31) } ];
    Lino.finan.AllJournalEntries.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.AllJournalEntries.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.AllJournalEntries.insertPanel = Ext.extend(Lino.finan.FinancialVouchers.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/finan/AllJournalEntries",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.AllJournalEntries.detail;
    this.ls_insert_handler = Lino.finan.AllJournalEntries.insert;
    Lino.finan.AllJournalEntries.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.AllJournalEntries.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.AllJournalEntries.insertPanel(p);
});
Lino.finan.AllJournalEntries.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.AllJournalEntries.detailPanel = Ext.extend(Lino.finan.FinancialVouchers.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/AllJournalEntries",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.AllJournalEntries.detail;
    this.ls_insert_handler = Lino.finan.AllJournalEntries.insert;
    Lino.finan.AllJournalEntries.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.AllJournalEntries.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.AllJournalEntries.detailPanel(p);
});
Lino.finan.AllJournalEntries.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.suggest = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.AllJournalEntries.GridPanel(p);
});
Lino.finan.AllJournalEntries.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllJournalEntries.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllJournalEntries", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.AllPaymentOrders
Lino.finan.AllPaymentOrders.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 26,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/AllPaymentOrders",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/AllPaymentOrders','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/AllPaymentOrders','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/AllPaymentOrders','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/AllPaymentOrders','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/AllPaymentOrders','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "write_xml", "menu_item_text": "Write XML", "overflowText": "Write XML", "panel_btn_handler": Lino.row_action_handler('write_xml','GET',null), "text": "Write XML" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Payment Order", "overflowText": "Payment Order", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Zahlungsauftr\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "narration" }, { "name": "total" }, { "dateFormat": "d.m.Y", "name": "execution_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "name": "print_actions" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.AllPaymentOrders.detail;
    this.ls_insert_handler = Lino.finan.AllPaymentOrders.insert;
    var ww = this.containing_window;
    var number_with_year_disp10744 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var entry_date10745 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var narration10746 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var total10747 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var execution_date10748 = new Lino.DateField({ "selectOnFocus": true });
    var accounting_period10749 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/AllPaymentOrders/accounting_period" }) }) });
    var workflow_buttons_disp10750 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id10751 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user10752 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/AllPaymentOrders/user" }) }) });
    var journal10753 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/AllPaymentOrders/journal" }) }) });
    var voucher_date10754 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number10755 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state10756 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by10757 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account10758 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/AllPaymentOrders/item_account" }) }) });
    var item_remark10759 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var print_actions_disp10760 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp10761 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10762 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp10763 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "sortable": false, "tooltip": "(finan.AllPaymentOrders.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date10745, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(finan.AllPaymentOrders.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "narration", "editable": true, "editor": narration10746, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(finan.AllPaymentOrders.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "total", "editable": true, "editor": total10747, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total", "sortable": true, "tooltip": "(finan.AllPaymentOrders.total) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "execution_date", "editable": true, "editor": execution_date10748, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Ausf\u00fchrungsdatum", "sortable": true, "tooltip": "(finan.AllPaymentOrders.execution_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period10749, "filter": { "type": "string" }, "header": "Buchungsperiode", "sortable": false, "tooltip": "(finan.AllPaymentOrders.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(finan.AllPaymentOrders.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id10751, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.AllPaymentOrders.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user10752, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.AllPaymentOrders.user) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "journal", "editable": true, "editor": journal10753, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(finan.AllPaymentOrders.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date10754, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(finan.AllPaymentOrders.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 11, "dataIndex": "number", "editable": true, "editor": number10755, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(finan.AllPaymentOrders.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "state", "editable": true, "editor": state10756, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(finan.AllPaymentOrders.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 13, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.AllPaymentOrders.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "item_account", "editable": true, "editor": item_account10758, "filter": { "type": "string" }, "header": "Standardwert Konto", "hidden": true, "sortable": false, "tooltip": "(finan.AllPaymentOrders.item_account) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "item_remark", "editable": true, "editor": item_remark10759, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(finan.AllPaymentOrders.item_remark) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(finan.AllPaymentOrders.print_actions) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.AllPaymentOrders.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.AllPaymentOrders.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(finan.AllPaymentOrders.printed) ", "width": Lino.chars2width(31) } ];
    Lino.finan.AllPaymentOrders.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.AllPaymentOrders.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.AllPaymentOrders.insertPanel = Ext.extend(Lino.finan.FinancialVouchers.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/finan/AllPaymentOrders",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.AllPaymentOrders.detail;
    this.ls_insert_handler = Lino.finan.AllPaymentOrders.insert;
    Lino.finan.AllPaymentOrders.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.AllPaymentOrders.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.AllPaymentOrders.insertPanel(p);
});
Lino.finan.AllPaymentOrders.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.AllPaymentOrders.detailPanel = Ext.extend(Lino.finan.PaymentOrders.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "write_xml", "menu_item_text": "Write XML", "overflowText": "Write XML", "panel_btn_handler": Lino.row_action_handler('write_xml','GET',null), "text": "Write XML" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Payment Order", "overflowText": "Payment Order", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/AllPaymentOrders",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.AllPaymentOrders.detail;
    this.ls_insert_handler = Lino.finan.AllPaymentOrders.insert;
    Lino.finan.AllPaymentOrders.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.AllPaymentOrders.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.AllPaymentOrders.detailPanel(p);
});
Lino.finan.AllPaymentOrders.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.write_xml = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "write_xml", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.suggest = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.AllPaymentOrders.GridPanel(p);
});
Lino.finan.AllPaymentOrders.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.AllPaymentOrders.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/AllPaymentOrders", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sepa.Accounts
Lino.sepa.Accounts.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 11,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sepa/Accounts",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sepa/Accounts','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sepa/Accounts','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sepa/Accounts','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sepa/Accounts','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sepa/Accounts','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Bankkonten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "partner" }, 'partnerHidden', { "name": "iban" }, { "name": "bic" }, { "name": "remark" }, { "name": "primary", "type": "boolean" }, { "name": "statements" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 65,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id10765 = new Ext.form.NumberField({ "selectOnFocus": true });
    var partner10766 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sepa/Accounts/partner" }) }) });
    var iban10767 = new Lino.UppercaseTextField({ "allowBlank": false, "maxLength": 34, "selectOnFocus": true });
    var bic10768 = new Lino.UppercaseTextField({ "maxLength": 11, "selectOnFocus": true });
    var remark10769 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var primary10770 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var statements_disp10771 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp10772 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10773 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10774 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10765, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(sepa.Accounts.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner10766, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sepa.Accounts.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "iban", "editable": true, "editor": iban10767, "filter": { "type": "string" }, "header": "IBAN", "renderer": Lino.iban_renderer, "sortable": true, "tooltip": "(sepa.Accounts.iban) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "bic", "editable": true, "editor": bic10768, "filter": { "type": "string" }, "header": "BIC", "sortable": true, "tooltip": "(sepa.Accounts.bic) ", "width": Lino.chars2width(13) }, { "colIndex": 4, "dataIndex": "remark", "editable": true, "editor": remark10769, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(sepa.Accounts.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "primary", "editable": true, "filter": { "type": "boolean" }, "header": "Prim\u00e4r", "sortable": false, "tooltip": "(sepa.Accounts.primary) Enabling this field will automatically disable any previous primary account and update the partner's IBAN and BIC", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 6, "dataIndex": "statements", "editable": false, "header": "Kontoausz\u00fcge", "hidden": true, "sortable": false, "tooltip": "(sepa.Accounts.statements) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sepa.Accounts.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sepa.Accounts.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(sepa.Accounts.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.sepa.Accounts.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sepa.Accounts.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/Accounts", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.Accounts.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/Accounts", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.Accounts.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/Accounts", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.Accounts.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/Accounts", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.Accounts.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/Accounts", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.Accounts.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/Accounts", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.Accounts.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/Accounts", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.Accounts.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/Accounts", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.Accounts.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sepa.Accounts.GridPanel(p);
});

// js_render_GridPanel_class notify.Messages
Lino.notify.Messages.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 21,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notify/Messages",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notify/Messages','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notify/Messages','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notify/Messages','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notify/Messages','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notify/Messages','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "mark_all_seen", "menu_item_text": "Alle als gelesen markieren", "overflowText": "Alle als gelesen markieren", "panel_btn_handler": Lino.list_action_handler('/notify/Messages','mark_all_seen','POST',null), "text": "Alle als gelesen markieren" } ],
  cell_edit : true,
  title : "Benachrichtigungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "created" }, { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "seen" }, { "name": "sent" }, { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "message_type" }, 'message_typeHidden', { "name": "body" }, { "name": "mail_mode" }, 'mail_modeHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "created_natural" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 66,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var created4882 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var subject4883 = new Ext.form.TextField({ "disabled": true, "maxLength": 250 });
    var user4884 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "store": new Lino.ComplexRemoteComboStore({  }) });
    var seen4885 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var sent4886 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var id4887 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type4888 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notify/Messages/owner_type" }) }) });
    var owner_id4889 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notify/Messages/owner_id" }) }) });
    var message_type4890 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.notify.MessageTypes });
    var body4891 = new Ext.form.HtmlEditor({ "disabled": true, "hidden": true });
    var mail_mode4892 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.notify.MailModes });
    var owner_disp4893 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp4894 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4895 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4896 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp4897 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      owner_id4889.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4888.on('change',Lino.chooser_handler(owner_id4889,'owner_type'));
      Lino.notify.Messages.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "created", "editable": false, "header": "Erstellt", "sortable": true, "tooltip": "(notify.Messages.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "subject", "editable": false, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(notify.Messages.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "user", "editable": false, "filter": { "type": "string" }, "header": "Empf\u00e4nger", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notify.Messages.user) The recipient.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "seen", "editable": false, "header": "gelesen", "sortable": true, "tooltip": "(notify.Messages.seen) ", "width": Lino.chars2width(17) }, { "colIndex": 4, "dataIndex": "sent", "editable": false, "header": "verschickt", "sortable": true, "tooltip": "(notify.Messages.sent) ", "width": Lino.chars2width(17) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4887, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notify.Messages.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "owner_type", "editable": true, "editor": owner_type4888, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notify.Messages.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "owner_id", "editable": true, "editor": owner_id4889, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "message_type", "editable": true, "editor": message_type4890, "filter": { "type": "string" }, "header": "Message Type", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.message_type) ", "width": Lino.chars2width(16) }, { "colIndex": 9, "dataIndex": "body", "editable": false, "filter": { "type": "string" }, "header": "Inhalt", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.body) ", "width": Lino.chars2width(61) }, { "colIndex": 10, "dataIndex": "mail_mode", "editable": true, "editor": mail_mode4892, "filter": { "type": "string" }, "header": "Benachrichtigungen per E-Mail", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.mail_mode) ", "width": Lino.chars2width(10) }, { "colIndex": 11, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.owner) The database object which controls this message.", "width": Lino.chars2width(11) }, { "colIndex": 12, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.created_natural) ", "width": Lino.chars2width(31) } ];
    Lino.notify.Messages.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notify.Messages.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/Messages", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/Messages", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/Messages", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/Messages", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/Messages", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/Messages", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/Messages", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/Messages", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notify.Messages.ParamsPanel({});
  return new Lino.notify.Messages.GridPanel(p);
});
Lino.notify.Messages.mark_seen = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/Messages", "GET", pk, "mark_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.mark_all_seen = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/Messages", "POST", pk, "mark_all_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.clear_seen = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/Messages", "GET", pk, "clear_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notify.AllMessages
Lino.notify.AllMessages.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 21,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notify/AllMessages",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notify/AllMessages','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notify/AllMessages','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notify/AllMessages','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notify/AllMessages','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notify/AllMessages','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "mark_all_seen", "menu_item_text": "Alle als gelesen markieren", "overflowText": "Alle als gelesen markieren", "panel_btn_handler": Lino.list_action_handler('/notify/AllMessages','mark_all_seen','POST',null), "text": "Alle als gelesen markieren" } ],
  cell_edit : true,
  title : "Benachrichtigungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "created" }, { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "seen" }, { "name": "sent" }, { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "message_type" }, 'message_typeHidden', { "name": "body" }, { "name": "mail_mode" }, 'mail_modeHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "created_natural" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 66,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var created10776 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var subject10777 = new Ext.form.TextField({ "disabled": true, "maxLength": 250 });
    var user10778 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "store": new Lino.ComplexRemoteComboStore({  }) });
    var seen10779 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var sent10780 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var id10781 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type10782 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notify/AllMessages/owner_type" }) }) });
    var owner_id10783 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notify/AllMessages/owner_id" }) }) });
    var message_type10784 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.notify.MessageTypes });
    var body10785 = new Ext.form.HtmlEditor({ "disabled": true, "hidden": true });
    var mail_mode10786 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.notify.MailModes });
    var owner_disp10787 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp10788 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10789 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10790 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp10791 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      owner_id10783.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type10782.on('change',Lino.chooser_handler(owner_id10783,'owner_type'));
      Lino.notify.AllMessages.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "created", "editable": false, "header": "Erstellt", "sortable": true, "tooltip": "(notify.AllMessages.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "subject", "editable": false, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(notify.AllMessages.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "user", "editable": false, "filter": { "type": "string" }, "header": "Empf\u00e4nger", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notify.AllMessages.user) The recipient.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "seen", "editable": false, "header": "gelesen", "sortable": true, "tooltip": "(notify.AllMessages.seen) ", "width": Lino.chars2width(17) }, { "colIndex": 4, "dataIndex": "sent", "editable": false, "header": "verschickt", "sortable": true, "tooltip": "(notify.AllMessages.sent) ", "width": Lino.chars2width(17) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id10781, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notify.AllMessages.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "owner_type", "editable": true, "editor": owner_type10782, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notify.AllMessages.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "owner_id", "editable": true, "editor": owner_id10783, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(notify.AllMessages.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "message_type", "editable": true, "editor": message_type10784, "filter": { "type": "string" }, "header": "Message Type", "hidden": true, "sortable": false, "tooltip": "(notify.AllMessages.message_type) ", "width": Lino.chars2width(16) }, { "colIndex": 9, "dataIndex": "body", "editable": false, "filter": { "type": "string" }, "header": "Inhalt", "hidden": true, "sortable": false, "tooltip": "(notify.AllMessages.body) ", "width": Lino.chars2width(61) }, { "colIndex": 10, "dataIndex": "mail_mode", "editable": true, "editor": mail_mode10786, "filter": { "type": "string" }, "header": "Benachrichtigungen per E-Mail", "hidden": true, "sortable": false, "tooltip": "(notify.AllMessages.mail_mode) ", "width": Lino.chars2width(10) }, { "colIndex": 11, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(notify.AllMessages.owner) The database object which controls this message.", "width": Lino.chars2width(11) }, { "colIndex": 12, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notify.AllMessages.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notify.AllMessages.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(notify.AllMessages.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(notify.AllMessages.created_natural) ", "width": Lino.chars2width(31) } ];
    Lino.notify.AllMessages.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notify.AllMessages.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/AllMessages", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.AllMessages.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/AllMessages", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.AllMessages.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/AllMessages", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.AllMessages.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/AllMessages", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.AllMessages.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/AllMessages", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.AllMessages.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/AllMessages", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.AllMessages.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/AllMessages", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.AllMessages.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/AllMessages", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.AllMessages.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notify.Messages.ParamsPanel({});
  return new Lino.notify.AllMessages.GridPanel(p);
});
Lino.notify.AllMessages.mark_all_seen = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/AllMessages", "POST", pk, "mark_all_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.AllMessages.mark_seen = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/AllMessages", "GET", pk, "mark_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.AllMessages.clear_seen = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/AllMessages", "GET", pk, "clear_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notify.MyMessages
Lino.notify.MyMessages.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 21,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notify/MyMessages",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notify/MyMessages','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notify/MyMessages','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notify/MyMessages','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notify/MyMessages','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notify/MyMessages','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "mark_all_seen", "menu_item_text": "Alle als gelesen markieren", "overflowText": "Alle als gelesen markieren", "panel_btn_handler": Lino.list_action_handler('/notify/MyMessages','mark_all_seen','POST',null), "text": "Alle als gelesen markieren" } ],
  cell_edit : true,
  title : "Meine Benachrichtigungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "created" }, { "name": "subject" }, { "name": "message_type" }, 'message_typeHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "seen" }, { "name": "sent" }, { "name": "body" }, { "name": "mail_mode" }, 'mail_modeHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "created_natural" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 66,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var created1057 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var subject1058 = new Ext.form.TextField({ "disabled": true, "maxLength": 250 });
    var message_type1059 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.notify.MessageTypes });
    var workflow_buttons_disp1060 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id1061 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user1062 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "store": new Lino.ComplexRemoteComboStore({  }) });
    var owner_type1063 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notify/MyMessages/owner_type" }) }) });
    var owner_id1064 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notify/MyMessages/owner_id" }) }) });
    var seen1065 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var sent1066 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var body1067 = new Ext.form.HtmlEditor({ "disabled": true, "hidden": true });
    var mail_mode1068 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.notify.MailModes });
    var owner_disp1069 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp1070 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1071 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp1072 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      owner_id1064.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type1063.on('change',Lino.chooser_handler(owner_id1064,'owner_type'));
      Lino.notify.MyMessages.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "created", "editable": false, "header": "Erstellt", "sortable": true, "tooltip": "(notify.MyMessages.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "subject", "editable": false, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(notify.MyMessages.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "message_type", "editable": true, "editor": message_type1059, "filter": { "type": "string" }, "header": "Message Type", "sortable": false, "tooltip": "(notify.MyMessages.message_type) ", "width": Lino.chars2width(16) }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(notify.MyMessages.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id1061, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notify.MyMessages.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "user", "editable": false, "filter": { "type": "string" }, "header": "Empf\u00e4nger", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notify.MyMessages.user) The recipient.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "owner_type", "editable": true, "editor": owner_type1063, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notify.MyMessages.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "owner_id", "editable": true, "editor": owner_id1064, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "seen", "editable": false, "header": "gelesen", "hidden": true, "sortable": true, "tooltip": "(notify.MyMessages.seen) ", "width": Lino.chars2width(17) }, { "colIndex": 9, "dataIndex": "sent", "editable": false, "header": "verschickt", "hidden": true, "sortable": true, "tooltip": "(notify.MyMessages.sent) ", "width": Lino.chars2width(17) }, { "colIndex": 10, "dataIndex": "body", "editable": false, "filter": { "type": "string" }, "header": "Inhalt", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.body) ", "width": Lino.chars2width(61) }, { "colIndex": 11, "dataIndex": "mail_mode", "editable": true, "editor": mail_mode1068, "filter": { "type": "string" }, "header": "Benachrichtigungen per E-Mail", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.mail_mode) ", "width": Lino.chars2width(10) }, { "colIndex": 12, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.owner) The database object which controls this message.", "width": Lino.chars2width(11) }, { "colIndex": 13, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.created_natural) ", "width": Lino.chars2width(31) } ];
    Lino.notify.MyMessages.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notify.MyMessages.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MyMessages", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MyMessages", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MyMessages", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MyMessages", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MyMessages", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MyMessages", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MyMessages", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MyMessages", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notify.Messages.ParamsPanel({});
  return new Lino.notify.MyMessages.GridPanel(p);
});
Lino.notify.MyMessages.mark_seen = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MyMessages", "GET", pk, "mark_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.mark_all_seen = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MyMessages", "POST", pk, "mark_all_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.clear_seen = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MyMessages", "GET", pk, "clear_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.NoteTypes
Lino.notes.NoteTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 15,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/NoteTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/NoteTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NoteTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NoteTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NoteTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/NoteTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Notizarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "build_method" }, 'build_methodHidden', { "name": "template" }, { "name": "special_type" }, { "name": "id", "type": "int" }, { "name": "attach_to_email", "type": "boolean" }, { "name": "email_template" }, { "name": "important", "type": "boolean" }, { "name": "remark" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 69,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NoteTypes.detail;
    this.ls_insert_handler = Lino.notes.NoteTypes.insert;
    var ww = this.containing_window;
    var name10793 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10794 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10795 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var build_method10796 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var template10797 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NoteTypes/template" }) }) });
    var special_type10798 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(5), "maxLength": 5, "selectOnFocus": true });
    var id10799 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var attach_to_email10800 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var email_template10801 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NoteTypes/email_template" }) }) });
    var important10802 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var remark10803 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10804 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10805 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10806 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      template10797.setContextValue('build_method', record ? record.data['build_methodHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      build_method10796.on('change',Lino.chooser_handler(template10797,'build_method'));
      Lino.notes.NoteTypes.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name10793, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(notes.NoteTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de10794, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(notes.NoteTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr10795, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(notes.NoteTypes.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "build_method", "editable": true, "editor": build_method10796, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "sortable": false, "tooltip": "(notes.NoteTypes.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 4, "dataIndex": "template", "editable": true, "editor": template10797, "filter": { "type": "string" }, "header": "Vorlage", "sortable": false, "tooltip": "(notes.NoteTypes.template) ", "width": Lino.chars2width(11) }, { "colIndex": 5, "dataIndex": "special_type", "editable": true, "editor": special_type10798, "filter": { "type": "string" }, "header": "Sondernotizart", "sortable": true, "tooltip": "(notes.NoteTypes.special_type) ", "width": Lino.chars2width(7) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id10799, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.NoteTypes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "attach_to_email", "editable": true, "filter": { "type": "boolean" }, "header": "als Anhang per E-Mail", "hidden": true, "sortable": false, "tooltip": "(notes.NoteTypes.attach_to_email) Whether the printable file should be attached to the email\nwhen creating an email from a mailable of this type.\n", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 8, "dataIndex": "email_template", "editable": true, "editor": email_template10801, "filter": { "type": "string" }, "header": "E-Mail-Vorlage", "hidden": true, "sortable": false, "tooltip": "(notes.NoteTypes.email_template) The name of the file to be used as template when creating an email from a mailable of this type.", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "important", "editable": true, "filter": { "type": "boolean" }, "header": "wichtig", "hidden": true, "sortable": false, "tooltip": "(notes.NoteTypes.important) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 10, "dataIndex": "remark", "editable": true, "editor": remark10803, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(notes.NoteTypes.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 11, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.NoteTypes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.NoteTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(notes.NoteTypes.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.notes.NoteTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NoteTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NoteTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NoteTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NoteTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NoteTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NoteTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NoteTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NoteTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NoteTypes.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NoteTypes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NoteTypes.insertPanel = Ext.extend(Lino.notes.NoteTypes.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/notes/NoteTypes",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NoteTypes.detail;
    this.ls_insert_handler = Lino.notes.NoteTypes.insert;
    Lino.notes.NoteTypes.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NoteTypes.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.notes.NoteTypes.insertPanel(p);
});
Lino.notes.NoteTypes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NoteTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NoteTypes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NoteTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NoteTypes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NoteTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NoteTypes.detailPanel = Ext.extend(Lino.notes.NoteTypes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/notes/NoteTypes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NoteTypes.detail;
    this.ls_insert_handler = Lino.notes.NoteTypes.insert;
    Lino.notes.NoteTypes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NoteTypes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.NoteTypes.detailPanel(p);
});
Lino.notes.NoteTypes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NoteTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NoteTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.NoteTypes.GridPanel(p);
});
Lino.notes.NoteTypes.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NoteTypes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.EventTypes
Lino.notes.EventTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 11,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/EventTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/EventTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/EventTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notes/EventTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/EventTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/EventTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Ereignisarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "id", "type": "int" }, { "name": "remark" }, { "name": "body" }, { "name": "body_de" }, { "name": "body_fr" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 68,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.EventTypes.detail;
    var ww = this.containing_window;
    var name10808 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10809 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10810 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id10811 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var remark10812 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var body10813 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var body_de10814 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var body_fr10815 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10816 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10817 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10818 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name10808, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(notes.EventTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de10809, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(notes.EventTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr10810, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(notes.EventTypes.name_fr) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id10811, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.EventTypes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "remark", "editable": true, "editor": remark10812, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(notes.EventTypes.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 5, "dataIndex": "body", "editable": true, "editor": body10813, "filter": { "type": "string" }, "header": "Inhalt", "hidden": true, "sortable": false, "tooltip": "(notes.EventTypes.body) ", "width": Lino.chars2width(61) }, { "colIndex": 6, "dataIndex": "body_de", "editable": true, "editor": body_de10814, "filter": { "type": "string" }, "header": "Inhalt (de)", "hidden": true, "sortable": false, "tooltip": "(notes.EventTypes.body_de) ", "width": Lino.chars2width(61) }, { "colIndex": 7, "dataIndex": "body_fr", "editable": true, "editor": body_fr10815, "filter": { "type": "string" }, "header": "Inhalt (fr)", "hidden": true, "sortable": false, "tooltip": "(notes.EventTypes.body_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 8, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.EventTypes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.EventTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(notes.EventTypes.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.notes.EventTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.EventTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/EventTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.EventTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/EventTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.EventTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/EventTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.EventTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/EventTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.EventTypes.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/EventTypes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.EventTypes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/EventTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.EventTypes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/EventTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.EventTypes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/EventTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.EventTypes.detailPanel = Ext.extend(Lino.notes.EventTypes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/notes/EventTypes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.EventTypes.detail;
    Lino.notes.EventTypes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.EventTypes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.EventTypes.detailPanel(p);
});
Lino.notes.EventTypes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/EventTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.EventTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.EventTypes.GridPanel(p);
});
Lino.notes.EventTypes.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/EventTypes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.Notes
Lino.notes.Notes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 30,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/Notes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/Notes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/Notes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notes/Notes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/Notes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/Notes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Notizen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "type" }, 'typeHidden', { "name": "subject" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "body" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.Notes.detail;
    var ww = this.containing_window;
    var date4899 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time4900 = new Lino.TimeField({ "selectOnFocus": true });
    var id4901 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user4902 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/user" }) }) });
    var event_type4903 = new Lino.RemoteComboFieldElement({ "emptyText": "Event Type ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/event_type" }) }) });
    var type4904 = new Lino.RemoteComboFieldElement({ "emptyText": "Notizart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/type" }) }) });
    var subject4905 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var build_time4906 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4907 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company4908 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/company" }) }) });
    var contact_person4909 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/contact_person" }) }) });
    var contact_role4910 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/contact_role" }) }) });
    var owner_type4911 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/owner_type" }) }) });
    var owner_id4912 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/owner_id" }) }) });
    var language4913 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var owner_disp4914 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp4915 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4916 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4917 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var body4918 = new Ext.form.HtmlEditor({ "selectOnFocus": true });
    this.before_row_edit = function(record) {
      contact_person4909.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id4912.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company4908.on('change',Lino.chooser_handler(contact_person4909,'company'));
      owner_type4911.on('change',Lino.chooser_handler(owner_id4912,'owner_type'));
      Lino.notes.Notes.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date4899, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum", "sortable": true, "tooltip": "(notes.Notes.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time4900, "header": "Zeit", "sortable": true, "tooltip": "(notes.Notes.time) ", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id4901, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(notes.Notes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user4902, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.Notes.user) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "event_type", "editable": true, "editor": event_type4903, "filter": { "type": "string" }, "header": "Ereignisart (Form)", "renderer": Lino.fk_renderer('event_typeHidden','Lino.notes.EventTypes.detail'), "sortable": false, "tooltip": "(notes.Notes.event_type) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "type", "editable": true, "editor": type4904, "filter": { "type": "string" }, "header": "Notizart (Inhalt)", "renderer": Lino.fk_renderer('typeHidden','Lino.notes.NoteTypes.detail'), "sortable": false, "tooltip": "(notes.Notes.type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "subject", "editable": true, "editor": subject4905, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(notes.Notes.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(notes.Notes.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "build_method", "editable": true, "editor": build_method4907, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 9, "dataIndex": "company", "editable": true, "editor": company4908, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Organisation)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.Notes.company) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "contact_person", "editable": true, "editor": contact_person4909, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.Notes.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "contact_role", "editable": true, "editor": contact_role4910, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_type", "editable": true, "editor": owner_type4911, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.Notes.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "owner_id", "editable": true, "editor": owner_id4912, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "language", "editable": true, "editor": language4913, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.language) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "body", "editable": true, "editor": body4918, "filter": { "type": "string" }, "header": "Inhalt", "sortable": false, "tooltip": "(notes.Notes.body) ", "width": Lino.chars2width(61) } ];
    Lino.notes.Notes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.Notes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.Notes.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/Notes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.Notes.detail;
    Lino.notes.Notes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.Notes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.Notes.detailPanel(p);
});
Lino.notes.Notes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.Notes.GridPanel(p);
});
Lino.notes.Notes.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/Notes", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.AllNotes
Lino.notes.AllNotes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 30,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/AllNotes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/AllNotes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/AllNotes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notes/AllNotes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/AllNotes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/AllNotes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Notizen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "type" }, 'typeHidden', { "name": "subject" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "body" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.AllNotes.detail;
    var ww = this.containing_window;
    var date10820 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time10821 = new Lino.TimeField({ "selectOnFocus": true });
    var id10822 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user10823 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/AllNotes/user" }) }) });
    var event_type10824 = new Lino.RemoteComboFieldElement({ "emptyText": "Event Type ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/AllNotes/event_type" }) }) });
    var type10825 = new Lino.RemoteComboFieldElement({ "emptyText": "Notizart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/AllNotes/type" }) }) });
    var subject10826 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var build_time10827 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method10828 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company10829 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/AllNotes/company" }) }) });
    var contact_person10830 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/AllNotes/contact_person" }) }) });
    var contact_role10831 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/AllNotes/contact_role" }) }) });
    var owner_type10832 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/AllNotes/owner_type" }) }) });
    var owner_id10833 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/AllNotes/owner_id" }) }) });
    var language10834 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var owner_disp10835 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp10836 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10837 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10838 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var body10839 = new Ext.form.HtmlEditor({ "selectOnFocus": true });
    this.before_row_edit = function(record) {
      contact_person10830.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id10833.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company10829.on('change',Lino.chooser_handler(contact_person10830,'company'));
      owner_type10832.on('change',Lino.chooser_handler(owner_id10833,'owner_type'));
      Lino.notes.AllNotes.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date10820, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum", "sortable": true, "tooltip": "(notes.AllNotes.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time10821, "header": "Zeit", "sortable": true, "tooltip": "(notes.AllNotes.time) ", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id10822, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(notes.AllNotes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user10823, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.AllNotes.user) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "event_type", "editable": true, "editor": event_type10824, "filter": { "type": "string" }, "header": "Ereignisart (Form)", "renderer": Lino.fk_renderer('event_typeHidden','Lino.notes.EventTypes.detail'), "sortable": false, "tooltip": "(notes.AllNotes.event_type) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "type", "editable": true, "editor": type10825, "filter": { "type": "string" }, "header": "Notizart (Inhalt)", "renderer": Lino.fk_renderer('typeHidden','Lino.notes.NoteTypes.detail'), "sortable": false, "tooltip": "(notes.AllNotes.type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "subject", "editable": true, "editor": subject10826, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(notes.AllNotes.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(notes.AllNotes.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "build_method", "editable": true, "editor": build_method10828, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(notes.AllNotes.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 9, "dataIndex": "company", "editable": true, "editor": company10829, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Organisation)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.AllNotes.company) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "contact_person", "editable": true, "editor": contact_person10830, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.AllNotes.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "contact_role", "editable": true, "editor": contact_role10831, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(notes.AllNotes.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_type", "editable": true, "editor": owner_type10832, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.AllNotes.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "owner_id", "editable": true, "editor": owner_id10833, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(notes.AllNotes.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "language", "editable": true, "editor": language10834, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(notes.AllNotes.language) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(notes.AllNotes.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.AllNotes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.AllNotes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(notes.AllNotes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "body", "editable": true, "editor": body10839, "filter": { "type": "string" }, "header": "Inhalt", "sortable": false, "tooltip": "(notes.AllNotes.body) ", "width": Lino.chars2width(61) } ];
    Lino.notes.AllNotes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.AllNotes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.AllNotes.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/AllNotes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.AllNotes.detail;
    Lino.notes.AllNotes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.AllNotes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.AllNotes.detailPanel(p);
});
Lino.notes.AllNotes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.AllNotes.GridPanel(p);
});
Lino.notes.AllNotes.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.AllNotes.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/AllNotes", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.MyNotes
Lino.notes.MyNotes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 30,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/MyNotes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/MyNotes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/MyNotes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notes/MyNotes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/MyNotes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/MyNotes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Meine Notizen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "event_type" }, 'event_typeHidden', { "name": "type" }, 'typeHidden', { "name": "subject" }, { "name": "body" }, { "name": "id", "type": "int" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.MyNotes.detail;
    var ww = this.containing_window;
    var date4920 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time4921 = new Lino.TimeField({ "selectOnFocus": true });
    var event_type4922 = new Lino.RemoteComboFieldElement({ "emptyText": "Event Type ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/event_type" }) }) });
    var type4923 = new Lino.RemoteComboFieldElement({ "emptyText": "Notizart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/type" }) }) });
    var subject4924 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var body4925 = new Ext.form.HtmlEditor({ "selectOnFocus": true });
    var id4926 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_time4927 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4928 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user4929 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/user" }) }) });
    var company4930 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/company" }) }) });
    var contact_person4931 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/contact_person" }) }) });
    var contact_role4932 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/contact_role" }) }) });
    var owner_type4933 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/owner_type" }) }) });
    var owner_id4934 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/owner_id" }) }) });
    var language4935 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var owner_disp4936 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp4937 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4938 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4939 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      contact_person4931.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id4934.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company4930.on('change',Lino.chooser_handler(contact_person4931,'company'));
      owner_type4933.on('change',Lino.chooser_handler(owner_id4934,'owner_type'));
      Lino.notes.MyNotes.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date4920, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum", "sortable": true, "tooltip": "(notes.MyNotes.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time4921, "header": "Zeit", "sortable": true, "tooltip": "(notes.MyNotes.time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type4922, "filter": { "type": "string" }, "header": "Ereignisart (Form)", "renderer": Lino.fk_renderer('event_typeHidden','Lino.notes.EventTypes.detail'), "sortable": false, "tooltip": "(notes.MyNotes.event_type) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type4923, "filter": { "type": "string" }, "header": "Notizart (Inhalt)", "renderer": Lino.fk_renderer('typeHidden','Lino.notes.NoteTypes.detail'), "sortable": false, "tooltip": "(notes.MyNotes.type) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "subject", "editable": true, "editor": subject4924, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(notes.MyNotes.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "body", "editable": true, "editor": body4925, "filter": { "type": "string" }, "header": "Inhalt", "sortable": false, "tooltip": "(notes.MyNotes.body) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id4926, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.MyNotes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(notes.MyNotes.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "build_method", "editable": true, "editor": build_method4928, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 9, "dataIndex": "user", "editable": true, "editor": user4929, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.MyNotes.user) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "company", "editable": true, "editor": company4930, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Organisation)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.MyNotes.company) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "contact_person", "editable": true, "editor": contact_person4931, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.MyNotes.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "contact_role", "editable": true, "editor": contact_role4932, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "owner_type", "editable": true, "editor": owner_type4933, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.MyNotes.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_id", "editable": true, "editor": owner_id4934, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 15, "dataIndex": "language", "editable": true, "editor": language4935, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.language) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 17, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.notes.MyNotes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.MyNotes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.MyNotes.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/MyNotes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.MyNotes.detail;
    Lino.notes.MyNotes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.MyNotes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.MyNotes.detailPanel(p);
});
Lino.notes.MyNotes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.MyNotes.GridPanel(p);
});
Lino.notes.MyNotes.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/MyNotes", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class uploads.UploadTypes
Lino.uploads.UploadTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 12,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/uploads/UploadTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Upload-Arten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "upload_area" }, 'upload_areaHidden', { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "max_number", "type": "int", "useNull": true }, { "name": "wanted", "type": "boolean" }, { "name": "shortcut" }, { "name": "id", "type": "int" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 70,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadTypes.detail;
    this.ls_insert_handler = Lino.uploads.UploadTypes.insert;
    var ww = this.containing_window;
    var upload_area10841 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var name10842 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10843 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10844 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var max_number10845 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": -1 });
    var wanted10846 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var shortcut10847 = new Ext.form.TextField({ "maxLength": 50, "selectOnFocus": true });
    var id10848 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp10849 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10850 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10851 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "upload_area", "editable": true, "editor": upload_area10841, "filter": { "type": "string" }, "header": "Upload-Bereich", "sortable": false, "tooltip": "(uploads.UploadTypes.upload_area) ", "width": Lino.chars2width(11) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name10842, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(uploads.UploadTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de10843, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(uploads.UploadTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr10844, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(uploads.UploadTypes.name_fr) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 4, "dataIndex": "max_number", "editable": true, "editor": max_number10845, "filter": { "type": "numeric" }, "format": "0", "header": "Max. number", "sortable": true, "tooltip": "(uploads.UploadTypes.max_number) No need to upload more uploads than N of this type.\n-1 means no limit.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "wanted", "editable": true, "filter": { "type": "boolean" }, "header": "Wanted", "sortable": false, "tooltip": "(uploads.UploadTypes.wanted) Add a (+) button when there is no upload of this type.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 6, "dataIndex": "shortcut", "editable": true, "editor": shortcut10847, "filter": { "type": "string" }, "header": "Upload shortcut", "sortable": true, "tooltip": "(uploads.UploadTypes.shortcut) Optional pointer to a virtual upload shortcut field.  If\nthis is not empty, then the given shortcut field will manage\nuploads of this type.  See also Shortcuts.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id10848, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(uploads.UploadTypes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadTypes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadTypes.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.uploads.UploadTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadTypes.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadTypes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.UploadTypes.insertPanel = Ext.extend(Lino.uploads.UploadTypes.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/uploads/UploadTypes",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadTypes.detail;
    this.ls_insert_handler = Lino.uploads.UploadTypes.insert;
    Lino.uploads.UploadTypes.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadTypes.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.uploads.UploadTypes.insertPanel(p);
});
Lino.uploads.UploadTypes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadTypes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadTypes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.UploadTypes.detailPanel = Ext.extend(Lino.uploads.UploadTypes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/uploads/UploadTypes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadTypes.detail;
    this.ls_insert_handler = Lino.uploads.UploadTypes.insert;
    Lino.uploads.UploadTypes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadTypes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.UploadTypes.detailPanel(p);
});
Lino.uploads.UploadTypes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.UploadTypes.GridPanel(p);
});
Lino.uploads.UploadTypes.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadTypes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class uploads.Uploads
Lino.uploads.Uploads.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 19,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/uploads/Uploads",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/Uploads','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/Uploads','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/Uploads','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/Uploads','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/Uploads','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Uploads",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "file" }, { "name": "type" }, 'typeHidden', { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "description" }, { "name": "id", "type": "int" }, { "name": "mimetype" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "upload_area" }, 'upload_areaHidden', { "name": "description_link" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 71,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.Uploads.detail;
    this.ls_insert_handler = Lino.uploads.Uploads.insert;
    var ww = this.containing_window;
    var file4941 = Lino.file_field_handler(this,{ "maxLength": 100, "selectOnFocus": true });
    var type4942 = new Lino.RemoteComboFieldElement({ "emptyText": "Upload-Art ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/type" }) }) });
    var user4943 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/user" }) }) });
    var owner_disp4944 = new Ext.form.DisplayField({ "disabled": true });
    var description4945 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id4946 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mimetype4947 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": 255 });
    var owner_type4948 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/owner_type" }) }) });
    var owner_id4949 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/owner_id" }) }) });
    var upload_area4950 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var description_link_disp4951 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4952 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4953 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4954 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      type4942.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
      owner_id4949.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      upload_area4950.on('change',Lino.chooser_handler(type4942,'upload_area'));
      owner_type4948.on('change',Lino.chooser_handler(owner_id4949,'owner_type'));
      Lino.uploads.Uploads.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "file", "editable": true, "editor": file4941, "filter": { "type": "string" }, "header": "Datei", "sortable": true, "tooltip": "(uploads.Uploads.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type4942, "filter": { "type": "string" }, "header": "Upload-Art", "renderer": Lino.fk_renderer('typeHidden','Lino.uploads.UploadTypes.detail'), "sortable": false, "tooltip": "(uploads.Uploads.type) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user4943, "filter": { "type": "string" }, "header": "Hochgeladen durch", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(uploads.Uploads.user) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(uploads.Uploads.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "description", "editable": true, "editor": description4945, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(uploads.Uploads.description) A short description entered manually by the user.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4946, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(uploads.Uploads.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "mimetype", "editable": false, "filter": { "type": "string" }, "header": "MIME-Art", "hidden": true, "sortable": true, "tooltip": "(uploads.Uploads.mimetype) The Media type\nof the file.  See also this thread\nabout length of MIME type field.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "owner_type", "editable": true, "editor": owner_type4948, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(uploads.Uploads.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_id", "editable": true, "editor": owner_id4949, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(uploads.Uploads.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "upload_area", "editable": true, "editor": upload_area4950, "filter": { "type": "string" }, "header": "Upload-Bereich", "hidden": true, "sortable": false, "tooltip": "(uploads.Uploads.upload_area) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "description_link", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.Uploads.description_link) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.Uploads.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.Uploads.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(uploads.Uploads.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.uploads.Uploads.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.Uploads.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Uploads", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Uploads", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Uploads", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Uploads", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Uploads", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.Uploads.insertPanel = Ext.extend(Lino.uploads.Uploads.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/uploads/Uploads",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.Uploads.detail;
    this.ls_insert_handler = Lino.uploads.Uploads.insert;
    Lino.uploads.Uploads.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.Uploads.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.uploads.Uploads.insertPanel(p);
});
Lino.uploads.Uploads.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Uploads", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Uploads", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Uploads", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.Uploads.detailPanel = Ext.extend(Lino.uploads.Uploads.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/uploads/Uploads",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.Uploads.detail;
    this.ls_insert_handler = Lino.uploads.Uploads.insert;
    Lino.uploads.Uploads.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.Uploads.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.Uploads.detailPanel(p);
});
Lino.uploads.Uploads.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Uploads", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.uploads.Uploads.ParamsPanel({});
  return new Lino.uploads.Uploads.GridPanel(p);
});
Lino.uploads.Uploads.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Uploads", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class uploads.AllUploads
Lino.uploads.AllUploads.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 19,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/uploads/AllUploads",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/AllUploads','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/AllUploads','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/AllUploads','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/AllUploads','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/AllUploads','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Uploads",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "file" }, { "name": "type" }, 'typeHidden', { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "description" }, { "name": "id", "type": "int" }, { "name": "mimetype" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "upload_area" }, 'upload_areaHidden', { "name": "description_link" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 71,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.AllUploads.detail;
    this.ls_insert_handler = Lino.uploads.AllUploads.insert;
    var ww = this.containing_window;
    var file10853 = Lino.file_field_handler(this,{ "maxLength": 100, "selectOnFocus": true });
    var type10854 = new Lino.RemoteComboFieldElement({ "emptyText": "Upload-Art ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/AllUploads/type" }) }) });
    var user10855 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/AllUploads/user" }) }) });
    var owner_disp10856 = new Ext.form.DisplayField({ "disabled": true });
    var description10857 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id10858 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mimetype10859 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": 255 });
    var owner_type10860 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/AllUploads/owner_type" }) }) });
    var owner_id10861 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/AllUploads/owner_id" }) }) });
    var upload_area10862 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var description_link_disp10863 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp10864 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10865 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10866 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      type10854.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
      owner_id10861.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      upload_area10862.on('change',Lino.chooser_handler(type10854,'upload_area'));
      owner_type10860.on('change',Lino.chooser_handler(owner_id10861,'owner_type'));
      Lino.uploads.AllUploads.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "file", "editable": true, "editor": file10853, "filter": { "type": "string" }, "header": "Datei", "sortable": true, "tooltip": "(uploads.AllUploads.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type10854, "filter": { "type": "string" }, "header": "Upload-Art", "renderer": Lino.fk_renderer('typeHidden','Lino.uploads.UploadTypes.detail'), "sortable": false, "tooltip": "(uploads.AllUploads.type) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user10855, "filter": { "type": "string" }, "header": "Hochgeladen durch", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(uploads.AllUploads.user) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(uploads.AllUploads.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "description", "editable": true, "editor": description10857, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(uploads.AllUploads.description) A short description entered manually by the user.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id10858, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(uploads.AllUploads.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "mimetype", "editable": false, "filter": { "type": "string" }, "header": "MIME-Art", "hidden": true, "sortable": true, "tooltip": "(uploads.AllUploads.mimetype) The Media type\nof the file.  See also this thread\nabout length of MIME type field.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "owner_type", "editable": true, "editor": owner_type10860, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(uploads.AllUploads.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_id", "editable": true, "editor": owner_id10861, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(uploads.AllUploads.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "upload_area", "editable": true, "editor": upload_area10862, "filter": { "type": "string" }, "header": "Upload-Bereich", "hidden": true, "sortable": false, "tooltip": "(uploads.AllUploads.upload_area) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "description_link", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.AllUploads.description_link) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.AllUploads.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.AllUploads.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(uploads.AllUploads.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.uploads.AllUploads.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.AllUploads.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AllUploads", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AllUploads.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AllUploads", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AllUploads.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AllUploads", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AllUploads.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AllUploads", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AllUploads.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AllUploads", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.AllUploads.insertPanel = Ext.extend(Lino.uploads.Uploads.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/uploads/AllUploads",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.AllUploads.detail;
    this.ls_insert_handler = Lino.uploads.AllUploads.insert;
    Lino.uploads.AllUploads.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.AllUploads.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.uploads.AllUploads.insertPanel(p);
});
Lino.uploads.AllUploads.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AllUploads", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AllUploads.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AllUploads", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AllUploads.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AllUploads", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.AllUploads.detailPanel = Ext.extend(Lino.uploads.Uploads.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/uploads/AllUploads",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.AllUploads.detail;
    this.ls_insert_handler = Lino.uploads.AllUploads.insert;
    Lino.uploads.AllUploads.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.AllUploads.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.AllUploads.detailPanel(p);
});
Lino.uploads.AllUploads.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AllUploads", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AllUploads.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.uploads.Uploads.ParamsPanel({});
  return new Lino.uploads.AllUploads.GridPanel(p);
});
Lino.uploads.AllUploads.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AllUploads", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class uploads.MyUploads
Lino.uploads.MyUploads.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 19,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/uploads/MyUploads",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/MyUploads','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/MyUploads','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/MyUploads','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/MyUploads','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/MyUploads','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Meine Uploads",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "file" }, { "name": "description" }, { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "id", "type": "int" }, { "name": "mimetype" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "upload_area" }, 'upload_areaHidden', { "name": "type" }, 'typeHidden', { "name": "description_link" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 71,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.MyUploads.detail;
    this.ls_insert_handler = Lino.uploads.MyUploads.insert;
    var ww = this.containing_window;
    var file4956 = Lino.file_field_handler(this,{ "maxLength": 100, "selectOnFocus": true });
    var description4957 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user4958 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/MyUploads/user" }) }) });
    var owner_disp4959 = new Ext.form.DisplayField({ "disabled": true });
    var id4960 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mimetype4961 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": 255 });
    var owner_type4962 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/MyUploads/owner_type" }) }) });
    var owner_id4963 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/MyUploads/owner_id" }) }) });
    var upload_area4964 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var type4965 = new Lino.RemoteComboFieldElement({ "emptyText": "Upload-Art ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/MyUploads/type" }) }) });
    var description_link_disp4966 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4967 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4968 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4969 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      owner_id4963.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      type4965.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4962.on('change',Lino.chooser_handler(owner_id4963,'owner_type'));
      upload_area4964.on('change',Lino.chooser_handler(type4965,'upload_area'));
      Lino.uploads.MyUploads.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "file", "editable": true, "editor": file4956, "filter": { "type": "string" }, "header": "Datei", "sortable": true, "tooltip": "(uploads.MyUploads.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "description", "editable": true, "editor": description4957, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(uploads.MyUploads.description) A short description entered manually by the user.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user4958, "filter": { "type": "string" }, "header": "Hochgeladen durch", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(uploads.MyUploads.user) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(uploads.MyUploads.owner) ", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id4960, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(uploads.MyUploads.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "mimetype", "editable": false, "filter": { "type": "string" }, "header": "MIME-Art", "hidden": true, "sortable": true, "tooltip": "(uploads.MyUploads.mimetype) The Media type\nof the file.  See also this thread\nabout length of MIME type field.", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "owner_type", "editable": true, "editor": owner_type4962, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(uploads.MyUploads.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "owner_id", "editable": true, "editor": owner_id4963, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(uploads.MyUploads.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "upload_area", "editable": true, "editor": upload_area4964, "filter": { "type": "string" }, "header": "Upload-Bereich", "hidden": true, "sortable": false, "tooltip": "(uploads.MyUploads.upload_area) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "type", "editable": true, "editor": type4965, "filter": { "type": "string" }, "header": "Upload-Art", "hidden": true, "renderer": Lino.fk_renderer('typeHidden','Lino.uploads.UploadTypes.detail'), "sortable": false, "tooltip": "(uploads.MyUploads.type) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "description_link", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.MyUploads.description_link) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.MyUploads.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.MyUploads.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(uploads.MyUploads.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.uploads.MyUploads.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.MyUploads.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/MyUploads", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/MyUploads", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/MyUploads", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/MyUploads", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/MyUploads", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.MyUploads.insertPanel = Ext.extend(Lino.uploads.Uploads.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/uploads/MyUploads",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.MyUploads.detail;
    this.ls_insert_handler = Lino.uploads.MyUploads.insert;
    Lino.uploads.MyUploads.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.MyUploads.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.uploads.MyUploads.insertPanel(p);
});
Lino.uploads.MyUploads.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/MyUploads", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/MyUploads", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/MyUploads", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.MyUploads.detailPanel = Ext.extend(Lino.uploads.Uploads.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/uploads/MyUploads",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.MyUploads.detail;
    this.ls_insert_handler = Lino.uploads.MyUploads.insert;
    Lino.uploads.MyUploads.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.MyUploads.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.MyUploads.detailPanel(p);
});
Lino.uploads.MyUploads.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/MyUploads", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.uploads.Uploads.ParamsPanel({});
  return new Lino.uploads.MyUploads.GridPanel(p);
});
Lino.uploads.MyUploads.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/MyUploads", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class uploads.AreaUploads
Lino.uploads.AreaUploads.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 19,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/uploads/AreaUploads",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/AreaUploads','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/AreaUploads','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/AreaUploads','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/AreaUploads','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/AreaUploads','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Uploads",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "file" }, { "name": "type" }, 'typeHidden', { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "description" }, { "name": "id", "type": "int" }, { "name": "mimetype" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "upload_area" }, 'upload_areaHidden', { "name": "description_link" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 71,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.AreaUploads.detail;
    this.ls_insert_handler = Lino.uploads.AreaUploads.insert;
    var ww = this.containing_window;
    var file4971 = Lino.file_field_handler(this,{ "maxLength": 100, "selectOnFocus": true });
    var type4972 = new Lino.RemoteComboFieldElement({ "emptyText": "Upload-Art ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/AreaUploads/type" }) }) });
    var user4973 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/AreaUploads/user" }) }) });
    var owner_disp4974 = new Ext.form.DisplayField({ "disabled": true });
    var description4975 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id4976 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mimetype4977 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": 255 });
    var owner_type4978 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/AreaUploads/owner_type" }) }) });
    var owner_id4979 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/AreaUploads/owner_id" }) }) });
    var upload_area4980 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var description_link_disp4981 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4982 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4983 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4984 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      type4972.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
      owner_id4979.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      upload_area4980.on('change',Lino.chooser_handler(type4972,'upload_area'));
      owner_type4978.on('change',Lino.chooser_handler(owner_id4979,'owner_type'));
      Lino.uploads.AreaUploads.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "file", "editable": true, "editor": file4971, "filter": { "type": "string" }, "header": "Datei", "sortable": true, "tooltip": "(uploads.AreaUploads.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type4972, "filter": { "type": "string" }, "header": "Upload-Art", "renderer": Lino.fk_renderer('typeHidden','Lino.uploads.UploadTypes.detail'), "sortable": false, "tooltip": "(uploads.AreaUploads.type) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user4973, "filter": { "type": "string" }, "header": "Hochgeladen durch", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(uploads.AreaUploads.user) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(uploads.AreaUploads.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "description", "editable": true, "editor": description4975, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(uploads.AreaUploads.description) A short description entered manually by the user.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4976, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(uploads.AreaUploads.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "mimetype", "editable": false, "filter": { "type": "string" }, "header": "MIME-Art", "hidden": true, "sortable": true, "tooltip": "(uploads.AreaUploads.mimetype) The Media type\nof the file.  See also this thread\nabout length of MIME type field.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "owner_type", "editable": true, "editor": owner_type4978, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(uploads.AreaUploads.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_id", "editable": true, "editor": owner_id4979, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(uploads.AreaUploads.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "upload_area", "editable": true, "editor": upload_area4980, "filter": { "type": "string" }, "header": "Upload-Bereich", "hidden": true, "sortable": false, "tooltip": "(uploads.AreaUploads.upload_area) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "description_link", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.AreaUploads.description_link) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.AreaUploads.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.AreaUploads.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(uploads.AreaUploads.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.uploads.AreaUploads.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.AreaUploads.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AreaUploads", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AreaUploads", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AreaUploads", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AreaUploads", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AreaUploads", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.AreaUploads.insertPanel = Ext.extend(Lino.uploads.Uploads.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/uploads/AreaUploads",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.AreaUploads.detail;
    this.ls_insert_handler = Lino.uploads.AreaUploads.insert;
    Lino.uploads.AreaUploads.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.AreaUploads.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.uploads.AreaUploads.insertPanel(p);
});
Lino.uploads.AreaUploads.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AreaUploads", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AreaUploads", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AreaUploads", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.AreaUploads.detailPanel = Ext.extend(Lino.uploads.Uploads.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/uploads/AreaUploads",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.AreaUploads.detail;
    this.ls_insert_handler = Lino.uploads.AreaUploads.insert;
    Lino.uploads.AreaUploads.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.AreaUploads.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.AreaUploads.detailPanel(p);
});
Lino.uploads.AreaUploads.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AreaUploads", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.uploads.Uploads.ParamsPanel({});
  return new Lino.uploads.AreaUploads.GridPanel(p);
});
Lino.uploads.AreaUploads.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/AreaUploads", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class outbox.Recipients
Lino.outbox.Recipients.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 12,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/Recipients",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/Recipients','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/Recipients','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/Recipients','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/Recipients','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/Recipients','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Empf\u00e4nger",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "mail" }, 'mailHidden', { "name": "partner" }, 'partnerHidden', { "name": "type" }, 'typeHidden', { "name": "address" }, { "name": "name" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 73,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id10868 = new Ext.form.NumberField({ "selectOnFocus": true });
    var mail10869 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "E-Mail-Ausgang ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/Recipients/mail" }) }) });
    var partner10870 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/Recipients/partner" }) }) });
    var type10871 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.outbox.RecipientTypes });
    var address10872 = new Ext.form.TextField({ "maxLength": 254, "selectOnFocus": true });
    var name10873 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var mobile_item_disp10874 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10875 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10876 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10868, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(outbox.Recipients.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "mail", "editable": true, "editor": mail10869, "filter": { "type": "string" }, "header": "E-Mail-Ausgang", "renderer": Lino.fk_renderer('mailHidden','Lino.outbox.Mails.detail'), "sortable": false, "tooltip": "(outbox.Recipients.mail) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "partner", "editable": true, "editor": partner10870, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(outbox.Recipients.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type10871, "filter": { "type": "string" }, "header": "Empf\u00e4ngerart", "sortable": false, "tooltip": "(outbox.Recipients.type) ", "width": Lino.chars2width(8) }, { "colIndex": 4, "dataIndex": "address", "editable": true, "editor": address10872, "filter": { "type": "string" }, "header": "Adresse", "sortable": true, "tooltip": "(outbox.Recipients.address) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "name", "editable": true, "editor": name10873, "filter": { "type": "string" }, "header": "Name", "sortable": true, "tooltip": "(outbox.Recipients.name) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.Recipients.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.Recipients.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(outbox.Recipients.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.outbox.Recipients.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.Recipients.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Recipients", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Recipients.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Recipients", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Recipients.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Recipients", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Recipients.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Recipients", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Recipients.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Recipients", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Recipients.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Recipients", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Recipients.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Recipients", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Recipients.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Recipients", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Recipients.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.Recipients.GridPanel(p);
});

// js_render_GridPanel_class outbox.Mails
Lino.outbox.Mails.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 16,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/Mails",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/Mails','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/Mails','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/Mails','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/Mails','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/Mails','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "E-Mail senden", "overflowText": "E-Mail senden", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  cell_edit : true,
  title : "E-Mail-Ausg\u00e4nge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "sent" }, { "name": "recipients" }, { "name": "subject" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "body" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 72,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.Mails.detail;
    this.ls_insert_handler = Lino.outbox.Mails.insert;
    var ww = this.containing_window;
    var sent10878 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var recipients_htmlbox10879 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "recipients", "title": "Empf\u00e4nger", "value": "<br/>" });
    var subject10880 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id10881 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user10882 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/Mails/user" }) }) });
    var owner_type10883 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/Mails/owner_type" }) }) });
    var owner_id10884 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/Mails/owner_id" }) }) });
    var date10885 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var owner_disp10886 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp10887 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10888 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10889 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var body10890 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    this.before_row_edit = function(record) {
      recipients_htmlbox10879.refresh();
      owner_id10884.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type10883.on('change',Lino.chooser_handler(owner_id10884,'owner_type'));
      Lino.outbox.Mails.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "sent", "editable": false, "header": "sent", "sortable": true, "tooltip": "(outbox.Mails.sent) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "recipients", "editable": false, "header": "Empf\u00e4nger", "sortable": false, "tooltip": "(outbox.Mails.recipients) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "subject", "editable": true, "editor": subject10880, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(outbox.Mails.subject) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id10881, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(outbox.Mails.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user10882, "filter": { "type": "string" }, "header": "Absender", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(outbox.Mails.user) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "owner_type", "editable": true, "editor": owner_type10883, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(outbox.Mails.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "owner_id", "editable": true, "editor": owner_id10884, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(outbox.Mails.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "date", "editable": true, "editor": date10885, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum", "hidden": true, "sortable": true, "tooltip": "(outbox.Mails.date) \n        The official date to be printed on the document.\n        ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(outbox.Mails.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.Mails.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.Mails.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(outbox.Mails.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "body", "editable": true, "editor": body10890, "filter": { "type": "string" }, "header": "Inhalt", "hidden": true, "sortable": false, "tooltip": "(outbox.Mails.body) ", "width": Lino.chars2width(61) } ];
    Lino.outbox.Mails.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.Mails.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Mails", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Mails.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Mails", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Mails.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Mails", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Mails.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Mails", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Mails.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Mails", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.Mails.insertPanel = Ext.extend(Lino.outbox.Mails.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/outbox/Mails",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.Mails.detail;
    this.ls_insert_handler = Lino.outbox.Mails.insert;
    Lino.outbox.Mails.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.Mails.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.outbox.Mails.insertPanel(p);
});
Lino.outbox.Mails.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Mails", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Mails.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Mails", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Mails.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Mails", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.Mails.detailPanel = Ext.extend(Lino.outbox.Mails.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "E-Mail senden", "overflowText": "E-Mail senden", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  ls_url: "/outbox/Mails",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.Mails.detail;
    this.ls_insert_handler = Lino.outbox.Mails.insert;
    Lino.outbox.Mails.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.Mails.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.Mails.detailPanel(p);
});
Lino.outbox.Mails.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Mails", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Mails.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Mails", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Mails.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.outbox.Mails.ParamsPanel({});
  return new Lino.outbox.Mails.GridPanel(p);
});
Lino.outbox.Mails.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Mails", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Mails.send_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Mails", "GET", pk, "send_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class outbox.Attachments
Lino.outbox.Attachments.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 11,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/Attachments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/Attachments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/Attachments','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/Attachments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/Attachments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/Attachments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Anh\u00e4nge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "mail" }, 'mailHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 74,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id10892 = new Ext.form.NumberField({ "selectOnFocus": true });
    var owner_type10893 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/Attachments/owner_type" }) }) });
    var owner_id10894 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/Attachments/owner_id" }) }) });
    var mail10895 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "E-Mail-Ausgang ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/Attachments/mail" }) }) });
    var owner_disp10896 = new Ext.form.DisplayField({ "disabled": true });
    var mobile_item_disp10897 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10898 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10899 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      owner_id10894.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type10893.on('change',Lino.chooser_handler(owner_id10894,'owner_type'));
      Lino.outbox.Attachments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10892, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(outbox.Attachments.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "owner_type", "editable": true, "editor": owner_type10893, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(outbox.Attachments.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "owner_id", "editable": true, "editor": owner_id10894, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "sortable": false, "tooltip": "(outbox.Attachments.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 3, "dataIndex": "mail", "editable": true, "editor": mail10895, "filter": { "type": "string" }, "header": "E-Mail-Ausgang", "renderer": Lino.fk_renderer('mailHidden','Lino.outbox.Mails.detail'), "sortable": false, "tooltip": "(outbox.Attachments.mail) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(outbox.Attachments.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 5, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.Attachments.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.Attachments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(outbox.Attachments.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.outbox.Attachments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.Attachments.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Attachments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Attachments.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Attachments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Attachments.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Attachments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Attachments.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Attachments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Attachments.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Attachments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Attachments.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Attachments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Attachments.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Attachments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Attachments.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/Attachments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.Attachments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.Attachments.GridPanel(p);
});

// js_render_GridPanel_class excerpts.ExcerptTypes
Lino.excerpts.ExcerptTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 23,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/excerpts/ExcerptTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Auszugsarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "content_type_display" }, { "name": "primary", "type": "boolean" }, { "name": "certifying", "type": "boolean" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "build_method" }, 'build_methodHidden', { "name": "template" }, { "name": "body_template" }, { "name": "id", "type": "int" }, { "name": "attach_to_email", "type": "boolean" }, { "name": "email_template" }, { "name": "remark" }, { "name": "content_type" }, 'content_typeHidden', { "name": "backward_compat", "type": "boolean" }, { "name": "print_recipient", "type": "boolean" }, { "name": "print_directly", "type": "boolean" }, { "name": "shortcut" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 75,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.ExcerptTypes.detail;
    this.ls_insert_handler = Lino.excerpts.ExcerptTypes.insert;
    var ww = this.containing_window;
    var content_type_display_disp10901 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var primary10902 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var certifying10903 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var name10904 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de10905 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr10906 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var build_method10907 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var template10908 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/template" }) }) });
    var body_template10909 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/body_template" }) }) });
    var id10910 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var attach_to_email10911 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var email_template10912 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/email_template" }) }) });
    var remark10913 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var content_type10914 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/content_type" }) }) });
    var backward_compat10915 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var print_recipient10916 = new Ext.form.Checkbox({ "checked": true, "hidden": true, "selectOnFocus": true });
    var print_directly10917 = new Ext.form.Checkbox({ "checked": true, "hidden": true, "selectOnFocus": true });
    var shortcut10918 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var mobile_item_disp10919 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10920 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10921 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      template10908.setContextValue('build_method', record ? record.data['build_methodHidden'] : undefined);
      template10908.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
      body_template10909.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
      email_template10912.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      build_method10907.on('change',Lino.chooser_handler(template10908,'build_method'));
      content_type10914.on('change',Lino.chooser_handler(template10908,'content_type'));
      content_type10914.on('change',Lino.chooser_handler(body_template10909,'content_type'));
      content_type10914.on('change',Lino.chooser_handler(email_template10912,'content_type'));
      Lino.excerpts.ExcerptTypes.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "content_type_display", "editable": false, "header": "Modell", "sortable": false, "tooltip": "(excerpts.ExcerptTypes.content_type_display) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "primary", "editable": true, "filter": { "type": "boolean" }, "header": "Prim\u00e4r", "sortable": false, "tooltip": "(excerpts.ExcerptTypes.primary) Whether this is the default type to use for this model. There's at most one primary type per model. Enabling this field will automatically make the other types non-primary.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 2, "dataIndex": "certifying", "editable": true, "filter": { "type": "boolean" }, "header": "Bescheinigend", "sortable": false, "tooltip": "(excerpts.ExcerptTypes.certifying) Ob Ausz\u00fcge dieser Art als einmalige Ausdrucke behandelt werden sollen.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 3, "dataIndex": "name", "editable": true, "editor": name10904, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(excerpts.ExcerptTypes.name) The designation of this excerpt type.\nOne field for every language.", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "name_de", "editable": true, "editor": name_de10905, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(excerpts.ExcerptTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "name_fr", "editable": true, "editor": name_fr10906, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(excerpts.ExcerptTypes.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "build_method", "editable": true, "editor": build_method10907, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "sortable": false, "tooltip": "(excerpts.ExcerptTypes.build_method) See lino.modlib.printing.mixins.PrintableType.build_method.", "width": Lino.chars2width(24) }, { "colIndex": 7, "dataIndex": "template", "editable": true, "editor": template10908, "filter": { "type": "string" }, "header": "Vorlage", "sortable": false, "tooltip": "(excerpts.ExcerptTypes.template) The main template to be used when printing an excerpt of this type.", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "body_template", "editable": true, "editor": body_template10909, "filter": { "type": "string" }, "header": "Textk\u00f6rper-Vorlage", "sortable": false, "tooltip": "(excerpts.ExcerptTypes.body_template) The body template to be used when         rendering a printable of this type. This is a list of files         with extension `.body.html`.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 9, "dataIndex": "id", "editable": true, "editor": id10910, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(excerpts.ExcerptTypes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 10, "dataIndex": "attach_to_email", "editable": true, "filter": { "type": "boolean" }, "header": "als Anhang per E-Mail", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptTypes.attach_to_email) Whether the printable file should be attached to the email\nwhen creating an email from a mailable of this type.\n", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 11, "dataIndex": "email_template", "editable": true, "editor": email_template10912, "filter": { "type": "string" }, "header": "E-Mail-Vorlage", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptTypes.email_template) The name of the file to be used as template when creating an email from a mailable of this type.", "width": Lino.chars2width(11) }, { "colIndex": 12, "dataIndex": "remark", "editable": true, "editor": remark10913, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptTypes.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 13, "dataIndex": "content_type", "editable": true, "editor": content_type10914, "filter": { "type": "string" }, "header": "Modell", "hidden": true, "renderer": Lino.fk_renderer('content_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptTypes.content_type) The model that can issue printouts of this type.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "backward_compat", "editable": true, "filter": { "type": "boolean" }, "header": "Backward compatible", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptTypes.backward_compat) Check this to have `this` in template context point to owner instead of excerpt.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "print_recipient", "editable": true, "filter": { "type": "boolean" }, "header": "Empf\u00e4nger drucken", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptTypes.print_recipient) Whether to print a recipient field in document.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "print_directly", "editable": true, "filter": { "type": "boolean" }, "header": "Print directly", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptTypes.print_directly) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "shortcut", "editable": true, "editor": shortcut10918, "filter": { "type": "string" }, "header": "Excerpt shortcut", "hidden": true, "sortable": true, "tooltip": "(excerpts.ExcerptTypes.shortcut) Optional pointer to a shortcut field.  If this is not empty, then\nthe given shortcut field will manage excerpts of this type.", "width": Lino.chars2width(22) }, { "colIndex": 18, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptTypes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptTypes.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.excerpts.ExcerptTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.ExcerptTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptTypes.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptTypes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.excerpts.ExcerptTypes.insertPanel = Ext.extend(Lino.excerpts.ExcerptTypes.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/excerpts/ExcerptTypes",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.ExcerptTypes.detail;
    this.ls_insert_handler = Lino.excerpts.ExcerptTypes.insert;
    Lino.excerpts.ExcerptTypes.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.ExcerptTypes.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.excerpts.ExcerptTypes.insertPanel(p);
});
Lino.excerpts.ExcerptTypes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptTypes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptTypes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.excerpts.ExcerptTypes.detailPanel = Ext.extend(Lino.excerpts.ExcerptTypes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/excerpts/ExcerptTypes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.ExcerptTypes.detail;
    this.ls_insert_handler = Lino.excerpts.ExcerptTypes.insert;
    Lino.excerpts.ExcerptTypes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.ExcerptTypes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.excerpts.ExcerptTypes.detailPanel(p);
});
Lino.excerpts.ExcerptTypes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.excerpts.ExcerptTypes.GridPanel(p);
});
Lino.excerpts.ExcerptTypes.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptTypes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class excerpts.Excerpts
Lino.excerpts.Excerpts.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 26,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/excerpts/Excerpts",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/excerpts/Excerpts','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/Excerpts','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/Excerpts','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/Excerpts','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/excerpts/Excerpts','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" } ],
  cell_edit : true,
  title : "Ausz\u00fcge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "excerpt_type" }, 'excerpt_typeHidden', { "name": "owner" }, { "name": "company" }, 'companyHidden', { "name": "language" }, 'languageHidden', { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "body_template_content" }, { "name": "preview" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 76,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.Excerpts.detail;
    var ww = this.containing_window;
    var id4986 = new Ext.form.NumberField({ "selectOnFocus": true });
    var excerpt_type4987 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Auszugsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/excerpt_type" }) }) });
    var owner_disp4988 = new Ext.form.DisplayField({ "disabled": true });
    var company4989 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/company" }) }) });
    var language4990 = new Lino.ChoicesFieldElement({ "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var build_time4991 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var build_method4992 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user4993 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/user" }) }) });
    var contact_person4994 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/contact_person" }) }) });
    var contact_role4995 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/contact_role" }) }) });
    var owner_type4996 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/owner_type" }) }) });
    var owner_id4997 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/owner_id" }) }) });
    var body_template_content4998 = new Ext.form.TextArea({ "disabled": true, "growMax": 2000, "hidden": true });
    var preview_htmlbox4999 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "preview", "title": "Vorschau", "value": "<br/>" });
    var mobile_item_disp5000 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5001 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5002 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      excerpt_type4987.setContextValue('owner', record ? record.data['owner'] : undefined);
      contact_person4994.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id4997.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      preview_htmlbox4999.refresh();
    };
    this.onRender = function(ct, position) {
      owner_disp4988.on('change',Lino.chooser_handler(excerpt_type4987,'owner'));
      company4989.on('change',Lino.chooser_handler(contact_person4994,'company'));
      owner_type4996.on('change',Lino.chooser_handler(owner_id4997,'owner_type'));
      Lino.excerpts.Excerpts.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4986, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(excerpts.Excerpts.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "excerpt_type", "editable": true, "editor": excerpt_type4987, "filter": { "type": "string" }, "header": "Auszugsart", "renderer": Lino.fk_renderer('excerpt_typeHidden','Lino.excerpts.ExcerptTypes.detail'), "sortable": false, "tooltip": "(excerpts.Excerpts.excerpt_type) The type of this excerpt (ForeignKey to ExcerptType).", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(excerpts.Excerpts.owner) The object being printed by this excerpt.\nSee Controllable.owner.", "width": Lino.chars2width(11) }, { "colIndex": 3, "dataIndex": "company", "editable": true, "editor": company4989, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Organisation)", "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(excerpts.Excerpts.company) The optional company of the recipient of this\nexcerpt.  See ContactRelated.company.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "language", "editable": true, "editor": language4990, "filter": { "type": "string" }, "header": "Sprache", "sortable": false, "tooltip": "(excerpts.Excerpts.language) The language used for printing this excerpt.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "sortable": true, "tooltip": "(excerpts.Excerpts.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "build_method", "editable": true, "editor": build_method4992, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user4993, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(excerpts.Excerpts.user) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "contact_person", "editable": true, "editor": contact_person4994, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(excerpts.Excerpts.contact_person) The optional contact person of the recipient of this\nexcerpt.  See ContactRelated.contact_person.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "contact_role", "editable": true, "editor": contact_role4995, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "owner_type", "editable": true, "editor": owner_type4996, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(excerpts.Excerpts.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "owner_id", "editable": true, "editor": owner_id4997, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 12, "dataIndex": "body_template_content", "editable": false, "header": "Textk\u00f6rper-Vorlage", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.body_template_content) ", "width": Lino.chars2width(61) }, { "colIndex": 13, "dataIndex": "preview", "editable": false, "header": "Vorschau", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.preview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.excerpts.Excerpts.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.Excerpts.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.excerpts.Excerpts.detailPanel = Ext.extend(Lino.excerpts.Excerpts.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" } ],
  ls_url: "/excerpts/Excerpts",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.Excerpts.detail;
    Lino.excerpts.Excerpts.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.Excerpts.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.excerpts.Excerpts.detailPanel(p);
});
Lino.excerpts.Excerpts.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.excerpts.Excerpts.ParamsPanel({});
  return new Lino.excerpts.Excerpts.GridPanel(p);
});
Lino.excerpts.Excerpts.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Excerpts", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class excerpts.AllExcerpts
Lino.excerpts.AllExcerpts.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 26,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/excerpts/AllExcerpts",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/excerpts/AllExcerpts','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/AllExcerpts','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/AllExcerpts','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/AllExcerpts','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/excerpts/AllExcerpts','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Ausz\u00fcge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "excerpt_type" }, 'excerpt_typeHidden', { "name": "owner" }, { "name": "company" }, 'companyHidden', { "name": "language" }, 'languageHidden', { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "body_template_content" }, { "name": "preview" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 76,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.AllExcerpts.detail;
    var ww = this.containing_window;
    var id10923 = new Ext.form.NumberField({ "selectOnFocus": true });
    var excerpt_type10924 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Auszugsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/AllExcerpts/excerpt_type" }) }) });
    var owner_disp10925 = new Ext.form.DisplayField({ "disabled": true });
    var company10926 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/AllExcerpts/company" }) }) });
    var language10927 = new Lino.ChoicesFieldElement({ "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var build_time10928 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var build_method10929 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user10930 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/AllExcerpts/user" }) }) });
    var contact_person10931 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/AllExcerpts/contact_person" }) }) });
    var contact_role10932 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/AllExcerpts/contact_role" }) }) });
    var owner_type10933 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/AllExcerpts/owner_type" }) }) });
    var owner_id10934 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/AllExcerpts/owner_id" }) }) });
    var body_template_content10935 = new Ext.form.TextArea({ "disabled": true, "growMax": 2000, "hidden": true });
    var preview_htmlbox10936 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "preview", "title": "Vorschau", "value": "<br/>" });
    var mobile_item_disp10937 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10938 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10939 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      excerpt_type10924.setContextValue('owner', record ? record.data['owner'] : undefined);
      contact_person10931.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id10934.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      preview_htmlbox10936.refresh();
    };
    this.onRender = function(ct, position) {
      owner_disp10925.on('change',Lino.chooser_handler(excerpt_type10924,'owner'));
      company10926.on('change',Lino.chooser_handler(contact_person10931,'company'));
      owner_type10933.on('change',Lino.chooser_handler(owner_id10934,'owner_type'));
      Lino.excerpts.AllExcerpts.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10923, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(excerpts.AllExcerpts.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "excerpt_type", "editable": true, "editor": excerpt_type10924, "filter": { "type": "string" }, "header": "Auszugsart", "renderer": Lino.fk_renderer('excerpt_typeHidden','Lino.excerpts.ExcerptTypes.detail'), "sortable": false, "tooltip": "(excerpts.AllExcerpts.excerpt_type) The type of this excerpt (ForeignKey to ExcerptType).", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(excerpts.AllExcerpts.owner) The object being printed by this excerpt.\nSee Controllable.owner.", "width": Lino.chars2width(11) }, { "colIndex": 3, "dataIndex": "company", "editable": true, "editor": company10926, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Organisation)", "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(excerpts.AllExcerpts.company) The optional company of the recipient of this\nexcerpt.  See ContactRelated.company.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "language", "editable": true, "editor": language10927, "filter": { "type": "string" }, "header": "Sprache", "sortable": false, "tooltip": "(excerpts.AllExcerpts.language) The language used for printing this excerpt.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "sortable": true, "tooltip": "(excerpts.AllExcerpts.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "build_method", "editable": true, "editor": build_method10929, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(excerpts.AllExcerpts.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user10930, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(excerpts.AllExcerpts.user) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "contact_person", "editable": true, "editor": contact_person10931, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(excerpts.AllExcerpts.contact_person) The optional contact person of the recipient of this\nexcerpt.  See ContactRelated.contact_person.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "contact_role", "editable": true, "editor": contact_role10932, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(excerpts.AllExcerpts.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "owner_type", "editable": true, "editor": owner_type10933, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(excerpts.AllExcerpts.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "owner_id", "editable": true, "editor": owner_id10934, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(excerpts.AllExcerpts.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 12, "dataIndex": "body_template_content", "editable": false, "header": "Textk\u00f6rper-Vorlage", "hidden": true, "sortable": false, "tooltip": "(excerpts.AllExcerpts.body_template_content) ", "width": Lino.chars2width(61) }, { "colIndex": 13, "dataIndex": "preview", "editable": false, "header": "Vorschau", "hidden": true, "sortable": false, "tooltip": "(excerpts.AllExcerpts.preview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(excerpts.AllExcerpts.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(excerpts.AllExcerpts.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(excerpts.AllExcerpts.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.excerpts.AllExcerpts.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.AllExcerpts.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.excerpts.AllExcerpts.detailPanel = Ext.extend(Lino.excerpts.Excerpts.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/excerpts/AllExcerpts",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.AllExcerpts.detail;
    Lino.excerpts.AllExcerpts.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.AllExcerpts.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.excerpts.AllExcerpts.detailPanel(p);
});
Lino.excerpts.AllExcerpts.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.excerpts.Excerpts.ParamsPanel({});
  return new Lino.excerpts.AllExcerpts.GridPanel(p);
});
Lino.excerpts.AllExcerpts.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.AllExcerpts.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/AllExcerpts", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class excerpts.MyExcerpts
Lino.excerpts.MyExcerpts.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 26,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/excerpts/MyExcerpts",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/excerpts/MyExcerpts','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/MyExcerpts','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/MyExcerpts','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/MyExcerpts','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/excerpts/MyExcerpts','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Meine Ausz\u00fcge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "build_time" }, { "name": "excerpt_type" }, 'excerpt_typeHidden', { "name": "id", "type": "int" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "body_template_content" }, { "name": "preview" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 76,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.MyExcerpts.detail;
    var ww = this.containing_window;
    var build_time5004 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var excerpt_type5005 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Auszugsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/excerpt_type" }) }) });
    var id5006 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_method5007 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user5008 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/user" }) }) });
    var company5009 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/company" }) }) });
    var contact_person5010 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/contact_person" }) }) });
    var contact_role5011 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/contact_role" }) }) });
    var owner_type5012 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/owner_type" }) }) });
    var owner_id5013 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/owner_id" }) }) });
    var language5014 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var owner_disp5015 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var body_template_content5016 = new Ext.form.TextArea({ "disabled": true, "growMax": 2000, "hidden": true });
    var preview_htmlbox5017 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "preview", "title": "Vorschau", "value": "<br/>" });
    var mobile_item_disp5018 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5019 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5020 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      excerpt_type5005.setContextValue('owner', record ? record.data['owner'] : undefined);
      contact_person5010.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id5013.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      preview_htmlbox5017.refresh();
    };
    this.onRender = function(ct, position) {
      owner_disp5015.on('change',Lino.chooser_handler(excerpt_type5005,'owner'));
      company5009.on('change',Lino.chooser_handler(contact_person5010,'company'));
      owner_type5012.on('change',Lino.chooser_handler(owner_id5013,'owner_type'));
      Lino.excerpts.MyExcerpts.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "sortable": true, "tooltip": "(excerpts.MyExcerpts.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "excerpt_type", "editable": true, "editor": excerpt_type5005, "filter": { "type": "string" }, "header": "Auszugsart", "renderer": Lino.fk_renderer('excerpt_typeHidden','Lino.excerpts.ExcerptTypes.detail'), "sortable": false, "tooltip": "(excerpts.MyExcerpts.excerpt_type) The type of this excerpt (ForeignKey to ExcerptType).", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id5006, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(excerpts.MyExcerpts.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "build_method", "editable": true, "editor": build_method5007, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user5008, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(excerpts.MyExcerpts.user) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "company", "editable": true, "editor": company5009, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Organisation)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(excerpts.MyExcerpts.company) The optional company of the recipient of this\nexcerpt.  See ContactRelated.company.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "contact_person", "editable": true, "editor": contact_person5010, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(excerpts.MyExcerpts.contact_person) The optional contact person of the recipient of this\nexcerpt.  See ContactRelated.contact_person.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "contact_role", "editable": true, "editor": contact_role5011, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_type", "editable": true, "editor": owner_type5012, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(excerpts.MyExcerpts.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "owner_id", "editable": true, "editor": owner_id5013, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "language", "editable": true, "editor": language5014, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.language) The language used for printing this excerpt.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.owner) The object being printed by this excerpt.\nSee Controllable.owner.", "width": Lino.chars2width(11) }, { "colIndex": 12, "dataIndex": "body_template_content", "editable": false, "header": "Textk\u00f6rper-Vorlage", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.body_template_content) ", "width": Lino.chars2width(61) }, { "colIndex": 13, "dataIndex": "preview", "editable": false, "header": "Vorschau", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.preview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.excerpts.MyExcerpts.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.MyExcerpts.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.excerpts.MyExcerpts.detailPanel = Ext.extend(Lino.excerpts.Excerpts.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/excerpts/MyExcerpts",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.MyExcerpts.detail;
    Lino.excerpts.MyExcerpts.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.MyExcerpts.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.excerpts.MyExcerpts.detailPanel(p);
});
Lino.excerpts.MyExcerpts.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.excerpts.Excerpts.ParamsPanel({});
  return new Lino.excerpts.MyExcerpts.GridPanel(p);
});
Lino.excerpts.MyExcerpts.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/MyExcerpts", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class extensible.PanelCalendars
Lino.extensible.PanelCalendars.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 5,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/extensible/PanelCalendars",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelCalendars','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelCalendars','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelCalendars','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelCalendars','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelCalendars','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Kalenderliste",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "summary" }, { "name": "description" }, { "name": "color", "type": "int", "useNull": true }, { "name": "is_hidden", "type": "boolean" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 27,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.extensible.PanelCalendars.detail;
    this.ls_insert_handler = Lino.extensible.PanelCalendars.insert;
    var ww = this.containing_window;
    var id5022 = new Ext.form.NumberField({ "selectOnFocus": true });
    var summary_disp5023 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description5024 = new Ext.form.HtmlEditor({ "selectOnFocus": true });
    var color5025 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true });
    var is_hidden_disp5026 = new Ext.form.DisplayField({ "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5022, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(extensible.PanelCalendars.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "summary", "editable": false, "header": "summary", "sortable": false, "tooltip": "(extensible.PanelCalendars.summary) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "description", "editable": true, "editor": description5024, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": false, "tooltip": "(extensible.PanelCalendars.description) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 3, "dataIndex": "color", "editable": true, "editor": color5025, "filter": { "type": "numeric" }, "format": "0", "header": "Farbe", "sortable": true, "tooltip": "(extensible.PanelCalendars.color) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "is_hidden", "editable": false, "header": "Versteckt", "sortable": false, "tooltip": "(extensible.PanelCalendars.is_hidden) ", "width": Lino.chars2width(21) } ];
    Lino.extensible.PanelCalendars.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.extensible.PanelCalendars.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelCalendars", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelCalendars", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelCalendars", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelCalendars", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelCalendars", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.extensible.PanelCalendars.insertPanel = Ext.extend(Lino.cal.Calendars.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/extensible/PanelCalendars",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.extensible.PanelCalendars.detail;
    this.ls_insert_handler = Lino.extensible.PanelCalendars.insert;
    Lino.extensible.PanelCalendars.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.extensible.PanelCalendars.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.extensible.PanelCalendars.insertPanel(p);
});
Lino.extensible.PanelCalendars.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelCalendars", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelCalendars", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelCalendars", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.extensible.PanelCalendars.detailPanel = Ext.extend(Lino.cal.Calendars.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/extensible/PanelCalendars",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.extensible.PanelCalendars.detail;
    this.ls_insert_handler = Lino.extensible.PanelCalendars.insert;
    Lino.extensible.PanelCalendars.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.extensible.PanelCalendars.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.extensible.PanelCalendars.detailPanel(p);
});
Lino.extensible.PanelCalendars.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelCalendars", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.extensible.PanelCalendars.GridPanel(p);
});
Lino.extensible.PanelCalendars.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelCalendars", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class extensible.PanelEvents
Lino.extensible.PanelEvents.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 14,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/extensible/PanelEvents",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelEvents','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelEvents','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelEvents','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelEvents','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelEvents','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Kalendereintr\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "start_dt" }, { "name": "end_dt" }, { "name": "summary" }, { "name": "description" }, { "name": "user" }, 'userHidden', { "name": "room" }, 'roomHidden', { "name": "calendar" }, 'calendarHidden', { "name": "url" }, { "name": "all_day", "type": "boolean" }, { "name": "reminder" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.extensible.PanelEvents.detail;
    this.ls_insert_handler = Lino.extensible.PanelEvents.insert;
    var ww = this.containing_window;
    var id5028 = new Ext.form.NumberField({ "selectOnFocus": true });
    var start_dt5029 = new Ext.form.DisplayField({ "allowBlank": false, "selectOnFocus": true, "value": "<br>" });
    var end_dt5030 = new Ext.form.DisplayField({ "allowBlank": false, "selectOnFocus": true, "value": "<br>" });
    var summary5031 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var description5032 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var user5033 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/extensible/PanelEvents/user" }) }) });
    var room5034 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/extensible/PanelEvents/room" }) }) });
    var calendar5035 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var url_disp5036 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var all_day5037 = new Ext.form.Checkbox({ "selectOnFocus": true });
    var reminder_disp5038 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5028, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(extensible.PanelEvents.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "start_dt", "editable": true, "editor": start_dt5029, "header": "Beginn", "sortable": false, "tooltip": "(extensible.PanelEvents.start_dt) ", "width": Lino.chars2width(17) }, { "colIndex": 2, "dataIndex": "end_dt", "editable": true, "editor": end_dt5030, "header": "Ende", "sortable": false, "tooltip": "(extensible.PanelEvents.end_dt) ", "width": Lino.chars2width(17) }, { "colIndex": 3, "dataIndex": "summary", "editable": true, "editor": summary5031, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(extensible.PanelEvents.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "description", "editable": true, "editor": description5032, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": false, "tooltip": "(extensible.PanelEvents.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user5033, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(extensible.PanelEvents.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "room", "editable": true, "editor": room5034, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(extensible.PanelEvents.room) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "calendar", "editable": false, "header": "Kalender", "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(extensible.PanelEvents.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "url", "editable": false, "header": "Link URL", "sortable": false, "tooltip": "(extensible.PanelEvents.url) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "all_day", "editable": true, "header": "ganztags", "sortable": false, "tooltip": "(extensible.PanelEvents.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 10, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "sortable": false, "tooltip": "(extensible.PanelEvents.reminder) ", "width": Lino.chars2width(31) } ];
    Lino.extensible.PanelEvents.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.extensible.PanelEvents.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.extensible.PanelEvents.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/extensible/PanelEvents",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.extensible.PanelEvents.detail;
    this.ls_insert_handler = Lino.extensible.PanelEvents.insert;
    Lino.extensible.PanelEvents.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.extensible.PanelEvents.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.extensible.PanelEvents.insertPanel(p);
});
Lino.extensible.PanelEvents.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.extensible.PanelEvents.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/extensible/PanelEvents",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.extensible.PanelEvents.detail;
    this.ls_insert_handler = Lino.extensible.PanelEvents.insert;
    Lino.extensible.PanelEvents.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.extensible.PanelEvents.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.extensible.PanelEvents.detailPanel(p);
});
Lino.extensible.PanelEvents.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.extensible.PanelEvents.GridPanel(p);
});
Lino.extensible.PanelEvents.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/extensible/PanelEvents", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class changes.Changes
Lino.changes.Changes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/changes/Changes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/changes/Changes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/changes/Changes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/changes/Changes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/changes/Changes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/changes/Changes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" } ],
  cell_edit : true,
  title : "\u00c4nderungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "time" }, { "name": "type" }, 'typeHidden', { "name": "user" }, 'userHidden', { "name": "object_type" }, 'object_typeHidden', { "name": "object_id" }, 'object_idHidden', { "name": "master_type" }, 'master_typeHidden', { "name": "master_id" }, 'master_idHidden', { "name": "diff" }, { "name": "changed_fields" }, { "name": "object" }, { "name": "master" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 77,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.changes.Changes.detail;
    var ww = this.containing_window;
    var id10941 = new Ext.form.NumberField({ "selectOnFocus": true });
    var time10942 = new Ext.form.DisplayField({ "allowBlank": false, "selectOnFocus": true, "value": "<br>" });
    var type10943 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.changes.ChangeTypes });
    var user10944 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/user" }) }) });
    var object_type10945 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/object_type" }) }) });
    var object_id10946 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/object_id" }) }) });
    var master_type10947 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/master_type" }) }) });
    var master_id10948 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/master_id" }) }) });
    var diff10949 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var changed_fields10950 = new Ext.form.TextField({ "maxLength": 250, "selectOnFocus": true });
    var object_disp10951 = new Ext.form.DisplayField({ "disabled": true });
    var master_disp10952 = new Ext.form.DisplayField({ "disabled": true });
    var mobile_item_disp10953 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10954 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10955 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      object_type10945.on('change',Lino.chooser_handler(object_id10946,'object_type'));
      master_type10947.on('change',Lino.chooser_handler(master_id10948,'master_type'));
      Lino.changes.Changes.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10941, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(changes.Changes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time10942, "header": "time", "sortable": true, "tooltip": "(changes.Changes.time) ", "width": Lino.chars2width(17) }, { "colIndex": 2, "dataIndex": "type", "editable": true, "editor": type10943, "filter": { "type": "string" }, "header": "\u00c4nderungsart", "sortable": false, "tooltip": "(changes.Changes.type) ", "width": Lino.chars2width(16) }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user10944, "filter": { "type": "string" }, "header": "Benutzer", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(changes.Changes.user) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "object_type", "editable": true, "editor": object_type10945, "filter": { "type": "string" }, "header": "Object type", "renderer": Lino.fk_renderer('object_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(changes.Changes.object_type) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "object_id", "editable": true, "editor": object_id10946, "filter": { "type": "string" }, "header": "object id", "sortable": false, "tooltip": "(changes.Changes.object_id) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "master_type", "editable": true, "editor": master_type10947, "filter": { "type": "string" }, "header": "Master type", "renderer": Lino.fk_renderer('master_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(changes.Changes.master_type) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "master_id", "editable": true, "editor": master_id10948, "filter": { "type": "string" }, "header": "master id", "sortable": false, "tooltip": "(changes.Changes.master_id) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "diff", "editable": true, "editor": diff10949, "filter": { "type": "string" }, "header": "\u00c4nderungen", "sortable": false, "tooltip": "(changes.Changes.diff) ", "width": Lino.chars2width(61) }, { "colIndex": 9, "dataIndex": "changed_fields", "editable": true, "editor": changed_fields10950, "filter": { "type": "string" }, "header": "Felder", "sortable": true, "tooltip": "(changes.Changes.changed_fields) ", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "object", "editable": false, "header": "Object", "sortable": false, "tooltip": "(changes.Changes.object) The database object which has been modified.", "width": Lino.chars2width(11) }, { "colIndex": 11, "dataIndex": "master", "editable": false, "header": "Stammdaten", "sortable": false, "tooltip": "(changes.Changes.master) The database object which acts as \"master\".", "width": Lino.chars2width(11) }, { "colIndex": 12, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(changes.Changes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(changes.Changes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(changes.Changes.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.changes.Changes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.Changes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/Changes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.Changes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/Changes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.Changes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/Changes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.Changes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/Changes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.Changes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/Changes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.Changes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/Changes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.changes.Changes.detailPanel = Ext.extend(Lino.changes.Changes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/changes/Changes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.changes.Changes.detail;
    Lino.changes.Changes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.Changes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.changes.Changes.detailPanel(p);
});
Lino.changes.Changes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.changes.Changes.ParamsPanel({});
  return new Lino.changes.Changes.GridPanel(p);
});

// js_render_GridPanel_class users.Users
Lino.users.Users.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 29,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/users/Users",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/users/Users','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/Users','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/users/Users','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/Users','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/users/Users','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "sign_out", "menu_item_text": "Sign out", "overflowText": "Sign out", "panel_btn_handler": Lino.list_action_handler('/users/Users','sign_out','GET',null), "text": "Sign out" }, { "auto_save": true, "itemId": "change_password", "menu_item_text": "Passwort \u00e4ndern", "overflowText": "Passwort \u00e4ndern", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" } ],
  cell_edit : true,
  title : "Benutzer",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "username" }, { "name": "user_type" }, 'user_typeHidden', { "name": "first_name" }, { "name": "last_name" }, { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "modified" }, { "name": "created" }, { "name": "password" }, { "name": "last_login" }, { "name": "initials" }, { "name": "remarks" }, { "name": "access_class" }, 'access_classHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "notify_myself", "type": "boolean" }, { "name": "mail_mode" }, 'mail_modeHidden', { "name": "partner" }, 'partnerHidden', { "name": "name_column" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "created_natural" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 2,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.users.Users.detail;
    this.ls_insert_handler = Lino.users.Users.insert;
    var ww = this.containing_window;
    var username1074 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 30, "selectOnFocus": true });
    var user_type1075 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.users.UserTypes) });
    var first_name1076 = new Ext.form.TextField({ "maxLength": 30, "selectOnFocus": true });
    var last_name1077 = new Ext.form.TextField({ "maxLength": 30, "selectOnFocus": true });
    var id1078 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email1079 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language1080 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var modified1081 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created1082 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var password1083 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 128, "selectOnFocus": true });
    var last_login1084 = new Ext.form.DisplayField({ "hidden": true, "selectOnFocus": true, "value": "<br>" });
    var initials1085 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var remarks1086 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class1087 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.AccessClasses });
    var event_type1088 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/Users/event_type" }) }) });
    var notify_myself1089 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var mail_mode1090 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.notify.MailModes });
    var partner1091 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/Users/partner" }) }) });
    var name_column_disp1092 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp1093 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1094 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1095 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp1096 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "username", "editable": true, "editor": username1074, "filter": { "type": "string" }, "header": "Benutzername", "sortable": true, "tooltip": "(users.Users.username) Must be unique and cannot be empty.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "user_type", "editable": true, "editor": user_type1075, "filter": { "type": "string" }, "header": "Benutzerart", "sortable": false, "tooltip": "(users.Users.user_type) The user_type of a user is what defines her or his permissions.", "width": Lino.chars2width(23) }, { "colIndex": 2, "dataIndex": "first_name", "editable": true, "editor": first_name1076, "filter": { "type": "string" }, "header": "Vorname", "sortable": true, "tooltip": "(users.Users.first_name) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "last_name", "editable": true, "editor": last_name1077, "filter": { "type": "string" }, "header": "Familienname", "sortable": true, "tooltip": "(users.Users.last_name) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id1078, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(users.Users.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "email", "editable": true, "editor": email1079, "filter": { "type": "string" }, "header": "E-Mail-Adresse", "hidden": true, "sortable": true, "tooltip": "(users.Users.email) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "language", "editable": true, "editor": language1080, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(users.Users.language) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(users.Users.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(users.Users.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 9, "dataIndex": "password", "editable": true, "editor": password1083, "filter": { "type": "string" }, "header": "password", "hidden": true, "sortable": true, "tooltip": "(users.Users.password) ", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "last_login", "editable": true, "editor": last_login1084, "header": "last login", "hidden": true, "sortable": true, "tooltip": "(users.Users.last_login) Not used in Lino.", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "initials", "editable": true, "editor": initials1085, "filter": { "type": "string" }, "header": "Initialien", "hidden": true, "sortable": true, "tooltip": "(users.Users.initials) The nickname or initials of this user. This does not need to\nbe unique but should provide a reasonably identifying\nfunction.", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "remarks", "editable": true, "editor": remarks1086, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(users.Users.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 13, "dataIndex": "access_class", "editable": true, "editor": access_class1087, "filter": { "type": "string" }, "header": "Standardm\u00e4\u00dfige Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(users.Users.access_class) Die standardm\u00e4\u00dfige Zugriffsklasse f\u00fcr Ihre Termine und Aufgaben", "width": Lino.chars2width(13) }, { "colIndex": 14, "dataIndex": "event_type", "editable": true, "editor": event_type1088, "filter": { "type": "string" }, "header": "Standard-Kalenderintragsart", "hidden": true, "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(users.Users.event_type) The default event type for your calendar events.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "notify_myself", "editable": true, "filter": { "type": "boolean" }, "header": "Benachrichtigungen an mich selbst", "hidden": true, "sortable": false, "tooltip": "(users.Users.notify_myself) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "mail_mode", "editable": true, "editor": mail_mode1090, "filter": { "type": "string" }, "header": "Benachrichtigungen per E-Mail", "hidden": true, "sortable": false, "tooltip": "(users.Users.mail_mode) ", "width": Lino.chars2width(10) }, { "colIndex": 17, "dataIndex": "partner", "editable": true, "editor": partner1091, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(users.Users.partner) Pointer to the Partner instance related to\nthis user.", "width": Lino.chars2width(21) }, { "colIndex": 18, "dataIndex": "name_column", "editable": false, "header": "Name", "hidden": true, "sortable": false, "tooltip": "(users.Users.name_column) ", "width": Lino.chars2width(16) }, { "colIndex": 19, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(users.Users.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(users.Users.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(users.Users.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(users.Users.created_natural) ", "width": Lino.chars2width(31) } ];
    Lino.users.Users.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.users.Users.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Users", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Users", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Users", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Users", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Users", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.users.Users.insertPanel = Ext.extend(Lino.users.Users.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/users/Users",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.users.Users.detail;
    this.ls_insert_handler = Lino.users.Users.insert;
    Lino.users.Users.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.users.Users.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.users.Users.insertPanel(p);
});
Lino.users.Users.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Users", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Users", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Users", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.users.Users.detailPanel = Ext.extend(Lino.users.Users.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "sign_out", "menu_item_text": "Sign out", "overflowText": "Sign out", "panel_btn_handler": Lino.list_action_handler('/users/Users','sign_out','GET',null), "text": "Sign out" }, { "auto_save": true, "itemId": "change_password", "menu_item_text": "Passwort \u00e4ndern", "overflowText": "Passwort \u00e4ndern", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" } ],
  ls_url: "/users/Users",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.users.Users.detail;
    this.ls_insert_handler = Lino.users.Users.insert;
    Lino.users.Users.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.users.Users.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.users.Users.detailPanel(p);
});
Lino.users.Users.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Users", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.users.Users.ParamsPanel({});
  return new Lino.users.Users.GridPanel(p);
});
Lino.users.Users.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Users", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.sign_out = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Users", "GET", pk, "sign_out", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class users.AllUsers
Lino.users.AllUsers.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 29,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/users/AllUsers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/users/AllUsers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/AllUsers','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/users/AllUsers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/AllUsers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/users/AllUsers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "change_password", "menu_item_text": "Passwort \u00e4ndern", "overflowText": "Passwort \u00e4ndern", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" }, { "auto_save": true, "itemId": "sign_out", "menu_item_text": "Sign out", "overflowText": "Sign out", "panel_btn_handler": Lino.list_action_handler('/users/AllUsers','sign_out','GET',null), "text": "Sign out" } ],
  cell_edit : true,
  title : "Benutzer",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "username" }, { "name": "user_type" }, 'user_typeHidden', { "name": "first_name" }, { "name": "last_name" }, { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "modified" }, { "name": "created" }, { "name": "password" }, { "name": "last_login" }, { "name": "initials" }, { "name": "remarks" }, { "name": "access_class" }, 'access_classHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "notify_myself", "type": "boolean" }, { "name": "mail_mode" }, 'mail_modeHidden', { "name": "partner" }, 'partnerHidden', { "name": "name_column" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "created_natural" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 2,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.users.AllUsers.detail;
    this.ls_insert_handler = Lino.users.AllUsers.insert;
    var ww = this.containing_window;
    var username10957 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 30, "selectOnFocus": true });
    var user_type10958 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.users.UserTypes) });
    var first_name10959 = new Ext.form.TextField({ "maxLength": 30, "selectOnFocus": true });
    var last_name10960 = new Ext.form.TextField({ "maxLength": 30, "selectOnFocus": true });
    var id10961 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email10962 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language10963 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var modified10964 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created10965 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var password10966 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 128, "selectOnFocus": true });
    var last_login10967 = new Ext.form.DisplayField({ "hidden": true, "selectOnFocus": true, "value": "<br>" });
    var initials10968 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var remarks10969 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class10970 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.AccessClasses });
    var event_type10971 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/AllUsers/event_type" }) }) });
    var notify_myself10972 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var mail_mode10973 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.notify.MailModes });
    var partner10974 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/AllUsers/partner" }) }) });
    var name_column_disp10975 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp10976 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10977 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10978 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp10979 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "username", "editable": true, "editor": username10957, "filter": { "type": "string" }, "header": "Benutzername", "sortable": true, "tooltip": "(users.AllUsers.username) Must be unique and cannot be empty.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "user_type", "editable": true, "editor": user_type10958, "filter": { "type": "string" }, "header": "Benutzerart", "sortable": false, "tooltip": "(users.AllUsers.user_type) The user_type of a user is what defines her or his permissions.", "width": Lino.chars2width(23) }, { "colIndex": 2, "dataIndex": "first_name", "editable": true, "editor": first_name10959, "filter": { "type": "string" }, "header": "Vorname", "sortable": true, "tooltip": "(users.AllUsers.first_name) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "last_name", "editable": true, "editor": last_name10960, "filter": { "type": "string" }, "header": "Familienname", "sortable": true, "tooltip": "(users.AllUsers.last_name) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id10961, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(users.AllUsers.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "email", "editable": true, "editor": email10962, "filter": { "type": "string" }, "header": "E-Mail-Adresse", "hidden": true, "sortable": true, "tooltip": "(users.AllUsers.email) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "language", "editable": true, "editor": language10963, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(users.AllUsers.language) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(users.AllUsers.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(users.AllUsers.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 9, "dataIndex": "password", "editable": true, "editor": password10966, "filter": { "type": "string" }, "header": "password", "hidden": true, "sortable": true, "tooltip": "(users.AllUsers.password) ", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "last_login", "editable": true, "editor": last_login10967, "header": "last login", "hidden": true, "sortable": true, "tooltip": "(users.AllUsers.last_login) Not used in Lino.", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "initials", "editable": true, "editor": initials10968, "filter": { "type": "string" }, "header": "Initialien", "hidden": true, "sortable": true, "tooltip": "(users.AllUsers.initials) The nickname or initials of this user. This does not need to\nbe unique but should provide a reasonably identifying\nfunction.", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "remarks", "editable": true, "editor": remarks10969, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(users.AllUsers.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 13, "dataIndex": "access_class", "editable": true, "editor": access_class10970, "filter": { "type": "string" }, "header": "Standardm\u00e4\u00dfige Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(users.AllUsers.access_class) Die standardm\u00e4\u00dfige Zugriffsklasse f\u00fcr Ihre Termine und Aufgaben", "width": Lino.chars2width(13) }, { "colIndex": 14, "dataIndex": "event_type", "editable": true, "editor": event_type10971, "filter": { "type": "string" }, "header": "Standard-Kalenderintragsart", "hidden": true, "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(users.AllUsers.event_type) The default event type for your calendar events.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "notify_myself", "editable": true, "filter": { "type": "boolean" }, "header": "Benachrichtigungen an mich selbst", "hidden": true, "sortable": false, "tooltip": "(users.AllUsers.notify_myself) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "mail_mode", "editable": true, "editor": mail_mode10973, "filter": { "type": "string" }, "header": "Benachrichtigungen per E-Mail", "hidden": true, "sortable": false, "tooltip": "(users.AllUsers.mail_mode) ", "width": Lino.chars2width(10) }, { "colIndex": 17, "dataIndex": "partner", "editable": true, "editor": partner10974, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(users.AllUsers.partner) Pointer to the Partner instance related to\nthis user.", "width": Lino.chars2width(21) }, { "colIndex": 18, "dataIndex": "name_column", "editable": false, "header": "Name", "hidden": true, "sortable": false, "tooltip": "(users.AllUsers.name_column) ", "width": Lino.chars2width(16) }, { "colIndex": 19, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(users.AllUsers.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(users.AllUsers.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(users.AllUsers.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(users.AllUsers.created_natural) ", "width": Lino.chars2width(31) } ];
    Lino.users.AllUsers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.users.AllUsers.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AllUsers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AllUsers.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AllUsers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AllUsers.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AllUsers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AllUsers.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AllUsers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AllUsers.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AllUsers", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.users.AllUsers.insertPanel = Ext.extend(Lino.users.Users.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/users/AllUsers",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.users.AllUsers.detail;
    this.ls_insert_handler = Lino.users.AllUsers.insert;
    Lino.users.AllUsers.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.users.AllUsers.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.users.AllUsers.insertPanel(p);
});
Lino.users.AllUsers.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AllUsers", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AllUsers.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AllUsers", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AllUsers.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AllUsers", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.users.AllUsers.detailPanel = Ext.extend(Lino.users.Users.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "change_password", "menu_item_text": "Passwort \u00e4ndern", "overflowText": "Passwort \u00e4ndern", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" }, { "auto_save": true, "itemId": "sign_out", "menu_item_text": "Sign out", "overflowText": "Sign out", "panel_btn_handler": Lino.list_action_handler('/users/AllUsers','sign_out','GET',null), "text": "Sign out" } ],
  ls_url: "/users/AllUsers",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.users.AllUsers.detail;
    this.ls_insert_handler = Lino.users.AllUsers.insert;
    Lino.users.AllUsers.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.users.AllUsers.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.users.AllUsers.detailPanel(p);
});
Lino.users.AllUsers.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AllUsers", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AllUsers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.users.Users.ParamsPanel({});
  return new Lino.users.AllUsers.GridPanel(p);
});
Lino.users.AllUsers.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AllUsers", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AllUsers.sign_out = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AllUsers", "GET", pk, "sign_out", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class users.UsersOverview
Lino.users.UsersOverview.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 6,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/users/UsersOverview",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/users/UsersOverview','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/UsersOverview','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/users/UsersOverview','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/UsersOverview','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/users/UsersOverview','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "sign_out", "menu_item_text": "Sign out", "overflowText": "Sign out", "panel_btn_handler": Lino.list_action_handler('/users/UsersOverview','sign_out','GET',null), "text": "Sign out" }, { "auto_save": true, "itemId": "change_password", "menu_item_text": "Passwort \u00e4ndern", "overflowText": "Passwort \u00e4ndern", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" }, { "auto_save": true, "itemId": "sign_in", "menu_item_text": "Sign in", "overflowText": "Sign in", "panel_btn_handler": Lino.param_action_handler(Lino.users.UsersOverview.sign_in), "text": "Sign in" } ],
  cell_edit : true,
  title : "Benutzer",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "username" }, { "name": "user_type" }, 'user_typeHidden', { "name": "language" }, 'languageHidden', { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 2,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.users.UsersOverview.detail;
    this.ls_insert_handler = Lino.users.UsersOverview.insert;
    var ww = this.containing_window;
    var username4136 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 30, "selectOnFocus": true });
    var user_type4137 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.users.UserTypes) });
    var language4138 = new Lino.ChoicesFieldElement({ "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "username", "editable": true, "editor": username4136, "filter": { "type": "string" }, "header": "Benutzername", "sortable": true, "tooltip": "(users.UsersOverview.username) Must be unique and cannot be empty.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "user_type", "editable": true, "editor": user_type4137, "filter": { "type": "string" }, "header": "Benutzerart", "sortable": false, "tooltip": "(users.UsersOverview.user_type) The user_type of a user is what defines her or his permissions.", "width": Lino.chars2width(23) }, { "colIndex": 2, "dataIndex": "language", "editable": true, "editor": language4138, "filter": { "type": "string" }, "header": "Sprache", "sortable": false, "tooltip": "(users.UsersOverview.language) ", "width": Lino.chars2width(21) } ];
    Lino.users.UsersOverview.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.users.UsersOverview.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UsersOverview", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UsersOverview", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UsersOverview", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UsersOverview", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UsersOverview", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.users.UsersOverview.insertPanel = Ext.extend(Lino.users.Users.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/users/UsersOverview",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.users.UsersOverview.detail;
    this.ls_insert_handler = Lino.users.UsersOverview.insert;
    Lino.users.UsersOverview.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.users.UsersOverview.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.users.UsersOverview.insertPanel(p);
});
Lino.users.UsersOverview.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UsersOverview", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UsersOverview", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UsersOverview", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.users.UsersOverview.detailPanel = Ext.extend(Lino.users.Users.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "sign_out", "menu_item_text": "Sign out", "overflowText": "Sign out", "panel_btn_handler": Lino.list_action_handler('/users/UsersOverview','sign_out','GET',null), "text": "Sign out" }, { "auto_save": true, "itemId": "change_password", "menu_item_text": "Passwort \u00e4ndern", "overflowText": "Passwort \u00e4ndern", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" }, { "auto_save": true, "itemId": "sign_in", "menu_item_text": "Sign in", "overflowText": "Sign in", "panel_btn_handler": Lino.param_action_handler(Lino.users.UsersOverview.sign_in), "text": "Sign in" } ],
  ls_url: "/users/UsersOverview",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.users.UsersOverview.detail;
    this.ls_insert_handler = Lino.users.UsersOverview.insert;
    Lino.users.UsersOverview.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.users.UsersOverview.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.users.UsersOverview.detailPanel(p);
});
Lino.users.UsersOverview.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UsersOverview", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.users.Users.ParamsPanel({});
  return new Lino.users.UsersOverview.GridPanel(p);
});
Lino.users.UsersOverview.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UsersOverview", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.sign_out = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UsersOverview", "GET", pk, "sign_out", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class users.MySettings
Lino.users.MySettings.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 29,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/users/MySettings",
  ls_bbar_actions : [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "sign_out", "menu_item_text": "Sign out", "overflowText": "Sign out", "panel_btn_handler": Lino.list_action_handler('/users/MySettings','sign_out','GET',null), "text": "Sign out" }, { "auto_save": true, "itemId": "change_password", "menu_item_text": "Passwort \u00e4ndern", "overflowText": "Passwort \u00e4ndern", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" } ],
  cell_edit : true,
  title : "Benutzer",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "username" }, { "name": "user_type" }, 'user_typeHidden', { "name": "first_name" }, { "name": "last_name" }, { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "modified" }, { "name": "created" }, { "name": "password" }, { "name": "last_login" }, { "name": "initials" }, { "name": "remarks" }, { "name": "access_class" }, 'access_classHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "notify_myself", "type": "boolean" }, { "name": "mail_mode" }, 'mail_modeHidden', { "name": "partner" }, 'partnerHidden', { "name": "name_column" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "created_natural" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 2,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.users.MySettings.detail;
    this.ls_insert_handler = Lino.users.Users.insert;
    var ww = this.containing_window;
    var username5040 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 30, "selectOnFocus": true });
    var user_type5041 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.users.UserTypes) });
    var first_name5042 = new Ext.form.TextField({ "maxLength": 30, "selectOnFocus": true });
    var last_name5043 = new Ext.form.TextField({ "maxLength": 30, "selectOnFocus": true });
    var id5044 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email5045 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language5046 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var modified5047 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created5048 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var password5049 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 128, "selectOnFocus": true });
    var last_login5050 = new Ext.form.DisplayField({ "hidden": true, "selectOnFocus": true, "value": "<br>" });
    var initials5051 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var remarks5052 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class5053 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.AccessClasses });
    var event_type5054 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/MySettings/event_type" }) }) });
    var notify_myself5055 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var mail_mode5056 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.notify.MailModes });
    var partner5057 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/MySettings/partner" }) }) });
    var name_column_disp5058 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp5059 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5060 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5061 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp5062 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "username", "editable": true, "editor": username5040, "filter": { "type": "string" }, "header": "Benutzername", "sortable": true, "tooltip": "(users.MySettings.username) Must be unique and cannot be empty.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "user_type", "editable": true, "editor": user_type5041, "filter": { "type": "string" }, "header": "Benutzerart", "sortable": false, "tooltip": "(users.MySettings.user_type) The user_type of a user is what defines her or his permissions.", "width": Lino.chars2width(23) }, { "colIndex": 2, "dataIndex": "first_name", "editable": true, "editor": first_name5042, "filter": { "type": "string" }, "header": "Vorname", "sortable": true, "tooltip": "(users.MySettings.first_name) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "last_name", "editable": true, "editor": last_name5043, "filter": { "type": "string" }, "header": "Familienname", "sortable": true, "tooltip": "(users.MySettings.last_name) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id5044, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "email", "editable": true, "editor": email5045, "filter": { "type": "string" }, "header": "E-Mail-Adresse", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.email) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "language", "editable": true, "editor": language5046, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.language) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 9, "dataIndex": "password", "editable": true, "editor": password5049, "filter": { "type": "string" }, "header": "password", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.password) ", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "last_login", "editable": true, "editor": last_login5050, "header": "last login", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.last_login) Not used in Lino.", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "initials", "editable": true, "editor": initials5051, "filter": { "type": "string" }, "header": "Initialien", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.initials) The nickname or initials of this user. This does not need to\nbe unique but should provide a reasonably identifying\nfunction.", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "remarks", "editable": true, "editor": remarks5052, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 13, "dataIndex": "access_class", "editable": true, "editor": access_class5053, "filter": { "type": "string" }, "header": "Standardm\u00e4\u00dfige Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.access_class) Die standardm\u00e4\u00dfige Zugriffsklasse f\u00fcr Ihre Termine und Aufgaben", "width": Lino.chars2width(13) }, { "colIndex": 14, "dataIndex": "event_type", "editable": true, "editor": event_type5054, "filter": { "type": "string" }, "header": "Standard-Kalenderintragsart", "hidden": true, "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(users.MySettings.event_type) The default event type for your calendar events.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "notify_myself", "editable": true, "filter": { "type": "boolean" }, "header": "Benachrichtigungen an mich selbst", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.notify_myself) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "mail_mode", "editable": true, "editor": mail_mode5056, "filter": { "type": "string" }, "header": "Benachrichtigungen per E-Mail", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.mail_mode) ", "width": Lino.chars2width(10) }, { "colIndex": 17, "dataIndex": "partner", "editable": true, "editor": partner5057, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(users.MySettings.partner) Pointer to the Partner instance related to\nthis user.", "width": Lino.chars2width(21) }, { "colIndex": 18, "dataIndex": "name_column", "editable": false, "header": "Name", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.name_column) ", "width": Lino.chars2width(16) }, { "colIndex": 19, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.created_natural) ", "width": Lino.chars2width(31) } ];
    Lino.users.MySettings.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.users.MySettings.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/MySettings", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/MySettings", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/MySettings", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/MySettings", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/MySettings", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/MySettings", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/MySettings", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/MySettings", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.users.MySettings.detailPanel = Ext.extend(Lino.users.Users.DetailFormPanel,{
  empty_title: "Benutzer",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "sign_out", "menu_item_text": "Sign out", "overflowText": "Sign out", "panel_btn_handler": Lino.list_action_handler('/users/MySettings','sign_out','GET',null), "text": "Sign out" }, { "auto_save": true, "itemId": "change_password", "menu_item_text": "Passwort \u00e4ndern", "overflowText": "Passwort \u00e4ndern", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" } ],
  ls_url: "/users/MySettings",
  initComponent : function() {
    this.ls_detail_handler = Lino.users.MySettings.detail;
    this.ls_insert_handler = Lino.users.Users.insert;
    Lino.users.MySettings.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.users.MySettings.detail = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.users.MySettings.detailPanel(p);
});

Lino.users.MySettings.detailPanel = Ext.extend(Lino.users.Users.DetailFormPanel,{
  empty_title: "Benutzer",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "sign_out", "menu_item_text": "Sign out", "overflowText": "Sign out", "panel_btn_handler": Lino.list_action_handler('/users/MySettings','sign_out','GET',null), "text": "Sign out" }, { "auto_save": true, "itemId": "change_password", "menu_item_text": "Passwort \u00e4ndern", "overflowText": "Passwort \u00e4ndern", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" } ],
  ls_url: "/users/MySettings",
  initComponent : function() {
    this.ls_detail_handler = Lino.users.MySettings.detail;
    this.ls_insert_handler = Lino.users.Users.insert;
    Lino.users.MySettings.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.users.MySettings.detail = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.users.MySettings.detailPanel(p);
});
Lino.users.MySettings.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/MySettings", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.sign_out = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/MySettings", "GET", pk, "sign_out", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class users.Authorities
Lino.users.Authorities.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 8,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/users/Authorities",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/users/Authorities','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/Authorities','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/users/Authorities','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/Authorities','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/users/Authorities','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Vollmachten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "authorized" }, 'authorizedHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 3,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id10981 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user10982 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/Authorities/user" }) }) });
    var authorized10983 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/Authorities/authorized" }) }) });
    var mobile_item_disp10984 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp10985 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp10986 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      authorized10983.setContextValue('user', record ? record.data['userHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      user10982.on('change',Lino.chooser_handler(authorized10983,'user'));
      Lino.users.Authorities.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id10981, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(users.Authorities.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user10982, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(users.Authorities.user) The user who gives the right of representation. author of this\nauthority", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "authorized", "editable": true, "editor": authorized10983, "filter": { "type": "string" }, "header": "Benutzer", "renderer": Lino.fk_renderer('authorizedHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(users.Authorities.authorized) The user who gets the right to represent the author", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(users.Authorities.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(users.Authorities.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(users.Authorities.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.users.Authorities.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.users.Authorities.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Authorities", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Authorities.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Authorities", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Authorities.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Authorities", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Authorities.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Authorities", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Authorities.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Authorities", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Authorities.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Authorities", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Authorities.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Authorities", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Authorities.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/Authorities", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Authorities.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.users.Authorities.ParamsPanel({});
  return new Lino.users.Authorities.GridPanel(p);
});

// js_render_GridPanel_class vat.VatRules
Lino.vat.VatRules.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 23,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/vat/VatRules",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/VatRules','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VatRules','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VatRules','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VatRules','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/VatRules','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "MwSt-Regeln",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "seqno", "type": "int", "useNull": true }, { "name": "country" }, 'countryHidden', { "name": "trade_type" }, 'trade_typeHidden', { "name": "vat_class" }, 'vat_classHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "rate" }, { "name": "can_edit", "type": "boolean" }, { "name": "vat_account" }, 'vat_accountHidden', { "name": "vat_returnable", "type": "boolean" }, { "name": "vat_returnable_account" }, 'vat_returnable_accountHidden', { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "move_buttons" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 16,
  ls_grid_configs : [  ],
  content_type : 42,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var seqno10988 = new Ext.form.NumberField({ "selectOnFocus": true });
    var country10989 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/VatRules/country" }) }) });
    var trade_type10990 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.TradeTypes) });
    var vat_class10991 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var vat_regime10992 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var rate10993 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 4, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var can_edit10994 = new Ext.form.Checkbox({ "checked": true, "selectOnFocus": true });
    var vat_account10995 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/VatRules/vat_account" }) }) });
    var vat_returnable10996 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var vat_returnable_account10997 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/VatRules/vat_returnable_account" }) }) });
    var id10998 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_date10999 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date11000 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var move_buttons_disp11001 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp11002 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp11003 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp11004 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "seqno", "editable": true, "editor": seqno10988, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(vat.VatRules.seqno) The sequence number.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "country", "editable": true, "editor": country10989, "filter": { "type": "string" }, "header": "Land", "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(vat.VatRules.country) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "trade_type", "editable": true, "editor": trade_type10990, "filter": { "type": "string" }, "header": "Handelsart", "sortable": false, "tooltip": "(vat.VatRules.trade_type) ", "width": Lino.chars2width(13) }, { "colIndex": 3, "dataIndex": "vat_class", "editable": true, "editor": vat_class10991, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "sortable": false, "tooltip": "(vat.VatRules.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime10992, "filter": { "type": "string" }, "header": "MwSt.-Regime", "sortable": false, "tooltip": "(vat.VatRules.vat_regime) The regime for which this rule applies. Pointer to\nVatRegimes.", "width": Lino.chars2width(19) }, { "align": "right", "colIndex": 5, "dataIndex": "rate", "editable": true, "editor": rate10993, "filter": { "type": "numeric" }, "format": "0.000,0000/i", "header": "rate", "sortable": true, "tooltip": "(vat.VatRules.rate) The VAT rate to be applied. Note that a VAT rate of 20 percent is\nstored as 0.20 (not 20).", "width": Lino.chars2width(12), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "can_edit", "editable": true, "filter": { "type": "boolean" }, "header": "Betrag \u00e4nderbar", "sortable": false, "tooltip": "(vat.VatRules.can_edit) Whether the VAT amount can be modified by the user. This applies\nonly for documents with VatTotal.auto_compute_totals set\nto False.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 7, "dataIndex": "vat_account", "editable": true, "editor": vat_account10995, "filter": { "type": "string" }, "header": "VAT account", "sortable": false, "tooltip": "(vat.VatRules.vat_account) The general account where VAT is to be booked.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "vat_returnable", "editable": true, "filter": { "type": "boolean" }, "header": "VAT is returnable", "sortable": false, "tooltip": "(vat.VatRules.vat_returnable) Whether VAT is \"returnable\" (i.e. not to be paid to or by the\npartner). Returnable VAT, unlike normal VAT, does not increase\nthe total amount of the voucher and causes an additional\nmovement into the vat_returnable_account.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 9, "dataIndex": "vat_returnable_account", "editable": true, "editor": vat_returnable_account10997, "filter": { "type": "string" }, "header": "VAT returnable account", "sortable": false, "tooltip": "(vat.VatRules.vat_returnable_account) Where to book returnable VAT. If VAT is returnable and this\nfield is empty, then VAT will be added to the base account.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 10, "dataIndex": "id", "editable": true, "editor": id10998, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(vat.VatRules.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "start_date", "editable": true, "editor": start_date10999, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(vat.VatRules.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 12, "dataIndex": "end_date", "editable": true, "editor": end_date11000, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enddatum", "hidden": true, "sortable": true, "tooltip": "(vat.VatRules.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 13, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(vat.VatRules.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 14, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(vat.VatRules.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(vat.VatRules.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(vat.VatRules.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.vat.VatRules.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.VatRules.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRules", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRules.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRules", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRules.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRules", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRules.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRules", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRules.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRules", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRules.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRules", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRules.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRules", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRules.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRules", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRules.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRules", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRules.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.vat.VatRules.ParamsPanel({});
  return new Lino.vat.VatRules.GridPanel(p);
});
Lino.vat.VatRules.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRules", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRules.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRules", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class vat.Invoices
Lino.vat.Invoices.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 29,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/vat/Invoices",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/Invoices','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/Invoices','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/Invoices','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/Invoices','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/Invoices','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Rechnungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "id", "type": "int" }, { "name": "number_with_year" }, { "name": "partner" }, 'partnerHidden', { "name": "total_incl" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "your_ref" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 1,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.Invoices.detail;
    this.ls_insert_handler = Lino.vat.Invoices.insert;
    var ww = this.containing_window;
    var entry_date5064 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var id5065 = new Ext.form.NumberField({ "selectOnFocus": true });
    var number_with_year_disp5066 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var partner5067 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/partner" }) }) });
    var total_incl5068 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var user5069 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/user" }) }) });
    var journal5070 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/journal" }) }) });
    var voucher_date5071 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period5072 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/accounting_period" }) }) });
    var number5073 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var narration5074 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state5075 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var payment_term5076 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/payment_term" }) }) });
    var match5077 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/match" }) }) });
    var your_ref5078 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var due_date5079 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var total_base5080 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat5081 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_regime5082 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var mobile_item_disp5083 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5084 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5085 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      match5077.setContextValue('journal', record ? record.data['journalHidden'] : undefined);
      match5077.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      journal5070.on('change',Lino.chooser_handler(match5077,'journal'));
      partner5067.on('change',Lino.chooser_handler(match5077,'partner'));
      Lino.vat.Invoices.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "entry_date", "editable": true, "editor": entry_date5064, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(vat.Invoices.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "id", "editable": true, "editor": id5065, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(vat.Invoices.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "sortable": false, "tooltip": "(vat.Invoices.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 3, "dataIndex": "partner", "editable": true, "editor": partner5067, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(vat.Invoices.partner) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "total_incl", "editable": true, "editor": total_incl5068, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(vat.Invoices.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user5069, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(vat.Invoices.user) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "journal", "editable": true, "editor": journal5070, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(vat.Invoices.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date5071, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(vat.Invoices.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period5072, "filter": { "type": "string" }, "header": "Buchungsperiode", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 9, "dataIndex": "number", "editable": true, "editor": number5073, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(vat.Invoices.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 10, "dataIndex": "narration", "editable": true, "editor": narration5074, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(vat.Invoices.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 11, "dataIndex": "state", "editable": true, "editor": state5075, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 12, "dataIndex": "payment_term", "editable": true, "editor": payment_term5076, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(vat.Invoices.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "match", "editable": true, "editor": match5077, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "your_ref", "editable": true, "editor": your_ref5078, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(vat.Invoices.your_ref) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "due_date", "editable": true, "editor": due_date5079, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Zahlungsziel", "hidden": true, "sortable": true, "tooltip": "(vat.Invoices.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 16, "dataIndex": "total_base", "editable": true, "editor": total_base5080, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "hidden": true, "sortable": true, "tooltip": "(vat.Invoices.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 17, "dataIndex": "total_vat", "editable": true, "editor": total_vat5081, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "hidden": true, "sortable": true, "tooltip": "(vat.Invoices.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 18, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5082, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 19, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.vat.Invoices.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.Invoices.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.vat.Invoices.insertPanel = Ext.extend(Lino.vat.Invoices.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/vat/Invoices",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.Invoices.detail;
    this.ls_insert_handler = Lino.vat.Invoices.insert;
    Lino.vat.Invoices.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.Invoices.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.vat.Invoices.insertPanel(p);
});
Lino.vat.Invoices.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.vat.Invoices.detailPanel = Ext.extend(Lino.vat.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/vat/Invoices",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.Invoices.detail;
    this.ls_insert_handler = Lino.vat.Invoices.insert;
    Lino.vat.Invoices.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.Invoices.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.Invoices.detailPanel(p);
});
Lino.vat.Invoices.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.vat.Invoices.ParamsPanel({});
  return new Lino.vat.Invoices.GridPanel(p);
});
Lino.vat.Invoices.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/Invoices", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class vat.IntracomInvoices
Lino.vat.IntracomInvoices.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/vat/IntracomInvoices",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomInvoices','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomInvoices','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomInvoices','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomInvoices','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomInvoices','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "vat documents",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  ls_store_fields : [ { "name": "detail_pointer" }, { "name": "partner" }, 'partnerHidden', { "name": "partner__vat_id" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "total_base" }, { "name": "total_vat" }, { "name": "total_incl" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var detail_pointer_disp5087 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var partner5088 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/IntracomInvoices/partner" }) }) });
    var partner__vat_id5089 = new Ext.form.TextField({ "disabled": true, "maxLength": 200, "sortable": false });
    var vat_regime5090 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var total_base5091 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat5092 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_incl5093 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "sortable": false, "tooltip": "(vat.IntracomInvoices.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner5088, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(vat.IntracomInvoices.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "partner__vat_id", "editable": false, "filter": { "type": "string" }, "header": "MwSt.-Nr.", "sortable": true, "tooltip": "(vat.IntracomInvoices.partner__vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5090, "filter": { "type": "string" }, "header": "MwSt.-Regime", "sortable": false, "tooltip": "(vat.IntracomInvoices.vat_regime) ", "width": Lino.chars2width(19) }, { "align": "right", "colIndex": 4, "dataIndex": "total_base", "editable": true, "editor": total_base5091, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "sortable": true, "tooltip": "(vat.IntracomInvoices.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "total_vat", "editable": true, "editor": total_vat5092, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "sortable": true, "tooltip": "(vat.IntracomInvoices.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "total_incl", "editable": true, "editor": total_incl5093, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(vat.IntracomInvoices.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.vat.IntracomInvoices.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.IntracomInvoices.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomInvoices", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomInvoices.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomInvoices", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomInvoices.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomInvoices", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomInvoices.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomInvoices", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomInvoices.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomInvoices", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomInvoices.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomInvoices", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomInvoices.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.vat.IntracomInvoices.ParamsPanel({});
  return new Lino.vat.IntracomInvoices.GridPanel(p);
});
Lino.vat.IntracomInvoices.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomInvoices", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomInvoices.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomInvoices", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomInvoices.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomInvoices", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class vat.IntracomSales
Lino.vat.IntracomSales.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/vat/IntracomSales",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomSales','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomSales','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomSales','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomSales','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomSales','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Intra-Community sales",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  ls_store_fields : [ { "name": "detail_pointer" }, { "name": "partner" }, 'partnerHidden', { "name": "partner__vat_id" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "total_base" }, { "name": "total_vat" }, { "name": "total_incl" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var detail_pointer_disp5095 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var partner5096 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/IntracomSales/partner" }) }) });
    var partner__vat_id5097 = new Ext.form.TextField({ "disabled": true, "maxLength": 200, "sortable": false });
    var vat_regime5098 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var total_base5099 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat5100 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_incl5101 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "sortable": false, "tooltip": "(vat.IntracomSales.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner5096, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(vat.IntracomSales.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "partner__vat_id", "editable": false, "filter": { "type": "string" }, "header": "MwSt.-Nr.", "sortable": true, "tooltip": "(vat.IntracomSales.partner__vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5098, "filter": { "type": "string" }, "header": "MwSt.-Regime", "sortable": false, "tooltip": "(vat.IntracomSales.vat_regime) ", "width": Lino.chars2width(19) }, { "align": "right", "colIndex": 4, "dataIndex": "total_base", "editable": true, "editor": total_base5099, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "sortable": true, "tooltip": "(vat.IntracomSales.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "total_vat", "editable": true, "editor": total_vat5100, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "sortable": true, "tooltip": "(vat.IntracomSales.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "total_incl", "editable": true, "editor": total_incl5101, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(vat.IntracomSales.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.vat.IntracomSales.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.IntracomSales.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomSales", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomSales.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomSales", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomSales.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomSales", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomSales.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomSales", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomSales.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomSales", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomSales.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomSales", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomSales.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.vat.IntracomInvoices.ParamsPanel({});
  return new Lino.vat.IntracomSales.GridPanel(p);
});
Lino.vat.IntracomSales.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomSales", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomSales.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomSales", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomSales.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomSales", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class vat.IntracomPurchases
Lino.vat.IntracomPurchases.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/vat/IntracomPurchases",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomPurchases','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomPurchases','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomPurchases','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomPurchases','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/IntracomPurchases','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Intra-Community purchases",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  ls_store_fields : [ { "name": "detail_pointer" }, { "name": "partner" }, 'partnerHidden', { "name": "partner__vat_id" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "total_base" }, { "name": "total_vat" }, { "name": "total_incl" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var detail_pointer_disp5103 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var partner5104 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/IntracomPurchases/partner" }) }) });
    var partner__vat_id5105 = new Ext.form.TextField({ "disabled": true, "maxLength": 200, "sortable": false });
    var vat_regime5106 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var total_base5107 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat5108 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_incl5109 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "sortable": false, "tooltip": "(vat.IntracomPurchases.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner5104, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(vat.IntracomPurchases.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "partner__vat_id", "editable": false, "filter": { "type": "string" }, "header": "MwSt.-Nr.", "sortable": true, "tooltip": "(vat.IntracomPurchases.partner__vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5106, "filter": { "type": "string" }, "header": "MwSt.-Regime", "sortable": false, "tooltip": "(vat.IntracomPurchases.vat_regime) ", "width": Lino.chars2width(19) }, { "align": "right", "colIndex": 4, "dataIndex": "total_base", "editable": true, "editor": total_base5107, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "sortable": true, "tooltip": "(vat.IntracomPurchases.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "total_vat", "editable": true, "editor": total_vat5108, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "sortable": true, "tooltip": "(vat.IntracomPurchases.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "total_incl", "editable": true, "editor": total_incl5109, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(vat.IntracomPurchases.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.vat.IntracomPurchases.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.IntracomPurchases.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomPurchases", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomPurchases.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomPurchases", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomPurchases.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomPurchases", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomPurchases.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomPurchases", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomPurchases.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomPurchases", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomPurchases.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomPurchases", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomPurchases.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.vat.IntracomInvoices.ParamsPanel({});
  return new Lino.vat.IntracomPurchases.GridPanel(p);
});
Lino.vat.IntracomPurchases.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomPurchases", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomPurchases.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomPurchases", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.IntracomPurchases.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/IntracomPurchases", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Slots
Lino.courses.Slots.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 9,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Slots",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Slots','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Slots','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Slots','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Slots','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Slots','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Timetable Slots",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "start_time" }, { "name": "end_time" }, { "name": "name" }, { "name": "move_buttons" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 49,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Slots.detail;
    this.ls_insert_handler = Lino.courses.Slots.insert;
    var ww = this.containing_window;
    var id11006 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno11007 = new Ext.form.NumberField({ "selectOnFocus": true });
    var start_time11008 = new Lino.TimeField({ "selectOnFocus": true });
    var end_time11009 = new Lino.TimeField({ "selectOnFocus": true });
    var name11010 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var move_buttons_disp11011 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp11012 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp11013 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp11014 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id11006, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(courses.Slots.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno11007, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(courses.Slots.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "start_time", "editable": true, "editor": start_time11008, "header": "Beginnt um", "sortable": true, "tooltip": "(courses.Slots.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 3, "dataIndex": "end_time", "editable": true, "editor": end_time11009, "header": "Endet um", "sortable": true, "tooltip": "(courses.Slots.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 4, "dataIndex": "name", "editable": true, "editor": name11010, "filter": { "type": "string" }, "header": "Name", "sortable": true, "tooltip": "(courses.Slots.name) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(courses.Slots.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Slots.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Slots.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.Slots.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.courses.Slots.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Slots.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Slots", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Slots.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Slots", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Slots.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Slots", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Slots.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Slots", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Slots.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Slots", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Slots.insertPanel = Ext.extend(Lino.courses.Slots.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/Slots",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Slots.detail;
    this.ls_insert_handler = Lino.courses.Slots.insert;
    Lino.courses.Slots.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Slots.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Slots.insertPanel(p);
});
Lino.courses.Slots.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Slots", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Slots.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Slots", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Slots.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Slots", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Slots.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Slots", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Slots.detailPanel = Ext.extend(Lino.courses.Slots.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/courses/Slots",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Slots.detail;
    this.ls_insert_handler = Lino.courses.Slots.insert;
    Lino.courses.Slots.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Slots.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Slots.detailPanel(p);
});
Lino.courses.Slots.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Slots", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Slots.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Slots.GridPanel(p);
});
Lino.courses.Slots.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Slots", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Slots.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Slots", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Slots.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Slots", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Topics
Lino.courses.Topics.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 7,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Topics",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Topics','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Topics','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Topics','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Topics','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Topics','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  cell_edit : true,
  title : "Themen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 54,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Topics.detail;
    var ww = this.containing_window;
    var id11016 = new Ext.form.NumberField({ "selectOnFocus": true });
    var name11017 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de11018 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr11019 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var mobile_item_disp11020 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp11021 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp11022 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id11016, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(courses.Topics.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name11017, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(courses.Topics.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de11018, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(courses.Topics.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr11019, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(courses.Topics.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Topics.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Topics.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.Topics.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.courses.Topics.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Topics.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Topics", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Topics.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Topics", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Topics.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Topics", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Topics.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Topics", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Topics.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Topics", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Topics.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Topics", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Topics.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Topics", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Topics.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Topics", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Topics.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Topics", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Topics.detailPanel = Ext.extend(Lino.courses.Topics.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  ls_url: "/courses/Topics",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Topics.detail;
    Lino.courses.Topics.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Topics.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Topics.detailPanel(p);
});
Lino.courses.Topics.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Topics", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Topics.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Topics", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Topics.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Topics.GridPanel(p);
});
Lino.courses.Topics.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Topics", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Lines
Lino.courses.Lines.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 40,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Lines",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Lines','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Lines','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Lines','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Lines','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Lines','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Aktivit\u00e4tenreihen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "topic" }, 'topicHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "guest_role" }, 'guest_roleHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "excerpt_title" }, { "name": "excerpt_title_de" }, { "name": "excerpt_title_fr" }, { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "fee" }, 'feeHidden', { "name": "options_cat" }, 'options_catHidden', { "name": "fees_cat" }, 'fees_catHidden', { "name": "body_template" }, { "name": "course_type" }, 'course_typeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 15,
  ls_grid_configs : [  ],
  content_type : 57,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Lines.detail;
    this.ls_insert_handler = Lino.courses.Lines.insert;
    var ww = this.containing_window;
    var ref5111 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name5112 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de5113 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr5114 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var topic5115 = new Lino.RemoteComboFieldElement({ "emptyText": "Thema ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/topic" }) }) });
    var course_area5116 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.courses.CourseAreas });
    var event_type5117 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/event_type" }) }) });
    var guest_role5118 = new Lino.RemoteComboFieldElement({ "emptyText": "Gastrolle ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/guest_role" }) }) });
    var every_unit5119 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every5120 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var id5121 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var company5122 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/company" }) }) });
    var contact_person5123 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/contact_person" }) }) });
    var contact_role5124 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/contact_role" }) }) });
    var excerpt_title5125 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var excerpt_title_de5126 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var excerpt_title_fr5127 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var description5128 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de5129 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr5130 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var fee5131 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/fee" }) }) });
    var options_cat5132 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarifkategorie ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/options_cat" }) }) });
    var fees_cat5133 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarifkategorie ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/fees_cat" }) }) });
    var body_template5134 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/body_template" }) }) });
    var course_type5135 = new Lino.RemoteComboFieldElement({ "emptyText": "Aktivit\u00e4tsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/course_type" }) }) });
    var mobile_item_disp5136 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5137 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5138 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      contact_person5123.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      fee5131.setContextValue('fees_cat', record ? record.data['fees_catHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company5122.on('change',Lino.chooser_handler(contact_person5123,'company'));
      fees_cat5133.on('change',Lino.chooser_handler(fee5131,'fees_cat'));
      Lino.courses.Lines.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref5111, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(courses.Lines.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name5112, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(courses.Lines.name) The designation of this activity line as seen by the user\ne.g. when selecting the line.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de5113, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(courses.Lines.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr5114, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(courses.Lines.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "topic", "editable": true, "editor": topic5115, "filter": { "type": "string" }, "header": "Thema", "renderer": Lino.fk_renderer('topicHidden','Lino.courses.Topics.detail'), "sortable": false, "tooltip": "(courses.Lines.topic) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "course_area", "editable": true, "editor": course_area5116, "filter": { "type": "string" }, "header": "Layout", "sortable": false, "tooltip": "(courses.Lines.course_area) Pointer to CourseAreas.  This is used only when an\napplication defines several variants of\nEnrolmentsByPupil.", "width": Lino.chars2width(14) }, { "colIndex": 6, "dataIndex": "event_type", "editable": true, "editor": event_type5117, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(courses.Lines.event_type) The type of calendar entries to be generated. If this is empty, no calendar entries will be generated.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "guest_role", "editable": true, "editor": guest_role5118, "filter": { "type": "string" }, "header": "Anwesenheiten erfassen als", "renderer": Lino.fk_renderer('guest_roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(courses.Lines.guest_role) The default guest role for particpants of calendar entries for activities in this series. Leave empty if you don't want any presences management.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "every_unit", "editable": true, "editor": every_unit5119, "filter": { "type": "string" }, "header": "Wiederholung", "sortable": false, "tooltip": "(courses.Lines.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 9, "dataIndex": "every", "editable": true, "editor": every5120, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "sortable": true, "tooltip": "(courses.Lines.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 10, "dataIndex": "id", "editable": true, "editor": id5121, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Lines.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "company", "editable": true, "editor": company5122, "filter": { "type": "string" }, "header": "Organisation", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(courses.Lines.company) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "contact_person", "editable": true, "editor": contact_person5123, "filter": { "type": "string" }, "header": "Vertreten durch", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(courses.Lines.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "contact_role", "editable": true, "editor": contact_role5124, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "excerpt_title", "editable": true, "editor": excerpt_title5125, "filter": { "type": "string" }, "header": "Excerpt title", "hidden": true, "sortable": true, "tooltip": "(courses.Lines.excerpt_title) The title to be used when printing an excerpt.", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "excerpt_title_de", "editable": true, "editor": excerpt_title_de5126, "filter": { "type": "string" }, "header": "Excerpt title (de)", "hidden": true, "sortable": true, "tooltip": "(courses.Lines.excerpt_title_de) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "excerpt_title_fr", "editable": true, "editor": excerpt_title_fr5127, "filter": { "type": "string" }, "header": "Excerpt title (fr)", "hidden": true, "sortable": true, "tooltip": "(courses.Lines.excerpt_title_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "description", "editable": true, "editor": description5128, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.description) ", "width": Lino.chars2width(61) }, { "colIndex": 18, "dataIndex": "description_de", "editable": true, "editor": description_de5129, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 19, "dataIndex": "description_fr", "editable": true, "editor": description_fr5130, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 20, "dataIndex": "fee", "editable": true, "editor": fee5131, "filter": { "type": "string" }, "header": "Teilnahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Lines.fee) ", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "options_cat", "editable": true, "editor": options_cat5132, "filter": { "type": "string" }, "header": "Kategorie f\u00fcr Optionen", "hidden": true, "renderer": Lino.fk_renderer('options_catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(courses.Lines.options_cat) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "fees_cat", "editable": true, "editor": fees_cat5133, "filter": { "type": "string" }, "header": "Kategorie f\u00fcr Teilnahmegeb\u00fchren", "hidden": true, "renderer": Lino.fk_renderer('fees_catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(courses.Lines.fees_cat) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "body_template", "editable": true, "editor": body_template5134, "filter": { "type": "string" }, "header": "Textk\u00f6rper-Vorlage", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.body_template) The body template to use when printing a course of this series. Leave empty to use the site's default.", "width": Lino.chars2width(11) }, { "colIndex": 24, "dataIndex": "course_type", "editable": true, "editor": course_type5135, "filter": { "type": "string" }, "header": "Aktivit\u00e4tsart", "hidden": true, "renderer": Lino.fk_renderer('course_typeHidden','Lino.courses.CourseTypes.detail'), "sortable": false, "tooltip": "(courses.Lines.course_type) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.courses.Lines.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Lines.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Lines", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Lines", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Lines", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Lines", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Lines", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Lines.insertPanel = Ext.extend(Lino.courses.Lines.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/Lines",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Lines.detail;
    this.ls_insert_handler = Lino.courses.Lines.insert;
    Lino.courses.Lines.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Lines.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(16), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Lines.insertPanel(p);
});
Lino.courses.Lines.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Lines", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Lines", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Lines", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Lines", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Lines.detailPanel = Ext.extend(Lino.courses.Lines.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/courses/Lines",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Lines.detail;
    this.ls_insert_handler = Lino.courses.Lines.insert;
    Lino.courses.Lines.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Lines.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Lines.detailPanel(p);
});
Lino.courses.Lines.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Lines", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Lines.GridPanel(p);
});
Lino.courses.Lines.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Lines", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Activities
Lino.courses.Activities.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 58,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Activities",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Activities','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Activities','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Activities','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Activities','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Activities','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Aktivit\u00e4ten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "name" }, { "name": "line" }, 'lineHidden', { "name": "teacher" }, 'teacherHidden', { "name": "room" }, 'roomHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "ref" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Activities.detail;
    this.ls_insert_handler = Lino.courses.Activities.insert;
    var ww = this.containing_window;
    var start_date5140 = new Lino.DateField({ "selectOnFocus": true });
    var name5141 = new Ext.form.TextField({ "maxLength": 100, "selectOnFocus": true });
    var line5142 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/line" }) }) });
    var teacher5143 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/teacher" }) }) });
    var room5144 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/room" }) }) });
    var workflow_buttons_disp5145 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id5146 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref5147 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_time5148 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date5149 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time5150 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user5151 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/user" }) }) });
    var every_unit5152 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every5153 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday5154 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday5155 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday5156 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday5157 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday5158 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday5159 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday5160 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events5161 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date5162 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var slot5163 = new Lino.RemoteComboFieldElement({ "emptyText": "Timetable Slot ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/slot" }) }) });
    var description5164 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de5165 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr5166 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark5167 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state5168 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places5169 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var enrolments_until5170 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee5171 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/fee" }) }) });
    var payment_term5172 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/payment_term" }) }) });
    var paper_type5173 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/paper_type" }) }) });
    var mobile_item_disp5174 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5175 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp5176 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments5177 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp5178 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested5179 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed5180 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox5181 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Anwesenheiten", "value": "<br/>" });
    var trying5182 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places5183 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var what_text_disp5184 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp5185 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp5186 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration5187 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee5171.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox5181.refresh();
    };
    this.onRender = function(ct, position) {
      line5142.on('change',Lino.chooser_handler(fee5171,'line'));
      Lino.courses.Activities.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date5140, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.Activities.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name5141, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(courses.Activities.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "line", "editable": true, "editor": line5142, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.Activities.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "teacher", "editable": true, "editor": teacher5143, "filter": { "type": "string" }, "header": "Kursleiter", "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.Activities.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "room", "editable": true, "editor": room5144, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.Activities.room) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.Activities.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id5146, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "ref", "editable": true, "editor": ref5147, "filter": { "type": "string" }, "header": "Referenz", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time5148, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date5149, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time5150, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user5151, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.Activities.user) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "every_unit", "editable": true, "editor": every_unit5152, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 13, "dataIndex": "every", "editable": true, "editor": every5153, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 14, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 20, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 21, "dataIndex": "max_events", "editable": true, "editor": max_events5161, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date5162, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "slot", "editable": true, "editor": slot5163, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "renderer": Lino.fk_renderer('slotHidden','Lino.courses.Slots.detail'), "sortable": false, "tooltip": "(courses.Activities.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "description", "editable": true, "editor": description5164, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.description) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_de", "editable": true, "editor": description_de5165, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_fr", "editable": true, "editor": description_fr5166, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "remark", "editable": true, "editor": remark5167, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "state", "editable": true, "editor": state5168, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 29, "dataIndex": "max_places", "editable": true, "editor": max_places5169, "filter": { "type": "numeric" }, "format": "0", "header": "Verf\u00fcgbare Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.max_places) Maximum number of participants", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 30, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until5170, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Einschreibung m\u00f6glich bis", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 31, "dataIndex": "fee", "editable": true, "editor": fee5171, "filter": { "type": "string" }, "header": "Standard-Teilnehmahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Activities.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "payment_term", "editable": true, "editor": payment_term5172, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.Activities.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "paper_type", "editable": true, "editor": paper_type5173, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "events_text", "editable": false, "header": "Kalendereintr\u00e4ge", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 37, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Einschreibungen", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.enrolments) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Angefragt", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.requested) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Best\u00e4tigt", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.confirmed) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Anwesenheiten", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Test", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.trying) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Freie Pl\u00e4tze", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.free_places) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 44, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.Activities.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Activities.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Activities.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/Activities",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Activities.detail;
    this.ls_insert_handler = Lino.courses.Activities.insert;
    Lino.courses.Activities.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Activities.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Activities.insertPanel(p);
});
Lino.courses.Activities.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Activities.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/Activities",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Activities.detail;
    this.ls_insert_handler = Lino.courses.Activities.insert;
    Lino.courses.Activities.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Activities.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Activities.detailPanel(p);
});
Lino.courses.Activities.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.Activities.GridPanel(p);
});
Lino.courses.Activities.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Activities", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Courses
Lino.courses.Courses.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 58,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Courses",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Courses','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Courses','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Courses','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Courses','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Courses','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Kurse",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "room" }, 'roomHidden', { "name": "teacher" }, 'teacherHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Courses.detail;
    this.ls_insert_handler = Lino.courses.Courses.insert;
    var ww = this.containing_window;
    var ref5189 = new Ext.form.TextField({ "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date5190 = new Lino.DateField({ "selectOnFocus": true });
    var enrolments_until5191 = new Lino.DateField({ "selectOnFocus": true });
    var line5192 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/line" }) }) });
    var room5193 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/room" }) }) });
    var teacher5194 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/teacher" }) }) });
    var workflow_buttons_disp5195 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id5196 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_time5197 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date5198 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time5199 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user5200 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/user" }) }) });
    var every_unit5201 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every5202 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday5203 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday5204 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday5205 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday5206 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday5207 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday5208 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday5209 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events5210 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date5211 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var slot5212 = new Lino.RemoteComboFieldElement({ "emptyText": "Timetable Slot ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/slot" }) }) });
    var description5213 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de5214 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr5215 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark5216 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state5217 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places5218 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name5219 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var fee5220 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/fee" }) }) });
    var payment_term5221 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/payment_term" }) }) });
    var paper_type5222 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/paper_type" }) }) });
    var mobile_item_disp5223 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5224 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp5225 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments5226 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp5227 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested5228 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed5229 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox5230 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Anwesenheiten", "value": "<br/>" });
    var trying5231 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places5232 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var what_text_disp5233 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp5234 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp5235 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration5236 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee5220.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox5230.refresh();
    };
    this.onRender = function(ct, position) {
      line5192.on('change',Lino.chooser_handler(fee5220,'line'));
      Lino.courses.Courses.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref5189, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(courses.Courses.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "start_date", "editable": true, "editor": start_date5190, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.Courses.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until5191, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Einschreibung m\u00f6glich bis", "sortable": true, "tooltip": "(courses.Courses.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "line", "editable": true, "editor": line5192, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.Courses.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "room", "editable": true, "editor": room5193, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.Courses.room) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "teacher", "editable": true, "editor": teacher5194, "filter": { "type": "string" }, "header": "Kursleiter", "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.Courses.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.Courses.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id5196, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time5197, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date5198, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time5199, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user5200, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.Courses.user) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "every_unit", "editable": true, "editor": every_unit5201, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 13, "dataIndex": "every", "editable": true, "editor": every5202, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 14, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 20, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 21, "dataIndex": "max_events", "editable": true, "editor": max_events5210, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date5211, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "slot", "editable": true, "editor": slot5212, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "renderer": Lino.fk_renderer('slotHidden','Lino.courses.Slots.detail'), "sortable": false, "tooltip": "(courses.Courses.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "description", "editable": true, "editor": description5213, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.description) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_de", "editable": true, "editor": description_de5214, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_fr", "editable": true, "editor": description_fr5215, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "remark", "editable": true, "editor": remark5216, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "state", "editable": true, "editor": state5217, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 29, "dataIndex": "max_places", "editable": true, "editor": max_places5218, "filter": { "type": "numeric" }, "format": "0", "header": "Verf\u00fcgbare Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.max_places) Maximum number of participants", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 30, "dataIndex": "name", "editable": true, "editor": name5219, "filter": { "type": "string" }, "header": "Bezeichnung", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 31, "dataIndex": "fee", "editable": true, "editor": fee5220, "filter": { "type": "string" }, "header": "Standard-Teilnehmahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Courses.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "payment_term", "editable": true, "editor": payment_term5221, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.Courses.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "paper_type", "editable": true, "editor": paper_type5222, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "events_text", "editable": false, "header": "Kalendereintr\u00e4ge", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 37, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Einschreibungen", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.enrolments) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Angefragt", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.requested) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Best\u00e4tigt", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.confirmed) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Anwesenheiten", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Test", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.trying) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Freie Pl\u00e4tze", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.free_places) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 44, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.Courses.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Courses.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Courses.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/Courses",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Courses.detail;
    this.ls_insert_handler = Lino.courses.Courses.insert;
    Lino.courses.Courses.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Courses.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Courses.insertPanel(p);
});
Lino.courses.Courses.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Courses.detailPanel = Ext.extend(Lino.courses.Courses.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/Courses",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Courses.detail;
    this.ls_insert_handler = Lino.courses.Courses.insert;
    Lino.courses.Courses.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Courses.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Courses.detailPanel(p);
});
Lino.courses.Courses.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.Courses.GridPanel(p);
});
Lino.courses.Courses.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Courses", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.AllActivities
Lino.courses.AllActivities.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 10,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/AllActivities",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/AllActivities','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/AllActivities','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/AllActivities','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/AllActivities','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/AllActivities','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Aktivit\u00e4ten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "line" }, 'lineHidden', { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "teacher" }, 'teacherHidden', { "name": "user" }, 'userHidden', { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.AllActivities.detail;
    this.ls_insert_handler = Lino.courses.AllActivities.insert;
    var ww = this.containing_window;
    var line11024 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllActivities/line" }) }) });
    var start_date11025 = new Lino.DateField({ "selectOnFocus": true });
    var teacher11026 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllActivities/teacher" }) }) });
    var user11027 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllActivities/user" }) }) });
    var weekdays_text_disp11028 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var times_text_disp11029 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "line", "editable": true, "editor": line11024, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.AllActivities.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "start_date", "editable": true, "editor": start_date11025, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.AllActivities.start_date) ", "width": Lino.chars2width(9), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "teacher", "editable": true, "editor": teacher11026, "filter": { "type": "string" }, "header": "Kursleiter", "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.AllActivities.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user11027, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.AllActivities.user) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(courses.AllActivities.weekdays_text) ", "width": Lino.chars2width(11) }, { "colIndex": 5, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "sortable": false, "tooltip": "(courses.AllActivities.times_text) ", "width": Lino.chars2width(11) } ];
    Lino.courses.AllActivities.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.AllActivities.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.AllActivities.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/AllActivities",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.AllActivities.detail;
    this.ls_insert_handler = Lino.courses.AllActivities.insert;
    Lino.courses.AllActivities.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.AllActivities.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.AllActivities.insertPanel(p);
});
Lino.courses.AllActivities.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.AllActivities.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/AllActivities",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.AllActivities.detail;
    this.ls_insert_handler = Lino.courses.AllActivities.insert;
    Lino.courses.AllActivities.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.AllActivities.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.AllActivities.detailPanel(p);
});
Lino.courses.AllActivities.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.AllActivities.GridPanel(p);
});
Lino.courses.AllActivities.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllActivities", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.MyActivities
Lino.courses.MyActivities.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 58,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/MyActivities",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/MyActivities','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/MyActivities','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/MyActivities','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/MyActivities','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/MyActivities','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Meine Aktivit\u00e4ten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "room" }, 'roomHidden', { "name": "name" }, { "name": "line" }, 'lineHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "ref" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.MyActivities.detail;
    this.ls_insert_handler = Lino.courses.MyActivities.insert;
    var ww = this.containing_window;
    var start_date841 = new Lino.DateField({ "selectOnFocus": true });
    var room842 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/room" }) }) });
    var name843 = new Ext.form.TextField({ "maxLength": 100, "selectOnFocus": true });
    var line844 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/line" }) }) });
    var workflow_buttons_disp845 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id846 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref847 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_time848 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date849 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time850 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user851 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/user" }) }) });
    var every_unit852 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every853 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday854 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday855 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday856 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday857 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday858 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday859 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday860 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events861 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date862 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var teacher863 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/teacher" }) }) });
    var slot864 = new Lino.RemoteComboFieldElement({ "emptyText": "Timetable Slot ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/slot" }) }) });
    var description865 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de866 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr867 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark868 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state869 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places870 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var enrolments_until871 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee872 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/fee" }) }) });
    var payment_term873 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/payment_term" }) }) });
    var paper_type874 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/paper_type" }) }) });
    var mobile_item_disp875 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp876 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp877 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments878 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp879 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested880 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed881 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox882 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Anwesenheiten", "value": "<br/>" });
    var trying883 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places884 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var what_text_disp885 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp886 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp887 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration888 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee872.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox882.refresh();
    };
    this.onRender = function(ct, position) {
      line844.on('change',Lino.chooser_handler(fee872,'line'));
      Lino.courses.MyActivities.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date841, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.MyActivities.start_date) ", "width": Lino.chars2width(9), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "room", "editable": true, "editor": room842, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.MyActivities.room) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "name", "editable": true, "editor": name843, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(courses.MyActivities.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "line", "editable": true, "editor": line844, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.MyActivities.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.MyActivities.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id846, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "ref", "editable": true, "editor": ref847, "filter": { "type": "string" }, "header": "Referenz", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "start_time", "editable": true, "editor": start_time848, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 8, "dataIndex": "end_date", "editable": true, "editor": end_date849, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "end_time", "editable": true, "editor": end_time850, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "user", "editable": true, "editor": user851, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.MyActivities.user) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "every_unit", "editable": true, "editor": every_unit852, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 12, "dataIndex": "every", "editable": true, "editor": every853, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 13, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 20, "dataIndex": "max_events", "editable": true, "editor": max_events861, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 21, "dataIndex": "max_date", "editable": true, "editor": max_date862, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 22, "dataIndex": "teacher", "editable": true, "editor": teacher863, "filter": { "type": "string" }, "header": "Kursleiter", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.MyActivities.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "slot", "editable": true, "editor": slot864, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "renderer": Lino.fk_renderer('slotHidden','Lino.courses.Slots.detail'), "sortable": false, "tooltip": "(courses.MyActivities.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "description", "editable": true, "editor": description865, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.description) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_de", "editable": true, "editor": description_de866, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_fr", "editable": true, "editor": description_fr867, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "remark", "editable": true, "editor": remark868, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "state", "editable": true, "editor": state869, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 29, "dataIndex": "max_places", "editable": true, "editor": max_places870, "filter": { "type": "numeric" }, "format": "0", "header": "Verf\u00fcgbare Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.max_places) Maximum number of participants", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 30, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until871, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Einschreibung m\u00f6glich bis", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 31, "dataIndex": "fee", "editable": true, "editor": fee872, "filter": { "type": "string" }, "header": "Standard-Teilnehmahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.MyActivities.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "payment_term", "editable": true, "editor": payment_term873, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.MyActivities.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "paper_type", "editable": true, "editor": paper_type874, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "events_text", "editable": false, "header": "Kalendereintr\u00e4ge", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 37, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Einschreibungen", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.enrolments) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Angefragt", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.requested) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Best\u00e4tigt", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.confirmed) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Anwesenheiten", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Test", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.trying) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Freie Pl\u00e4tze", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.free_places) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 44, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.MyActivities.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.MyActivities.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.MyActivities.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/MyActivities",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.MyActivities.detail;
    this.ls_insert_handler = Lino.courses.MyActivities.insert;
    Lino.courses.MyActivities.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.MyActivities.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.MyActivities.insertPanel(p);
});
Lino.courses.MyActivities.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.MyActivities.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/MyActivities",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.MyActivities.detail;
    this.ls_insert_handler = Lino.courses.MyActivities.insert;
    Lino.courses.MyActivities.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.MyActivities.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.MyActivities.detailPanel(p);
});
Lino.courses.MyActivities.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.MyActivities.GridPanel(p);
});
Lino.courses.MyActivities.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/MyActivities", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.DraftCourses
Lino.courses.DraftCourses.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 58,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/DraftCourses",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/DraftCourses','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/DraftCourses','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/DraftCourses','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/DraftCourses','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/DraftCourses','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Draft activities",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "overview" }, { "name": "room" }, 'roomHidden', { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "workflow_buttons" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.DraftCourses.detail;
    this.ls_insert_handler = Lino.courses.DraftCourses.insert;
    var ww = this.containing_window;
    var overview_disp5238 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var room5239 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/room" }) }) });
    var id5240 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref5241 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date5242 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time5243 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date5244 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time5245 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user5246 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/user" }) }) });
    var every_unit5247 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every5248 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday5249 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday5250 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday5251 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday5252 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday5253 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday5254 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday5255 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events5256 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date5257 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var line5258 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/line" }) }) });
    var teacher5259 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/teacher" }) }) });
    var slot5260 = new Lino.RemoteComboFieldElement({ "emptyText": "Timetable Slot ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/slot" }) }) });
    var description5261 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de5262 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr5263 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark5264 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state5265 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places5266 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name5267 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until5268 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee5269 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/fee" }) }) });
    var payment_term5270 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/payment_term" }) }) });
    var paper_type5271 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/paper_type" }) }) });
    var mobile_item_disp5272 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5273 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp5274 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments5275 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp5276 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested5277 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed5278 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox5279 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Anwesenheiten", "value": "<br/>" });
    var trying5280 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places5281 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var what_text_disp5282 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp5283 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp5284 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration5285 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee5269.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox5279.refresh();
    };
    this.onRender = function(ct, position) {
      line5258.on('change',Lino.chooser_handler(fee5269,'line'));
      Lino.courses.DraftCourses.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(courses.DraftCourses.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "room", "editable": true, "editor": room5239, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.DraftCourses.room) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id5240, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "ref", "editable": true, "editor": ref5241, "filter": { "type": "string" }, "header": "Referenz", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "start_date", "editable": true, "editor": start_date5242, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "start_time", "editable": true, "editor": start_time5243, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 6, "dataIndex": "end_date", "editable": true, "editor": end_date5244, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "end_time", "editable": true, "editor": end_time5245, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user5246, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.DraftCourses.user) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "every_unit", "editable": true, "editor": every_unit5247, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 10, "dataIndex": "every", "editable": true, "editor": every5248, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 12, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 18, "dataIndex": "max_events", "editable": true, "editor": max_events5256, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 19, "dataIndex": "max_date", "editable": true, "editor": max_date5257, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 20, "dataIndex": "line", "editable": true, "editor": line5258, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "hidden": true, "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.DraftCourses.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "teacher", "editable": true, "editor": teacher5259, "filter": { "type": "string" }, "header": "Kursleiter", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.DraftCourses.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "slot", "editable": true, "editor": slot5260, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "renderer": Lino.fk_renderer('slotHidden','Lino.courses.Slots.detail'), "sortable": false, "tooltip": "(courses.DraftCourses.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "description", "editable": true, "editor": description5261, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.description) ", "width": Lino.chars2width(61) }, { "colIndex": 24, "dataIndex": "description_de", "editable": true, "editor": description_de5262, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_fr", "editable": true, "editor": description_fr5263, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "remark", "editable": true, "editor": remark5264, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "state", "editable": true, "editor": state5265, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 28, "dataIndex": "max_places", "editable": true, "editor": max_places5266, "filter": { "type": "numeric" }, "format": "0", "header": "Verf\u00fcgbare Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.max_places) Maximum number of participants", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 29, "dataIndex": "name", "editable": true, "editor": name5267, "filter": { "type": "string" }, "header": "Bezeichnung", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 30, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until5268, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Einschreibung m\u00f6glich bis", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 31, "dataIndex": "fee", "editable": true, "editor": fee5269, "filter": { "type": "string" }, "header": "Standard-Teilnehmahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.DraftCourses.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "payment_term", "editable": true, "editor": payment_term5270, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.DraftCourses.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "paper_type", "editable": true, "editor": paper_type5271, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "events_text", "editable": false, "header": "Kalendereintr\u00e4ge", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 37, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Einschreibungen", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.enrolments) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Angefragt", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.requested) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Best\u00e4tigt", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.confirmed) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Anwesenheiten", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Test", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.trying) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Freie Pl\u00e4tze", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.free_places) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 44, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.DraftCourses.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.DraftCourses.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.DraftCourses.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/DraftCourses",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.DraftCourses.detail;
    this.ls_insert_handler = Lino.courses.DraftCourses.insert;
    Lino.courses.DraftCourses.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.DraftCourses.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.DraftCourses.insertPanel(p);
});
Lino.courses.DraftCourses.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.DraftCourses.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/DraftCourses",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.DraftCourses.detail;
    this.ls_insert_handler = Lino.courses.DraftCourses.insert;
    Lino.courses.DraftCourses.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.DraftCourses.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.DraftCourses.detailPanel(p);
});
Lino.courses.DraftCourses.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.DraftCourses.GridPanel(p);
});
Lino.courses.DraftCourses.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/DraftCourses", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.ActiveCourses
Lino.courses.ActiveCourses.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 58,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/ActiveCourses",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/ActiveCourses','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/ActiveCourses','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/ActiveCourses','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/ActiveCourses','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/ActiveCourses','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Current activities",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "overview" }, { "name": "enrolments" }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "teacher" }, 'teacherHidden', { "name": "room" }, 'roomHidden', { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "workflow_buttons" }, { "name": "events_text" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.ActiveCourses.detail;
    this.ls_insert_handler = Lino.courses.ActiveCourses.insert;
    var ww = this.containing_window;
    var overview_disp5287 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var enrolments5288 = new Ext.form.NumberField({ "disabled": true });
    var free_places5289 = new Ext.form.NumberField({ "disabled": true });
    var teacher5290 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/teacher" }) }) });
    var room5291 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/room" }) }) });
    var id5292 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref5293 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date5294 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time5295 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date5296 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time5297 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user5298 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/user" }) }) });
    var every_unit5299 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every5300 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday5301 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday5302 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday5303 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday5304 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday5305 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday5306 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday5307 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events5308 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date5309 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var line5310 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/line" }) }) });
    var slot5311 = new Lino.RemoteComboFieldElement({ "emptyText": "Timetable Slot ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/slot" }) }) });
    var description5312 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de5313 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr5314 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark5315 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state5316 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places5317 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name5318 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until5319 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee5320 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/fee" }) }) });
    var payment_term5321 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/payment_term" }) }) });
    var paper_type5322 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/paper_type" }) }) });
    var mobile_item_disp5323 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5324 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp5325 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var print_actions_disp5326 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested5327 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed5328 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox5329 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Anwesenheiten", "value": "<br/>" });
    var trying5330 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var what_text_disp5331 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp5332 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp5333 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration5334 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee5320.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox5329.refresh();
    };
    this.onRender = function(ct, position) {
      line5310.on('change',Lino.chooser_handler(fee5320,'line'));
      Lino.courses.ActiveCourses.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(courses.ActiveCourses.overview) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Einschreibungen", "sortable": false, "tooltip": "(courses.ActiveCourses.enrolments) ", "width": Lino.chars2width(9), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Freie Pl\u00e4tze", "sortable": false, "tooltip": "(courses.ActiveCourses.free_places) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "teacher", "editable": true, "editor": teacher5290, "filter": { "type": "string" }, "header": "Kursleiter", "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.ActiveCourses.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "room", "editable": true, "editor": room5291, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.ActiveCourses.room) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id5292, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "ref", "editable": true, "editor": ref5293, "filter": { "type": "string" }, "header": "Referenz", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date5294, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time5295, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date5296, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time5297, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user5298, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.ActiveCourses.user) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "every_unit", "editable": true, "editor": every_unit5299, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 13, "dataIndex": "every", "editable": true, "editor": every5300, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 14, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 20, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 21, "dataIndex": "max_events", "editable": true, "editor": max_events5308, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date5309, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "line", "editable": true, "editor": line5310, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "hidden": true, "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.ActiveCourses.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "slot", "editable": true, "editor": slot5311, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "renderer": Lino.fk_renderer('slotHidden','Lino.courses.Slots.detail'), "sortable": false, "tooltip": "(courses.ActiveCourses.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "description", "editable": true, "editor": description5312, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.description) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_de", "editable": true, "editor": description_de5313, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "description_fr", "editable": true, "editor": description_fr5314, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "remark", "editable": true, "editor": remark5315, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 29, "dataIndex": "state", "editable": true, "editor": state5316, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 30, "dataIndex": "max_places", "editable": true, "editor": max_places5317, "filter": { "type": "numeric" }, "format": "0", "header": "Verf\u00fcgbare Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.max_places) Maximum number of participants", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 31, "dataIndex": "name", "editable": true, "editor": name5318, "filter": { "type": "string" }, "header": "Bezeichnung", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 32, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until5319, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Einschreibung m\u00f6glich bis", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 33, "dataIndex": "fee", "editable": true, "editor": fee5320, "filter": { "type": "string" }, "header": "Standard-Teilnehmahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.ActiveCourses.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "payment_term", "editable": true, "editor": payment_term5321, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.ActiveCourses.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 35, "dataIndex": "paper_type", "editable": true, "editor": paper_type5322, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 36, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 37, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 38, "dataIndex": "events_text", "editable": false, "header": "Kalendereintr\u00e4ge", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.events_text) ", "width": Lino.chars2width(31) }, { "colIndex": 39, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 40, "dataIndex": "requested", "editable": false, "format": "0", "header": "Angefragt", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.requested) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 41, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Best\u00e4tigt", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.confirmed) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 42, "dataIndex": "presences_box", "editable": false, "header": "Anwesenheiten", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 43, "dataIndex": "trying", "editable": false, "format": "0", "header": "Test", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.trying) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 44, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.ActiveCourses.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.ActiveCourses.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.ActiveCourses.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/ActiveCourses",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.ActiveCourses.detail;
    this.ls_insert_handler = Lino.courses.ActiveCourses.insert;
    Lino.courses.ActiveCourses.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.ActiveCourses.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.ActiveCourses.insertPanel(p);
});
Lino.courses.ActiveCourses.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.ActiveCourses.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/ActiveCourses",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.ActiveCourses.detail;
    this.ls_insert_handler = Lino.courses.ActiveCourses.insert;
    Lino.courses.ActiveCourses.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.ActiveCourses.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.ActiveCourses.detailPanel(p);
});
Lino.courses.ActiveCourses.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.ActiveCourses.GridPanel(p);
});
Lino.courses.ActiveCourses.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ActiveCourses", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.InactiveCourses
Lino.courses.InactiveCourses.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 58,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/InactiveCourses",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/InactiveCourses','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/InactiveCourses','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/InactiveCourses','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/InactiveCourses','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/InactiveCourses','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Inaktive Kurse",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "overview" }, { "name": "enrolments" }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "room" }, 'roomHidden', { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "workflow_buttons" }, { "name": "events_text" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.InactiveCourses.detail;
    this.ls_insert_handler = Lino.courses.InactiveCourses.insert;
    var ww = this.containing_window;
    var overview_disp5336 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var enrolments5337 = new Ext.form.NumberField({ "disabled": true });
    var free_places5338 = new Ext.form.NumberField({ "disabled": true });
    var room5339 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/room" }) }) });
    var id5340 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref5341 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date5342 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time5343 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date5344 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time5345 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user5346 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/user" }) }) });
    var every_unit5347 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every5348 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday5349 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday5350 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday5351 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday5352 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday5353 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday5354 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday5355 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events5356 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date5357 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var line5358 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/line" }) }) });
    var teacher5359 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/teacher" }) }) });
    var slot5360 = new Lino.RemoteComboFieldElement({ "emptyText": "Timetable Slot ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/slot" }) }) });
    var description5361 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de5362 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr5363 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark5364 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state5365 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places5366 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name5367 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until5368 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee5369 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/fee" }) }) });
    var payment_term5370 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/payment_term" }) }) });
    var paper_type5371 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/paper_type" }) }) });
    var mobile_item_disp5372 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5373 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp5374 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var print_actions_disp5375 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested5376 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed5377 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox5378 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Anwesenheiten", "value": "<br/>" });
    var trying5379 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var what_text_disp5380 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp5381 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp5382 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration5383 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee5369.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox5378.refresh();
    };
    this.onRender = function(ct, position) {
      line5358.on('change',Lino.chooser_handler(fee5369,'line'));
      Lino.courses.InactiveCourses.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(courses.InactiveCourses.overview) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Einschreibungen", "sortable": false, "tooltip": "(courses.InactiveCourses.enrolments) ", "width": Lino.chars2width(9), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Freie Pl\u00e4tze", "sortable": false, "tooltip": "(courses.InactiveCourses.free_places) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "room", "editable": true, "editor": room5339, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.InactiveCourses.room) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id5340, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "ref", "editable": true, "editor": ref5341, "filter": { "type": "string" }, "header": "Referenz", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "start_date", "editable": true, "editor": start_date5342, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "start_time", "editable": true, "editor": start_time5343, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 8, "dataIndex": "end_date", "editable": true, "editor": end_date5344, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "end_time", "editable": true, "editor": end_time5345, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "user", "editable": true, "editor": user5346, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.InactiveCourses.user) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "every_unit", "editable": true, "editor": every_unit5347, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 12, "dataIndex": "every", "editable": true, "editor": every5348, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 13, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 20, "dataIndex": "max_events", "editable": true, "editor": max_events5356, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 21, "dataIndex": "max_date", "editable": true, "editor": max_date5357, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 22, "dataIndex": "line", "editable": true, "editor": line5358, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "hidden": true, "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.InactiveCourses.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "teacher", "editable": true, "editor": teacher5359, "filter": { "type": "string" }, "header": "Kursleiter", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.InactiveCourses.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "slot", "editable": true, "editor": slot5360, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "renderer": Lino.fk_renderer('slotHidden','Lino.courses.Slots.detail'), "sortable": false, "tooltip": "(courses.InactiveCourses.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "description", "editable": true, "editor": description5361, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.description) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_de", "editable": true, "editor": description_de5362, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "description_fr", "editable": true, "editor": description_fr5363, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "remark", "editable": true, "editor": remark5364, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 29, "dataIndex": "state", "editable": true, "editor": state5365, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 30, "dataIndex": "max_places", "editable": true, "editor": max_places5366, "filter": { "type": "numeric" }, "format": "0", "header": "Verf\u00fcgbare Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.max_places) Maximum number of participants", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 31, "dataIndex": "name", "editable": true, "editor": name5367, "filter": { "type": "string" }, "header": "Bezeichnung", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 32, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until5368, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Einschreibung m\u00f6glich bis", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 33, "dataIndex": "fee", "editable": true, "editor": fee5369, "filter": { "type": "string" }, "header": "Standard-Teilnehmahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.InactiveCourses.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "payment_term", "editable": true, "editor": payment_term5370, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.InactiveCourses.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 35, "dataIndex": "paper_type", "editable": true, "editor": paper_type5371, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 36, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 37, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 38, "dataIndex": "events_text", "editable": false, "header": "Kalendereintr\u00e4ge", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.events_text) ", "width": Lino.chars2width(31) }, { "colIndex": 39, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 40, "dataIndex": "requested", "editable": false, "format": "0", "header": "Angefragt", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.requested) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 41, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Best\u00e4tigt", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.confirmed) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 42, "dataIndex": "presences_box", "editable": false, "header": "Anwesenheiten", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 43, "dataIndex": "trying", "editable": false, "format": "0", "header": "Test", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.trying) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 44, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.InactiveCourses.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.InactiveCourses.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.InactiveCourses.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/InactiveCourses",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.InactiveCourses.detail;
    this.ls_insert_handler = Lino.courses.InactiveCourses.insert;
    Lino.courses.InactiveCourses.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.InactiveCourses.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.InactiveCourses.insertPanel(p);
});
Lino.courses.InactiveCourses.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.InactiveCourses.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/InactiveCourses",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.InactiveCourses.detail;
    this.ls_insert_handler = Lino.courses.InactiveCourses.insert;
    Lino.courses.InactiveCourses.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.InactiveCourses.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.InactiveCourses.detailPanel(p);
});
Lino.courses.InactiveCourses.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.InactiveCourses.GridPanel(p);
});
Lino.courses.InactiveCourses.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/InactiveCourses", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.ClosedCourses
Lino.courses.ClosedCourses.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 58,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/ClosedCourses",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/ClosedCourses','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/ClosedCourses','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/ClosedCourses','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/ClosedCourses','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/ClosedCourses','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Abgeschlossene Kurse",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "overview" }, { "name": "enrolments" }, { "name": "room" }, 'roomHidden', { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "workflow_buttons" }, { "name": "events_text" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.ClosedCourses.detail;
    this.ls_insert_handler = Lino.courses.ClosedCourses.insert;
    var ww = this.containing_window;
    var overview_disp5385 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var enrolments5386 = new Ext.form.NumberField({ "disabled": true });
    var room5387 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/room" }) }) });
    var id5388 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref5389 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date5390 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time5391 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date5392 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time5393 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user5394 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/user" }) }) });
    var every_unit5395 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every5396 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday5397 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday5398 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday5399 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday5400 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday5401 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday5402 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday5403 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events5404 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date5405 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var line5406 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/line" }) }) });
    var teacher5407 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/teacher" }) }) });
    var slot5408 = new Lino.RemoteComboFieldElement({ "emptyText": "Timetable Slot ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/slot" }) }) });
    var description5409 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de5410 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr5411 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark5412 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state5413 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places5414 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name5415 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until5416 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee5417 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/fee" }) }) });
    var payment_term5418 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/payment_term" }) }) });
    var paper_type5419 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/paper_type" }) }) });
    var mobile_item_disp5420 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5421 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp5422 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var print_actions_disp5423 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested5424 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed5425 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox5426 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Anwesenheiten", "value": "<br/>" });
    var trying5427 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places5428 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var what_text_disp5429 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp5430 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp5431 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration5432 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee5417.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox5426.refresh();
    };
    this.onRender = function(ct, position) {
      line5406.on('change',Lino.chooser_handler(fee5417,'line'));
      Lino.courses.ClosedCourses.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(courses.ClosedCourses.overview) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Einschreibungen", "sortable": false, "tooltip": "(courses.ClosedCourses.enrolments) ", "width": Lino.chars2width(9), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "room", "editable": true, "editor": room5387, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.ClosedCourses.room) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id5388, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "ref", "editable": true, "editor": ref5389, "filter": { "type": "string" }, "header": "Referenz", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "start_date", "editable": true, "editor": start_date5390, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "start_time", "editable": true, "editor": start_time5391, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 7, "dataIndex": "end_date", "editable": true, "editor": end_date5392, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "end_time", "editable": true, "editor": end_time5393, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "user", "editable": true, "editor": user5394, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.ClosedCourses.user) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "every_unit", "editable": true, "editor": every_unit5395, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 11, "dataIndex": "every", "editable": true, "editor": every5396, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "max_events", "editable": true, "editor": max_events5404, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "max_date", "editable": true, "editor": max_date5405, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 21, "dataIndex": "line", "editable": true, "editor": line5406, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "hidden": true, "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.ClosedCourses.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "teacher", "editable": true, "editor": teacher5407, "filter": { "type": "string" }, "header": "Kursleiter", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.ClosedCourses.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "slot", "editable": true, "editor": slot5408, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "renderer": Lino.fk_renderer('slotHidden','Lino.courses.Slots.detail'), "sortable": false, "tooltip": "(courses.ClosedCourses.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "description", "editable": true, "editor": description5409, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.description) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_de", "editable": true, "editor": description_de5410, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_fr", "editable": true, "editor": description_fr5411, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "remark", "editable": true, "editor": remark5412, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "state", "editable": true, "editor": state5413, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 29, "dataIndex": "max_places", "editable": true, "editor": max_places5414, "filter": { "type": "numeric" }, "format": "0", "header": "Verf\u00fcgbare Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.max_places) Maximum number of participants", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 30, "dataIndex": "name", "editable": true, "editor": name5415, "filter": { "type": "string" }, "header": "Bezeichnung", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 31, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until5416, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Einschreibung m\u00f6glich bis", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 32, "dataIndex": "fee", "editable": true, "editor": fee5417, "filter": { "type": "string" }, "header": "Standard-Teilnehmahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.ClosedCourses.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "payment_term", "editable": true, "editor": payment_term5418, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.ClosedCourses.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "paper_type", "editable": true, "editor": paper_type5419, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 35, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 37, "dataIndex": "events_text", "editable": false, "header": "Kalendereintr\u00e4ge", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.events_text) ", "width": Lino.chars2width(31) }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Angefragt", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.requested) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Best\u00e4tigt", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.confirmed) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Anwesenheiten", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Test", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.trying) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Freie Pl\u00e4tze", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.free_places) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 44, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.ClosedCourses.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.ClosedCourses.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.ClosedCourses.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/ClosedCourses",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.ClosedCourses.detail;
    this.ls_insert_handler = Lino.courses.ClosedCourses.insert;
    Lino.courses.ClosedCourses.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.ClosedCourses.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.ClosedCourses.insertPanel(p);
});
Lino.courses.ClosedCourses.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.ClosedCourses.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/ClosedCourses",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.ClosedCourses.detail;
    this.ls_insert_handler = Lino.courses.ClosedCourses.insert;
    Lino.courses.ClosedCourses.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.ClosedCourses.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.ClosedCourses.detailPanel(p);
});
Lino.courses.ClosedCourses.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.ClosedCourses.GridPanel(p);
});
Lino.courses.ClosedCourses.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/ClosedCourses", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Enrolments
Lino.courses.Enrolments.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 34,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Enrolments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Enrolments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Enrolments','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Enrolments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Enrolments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Enrolments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Einschreibungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "course" }, 'courseHidden', { "name": "course__state" }, 'course__stateHidden', { "name": "pupil" }, 'pupilHidden', { "name": "workflow_buttons" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "places", "type": "int", "useNull": true }, { "name": "option" }, 'optionHidden', { "name": "remark" }, { "name": "confirmation_details" }, { "name": "amount" }, { "name": "fee" }, 'feeHidden', { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Enrolments.detail;
    this.ls_insert_handler = Lino.courses.Enrolments.insert;
    var ww = this.containing_window;
    var request_date5434 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var course5435 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Activity ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/course" }) }) });
    var course__state5436 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "disabled": true, "maxLength": 10, "sortable": false });
    var pupil5437 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Teilnehmer ausw\u00e4hlen...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/pupil" }) }) });
    var workflow_buttons_disp5438 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var user5439 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/user" }) }) });
    var id5440 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_date5441 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date5442 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var printed_by5443 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area5444 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state5445 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var places5446 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 1 });
    var option5447 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/option" }) }) });
    var remark5448 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var confirmation_details5449 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var amount5450 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var fee5451 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/fee" }) }) });
    var free_events5452 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox5453 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Teilnehmer", "value": "<br/>" });
    var payment_info_disp5454 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp5455 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp5456 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5457 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp5458 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      course5435.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course5435.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil5437.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      option5447.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee5451.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      pupil_info_htmlbox5453.refresh();
    };
    this.onRender = function(ct, position) {
      course_area5444.on('change',Lino.chooser_handler(course5435,'course_area'));
      request_date5434.on('change',Lino.chooser_handler(course5435,'request_date'));
      course5435.on('change',Lino.chooser_handler(pupil5437,'course'));
      course5435.on('change',Lino.chooser_handler(option5447,'course'));
      course5435.on('change',Lino.chooser_handler(fee5451,'course'));
      Lino.courses.Enrolments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date5434, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum der Anfrage", "sortable": true, "tooltip": "(courses.Enrolments.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "course", "editable": true, "editor": course5435, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.Enrolments.course) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "course__state", "editable": false, "filter": { "type": "string" }, "header": "Zustand", "sortable": true, "tooltip": "(courses.Enrolments.course__state) ", "width": Lino.chars2width(12) }, { "colIndex": 3, "dataIndex": "pupil", "editable": true, "editor": pupil5437, "filter": { "type": "string" }, "header": "Teilnehmer", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.Enrolments.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.Enrolments.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user5439, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.Enrolments.user) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id5440, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date5441, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "end_date", "editable": true, "editor": end_date5442, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enddatum", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.Enrolments.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 11, "dataIndex": "state", "editable": true, "editor": state5445, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 12, "dataIndex": "places", "editable": true, "editor": places5446, "filter": { "type": "numeric" }, "format": "0", "header": "Anz. Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.places) The number of participants in this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 13, "dataIndex": "option", "editable": true, "editor": option5447, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Enrolments.option) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "remark", "editable": true, "editor": remark5448, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details5449, "filter": { "type": "string" }, "header": "Details Best\u00e4tigung", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.confirmation_details) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 16, "dataIndex": "amount", "editable": true, "editor": amount5450, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 17, "dataIndex": "fee", "editable": true, "editor": fee5451, "filter": { "type": "string" }, "header": "Tarif", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Enrolments.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 18, "dataIndex": "free_events", "editable": true, "editor": free_events5452, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 19, "dataIndex": "pupil_info", "editable": false, "header": "Teilnehmer", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "payment_info", "editable": false, "header": "Info Buchhaltung", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "invoicing_info", "editable": false, "header": "Info Fakturation", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 24, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.printed) ", "width": Lino.chars2width(31) } ];
    Lino.courses.Enrolments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Enrolments.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Enrolments.insertPanel = Ext.extend(Lino.courses.Enrolments.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/Enrolments",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Enrolments.detail;
    this.ls_insert_handler = Lino.courses.Enrolments.insert;
    Lino.courses.Enrolments.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Enrolments.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Enrolments.insertPanel(p);
});
Lino.courses.Enrolments.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Enrolments.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/Enrolments",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Enrolments.detail;
    this.ls_insert_handler = Lino.courses.Enrolments.insert;
    Lino.courses.Enrolments.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Enrolments.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Enrolments.detailPanel(p);
});
Lino.courses.Enrolments.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.create_excerpt9 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.create_excerpt10 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.Enrolments.GridPanel(p);
});
Lino.courses.Enrolments.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Enrolments", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.AllEnrolments
Lino.courses.AllEnrolments.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 40,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/AllEnrolments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/AllEnrolments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/AllEnrolments','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/AllEnrolments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/AllEnrolments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/AllEnrolments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Einschreibungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "user" }, 'userHidden', { "name": "course" }, 'courseHidden', { "name": "pupil" }, 'pupilHidden', { "name": "pupil__birth_date" }, { "name": "pupil__age" }, { "name": "pupil__country" }, 'pupil__countryHidden', { "name": "pupil__city" }, 'pupil__cityHidden', { "name": "pupil__gender" }, 'pupil__genderHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "places", "type": "int", "useNull": true }, { "name": "option" }, 'optionHidden', { "name": "remark" }, { "name": "confirmation_details" }, { "name": "amount" }, { "name": "fee" }, 'feeHidden', { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.AllEnrolments.detail;
    this.ls_insert_handler = Lino.courses.AllEnrolments.insert;
    var ww = this.containing_window;
    var id11031 = new Ext.form.NumberField({ "selectOnFocus": true });
    var request_date11032 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var start_date11033 = new Lino.DateField({ "selectOnFocus": true });
    var end_date11034 = new Lino.DateField({ "selectOnFocus": true });
    var user11035 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllEnrolments/user" }) }) });
    var course11036 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Activity ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllEnrolments/course" }) }) });
    var pupil11037 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Teilnehmer ausw\u00e4hlen...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllEnrolments/pupil" }) }) });
    var pupil__birth_date11038 = new Lino.IncompleteDateField({ "disabled": true, "sortable": false });
    var pupil__age_disp11039 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "sortable": false, "value": "<br/>" });
    var pupil__country11040 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Land ausw\u00e4hlen...", "pageSize": 20, "sortable": false, "store": new Lino.ComplexRemoteComboStore({  }) });
    var pupil__city11041 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Ort ausw\u00e4hlen...", "pageSize": 20, "sortable": false, "store": new Lino.ComplexRemoteComboStore({  }) });
    var pupil__gender11042 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "disabled": true, "maxLength": 10, "sortable": false });
    var printed_by11043 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area11044 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state11045 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var places11046 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 1 });
    var option11047 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllEnrolments/option" }) }) });
    var remark11048 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var confirmation_details11049 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var amount11050 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var fee11051 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllEnrolments/fee" }) }) });
    var free_events11052 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox11053 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Teilnehmer", "value": "<br/>" });
    var payment_info_disp11054 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp11055 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp11056 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp11057 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp11058 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp11059 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      course11036.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course11036.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil11037.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      option11047.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee11051.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      pupil_info_htmlbox11053.refresh();
    };
    this.onRender = function(ct, position) {
      course_area11044.on('change',Lino.chooser_handler(course11036,'course_area'));
      request_date11032.on('change',Lino.chooser_handler(course11036,'request_date'));
      course11036.on('change',Lino.chooser_handler(pupil11037,'course'));
      course11036.on('change',Lino.chooser_handler(option11047,'course'));
      course11036.on('change',Lino.chooser_handler(fee11051,'course'));
      Lino.courses.AllEnrolments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id11031, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(courses.AllEnrolments.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "request_date", "editable": true, "editor": request_date11032, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum der Anfrage", "sortable": true, "tooltip": "(courses.AllEnrolments.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "start_date", "editable": true, "editor": start_date11033, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.AllEnrolments.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "end_date", "editable": true, "editor": end_date11034, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enddatum", "sortable": true, "tooltip": "(courses.AllEnrolments.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user11035, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.AllEnrolments.user) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "course", "editable": true, "editor": course11036, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.AllEnrolments.course) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "pupil", "editable": true, "editor": pupil11037, "filter": { "type": "string" }, "header": "Teilnehmer", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.AllEnrolments.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "pupil__birth_date", "editable": false, "filter": { "type": "string" }, "header": "Geburtsdatum", "sortable": true, "tooltip": "(courses.AllEnrolments.pupil__birth_date) ", "width": Lino.chars2width(13) }, { "colIndex": 8, "dataIndex": "pupil__age", "editable": false, "header": "Alter", "sortable": false, "tooltip": "(courses.AllEnrolments.pupil__age) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "pupil__country", "editable": false, "filter": { "type": "string" }, "header": "Land", "sortable": false, "tooltip": "(courses.AllEnrolments.pupil__country) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "pupil__city", "editable": false, "filter": { "type": "string" }, "header": "Locality", "sortable": false, "tooltip": "(courses.AllEnrolments.pupil__city) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "pupil__gender", "editable": false, "filter": { "type": "string" }, "header": "Geschlecht", "sortable": true, "tooltip": "(courses.AllEnrolments.pupil__gender) ", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.AllEnrolments.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 14, "dataIndex": "state", "editable": true, "editor": state11045, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 15, "dataIndex": "places", "editable": true, "editor": places11046, "filter": { "type": "numeric" }, "format": "0", "header": "Anz. Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.AllEnrolments.places) The number of participants in this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 16, "dataIndex": "option", "editable": true, "editor": option11047, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.AllEnrolments.option) ", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "remark", "editable": true, "editor": remark11048, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": true, "tooltip": "(courses.AllEnrolments.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 18, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details11049, "filter": { "type": "string" }, "header": "Details Best\u00e4tigung", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.confirmation_details) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 19, "dataIndex": "amount", "editable": true, "editor": amount11050, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "hidden": true, "sortable": true, "tooltip": "(courses.AllEnrolments.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "fee", "editable": true, "editor": fee11051, "filter": { "type": "string" }, "header": "Tarif", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.AllEnrolments.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 21, "dataIndex": "free_events", "editable": true, "editor": free_events11052, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.AllEnrolments.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 22, "dataIndex": "pupil_info", "editable": false, "header": "Teilnehmer", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "payment_info", "editable": false, "header": "Info Buchhaltung", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 24, "dataIndex": "invoicing_info", "editable": false, "header": "Info Fakturation", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 25, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.printed) ", "width": Lino.chars2width(31) } ];
    Lino.courses.AllEnrolments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.AllEnrolments.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.AllEnrolments.insertPanel = Ext.extend(Lino.courses.Enrolments.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/AllEnrolments",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.AllEnrolments.detail;
    this.ls_insert_handler = Lino.courses.AllEnrolments.insert;
    Lino.courses.AllEnrolments.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.AllEnrolments.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.AllEnrolments.insertPanel(p);
});
Lino.courses.AllEnrolments.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.AllEnrolments.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/AllEnrolments",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.AllEnrolments.detail;
    this.ls_insert_handler = Lino.courses.AllEnrolments.insert;
    Lino.courses.AllEnrolments.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.AllEnrolments.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.AllEnrolments.detailPanel(p);
});
Lino.courses.AllEnrolments.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.create_excerpt9 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.create_excerpt10 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.AllEnrolments.GridPanel(p);
});
Lino.courses.AllEnrolments.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/AllEnrolments", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.PendingConfirmedEnrolments
Lino.courses.PendingConfirmedEnrolments.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 34,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/PendingConfirmedEnrolments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/PendingConfirmedEnrolments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/PendingConfirmedEnrolments','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/PendingConfirmedEnrolments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/PendingConfirmedEnrolments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/PendingConfirmedEnrolments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Auszustellende Teilnahmebescheinigungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "course" }, 'courseHidden', { "name": "course__state" }, 'course__stateHidden', { "name": "pupil" }, 'pupilHidden', { "name": "workflow_buttons" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "places", "type": "int", "useNull": true }, { "name": "option" }, 'optionHidden', { "name": "remark" }, { "name": "confirmation_details" }, { "name": "amount" }, { "name": "fee" }, 'feeHidden', { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PendingConfirmedEnrolments.detail;
    this.ls_insert_handler = Lino.courses.PendingConfirmedEnrolments.insert;
    var ww = this.containing_window;
    var request_date11061 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var course11062 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Activity ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingConfirmedEnrolments/course" }) }) });
    var course__state11063 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "disabled": true, "maxLength": 10, "sortable": false });
    var pupil11064 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Teilnehmer ausw\u00e4hlen...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingConfirmedEnrolments/pupil" }) }) });
    var workflow_buttons_disp11065 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var user11066 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingConfirmedEnrolments/user" }) }) });
    var id11067 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_date11068 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date11069 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var printed_by11070 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area11071 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state11072 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var places11073 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 1 });
    var option11074 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingConfirmedEnrolments/option" }) }) });
    var remark11075 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var confirmation_details11076 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var amount11077 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var fee11078 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingConfirmedEnrolments/fee" }) }) });
    var free_events11079 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox11080 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Teilnehmer", "value": "<br/>" });
    var payment_info_disp11081 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp11082 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp11083 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp11084 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp11085 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      course11062.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course11062.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil11064.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      option11074.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee11078.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      pupil_info_htmlbox11080.refresh();
    };
    this.onRender = function(ct, position) {
      course_area11071.on('change',Lino.chooser_handler(course11062,'course_area'));
      request_date11061.on('change',Lino.chooser_handler(course11062,'request_date'));
      course11062.on('change',Lino.chooser_handler(pupil11064,'course'));
      course11062.on('change',Lino.chooser_handler(option11074,'course'));
      course11062.on('change',Lino.chooser_handler(fee11078,'course'));
      Lino.courses.PendingConfirmedEnrolments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date11061, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum der Anfrage", "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "course", "editable": true, "editor": course11062, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.course) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "course__state", "editable": false, "filter": { "type": "string" }, "header": "Zustand", "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.course__state) ", "width": Lino.chars2width(12) }, { "colIndex": 3, "dataIndex": "pupil", "editable": true, "editor": pupil11064, "filter": { "type": "string" }, "header": "Teilnehmer", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user11066, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.user) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id11067, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date11068, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "end_date", "editable": true, "editor": end_date11069, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enddatum", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 11, "dataIndex": "state", "editable": true, "editor": state11072, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 12, "dataIndex": "places", "editable": true, "editor": places11073, "filter": { "type": "numeric" }, "format": "0", "header": "Anz. Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.places) The number of participants in this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 13, "dataIndex": "option", "editable": true, "editor": option11074, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.option) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "remark", "editable": true, "editor": remark11075, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details11076, "filter": { "type": "string" }, "header": "Details Best\u00e4tigung", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.confirmation_details) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 16, "dataIndex": "amount", "editable": true, "editor": amount11077, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 17, "dataIndex": "fee", "editable": true, "editor": fee11078, "filter": { "type": "string" }, "header": "Tarif", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 18, "dataIndex": "free_events", "editable": true, "editor": free_events11079, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 19, "dataIndex": "pupil_info", "editable": false, "header": "Teilnehmer", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "payment_info", "editable": false, "header": "Info Buchhaltung", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "invoicing_info", "editable": false, "header": "Info Fakturation", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 24, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.printed) ", "width": Lino.chars2width(31) } ];
    Lino.courses.PendingConfirmedEnrolments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PendingConfirmedEnrolments.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PendingConfirmedEnrolments.insertPanel = Ext.extend(Lino.courses.Enrolments.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/PendingConfirmedEnrolments",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PendingConfirmedEnrolments.detail;
    this.ls_insert_handler = Lino.courses.PendingConfirmedEnrolments.insert;
    Lino.courses.PendingConfirmedEnrolments.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PendingConfirmedEnrolments.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.PendingConfirmedEnrolments.insertPanel(p);
});
Lino.courses.PendingConfirmedEnrolments.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PendingConfirmedEnrolments.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/PendingConfirmedEnrolments",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PendingConfirmedEnrolments.detail;
    this.ls_insert_handler = Lino.courses.PendingConfirmedEnrolments.insert;
    Lino.courses.PendingConfirmedEnrolments.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PendingConfirmedEnrolments.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.PendingConfirmedEnrolments.detailPanel(p);
});
Lino.courses.PendingConfirmedEnrolments.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.create_excerpt9 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.create_excerpt10 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.PendingConfirmedEnrolments.GridPanel(p);
});
Lino.courses.PendingConfirmedEnrolments.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingConfirmedEnrolments", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.TeacherTypes
Lino.courses.TeacherTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 8,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/TeacherTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/TeacherTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/TeacherTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/TeacherTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/TeacherTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/TeacherTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  cell_edit : true,
  title : "Kursleiterarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 55,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.TeacherTypes.detail;
    var ww = this.containing_window;
    var id5460 = new Ext.form.NumberField({ "selectOnFocus": true });
    var ref5461 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name5462 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de5463 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr5464 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var mobile_item_disp5465 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5466 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5467 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5460, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(courses.TeacherTypes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "ref", "editable": true, "editor": ref5461, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(courses.TeacherTypes.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name", "editable": true, "editor": name5462, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(courses.TeacherTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_de", "editable": true, "editor": name_de5463, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(courses.TeacherTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "name_fr", "editable": true, "editor": name_fr5464, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(courses.TeacherTypes.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.TeacherTypes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.TeacherTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.TeacherTypes.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.courses.TeacherTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.TeacherTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeacherTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeacherTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeacherTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeacherTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeacherTypes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeacherTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeacherTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeacherTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.TeacherTypes.detailPanel = Ext.extend(Lino.courses.TeacherTypes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  ls_url: "/courses/TeacherTypes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.TeacherTypes.detail;
    Lino.courses.TeacherTypes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.TeacherTypes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.TeacherTypes.detailPanel(p);
});
Lino.courses.TeacherTypes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeacherTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeacherTypes", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.TeacherTypes.GridPanel(p);
});
Lino.courses.TeacherTypes.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeacherTypes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.PupilTypes
Lino.courses.PupilTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 8,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/PupilTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/PupilTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/PupilTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/PupilTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/PupilTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/PupilTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  cell_edit : true,
  title : "Teilnehmerarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 50,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PupilTypes.detail;
    var ww = this.containing_window;
    var id5469 = new Ext.form.NumberField({ "selectOnFocus": true });
    var ref5470 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name5471 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de5472 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr5473 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var mobile_item_disp5474 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5475 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5476 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5469, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(courses.PupilTypes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "ref", "editable": true, "editor": ref5470, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(courses.PupilTypes.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name", "editable": true, "editor": name5471, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(courses.PupilTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_de", "editable": true, "editor": name_de5472, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(courses.PupilTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "name_fr", "editable": true, "editor": name_fr5473, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(courses.PupilTypes.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.PupilTypes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.PupilTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.PupilTypes.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.courses.PupilTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PupilTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilTypes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PupilTypes.detailPanel = Ext.extend(Lino.courses.PupilTypes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  ls_url: "/courses/PupilTypes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PupilTypes.detail;
    Lino.courses.PupilTypes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PupilTypes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.PupilTypes.detailPanel(p);
});
Lino.courses.PupilTypes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilTypes", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.PupilTypes.GridPanel(p);
});
Lino.courses.PupilTypes.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilTypes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.CourseTypes
Lino.courses.CourseTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 8,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/CourseTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/CourseTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/CourseTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Aktivit\u00e4tsarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 51,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CourseTypes.detail;
    var ww = this.containing_window;
    var id5478 = new Ext.form.NumberField({ "selectOnFocus": true });
    var ref5479 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name5480 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de5481 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr5482 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var mobile_item_disp5483 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5484 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5485 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5478, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(courses.CourseTypes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "ref", "editable": true, "editor": ref5479, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(courses.CourseTypes.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name", "editable": true, "editor": name5480, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(courses.CourseTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_de", "editable": true, "editor": name_de5481, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(courses.CourseTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "name_fr", "editable": true, "editor": name_fr5482, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(courses.CourseTypes.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CourseTypes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CourseTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.CourseTypes.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.courses.CourseTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CourseTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseTypes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CourseTypes.detailPanel = Ext.extend(Lino.courses.CourseTypes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/courses/CourseTypes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CourseTypes.detail;
    Lino.courses.CourseTypes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CourseTypes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CourseTypes.detailPanel(p);
});
Lino.courses.CourseTypes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CourseTypes.GridPanel(p);
});
Lino.courses.CourseTypes.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseTypes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.PendingRequestedEnrolments
Lino.courses.PendingRequestedEnrolments.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 11,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/PendingRequestedEnrolments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/PendingRequestedEnrolments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/PendingRequestedEnrolments','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/PendingRequestedEnrolments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/PendingRequestedEnrolments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/PendingRequestedEnrolments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Offene Einschreibungsanfragen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "course" }, 'courseHidden', { "name": "pupil" }, 'pupilHidden', { "name": "remark" }, { "name": "user" }, 'userHidden', { "name": "amount" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PendingRequestedEnrolments.detail;
    this.ls_insert_handler = Lino.courses.PendingRequestedEnrolments.insert;
    var ww = this.containing_window;
    var request_date11087 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var course11088 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Activity ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingRequestedEnrolments/course" }) }) });
    var pupil11089 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Teilnehmer ausw\u00e4hlen...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingRequestedEnrolments/pupil" }) }) });
    var remark11090 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user11091 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingRequestedEnrolments/user" }) }) });
    var amount11092 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp11093 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      course11088.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course11088.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil11089.setContextValue('course', record ? record.data['courseHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      request_date11087.on('change',Lino.chooser_handler(course11088,'request_date'));
      course11088.on('change',Lino.chooser_handler(pupil11089,'course'));
      Lino.courses.PendingRequestedEnrolments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date11087, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum der Anfrage", "sortable": true, "tooltip": "(courses.PendingRequestedEnrolments.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "course", "editable": true, "editor": course11088, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.PendingRequestedEnrolments.course) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "pupil", "editable": true, "editor": pupil11089, "filter": { "type": "string" }, "header": "Teilnehmer", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.PendingRequestedEnrolments.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark11090, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(courses.PendingRequestedEnrolments.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user11091, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.PendingRequestedEnrolments.user) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "amount", "editable": true, "editor": amount11092, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "sortable": true, "tooltip": "(courses.PendingRequestedEnrolments.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.PendingRequestedEnrolments.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.courses.PendingRequestedEnrolments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PendingRequestedEnrolments.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PendingRequestedEnrolments.insertPanel = Ext.extend(Lino.courses.Enrolments.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/PendingRequestedEnrolments",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PendingRequestedEnrolments.detail;
    this.ls_insert_handler = Lino.courses.PendingRequestedEnrolments.insert;
    Lino.courses.PendingRequestedEnrolments.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PendingRequestedEnrolments.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.PendingRequestedEnrolments.insertPanel(p);
});
Lino.courses.PendingRequestedEnrolments.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PendingRequestedEnrolments.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/PendingRequestedEnrolments",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PendingRequestedEnrolments.detail;
    this.ls_insert_handler = Lino.courses.PendingRequestedEnrolments.insert;
    Lino.courses.PendingRequestedEnrolments.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PendingRequestedEnrolments.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.PendingRequestedEnrolments.detailPanel(p);
});
Lino.courses.PendingRequestedEnrolments.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.create_excerpt9 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.create_excerpt10 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.PendingRequestedEnrolments.GridPanel(p);
});
Lino.courses.PendingRequestedEnrolments.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PendingRequestedEnrolments", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Teachers
Lino.courses.Teachers.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 65,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Teachers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Teachers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Teachers','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Teachers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/courses/Teachers','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Teachers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Teachers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Kursleiter",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name_column" }, { "name": "address_column" }, { "name": "teacher_type" }, 'teacher_typeHidden', { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "prefix" }, { "name": "name" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_id" }, { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "title" }, { "name": "first_name" }, { "name": "middle_name" }, { "name": "last_name" }, { "name": "gender" }, 'genderHidden', { "name": "birth_date" }, { "name": "national_id" }, { "name": "birth_country" }, 'birth_countryHidden', { "name": "birth_place" }, { "name": "nationality" }, 'nationalityHidden', { "name": "card_number" }, { "dateFormat": "d.m.Y", "name": "card_valid_from", "type": "date" }, { "dateFormat": "d.m.Y", "name": "card_valid_until", "type": "date" }, { "name": "card_type" }, 'card_typeHidden', { "name": "card_issuer" }, { "name": "noble_condition" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "age" }, { "name": "mti_navigator" }, { "name": "debit_balance" }, { "name": "image" }, { "name": "eid_info" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Teachers.detail;
    this.ls_insert_handler = Lino.courses.Teachers.insert;
    var ww = this.containing_window;
    var name_column_disp5487 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var address_column_disp5488 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var teacher_type5489 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiterart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/teacher_type" }) }) });
    var id5490 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email5491 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language5492 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var url5493 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone5494 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm5495 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax5496 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country5497 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/country" }) }) });
    var city5498 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/city" }) }) });
    var zip_code5499 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region5500 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/region" }) }) });
    var addr15501 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix5502 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street5503 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no5504 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box5505 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr25506 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var prefix5507 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name5508 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks5509 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term5510 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/payment_term" }) }) });
    var vat_regime5511 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_id5512 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var invoice_recipient5513 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/invoice_recipient" }) }) });
    var paper_type5514 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/paper_type" }) }) });
    var title5515 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var first_name5516 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var middle_name5517 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_name5518 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gender5519 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var birth_date5520 = new Lino.IncompleteDateField({ "hidden": true, "selectOnFocus": true });
    var national_id5521 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var birth_country5522 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/birth_country" }) }) });
    var birth_place5523 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var nationality5524 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/nationality" }) }) });
    var card_number5525 = new Ext.form.TextField({ "hidden": true, "maxLength": 20, "selectOnFocus": true });
    var card_valid_from5526 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_valid_until5527 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_type5528 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.beid.BeIdCardTypes) });
    var card_issuer5529 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var noble_condition5530 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var mobile_item_disp5531 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5532 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5533 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var age_disp5534 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp5535 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var debit_balance5536 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var image_htmlbox5537 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "image", "value": "<br/>" });
    var eid_info_disp5538 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      city5498.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city5498.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region5500.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      image_htmlbox5537.refresh();
    };
    this.onRender = function(ct, position) {
      country5497.on('change',Lino.chooser_handler(city5498,'country'));
      region5500.on('change',Lino.chooser_handler(city5498,'region'));
      country5497.on('change',Lino.chooser_handler(region5500,'country'));
      Lino.courses.Teachers.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name_column", "editable": false, "header": "Name", "sortable": false, "tooltip": "(courses.Teachers.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "address_column", "editable": false, "header": "Adresse", "sortable": false, "tooltip": "(courses.Teachers.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "teacher_type", "editable": true, "editor": teacher_type5489, "filter": { "type": "string" }, "header": "Kursleiterart", "renderer": Lino.fk_renderer('teacher_typeHidden','Lino.courses.TeacherTypes.detail'), "sortable": false, "tooltip": "(courses.Teachers.teacher_type) Pointer to TeacherType.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id5490, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "email", "editable": true, "editor": email5491, "filter": { "type": "string" }, "header": "E-Mail-Adresse", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "language", "editable": true, "editor": language5492, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "url", "editable": true, "editor": url5493, "filter": { "type": "string" }, "header": "Adresse (URL)", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.url) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "phone", "editable": true, "editor": phone5494, "filter": { "type": "string" }, "header": "Telefon", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "gsm", "editable": true, "editor": gsm5495, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "fax", "editable": true, "editor": fax5496, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "country", "editable": true, "editor": country5497, "filter": { "type": "string" }, "header": "Land", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.Teachers.country) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "city", "editable": true, "editor": city5498, "filter": { "type": "string" }, "header": "Locality", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.Teachers.city) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "zip_code", "editable": true, "editor": zip_code5499, "filter": { "type": "string" }, "header": "Postleitzahl", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 13, "dataIndex": "region", "editable": true, "editor": region5500, "filter": { "type": "string" }, "header": "Regierungsbezirk", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.Teachers.region) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "addr1", "editable": true, "editor": addr15501, "filter": { "type": "string" }, "header": "Adresszeile vor Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.addr1) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix5502, "filter": { "type": "string" }, "header": "Pr\u00e4fix Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.street_prefix) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "street", "editable": true, "editor": street5503, "filter": { "type": "string" }, "header": "Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.street) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "street_no", "editable": true, "editor": street_no5504, "filter": { "type": "string" }, "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.street_no) ", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "street_box", "editable": true, "editor": street_box5505, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.street_box) ", "width": Lino.chars2width(12) }, { "colIndex": 19, "dataIndex": "addr2", "editable": true, "editor": addr25506, "filter": { "type": "string" }, "header": "Adresszeile nach Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.addr2) ", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "prefix", "editable": true, "editor": prefix5507, "filter": { "type": "string" }, "header": "Name prefix", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.prefix) An optional name prefix. For organisations this is inserted\nbefore the name, for persons this is inserted between first\nname and last name (see\nlino.mixins.human.Human.get_last_name_prefix()).", "width": Lino.chars2width(22) }, { "colIndex": 21, "dataIndex": "name", "editable": true, "editor": name5508, "filter": { "type": "string" }, "header": "Name", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 22, "dataIndex": "remarks", "editable": true, "editor": remarks5509, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 23, "dataIndex": "payment_term", "editable": true, "editor": payment_term5510, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.Teachers.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5511, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 25, "dataIndex": "vat_id", "editable": true, "editor": vat_id5512, "filter": { "type": "string" }, "header": "MwSt.-Nr.", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 26, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient5513, "filter": { "type": "string" }, "header": "Fakturationsadresse", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(courses.Teachers.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "paper_type", "editable": true, "editor": paper_type5514, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 28, "dataIndex": "title", "editable": true, "editor": title5515, "filter": { "type": "string" }, "header": "Titel", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.title) Used to specify a professional position or academic\nqualification like \"Dr.\" or \"PhD\".", "width": Lino.chars2width(22) }, { "colIndex": 29, "dataIndex": "first_name", "editable": true, "editor": first_name5516, "filter": { "type": "string" }, "header": "Vorname", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.first_name) The first name, also known as given name.", "width": Lino.chars2width(22) }, { "colIndex": 30, "dataIndex": "middle_name", "editable": true, "editor": middle_name5517, "filter": { "type": "string" }, "header": "Zwischenname", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.middle_name) A space-separated list of all middle names.", "width": Lino.chars2width(22) }, { "colIndex": 31, "dataIndex": "last_name", "editable": true, "editor": last_name5518, "filter": { "type": "string" }, "header": "Familienname", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.last_name) The last name, also known as family name.", "width": Lino.chars2width(22) }, { "colIndex": 32, "dataIndex": "gender", "editable": true, "editor": gender5519, "filter": { "type": "string" }, "header": "Geschlecht", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.gender) The sex of this person (male or female).", "width": Lino.chars2width(10) }, { "colIndex": 33, "dataIndex": "birth_date", "editable": true, "editor": birth_date5520, "filter": { "type": "string" }, "header": "Geburtsdatum", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".", "width": Lino.chars2width(13) }, { "colIndex": 34, "dataIndex": "national_id", "editable": true, "editor": national_id5521, "filter": { "type": "string" }, "header": "NR-Nummer", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.", "width": Lino.chars2width(22) }, { "colIndex": 35, "dataIndex": "birth_country", "editable": true, "editor": birth_country5522, "filter": { "type": "string" }, "header": "Geburtsland", "hidden": true, "renderer": Lino.fk_renderer('birth_countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.Teachers.birth_country) ", "width": Lino.chars2width(21) }, { "colIndex": 36, "dataIndex": "birth_place", "editable": true, "editor": birth_place5523, "filter": { "type": "string" }, "header": "Geburtsort", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.birth_place) ", "width": Lino.chars2width(22) }, { "colIndex": 37, "dataIndex": "nationality", "editable": true, "editor": nationality5524, "filter": { "type": "string" }, "header": "Staatsangeh\u00f6rigkeit", "hidden": true, "renderer": Lino.fk_renderer('nationalityHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.Teachers.nationality) The nationality. This is a pointer to\ncountries.Country which should\ncontain also entries for refugee statuses.", "width": Lino.chars2width(21) }, { "colIndex": 38, "dataIndex": "card_number", "editable": true, "editor": card_number5525, "filter": { "type": "string" }, "header": "eID-Kartennummer", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.card_number) ", "width": Lino.chars2width(22) }, { "colIndex": 39, "dataIndex": "card_valid_from", "editable": true, "editor": card_valid_from5526, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "ID-Karte g\u00fcltig von", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.card_valid_from) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 40, "dataIndex": "card_valid_until", "editable": true, "editor": card_valid_until5527, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "bis", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.card_valid_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 41, "dataIndex": "card_type", "editable": true, "editor": card_type5528, "filter": { "type": "string" }, "header": "eID-Kartenart", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.card_type) ", "width": Lino.chars2width(42) }, { "colIndex": 42, "dataIndex": "card_issuer", "editable": true, "editor": card_issuer5529, "filter": { "type": "string" }, "header": "eID-Karte ausgestellt durch", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.card_issuer) ", "width": Lino.chars2width(22) }, { "colIndex": 43, "dataIndex": "noble_condition", "editable": true, "editor": noble_condition5530, "filter": { "type": "string" }, "header": "Adelstitel", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.noble_condition) Eventueller Adelstitel", "width": Lino.chars2width(22) }, { "colIndex": 44, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 47, "dataIndex": "age", "editable": false, "header": "Alter", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.age) ", "width": Lino.chars2width(31) }, { "colIndex": 48, "dataIndex": "mti_navigator", "editable": false, "header": "Ansicht als ", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.mti_navigator) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 49, "dataIndex": "debit_balance", "editable": false, "format": "0.000,00/i", "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.debit_balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 50, "dataIndex": "image", "editable": false, "header": "image", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.image) ", "width": Lino.chars2width(31) }, { "colIndex": 51, "dataIndex": "eid_info", "editable": false, "header": "eID-Karte", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.eid_info) ", "width": Lino.chars2width(31) } ];
    Lino.courses.Teachers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Teachers.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Teachers.insertPanel = Ext.extend(Lino.contacts.Persons.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/Teachers",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Teachers.detail;
    this.ls_insert_handler = Lino.courses.Teachers.insert;
    Lino.courses.Teachers.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Teachers.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Teachers.insertPanel(p);
});
Lino.courses.Teachers.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Teachers.detailPanel = Ext.extend(Lino.courses.Teachers.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/courses/Teachers",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Teachers.detail;
    this.ls_insert_handler = Lino.courses.Teachers.insert;
    Lino.courses.Teachers.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Teachers.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Teachers.detailPanel(p);
});
Lino.courses.Teachers.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.create_excerpt1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.show_invoice_partners = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.courses.Teachers.GridPanel(p);
});
Lino.courses.Teachers.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.ins_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.del_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.read_beid = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "POST", pk, "read_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.ins_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.del_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.ins_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.del_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.ins_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.del_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.del_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.ins_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.find_by_beid = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Teachers", "POST", pk, "find_by_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Pupils
Lino.courses.Pupils.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 73,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Pupils",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Pupils','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Pupils','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Pupils','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/courses/Pupils','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Pupils','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Pupils','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-arrow_join", "itemId": "merge_row", "menu_item_text": "Fusionieren", "overflowText": "Fusionieren", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Pupils.merge_row), "tooltip": "Dieses Objekt in ein anderes Objekt der gleichen Klasse fusionieren." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Teilnehmer",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name_column" }, { "name": "address_column" }, { "name": "pupil_type" }, 'pupil_typeHidden', { "name": "section" }, 'sectionHidden', { "name": "is_lfv", "type": "boolean" }, { "name": "is_ckk", "type": "boolean" }, { "name": "is_raviva", "type": "boolean" }, { "dateFormat": "d.m.Y", "name": "member_until", "type": "date" }, { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "prefix" }, { "name": "name" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_id" }, { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "title" }, { "name": "first_name" }, { "name": "middle_name" }, { "name": "last_name" }, { "name": "gender" }, 'genderHidden', { "name": "birth_date" }, { "name": "national_id" }, { "name": "birth_country" }, 'birth_countryHidden', { "name": "birth_place" }, { "name": "nationality" }, 'nationalityHidden', { "name": "card_number" }, { "dateFormat": "d.m.Y", "name": "card_valid_from", "type": "date" }, { "dateFormat": "d.m.Y", "name": "card_valid_until", "type": "date" }, { "name": "card_type" }, 'card_typeHidden', { "name": "card_issuer" }, { "name": "noble_condition" }, { "name": "legacy_id" }, { "name": "is_member", "type": "boolean" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "age" }, { "name": "mti_navigator" }, { "name": "debit_balance" }, { "name": "image" }, { "name": "eid_info" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Pupils.detail;
    this.ls_insert_handler = Lino.courses.Pupils.insert;
    var ww = this.containing_window;
    var name_column_disp5540 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var address_column_disp5541 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var pupil_type5542 = new Lino.RemoteComboFieldElement({ "emptyText": "Teilnehmerart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/pupil_type" }) }) });
    var section5543 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.Sections) });
    var is_lfv5544 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var is_ckk5545 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var is_raviva5546 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var member_until5547 = new Lino.DateField({ "selectOnFocus": true });
    var id5548 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email5549 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language5550 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var url5551 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone5552 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm5553 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax5554 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country5555 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/country" }) }) });
    var city5556 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/city" }) }) });
    var zip_code5557 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region5558 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/region" }) }) });
    var addr15559 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix5560 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street5561 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no5562 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box5563 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr25564 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var prefix5565 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name5566 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks5567 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term5568 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/payment_term" }) }) });
    var vat_regime5569 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_id5570 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var invoice_recipient5571 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/invoice_recipient" }) }) });
    var paper_type5572 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/paper_type" }) }) });
    var title5573 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var first_name5574 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var middle_name5575 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_name5576 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gender5577 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var birth_date5578 = new Lino.IncompleteDateField({ "hidden": true, "selectOnFocus": true });
    var national_id5579 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var birth_country5580 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/birth_country" }) }) });
    var birth_place5581 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var nationality5582 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/nationality" }) }) });
    var card_number5583 = new Ext.form.TextField({ "hidden": true, "maxLength": 20, "selectOnFocus": true });
    var card_valid_from5584 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_valid_until5585 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_type5586 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.beid.BeIdCardTypes) });
    var card_issuer5587 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var noble_condition5588 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var legacy_id5589 = new Ext.form.TextField({ "hidden": true, "maxLength": 12, "selectOnFocus": true });
    var is_member5590 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var mobile_item_disp5591 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5592 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5593 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var age_disp5594 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp5595 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var debit_balance5596 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var image_htmlbox5597 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "image", "value": "<br/>" });
    var eid_info_disp5598 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      city5556.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city5556.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region5558.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      image_htmlbox5597.refresh();
    };
    this.onRender = function(ct, position) {
      country5555.on('change',Lino.chooser_handler(city5556,'country'));
      region5558.on('change',Lino.chooser_handler(city5556,'region'));
      country5555.on('change',Lino.chooser_handler(region5558,'country'));
      Lino.courses.Pupils.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name_column", "editable": false, "header": "Name", "sortable": false, "tooltip": "(courses.Pupils.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "address_column", "editable": false, "header": "Adresse", "sortable": false, "tooltip": "(courses.Pupils.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "pupil_type", "editable": true, "editor": pupil_type5542, "filter": { "type": "string" }, "header": "Teilnehmerart", "renderer": Lino.fk_renderer('pupil_typeHidden','Lino.courses.PupilTypes.detail'), "sortable": false, "tooltip": "(courses.Pupils.pupil_type) Pointer to PupilType.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "section", "editable": true, "editor": section5543, "filter": { "type": "string" }, "header": "Sektion", "sortable": false, "tooltip": "(courses.Pupils.section) ", "width": Lino.chars2width(14) }, { "colIndex": 4, "dataIndex": "is_lfv", "editable": true, "filter": { "type": "boolean" }, "header": "LFV", "sortable": false, "tooltip": "(courses.Pupils.is_lfv) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 5, "dataIndex": "is_ckk", "editable": true, "filter": { "type": "boolean" }, "header": "CKK", "sortable": false, "tooltip": "(courses.Pupils.is_ckk) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 6, "dataIndex": "is_raviva", "editable": true, "filter": { "type": "boolean" }, "header": "Raviva", "sortable": false, "tooltip": "(courses.Pupils.is_raviva) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 7, "dataIndex": "member_until", "editable": true, "editor": member_until5547, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Mitglied bis", "sortable": true, "tooltip": "(courses.Pupils.member_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id5548, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 9, "dataIndex": "email", "editable": true, "editor": email5549, "filter": { "type": "string" }, "header": "E-Mail-Adresse", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "language", "editable": true, "editor": language5550, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "url", "editable": true, "editor": url5551, "filter": { "type": "string" }, "header": "Adresse (URL)", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.url) ", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "phone", "editable": true, "editor": phone5552, "filter": { "type": "string" }, "header": "Telefon", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 13, "dataIndex": "gsm", "editable": true, "editor": gsm5553, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "fax", "editable": true, "editor": fax5554, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "country", "editable": true, "editor": country5555, "filter": { "type": "string" }, "header": "Land", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.Pupils.country) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "city", "editable": true, "editor": city5556, "filter": { "type": "string" }, "header": "Locality", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.Pupils.city) ", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "zip_code", "editable": true, "editor": zip_code5557, "filter": { "type": "string" }, "header": "Postleitzahl", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "region", "editable": true, "editor": region5558, "filter": { "type": "string" }, "header": "Regierungsbezirk", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.Pupils.region) ", "width": Lino.chars2width(21) }, { "colIndex": 19, "dataIndex": "addr1", "editable": true, "editor": addr15559, "filter": { "type": "string" }, "header": "Adresszeile vor Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.addr1) ", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix5560, "filter": { "type": "string" }, "header": "Pr\u00e4fix Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.street_prefix) ", "width": Lino.chars2width(22) }, { "colIndex": 21, "dataIndex": "street", "editable": true, "editor": street5561, "filter": { "type": "string" }, "header": "Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.street) ", "width": Lino.chars2width(22) }, { "colIndex": 22, "dataIndex": "street_no", "editable": true, "editor": street_no5562, "filter": { "type": "string" }, "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.street_no) ", "width": Lino.chars2width(12) }, { "colIndex": 23, "dataIndex": "street_box", "editable": true, "editor": street_box5563, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.street_box) ", "width": Lino.chars2width(12) }, { "colIndex": 24, "dataIndex": "addr2", "editable": true, "editor": addr25564, "filter": { "type": "string" }, "header": "Adresszeile nach Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.addr2) ", "width": Lino.chars2width(22) }, { "colIndex": 25, "dataIndex": "prefix", "editable": true, "editor": prefix5565, "filter": { "type": "string" }, "header": "Name prefix", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.prefix) An optional name prefix. For organisations this is inserted\nbefore the name, for persons this is inserted between first\nname and last name (see\nlino.mixins.human.Human.get_last_name_prefix()).", "width": Lino.chars2width(22) }, { "colIndex": 26, "dataIndex": "name", "editable": true, "editor": name5566, "filter": { "type": "string" }, "header": "Name", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 27, "dataIndex": "remarks", "editable": true, "editor": remarks5567, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "payment_term", "editable": true, "editor": payment_term5568, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.Pupils.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 29, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5569, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 30, "dataIndex": "vat_id", "editable": true, "editor": vat_id5570, "filter": { "type": "string" }, "header": "MwSt.-Nr.", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 31, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient5571, "filter": { "type": "string" }, "header": "Fakturationsadresse", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(courses.Pupils.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "paper_type", "editable": true, "editor": paper_type5572, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "title", "editable": true, "editor": title5573, "filter": { "type": "string" }, "header": "Titel", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.title) Used to specify a professional position or academic\nqualification like \"Dr.\" or \"PhD\".", "width": Lino.chars2width(22) }, { "colIndex": 34, "dataIndex": "first_name", "editable": true, "editor": first_name5574, "filter": { "type": "string" }, "header": "Vorname", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.first_name) The first name, also known as given name.", "width": Lino.chars2width(22) }, { "colIndex": 35, "dataIndex": "middle_name", "editable": true, "editor": middle_name5575, "filter": { "type": "string" }, "header": "Zwischenname", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.middle_name) A space-separated list of all middle names.", "width": Lino.chars2width(22) }, { "colIndex": 36, "dataIndex": "last_name", "editable": true, "editor": last_name5576, "filter": { "type": "string" }, "header": "Familienname", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.last_name) The last name, also known as family name.", "width": Lino.chars2width(22) }, { "colIndex": 37, "dataIndex": "gender", "editable": true, "editor": gender5577, "filter": { "type": "string" }, "header": "Geschlecht", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.gender) The sex of this person (male or female).", "width": Lino.chars2width(10) }, { "colIndex": 38, "dataIndex": "birth_date", "editable": true, "editor": birth_date5578, "filter": { "type": "string" }, "header": "Geburtsdatum", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".", "width": Lino.chars2width(13) }, { "colIndex": 39, "dataIndex": "national_id", "editable": true, "editor": national_id5579, "filter": { "type": "string" }, "header": "NR-Nummer", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.", "width": Lino.chars2width(22) }, { "colIndex": 40, "dataIndex": "birth_country", "editable": true, "editor": birth_country5580, "filter": { "type": "string" }, "header": "Geburtsland", "hidden": true, "renderer": Lino.fk_renderer('birth_countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.Pupils.birth_country) ", "width": Lino.chars2width(21) }, { "colIndex": 41, "dataIndex": "birth_place", "editable": true, "editor": birth_place5581, "filter": { "type": "string" }, "header": "Geburtsort", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.birth_place) ", "width": Lino.chars2width(22) }, { "colIndex": 42, "dataIndex": "nationality", "editable": true, "editor": nationality5582, "filter": { "type": "string" }, "header": "Staatsangeh\u00f6rigkeit", "hidden": true, "renderer": Lino.fk_renderer('nationalityHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.Pupils.nationality) The nationality. This is a pointer to\ncountries.Country which should\ncontain also entries for refugee statuses.", "width": Lino.chars2width(21) }, { "colIndex": 43, "dataIndex": "card_number", "editable": true, "editor": card_number5583, "filter": { "type": "string" }, "header": "eID-Kartennummer", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.card_number) ", "width": Lino.chars2width(22) }, { "colIndex": 44, "dataIndex": "card_valid_from", "editable": true, "editor": card_valid_from5584, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "ID-Karte g\u00fcltig von", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.card_valid_from) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 45, "dataIndex": "card_valid_until", "editable": true, "editor": card_valid_until5585, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "bis", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.card_valid_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 46, "dataIndex": "card_type", "editable": true, "editor": card_type5586, "filter": { "type": "string" }, "header": "eID-Kartenart", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.card_type) ", "width": Lino.chars2width(42) }, { "colIndex": 47, "dataIndex": "card_issuer", "editable": true, "editor": card_issuer5587, "filter": { "type": "string" }, "header": "eID-Karte ausgestellt durch", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.card_issuer) ", "width": Lino.chars2width(22) }, { "colIndex": 48, "dataIndex": "noble_condition", "editable": true, "editor": noble_condition5588, "filter": { "type": "string" }, "header": "Adelstitel", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.noble_condition) Eventueller Adelstitel", "width": Lino.chars2width(22) }, { "colIndex": 49, "dataIndex": "legacy_id", "editable": true, "editor": legacy_id5589, "filter": { "type": "string" }, "header": "Alte Nr.", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.legacy_id) ", "width": Lino.chars2width(14) }, { "colIndex": 50, "dataIndex": "is_member", "editable": true, "filter": { "type": "boolean" }, "header": "Mitglied", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.is_member) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 51, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 52, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 53, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 54, "dataIndex": "age", "editable": false, "header": "Alter", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.age) ", "width": Lino.chars2width(31) }, { "colIndex": 55, "dataIndex": "mti_navigator", "editable": false, "header": "Ansicht als ", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.mti_navigator) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 56, "dataIndex": "debit_balance", "editable": false, "format": "0.000,00/i", "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.debit_balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 57, "dataIndex": "image", "editable": false, "header": "image", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.image) ", "width": Lino.chars2width(31) }, { "colIndex": 58, "dataIndex": "eid_info", "editable": false, "header": "eID-Karte", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.eid_info) ", "width": Lino.chars2width(31) } ];
    Lino.courses.Pupils.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Pupils.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Pupils.insertPanel = Ext.extend(Lino.courses.Pupils.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/Pupils",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Pupils.detail;
    this.ls_insert_handler = Lino.courses.Pupils.insert;
    Lino.courses.Pupils.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Pupils.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Pupils.insertPanel(p);
});
Lino.courses.Pupils.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Pupils.detailPanel = Ext.extend(Lino.courses.Pupils.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-arrow_join", "itemId": "merge_row", "menu_item_text": "Fusionieren", "overflowText": "Fusionieren", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Pupils.merge_row), "tooltip": "Dieses Objekt in ein anderes Objekt der gleichen Klasse fusionieren." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/courses/Pupils",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Pupils.detail;
    this.ls_insert_handler = Lino.courses.Pupils.insert;
    Lino.courses.Pupils.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Pupils.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Pupils.detailPanel(p);
});
Lino.courses.Pupils.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.create_excerpt1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.show_invoice_partners = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Pupils.ParamsPanel({});
  return new Lino.courses.Pupils.GridPanel(p);
});
Lino.courses.Pupils.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.ins_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.del_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.read_beid = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "POST", pk, "read_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.ins_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.del_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.ins_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.del_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.ins_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.del_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.del_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.ins_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.find_by_beid = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Pupils", "POST", pk, "find_by_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Hikes
Lino.courses.Hikes.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 58,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Hikes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Hikes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Hikes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Hikes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Hikes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Hikes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Ausfahrten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "name": "room" }, 'roomHidden', { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Hikes.detail;
    this.ls_insert_handler = Lino.courses.Hikes.insert;
    var ww = this.containing_window;
    var ref5600 = new Ext.form.TextField({ "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var name5601 = new Ext.form.TextField({ "maxLength": 100, "selectOnFocus": true });
    var start_date5602 = new Lino.DateField({ "selectOnFocus": true });
    var enrolments_until5603 = new Lino.DateField({ "selectOnFocus": true });
    var line5604 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/line" }) }) });
    var workflow_buttons_disp5605 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id5606 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_time5607 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date5608 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time5609 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user5610 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/user" }) }) });
    var every_unit5611 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every5612 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday5613 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday5614 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday5615 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday5616 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday5617 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday5618 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday5619 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events5620 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var room5621 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/room" }) }) });
    var max_date5622 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var teacher5623 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/teacher" }) }) });
    var slot5624 = new Lino.RemoteComboFieldElement({ "emptyText": "Timetable Slot ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/slot" }) }) });
    var description5625 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de5626 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr5627 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark5628 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state5629 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places5630 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var fee5631 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/fee" }) }) });
    var payment_term5632 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/payment_term" }) }) });
    var paper_type5633 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/paper_type" }) }) });
    var mobile_item_disp5634 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5635 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp5636 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments5637 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp5638 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested5639 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed5640 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox5641 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Anwesenheiten", "value": "<br/>" });
    var trying5642 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places5643 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var what_text_disp5644 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp5645 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp5646 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration5647 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee5631.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox5641.refresh();
    };
    this.onRender = function(ct, position) {
      line5604.on('change',Lino.chooser_handler(fee5631,'line'));
      Lino.courses.Hikes.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref5600, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(courses.Hikes.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name5601, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(courses.Hikes.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "start_date", "editable": true, "editor": start_date5602, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.Hikes.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until5603, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Einschreibung m\u00f6glich bis", "sortable": true, "tooltip": "(courses.Hikes.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "line", "editable": true, "editor": line5604, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.Hikes.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.Hikes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id5606, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "start_time", "editable": true, "editor": start_time5607, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 8, "dataIndex": "end_date", "editable": true, "editor": end_date5608, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "end_time", "editable": true, "editor": end_time5609, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "user", "editable": true, "editor": user5610, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.Hikes.user) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "every_unit", "editable": true, "editor": every_unit5611, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 12, "dataIndex": "every", "editable": true, "editor": every5612, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 13, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 20, "dataIndex": "max_events", "editable": true, "editor": max_events5620, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 21, "dataIndex": "room", "editable": true, "editor": room5621, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.Hikes.room) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date5622, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "teacher", "editable": true, "editor": teacher5623, "filter": { "type": "string" }, "header": "Kursleiter", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.Hikes.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "slot", "editable": true, "editor": slot5624, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "renderer": Lino.fk_renderer('slotHidden','Lino.courses.Slots.detail'), "sortable": false, "tooltip": "(courses.Hikes.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "description", "editable": true, "editor": description5625, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.description) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_de", "editable": true, "editor": description_de5626, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "description_fr", "editable": true, "editor": description_fr5627, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "remark", "editable": true, "editor": remark5628, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 29, "dataIndex": "state", "editable": true, "editor": state5629, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 30, "dataIndex": "max_places", "editable": true, "editor": max_places5630, "filter": { "type": "numeric" }, "format": "0", "header": "Verf\u00fcgbare Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.max_places) Maximum number of participants", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 31, "dataIndex": "fee", "editable": true, "editor": fee5631, "filter": { "type": "string" }, "header": "Standard-Teilnehmahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Hikes.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "payment_term", "editable": true, "editor": payment_term5632, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.Hikes.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "paper_type", "editable": true, "editor": paper_type5633, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "events_text", "editable": false, "header": "Kalendereintr\u00e4ge", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 37, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Einschreibungen", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.enrolments) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Angefragt", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.requested) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Best\u00e4tigt", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.confirmed) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Anwesenheiten", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Test", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.trying) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Freie Pl\u00e4tze", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.free_places) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 44, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.Hikes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Hikes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Hikes.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/Hikes",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Hikes.detail;
    this.ls_insert_handler = Lino.courses.Hikes.insert;
    Lino.courses.Hikes.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Hikes.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Hikes.insertPanel(p);
});
Lino.courses.Hikes.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Hikes.detailPanel = Ext.extend(Lino.courses.Hikes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/Hikes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Hikes.detail;
    this.ls_insert_handler = Lino.courses.Hikes.insert;
    Lino.courses.Hikes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Hikes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Hikes.detailPanel(p);
});
Lino.courses.Hikes.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.Hikes.GridPanel(p);
});
Lino.courses.Hikes.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Hikes", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Journeys
Lino.courses.Journeys.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 58,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Journeys",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Journeys','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Journeys','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Journeys','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Journeys','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Journeys','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Reisen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "start_time" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "name": "room" }, 'roomHidden', { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Journeys.detail;
    this.ls_insert_handler = Lino.courses.Journeys.insert;
    var ww = this.containing_window;
    var ref5649 = new Ext.form.TextField({ "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var name5650 = new Ext.form.TextField({ "maxLength": 100, "selectOnFocus": true });
    var start_date5651 = new Lino.DateField({ "selectOnFocus": true });
    var end_date5652 = new Lino.DateField({ "selectOnFocus": true });
    var enrolments_until5653 = new Lino.DateField({ "selectOnFocus": true });
    var line5654 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/line" }) }) });
    var workflow_buttons_disp5655 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id5656 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_time5657 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_time5658 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user5659 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/user" }) }) });
    var every_unit5660 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every5661 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday5662 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday5663 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday5664 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday5665 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday5666 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday5667 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday5668 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events5669 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var room5670 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/room" }) }) });
    var max_date5671 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var teacher5672 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/teacher" }) }) });
    var slot5673 = new Lino.RemoteComboFieldElement({ "emptyText": "Timetable Slot ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/slot" }) }) });
    var description5674 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de5675 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr5676 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark5677 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state5678 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places5679 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var fee5680 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/fee" }) }) });
    var payment_term5681 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/payment_term" }) }) });
    var paper_type5682 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/paper_type" }) }) });
    var mobile_item_disp5683 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5684 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp5685 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments5686 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp5687 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested5688 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed5689 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox5690 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Anwesenheiten", "value": "<br/>" });
    var trying5691 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places5692 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var what_text_disp5693 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp5694 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp5695 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration5696 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee5680.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox5690.refresh();
    };
    this.onRender = function(ct, position) {
      line5654.on('change',Lino.chooser_handler(fee5680,'line'));
      Lino.courses.Journeys.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref5649, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(courses.Journeys.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name5650, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(courses.Journeys.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "start_date", "editable": true, "editor": start_date5651, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.Journeys.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "end_date", "editable": true, "editor": end_date5652, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "sortable": true, "tooltip": "(courses.Journeys.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until5653, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Einschreibung m\u00f6glich bis", "sortable": true, "tooltip": "(courses.Journeys.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "line", "editable": true, "editor": line5654, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.Journeys.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.Journeys.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id5656, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time5657, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_time", "editable": true, "editor": end_time5658, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "user", "editable": true, "editor": user5659, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.Journeys.user) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "every_unit", "editable": true, "editor": every_unit5660, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 12, "dataIndex": "every", "editable": true, "editor": every5661, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 13, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 20, "dataIndex": "max_events", "editable": true, "editor": max_events5669, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 21, "dataIndex": "room", "editable": true, "editor": room5670, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.Journeys.room) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date5671, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "teacher", "editable": true, "editor": teacher5672, "filter": { "type": "string" }, "header": "Kursleiter", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.Journeys.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "slot", "editable": true, "editor": slot5673, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "renderer": Lino.fk_renderer('slotHidden','Lino.courses.Slots.detail'), "sortable": false, "tooltip": "(courses.Journeys.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "description", "editable": true, "editor": description5674, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.description) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_de", "editable": true, "editor": description_de5675, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "description_fr", "editable": true, "editor": description_fr5676, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "remark", "editable": true, "editor": remark5677, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 29, "dataIndex": "state", "editable": true, "editor": state5678, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 30, "dataIndex": "max_places", "editable": true, "editor": max_places5679, "filter": { "type": "numeric" }, "format": "0", "header": "Verf\u00fcgbare Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.max_places) Maximum number of participants", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 31, "dataIndex": "fee", "editable": true, "editor": fee5680, "filter": { "type": "string" }, "header": "Standard-Teilnehmahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Journeys.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "payment_term", "editable": true, "editor": payment_term5681, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.Journeys.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "paper_type", "editable": true, "editor": paper_type5682, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "events_text", "editable": false, "header": "Kalendereintr\u00e4ge", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 37, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Einschreibungen", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.enrolments) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Angefragt", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.requested) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Best\u00e4tigt", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.confirmed) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Anwesenheiten", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Test", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.trying) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Freie Pl\u00e4tze", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.free_places) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 44, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.Journeys.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Journeys.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Journeys.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/Journeys",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Journeys.detail;
    this.ls_insert_handler = Lino.courses.Journeys.insert;
    Lino.courses.Journeys.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Journeys.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Journeys.insertPanel(p);
});
Lino.courses.Journeys.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Journeys.detailPanel = Ext.extend(Lino.courses.Journeys.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/Journeys",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Journeys.detail;
    this.ls_insert_handler = Lino.courses.Journeys.insert;
    Lino.courses.Journeys.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Journeys.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Journeys.detailPanel(p);
});
Lino.courses.Journeys.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.Journeys.GridPanel(p);
});
Lino.courses.Journeys.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Journeys", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class vat.InvoiceItemTable
Lino.vat.InvoiceItemTable.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 16,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/vat/InvoiceItemTable",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/InvoiceItemTable','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/InvoiceItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/InvoiceItemTable','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/InvoiceItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/InvoiceItemTable','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Account invoice items",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "account" }, 'accountHidden', { "name": "total_incl" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_class" }, 'vat_classHidden', { "name": "voucher" }, 'voucherHidden', { "name": "title" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "move_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 43,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id5698 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno5699 = new Ext.form.NumberField({ "selectOnFocus": true });
    var account5700 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoiceItemTable/account" }) }) });
    var total_incl5701 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_base5702 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat5703 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var vat_class5704 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var voucher5705 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Rechnung ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoiceItemTable/voucher" }) }) });
    var title5706 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var mobile_item_disp5707 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5708 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5709 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp5710 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      account5700.setContextValue('voucher', record ? record.data['voucherHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      voucher5705.on('change',Lino.chooser_handler(account5700,'voucher'));
      Lino.vat.InvoiceItemTable.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5698, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(vat.InvoiceItemTable.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno5699, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(vat.InvoiceItemTable.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "account", "editable": true, "editor": account5700, "filter": { "type": "string" }, "header": "Konto", "sortable": false, "tooltip": "(vat.InvoiceItemTable.account) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "total_incl", "editable": true, "editor": total_incl5701, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(vat.InvoiceItemTable.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "total_base", "editable": true, "editor": total_base5702, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "sortable": true, "tooltip": "(vat.InvoiceItemTable.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "total_vat", "editable": true, "editor": total_vat5703, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "sortable": true, "tooltip": "(vat.InvoiceItemTable.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "vat_class", "editable": true, "editor": vat_class5704, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "sortable": false, "tooltip": "(vat.InvoiceItemTable.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "voucher", "editable": true, "editor": voucher5705, "filter": { "type": "string" }, "header": "Rechnung", "renderer": Lino.fk_renderer('voucherHidden','Lino.vat.Invoices.detail'), "sortable": false, "tooltip": "(vat.InvoiceItemTable.voucher) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "title", "editable": true, "editor": title5706, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(vat.InvoiceItemTable.title) ", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(vat.InvoiceItemTable.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(vat.InvoiceItemTable.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(vat.InvoiceItemTable.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(vat.InvoiceItemTable.move_buttons) ", "width": Lino.chars2width(6) } ];
    Lino.vat.InvoiceItemTable.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.InvoiceItemTable.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoiceItemTable", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoiceItemTable", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoiceItemTable", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoiceItemTable", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoiceItemTable", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoiceItemTable", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoiceItemTable", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoiceItemTable", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoiceItemTable", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.InvoiceItemTable.GridPanel(p);
});
Lino.vat.InvoiceItemTable.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoiceItemTable", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoiceItemTable", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.JournalEntryItemTable
Lino.finan.JournalEntryItemTable.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 19,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/JournalEntryItemTable",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntryItemTable','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntryItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntryItemTable','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntryItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntryItemTable','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Belegszeilen Diverse Buchungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "match" }, { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "remark" }, { "name": "account" }, 'accountHidden', { "name": "partner" }, 'partnerHidden', { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "voucher" }, 'voucherHidden', { "name": "credit" }, { "name": "debit" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "move_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 60,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id5712 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno5713 = new Ext.form.NumberField({ "selectOnFocus": true });
    var match5714 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntryItemTable/match" }) }) });
    var amount5715 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var dc5716 = new Ext.form.Checkbox({ "selectOnFocus": true });
    var remark5717 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var account5718 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntryItemTable/account" }) }) });
    var partner5719 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntryItemTable/partner" }) }) });
    var date5720 = new Lino.DateField({ "selectOnFocus": true });
    var voucher5721 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Diverse Buchung ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntryItemTable/voucher" }) }) });
    var credit5722 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var debit5723 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var mobile_item_disp5724 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5725 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5726 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp5727 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      match5714.setContextValue('voucher', record ? record.data['voucherHidden'] : undefined);
      match5714.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      voucher5721.on('change',Lino.chooser_handler(match5714,'voucher'));
      partner5719.on('change',Lino.chooser_handler(match5714,'partner'));
      Lino.finan.JournalEntryItemTable.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5712, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(finan.JournalEntryItemTable.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno5713, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(finan.JournalEntryItemTable.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "match", "editable": true, "editor": match5714, "filter": { "type": "string" }, "header": "Match", "sortable": false, "tooltip": "(finan.JournalEntryItemTable.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 3, "dataIndex": "amount", "editable": true, "editor": amount5715, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "sortable": true, "tooltip": "(finan.JournalEntryItemTable.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "sortable": false, "tooltip": "(finan.JournalEntryItemTable.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark5717, "filter": { "type": "string" }, "header": "Ihr Zeichen", "sortable": true, "tooltip": "(finan.JournalEntryItemTable.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "account", "editable": true, "editor": account5718, "filter": { "type": "string" }, "header": "Konto", "sortable": false, "tooltip": "(finan.JournalEntryItemTable.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "partner", "editable": true, "editor": partner5719, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.JournalEntryItemTable.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "date", "editable": true, "editor": date5720, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "date", "sortable": true, "tooltip": "(finan.JournalEntryItemTable.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "voucher", "editable": true, "editor": voucher5721, "filter": { "type": "string" }, "header": "Diverse Buchung", "renderer": Lino.fk_renderer('voucherHidden','Lino.finan.FinancialVouchers.detail'), "sortable": false, "tooltip": "(finan.JournalEntryItemTable.voucher) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 10, "dataIndex": "credit", "editable": true, "editor": credit5722, "format": "0.000,00/i", "header": "Kredit", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntryItemTable.credit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 11, "dataIndex": "debit", "editable": true, "editor": debit5723, "format": "0.000,00/i", "header": "Debit", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntryItemTable.debit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntryItemTable.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntryItemTable.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntryItemTable.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntryItemTable.move_buttons) ", "width": Lino.chars2width(6) } ];
    Lino.finan.JournalEntryItemTable.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntryItemTable.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntryItemTable", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntryItemTable", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntryItemTable", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntryItemTable", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntryItemTable", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntryItemTable", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntryItemTable", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntryItemTable", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntryItemTable", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.JournalEntryItemTable.GridPanel(p);
});
Lino.finan.JournalEntryItemTable.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntryItemTable", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntryItemTable", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.BankStatementItemTable
Lino.finan.BankStatementItemTable.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 19,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/BankStatementItemTable",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementItemTable','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementItemTable','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementItemTable','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Belegszeilen Kontoausz\u00fcge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "match" }, { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "remark" }, { "name": "account" }, 'accountHidden', { "name": "partner" }, 'partnerHidden', { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "voucher" }, 'voucherHidden', { "name": "credit" }, { "name": "debit" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "move_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 62,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id5729 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno5730 = new Ext.form.NumberField({ "selectOnFocus": true });
    var match5731 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementItemTable/match" }) }) });
    var amount5732 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var dc5733 = new Ext.form.Checkbox({ "selectOnFocus": true });
    var remark5734 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var account5735 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementItemTable/account" }) }) });
    var partner5736 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementItemTable/partner" }) }) });
    var date5737 = new Lino.DateField({ "selectOnFocus": true });
    var voucher5738 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Kontoauszug ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementItemTable/voucher" }) }) });
    var credit5739 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var debit5740 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var mobile_item_disp5741 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5742 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5743 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp5744 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      match5731.setContextValue('voucher', record ? record.data['voucherHidden'] : undefined);
      match5731.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      voucher5738.on('change',Lino.chooser_handler(match5731,'voucher'));
      partner5736.on('change',Lino.chooser_handler(match5731,'partner'));
      Lino.finan.BankStatementItemTable.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5729, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(finan.BankStatementItemTable.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno5730, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(finan.BankStatementItemTable.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "match", "editable": true, "editor": match5731, "filter": { "type": "string" }, "header": "Match", "sortable": false, "tooltip": "(finan.BankStatementItemTable.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 3, "dataIndex": "amount", "editable": true, "editor": amount5732, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "sortable": true, "tooltip": "(finan.BankStatementItemTable.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "sortable": false, "tooltip": "(finan.BankStatementItemTable.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark5734, "filter": { "type": "string" }, "header": "Ihr Zeichen", "sortable": true, "tooltip": "(finan.BankStatementItemTable.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "account", "editable": true, "editor": account5735, "filter": { "type": "string" }, "header": "Konto", "sortable": false, "tooltip": "(finan.BankStatementItemTable.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "partner", "editable": true, "editor": partner5736, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.BankStatementItemTable.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "date", "editable": true, "editor": date5737, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "date", "sortable": true, "tooltip": "(finan.BankStatementItemTable.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "voucher", "editable": true, "editor": voucher5738, "filter": { "type": "string" }, "header": "Kontoauszug", "renderer": Lino.fk_renderer('voucherHidden','Lino.finan.BankStatements.detail'), "sortable": false, "tooltip": "(finan.BankStatementItemTable.voucher) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 10, "dataIndex": "credit", "editable": true, "editor": credit5739, "format": "0.000,00/i", "header": "Ausgabe", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementItemTable.credit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 11, "dataIndex": "debit", "editable": true, "editor": debit5740, "format": "0.000,00/i", "header": "Eingang", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementItemTable.debit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementItemTable.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementItemTable.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementItemTable.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementItemTable.move_buttons) ", "width": Lino.chars2width(6) } ];
    Lino.finan.BankStatementItemTable.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatementItemTable.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementItemTable", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementItemTable", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementItemTable", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementItemTable", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementItemTable", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementItemTable", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementItemTable", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementItemTable", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementItemTable", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.BankStatementItemTable.GridPanel(p);
});
Lino.finan.BankStatementItemTable.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementItemTable", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementItemTable", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.PaymentOrderItemTable
Lino.finan.PaymentOrderItemTable.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 18,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/PaymentOrderItemTable",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrderItemTable','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrderItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrderItemTable','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrderItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrderItemTable','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Belegszeilen Zahlungsauftr\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "match" }, { "name": "bank_account" }, 'bank_accountHidden', { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "remark" }, { "name": "account" }, 'accountHidden', { "name": "partner" }, 'partnerHidden', { "name": "voucher" }, 'voucherHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "move_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 59,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id5746 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno5747 = new Ext.form.NumberField({ "selectOnFocus": true });
    var match5748 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrderItemTable/match" }) }) });
    var bank_account5749 = new Lino.RemoteComboFieldElement({ "emptyText": "Bankkonto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrderItemTable/bank_account" }) }) });
    var amount5750 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var dc5751 = new Ext.form.Checkbox({ "selectOnFocus": true });
    var remark5752 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var account5753 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrderItemTable/account" }) }) });
    var partner5754 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrderItemTable/partner" }) }) });
    var voucher5755 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Zahlungsauftrag ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrderItemTable/voucher" }) }) });
    var mobile_item_disp5756 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5757 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5758 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp5759 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      match5748.setContextValue('voucher', record ? record.data['voucherHidden'] : undefined);
      match5748.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
      bank_account5749.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
      bank_account5749.setContextValue('project', record ? record.data['project'] : undefined);
    };
    this.onRender = function(ct, position) {
      voucher5755.on('change',Lino.chooser_handler(match5748,'voucher'));
      partner5754.on('change',Lino.chooser_handler(match5748,'partner'));
      partner5754.on('change',Lino.chooser_handler(bank_account5749,'partner'));
      Lino.finan.PaymentOrderItemTable.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5746, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(finan.PaymentOrderItemTable.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno5747, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(finan.PaymentOrderItemTable.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "match", "editable": true, "editor": match5748, "filter": { "type": "string" }, "header": "Match", "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 3, "dataIndex": "bank_account", "editable": true, "editor": bank_account5749, "filter": { "type": "string" }, "header": "Bankkonto", "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.bank_account) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "amount", "editable": true, "editor": amount5750, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "sortable": true, "tooltip": "(finan.PaymentOrderItemTable.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 6, "dataIndex": "remark", "editable": true, "editor": remark5752, "filter": { "type": "string" }, "header": "Ihr Zeichen", "sortable": true, "tooltip": "(finan.PaymentOrderItemTable.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "account", "editable": true, "editor": account5753, "filter": { "type": "string" }, "header": "Konto", "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.account) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "partner", "editable": true, "editor": partner5754, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "voucher", "editable": true, "editor": voucher5755, "filter": { "type": "string" }, "header": "Zahlungsauftrag", "renderer": Lino.fk_renderer('voucherHidden','Lino.finan.PaymentOrders.detail'), "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.voucher) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.move_buttons) ", "width": Lino.chars2width(6) } ];
    Lino.finan.PaymentOrderItemTable.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrderItemTable.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrderItemTable", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrderItemTable", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrderItemTable", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrderItemTable", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrderItemTable", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrderItemTable", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrderItemTable", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrderItemTable", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrderItemTable", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.PaymentOrderItemTable.GridPanel(p);
});
Lino.finan.PaymentOrderItemTable.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrderItemTable", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrderItemTable", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrderItemTable", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrderItemTable", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sessions.SessionTable
Lino.sessions.SessionTable.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 3,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sessions/SessionTable",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sessions/SessionTable','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sessions/SessionTable','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sessions/SessionTable','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sessions/SessionTable','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sessions/SessionTable','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Sitzungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "session_key" }, { "name": "session_data" }, { "name": "expire_date" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 78,
  ls_id_property : "session_key",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var session_key5761 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 40, "selectOnFocus": true });
    var session_data5762 = new Ext.form.TextArea({ "allowBlank": false, "growMax": 2000, "selectOnFocus": true });
    var expire_date5763 = new Ext.form.DisplayField({ "allowBlank": false, "selectOnFocus": true, "value": "<br>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "session_key", "editable": true, "editor": session_key5761, "filter": { "type": "string" }, "header": "Sitzungs-ID", "sortable": true, "tooltip": "(sessions.SessionTable.session_key) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "session_data", "editable": true, "editor": session_data5762, "filter": { "type": "string" }, "header": "Sitzungsdaten", "sortable": false, "tooltip": "(sessions.SessionTable.session_data) ", "width": Lino.chars2width(61) }, { "colIndex": 2, "dataIndex": "expire_date", "editable": true, "editor": expire_date5763, "header": "Verfallsdatum", "sortable": true, "tooltip": "(sessions.SessionTable.expire_date) ", "width": Lino.chars2width(17) } ];
    Lino.sessions.SessionTable.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sessions.SessionTable.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sessions/SessionTable", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sessions/SessionTable", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sessions/SessionTable", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sessions/SessionTable", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sessions/SessionTable", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sessions/SessionTable", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sessions/SessionTable", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sessions/SessionTable", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sessions.SessionTable.GridPanel(p);
});

// js_render_GridPanel_class countries.PlacesByPlace
Lino.countries.PlacesByPlace.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 16,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/countries/PlacesByPlace",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByPlace','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByPlace','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByPlace','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByPlace','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByPlace','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Unterteilungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "overview" }, { "name": "type" }, 'typeHidden', { "name": "zip_code" }, { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "country" }, 'countryHidden', { "name": "show_type", "type": "boolean" }, { "name": "children_summary" }, { "name": "mobile_item" }, { "name": "workflow_buttons" }, { "name": "parent" }, 'parentHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 5,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.PlacesByPlace.detail;
    var ww = this.containing_window;
    var overview_disp2436 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var type2437 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/PlacesByPlace/type" }) }) });
    var zip_code2438 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(8), "maxLength": 8, "selectOnFocus": true });
    var id2439 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name2440 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name_de2441 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name_fr2442 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country2443 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/PlacesByPlace/country" }) }) });
    var show_type2444 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var children_summary_disp2445 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp2446 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2447 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var parent2448 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/PlacesByPlace/parent" }) }) });
    this.before_row_edit = function(record) {
      type2437.setContextValue('country', record ? record.data['countryHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      country2443.on('change',Lino.chooser_handler(type2437,'country'));
      Lino.countries.PlacesByPlace.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(countries.PlacesByPlace.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type2437, "filter": { "type": "string" }, "header": "Ortsart", "sortable": false, "tooltip": "(countries.PlacesByPlace.type) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "zip_code", "editable": true, "editor": zip_code2438, "filter": { "type": "string" }, "header": "zip code", "sortable": true, "tooltip": "(countries.PlacesByPlace.zip_code) ", "width": Lino.chars2width(10) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id2439, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(countries.PlacesByPlace.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "name", "editable": true, "editor": name2440, "filter": { "type": "string" }, "header": "Bezeichnung", "hidden": true, "sortable": true, "tooltip": "(countries.PlacesByPlace.name) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "name_de", "editable": true, "editor": name_de2441, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "hidden": true, "sortable": true, "tooltip": "(countries.PlacesByPlace.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "name_fr", "editable": true, "editor": name_fr2442, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "hidden": true, "sortable": true, "tooltip": "(countries.PlacesByPlace.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "country", "editable": true, "editor": country2443, "filter": { "type": "string" }, "header": "Land", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(countries.PlacesByPlace.country) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "show_type", "editable": true, "filter": { "type": "boolean" }, "header": "Show type", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByPlace.show_type) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 9, "dataIndex": "children_summary", "editable": false, "header": "Kinder", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByPlace.children_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByPlace.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByPlace.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "parent", "editable": true, "editor": parent2448, "filter": { "type": "string" }, "header": "Teil von", "hidden": true, "renderer": Lino.fk_renderer('parentHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(countries.PlacesByPlace.parent) The superordinate geographic place of which this place is a part.", "width": Lino.chars2width(21) } ];
    Lino.countries.PlacesByPlace.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.PlacesByPlace.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByPlace", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByPlace", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByPlace", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByPlace", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByPlace", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByPlace", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByPlace", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByPlace", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByPlace", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.countries.PlacesByPlace.detailPanel = Ext.extend(Lino.countries.Places.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/countries/PlacesByPlace",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.PlacesByPlace.detail;
    Lino.countries.PlacesByPlace.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.PlacesByPlace.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.PlacesByPlace.detailPanel(p);
});
Lino.countries.PlacesByPlace.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByPlace", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.PlacesByPlace.GridPanel(p);
});
Lino.countries.PlacesByPlace.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByPlace", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByPlace", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByPlace", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class countries.PlacesByCountry
Lino.countries.PlacesByCountry.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 16,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/countries/PlacesByCountry",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByCountry','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByCountry','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByCountry','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByCountry','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByCountry','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Orte",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "type" }, 'typeHidden', { "name": "zip_code" }, { "name": "id", "type": "int" }, { "name": "parent" }, 'parentHidden', { "name": "show_type", "type": "boolean" }, { "name": "children_summary" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "country" }, 'countryHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 5,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.PlacesByCountry.detail;
    var ww = this.containing_window;
    var name2404 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de2405 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr2406 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var type2407 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/PlacesByCountry/type" }) }) });
    var zip_code2408 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(8), "maxLength": 8, "selectOnFocus": true });
    var id2409 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var parent2410 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/PlacesByCountry/parent" }) }) });
    var show_type2411 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var children_summary_disp2412 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp2413 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2414 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2415 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var country2416 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/PlacesByCountry/country" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      type2407.setContextValue('mk',bp['mk']);
      type2407.setContextValue('mt',bp['mt']);
    };
    this.onRender = function(ct, position) {
      country2416.on('change',Lino.chooser_handler(type2407,'country'));
      Lino.countries.PlacesByCountry.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name2404, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(countries.PlacesByCountry.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de2405, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(countries.PlacesByCountry.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr2406, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(countries.PlacesByCountry.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type2407, "filter": { "type": "string" }, "header": "Ortsart", "sortable": false, "tooltip": "(countries.PlacesByCountry.type) ", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "zip_code", "editable": true, "editor": zip_code2408, "filter": { "type": "string" }, "header": "zip code", "sortable": true, "tooltip": "(countries.PlacesByCountry.zip_code) ", "width": Lino.chars2width(10) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id2409, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(countries.PlacesByCountry.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "parent", "editable": true, "editor": parent2410, "filter": { "type": "string" }, "header": "Teil von", "hidden": true, "renderer": Lino.fk_renderer('parentHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(countries.PlacesByCountry.parent) The superordinate geographic place of which this place is a part.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "show_type", "editable": true, "filter": { "type": "boolean" }, "header": "Show type", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByCountry.show_type) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 8, "dataIndex": "children_summary", "editable": false, "header": "Kinder", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByCountry.children_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByCountry.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByCountry.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByCountry.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "country", "editable": true, "editor": country2416, "filter": { "type": "string" }, "header": "Land", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(countries.PlacesByCountry.country) ", "width": Lino.chars2width(21) } ];
    Lino.countries.PlacesByCountry.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.PlacesByCountry.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByCountry", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByCountry", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByCountry", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByCountry", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByCountry", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByCountry", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByCountry", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByCountry", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByCountry", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.countries.PlacesByCountry.detailPanel = Ext.extend(Lino.countries.Places.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/countries/PlacesByCountry",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.PlacesByCountry.detail;
    Lino.countries.PlacesByCountry.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.PlacesByCountry.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.PlacesByCountry.detailPanel(p);
});
Lino.countries.PlacesByCountry.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByCountry", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.PlacesByCountry.GridPanel(p);
});
Lino.countries.PlacesByCountry.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByCountry", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByCountry", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlacesByCountry", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.PartnersByCity
Lino.contacts.PartnersByCity.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 40,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/PartnersByCity",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCity','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCity','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCity','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCity','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCity','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCity','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" } ],
  cell_edit : true,
  title : "Partner",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "address_column" }, { "name": "name" }, { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "prefix" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_id" }, { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "debit_balance" }, { "name": "name_column" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "mti_navigator" }, { "name": "city" }, 'cityHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.PartnersByCity.detail;
    this.ls_insert_handler = Lino.contacts.PartnersByCity.insert;
    var ww = this.containing_window;
    var address_column_disp5765 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var name5766 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var id5767 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email5768 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language5769 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var url5770 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone5771 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm5772 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax5773 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country5774 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCity/country" }) }) });
    var zip_code5775 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region5776 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCity/region" }) }) });
    var addr15777 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix5778 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street5779 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no5780 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box5781 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr25782 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var prefix5783 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks5784 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term5785 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCity/payment_term" }) }) });
    var vat_regime5786 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_id5787 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var invoice_recipient5788 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCity/invoice_recipient" }) }) });
    var paper_type5789 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCity/paper_type" }) }) });
    var debit_balance5790 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var name_column_disp5791 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp5792 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5793 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5794 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp5795 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var city5796 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCity/city" }) }) });
    this.before_row_edit = function(record) {
      region5776.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city5796.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city5796.setContextValue('region', record ? record.data['regionHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      country5774.on('change',Lino.chooser_handler(region5776,'country'));
      country5774.on('change',Lino.chooser_handler(city5796,'country'));
      region5776.on('change',Lino.chooser_handler(city5796,'region'));
      Lino.contacts.PartnersByCity.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "address_column", "editable": false, "header": "Adresse", "sortable": false, "tooltip": "(contacts.PartnersByCity.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name5766, "filter": { "type": "string" }, "header": "Name", "sortable": true, "tooltip": "(contacts.PartnersByCity.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id5767, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "email", "editable": true, "editor": email5768, "filter": { "type": "string" }, "header": "E-Mail-Adresse", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "language", "editable": true, "editor": language5769, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "url", "editable": true, "editor": url5770, "filter": { "type": "string" }, "header": "Adresse (URL)", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.url) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "phone", "editable": true, "editor": phone5771, "filter": { "type": "string" }, "header": "Telefon", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "gsm", "editable": true, "editor": gsm5772, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "fax", "editable": true, "editor": fax5773, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "country", "editable": true, "editor": country5774, "filter": { "type": "string" }, "header": "Land", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCity.country) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "zip_code", "editable": true, "editor": zip_code5775, "filter": { "type": "string" }, "header": "Postleitzahl", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 11, "dataIndex": "region", "editable": true, "editor": region5776, "filter": { "type": "string" }, "header": "Regierungsbezirk", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCity.region) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "addr1", "editable": true, "editor": addr15777, "filter": { "type": "string" }, "header": "Adresszeile vor Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.addr1) ", "width": Lino.chars2width(22) }, { "colIndex": 13, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix5778, "filter": { "type": "string" }, "header": "Pr\u00e4fix Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.street_prefix) ", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "street", "editable": true, "editor": street5779, "filter": { "type": "string" }, "header": "Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.street) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "street_no", "editable": true, "editor": street_no5780, "filter": { "type": "string" }, "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.street_no) ", "width": Lino.chars2width(12) }, { "colIndex": 16, "dataIndex": "street_box", "editable": true, "editor": street_box5781, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.street_box) ", "width": Lino.chars2width(12) }, { "colIndex": 17, "dataIndex": "addr2", "editable": true, "editor": addr25782, "filter": { "type": "string" }, "header": "Adresszeile nach Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.addr2) ", "width": Lino.chars2width(22) }, { "colIndex": 18, "dataIndex": "prefix", "editable": true, "editor": prefix5783, "filter": { "type": "string" }, "header": "Name prefix", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.prefix) An optional name prefix. For organisations this is inserted\nbefore the name, for persons this is inserted between first\nname and last name (see\nlino.mixins.human.Human.get_last_name_prefix()).", "width": Lino.chars2width(22) }, { "colIndex": 19, "dataIndex": "remarks", "editable": true, "editor": remarks5784, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 20, "dataIndex": "payment_term", "editable": true, "editor": payment_term5785, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCity.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5786, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 22, "dataIndex": "vat_id", "editable": true, "editor": vat_id5787, "filter": { "type": "string" }, "header": "MwSt.-Nr.", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 23, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient5788, "filter": { "type": "string" }, "header": "Fakturationsadresse", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCity.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "paper_type", "editable": true, "editor": paper_type5789, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 25, "dataIndex": "debit_balance", "editable": false, "format": "0.000,00/i", "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.debit_balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 26, "dataIndex": "name_column", "editable": false, "header": "Name", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "mti_navigator", "editable": false, "header": "Ansicht als ", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.mti_navigator) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "city", "editable": true, "editor": city5796, "filter": { "type": "string" }, "header": "Locality", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCity.city) ", "width": Lino.chars2width(21) } ];
    Lino.contacts.PartnersByCity.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnersByCity.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.PartnersByCity.insertPanel = Ext.extend(Lino.contacts.Partners.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/contacts/PartnersByCity",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.PartnersByCity.detail;
    this.ls_insert_handler = Lino.contacts.PartnersByCity.insert;
    Lino.contacts.PartnersByCity.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnersByCity.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.contacts.PartnersByCity.insertPanel(p);
});
Lino.contacts.PartnersByCity.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.PartnersByCity.detailPanel = Ext.extend(Lino.contacts.Partners.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" } ],
  ls_url: "/contacts/PartnersByCity",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.PartnersByCity.detail;
    this.ls_insert_handler = Lino.contacts.PartnersByCity.insert;
    Lino.contacts.PartnersByCity.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnersByCity.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.PartnersByCity.detailPanel(p);
});
Lino.contacts.PartnersByCity.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.create_excerpt1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.show_invoice_partners = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.contacts.PartnersByCity.GridPanel(p);
});
Lino.contacts.PartnersByCity.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.ins_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.ins_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.del_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.del_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.ins_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.del_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.del_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.ins_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.del_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.ins_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCity", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.PartnersByCountry
Lino.contacts.PartnersByCountry.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 40,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/PartnersByCountry",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCountry','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCountry','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCountry','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCountry','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCountry','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCountry','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" } ],
  cell_edit : true,
  title : "Partner",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "city" }, 'cityHidden', { "name": "street" }, { "name": "street_no" }, { "name": "name" }, { "name": "language" }, 'languageHidden', { "name": "id", "type": "int" }, { "name": "email" }, { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "prefix" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_id" }, { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "debit_balance" }, { "name": "name_column" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "mti_navigator" }, { "name": "address_column" }, { "name": "country" }, 'countryHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.PartnersByCountry.detail;
    this.ls_insert_handler = Lino.contacts.PartnersByCountry.insert;
    var ww = this.containing_window;
    var city5798 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "forceSelection": false, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCountry/city" }) }) });
    var street5799 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var street_no5800 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "maxLength": 10, "selectOnFocus": true });
    var name5801 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var language5802 = new Lino.ChoicesFieldElement({ "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var id5803 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email5804 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var url5805 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone5806 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm5807 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax5808 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var zip_code5809 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region5810 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCountry/region" }) }) });
    var addr15811 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix5812 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_box5813 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr25814 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var prefix5815 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks5816 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term5817 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCountry/payment_term" }) }) });
    var vat_regime5818 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_id5819 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var invoice_recipient5820 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCountry/invoice_recipient" }) }) });
    var paper_type5821 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCountry/paper_type" }) }) });
    var debit_balance5822 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var name_column_disp5823 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp5824 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5825 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5826 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp5827 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var address_column_disp5828 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var country5829 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCountry/country" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      city5798.setContextValue('mk',bp['mk']);
      city5798.setContextValue('mt',bp['mt']);
      city5798.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      var bp = this.get_base_params();
      region5810.setContextValue('mk',bp['mk']);
      region5810.setContextValue('mt',bp['mt']);
    };
    this.onRender = function(ct, position) {
      country5829.on('change',Lino.chooser_handler(city5798,'country'));
      region5810.on('change',Lino.chooser_handler(city5798,'region'));
      country5829.on('change',Lino.chooser_handler(region5810,'country'));
      Lino.contacts.PartnersByCountry.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "city", "editable": true, "editor": city5798, "filter": { "type": "string" }, "header": "Locality", "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCountry.city) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "street", "editable": true, "editor": street5799, "filter": { "type": "string" }, "header": "Stra\u00dfe", "sortable": true, "tooltip": "(contacts.PartnersByCountry.street) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "street_no", "editable": true, "editor": street_no5800, "filter": { "type": "string" }, "header": "Nr.", "sortable": true, "tooltip": "(contacts.PartnersByCountry.street_no) ", "width": Lino.chars2width(12) }, { "colIndex": 3, "dataIndex": "name", "editable": true, "editor": name5801, "filter": { "type": "string" }, "header": "Name", "sortable": true, "tooltip": "(contacts.PartnersByCountry.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "language", "editable": true, "editor": language5802, "filter": { "type": "string" }, "header": "Sprache", "sortable": false, "tooltip": "(contacts.PartnersByCountry.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id5803, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "email", "editable": true, "editor": email5804, "filter": { "type": "string" }, "header": "E-Mail-Adresse", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "url", "editable": true, "editor": url5805, "filter": { "type": "string" }, "header": "Adresse (URL)", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.url) ", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "phone", "editable": true, "editor": phone5806, "filter": { "type": "string" }, "header": "Telefon", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "gsm", "editable": true, "editor": gsm5807, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "fax", "editable": true, "editor": fax5808, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 11, "dataIndex": "zip_code", "editable": true, "editor": zip_code5809, "filter": { "type": "string" }, "header": "Postleitzahl", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "region", "editable": true, "editor": region5810, "filter": { "type": "string" }, "header": "Regierungsbezirk", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCountry.region) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "addr1", "editable": true, "editor": addr15811, "filter": { "type": "string" }, "header": "Adresszeile vor Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.addr1) ", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix5812, "filter": { "type": "string" }, "header": "Pr\u00e4fix Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.street_prefix) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "street_box", "editable": true, "editor": street_box5813, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.street_box) ", "width": Lino.chars2width(12) }, { "colIndex": 16, "dataIndex": "addr2", "editable": true, "editor": addr25814, "filter": { "type": "string" }, "header": "Adresszeile nach Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.addr2) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "prefix", "editable": true, "editor": prefix5815, "filter": { "type": "string" }, "header": "Name prefix", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.prefix) An optional name prefix. For organisations this is inserted\nbefore the name, for persons this is inserted between first\nname and last name (see\nlino.mixins.human.Human.get_last_name_prefix()).", "width": Lino.chars2width(22) }, { "colIndex": 18, "dataIndex": "remarks", "editable": true, "editor": remarks5816, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 19, "dataIndex": "payment_term", "editable": true, "editor": payment_term5817, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCountry.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 20, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5818, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 21, "dataIndex": "vat_id", "editable": true, "editor": vat_id5819, "filter": { "type": "string" }, "header": "MwSt.-Nr.", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 22, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient5820, "filter": { "type": "string" }, "header": "Fakturationsadresse", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCountry.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "paper_type", "editable": true, "editor": paper_type5821, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 24, "dataIndex": "debit_balance", "editable": false, "format": "0.000,00/i", "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.debit_balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 25, "dataIndex": "name_column", "editable": false, "header": "Name", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "mti_navigator", "editable": false, "header": "Ansicht als ", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.mti_navigator) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "address_column", "editable": false, "header": "Adresse", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "country", "editable": true, "editor": country5829, "filter": { "type": "string" }, "header": "Land", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCountry.country) ", "width": Lino.chars2width(21) } ];
    Lino.contacts.PartnersByCountry.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnersByCountry.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.PartnersByCountry.insertPanel = Ext.extend(Lino.contacts.Partners.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/contacts/PartnersByCountry",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.PartnersByCountry.detail;
    this.ls_insert_handler = Lino.contacts.PartnersByCountry.insert;
    Lino.contacts.PartnersByCountry.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnersByCountry.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.contacts.PartnersByCountry.insertPanel(p);
});
Lino.contacts.PartnersByCountry.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.PartnersByCountry.detailPanel = Ext.extend(Lino.contacts.Partners.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" } ],
  ls_url: "/contacts/PartnersByCountry",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.PartnersByCountry.detail;
    this.ls_insert_handler = Lino.contacts.PartnersByCountry.insert;
    Lino.contacts.PartnersByCountry.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnersByCountry.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.PartnersByCountry.detailPanel(p);
});
Lino.contacts.PartnersByCountry.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.create_excerpt1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.show_invoice_partners = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.contacts.PartnersByCountry.GridPanel(p);
});
Lino.contacts.PartnersByCountry.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.ins_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.ins_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.del_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.del_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.ins_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.del_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.del_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.ins_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.del_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.ins_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnersByCountry", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.RolesByCompany
Lino.contacts.RolesByCompany.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 10,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/RolesByCompany",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByCompany','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByCompany','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByCompany','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByCompany','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByCompany','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByCompany','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Kontaktpersonen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "person" }, 'personHidden', { "name": "type" }, 'typeHidden', { "name": "id", "type": "int" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "company" }, 'companyHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 9,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var person2512 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Person ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/RolesByCompany/person" }) }) });
    var type2513 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/RolesByCompany/type" }) }) });
    var id2514 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp2515 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2516 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2517 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var company2518 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/RolesByCompany/company" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "person", "editable": true, "editor": person2512, "filter": { "type": "string" }, "header": "Person", "renderer": Lino.fk_renderer('personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(contacts.RolesByCompany.person) The person having this role in this company.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type2513, "filter": { "type": "string" }, "header": "Funktion", "sortable": false, "tooltip": "(contacts.RolesByCompany.type) The function of this person in this company.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id2514, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(contacts.RolesByCompany.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.RolesByCompany.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.RolesByCompany.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(contacts.RolesByCompany.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "company", "editable": true, "editor": company2518, "filter": { "type": "string" }, "header": "Organisation", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(contacts.RolesByCompany.company) The organization where this person has this role.", "width": Lino.chars2width(21) } ];
    Lino.contacts.RolesByCompany.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.RolesByCompany.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByCompany", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByCompany", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByCompany", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByCompany", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByCompany", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByCompany", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByCompany", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByCompany", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByCompany", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.RolesByCompany.GridPanel(p);
});

// js_render_GridPanel_class contacts.RolesByPerson
Lino.contacts.RolesByPerson.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 10,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/RolesByPerson",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByPerson','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByPerson','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByPerson','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByPerson','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByPerson','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByPerson','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Kontaktperson f\u00fcr",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "company" }, 'companyHidden', { "name": "type" }, 'typeHidden', { "name": "id", "type": "int" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "person" }, 'personHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 9,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var company1815 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Organisation ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/RolesByPerson/company" }) }) });
    var type1816 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/RolesByPerson/type" }) }) });
    var id1817 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp1818 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1819 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1820 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var person1821 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/RolesByPerson/person" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "company", "editable": true, "editor": company1815, "filter": { "type": "string" }, "header": "Organisation", "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(contacts.RolesByPerson.company) The organization where this person has this role.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type1816, "filter": { "type": "string" }, "header": "Funktion", "sortable": false, "tooltip": "(contacts.RolesByPerson.type) The function of this person in this company.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id1817, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(contacts.RolesByPerson.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.RolesByPerson.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(contacts.RolesByPerson.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(contacts.RolesByPerson.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "person", "editable": true, "editor": person1821, "filter": { "type": "string" }, "header": "Person", "hidden": true, "renderer": Lino.fk_renderer('personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(contacts.RolesByPerson.person) The person having this role in this company.", "width": Lino.chars2width(21) } ];
    Lino.contacts.RolesByPerson.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.RolesByPerson.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByPerson", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByPerson", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByPerson", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByPerson", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByPerson", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByPerson", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByPerson", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByPerson", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/RolesByPerson", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.RolesByPerson.GridPanel(p);
});

// js_render_GridPanel_class ledger.MatchRulesByAccount
Lino.ledger.MatchRulesByAccount.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 8,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/ledger/MatchRulesByAccount",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByAccount','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByAccount','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByAccount','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByAccount','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByAccount','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Begleichungsregeln",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "journal" }, 'journalHidden', { "name": "id", "type": "int" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "account" }, 'accountHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 36,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var journal11095 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MatchRulesByAccount/journal" }) }) });
    var id11096 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp11097 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp11098 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp11099 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var account11100 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MatchRulesByAccount/account" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "journal", "editable": true, "editor": journal11095, "filter": { "type": "string" }, "header": "Journal", "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(ledger.MatchRulesByAccount.journal) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 1, "dataIndex": "id", "editable": true, "editor": id11096, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.MatchRulesByAccount.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRulesByAccount.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRulesByAccount.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRulesByAccount.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "account", "editable": true, "editor": account11100, "filter": { "type": "string" }, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRulesByAccount.account) ", "width": Lino.chars2width(21) } ];
    Lino.ledger.MatchRulesByAccount.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.MatchRulesByAccount.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByAccount", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByAccount.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByAccount", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByAccount.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByAccount", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByAccount.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByAccount", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByAccount.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByAccount", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByAccount.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByAccount", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByAccount.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByAccount", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByAccount.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByAccount", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByAccount.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.MatchRulesByAccount.GridPanel(p);
});

// js_render_GridPanel_class ledger.MatchRulesByJournal
Lino.ledger.MatchRulesByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 8,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/ledger/MatchRulesByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Begleichungsregeln",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "account" }, 'accountHidden', { "name": "id", "type": "int" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "journal" }, 'journalHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 36,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var account3159 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MatchRulesByJournal/account" }) }) });
    var id3160 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp3161 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3162 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp3163 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal3164 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MatchRulesByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "account", "editable": true, "editor": account3159, "filter": { "type": "string" }, "header": "Konto", "sortable": false, "tooltip": "(ledger.MatchRulesByJournal.account) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 1, "dataIndex": "id", "editable": true, "editor": id3160, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.MatchRulesByJournal.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRulesByJournal.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRulesByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRulesByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "journal", "editable": true, "editor": journal3164, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(ledger.MatchRulesByJournal.journal) ", "width": Lino.chars2width(21) } ];
    Lino.ledger.MatchRulesByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.MatchRulesByJournal.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByJournal", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MatchRulesByJournal", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.MatchRulesByJournal.GridPanel(p);
});

// js_render_GridPanel_class ledger.MovementsByVoucher
Lino.ledger.MovementsByVoucher.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/MovementsByVoucher",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByVoucher','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByVoucher','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByVoucher','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByVoucher','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByVoucher','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Bewegungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "account" }, 'accountHidden', { "name": "partner" }, 'partnerHidden', { "name": "debit" }, { "name": "credit" }, { "name": "match_link" }, { "name": "cleared", "type": "boolean" }, { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "value_date", "type": "date" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_class" }, 'vat_classHidden', { "name": "voucher_link" }, { "name": "voucher_partner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "voucher" }, 'voucherHidden' ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var account5831 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByVoucher/account" }) }) });
    var partner5832 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByVoucher/partner" }) }) });
    var debit5833 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var credit5834 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var match_link_disp5835 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var cleared5836 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var id5837 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var seqno5838 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var amount5839 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc5840 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var match5841 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByVoucher/match" }) }) });
    var value_date5842 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var vat_regime5843 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_class5844 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var voucher_link_disp5845 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var voucher_partner_disp5846 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp5847 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5848 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5849 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var voucher5850 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Beleg ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByVoucher/voucher" }) }) });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      partner5832.on('change',Lino.chooser_handler(match5841,'partner'));
      account5831.on('change',Lino.chooser_handler(match5841,'account'));
      Lino.ledger.MovementsByVoucher.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "account", "editable": true, "editor": account5831, "filter": { "type": "string" }, "header": "Konto", "sortable": false, "tooltip": "(ledger.MovementsByVoucher.account) Pointer to the Account that is being moved by this movement.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner5832, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.MovementsByVoucher.partner) Pointer to the partner involved in this movement. This may be\nblank.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "debit", "editable": false, "format": "0.000,00/i", "header": "Debit", "sortable": false, "tooltip": "(ledger.MovementsByVoucher.debit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 3, "dataIndex": "credit", "editable": false, "format": "0.000,00/i", "header": "Kredit", "sortable": false, "tooltip": "(ledger.MovementsByVoucher.credit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "match_link", "editable": false, "header": "Match", "sortable": false, "tooltip": "(ledger.MovementsByVoucher.match_link) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "cleared", "editable": true, "filter": { "type": "boolean" }, "header": "Beglichen", "sortable": false, "tooltip": "(ledger.MovementsByVoucher.cleared) Whether", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id5837, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByVoucher.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "seqno", "editable": true, "editor": seqno5838, "filter": { "type": "numeric" }, "format": "0", "header": "Seq.-Nr.", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByVoucher.seqno) Sequential number within a voucher.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "amount", "editable": true, "editor": amount5839, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "amount", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByVoucher.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 9, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByVoucher.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 10, "dataIndex": "match", "editable": true, "editor": match5841, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByVoucher.match) Pointer to the Movement that is being cleared by this\nmovement.", "width": Lino.chars2width(11) }, { "colIndex": 11, "dataIndex": "value_date", "editable": true, "editor": value_date5842, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Valuta", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByVoucher.value_date) The date at which this movement is to be entered into the\nledger.  This is usually the voucher's entry_date, except\ne.g. for bank statements where each item can have its own\nvalue date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 12, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5843, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByVoucher.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 13, "dataIndex": "vat_class", "editable": true, "editor": vat_class5844, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByVoucher.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "voucher_link", "editable": false, "header": "Beleg", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByVoucher.voucher_link) ", "width": Lino.chars2width(13) }, { "colIndex": 15, "dataIndex": "voucher_partner", "editable": false, "header": "Partner", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByVoucher.voucher_partner) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByVoucher.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByVoucher.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByVoucher.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "voucher", "editable": true, "editor": voucher5850, "filter": { "type": "string" }, "header": "Beleg", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByVoucher.voucher) Pointer to the Voucher who caused this movement.", "width": Lino.chars2width(21) } ];
    Lino.ledger.MovementsByVoucher.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.MovementsByVoucher.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByVoucher", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByVoucher.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByVoucher", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByVoucher.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByVoucher", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByVoucher.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByVoucher", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByVoucher.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByVoucher", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByVoucher.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByVoucher", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByVoucher.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Movements.ParamsPanel({});
  return new Lino.ledger.MovementsByVoucher.GridPanel(p);
});

// js_render_GridPanel_class ledger.MovementsByPartner
Lino.ledger.MovementsByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/MovementsByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Bewegungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "value_date", "type": "date" }, { "name": "voucher_link" }, { "name": "description" }, { "name": "debit" }, { "name": "credit" }, { "name": "match_link" }, { "name": "cleared", "type": "boolean" }, { "name": "id", "type": "int" }, { "name": "voucher" }, 'voucherHidden', { "name": "seqno", "type": "int", "useNull": true }, { "name": "account" }, 'accountHidden', { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "match" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_class" }, 'vat_classHidden', { "name": "voucher_partner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "partner" }, 'partnerHidden' ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value_date5852 = new Lino.DateField({ "selectOnFocus": true });
    var voucher_link_disp5853 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description_disp5854 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var debit5855 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var credit5856 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var match_link_disp5857 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var cleared5858 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var id5859 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var voucher5860 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Beleg ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByPartner/voucher" }) }) });
    var seqno5861 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var account5862 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByPartner/account" }) }) });
    var amount5863 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc5864 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var match5865 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByPartner/match" }) }) });
    var vat_regime5866 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_class5867 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var voucher_partner_disp5868 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp5869 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5870 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5871 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner5872 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByPartner/partner" }) }) });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      partner5872.on('change',Lino.chooser_handler(match5865,'partner'));
      account5862.on('change',Lino.chooser_handler(match5865,'account'));
      Lino.ledger.MovementsByPartner.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value_date", "editable": true, "editor": value_date5852, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Valuta", "sortable": true, "tooltip": "(ledger.MovementsByPartner.value_date) The date at which this movement is to be entered into the\nledger.  This is usually the voucher's entry_date, except\ne.g. for bank statements where each item can have its own\nvalue date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "voucher_link", "editable": false, "header": "Beleg", "sortable": false, "tooltip": "(ledger.MovementsByPartner.voucher_link) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "description", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(ledger.MovementsByPartner.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "debit", "editable": false, "format": "0.000,00/i", "header": "Debit", "sortable": false, "tooltip": "(ledger.MovementsByPartner.debit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "credit", "editable": false, "format": "0.000,00/i", "header": "Kredit", "sortable": false, "tooltip": "(ledger.MovementsByPartner.credit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "match_link", "editable": false, "header": "Match", "sortable": false, "tooltip": "(ledger.MovementsByPartner.match_link) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "cleared", "editable": true, "filter": { "type": "boolean" }, "header": "Beglichen", "sortable": false, "tooltip": "(ledger.MovementsByPartner.cleared) Whether", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id5859, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByPartner.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "voucher", "editable": true, "editor": voucher5860, "filter": { "type": "string" }, "header": "Beleg", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.voucher) Pointer to the Voucher who caused this movement.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 9, "dataIndex": "seqno", "editable": true, "editor": seqno5861, "filter": { "type": "numeric" }, "format": "0", "header": "Seq.-Nr.", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByPartner.seqno) Sequential number within a voucher.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 10, "dataIndex": "account", "editable": true, "editor": account5862, "filter": { "type": "string" }, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.account) Pointer to the Account that is being moved by this movement.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 11, "dataIndex": "amount", "editable": true, "editor": amount5863, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "amount", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByPartner.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "match", "editable": true, "editor": match5865, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.match) Pointer to the Movement that is being cleared by this\nmovement.", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5866, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 15, "dataIndex": "vat_class", "editable": true, "editor": vat_class5867, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "voucher_partner", "editable": false, "header": "Partner", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.voucher_partner) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "partner", "editable": true, "editor": partner5872, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.MovementsByPartner.partner) Pointer to the partner involved in this movement. This may be\nblank.", "width": Lino.chars2width(21) } ];
    Lino.ledger.MovementsByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.MovementsByPartner.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByPartner.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByPartner.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByPartner.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByPartner.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByPartner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByPartner.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByPartner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Movements.ParamsPanel({});
  return new Lino.ledger.MovementsByPartner.GridPanel(p);
});

// js_render_GridPanel_class ledger.MovementsByAccount
Lino.ledger.MovementsByAccount.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/MovementsByAccount",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByAccount','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByAccount','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByAccount','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByAccount','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByAccount','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Bewegungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "value_date", "type": "date" }, { "name": "voucher_link" }, { "name": "description" }, { "name": "debit" }, { "name": "credit" }, { "name": "match_link" }, { "name": "id", "type": "int" }, { "name": "voucher" }, 'voucherHidden', { "name": "partner" }, 'partnerHidden', { "name": "seqno", "type": "int", "useNull": true }, { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "match" }, { "name": "cleared", "type": "boolean" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_class" }, 'vat_classHidden', { "name": "voucher_partner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "account" }, 'accountHidden' ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value_date5874 = new Lino.DateField({ "selectOnFocus": true });
    var voucher_link_disp5875 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description_disp5876 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var debit5877 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var credit5878 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var match_link_disp5879 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id5880 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var voucher5881 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Beleg ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByAccount/voucher" }) }) });
    var partner5882 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByAccount/partner" }) }) });
    var seqno5883 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var amount5884 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc5885 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var match5886 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByAccount/match" }) }) });
    var cleared5887 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var vat_regime5888 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_class5889 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var voucher_partner_disp5890 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp5891 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5892 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5893 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var account5894 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByAccount/account" }) }) });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      partner5882.on('change',Lino.chooser_handler(match5886,'partner'));
      account5894.on('change',Lino.chooser_handler(match5886,'account'));
      Lino.ledger.MovementsByAccount.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value_date", "editable": true, "editor": value_date5874, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Valuta", "sortable": true, "tooltip": "(ledger.MovementsByAccount.value_date) The date at which this movement is to be entered into the\nledger.  This is usually the voucher's entry_date, except\ne.g. for bank statements where each item can have its own\nvalue date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "voucher_link", "editable": false, "header": "Beleg", "sortable": false, "tooltip": "(ledger.MovementsByAccount.voucher_link) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "description", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(ledger.MovementsByAccount.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "debit", "editable": false, "format": "0.000,00/i", "header": "Debit", "sortable": false, "tooltip": "(ledger.MovementsByAccount.debit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "credit", "editable": false, "format": "0.000,00/i", "header": "Kredit", "sortable": false, "tooltip": "(ledger.MovementsByAccount.credit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "match_link", "editable": false, "header": "Match", "sortable": false, "tooltip": "(ledger.MovementsByAccount.match_link) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id5880, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByAccount.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "voucher", "editable": true, "editor": voucher5881, "filter": { "type": "string" }, "header": "Beleg", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.voucher) Pointer to the Voucher who caused this movement.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "partner", "editable": true, "editor": partner5882, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.MovementsByAccount.partner) Pointer to the partner involved in this movement. This may be\nblank.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 9, "dataIndex": "seqno", "editable": true, "editor": seqno5883, "filter": { "type": "numeric" }, "format": "0", "header": "Seq.-Nr.", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByAccount.seqno) Sequential number within a voucher.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 10, "dataIndex": "amount", "editable": true, "editor": amount5884, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "amount", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByAccount.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 12, "dataIndex": "match", "editable": true, "editor": match5886, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.match) Pointer to the Movement that is being cleared by this\nmovement.", "width": Lino.chars2width(11) }, { "colIndex": 13, "dataIndex": "cleared", "editable": true, "filter": { "type": "boolean" }, "header": "Beglichen", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.cleared) Whether", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5888, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 15, "dataIndex": "vat_class", "editable": true, "editor": vat_class5889, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "voucher_partner", "editable": false, "header": "Partner", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.voucher_partner) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "account", "editable": true, "editor": account5894, "filter": { "type": "string" }, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.account) Pointer to the Account that is being moved by this movement.", "width": Lino.chars2width(21) } ];
    Lino.ledger.MovementsByAccount.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.MovementsByAccount.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByAccount", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByAccount.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByAccount", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByAccount.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByAccount", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByAccount.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByAccount", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByAccount.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByAccount", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByAccount.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByAccount", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByAccount.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Movements.ParamsPanel({});
  return new Lino.ledger.MovementsByAccount.GridPanel(p);
});

// js_render_GridPanel_class ledger.MovementsByMatch
Lino.ledger.MovementsByMatch.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": Lino.auto_height_cell_template, "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/MovementsByMatch",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByMatch','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByMatch','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByMatch','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByMatch','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByMatch','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Bewegungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "value_date", "type": "date" }, { "name": "voucher_link" }, { "name": "description" }, { "name": "debit" }, { "name": "credit" }, { "name": "cleared", "type": "boolean" }, { "name": "id", "type": "int" }, { "name": "voucher" }, 'voucherHidden', { "name": "partner" }, 'partnerHidden', { "name": "seqno", "type": "int", "useNull": true }, { "name": "account" }, 'accountHidden', { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "match" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_class" }, 'vat_classHidden', { "name": "match_link" }, { "name": "voucher_partner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value_date5896 = new Lino.DateField({ "selectOnFocus": true });
    var voucher_link_disp5897 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description_disp5898 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var debit5899 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var credit5900 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var cleared5901 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var id5902 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var voucher5903 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Beleg ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByMatch/voucher" }) }) });
    var partner5904 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByMatch/partner" }) }) });
    var seqno5905 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var account5906 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByMatch/account" }) }) });
    var amount5907 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc5908 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var match5909 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByMatch/match" }) }) });
    var vat_regime5910 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_class5911 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var match_link_disp5912 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var voucher_partner_disp5913 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp5914 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5915 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5916 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      partner5904.on('change',Lino.chooser_handler(match5909,'partner'));
      account5906.on('change',Lino.chooser_handler(match5909,'account'));
      Lino.ledger.MovementsByMatch.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value_date", "editable": true, "editor": value_date5896, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Valuta", "sortable": true, "tooltip": "(ledger.MovementsByMatch.value_date) The date at which this movement is to be entered into the\nledger.  This is usually the voucher's entry_date, except\ne.g. for bank statements where each item can have its own\nvalue date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "voucher_link", "editable": false, "header": "Beleg", "sortable": false, "tooltip": "(ledger.MovementsByMatch.voucher_link) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "description", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(ledger.MovementsByMatch.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "debit", "editable": false, "format": "0.000,00/i", "header": "Debit", "sortable": false, "tooltip": "(ledger.MovementsByMatch.debit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "credit", "editable": false, "format": "0.000,00/i", "header": "Kredit", "sortable": false, "tooltip": "(ledger.MovementsByMatch.credit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "cleared", "editable": true, "filter": { "type": "boolean" }, "header": "Beglichen", "sortable": false, "tooltip": "(ledger.MovementsByMatch.cleared) Whether", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id5902, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByMatch.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "voucher", "editable": true, "editor": voucher5903, "filter": { "type": "string" }, "header": "Beleg", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.voucher) Pointer to the Voucher who caused this movement.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "partner", "editable": true, "editor": partner5904, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.MovementsByMatch.partner) Pointer to the partner involved in this movement. This may be\nblank.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 9, "dataIndex": "seqno", "editable": true, "editor": seqno5905, "filter": { "type": "numeric" }, "format": "0", "header": "Seq.-Nr.", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByMatch.seqno) Sequential number within a voucher.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 10, "dataIndex": "account", "editable": true, "editor": account5906, "filter": { "type": "string" }, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.account) Pointer to the Account that is being moved by this movement.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 11, "dataIndex": "amount", "editable": true, "editor": amount5907, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "amount", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByMatch.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "match", "editable": true, "editor": match5909, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.match) Pointer to the Movement that is being cleared by this\nmovement.", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5910, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 15, "dataIndex": "vat_class", "editable": true, "editor": vat_class5911, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "match_link", "editable": false, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.match_link) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "voucher_partner", "editable": false, "header": "Partner", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.voucher_partner) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.MovementsByMatch.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.MovementsByMatch.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByMatch", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByMatch.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByMatch", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByMatch.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByMatch", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByMatch.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByMatch", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByMatch.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByMatch", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByMatch.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/MovementsByMatch", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByMatch.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Movements.ParamsPanel({});
  return new Lino.ledger.MovementsByMatch.GridPanel(p);
});

// js_render_GridPanel_class lists.MembersByList
Lino.lists.MembersByList.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 11,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/lists/MembersByList",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByList','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByList','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByList','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByList','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByList','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Mitglieder",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "seqno", "type": "int", "useNull": true }, { "name": "partner" }, 'partnerHidden', { "name": "remark" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "move_buttons" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "list" }, 'listHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 13,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var seqno1385 = new Ext.form.NumberField({ "selectOnFocus": true });
    var partner1386 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/MembersByList/partner" }) }) });
    var remark1387 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp1388 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id1389 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var move_buttons_disp1390 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp1391 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1392 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var list1393 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Partnerliste ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/MembersByList/list" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "seqno", "editable": true, "editor": seqno1385, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(lists.MembersByList.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner1386, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(lists.MembersByList.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "remark", "editable": true, "editor": remark1387, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(lists.MembersByList.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(lists.MembersByList.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id1389, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(lists.MembersByList.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByList.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByList.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByList.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "list", "editable": true, "editor": list1393, "filter": { "type": "string" }, "header": "Partnerliste", "hidden": true, "renderer": Lino.fk_renderer('listHidden','Lino.lists.Lists.detail'), "sortable": false, "tooltip": "(lists.MembersByList.list) ", "width": Lino.chars2width(21) } ];
    Lino.lists.MembersByList.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.MembersByList.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByList", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByList", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByList", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByList", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByList", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByList", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByList", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByList", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByList", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.MembersByList.GridPanel(p);
});
Lino.lists.MembersByList.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByList", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByList", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class lists.MembersByPartner
Lino.lists.MembersByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 11,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/lists/MembersByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Listenmitgliedschaften",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "list" }, 'listHidden', { "name": "remark" }, { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "move_buttons" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "partner" }, 'partnerHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 13,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var list1406 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Partnerliste ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/MembersByPartner/list" }) }) });
    var remark1407 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id1408 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var seqno1409 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var move_buttons_disp1410 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp1411 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1412 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1413 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner1414 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/MembersByPartner/partner" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "list", "editable": true, "editor": list1406, "filter": { "type": "string" }, "header": "Partnerliste", "renderer": Lino.fk_renderer('listHidden','Lino.lists.Lists.detail'), "sortable": false, "tooltip": "(lists.MembersByPartner.list) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "remark", "editable": true, "editor": remark1407, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(lists.MembersByPartner.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id1408, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(lists.MembersByPartner.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 3, "dataIndex": "seqno", "editable": true, "editor": seqno1409, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(lists.MembersByPartner.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByPartner.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByPartner.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByPartner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByPartner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "partner", "editable": true, "editor": partner1414, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(lists.MembersByPartner.partner) ", "width": Lino.chars2width(21) } ];
    Lino.lists.MembersByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.MembersByPartner.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByPartner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByPartner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByPartner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByPartner", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByPartner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.MembersByPartner.GridPanel(p);
});
Lino.lists.MembersByPartner.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByPartner", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/lists/MembersByPartner", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class plausibility.ProblemsByChecker
Lino.plausibility.ProblemsByChecker.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/plausibility/ProblemsByChecker",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByChecker','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByChecker','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByChecker','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByChecker','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByChecker','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Datenkontrolle durchf\u00fchren" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Datenprobleme reparieren" } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : false,
  title : "Datenprobleme",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "message" }, { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "checker" }, 'checkerHidden' ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 17,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.ProblemsByChecker.detail;
    var ww = this.containing_window;
    var user2786 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/ProblemsByChecker/user" }) }) });
    var owner_disp2787 = new Ext.form.DisplayField({ "disabled": true });
    var message2788 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 250, "selectOnFocus": true });
    var id2789 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type2790 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/ProblemsByChecker/owner_type" }) }) });
    var owner_id2791 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/ProblemsByChecker/owner_id" }) }) });
    var mobile_item_disp2792 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2793 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2794 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var checker2795 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.plausibility.Checkers });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      owner_type2790.on('change',Lino.chooser_handler(owner_id2791,'owner_type'));
      Lino.plausibility.ProblemsByChecker.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "user", "editable": true, "editor": user2786, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.user) The user reponsible\nfor fixing this problem.", "width": Lino.chars2width(11) }, { "colIndex": 1, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "message", "editable": true, "editor": message2788, "filter": { "type": "string" }, "header": "Meldung", "sortable": true, "tooltip": "(plausibility.ProblemsByChecker.message) The message text. This is a concatenation of all messages that\nwere yeld by the checker.", "width": Lino.chars2width(51) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id2789, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(plausibility.ProblemsByChecker.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "owner_type", "editable": true, "editor": owner_type2790, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "owner_id", "editable": true, "editor": owner_id2791, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "checker", "editable": true, "editor": checker2795, "filter": { "type": "string" }, "header": "Datentest", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.checker) The Checker which reported\nthis problem.", "width": Lino.chars2width(11) } ];
    Lino.plausibility.ProblemsByChecker.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.ProblemsByChecker.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByChecker", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByChecker.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByChecker", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByChecker.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByChecker", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByChecker.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByChecker", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByChecker.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByChecker", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByChecker.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByChecker", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.plausibility.ProblemsByChecker.detailPanel = Ext.extend(Lino.plausibility.Problems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Datenkontrolle durchf\u00fchren" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Datenprobleme reparieren" } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/plausibility/ProblemsByChecker",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.ProblemsByChecker.detail;
    Lino.plausibility.ProblemsByChecker.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.ProblemsByChecker.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.ProblemsByChecker.detailPanel(p);
});
Lino.plausibility.ProblemsByChecker.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.plausibility.Problems.ParamsPanel({});
  return new Lino.plausibility.ProblemsByChecker.GridPanel(p);
});
Lino.plausibility.ProblemsByChecker.update_problem = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByChecker", "GET", pk, "update_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByChecker.fix_problem = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByChecker", "GET", pk, "fix_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.SubscriptionsByUser
Lino.cal.SubscriptionsByUser.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 9,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/SubscriptionsByUser",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByUser','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByUser','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByUser','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByUser','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByUser','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Abonnements",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "calendar" }, 'calendarHidden', { "name": "is_hidden", "type": "boolean" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "user" }, 'userHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 29,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id5918 = new Ext.form.NumberField({ "selectOnFocus": true });
    var calendar5919 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Kalender ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/SubscriptionsByUser/calendar" }) }) });
    var is_hidden5920 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var mobile_item_disp5921 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5922 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5923 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var user5924 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/SubscriptionsByUser/user" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5918, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.SubscriptionsByUser.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "calendar", "editable": true, "editor": calendar5919, "filter": { "type": "string" }, "header": "Kalender", "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.SubscriptionsByUser.calendar) The calendar you want to subscribe to.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "is_hidden", "editable": true, "filter": { "type": "boolean" }, "header": "versteckt", "sortable": false, "tooltip": "(cal.SubscriptionsByUser.is_hidden) Whether this subscription should \"\n        \"initially be displayed as a hidden calendar.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 3, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.SubscriptionsByUser.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.SubscriptionsByUser.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.SubscriptionsByUser.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "user", "editable": true, "editor": user5924, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.SubscriptionsByUser.user) ", "width": Lino.chars2width(21) } ];
    Lino.cal.SubscriptionsByUser.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.SubscriptionsByUser.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByUser", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByUser", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByUser", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByUser", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByUser", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByUser", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByUser", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByUser", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Subscriptions.ParamsPanel({});
  return new Lino.cal.SubscriptionsByUser.GridPanel(p);
});

// js_render_GridPanel_class cal.SubscriptionsByCalendar
Lino.cal.SubscriptionsByCalendar.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 9,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/SubscriptionsByCalendar",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByCalendar','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByCalendar','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByCalendar','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByCalendar','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByCalendar','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Abonnements",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "is_hidden", "type": "boolean" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "calendar" }, 'calendarHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 29,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id2639 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user2640 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/SubscriptionsByCalendar/user" }) }) });
    var is_hidden2641 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var mobile_item_disp2642 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2643 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2644 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var calendar2645 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/SubscriptionsByCalendar/calendar" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id2639, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.SubscriptionsByCalendar.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user2640, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.SubscriptionsByCalendar.user) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "is_hidden", "editable": true, "filter": { "type": "boolean" }, "header": "versteckt", "sortable": false, "tooltip": "(cal.SubscriptionsByCalendar.is_hidden) Whether this subscription should \"\n        \"initially be displayed as a hidden calendar.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 3, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.SubscriptionsByCalendar.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.SubscriptionsByCalendar.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.SubscriptionsByCalendar.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "calendar", "editable": true, "editor": calendar2645, "filter": { "type": "string" }, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.SubscriptionsByCalendar.calendar) The calendar you want to subscribe to.", "width": Lino.chars2width(21) } ];
    Lino.cal.SubscriptionsByCalendar.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.SubscriptionsByCalendar.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByCalendar", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByCalendar", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByCalendar", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByCalendar", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByCalendar", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByCalendar", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByCalendar", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/SubscriptionsByCalendar", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Subscriptions.ParamsPanel({});
  return new Lino.cal.SubscriptionsByCalendar.GridPanel(p);
});

// js_render_GridPanel_class cal.TasksByUser
Lino.cal.TasksByUser.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 27,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/TasksByUser",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByUser','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByUser','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByUser','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByUser','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByUser','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Aufgaben",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "name": "start_time" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "due_time" }, { "name": "percent", "type": "int", "useNull": true }, { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "created_natural" }, { "name": "user" }, 'userHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 18,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.TasksByUser.detail;
    this.ls_insert_handler = Lino.cal.TasksByUser.insert;
    var ww = this.containing_window;
    var start_date5926 = new Lino.DateField({ "selectOnFocus": true });
    var summary5927 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp5928 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id5929 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified5930 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created5931 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_time5932 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var owner_type5933 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/TasksByUser/owner_type" }) }) });
    var owner_id5934 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/TasksByUser/owner_id" }) }) });
    var description5935 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class5936 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence5937 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type5938 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var due_date5939 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var due_time5940 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var percent5941 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state5942 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.TaskStates });
    var owner_disp5943 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp5944 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5945 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp5946 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var user5947 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/TasksByUser/user" }) }) });
    this.before_row_edit = function(record) {
      owner_id5934.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type5933.on('change',Lino.chooser_handler(owner_id5934,'owner_type'));
      Lino.cal.TasksByUser.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date5926, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(cal.TasksByUser.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "summary", "editable": true, "editor": summary5927, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.TasksByUser.summary) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.TasksByUser.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id5929, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 5, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "start_time", "editable": true, "editor": start_time5932, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 7, "dataIndex": "owner_type", "editable": true, "editor": owner_type5933, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.TasksByUser.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_id", "editable": true, "editor": owner_id5934, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "description", "editable": true, "editor": description5935, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.description) ", "width": Lino.chars2width(61) }, { "colIndex": 10, "dataIndex": "access_class", "editable": true, "editor": access_class5936, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 11, "dataIndex": "sequence", "editable": true, "editor": sequence5937, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 12, "dataIndex": "auto_type", "editable": true, "editor": auto_type5938, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 13, "dataIndex": "due_date", "editable": true, "editor": due_date5939, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Zahlungsziel", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 14, "dataIndex": "due_time", "editable": true, "editor": due_time5940, "header": "F\u00e4llig um", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.due_time) ", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 15, "dataIndex": "percent", "editable": true, "editor": percent5941, "filter": { "type": "numeric" }, "format": "0", "header": "Dauer (Anzahl)", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.percent) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 16, "dataIndex": "state", "editable": true, "editor": state5942, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.state) The state of this Task. one of TaskStates.", "width": Lino.chars2width(13) }, { "colIndex": 17, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 18, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.created_natural) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "user", "editable": true, "editor": user5947, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.TasksByUser.user) ", "width": Lino.chars2width(21) } ];
    Lino.cal.TasksByUser.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TasksByUser.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.TasksByUser.insertPanel = Ext.extend(Lino.cal.Tasks.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/TasksByUser",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.TasksByUser.detail;
    this.ls_insert_handler = Lino.cal.TasksByUser.insert;
    Lino.cal.TasksByUser.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TasksByUser.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.TasksByUser.insertPanel(p);
});
Lino.cal.TasksByUser.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.TasksByUser.detailPanel = Ext.extend(Lino.cal.Tasks.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/TasksByUser",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.TasksByUser.detail;
    this.ls_insert_handler = Lino.cal.TasksByUser.insert;
    Lino.cal.TasksByUser.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TasksByUser.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.TasksByUser.detailPanel(p);
});
Lino.cal.TasksByUser.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Tasks.ParamsPanel({});
  return new Lino.cal.TasksByUser.GridPanel(p);
});
Lino.cal.TasksByUser.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByUser", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.GuestsByEvent
Lino.cal.GuestsByEvent.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 14,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/GuestsByEvent",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByEvent','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByEvent','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByEvent','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByEvent','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByEvent','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Anwesenheiten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "partner" }, 'partnerHidden', { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "remark" }, { "name": "id", "type": "int" }, { "name": "state" }, 'stateHidden', { "name": "event_summary" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "event" }, 'eventHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByEvent.detail;
    this.ls_insert_handler = Lino.cal.GuestsByEvent.insert;
    var ww = this.containing_window;
    var partner635 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Person ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/GuestsByEvent/partner" }) }) });
    var role636 = new Lino.RemoteComboFieldElement({ "emptyText": "Gastrolle ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/GuestsByEvent/role" }) }) });
    var workflow_buttons_disp637 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark638 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id639 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state640 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.GuestStates });
    var event_summary_disp641 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp642 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp643 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var event644 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Kalendereintrag ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/GuestsByEvent/event" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "partner", "editable": true, "editor": partner635, "filter": { "type": "string" }, "header": "Person", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(cal.GuestsByEvent.partner) The partner to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "role", "editable": true, "editor": role636, "filter": { "type": "string" }, "header": "Rolle", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.GuestsByEvent.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.GuestsByEvent.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark638, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(cal.GuestsByEvent.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id639, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.GuestsByEvent.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "state", "editable": true, "editor": state640, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.GuestsByEvent.state) The state of this presence.", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "event_summary", "editable": false, "header": "Veranstaltung", "hidden": true, "sortable": false, "tooltip": "(cal.GuestsByEvent.event_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.GuestsByEvent.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.GuestsByEvent.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "event", "editable": true, "editor": event644, "filter": { "type": "string" }, "header": "Kalendereintrag", "hidden": true, "renderer": Lino.fk_renderer('eventHidden','Lino.cal.OneEvent.detail'), "sortable": false, "tooltip": "(cal.GuestsByEvent.event) The calendar event to which this presence applies.", "width": Lino.chars2width(21) } ];
    Lino.cal.GuestsByEvent.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByEvent.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestsByEvent.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/GuestsByEvent",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByEvent.detail;
    this.ls_insert_handler = Lino.cal.GuestsByEvent.insert;
    Lino.cal.GuestsByEvent.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByEvent.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.GuestsByEvent.insertPanel(p);
});
Lino.cal.GuestsByEvent.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestsByEvent.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/GuestsByEvent",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByEvent.detail;
    this.ls_insert_handler = Lino.cal.GuestsByEvent.insert;
    Lino.cal.GuestsByEvent.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByEvent.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.GuestsByEvent.detailPanel(p);
});
Lino.cal.GuestsByEvent.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.GuestsByEvent.GridPanel(p);
});
Lino.cal.GuestsByEvent.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByEvent", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.GuestsByRole
Lino.cal.GuestsByRole.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 14,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/GuestsByRole",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByRole','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByRole','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByRole','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByRole','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByRole','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Anwesenheiten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "partner" }, 'partnerHidden', { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "remark" }, { "name": "event" }, 'eventHidden', { "name": "id", "type": "int" }, { "name": "state" }, 'stateHidden', { "name": "event_summary" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByRole.detail;
    this.ls_insert_handler = Lino.cal.GuestsByRole.insert;
    var ww = this.containing_window;
    var partner2659 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Person ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/GuestsByRole/partner" }) }) });
    var role2660 = new Lino.RemoteComboFieldElement({ "emptyText": "Gastrolle ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/GuestsByRole/role" }) }) });
    var workflow_buttons_disp2661 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark2662 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event2663 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Kalendereintrag ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/GuestsByRole/event" }) }) });
    var id2664 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state2665 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.GuestStates });
    var event_summary_disp2666 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp2667 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2668 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "partner", "editable": true, "editor": partner2659, "filter": { "type": "string" }, "header": "Person", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(cal.GuestsByRole.partner) The partner to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "role", "editable": true, "editor": role2660, "filter": { "type": "string" }, "header": "Rolle", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.GuestsByRole.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.GuestsByRole.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark2662, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(cal.GuestsByRole.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "event", "editable": true, "editor": event2663, "filter": { "type": "string" }, "header": "Kalendereintrag", "renderer": Lino.fk_renderer('eventHidden','Lino.cal.OneEvent.detail'), "sortable": false, "tooltip": "(cal.GuestsByRole.event) The calendar event to which this presence applies.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id2664, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.GuestsByRole.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "state", "editable": true, "editor": state2665, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.GuestsByRole.state) The state of this presence.", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "event_summary", "editable": false, "header": "Veranstaltung", "hidden": true, "sortable": false, "tooltip": "(cal.GuestsByRole.event_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.GuestsByRole.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.GuestsByRole.overview) ", "width": Lino.chars2width(31) } ];
    Lino.cal.GuestsByRole.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByRole.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestsByRole.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/GuestsByRole",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByRole.detail;
    this.ls_insert_handler = Lino.cal.GuestsByRole.insert;
    Lino.cal.GuestsByRole.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByRole.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.GuestsByRole.insertPanel(p);
});
Lino.cal.GuestsByRole.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestsByRole.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/GuestsByRole",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByRole.detail;
    this.ls_insert_handler = Lino.cal.GuestsByRole.insert;
    Lino.cal.GuestsByRole.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByRole.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.GuestsByRole.detailPanel(p);
});
Lino.cal.GuestsByRole.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.GuestsByRole.GridPanel(p);
});
Lino.cal.GuestsByRole.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByRole", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.GuestsByPartner
Lino.cal.GuestsByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 3,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/GuestsByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Anwesenheiten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "event__when_text" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByPartner.detail;
    this.ls_insert_handler = Lino.cal.GuestsByPartner.insert;
    var ww = this.containing_window;
    var event__when_text_disp5949 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "sortable": false, "value": "<br/>" });
    var workflow_buttons_disp5950 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "event__when_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(cal.GuestsByPartner.event__when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.GuestsByPartner.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.cal.GuestsByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByPartner.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestsByPartner.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/GuestsByPartner",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByPartner.detail;
    this.ls_insert_handler = Lino.cal.GuestsByPartner.insert;
    Lino.cal.GuestsByPartner.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByPartner.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.GuestsByPartner.insertPanel(p);
});
Lino.cal.GuestsByPartner.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestsByPartner.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/GuestsByPartner",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByPartner.detail;
    this.ls_insert_handler = Lino.cal.GuestsByPartner.insert;
    Lino.cal.GuestsByPartner.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByPartner.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.GuestsByPartner.detailPanel(p);
});
Lino.cal.GuestsByPartner.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.GuestsByPartner.GridPanel(p);
});
Lino.cal.GuestsByPartner.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestsByPartner", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.EntriesByType
Lino.cal.EntriesByType.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/EntriesByType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByType','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Kalendereintr\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "when_text" }, { "name": "user" }, 'userHidden', { "name": "summary" }, { "name": "event_type" }, 'event_typeHidden', { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByType.detail;
    this.ls_insert_handler = Lino.cal.EntriesByType.insert;
    var ww = this.containing_window;
    var when_text_disp1217 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var user1218 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByType/user" }) }) });
    var summary1219 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event_type1220 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByType/event_type" }) }) });
    var id1221 = new Ext.form.NumberField({ "selectOnFocus": true });
    var modified1222 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created1223 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date1224 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time1225 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date1226 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time1227 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time1228 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method1229 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var assigned_to1230 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByType/assigned_to" }) }) });
    var owner_type1231 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByType/owner_type" }) }) });
    var owner_id1232 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByType/owner_id" }) }) });
    var description1233 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class1234 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence1235 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type1236 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent1237 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room1238 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByType/room" }) }) });
    var priority1239 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByType/priority" }) }) });
    var state1240 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp1241 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar1242 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp1243 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp1244 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day1245 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp1246 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp1247 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1248 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1249 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp1250 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration1251 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id1232.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type1231.on('change',Lino.chooser_handler(owner_id1232,'owner_type'));
      Lino.cal.EntriesByType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(cal.EntriesByType.when_text) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user1218, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.EntriesByType.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "summary", "editable": true, "editor": summary1219, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.EntriesByType.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "event_type", "editable": true, "editor": event_type1220, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.EntriesByType.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id1221, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.EntriesByType.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByType.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByType.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date1224, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByType.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time1225, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByType.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date1226, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByType.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time1227, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByType.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByType.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 12, "dataIndex": "build_method", "editable": true, "editor": build_method1229, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 13, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to1230, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.EntriesByType.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_type", "editable": true, "editor": owner_type1231, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.EntriesByType.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_id", "editable": true, "editor": owner_id1232, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description1233, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class1234, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence1235, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByType.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type1236, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByType.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 21, "dataIndex": "room", "editable": true, "editor": room1238, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.EntriesByType.room) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "priority", "editable": true, "editor": priority1239, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "state", "editable": true, "editor": state1240, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 24, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 25, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.EntriesByType.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 29, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.url) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByType.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.EntriesByType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByType.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EntriesByType.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/EntriesByType",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByType.detail;
    this.ls_insert_handler = Lino.cal.EntriesByType.insert;
    Lino.cal.EntriesByType.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByType.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.EntriesByType.insertPanel(p);
});
Lino.cal.EntriesByType.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EntriesByType.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/EntriesByType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByType.detail;
    this.ls_insert_handler = Lino.cal.EntriesByType.insert;
    Lino.cal.EntriesByType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByType.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.EntriesByType.detailPanel(p);
});
Lino.cal.EntriesByType.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.EntriesByType.GridPanel(p);
});
Lino.cal.EntriesByType.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByType.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByType", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.ConflictingEvents
Lino.cal.ConflictingEvents.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/ConflictingEvents",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/ConflictingEvents','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/ConflictingEvents','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/ConflictingEvents','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/ConflictingEvents','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/ConflictingEvents','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "\u00a0\u2694\u00a0",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "name": "end_time" }, { "name": "room" }, 'roomHidden', { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "summary" }, { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "event_type" }, 'event_typeHidden', { "name": "transparent", "type": "boolean" }, { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "when_text" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.ConflictingEvents.detail;
    this.ls_insert_handler = Lino.cal.ConflictingEvents.insert;
    var ww = this.containing_window;
    var start_date11102 = new Lino.DateField({ "selectOnFocus": true });
    var start_time11103 = new Lino.TimeField({ "selectOnFocus": true });
    var end_time11104 = new Lino.TimeField({ "selectOnFocus": true });
    var room11105 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/ConflictingEvents/room" }) }) });
    var user11106 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/ConflictingEvents/user" }) }) });
    var id11107 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified11108 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created11109 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var end_date11110 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var build_time11111 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method11112 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var assigned_to11113 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/ConflictingEvents/assigned_to" }) }) });
    var owner_type11114 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/ConflictingEvents/owner_type" }) }) });
    var owner_id11115 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/ConflictingEvents/owner_id" }) }) });
    var summary11116 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var description11117 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class11118 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence11119 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type11120 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var event_type11121 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/ConflictingEvents/event_type" }) }) });
    var transparent11122 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var priority11123 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/ConflictingEvents/priority" }) }) });
    var state11124 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp11125 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar11126 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp11127 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp11128 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var when_text_disp11129 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day11130 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp11131 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp11132 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp11133 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp11134 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp11135 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration11136 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id11115.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type11114.on('change',Lino.chooser_handler(owner_id11115,'owner_type'));
      Lino.cal.ConflictingEvents.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date11102, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(cal.ConflictingEvents.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "start_time", "editable": true, "editor": start_time11103, "header": "Start time", "sortable": true, "tooltip": "(cal.ConflictingEvents.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "end_time", "editable": true, "editor": end_time11104, "header": "Endet um", "sortable": true, "tooltip": "(cal.ConflictingEvents.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 3, "dataIndex": "room", "editable": true, "editor": room11105, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.ConflictingEvents.room) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user11106, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.ConflictingEvents.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id11107, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.ConflictingEvents.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.ConflictingEvents.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.ConflictingEvents.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "end_date", "editable": true, "editor": end_date11110, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.ConflictingEvents.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.ConflictingEvents.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 10, "dataIndex": "build_method", "editable": true, "editor": build_method11112, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 11, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to11113, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.ConflictingEvents.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_type", "editable": true, "editor": owner_type11114, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.ConflictingEvents.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "owner_id", "editable": true, "editor": owner_id11115, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "summary", "editable": true, "editor": summary11116, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "hidden": true, "sortable": true, "tooltip": "(cal.ConflictingEvents.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "description", "editable": true, "editor": description11117, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 16, "dataIndex": "access_class", "editable": true, "editor": access_class11118, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 17, "dataIndex": "sequence", "editable": true, "editor": sequence11119, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.ConflictingEvents.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 18, "dataIndex": "auto_type", "editable": true, "editor": auto_type11120, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.ConflictingEvents.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 19, "dataIndex": "event_type", "editable": true, "editor": event_type11121, "filter": { "type": "string" }, "header": "Kalendereintragsart", "hidden": true, "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.ConflictingEvents.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 20, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 21, "dataIndex": "priority", "editable": true, "editor": priority11123, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "state", "editable": true, "editor": state11124, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 23, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 24, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.ConflictingEvents.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "when_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 29, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.url) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.ConflictingEvents.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.ConflictingEvents.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.ConflictingEvents.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.ConflictingEvents.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/ConflictingEvents",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.ConflictingEvents.detail;
    this.ls_insert_handler = Lino.cal.ConflictingEvents.insert;
    Lino.cal.ConflictingEvents.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.ConflictingEvents.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.ConflictingEvents.insertPanel(p);
});
Lino.cal.ConflictingEvents.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.ConflictingEvents.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/ConflictingEvents",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.ConflictingEvents.detail;
    this.ls_insert_handler = Lino.cal.ConflictingEvents.insert;
    Lino.cal.ConflictingEvents.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.ConflictingEvents.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.ConflictingEvents.detailPanel(p);
});
Lino.cal.ConflictingEvents.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.ConflictingEvents.GridPanel(p);
});
Lino.cal.ConflictingEvents.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.ConflictingEvents.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/ConflictingEvents", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.EntriesByRoom
Lino.cal.EntriesByRoom.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/EntriesByRoom",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByRoom','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByRoom','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByRoom','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByRoom','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByRoom','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Kalendereintr\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "when_text" }, { "name": "user" }, 'userHidden', { "name": "summary" }, { "name": "event_type" }, 'event_typeHidden', { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "room" }, 'roomHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByRoom.detail;
    this.ls_insert_handler = Lino.cal.EntriesByRoom.insert;
    var ww = this.containing_window;
    var when_text_disp2129 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var user2130 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByRoom/user" }) }) });
    var summary2131 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event_type2132 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByRoom/event_type" }) }) });
    var id2133 = new Ext.form.NumberField({ "selectOnFocus": true });
    var modified2134 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created2135 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date2136 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time2137 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date2138 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time2139 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time2140 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method2141 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var assigned_to2142 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByRoom/assigned_to" }) }) });
    var owner_type2143 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByRoom/owner_type" }) }) });
    var owner_id2144 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByRoom/owner_id" }) }) });
    var description2145 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class2146 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence2147 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type2148 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent2149 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var priority2150 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByRoom/priority" }) }) });
    var state2151 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp2152 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar2153 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp2154 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp2155 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day2156 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp2157 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp2158 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2159 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2160 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp2161 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration2162 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    var room2163 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByRoom/room" }) }) });
    this.before_row_edit = function(record) {
      owner_id2144.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type2143.on('change',Lino.chooser_handler(owner_id2144,'owner_type'));
      Lino.cal.EntriesByRoom.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(cal.EntriesByRoom.when_text) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user2130, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.EntriesByRoom.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "summary", "editable": true, "editor": summary2131, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.EntriesByRoom.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "event_type", "editable": true, "editor": event_type2132, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.EntriesByRoom.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id2133, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.EntriesByRoom.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByRoom.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByRoom.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date2136, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByRoom.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time2137, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByRoom.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date2138, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByRoom.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time2139, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByRoom.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByRoom.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 12, "dataIndex": "build_method", "editable": true, "editor": build_method2141, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 13, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to2142, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.EntriesByRoom.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_type", "editable": true, "editor": owner_type2143, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.EntriesByRoom.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_id", "editable": true, "editor": owner_id2144, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description2145, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class2146, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence2147, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByRoom.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type2148, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByRoom.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 21, "dataIndex": "priority", "editable": true, "editor": priority2150, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "state", "editable": true, "editor": state2151, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 23, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 24, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.EntriesByRoom.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 28, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.url) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 33, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByRoom.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 34, "dataIndex": "room", "editable": true, "editor": room2163, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.EntriesByRoom.room) ", "width": Lino.chars2width(21) } ];
    Lino.cal.EntriesByRoom.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByRoom.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EntriesByRoom.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/EntriesByRoom",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByRoom.detail;
    this.ls_insert_handler = Lino.cal.EntriesByRoom.insert;
    Lino.cal.EntriesByRoom.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByRoom.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.EntriesByRoom.insertPanel(p);
});
Lino.cal.EntriesByRoom.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EntriesByRoom.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/EntriesByRoom",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByRoom.detail;
    this.ls_insert_handler = Lino.cal.EntriesByRoom.insert;
    Lino.cal.EntriesByRoom.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByRoom.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.EntriesByRoom.detailPanel(p);
});
Lino.cal.EntriesByRoom.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.EntriesByRoom.GridPanel(p);
});
Lino.cal.EntriesByRoom.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByRoom.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByRoom", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class products.ProductsByCategory
Lino.products.ProductsByCategory.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 23,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/products/ProductsByCategory",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/products/ProductsByCategory','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/products/ProductsByCategory','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/products/ProductsByCategory','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/products/ProductsByCategory','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/products/ProductsByCategory','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Tarife",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "cat" }, 'catHidden', { "name": "vat_class" }, 'vat_classHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "delivery_unit" }, 'delivery_unitHidden', { "name": "number_of_events", "type": "int", "useNull": true }, { "name": "min_asset", "type": "int", "useNull": true }, { "name": "sales_account" }, 'sales_accountHidden', { "name": "sales_price" }, { "name": "purchases_account" }, 'purchases_accountHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 31,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.products.ProductsByCategory.detail;
    this.ls_insert_handler = Lino.products.ProductsByCategory.insert;
    var ww = this.containing_window;
    var id2004 = new Ext.form.NumberField({ "selectOnFocus": true });
    var name2005 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de2006 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr2007 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var cat2008 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarifkategorie ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/ProductsByCategory/cat" }) }) });
    var vat_class2009 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var description2010 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de2011 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr2012 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var delivery_unit2013 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.products.DeliveryUnit, "value": "20" });
    var number_of_events2014 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var min_asset2015 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true, "value": 1 });
    var sales_account2016 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/ProductsByCategory/sales_account" }) }) });
    var sales_price2017 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var purchases_account2018 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/ProductsByCategory/purchases_account" }) }) });
    var mobile_item_disp2019 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2020 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2021 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id2004, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(products.ProductsByCategory.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name2005, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(products.ProductsByCategory.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de2006, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(products.ProductsByCategory.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr2007, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(products.ProductsByCategory.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "cat", "editable": true, "editor": cat2008, "filter": { "type": "string" }, "header": "Kategorie", "renderer": Lino.fk_renderer('catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(products.ProductsByCategory.cat) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "vat_class", "editable": true, "editor": vat_class2009, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "sortable": false, "tooltip": "(products.ProductsByCategory.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "description", "editable": true, "editor": description2010, "filter": { "type": "string" }, "header": "Long description", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.description) ", "width": Lino.chars2width(61) }, { "colIndex": 7, "dataIndex": "description_de", "editable": true, "editor": description_de2011, "filter": { "type": "string" }, "header": "Long description (de)", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 8, "dataIndex": "description_fr", "editable": true, "editor": description_fr2012, "filter": { "type": "string" }, "header": "Long description (fr)", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 9, "dataIndex": "delivery_unit", "editable": true, "editor": delivery_unit2013, "filter": { "type": "string" }, "header": "Delivery unit", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.delivery_unit) ", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 10, "dataIndex": "number_of_events", "editable": true, "editor": number_of_events2014, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(products.ProductsByCategory.number_of_events) Anzahl Termine pro fakturierter Einheit.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 11, "dataIndex": "min_asset", "editable": true, "editor": min_asset2015, "filter": { "type": "numeric" }, "format": "0", "header": "Schwellenwert n\u00e4chste Rechnung", "hidden": true, "sortable": true, "tooltip": "(products.ProductsByCategory.min_asset) Die Mindestzahl vorgesehener Termine, um eine Rechnung zu erstellen.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "sales_account", "editable": true, "editor": sales_account2016, "filter": { "type": "string" }, "header": "Konto f\u00fcr Basisbetrag Verk\u00e4ufe", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.sales_account) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 13, "dataIndex": "sales_price", "editable": true, "editor": sales_price2017, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Verkaufspreis", "hidden": true, "sortable": true, "tooltip": "(products.ProductsByCategory.sales_price) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 14, "dataIndex": "purchases_account", "editable": true, "editor": purchases_account2018, "filter": { "type": "string" }, "header": "Basis Einkauf", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.purchases_account) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.products.ProductsByCategory.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.products.ProductsByCategory.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductsByCategory", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductsByCategory", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductsByCategory", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductsByCategory", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductsByCategory", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.products.ProductsByCategory.insertPanel = Ext.extend(Lino.products.Products.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/products/ProductsByCategory",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.products.ProductsByCategory.detail;
    this.ls_insert_handler = Lino.products.ProductsByCategory.insert;
    Lino.products.ProductsByCategory.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.products.ProductsByCategory.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.products.ProductsByCategory.insertPanel(p);
});
Lino.products.ProductsByCategory.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductsByCategory", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductsByCategory", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductsByCategory", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.products.ProductsByCategory.detailPanel = Ext.extend(Lino.products.Products.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/products/ProductsByCategory",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.products.ProductsByCategory.detail;
    this.ls_insert_handler = Lino.products.ProductsByCategory.insert;
    Lino.products.ProductsByCategory.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.products.ProductsByCategory.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.ProductsByCategory.detailPanel(p);
});
Lino.products.ProductsByCategory.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductsByCategory", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.ProductsByCategory.GridPanel(p);
});
Lino.products.ProductsByCategory.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/ProductsByCategory", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class rooms.BookingsByCompany
Lino.rooms.BookingsByCompany.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 38,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/rooms/BookingsByCompany",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/rooms/BookingsByCompany','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/rooms/BookingsByCompany','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/rooms/BookingsByCompany','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/rooms/BookingsByCompany','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/rooms/BookingsByCompany','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Buchungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "company" }, 'companyHidden', { "name": "room" }, 'roomHidden', { "name": "id", "type": "int" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "state" }, 'stateHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 32,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.rooms.BookingsByCompany.detail;
    this.ls_insert_handler = Lino.rooms.BookingsByCompany.insert;
    var ww = this.containing_window;
    var start_date2538 = new Lino.DateField({ "selectOnFocus": true });
    var company2539 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/BookingsByCompany/company" }) }) });
    var room2540 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/BookingsByCompany/room" }) }) });
    var id2541 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_time2542 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date2543 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time2544 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user2545 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/BookingsByCompany/user" }) }) });
    var contact_person2546 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/BookingsByCompany/contact_person" }) }) });
    var contact_role2547 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/BookingsByCompany/contact_role" }) }) });
    var every_unit2548 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every2549 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 1 });
    var monday2550 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday2551 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday2552 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday2553 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday2554 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday2555 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday2556 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events2557 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date2558 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var state2559 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.rooms.BookingStates });
    var event_type2560 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/BookingsByCompany/event_type" }) }) });
    var mobile_item_disp2561 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2562 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2563 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp2564 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp2565 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp2566 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration2567 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      contact_person2546.setContextValue('mk',bp['mk']);
      contact_person2546.setContextValue('mt',bp['mt']);
    };
    this.onRender = function(ct, position) {
      company2539.on('change',Lino.chooser_handler(contact_person2546,'company'));
      Lino.rooms.BookingsByCompany.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date2538, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(rooms.BookingsByCompany.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "company", "editable": true, "editor": company2539, "filter": { "type": "string" }, "header": "Veranstalter", "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(rooms.BookingsByCompany.company) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "room", "editable": true, "editor": room2540, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(rooms.BookingsByCompany.room) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id2541, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(rooms.BookingsByCompany.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "start_time", "editable": true, "editor": start_time2542, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(rooms.BookingsByCompany.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 5, "dataIndex": "end_date", "editable": true, "editor": end_date2543, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(rooms.BookingsByCompany.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "end_time", "editable": true, "editor": end_time2544, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(rooms.BookingsByCompany.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user2545, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(rooms.BookingsByCompany.user) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "contact_person", "editable": true, "editor": contact_person2546, "filter": { "type": "string" }, "header": "Kontaktperson", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(rooms.BookingsByCompany.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "contact_role", "editable": true, "editor": contact_role2547, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "every_unit", "editable": true, "editor": every_unit2548, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 11, "dataIndex": "every", "editable": true, "editor": every2549, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(rooms.BookingsByCompany.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "max_events", "editable": true, "editor": max_events2557, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(rooms.BookingsByCompany.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "max_date", "editable": true, "editor": max_date2558, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(rooms.BookingsByCompany.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 21, "dataIndex": "state", "editable": true, "editor": state2559, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 22, "dataIndex": "event_type", "editable": true, "editor": event_type2560, "filter": { "type": "string" }, "header": "Kalendereintragsart", "hidden": true, "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(rooms.BookingsByCompany.event_type) The Event Type to which events will be generated.", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 24, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 25, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 29, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingsByCompany.duration) ", "width": Lino.chars2width(8) } ];
    Lino.rooms.BookingsByCompany.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.rooms.BookingsByCompany.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingsByCompany.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingsByCompany.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingsByCompany.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingsByCompany.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.rooms.BookingsByCompany.insertPanel = Ext.extend(Lino.rooms.Bookings.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/rooms/BookingsByCompany",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.rooms.BookingsByCompany.detail;
    this.ls_insert_handler = Lino.rooms.BookingsByCompany.insert;
    Lino.rooms.BookingsByCompany.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.rooms.BookingsByCompany.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.rooms.BookingsByCompany.insertPanel(p);
});
Lino.rooms.BookingsByCompany.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingsByCompany.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingsByCompany.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.rooms.BookingsByCompany.detailPanel = Ext.extend(Lino.rooms.Bookings.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/rooms/BookingsByCompany",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.rooms.BookingsByCompany.detail;
    this.ls_insert_handler = Lino.rooms.BookingsByCompany.insert;
    Lino.rooms.BookingsByCompany.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.rooms.BookingsByCompany.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.rooms.BookingsByCompany.detailPanel(p);
});
Lino.rooms.BookingsByCompany.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingsByCompany.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingsByCompany.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.rooms.Bookings.ParamsPanel({});
  return new Lino.rooms.BookingsByCompany.GridPanel(p);
});
Lino.rooms.BookingsByCompany.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingsByCompany.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingsByCompany.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingsByCompany.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingsByCompany.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingsByCompany.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingsByCompany", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class accounts.AccountsByGroup
Lino.accounts.AccountsByGroup.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 23,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/accounts/AccountsByGroup",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountsByGroup','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountsByGroup','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountsByGroup','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountsByGroup','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountsByGroup','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Konten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "sales_allowed", "type": "boolean" }, { "name": "purchases_allowed", "type": "boolean" }, { "name": "wages_allowed", "type": "boolean" }, { "name": "taxes_allowed", "type": "boolean" }, { "name": "clearings_allowed", "type": "boolean" }, { "name": "vat_column" }, { "name": "type" }, 'typeHidden', { "name": "needs_partner", "type": "boolean" }, { "name": "clearable", "type": "boolean" }, { "name": "default_amount" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "move_buttons" }, { "name": "group" }, 'groupHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 33,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.accounts.AccountsByGroup.detail;
    this.ls_insert_handler = Lino.accounts.AccountsByGroup.insert;
    var ww = this.containing_window;
    var ref2261 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name2262 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de2263 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr2264 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id2265 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var seqno2266 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var sales_allowed2267 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var purchases_allowed2268 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wages_allowed2269 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var taxes_allowed2270 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var clearings_allowed2271 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var vat_column2272 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var type2273 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.accounts.AccountTypes });
    var needs_partner2274 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var clearable2275 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var default_amount2276 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var mobile_item_disp2277 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2278 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2279 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp2280 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var group2281 = new Lino.RemoteComboFieldElement({ "emptyText": "Kontengruppe ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/accounts/AccountsByGroup/group" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref2261, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(accounts.AccountsByGroup.ref) An optional unique name which can be used to reference a given\naccount.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name2262, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(accounts.AccountsByGroup.name) The multilingual designation of this account, as the users see\nit.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de2263, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(accounts.AccountsByGroup.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr2264, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(accounts.AccountsByGroup.name_fr) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id2265, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(accounts.AccountsByGroup.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "seqno", "editable": true, "editor": seqno2266, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(accounts.AccountsByGroup.seqno) The sequence number of this account within its group.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "sales_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "Verkauf", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.sales_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 7, "dataIndex": "purchases_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "Einkauf", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.purchases_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 8, "dataIndex": "wages_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "L\u00f6hne und Geh\u00e4lter", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.wages_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 9, "dataIndex": "taxes_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "Taxes", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.taxes_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 10, "dataIndex": "clearings_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "Begleichungen", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.clearings_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 11, "dataIndex": "vat_column", "editable": true, "editor": vat_column2272, "filter": { "type": "string" }, "header": "VAT column", "hidden": true, "sortable": true, "tooltip": "(accounts.AccountsByGroup.vat_column) ", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "type", "editable": true, "editor": type2273, "filter": { "type": "string" }, "header": "Kontenart", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.type) The account type of this account.  This points to an item of\nAccountTypes.", "width": Lino.chars2width(17) }, { "colIndex": 13, "dataIndex": "needs_partner", "editable": true, "filter": { "type": "boolean" }, "header": "Braucht Partner", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.needs_partner) Whether bookings to this account need a partner specified.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "clearable", "editable": true, "filter": { "type": "boolean" }, "header": "Auszugleichen", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.clearable) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 15, "dataIndex": "default_amount", "editable": true, "editor": default_amount2276, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Vorschlag Betrag", "hidden": true, "sortable": true, "tooltip": "(accounts.AccountsByGroup.default_amount) The default amount to book in bank statements or journal\nentries when this account has been selected manually. The\ndefault booking direction is that of the type.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 16, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 20, "dataIndex": "group", "editable": true, "editor": group2281, "filter": { "type": "string" }, "header": "Kontengruppe", "hidden": true, "renderer": Lino.fk_renderer('groupHidden','Lino.accounts.Groups.detail'), "sortable": false, "tooltip": "(accounts.AccountsByGroup.group) The account group to which this account belongs.  Points to\nan instance of Group.  If this field is empty, the\naccount won't appear in certain reports.", "width": Lino.chars2width(21) } ];
    Lino.accounts.AccountsByGroup.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.AccountsByGroup.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.accounts.AccountsByGroup.insertPanel = Ext.extend(Lino.accounts.Accounts.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/accounts/AccountsByGroup",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.accounts.AccountsByGroup.detail;
    this.ls_insert_handler = Lino.accounts.AccountsByGroup.insert;
    Lino.accounts.AccountsByGroup.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.AccountsByGroup.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.accounts.AccountsByGroup.insertPanel(p);
});
Lino.accounts.AccountsByGroup.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.accounts.AccountsByGroup.detailPanel = Ext.extend(Lino.accounts.Accounts.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/accounts/AccountsByGroup",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.accounts.AccountsByGroup.detail;
    this.ls_insert_handler = Lino.accounts.AccountsByGroup.insert;
    Lino.accounts.AccountsByGroup.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.AccountsByGroup.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.accounts.AccountsByGroup.detailPanel(p);
});
Lino.accounts.AccountsByGroup.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.accounts.AccountsByGroup.GridPanel(p);
});
Lino.accounts.AccountsByGroup.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountsByGroup", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.PartnersByInvoiceRecipient
Lino.sales.PartnersByInvoiceRecipient.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 40,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/PartnersByInvoiceRecipient",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/PartnersByInvoiceRecipient','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/PartnersByInvoiceRecipient','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/PartnersByInvoiceRecipient','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/sales/PartnersByInvoiceRecipient','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/PartnersByInvoiceRecipient','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/PartnersByInvoiceRecipient','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" } ],
  cell_edit : true,
  title : "Rechnungssender",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name" }, { "name": "id", "type": "int" }, { "name": "address_column" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "prefix" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_id" }, { "name": "paper_type" }, 'paper_typeHidden', { "name": "debit_balance" }, { "name": "name_column" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "mti_navigator" }, { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 1,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.PartnersByInvoiceRecipient.detail;
    this.ls_insert_handler = Lino.sales.PartnersByInvoiceRecipient.insert;
    var ww = this.containing_window;
    var name5952 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var id5953 = new Ext.form.NumberField({ "selectOnFocus": true });
    var address_column_disp5954 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var email5955 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language5956 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var url5957 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone5958 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm5959 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax5960 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country5961 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PartnersByInvoiceRecipient/country" }) }) });
    var city5962 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PartnersByInvoiceRecipient/city" }) }) });
    var zip_code5963 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region5964 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PartnersByInvoiceRecipient/region" }) }) });
    var addr15965 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix5966 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street5967 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no5968 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box5969 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr25970 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var prefix5971 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks5972 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term5973 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PartnersByInvoiceRecipient/payment_term" }) }) });
    var vat_regime5974 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_id5975 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var paper_type5976 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PartnersByInvoiceRecipient/paper_type" }) }) });
    var debit_balance5977 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var name_column_disp5978 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp5979 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5980 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5981 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp5982 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoice_recipient5983 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PartnersByInvoiceRecipient/invoice_recipient" }) }) });
    this.before_row_edit = function(record) {
      city5962.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city5962.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region5964.setContextValue('country', record ? record.data['countryHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      country5961.on('change',Lino.chooser_handler(city5962,'country'));
      region5964.on('change',Lino.chooser_handler(city5962,'region'));
      country5961.on('change',Lino.chooser_handler(region5964,'country'));
      Lino.sales.PartnersByInvoiceRecipient.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name5952, "filter": { "type": "string" }, "header": "Name", "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 1, "dataIndex": "id", "editable": true, "editor": id5953, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "address_column", "editable": false, "header": "Adresse", "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "email", "editable": true, "editor": email5955, "filter": { "type": "string" }, "header": "E-Mail-Adresse", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "language", "editable": true, "editor": language5956, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "url", "editable": true, "editor": url5957, "filter": { "type": "string" }, "header": "Adresse (URL)", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.url) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "phone", "editable": true, "editor": phone5958, "filter": { "type": "string" }, "header": "Telefon", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "gsm", "editable": true, "editor": gsm5959, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "fax", "editable": true, "editor": fax5960, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "country", "editable": true, "editor": country5961, "filter": { "type": "string" }, "header": "Land", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.country) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "city", "editable": true, "editor": city5962, "filter": { "type": "string" }, "header": "Locality", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.city) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "zip_code", "editable": true, "editor": zip_code5963, "filter": { "type": "string" }, "header": "Postleitzahl", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "region", "editable": true, "editor": region5964, "filter": { "type": "string" }, "header": "Regierungsbezirk", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.region) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "addr1", "editable": true, "editor": addr15965, "filter": { "type": "string" }, "header": "Adresszeile vor Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.addr1) ", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix5966, "filter": { "type": "string" }, "header": "Pr\u00e4fix Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.street_prefix) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "street", "editable": true, "editor": street5967, "filter": { "type": "string" }, "header": "Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.street) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "street_no", "editable": true, "editor": street_no5968, "filter": { "type": "string" }, "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.street_no) ", "width": Lino.chars2width(12) }, { "colIndex": 17, "dataIndex": "street_box", "editable": true, "editor": street_box5969, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.street_box) ", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "addr2", "editable": true, "editor": addr25970, "filter": { "type": "string" }, "header": "Adresszeile nach Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.addr2) ", "width": Lino.chars2width(22) }, { "colIndex": 19, "dataIndex": "prefix", "editable": true, "editor": prefix5971, "filter": { "type": "string" }, "header": "Name prefix", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.prefix) An optional name prefix. For organisations this is inserted\nbefore the name, for persons this is inserted between first\nname and last name (see\nlino.mixins.human.Human.get_last_name_prefix()).", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "remarks", "editable": true, "editor": remarks5972, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 21, "dataIndex": "payment_term", "editable": true, "editor": payment_term5973, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5974, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 23, "dataIndex": "vat_id", "editable": true, "editor": vat_id5975, "filter": { "type": "string" }, "header": "MwSt.-Nr.", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 24, "dataIndex": "paper_type", "editable": true, "editor": paper_type5976, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 25, "dataIndex": "debit_balance", "editable": false, "format": "0.000,00/i", "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.debit_balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 26, "dataIndex": "name_column", "editable": false, "header": "Name", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "mti_navigator", "editable": false, "header": "Ansicht als ", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.mti_navigator) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient5983, "filter": { "type": "string" }, "header": "Fakturationsadresse", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) } ];
    Lino.sales.PartnersByInvoiceRecipient.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.PartnersByInvoiceRecipient.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.PartnersByInvoiceRecipient.insertPanel = Ext.extend(Lino.contacts.Partners.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/sales/PartnersByInvoiceRecipient",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.PartnersByInvoiceRecipient.detail;
    this.ls_insert_handler = Lino.sales.PartnersByInvoiceRecipient.insert;
    Lino.sales.PartnersByInvoiceRecipient.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.PartnersByInvoiceRecipient.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.PartnersByInvoiceRecipient.insertPanel(p);
});
Lino.sales.PartnersByInvoiceRecipient.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.PartnersByInvoiceRecipient.detailPanel = Ext.extend(Lino.contacts.Partners.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" } ],
  ls_url: "/sales/PartnersByInvoiceRecipient",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.PartnersByInvoiceRecipient.detail;
    this.ls_insert_handler = Lino.sales.PartnersByInvoiceRecipient.insert;
    Lino.sales.PartnersByInvoiceRecipient.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.PartnersByInvoiceRecipient.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.PartnersByInvoiceRecipient.detailPanel(p);
});
Lino.sales.PartnersByInvoiceRecipient.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.create_excerpt1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.show_invoice_partners = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(15), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.sales.PartnersByInvoiceRecipient.GridPanel(p);
});
Lino.sales.PartnersByInvoiceRecipient.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.ins_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.ins_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.del_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.del_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.del_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.ins_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.del_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.del_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.ins_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.ins_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PartnersByInvoiceRecipient", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.InvoicesByJournal
Lino.sales.InvoicesByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 40,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/InvoicesByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this journal." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Produktrechnungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "total_incl" }, { "name": "subject" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "your_ref" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "language" }, 'languageHidden', { "name": "intro" }, { "name": "paper_type" }, 'paper_typeHidden', { "name": "balance_before" }, { "name": "balance_to_pay" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "journal" }, 'journalHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoicesByJournal.detail;
    this.ls_insert_handler = Lino.sales.InvoicesByJournal.insert;
    var ww = this.containing_window;
    var number_with_year_disp4143 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var entry_date4144 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var due_date4145 = new Lino.DateField({ "selectOnFocus": true });
    var partner4146 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/partner" }) }) });
    var total_incl4147 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var subject4148 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp4149 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4150 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user4151 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/user" }) }) });
    var voucher_date4152 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period4153 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/accounting_period" }) }) });
    var number4154 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var narration4155 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state4156 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by4157 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var payment_term4158 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/payment_term" }) }) });
    var match4159 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/match" }) }) });
    var your_ref4160 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var total_base4161 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat4162 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_regime4163 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var language4164 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var intro4165 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var paper_type4166 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/paper_type" }) }) });
    var balance_before4167 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var balance_to_pay4168 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var mobile_item_disp4169 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4170 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp4171 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal4172 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      match4159.setContextValue('mk',bp['mk']);
      match4159.setContextValue('mt',bp['mt']);
      match4159.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      journal4172.on('change',Lino.chooser_handler(match4159,'journal'));
      partner4146.on('change',Lino.chooser_handler(match4159,'partner'));
      Lino.sales.InvoicesByJournal.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "sortable": false, "tooltip": "(sales.InvoicesByJournal.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date4144, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(sales.InvoicesByJournal.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "due_date", "editable": true, "editor": due_date4145, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": true, "tooltip": "(sales.InvoicesByJournal.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "partner", "editable": true, "editor": partner4146, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sales.InvoicesByJournal.partner) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "total_incl", "editable": true, "editor": total_incl4147, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(sales.InvoicesByJournal.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "subject", "editable": true, "editor": subject4148, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(sales.InvoicesByJournal.subject) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(sales.InvoicesByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id4150, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user4151, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(sales.InvoicesByJournal.user) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4152, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4153, "filter": { "type": "string" }, "header": "Buchungsperiode", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 11, "dataIndex": "number", "editable": true, "editor": number4154, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "narration", "editable": true, "editor": narration4155, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 13, "dataIndex": "state", "editable": true, "editor": state4156, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 14, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(sales.InvoicesByJournal.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "payment_term", "editable": true, "editor": payment_term4158, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(sales.InvoicesByJournal.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "match", "editable": true, "editor": match4159, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 17, "dataIndex": "your_ref", "editable": true, "editor": your_ref4160, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.your_ref) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 18, "dataIndex": "total_base", "editable": true, "editor": total_base4161, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "total_vat", "editable": true, "editor": total_vat4162, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime4163, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 21, "dataIndex": "language", "editable": true, "editor": language4164, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.language) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "intro", "editable": true, "editor": intro4165, "filter": { "type": "string" }, "header": "Introductive Text", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.intro) ", "width": Lino.chars2width(61) }, { "colIndex": 23, "dataIndex": "paper_type", "editable": true, "editor": paper_type4166, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 24, "dataIndex": "balance_before", "editable": false, "format": "0.000,00/i", "header": "Saldo vorher", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.balance_before) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 25, "dataIndex": "balance_to_pay", "editable": false, "format": "0.000,00/i", "header": "Saldo zu zahlen", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.balance_to_pay) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 26, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "journal", "editable": true, "editor": journal4172, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(sales.InvoicesByJournal.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) } ];
    Lino.sales.InvoicesByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoicesByJournal.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.InvoicesByJournal.insertPanel = Ext.extend(Lino.sales.Invoices.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/sales/InvoicesByJournal",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoicesByJournal.detail;
    this.ls_insert_handler = Lino.sales.InvoicesByJournal.insert;
    Lino.sales.InvoicesByJournal.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoicesByJournal.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.InvoicesByJournal.insertPanel(p);
});
Lino.sales.InvoicesByJournal.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.InvoicesByJournal.detailPanel = Ext.extend(Lino.sales.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this journal." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/sales/InvoicesByJournal",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoicesByJournal.detail;
    this.ls_insert_handler = Lino.sales.InvoicesByJournal.insert;
    Lino.sales.InvoicesByJournal.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoicesByJournal.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.InvoicesByJournal.detailPanel(p);
});
Lino.sales.InvoicesByJournal.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.sales.InvoicesByJournal.ParamsPanel({});
  return new Lino.sales.InvoicesByJournal.GridPanel(p);
});
Lino.sales.InvoicesByJournal.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByJournal", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.PrintableInvoicesByJournal
Lino.sales.PrintableInvoicesByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/sales/PrintableInvoicesByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/PrintableInvoicesByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/PrintableInvoicesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/PrintableInvoicesByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/PrintableInvoicesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/PrintableInvoicesByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Sales invoice journal",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "number", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "total_base" }, { "name": "total_vat" }, { "name": "total_incl" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "your_ref" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "language" }, 'languageHidden', { "name": "subject" }, { "name": "intro" }, { "name": "paper_type" }, 'paper_typeHidden', { "name": "balance_before" }, { "name": "balance_to_pay" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "printed" }, { "name": "number_with_year" }, { "name": "journal" }, 'journalHidden' ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.PrintableInvoicesByJournal.detail;
    this.ls_insert_handler = Lino.sales.Invoices.insert;
    var ww = this.containing_window;
    var number5985 = new Ext.form.NumberField({ "selectOnFocus": true });
    var entry_date5986 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var partner5987 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PrintableInvoicesByJournal/partner" }) }) });
    var total_base5988 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat5989 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_incl5990 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var vat_regime5991 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var id5992 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user5993 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PrintableInvoicesByJournal/user" }) }) });
    var voucher_date5994 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period5995 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PrintableInvoicesByJournal/accounting_period" }) }) });
    var narration5996 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state5997 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by5998 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var payment_term5999 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PrintableInvoicesByJournal/payment_term" }) }) });
    var match6000 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PrintableInvoicesByJournal/match" }) }) });
    var your_ref6001 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var due_date6002 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var language6003 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var subject6004 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var intro6005 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var paper_type6006 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PrintableInvoicesByJournal/paper_type" }) }) });
    var balance_before6007 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var balance_to_pay6008 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var mobile_item_disp6009 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6010 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6011 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp6012 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var number_with_year_disp6013 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal6014 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PrintableInvoicesByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      journal6014.on('change',Lino.chooser_handler(match6000,'journal'));
      partner5987.on('change',Lino.chooser_handler(match6000,'partner'));
      Lino.sales.PrintableInvoicesByJournal.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "number", "editable": true, "editor": number5985, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(sales.PrintableInvoicesByJournal.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date5986, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(sales.PrintableInvoicesByJournal.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "partner", "editable": true, "editor": partner5987, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.partner) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "total_base", "editable": true, "editor": total_base5988, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "sortable": true, "tooltip": "(sales.PrintableInvoicesByJournal.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "total_vat", "editable": true, "editor": total_vat5989, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "sortable": true, "tooltip": "(sales.PrintableInvoicesByJournal.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "total_incl", "editable": true, "editor": total_incl5990, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(sales.PrintableInvoicesByJournal.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5991, "filter": { "type": "string" }, "header": "MwSt.-Regime", "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.vat_regime) ", "width": Lino.chars2width(19) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id5992, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sales.PrintableInvoicesByJournal.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user5993, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.user) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date5994, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(sales.PrintableInvoicesByJournal.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period5995, "filter": { "type": "string" }, "header": "Buchungsperiode", "hidden": true, "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "narration", "editable": true, "editor": narration5996, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(sales.PrintableInvoicesByJournal.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "state", "editable": true, "editor": state5997, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 13, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "payment_term", "editable": true, "editor": payment_term5999, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "match", "editable": true, "editor": match6000, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "your_ref", "editable": true, "editor": your_ref6001, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(sales.PrintableInvoicesByJournal.your_ref) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "due_date", "editable": true, "editor": due_date6002, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Zahlungsziel", "hidden": true, "sortable": true, "tooltip": "(sales.PrintableInvoicesByJournal.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 18, "dataIndex": "language", "editable": true, "editor": language6003, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.language) ", "width": Lino.chars2width(21) }, { "colIndex": 19, "dataIndex": "subject", "editable": true, "editor": subject6004, "filter": { "type": "string" }, "header": "Betreff", "hidden": true, "sortable": true, "tooltip": "(sales.PrintableInvoicesByJournal.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "intro", "editable": true, "editor": intro6005, "filter": { "type": "string" }, "header": "Introductive Text", "hidden": true, "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.intro) ", "width": Lino.chars2width(61) }, { "colIndex": 21, "dataIndex": "paper_type", "editable": true, "editor": paper_type6006, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 22, "dataIndex": "balance_before", "editable": false, "format": "0.000,00/i", "header": "Saldo vorher", "hidden": true, "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.balance_before) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 23, "dataIndex": "balance_to_pay", "editable": false, "format": "0.000,00/i", "header": "Saldo zu zahlen", "hidden": true, "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.balance_to_pay) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 24, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 25, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "hidden": true, "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 29, "dataIndex": "journal", "editable": true, "editor": journal6014, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(sales.PrintableInvoicesByJournal.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) } ];
    Lino.sales.PrintableInvoicesByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.PrintableInvoicesByJournal.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PrintableInvoicesByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PrintableInvoicesByJournal.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PrintableInvoicesByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PrintableInvoicesByJournal.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PrintableInvoicesByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PrintableInvoicesByJournal.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PrintableInvoicesByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PrintableInvoicesByJournal.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PrintableInvoicesByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PrintableInvoicesByJournal.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PrintableInvoicesByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.PrintableInvoicesByJournal.detailPanel = Ext.extend(Lino.sales.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/sales/PrintableInvoicesByJournal",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.PrintableInvoicesByJournal.detail;
    this.ls_insert_handler = Lino.sales.Invoices.insert;
    Lino.sales.PrintableInvoicesByJournal.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.PrintableInvoicesByJournal.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.PrintableInvoicesByJournal.detailPanel(p);
});
Lino.sales.PrintableInvoicesByJournal.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PrintableInvoicesByJournal", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PrintableInvoicesByJournal.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PrintableInvoicesByJournal", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PrintableInvoicesByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.sales.PrintableInvoicesByJournal.ParamsPanel({});
  return new Lino.sales.PrintableInvoicesByJournal.GridPanel(p);
});
Lino.sales.PrintableInvoicesByJournal.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PrintableInvoicesByJournal", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PrintableInvoicesByJournal.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PrintableInvoicesByJournal", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PrintableInvoicesByJournal.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PrintableInvoicesByJournal", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PrintableInvoicesByJournal.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PrintableInvoicesByJournal", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PrintableInvoicesByJournal.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/PrintableInvoicesByJournal", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.ItemsByInvoice
Lino.sales.ItemsByInvoice.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 25,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/ItemsByInvoice",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoice','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoice','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoice','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoice','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoice','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Inhalt",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "product" }, 'productHidden', { "name": "title" }, { "name": "discount" }, { "name": "unit_price" }, { "name": "qty" }, { "name": "total_incl" }, { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_class" }, 'vat_classHidden', { "name": "description" }, { "name": "invoiceable_type" }, 'invoiceable_typeHidden', { "name": "invoiceable_id" }, 'invoiceable_idHidden', { "name": "invoiceable" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "move_buttons" }, { "name": "voucher" }, 'voucherHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 44,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoice.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoice.insert;
    var ww = this.containing_window;
    var product1588 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/ItemsByInvoice/product" }) }) });
    var title1589 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var discount1590 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var unit_price1591 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var qty1592 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "maxLength": 6, "selectOnFocus": true });
    var total_incl1593 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var id1594 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var seqno1595 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var total_base1596 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat1597 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_class1598 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var description1599 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var invoiceable_type1600 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/ItemsByInvoice/invoiceable_type" }) }) });
    var invoiceable_id1601 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/ItemsByInvoice/invoiceable_id" }) }) });
    var invoiceable_disp1602 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp1603 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1604 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1605 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp1606 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var voucher1607 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Produktrechnung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/ItemsByInvoice/voucher" }) }) });
    this.before_row_edit = function(record) {
      invoiceable_id1601.setContextValue('invoiceable_type', record ? record.data['invoiceable_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      invoiceable_type1600.on('change',Lino.chooser_handler(invoiceable_id1601,'invoiceable_type'));
      Lino.sales.ItemsByInvoice.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "product", "editable": true, "editor": product1588, "filter": { "type": "string" }, "header": "Tarif", "renderer": Lino.fk_renderer('productHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(sales.ItemsByInvoice.product) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "title", "editable": true, "editor": title1589, "filter": { "type": "string" }, "header": "\u00dcberschrift", "sortable": true, "tooltip": "(sales.ItemsByInvoice.title) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 2, "dataIndex": "discount", "editable": true, "editor": discount1590, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Erm\u00e4\u00dfigung", "sortable": true, "tooltip": "(sales.ItemsByInvoice.discount) ", "width": Lino.chars2width(8), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 3, "dataIndex": "unit_price", "editable": true, "editor": unit_price1591, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "St\u00fcckpreis", "sortable": true, "tooltip": "(sales.ItemsByInvoice.unit_price) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "qty", "editable": true, "editor": qty1592, "filter": { "type": "string" }, "format": "", "header": "Menge", "sortable": true, "tooltip": "(sales.ItemsByInvoice.qty) ", "width": Lino.chars2width(8) }, { "align": "right", "colIndex": 5, "dataIndex": "total_incl", "editable": true, "editor": total_incl1593, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(sales.ItemsByInvoice.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id1594, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sales.ItemsByInvoice.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "seqno", "editable": true, "editor": seqno1595, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(sales.ItemsByInvoice.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "total_base", "editable": true, "editor": total_base1596, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "hidden": true, "sortable": true, "tooltip": "(sales.ItemsByInvoice.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 9, "dataIndex": "total_vat", "editable": true, "editor": total_vat1597, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "hidden": true, "sortable": true, "tooltip": "(sales.ItemsByInvoice.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 10, "dataIndex": "vat_class", "editable": true, "editor": vat_class1598, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 11, "dataIndex": "description", "editable": true, "editor": description1599, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.description) A multi-line rich text to be printed in the resulting printable\ndocument.", "width": Lino.chars2width(61) }, { "colIndex": 12, "dataIndex": "invoiceable_type", "editable": true, "editor": invoiceable_type1600, "filter": { "type": "string" }, "header": "Fakturiertes Objekt (Modell)", "hidden": true, "renderer": Lino.fk_renderer('invoiceable_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(sales.ItemsByInvoice.invoiceable_type) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "invoiceable_id", "editable": true, "editor": invoiceable_id1601, "filter": { "type": "string" }, "header": "Fakturiertes Objekt (Objekt)", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.invoiceable_id) ", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "invoiceable", "editable": false, "header": "Fakturiertes Objekt", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.invoiceable) ", "width": Lino.chars2width(11) }, { "colIndex": 15, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 19, "dataIndex": "voucher", "editable": true, "editor": voucher1607, "filter": { "type": "string" }, "header": "Produktrechnung", "hidden": true, "renderer": Lino.fk_renderer('voucherHidden','Lino.sales.Invoices.detail'), "sortable": false, "tooltip": "(sales.ItemsByInvoice.voucher) ", "width": Lino.chars2width(21) } ];
    Lino.sales.ItemsByInvoice.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoice.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoice", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoice", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoice", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoice", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoice", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.ItemsByInvoice.insertPanel = Ext.extend(Lino.sales.InvoiceItems.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/sales/ItemsByInvoice",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoice.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoice.insert;
    Lino.sales.ItemsByInvoice.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoice.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.ItemsByInvoice.insertPanel(p);
});
Lino.sales.ItemsByInvoice.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoice", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoice", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoice", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoice", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.ItemsByInvoice.detailPanel = Ext.extend(Lino.sales.InvoiceItems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/sales/ItemsByInvoice",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoice.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoice.insert;
    Lino.sales.ItemsByInvoice.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoice.detail = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.ItemsByInvoice.detailPanel(p);
});
Lino.sales.ItemsByInvoice.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoice", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.ItemsByInvoice.GridPanel(p);
});
Lino.sales.ItemsByInvoice.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoice", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoice", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoice", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.ItemsByInvoicePrint
Lino.sales.ItemsByInvoicePrint.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 5,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/ItemsByInvoicePrint",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrint','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrint','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrint','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrint','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrint','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Inhalt",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "description_print" }, { "name": "unit_price" }, { "name": "qty" }, { "name": "total_incl" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 44,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoicePrint.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoicePrint.insert;
    var ww = this.containing_window;
    var description_print_disp6016 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var unit_price6017 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var qty6018 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "maxLength": 6, "selectOnFocus": true });
    var total_incl6019 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "description_print", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(sales.ItemsByInvoicePrint.description_print) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "unit_price", "editable": true, "editor": unit_price6017, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "St\u00fcckpreis", "sortable": true, "tooltip": "(sales.ItemsByInvoicePrint.unit_price) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "qty", "editable": true, "editor": qty6018, "filter": { "type": "string" }, "format": "", "header": "Menge", "sortable": true, "tooltip": "(sales.ItemsByInvoicePrint.qty) ", "width": Lino.chars2width(8) }, { "align": "right", "colIndex": 3, "dataIndex": "total_incl", "editable": true, "editor": total_incl6019, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(sales.ItemsByInvoicePrint.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.sales.ItemsByInvoicePrint.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoicePrint.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrint", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrint", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrint", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrint", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrint", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.ItemsByInvoicePrint.insertPanel = Ext.extend(Lino.sales.InvoiceItems.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/sales/ItemsByInvoicePrint",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoicePrint.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoicePrint.insert;
    Lino.sales.ItemsByInvoicePrint.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoicePrint.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.ItemsByInvoicePrint.insertPanel(p);
});
Lino.sales.ItemsByInvoicePrint.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrint", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrint", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrint", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrint", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.ItemsByInvoicePrint.detailPanel = Ext.extend(Lino.sales.InvoiceItems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/sales/ItemsByInvoicePrint",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoicePrint.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoicePrint.insert;
    Lino.sales.ItemsByInvoicePrint.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoicePrint.detail = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.ItemsByInvoicePrint.detailPanel(p);
});
Lino.sales.ItemsByInvoicePrint.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrint", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.ItemsByInvoicePrint.GridPanel(p);
});
Lino.sales.ItemsByInvoicePrint.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrint", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrint", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrint", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.ItemsByInvoicePrintNoQtyColumn
Lino.sales.ItemsByInvoicePrintNoQtyColumn.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 3,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/ItemsByInvoicePrintNoQtyColumn",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrintNoQtyColumn','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrintNoQtyColumn','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrintNoQtyColumn','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrintNoQtyColumn','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrintNoQtyColumn','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Inhalt",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "description_print" }, { "name": "total_incl" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 44,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoicePrintNoQtyColumn.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoicePrintNoQtyColumn.insert;
    var ww = this.containing_window;
    var description_print_disp6021 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var total_incl6022 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "description_print", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(sales.ItemsByInvoicePrintNoQtyColumn.description_print) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "total_incl", "editable": true, "editor": total_incl6022, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(sales.ItemsByInvoicePrintNoQtyColumn.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.sales.ItemsByInvoicePrintNoQtyColumn.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoicePrintNoQtyColumn.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.ItemsByInvoicePrintNoQtyColumn.insertPanel = Ext.extend(Lino.sales.InvoiceItems.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/sales/ItemsByInvoicePrintNoQtyColumn",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoicePrintNoQtyColumn.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoicePrintNoQtyColumn.insert;
    Lino.sales.ItemsByInvoicePrintNoQtyColumn.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoicePrintNoQtyColumn.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.ItemsByInvoicePrintNoQtyColumn.insertPanel(p);
});
Lino.sales.ItemsByInvoicePrintNoQtyColumn.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.ItemsByInvoicePrintNoQtyColumn.detailPanel = Ext.extend(Lino.sales.InvoiceItems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/sales/ItemsByInvoicePrintNoQtyColumn",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoicePrintNoQtyColumn.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoicePrintNoQtyColumn.insert;
    Lino.sales.ItemsByInvoicePrintNoQtyColumn.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoicePrintNoQtyColumn.detail = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.ItemsByInvoicePrintNoQtyColumn.detailPanel(p);
});
Lino.sales.ItemsByInvoicePrintNoQtyColumn.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.ItemsByInvoicePrintNoQtyColumn.GridPanel(p);
});
Lino.sales.ItemsByInvoicePrintNoQtyColumn.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.InvoiceItemsByProduct
Lino.sales.InvoiceItemsByProduct.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/sales/InvoiceItemsByProduct",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/InvoiceItemsByProduct','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoiceItemsByProduct','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoiceItemsByProduct','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoiceItemsByProduct','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/InvoiceItemsByProduct','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Produktrechnungszeilen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "voucher" }, 'voucherHidden', { "name": "voucher__partner" }, 'voucher__partnerHidden', { "name": "qty" }, { "name": "title" }, { "name": "description" }, { "name": "discount" }, { "name": "unit_price" }, { "name": "total_incl" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "id", "type": "int" } ],
  pk_index : 12,
  ls_grid_configs : [  ],
  content_type : 44,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoiceItemsByProduct.detail;
    this.ls_insert_handler = Lino.sales.InvoiceItems.insert;
    var ww = this.containing_window;
    var voucher11138 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Produktrechnung ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoiceItemsByProduct/voucher" }) }) });
    var voucher__partner11139 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "sortable": false, "store": new Lino.ComplexRemoteComboStore({  }) });
    var qty11140 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "maxLength": 6, "selectOnFocus": true });
    var title11141 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var description11142 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var discount11143 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var unit_price11144 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_incl11145 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_base11146 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat11147 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "voucher", "editable": true, "editor": voucher11138, "filter": { "type": "string" }, "header": "Produktrechnung", "renderer": Lino.fk_renderer('voucherHidden','Lino.sales.Invoices.detail'), "sortable": false, "tooltip": "(sales.InvoiceItemsByProduct.voucher) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "voucher__partner", "editable": false, "filter": { "type": "string" }, "header": "Partner", "sortable": false, "tooltip": "(sales.InvoiceItemsByProduct.voucher__partner) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "qty", "editable": true, "editor": qty11140, "filter": { "type": "string" }, "format": "", "header": "Menge", "sortable": true, "tooltip": "(sales.InvoiceItemsByProduct.qty) ", "width": Lino.chars2width(8) }, { "colIndex": 3, "dataIndex": "title", "editable": true, "editor": title11141, "filter": { "type": "string" }, "header": "\u00dcberschrift", "sortable": true, "tooltip": "(sales.InvoiceItemsByProduct.title) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "description", "editable": true, "editor": description11142, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": false, "tooltip": "(sales.InvoiceItemsByProduct.description) A multi-line rich text to be printed in the resulting printable\ndocument.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "discount", "editable": true, "editor": discount11143, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Erm\u00e4\u00dfigung", "sortable": true, "tooltip": "(sales.InvoiceItemsByProduct.discount) ", "width": Lino.chars2width(8), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "unit_price", "editable": true, "editor": unit_price11144, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "St\u00fcckpreis", "sortable": true, "tooltip": "(sales.InvoiceItemsByProduct.unit_price) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "total_incl", "editable": true, "editor": total_incl11145, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(sales.InvoiceItemsByProduct.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "total_base", "editable": true, "editor": total_base11146, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "sortable": true, "tooltip": "(sales.InvoiceItemsByProduct.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 9, "dataIndex": "total_vat", "editable": true, "editor": total_vat11147, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "sortable": true, "tooltip": "(sales.InvoiceItemsByProduct.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.sales.InvoiceItemsByProduct.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoiceItemsByProduct.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItemsByProduct", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItemsByProduct.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItemsByProduct", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItemsByProduct.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItemsByProduct", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItemsByProduct.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItemsByProduct", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItemsByProduct.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItemsByProduct", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItemsByProduct.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItemsByProduct", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItemsByProduct.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItemsByProduct", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.InvoiceItemsByProduct.detailPanel = Ext.extend(Lino.sales.InvoiceItems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/sales/InvoiceItemsByProduct",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoiceItemsByProduct.detail;
    this.ls_insert_handler = Lino.sales.InvoiceItems.insert;
    Lino.sales.InvoiceItemsByProduct.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoiceItemsByProduct.detail = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.InvoiceItemsByProduct.detailPanel(p);
});
Lino.sales.InvoiceItemsByProduct.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.InvoiceItemsByProduct.GridPanel(p);
});
Lino.sales.InvoiceItemsByProduct.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItemsByProduct", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoiceItemsByProduct.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoiceItemsByProduct", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.InvoicesByPartner
Lino.sales.InvoicesByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 41,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/InvoicesByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Produktrechnungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "journal__ref" }, { "name": "number", "type": "int", "useNull": true }, { "name": "total_incl" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "your_ref" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "language" }, 'languageHidden', { "name": "subject" }, { "name": "intro" }, { "name": "paper_type" }, 'paper_typeHidden', { "name": "balance_before" }, { "name": "balance_to_pay" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "number_with_year" }, { "name": "partner" }, 'partnerHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoicesByPartner.detail;
    this.ls_insert_handler = Lino.sales.InvoicesByPartner.insert;
    var ww = this.containing_window;
    var entry_date1522 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var journal__ref1523 = new Ext.form.TextField({ "disabled": true, "maxLength": 40, "sortable": false });
    var number1524 = new Ext.form.NumberField({ "selectOnFocus": true });
    var total_incl1525 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp1526 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id1527 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user1528 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/user" }) }) });
    var journal1529 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/journal" }) }) });
    var voucher_date1530 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period1531 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/accounting_period" }) }) });
    var narration1532 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state1533 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by1534 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var payment_term1535 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/payment_term" }) }) });
    var match1536 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/match" }) }) });
    var your_ref1537 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var due_date1538 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var total_base1539 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat1540 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_regime1541 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var language1542 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var subject1543 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var intro1544 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var paper_type1545 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/paper_type" }) }) });
    var balance_before1546 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var balance_to_pay1547 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var mobile_item_disp1548 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1549 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp1550 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var number_with_year_disp1551 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner1552 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/partner" }) }) });
    this.before_row_edit = function(record) {
      match1536.setContextValue('journal', record ? record.data['journalHidden'] : undefined);
      var bp = this.get_base_params();
      match1536.setContextValue('mk',bp['mk']);
      match1536.setContextValue('mt',bp['mt']);
    };
    this.onRender = function(ct, position) {
      journal1529.on('change',Lino.chooser_handler(match1536,'journal'));
      partner1552.on('change',Lino.chooser_handler(match1536,'partner'));
      Lino.sales.InvoicesByPartner.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "entry_date", "editable": true, "editor": entry_date1522, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(sales.InvoicesByPartner.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "journal__ref", "editable": false, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(sales.InvoicesByPartner.journal__ref) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 2, "dataIndex": "number", "editable": true, "editor": number1524, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(sales.InvoicesByPartner.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 3, "dataIndex": "total_incl", "editable": true, "editor": total_incl1525, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(sales.InvoicesByPartner.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(sales.InvoicesByPartner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id1527, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "user", "editable": true, "editor": user1528, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(sales.InvoicesByPartner.user) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "journal", "editable": true, "editor": journal1529, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(sales.InvoicesByPartner.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date1530, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period1531, "filter": { "type": "string" }, "header": "Buchungsperiode", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "narration", "editable": true, "editor": narration1532, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 11, "dataIndex": "state", "editable": true, "editor": state1533, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 12, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(sales.InvoicesByPartner.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "payment_term", "editable": true, "editor": payment_term1535, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(sales.InvoicesByPartner.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "match", "editable": true, "editor": match1536, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 15, "dataIndex": "your_ref", "editable": true, "editor": your_ref1537, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.your_ref) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "due_date", "editable": true, "editor": due_date1538, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Zahlungsziel", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 17, "dataIndex": "total_base", "editable": true, "editor": total_base1539, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 18, "dataIndex": "total_vat", "editable": true, "editor": total_vat1540, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 19, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime1541, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 20, "dataIndex": "language", "editable": true, "editor": language1542, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.language) ", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "subject", "editable": true, "editor": subject1543, "filter": { "type": "string" }, "header": "Betreff", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 22, "dataIndex": "intro", "editable": true, "editor": intro1544, "filter": { "type": "string" }, "header": "Introductive Text", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.intro) ", "width": Lino.chars2width(61) }, { "colIndex": 23, "dataIndex": "paper_type", "editable": true, "editor": paper_type1545, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 24, "dataIndex": "balance_before", "editable": false, "format": "0.000,00/i", "header": "Saldo vorher", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.balance_before) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 25, "dataIndex": "balance_to_pay", "editable": false, "format": "0.000,00/i", "header": "Saldo zu zahlen", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.balance_to_pay) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 26, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 30, "dataIndex": "partner", "editable": true, "editor": partner1552, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sales.InvoicesByPartner.partner) ", "width": Lino.chars2width(21) } ];
    Lino.sales.InvoicesByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoicesByPartner.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.InvoicesByPartner.insertPanel = Ext.extend(Lino.sales.Invoices.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/sales/InvoicesByPartner",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoicesByPartner.detail;
    this.ls_insert_handler = Lino.sales.InvoicesByPartner.insert;
    Lino.sales.InvoicesByPartner.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoicesByPartner.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.InvoicesByPartner.insertPanel(p);
});
Lino.sales.InvoicesByPartner.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.InvoicesByPartner.detailPanel = Ext.extend(Lino.sales.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/sales/InvoicesByPartner",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoicesByPartner.detail;
    this.ls_insert_handler = Lino.sales.InvoicesByPartner.insert;
    Lino.sales.InvoicesByPartner.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoicesByPartner.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.InvoicesByPartner.detailPanel(p);
});
Lino.sales.InvoicesByPartner.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.sales.Invoices.ParamsPanel({});
  return new Lino.sales.InvoicesByPartner.GridPanel(p);
});
Lino.sales.InvoicesByPartner.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sales/InvoicesByPartner", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class invoicing.ItemsByPlan
Lino.invoicing.ItemsByPlan.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 16,
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:22px" {attr}>{value}</div>',
'</td>'), "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/invoicing/ItemsByPlan",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/invoicing/ItemsByPlan','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/ItemsByPlan','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/ItemsByPlan','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/ItemsByPlan','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/invoicing/ItemsByPlan','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  page_length : 20,
  cell_edit : true,
  title : "Fakturationsvorschl\u00e4ge",
  row_height : 2,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "selected", "type": "boolean" }, { "name": "partner" }, 'partnerHidden', { "name": "preview" }, { "name": "amount" }, { "name": "invoice" }, 'invoiceHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "first_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "last_date", "type": "date" }, { "name": "number_of_invoiceables", "type": "int", "useNull": true }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "plan" }, 'planHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 47,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var selected3720 = new Ext.form.Checkbox({ "checked": true, "selectOnFocus": true });
    var partner3721 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/ItemsByPlan/partner" }) }) });
    var preview3722 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var amount3723 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var invoice3724 = new Lino.RemoteComboFieldElement({ "emptyText": "Produktrechnung ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/ItemsByPlan/invoice" }) }) });
    var workflow_buttons_disp3725 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id3726 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var first_date3727 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var last_date3728 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number_of_invoiceables3729 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var mobile_item_disp3730 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3731 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var plan3732 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Fakturationsplan ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/ItemsByPlan/plan" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "selected", "editable": true, "filter": { "type": "boolean" }, "header": "Selected", "sortable": false, "tooltip": "(invoicing.ItemsByPlan.selected) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner3721, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(invoicing.ItemsByPlan.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "preview", "editable": true, "editor": preview3722, "filter": { "type": "string" }, "header": "Vorschau", "sortable": false, "tooltip": "(invoicing.ItemsByPlan.preview) A textual preview of the invoiceable items to be included in\nthe invoice.", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 3, "dataIndex": "amount", "editable": true, "editor": amount3723, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "sortable": true, "tooltip": "(invoicing.ItemsByPlan.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "invoice", "editable": true, "editor": invoice3724, "filter": { "type": "string" }, "header": "Rechnung", "renderer": Lino.fk_renderer('invoiceHidden','Lino.sales.Invoices.detail'), "sortable": false, "tooltip": "(invoicing.ItemsByPlan.invoice) The invoice that has been generated. This field is empty for\nnew items. When an item has been executed, this field points\nto the generated invoice.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(invoicing.ItemsByPlan.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id3726, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(invoicing.ItemsByPlan.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "first_date", "editable": true, "editor": first_date3727, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Erstes Datum", "hidden": true, "sortable": true, "tooltip": "(invoicing.ItemsByPlan.first_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "last_date", "editable": true, "editor": last_date3728, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Letztes Datum", "hidden": true, "sortable": true, "tooltip": "(invoicing.ItemsByPlan.last_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 9, "dataIndex": "number_of_invoiceables", "editable": true, "editor": number_of_invoiceables3729, "filter": { "type": "numeric" }, "format": "0", "header": "Number", "hidden": true, "sortable": true, "tooltip": "(invoicing.ItemsByPlan.number_of_invoiceables) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(invoicing.ItemsByPlan.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(invoicing.ItemsByPlan.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "plan", "editable": true, "editor": plan3732, "filter": { "type": "string" }, "header": "Fakturationsplan", "hidden": true, "renderer": Lino.fk_renderer('planHidden','Lino.invoicing.Plans.detail'), "sortable": false, "tooltip": "(invoicing.ItemsByPlan.plan) ", "width": Lino.chars2width(21) } ];
    Lino.invoicing.ItemsByPlan.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.ItemsByPlan.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/ItemsByPlan", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/ItemsByPlan", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/ItemsByPlan", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/ItemsByPlan", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/ItemsByPlan", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/ItemsByPlan", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/ItemsByPlan", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/ItemsByPlan", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.invoicing.ItemsByPlan.GridPanel(p);
});
Lino.invoicing.ItemsByPlan.exec_item = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/ItemsByPlan", "GET", pk, "exec_item", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.PaymentOrdersByJournal
Lino.finan.PaymentOrdersByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 26,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/PaymentOrdersByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrdersByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrdersByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrdersByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrdersByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrdersByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "write_xml", "menu_item_text": "Write XML", "overflowText": "Write XML", "panel_btn_handler": Lino.row_action_handler('write_xml','GET',null), "text": "Write XML" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Payment Order", "overflowText": "Payment Order", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Zahlungsauftr\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "narration" }, { "name": "total" }, { "dateFormat": "d.m.Y", "name": "execution_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "name": "print_actions" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "journal" }, 'journalHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.PaymentOrdersByJournal.detail;
    this.ls_insert_handler = Lino.finan.PaymentOrdersByJournal.insert;
    var ww = this.containing_window;
    var number_with_year_disp4197 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var entry_date4198 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var narration4199 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var total4200 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var execution_date4201 = new Lino.DateField({ "selectOnFocus": true });
    var accounting_period4202 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrdersByJournal/accounting_period" }) }) });
    var workflow_buttons_disp4203 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4204 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user4205 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrdersByJournal/user" }) }) });
    var voucher_date4206 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number4207 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state4208 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by4209 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account4210 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrdersByJournal/item_account" }) }) });
    var item_remark4211 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var print_actions_disp4212 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp4213 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4214 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp4215 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal4216 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrdersByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date4198, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "narration", "editable": true, "editor": narration4199, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "total", "editable": true, "editor": total4200, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total", "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.total) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "execution_date", "editable": true, "editor": execution_date4201, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Ausf\u00fchrungsdatum", "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.execution_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4202, "filter": { "type": "string" }, "header": "Buchungsperiode", "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id4204, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user4205, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.user) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4206, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 10, "dataIndex": "number", "editable": true, "editor": number4207, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "state", "editable": true, "editor": state4208, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 12, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "item_account", "editable": true, "editor": item_account4210, "filter": { "type": "string" }, "header": "Standardwert Konto", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.item_account) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "item_remark", "editable": true, "editor": item_remark4211, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.item_remark) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.print_actions) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "journal", "editable": true, "editor": journal4216, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) } ];
    Lino.finan.PaymentOrdersByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrdersByJournal.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.PaymentOrdersByJournal.insertPanel = Ext.extend(Lino.finan.FinancialVouchers.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/finan/PaymentOrdersByJournal",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.PaymentOrdersByJournal.detail;
    this.ls_insert_handler = Lino.finan.PaymentOrdersByJournal.insert;
    Lino.finan.PaymentOrdersByJournal.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrdersByJournal.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.PaymentOrdersByJournal.insertPanel(p);
});
Lino.finan.PaymentOrdersByJournal.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.PaymentOrdersByJournal.detailPanel = Ext.extend(Lino.finan.PaymentOrders.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "write_xml", "menu_item_text": "Write XML", "overflowText": "Write XML", "panel_btn_handler": Lino.row_action_handler('write_xml','GET',null), "text": "Write XML" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Payment Order", "overflowText": "Payment Order", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/PaymentOrdersByJournal",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.PaymentOrdersByJournal.detail;
    this.ls_insert_handler = Lino.finan.PaymentOrdersByJournal.insert;
    Lino.finan.PaymentOrdersByJournal.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrdersByJournal.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.PaymentOrdersByJournal.detailPanel(p);
});
Lino.finan.PaymentOrdersByJournal.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.write_xml = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "write_xml", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.suggest = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.PaymentOrdersByJournal.ParamsPanel({});
  return new Lino.finan.PaymentOrdersByJournal.GridPanel(p);
});
Lino.finan.PaymentOrdersByJournal.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/PaymentOrdersByJournal", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.JournalEntriesByJournal
Lino.finan.JournalEntriesByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 24,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/JournalEntriesByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntriesByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntriesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntriesByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntriesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntriesByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Diverse Buchungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "narration" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "dateFormat": "d.m.Y", "name": "last_item_date", "type": "date" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "journal" }, 'journalHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.JournalEntriesByJournal.detail;
    this.ls_insert_handler = Lino.finan.JournalEntriesByJournal.insert;
    var ww = this.containing_window;
    var number_with_year_disp4239 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var entry_date4240 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var narration4241 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var accounting_period4242 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntriesByJournal/accounting_period" }) }) });
    var workflow_buttons_disp4243 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4244 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user4245 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntriesByJournal/user" }) }) });
    var voucher_date4246 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number4247 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state4248 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by4249 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account4250 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntriesByJournal/item_account" }) }) });
    var item_remark4251 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_item_date4252 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp4253 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4254 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp4255 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal4256 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntriesByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date4240, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "narration", "editable": true, "editor": narration4241, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4242, "filter": { "type": "string" }, "header": "Buchungsperiode", "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4244, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "user", "editable": true, "editor": user4245, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.user) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4246, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "number", "editable": true, "editor": number4247, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 9, "dataIndex": "state", "editable": true, "editor": state4248, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 10, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "item_account", "editable": true, "editor": item_account4250, "filter": { "type": "string" }, "header": "Standardwert Konto", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.item_account) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "item_remark", "editable": true, "editor": item_remark4251, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.item_remark) ", "width": Lino.chars2width(22) }, { "colIndex": 13, "dataIndex": "last_item_date", "editable": true, "editor": last_item_date4252, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "last item date", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.last_item_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 14, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "journal", "editable": true, "editor": journal4256, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) } ];
    Lino.finan.JournalEntriesByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntriesByJournal.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.JournalEntriesByJournal.insertPanel = Ext.extend(Lino.finan.FinancialVouchers.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/finan/JournalEntriesByJournal",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.JournalEntriesByJournal.detail;
    this.ls_insert_handler = Lino.finan.JournalEntriesByJournal.insert;
    Lino.finan.JournalEntriesByJournal.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntriesByJournal.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.JournalEntriesByJournal.insertPanel(p);
});
Lino.finan.JournalEntriesByJournal.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.JournalEntriesByJournal.detailPanel = Ext.extend(Lino.finan.FinancialVouchers.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/JournalEntriesByJournal",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.JournalEntriesByJournal.detail;
    this.ls_insert_handler = Lino.finan.JournalEntriesByJournal.insert;
    Lino.finan.JournalEntriesByJournal.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntriesByJournal.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.JournalEntriesByJournal.detailPanel(p);
});
Lino.finan.JournalEntriesByJournal.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.suggest = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.JournalEntriesByJournal.ParamsPanel({});
  return new Lino.finan.JournalEntriesByJournal.GridPanel(p);
});
Lino.finan.JournalEntriesByJournal.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/JournalEntriesByJournal", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.BankStatementsByJournal
Lino.finan.BankStatementsByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 26,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/BankStatementsByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementsByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementsByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementsByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementsByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementsByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Bank Statement", "overflowText": "Bank Statement", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Kontoausz\u00fcge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "balance1" }, { "name": "balance2" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "dateFormat": "d.m.Y", "name": "last_item_date", "type": "date" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "journal" }, 'journalHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.BankStatementsByJournal.detail;
    this.ls_insert_handler = Lino.finan.BankStatementsByJournal.insert;
    var ww = this.containing_window;
    var number_with_year_disp4218 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var entry_date4219 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var balance14220 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var balance24221 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var accounting_period4222 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementsByJournal/accounting_period" }) }) });
    var workflow_buttons_disp4223 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4224 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user4225 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementsByJournal/user" }) }) });
    var voucher_date4226 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number4227 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var narration4228 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state4229 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by4230 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account4231 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementsByJournal/item_account" }) }) });
    var item_remark4232 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_item_date4233 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp4234 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4235 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp4236 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal4237 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementsByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "sortable": false, "tooltip": "(finan.BankStatementsByJournal.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date4219, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(finan.BankStatementsByJournal.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "balance1", "editable": true, "editor": balance14220, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Alter Saldo", "sortable": true, "tooltip": "(finan.BankStatementsByJournal.balance1) The old (or start) balance.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 3, "dataIndex": "balance2", "editable": true, "editor": balance24221, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Neuer Saldo", "sortable": true, "tooltip": "(finan.BankStatementsByJournal.balance2) The new (or end) balance.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4222, "filter": { "type": "string" }, "header": "Buchungsperiode", "sortable": false, "tooltip": "(finan.BankStatementsByJournal.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(finan.BankStatementsByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id4224, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatementsByJournal.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user4225, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.BankStatementsByJournal.user) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4226, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatementsByJournal.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 9, "dataIndex": "number", "editable": true, "editor": number4227, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatementsByJournal.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 10, "dataIndex": "narration", "editable": true, "editor": narration4228, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatementsByJournal.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 11, "dataIndex": "state", "editable": true, "editor": state4229, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementsByJournal.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 12, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.BankStatementsByJournal.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "item_account", "editable": true, "editor": item_account4231, "filter": { "type": "string" }, "header": "Standardwert Konto", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementsByJournal.item_account) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "item_remark", "editable": true, "editor": item_remark4232, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatementsByJournal.item_remark) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "last_item_date", "editable": true, "editor": last_item_date4233, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "last item date", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatementsByJournal.last_item_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 16, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementsByJournal.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementsByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementsByJournal.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "journal", "editable": true, "editor": journal4237, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(finan.BankStatementsByJournal.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) } ];
    Lino.finan.BankStatementsByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatementsByJournal.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.BankStatementsByJournal.insertPanel = Ext.extend(Lino.finan.BankStatements.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/finan/BankStatementsByJournal",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.BankStatementsByJournal.detail;
    this.ls_insert_handler = Lino.finan.BankStatementsByJournal.insert;
    Lino.finan.BankStatementsByJournal.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatementsByJournal.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.BankStatementsByJournal.insertPanel(p);
});
Lino.finan.BankStatementsByJournal.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.BankStatementsByJournal.detailPanel = Ext.extend(Lino.finan.BankStatements.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Bank Statement", "overflowText": "Bank Statement", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/BankStatementsByJournal",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.BankStatementsByJournal.detail;
    this.ls_insert_handler = Lino.finan.BankStatementsByJournal.insert;
    Lino.finan.BankStatementsByJournal.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatementsByJournal.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.BankStatementsByJournal.detailPanel(p);
});
Lino.finan.BankStatementsByJournal.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.suggest = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.BankStatementsByJournal.ParamsPanel({});
  return new Lino.finan.BankStatementsByJournal.GridPanel(p);
});
Lino.finan.BankStatementsByJournal.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/BankStatementsByJournal", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.ItemsByJournalEntry
Lino.finan.ItemsByJournalEntry.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 19,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/ItemsByJournalEntry",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByJournalEntry','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByJournalEntry','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByJournalEntry','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByJournalEntry','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByJournalEntry','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Inhalt",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "seqno", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "account" }, 'accountHidden', { "name": "match" }, { "name": "debit" }, { "name": "credit" }, { "name": "remark" }, { "name": "id", "type": "int" }, { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "move_buttons" }, { "name": "voucher" }, 'voucherHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 60,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var seqno6024 = new Ext.form.NumberField({ "selectOnFocus": true });
    var date6025 = new Lino.DateField({ "selectOnFocus": true });
    var partner6026 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByJournalEntry/partner" }) }) });
    var account6027 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByJournalEntry/account" }) }) });
    var match6028 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByJournalEntry/match" }) }) });
    var debit6029 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var credit6030 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var remark6031 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id6032 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var amount6033 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc6034 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp6035 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6036 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6037 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp6038 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var voucher6039 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Diverse Buchung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByJournalEntry/voucher" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      match6028.setContextValue('mk',bp['mk']);
      match6028.setContextValue('mt',bp['mt']);
      match6028.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      voucher6039.on('change',Lino.chooser_handler(match6028,'voucher'));
      partner6026.on('change',Lino.chooser_handler(match6028,'partner'));
      Lino.finan.ItemsByJournalEntry.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "seqno", "editable": true, "editor": seqno6024, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(finan.ItemsByJournalEntry.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "date", "editable": true, "editor": date6025, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "date", "sortable": true, "tooltip": "(finan.ItemsByJournalEntry.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "partner", "editable": true, "editor": partner6026, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "account", "editable": true, "editor": account6027, "filter": { "type": "string" }, "header": "Konto", "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.account) ", "width": Lino.chars2width(51) }, { "colIndex": 4, "dataIndex": "match", "editable": true, "editor": match6028, "filter": { "type": "string" }, "header": "Match", "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 5, "dataIndex": "debit", "editable": true, "editor": debit6029, "format": "0.000,00/i", "header": "Debit", "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.debit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "credit", "editable": true, "editor": credit6030, "format": "0.000,00/i", "header": "Kredit", "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.credit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "remark", "editable": true, "editor": remark6031, "filter": { "type": "string" }, "header": "Ihr Zeichen", "sortable": true, "tooltip": "(finan.ItemsByJournalEntry.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id6032, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.ItemsByJournalEntry.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 9, "dataIndex": "amount", "editable": true, "editor": amount6033, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "hidden": true, "sortable": true, "tooltip": "(finan.ItemsByJournalEntry.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 10, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 11, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 15, "dataIndex": "voucher", "editable": true, "editor": voucher6039, "filter": { "type": "string" }, "header": "Diverse Buchung", "hidden": true, "renderer": Lino.fk_renderer('voucherHidden','Lino.finan.FinancialVouchers.detail'), "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.voucher) ", "width": Lino.chars2width(21) } ];
    Lino.finan.ItemsByJournalEntry.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.ItemsByJournalEntry.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByJournalEntry", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByJournalEntry", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByJournalEntry", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByJournalEntry", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByJournalEntry", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByJournalEntry", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByJournalEntry", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByJournalEntry", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByJournalEntry", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.ItemsByJournalEntry.GridPanel(p);
});
Lino.finan.ItemsByJournalEntry.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByJournalEntry", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByJournalEntry", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.ItemsByBankStatement
Lino.finan.ItemsByBankStatement.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 19,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/ItemsByBankStatement",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByBankStatement','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByBankStatement','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByBankStatement','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByBankStatement','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByBankStatement','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Inhalt",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "seqno", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "account" }, 'accountHidden', { "name": "match" }, { "name": "remark" }, { "name": "debit" }, { "name": "credit" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "move_buttons" }, { "name": "voucher" }, 'voucherHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 11,
  ls_grid_configs : [  ],
  content_type : 62,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var seqno6041 = new Ext.form.NumberField({ "selectOnFocus": true });
    var date6042 = new Lino.DateField({ "selectOnFocus": true });
    var partner6043 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByBankStatement/partner" }) }) });
    var account6044 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByBankStatement/account" }) }) });
    var match6045 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByBankStatement/match" }) }) });
    var remark6046 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var debit6047 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var credit6048 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp6049 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id6050 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var amount6051 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc6052 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp6053 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6054 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp6055 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var voucher6056 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Kontoauszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByBankStatement/voucher" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      match6045.setContextValue('mk',bp['mk']);
      match6045.setContextValue('mt',bp['mt']);
      match6045.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      voucher6056.on('change',Lino.chooser_handler(match6045,'voucher'));
      partner6043.on('change',Lino.chooser_handler(match6045,'partner'));
      Lino.finan.ItemsByBankStatement.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "seqno", "editable": true, "editor": seqno6041, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(finan.ItemsByBankStatement.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "date", "editable": true, "editor": date6042, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "date", "sortable": true, "tooltip": "(finan.ItemsByBankStatement.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "partner", "editable": true, "editor": partner6043, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.ItemsByBankStatement.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "account", "editable": true, "editor": account6044, "filter": { "type": "string" }, "header": "Konto", "sortable": false, "tooltip": "(finan.ItemsByBankStatement.account) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "match", "editable": true, "editor": match6045, "filter": { "type": "string" }, "header": "Match", "sortable": false, "tooltip": "(finan.ItemsByBankStatement.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark6046, "filter": { "type": "string" }, "header": "Ihr Zeichen", "sortable": true, "tooltip": "(finan.ItemsByBankStatement.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 6, "dataIndex": "debit", "editable": true, "editor": debit6047, "format": "0.000,00/i", "header": "Eingang", "sortable": false, "tooltip": "(finan.ItemsByBankStatement.debit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "credit", "editable": true, "editor": credit6048, "format": "0.000,00/i", "header": "Ausgabe", "sortable": false, "tooltip": "(finan.ItemsByBankStatement.credit) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(finan.ItemsByBankStatement.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 9, "dataIndex": "id", "editable": true, "editor": id6050, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.ItemsByBankStatement.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 10, "dataIndex": "amount", "editable": true, "editor": amount6051, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "hidden": true, "sortable": true, "tooltip": "(finan.ItemsByBankStatement.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByBankStatement.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 12, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByBankStatement.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByBankStatement.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByBankStatement.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 15, "dataIndex": "voucher", "editable": true, "editor": voucher6056, "filter": { "type": "string" }, "header": "Kontoauszug", "hidden": true, "renderer": Lino.fk_renderer('voucherHidden','Lino.finan.BankStatements.detail'), "sortable": false, "tooltip": "(finan.ItemsByBankStatement.voucher) ", "width": Lino.chars2width(21) } ];
    Lino.finan.ItemsByBankStatement.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.ItemsByBankStatement.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByBankStatement", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByBankStatement", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByBankStatement", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByBankStatement", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByBankStatement", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByBankStatement", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByBankStatement", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByBankStatement", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByBankStatement", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.suggest = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByBankStatement", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.ItemsByBankStatement.GridPanel(p);
});
Lino.finan.ItemsByBankStatement.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByBankStatement", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByBankStatement", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.ItemsByPaymentOrder
Lino.finan.ItemsByPaymentOrder.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 18,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/ItemsByPaymentOrder",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByPaymentOrder','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByPaymentOrder','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByPaymentOrder','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByPaymentOrder','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByPaymentOrder','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Inhalt",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "seqno", "type": "int", "useNull": true }, { "name": "partner" }, 'partnerHidden', { "name": "workflow_buttons" }, { "name": "bank_account" }, 'bank_accountHidden', { "name": "match" }, { "name": "amount" }, { "name": "remark" }, { "name": "id", "type": "int" }, { "name": "dc", "type": "boolean" }, { "name": "account" }, 'accountHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "move_buttons" }, { "name": "voucher" }, 'voucherHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 59,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var seqno6058 = new Ext.form.NumberField({ "selectOnFocus": true });
    var partner6059 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByPaymentOrder/partner" }) }) });
    var workflow_buttons_disp6060 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var bank_account6061 = new Lino.RemoteComboFieldElement({ "emptyText": "Bankkonto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByPaymentOrder/bank_account" }) }) });
    var match6062 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByPaymentOrder/match" }) }) });
    var amount6063 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var remark6064 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id6065 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var dc6066 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var account6067 = new Lino.RemoteComboFieldElement({ "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByPaymentOrder/account" }) }) });
    var mobile_item_disp6068 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6069 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp6070 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var voucher6071 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Zahlungsauftrag ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByPaymentOrder/voucher" }) }) });
    this.before_row_edit = function(record) {
      bank_account6061.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
      bank_account6061.setContextValue('project', record ? record.data['project'] : undefined);
      var bp = this.get_base_params();
      match6062.setContextValue('mk',bp['mk']);
      match6062.setContextValue('mt',bp['mt']);
      match6062.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      partner6059.on('change',Lino.chooser_handler(bank_account6061,'partner'));
      voucher6071.on('change',Lino.chooser_handler(match6062,'voucher'));
      partner6059.on('change',Lino.chooser_handler(match6062,'partner'));
      Lino.finan.ItemsByPaymentOrder.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "seqno", "editable": true, "editor": seqno6058, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(finan.ItemsByPaymentOrder.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner6059, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "bank_account", "editable": true, "editor": bank_account6061, "filter": { "type": "string" }, "header": "Bankkonto", "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.bank_account) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "match", "editable": true, "editor": match6062, "filter": { "type": "string" }, "header": "Match", "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 5, "dataIndex": "amount", "editable": true, "editor": amount6063, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "sortable": true, "tooltip": "(finan.ItemsByPaymentOrder.amount) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "remark", "editable": true, "editor": remark6064, "filter": { "type": "string" }, "header": "Ihr Zeichen", "sortable": true, "tooltip": "(finan.ItemsByPaymentOrder.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id6065, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.ItemsByPaymentOrder.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 9, "dataIndex": "account", "editable": true, "editor": account6067, "filter": { "type": "string" }, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.account) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 13, "dataIndex": "voucher", "editable": true, "editor": voucher6071, "filter": { "type": "string" }, "header": "Zahlungsauftrag", "hidden": true, "renderer": Lino.fk_renderer('voucherHidden','Lino.finan.PaymentOrders.detail'), "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.voucher) ", "width": Lino.chars2width(21) } ];
    Lino.finan.ItemsByPaymentOrder.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.ItemsByPaymentOrder.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.suggest = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.ItemsByPaymentOrder.GridPanel(p);
});
Lino.finan.ItemsByPaymentOrder.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/ItemsByPaymentOrder", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sepa.AccountsByPartner
Lino.sepa.AccountsByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 11,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sepa/AccountsByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sepa/AccountsByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sepa/AccountsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/sepa/AccountsByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/sepa/AccountsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sepa/AccountsByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Bankkonten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "iban" }, { "name": "bic" }, { "name": "remark" }, { "name": "primary", "type": "boolean" }, { "name": "id", "type": "int" }, { "name": "statements" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "partner" }, 'partnerHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 65,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_insert_handler = Lino.sepa.AccountsByPartner.insert;
    var ww = this.containing_window;
    var iban1441 = new Lino.UppercaseTextField({ "allowBlank": false, "maxLength": 34, "selectOnFocus": true });
    var bic1442 = new Lino.UppercaseTextField({ "maxLength": 11, "selectOnFocus": true });
    var remark1443 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var primary1444 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var id1445 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var statements_disp1446 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp1447 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1448 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1449 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner1450 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sepa/AccountsByPartner/partner" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "iban", "editable": true, "editor": iban1441, "filter": { "type": "string" }, "header": "IBAN", "renderer": Lino.iban_renderer, "sortable": true, "tooltip": "(sepa.AccountsByPartner.iban) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "bic", "editable": true, "editor": bic1442, "filter": { "type": "string" }, "header": "BIC", "sortable": true, "tooltip": "(sepa.AccountsByPartner.bic) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "remark", "editable": true, "editor": remark1443, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(sepa.AccountsByPartner.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "primary", "editable": true, "filter": { "type": "boolean" }, "header": "Prim\u00e4r", "sortable": false, "tooltip": "(sepa.AccountsByPartner.primary) Enabling this field will automatically disable any previous primary account and update the partner's IBAN and BIC", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id1445, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sepa.AccountsByPartner.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "statements", "editable": false, "header": "Kontoausz\u00fcge", "hidden": true, "sortable": false, "tooltip": "(sepa.AccountsByPartner.statements) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sepa.AccountsByPartner.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(sepa.AccountsByPartner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(sepa.AccountsByPartner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "partner", "editable": true, "editor": partner1450, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sepa.AccountsByPartner.partner) ", "width": Lino.chars2width(21) } ];
    Lino.sepa.AccountsByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sepa.AccountsByPartner.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/AccountsByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/AccountsByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/AccountsByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/AccountsByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sepa.AccountsByPartner.insertPanel = Ext.extend(Lino.sepa.AccountsByPartner.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/sepa/AccountsByPartner",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_insert_handler = Lino.sepa.AccountsByPartner.insert;
    Lino.sepa.AccountsByPartner.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sepa.AccountsByPartner.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sepa.AccountsByPartner.insertPanel(p);
});
Lino.sepa.AccountsByPartner.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/AccountsByPartner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/AccountsByPartner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/AccountsByPartner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/sepa/AccountsByPartner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sepa.AccountsByPartner.GridPanel(p);
});

// js_render_GridPanel_class notes.NotesByType
Lino.notes.NotesByType.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 30,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/NotesByType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByType','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Notizen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "event_type" }, 'event_typeHidden', { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "body" }, { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "type" }, 'typeHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByType.detail;
    var ww = this.containing_window;
    var date1346 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time1347 = new Lino.TimeField({ "selectOnFocus": true });
    var event_type1348 = new Lino.RemoteComboFieldElement({ "emptyText": "Event Type ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/event_type" }) }) });
    var subject1349 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user1350 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/user" }) }) });
    var id1351 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_time1352 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method1353 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company1354 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/company" }) }) });
    var contact_person1355 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/contact_person" }) }) });
    var contact_role1356 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/contact_role" }) }) });
    var owner_type1357 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/owner_type" }) }) });
    var owner_id1358 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/owner_id" }) }) });
    var body1359 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var language1360 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var owner_disp1361 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp1362 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1363 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1364 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type1365 = new Lino.RemoteComboFieldElement({ "emptyText": "Notizart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/type" }) }) });
    this.before_row_edit = function(record) {
      contact_person1355.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id1358.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company1354.on('change',Lino.chooser_handler(contact_person1355,'company'));
      owner_type1357.on('change',Lino.chooser_handler(owner_id1358,'owner_type'));
      Lino.notes.NotesByType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date1346, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum", "sortable": true, "tooltip": "(notes.NotesByType.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time1347, "header": "Zeit", "sortable": true, "tooltip": "(notes.NotesByType.time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type1348, "filter": { "type": "string" }, "header": "Ereignisart (Form)", "renderer": Lino.fk_renderer('event_typeHidden','Lino.notes.EventTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByType.event_type) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "subject", "editable": true, "editor": subject1349, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(notes.NotesByType.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user1350, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.NotesByType.user) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id1351, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByType.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByType.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "build_method", "editable": true, "editor": build_method1353, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 8, "dataIndex": "company", "editable": true, "editor": company1354, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Organisation)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.NotesByType.company) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "contact_person", "editable": true, "editor": contact_person1355, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.NotesByType.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "contact_role", "editable": true, "editor": contact_role1356, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "owner_type", "editable": true, "editor": owner_type1357, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByType.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_id", "editable": true, "editor": owner_id1358, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 13, "dataIndex": "body", "editable": true, "editor": body1359, "filter": { "type": "string" }, "header": "Inhalt", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.body) ", "width": Lino.chars2width(61) }, { "colIndex": 14, "dataIndex": "language", "editable": true, "editor": language1360, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.language) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "type", "editable": true, "editor": type1365, "filter": { "type": "string" }, "header": "Notizart (Inhalt)", "hidden": true, "renderer": Lino.fk_renderer('typeHidden','Lino.notes.NoteTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByType.type) ", "width": Lino.chars2width(21) } ];
    Lino.notes.NotesByType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByType.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByType.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/NotesByType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByType.detail;
    Lino.notes.NotesByType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByType.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.NotesByType.detailPanel(p);
});
Lino.notes.NotesByType.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.NotesByType.GridPanel(p);
});
Lino.notes.NotesByType.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByType", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.NotesByEventType
Lino.notes.NotesByEventType.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 30,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/NotesByEventType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByEventType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByEventType','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByEventType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByEventType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByEventType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Notizen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "type" }, 'typeHidden', { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "body" }, { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "event_type" }, 'event_typeHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByEventType.detail;
    var ww = this.containing_window;
    var date3657 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time3658 = new Lino.TimeField({ "selectOnFocus": true });
    var type3659 = new Lino.RemoteComboFieldElement({ "emptyText": "Notizart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/type" }) }) });
    var subject3660 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user3661 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/user" }) }) });
    var id3662 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_time3663 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method3664 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company3665 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/company" }) }) });
    var contact_person3666 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/contact_person" }) }) });
    var contact_role3667 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/contact_role" }) }) });
    var owner_type3668 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/owner_type" }) }) });
    var owner_id3669 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/owner_id" }) }) });
    var body3670 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var language3671 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var owner_disp3672 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp3673 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3674 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp3675 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var event_type3676 = new Lino.RemoteComboFieldElement({ "emptyText": "Event Type ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/event_type" }) }) });
    this.before_row_edit = function(record) {
      contact_person3666.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id3669.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company3665.on('change',Lino.chooser_handler(contact_person3666,'company'));
      owner_type3668.on('change',Lino.chooser_handler(owner_id3669,'owner_type'));
      Lino.notes.NotesByEventType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date3657, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum", "sortable": true, "tooltip": "(notes.NotesByEventType.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time3658, "header": "Zeit", "sortable": true, "tooltip": "(notes.NotesByEventType.time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "type", "editable": true, "editor": type3659, "filter": { "type": "string" }, "header": "Notizart (Inhalt)", "renderer": Lino.fk_renderer('typeHidden','Lino.notes.NoteTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByEventType.type) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "subject", "editable": true, "editor": subject3660, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(notes.NotesByEventType.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user3661, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.NotesByEventType.user) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id3662, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByEventType.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByEventType.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "build_method", "editable": true, "editor": build_method3664, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 8, "dataIndex": "company", "editable": true, "editor": company3665, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Organisation)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.NotesByEventType.company) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "contact_person", "editable": true, "editor": contact_person3666, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.NotesByEventType.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "contact_role", "editable": true, "editor": contact_role3667, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "owner_type", "editable": true, "editor": owner_type3668, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByEventType.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_id", "editable": true, "editor": owner_id3669, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 13, "dataIndex": "body", "editable": true, "editor": body3670, "filter": { "type": "string" }, "header": "Inhalt", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.body) ", "width": Lino.chars2width(61) }, { "colIndex": 14, "dataIndex": "language", "editable": true, "editor": language3671, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.language) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "event_type", "editable": true, "editor": event_type3676, "filter": { "type": "string" }, "header": "Ereignisart (Form)", "hidden": true, "renderer": Lino.fk_renderer('event_typeHidden','Lino.notes.EventTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByEventType.event_type) ", "width": Lino.chars2width(21) } ];
    Lino.notes.NotesByEventType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByEventType.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByEventType.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/NotesByEventType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByEventType.detail;
    Lino.notes.NotesByEventType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByEventType.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.NotesByEventType.detailPanel(p);
});
Lino.notes.NotesByEventType.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.NotesByEventType.GridPanel(p);
});
Lino.notes.NotesByEventType.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByEventType", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.NotesByCompany
Lino.notes.NotesByCompany.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 30,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/NotesByCompany",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByCompany','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByCompany','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByCompany','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByCompany','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByCompany','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Notizen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "event_type" }, 'event_typeHidden', { "name": "type" }, 'typeHidden', { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "body" }, { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "company" }, 'companyHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByCompany.detail;
    var ww = this.containing_window;
    var date2588 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time2589 = new Lino.TimeField({ "selectOnFocus": true });
    var event_type2590 = new Lino.RemoteComboFieldElement({ "emptyText": "Event Type ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/event_type" }) }) });
    var type2591 = new Lino.RemoteComboFieldElement({ "emptyText": "Notizart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/type" }) }) });
    var subject2592 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user2593 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/user" }) }) });
    var id2594 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_time2595 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method2596 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var contact_person2597 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/contact_person" }) }) });
    var contact_role2598 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/contact_role" }) }) });
    var owner_type2599 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/owner_type" }) }) });
    var owner_id2600 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/owner_id" }) }) });
    var body2601 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var language2602 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var owner_disp2603 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp2604 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2605 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2606 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var company2607 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/company" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      contact_person2597.setContextValue('mk',bp['mk']);
      contact_person2597.setContextValue('mt',bp['mt']);
      owner_id2600.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company2607.on('change',Lino.chooser_handler(contact_person2597,'company'));
      owner_type2599.on('change',Lino.chooser_handler(owner_id2600,'owner_type'));
      Lino.notes.NotesByCompany.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date2588, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum", "sortable": true, "tooltip": "(notes.NotesByCompany.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time2589, "header": "Zeit", "sortable": true, "tooltip": "(notes.NotesByCompany.time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type2590, "filter": { "type": "string" }, "header": "Ereignisart (Form)", "renderer": Lino.fk_renderer('event_typeHidden','Lino.notes.EventTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByCompany.event_type) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type2591, "filter": { "type": "string" }, "header": "Notizart (Inhalt)", "renderer": Lino.fk_renderer('typeHidden','Lino.notes.NoteTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByCompany.type) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "subject", "editable": true, "editor": subject2592, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(notes.NotesByCompany.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user2593, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.NotesByCompany.user) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id2594, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByCompany.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByCompany.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "build_method", "editable": true, "editor": build_method2596, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 9, "dataIndex": "contact_person", "editable": true, "editor": contact_person2597, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.NotesByCompany.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "contact_role", "editable": true, "editor": contact_role2598, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "owner_type", "editable": true, "editor": owner_type2599, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByCompany.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_id", "editable": true, "editor": owner_id2600, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 13, "dataIndex": "body", "editable": true, "editor": body2601, "filter": { "type": "string" }, "header": "Inhalt", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.body) ", "width": Lino.chars2width(61) }, { "colIndex": 14, "dataIndex": "language", "editable": true, "editor": language2602, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.language) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "company", "editable": true, "editor": company2607, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Organisation)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.NotesByCompany.company) ", "width": Lino.chars2width(21) } ];
    Lino.notes.NotesByCompany.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByCompany.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByCompany.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/NotesByCompany",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByCompany.detail;
    Lino.notes.NotesByCompany.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByCompany.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.NotesByCompany.detailPanel(p);
});
Lino.notes.NotesByCompany.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.NotesByCompany.GridPanel(p);
});
Lino.notes.NotesByCompany.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByCompany", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.NotesByPerson
Lino.notes.NotesByPerson.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 30,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/NotesByPerson",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByPerson','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByPerson','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByPerson','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByPerson','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByPerson','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Notizen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "event_type" }, 'event_typeHidden', { "name": "type" }, 'typeHidden', { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "body" }, { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "contact_person" }, 'contact_personHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByPerson.detail;
    var ww = this.containing_window;
    var date1932 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time1933 = new Lino.TimeField({ "selectOnFocus": true });
    var event_type1934 = new Lino.RemoteComboFieldElement({ "emptyText": "Event Type ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/event_type" }) }) });
    var type1935 = new Lino.RemoteComboFieldElement({ "emptyText": "Notizart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/type" }) }) });
    var subject1936 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user1937 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/user" }) }) });
    var id1938 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_time1939 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method1940 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company1941 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/company" }) }) });
    var contact_role1942 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/contact_role" }) }) });
    var owner_type1943 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/owner_type" }) }) });
    var owner_id1944 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/owner_id" }) }) });
    var body1945 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var language1946 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var owner_disp1947 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp1948 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1949 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1950 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var contact_person1951 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/contact_person" }) }) });
    this.before_row_edit = function(record) {
      owner_id1944.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      contact_person1951.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type1943.on('change',Lino.chooser_handler(owner_id1944,'owner_type'));
      company1941.on('change',Lino.chooser_handler(contact_person1951,'company'));
      Lino.notes.NotesByPerson.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date1932, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum", "sortable": true, "tooltip": "(notes.NotesByPerson.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time1933, "header": "Zeit", "sortable": true, "tooltip": "(notes.NotesByPerson.time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type1934, "filter": { "type": "string" }, "header": "Ereignisart (Form)", "renderer": Lino.fk_renderer('event_typeHidden','Lino.notes.EventTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByPerson.event_type) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type1935, "filter": { "type": "string" }, "header": "Notizart (Inhalt)", "renderer": Lino.fk_renderer('typeHidden','Lino.notes.NoteTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByPerson.type) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "subject", "editable": true, "editor": subject1936, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(notes.NotesByPerson.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user1937, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.NotesByPerson.user) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id1938, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByPerson.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByPerson.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "build_method", "editable": true, "editor": build_method1940, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 9, "dataIndex": "company", "editable": true, "editor": company1941, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Organisation)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.NotesByPerson.company) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "contact_role", "editable": true, "editor": contact_role1942, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "owner_type", "editable": true, "editor": owner_type1943, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByPerson.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_id", "editable": true, "editor": owner_id1944, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 13, "dataIndex": "body", "editable": true, "editor": body1945, "filter": { "type": "string" }, "header": "Inhalt", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.body) ", "width": Lino.chars2width(61) }, { "colIndex": 14, "dataIndex": "language", "editable": true, "editor": language1946, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.language) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "contact_person", "editable": true, "editor": contact_person1951, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.NotesByPerson.contact_person) ", "width": Lino.chars2width(21) } ];
    Lino.notes.NotesByPerson.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByPerson.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByPerson.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/NotesByPerson",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByPerson.detail;
    Lino.notes.NotesByPerson.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByPerson.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.NotesByPerson.detailPanel(p);
});
Lino.notes.NotesByPerson.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.NotesByPerson.GridPanel(p);
});
Lino.notes.NotesByPerson.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByPerson", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class uploads.UploadsByType
Lino.uploads.UploadsByType.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 19,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/uploads/UploadsByType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByType','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Uploads",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "file" }, { "name": "description" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "mimetype" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "upload_area" }, 'upload_areaHidden', { "name": "owner" }, { "name": "description_link" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "type" }, 'typeHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 71,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadsByType.detail;
    this.ls_insert_handler = Lino.uploads.UploadsByType.insert;
    var ww = this.containing_window;
    var file3797 = Lino.file_field_handler(this,{ "maxLength": 100, "selectOnFocus": true });
    var description3798 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user3799 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByType/user" }) }) });
    var id3800 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mimetype3801 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": 255 });
    var owner_type3802 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByType/owner_type" }) }) });
    var owner_id3803 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByType/owner_id" }) }) });
    var upload_area3804 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var owner_disp3805 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var description_link_disp3806 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp3807 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3808 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp3809 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type3810 = new Lino.RemoteComboFieldElement({ "emptyText": "Upload-Art ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByType/type" }) }) });
    this.before_row_edit = function(record) {
      owner_id3803.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      type3810.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type3802.on('change',Lino.chooser_handler(owner_id3803,'owner_type'));
      upload_area3804.on('change',Lino.chooser_handler(type3810,'upload_area'));
      Lino.uploads.UploadsByType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "file", "editable": true, "editor": file3797, "filter": { "type": "string" }, "header": "Datei", "sortable": true, "tooltip": "(uploads.UploadsByType.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "description", "editable": true, "editor": description3798, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(uploads.UploadsByType.description) A short description entered manually by the user.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user3799, "filter": { "type": "string" }, "header": "Hochgeladen durch", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(uploads.UploadsByType.user) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id3800, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(uploads.UploadsByType.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "mimetype", "editable": false, "filter": { "type": "string" }, "header": "MIME-Art", "hidden": true, "sortable": true, "tooltip": "(uploads.UploadsByType.mimetype) The Media type\nof the file.  See also this thread\nabout length of MIME type field.", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "owner_type", "editable": true, "editor": owner_type3802, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(uploads.UploadsByType.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "owner_id", "editable": true, "editor": owner_id3803, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "upload_area", "editable": true, "editor": upload_area3804, "filter": { "type": "string" }, "header": "Upload-Bereich", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.upload_area) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "description_link", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.description_link) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "type", "editable": true, "editor": type3810, "filter": { "type": "string" }, "header": "Upload-Art", "hidden": true, "renderer": Lino.fk_renderer('typeHidden','Lino.uploads.UploadTypes.detail'), "sortable": false, "tooltip": "(uploads.UploadsByType.type) ", "width": Lino.chars2width(21) } ];
    Lino.uploads.UploadsByType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadsByType.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.UploadsByType.insertPanel = Ext.extend(Lino.uploads.Uploads.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/uploads/UploadsByType",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadsByType.detail;
    this.ls_insert_handler = Lino.uploads.UploadsByType.insert;
    Lino.uploads.UploadsByType.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadsByType.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.uploads.UploadsByType.insertPanel(p);
});
Lino.uploads.UploadsByType.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.UploadsByType.detailPanel = Ext.extend(Lino.uploads.Uploads.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/uploads/UploadsByType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadsByType.detail;
    this.ls_insert_handler = Lino.uploads.UploadsByType.insert;
    Lino.uploads.UploadsByType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadsByType.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.UploadsByType.detailPanel(p);
});
Lino.uploads.UploadsByType.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.uploads.Uploads.ParamsPanel({});
  return new Lino.uploads.UploadsByType.GridPanel(p);
});
Lino.uploads.UploadsByType.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class outbox.RecipientsByMail
Lino.outbox.RecipientsByMail.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 12,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/RecipientsByMail",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientsByMail','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientsByMail','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientsByMail','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientsByMail','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientsByMail','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Empf\u00e4nger",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "partner" }, 'partnerHidden', { "name": "address" }, { "name": "name" }, { "name": "type" }, 'typeHidden', { "name": "id", "type": "int" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "mail" }, 'mailHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 73,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var partner1301 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/RecipientsByMail/partner" }) }) });
    var address1302 = new Ext.form.TextField({ "maxLength": 254, "selectOnFocus": true });
    var name1303 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var type1304 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.outbox.RecipientTypes });
    var id1305 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp1306 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1307 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1308 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mail1309 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "E-Mail-Ausgang ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/RecipientsByMail/mail" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "partner", "editable": true, "editor": partner1301, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(outbox.RecipientsByMail.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "address", "editable": true, "editor": address1302, "filter": { "type": "string" }, "header": "Adresse", "sortable": true, "tooltip": "(outbox.RecipientsByMail.address) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "name", "editable": true, "editor": name1303, "filter": { "type": "string" }, "header": "Name", "sortable": true, "tooltip": "(outbox.RecipientsByMail.name) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type1304, "filter": { "type": "string" }, "header": "Empf\u00e4ngerart", "sortable": false, "tooltip": "(outbox.RecipientsByMail.type) ", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id1305, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(outbox.RecipientsByMail.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.RecipientsByMail.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.RecipientsByMail.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(outbox.RecipientsByMail.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "mail", "editable": true, "editor": mail1309, "filter": { "type": "string" }, "header": "E-Mail-Ausgang", "hidden": true, "renderer": Lino.fk_renderer('mailHidden','Lino.outbox.Mails.detail'), "sortable": false, "tooltip": "(outbox.RecipientsByMail.mail) ", "width": Lino.chars2width(21) } ];
    Lino.outbox.RecipientsByMail.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.RecipientsByMail.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/RecipientsByMail", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/RecipientsByMail", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/RecipientsByMail", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/RecipientsByMail", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/RecipientsByMail", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/RecipientsByMail", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/RecipientsByMail", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/RecipientsByMail", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.RecipientsByMail.GridPanel(p);
});

// js_render_GridPanel_class outbox.MyOutbox
Lino.outbox.MyOutbox.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 16,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/MyOutbox",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/MyOutbox','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/MyOutbox','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/MyOutbox','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/MyOutbox','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/MyOutbox','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "E-Mail senden", "overflowText": "E-Mail senden", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  cell_edit : true,
  title : "Mein E-Mail-Ausgang",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "sent" }, { "name": "recipients" }, { "name": "subject" }, { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "body" }, { "name": "user" }, 'userHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 72,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MyOutbox.detail;
    this.ls_insert_handler = Lino.outbox.MyOutbox.insert;
    var ww = this.containing_window;
    var sent6073 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var recipients_htmlbox6074 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "recipients", "title": "Empf\u00e4nger", "value": "<br/>" });
    var subject6075 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id6076 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type6077 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/MyOutbox/owner_type" }) }) });
    var owner_id6078 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/MyOutbox/owner_id" }) }) });
    var date6079 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var owner_disp6080 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var mobile_item_disp6081 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6082 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6083 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var body6084 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var user6085 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/MyOutbox/user" }) }) });
    this.before_row_edit = function(record) {
      recipients_htmlbox6074.refresh();
      owner_id6078.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type6077.on('change',Lino.chooser_handler(owner_id6078,'owner_type'));
      Lino.outbox.MyOutbox.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "sent", "editable": false, "header": "sent", "sortable": true, "tooltip": "(outbox.MyOutbox.sent) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "recipients", "editable": false, "header": "Empf\u00e4nger", "sortable": false, "tooltip": "(outbox.MyOutbox.recipients) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "subject", "editable": true, "editor": subject6075, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(outbox.MyOutbox.subject) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id6076, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(outbox.MyOutbox.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "owner_type", "editable": true, "editor": owner_type6077, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(outbox.MyOutbox.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "owner_id", "editable": true, "editor": owner_id6078, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(outbox.MyOutbox.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "date", "editable": true, "editor": date6079, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum", "hidden": true, "sortable": true, "tooltip": "(outbox.MyOutbox.date) \n        The official date to be printed on the document.\n        ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(outbox.MyOutbox.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.MyOutbox.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.MyOutbox.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(outbox.MyOutbox.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "body", "editable": true, "editor": body6084, "filter": { "type": "string" }, "header": "Inhalt", "hidden": true, "sortable": false, "tooltip": "(outbox.MyOutbox.body) ", "width": Lino.chars2width(61) }, { "colIndex": 12, "dataIndex": "user", "editable": true, "editor": user6085, "filter": { "type": "string" }, "header": "Absender", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(outbox.MyOutbox.user) ", "width": Lino.chars2width(21) } ];
    Lino.outbox.MyOutbox.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MyOutbox.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MyOutbox", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MyOutbox", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MyOutbox", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MyOutbox", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MyOutbox", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.MyOutbox.insertPanel = Ext.extend(Lino.outbox.Mails.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/outbox/MyOutbox",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MyOutbox.detail;
    this.ls_insert_handler = Lino.outbox.MyOutbox.insert;
    Lino.outbox.MyOutbox.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MyOutbox.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.outbox.MyOutbox.insertPanel(p);
});
Lino.outbox.MyOutbox.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MyOutbox", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MyOutbox", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MyOutbox", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.MyOutbox.detailPanel = Ext.extend(Lino.outbox.Mails.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "E-Mail senden", "overflowText": "E-Mail senden", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  ls_url: "/outbox/MyOutbox",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MyOutbox.detail;
    this.ls_insert_handler = Lino.outbox.MyOutbox.insert;
    Lino.outbox.MyOutbox.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MyOutbox.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.MyOutbox.detailPanel(p);
});
Lino.outbox.MyOutbox.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MyOutbox", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MyOutbox", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.outbox.Mails.ParamsPanel({});
  return new Lino.outbox.MyOutbox.GridPanel(p);
});
Lino.outbox.MyOutbox.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MyOutbox", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.send_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MyOutbox", "GET", pk, "send_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class outbox.MailsByUser
Lino.outbox.MailsByUser.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 4,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/MailsByUser",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByUser','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByUser','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByUser','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByUser','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByUser','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "E-Mail senden", "overflowText": "E-Mail senden", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  cell_edit : true,
  title : "E-Mail-Ausgang",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "sent" }, { "name": "subject" }, { "name": "recipients" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 72,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MailsByUser.detail;
    this.ls_insert_handler = Lino.outbox.MailsByUser.insert;
    var ww = this.containing_window;
    var sent6087 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var subject6088 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var recipients_htmlbox6089 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "recipients", "title": "Empf\u00e4nger", "value": "<br/>" });
    this.before_row_edit = function(record) {
      recipients_htmlbox6089.refresh();
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "sent", "editable": false, "header": "sent", "sortable": true, "tooltip": "(outbox.MailsByUser.sent) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "subject", "editable": true, "editor": subject6088, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(outbox.MailsByUser.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "recipients", "editable": false, "header": "Empf\u00e4nger", "sortable": false, "tooltip": "(outbox.MailsByUser.recipients) ", "width": Lino.chars2width(31) } ];
    Lino.outbox.MailsByUser.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MailsByUser.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByUser", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByUser", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByUser", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByUser", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByUser", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.MailsByUser.insertPanel = Ext.extend(Lino.outbox.Mails.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/outbox/MailsByUser",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MailsByUser.detail;
    this.ls_insert_handler = Lino.outbox.MailsByUser.insert;
    Lino.outbox.MailsByUser.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MailsByUser.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.outbox.MailsByUser.insertPanel(p);
});
Lino.outbox.MailsByUser.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByUser", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByUser", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByUser", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.MailsByUser.detailPanel = Ext.extend(Lino.outbox.Mails.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "E-Mail senden", "overflowText": "E-Mail senden", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  ls_url: "/outbox/MailsByUser",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MailsByUser.detail;
    this.ls_insert_handler = Lino.outbox.MailsByUser.insert;
    Lino.outbox.MailsByUser.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MailsByUser.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.MailsByUser.detailPanel(p);
});
Lino.outbox.MailsByUser.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByUser", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByUser", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.outbox.Mails.ParamsPanel({});
  return new Lino.outbox.MailsByUser.GridPanel(p);
});
Lino.outbox.MailsByUser.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByUser", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.send_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByUser", "GET", pk, "send_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class outbox.SentByPartner
Lino.outbox.SentByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 5,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/SentByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/SentByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/SentByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/SentByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/SentByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/SentByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "E-Mail senden", "overflowText": "E-Mail senden", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  cell_edit : true,
  title : "E-Mail-Ausgang",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "sent" }, { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 72,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.SentByPartner.detail;
    this.ls_insert_handler = Lino.outbox.SentByPartner.insert;
    var ww = this.containing_window;
    var sent6091 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var subject6092 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user6093 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/SentByPartner/user" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "sent", "editable": false, "header": "sent", "sortable": true, "tooltip": "(outbox.SentByPartner.sent) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "subject", "editable": true, "editor": subject6092, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(outbox.SentByPartner.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user6093, "filter": { "type": "string" }, "header": "Absender", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(outbox.SentByPartner.user) ", "width": Lino.chars2width(21) } ];
    Lino.outbox.SentByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.SentByPartner.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/SentByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/SentByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/SentByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/SentByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/SentByPartner", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.SentByPartner.insertPanel = Ext.extend(Lino.outbox.Mails.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/outbox/SentByPartner",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.SentByPartner.detail;
    this.ls_insert_handler = Lino.outbox.SentByPartner.insert;
    Lino.outbox.SentByPartner.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.SentByPartner.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.outbox.SentByPartner.insertPanel(p);
});
Lino.outbox.SentByPartner.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/SentByPartner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/SentByPartner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/SentByPartner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.SentByPartner.detailPanel = Ext.extend(Lino.outbox.Mails.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "E-Mail senden", "overflowText": "E-Mail senden", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  ls_url: "/outbox/SentByPartner",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.SentByPartner.detail;
    this.ls_insert_handler = Lino.outbox.SentByPartner.insert;
    Lino.outbox.SentByPartner.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.SentByPartner.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.SentByPartner.detailPanel(p);
});
Lino.outbox.SentByPartner.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/SentByPartner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/SentByPartner", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.outbox.Mails.ParamsPanel({});
  return new Lino.outbox.SentByPartner.GridPanel(p);
});
Lino.outbox.SentByPartner.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/SentByPartner", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.send_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/SentByPartner", "GET", pk, "send_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class outbox.AttachmentsByMail
Lino.outbox.AttachmentsByMail.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 11,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/AttachmentsByMail",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByMail','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByMail','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByMail','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByMail','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByMail','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Anh\u00e4nge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "owner" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "mail" }, 'mailHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 74,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id6095 = new Ext.form.NumberField({ "selectOnFocus": true });
    var owner_type6096 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/AttachmentsByMail/owner_type" }) }) });
    var owner_id6097 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/AttachmentsByMail/owner_id" }) }) });
    var owner_disp6098 = new Ext.form.DisplayField({ "disabled": true });
    var mobile_item_disp6099 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6100 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6101 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mail6102 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "E-Mail-Ausgang ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/AttachmentsByMail/mail" }) }) });
    this.before_row_edit = function(record) {
      owner_id6097.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type6096.on('change',Lino.chooser_handler(owner_id6097,'owner_type'));
      Lino.outbox.AttachmentsByMail.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id6095, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(outbox.AttachmentsByMail.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "owner_type", "editable": true, "editor": owner_type6096, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(outbox.AttachmentsByMail.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "owner_id", "editable": true, "editor": owner_id6097, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "sortable": false, "tooltip": "(outbox.AttachmentsByMail.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 3, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(outbox.AttachmentsByMail.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.AttachmentsByMail.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.AttachmentsByMail.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(outbox.AttachmentsByMail.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "mail", "editable": true, "editor": mail6102, "filter": { "type": "string" }, "header": "E-Mail-Ausgang", "hidden": true, "renderer": Lino.fk_renderer('mailHidden','Lino.outbox.Mails.detail'), "sortable": false, "tooltip": "(outbox.AttachmentsByMail.mail) ", "width": Lino.chars2width(21) } ];
    Lino.outbox.AttachmentsByMail.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.AttachmentsByMail.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByMail", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByMail", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByMail", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByMail", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByMail", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByMail", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByMail", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByMail", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.AttachmentsByMail.GridPanel(p);
});

// js_render_GridPanel_class excerpts.ExcerptsByType
Lino.excerpts.ExcerptsByType.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 26,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/excerpts/ExcerptsByType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByType','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Ausz\u00fcge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "build_time" }, { "name": "owner" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "language" }, 'languageHidden', { "name": "body_template_content" }, { "name": "preview" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "excerpt_type" }, 'excerpt_typeHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 76,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.ExcerptsByType.detail;
    var ww = this.containing_window;
    var build_time3979 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var owner_disp3980 = new Ext.form.DisplayField({ "disabled": true });
    var user3981 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/user" }) }) });
    var id3982 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_method3983 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company3984 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/company" }) }) });
    var contact_person3985 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/contact_person" }) }) });
    var contact_role3986 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/contact_role" }) }) });
    var owner_type3987 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/owner_type" }) }) });
    var owner_id3988 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/owner_id" }) }) });
    var language3989 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var body_template_content3990 = new Ext.form.TextArea({ "disabled": true, "growMax": 2000, "hidden": true });
    var preview_htmlbox3991 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "preview", "title": "Vorschau", "value": "<br/>" });
    var mobile_item_disp3992 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3993 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp3994 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var excerpt_type3995 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Auszugsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/excerpt_type" }) }) });
    this.before_row_edit = function(record) {
      contact_person3985.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id3988.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      preview_htmlbox3991.refresh();
      excerpt_type3995.setContextValue('owner', record ? record.data['owner'] : undefined);
    };
    this.onRender = function(ct, position) {
      company3984.on('change',Lino.chooser_handler(contact_person3985,'company'));
      owner_type3987.on('change',Lino.chooser_handler(owner_id3988,'owner_type'));
      owner_disp3980.on('change',Lino.chooser_handler(excerpt_type3995,'owner'));
      Lino.excerpts.ExcerptsByType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "sortable": true, "tooltip": "(excerpts.ExcerptsByType.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(excerpts.ExcerptsByType.owner) The object being printed by this excerpt.\nSee Controllable.owner.", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user3981, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByType.user) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id3982, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(excerpts.ExcerptsByType.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "build_method", "editable": true, "editor": build_method3983, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 5, "dataIndex": "company", "editable": true, "editor": company3984, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Organisation)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByType.company) The optional company of the recipient of this\nexcerpt.  See ContactRelated.company.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "contact_person", "editable": true, "editor": contact_person3985, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByType.contact_person) The optional contact person of the recipient of this\nexcerpt.  See ContactRelated.contact_person.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "contact_role", "editable": true, "editor": contact_role3986, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_type", "editable": true, "editor": owner_type3987, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByType.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "owner_id", "editable": true, "editor": owner_id3988, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "language", "editable": true, "editor": language3989, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.language) The language used for printing this excerpt.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "body_template_content", "editable": false, "header": "Textk\u00f6rper-Vorlage", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.body_template_content) ", "width": Lino.chars2width(61) }, { "colIndex": 12, "dataIndex": "preview", "editable": false, "header": "Vorschau", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.preview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "excerpt_type", "editable": true, "editor": excerpt_type3995, "filter": { "type": "string" }, "header": "Auszugsart", "hidden": true, "renderer": Lino.fk_renderer('excerpt_typeHidden','Lino.excerpts.ExcerptTypes.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByType.excerpt_type) The type of this excerpt (ForeignKey to ExcerptType).", "width": Lino.chars2width(21) } ];
    Lino.excerpts.ExcerptsByType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.ExcerptsByType.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.excerpts.ExcerptsByType.detailPanel = Ext.extend(Lino.excerpts.Excerpts.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/excerpts/ExcerptsByType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.ExcerptsByType.detail;
    Lino.excerpts.ExcerptsByType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.ExcerptsByType.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.excerpts.ExcerptsByType.detailPanel(p);
});
Lino.excerpts.ExcerptsByType.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.excerpts.Excerpts.ParamsPanel({});
  return new Lino.excerpts.ExcerptsByType.GridPanel(p);
});
Lino.excerpts.ExcerptsByType.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByType", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class users.AuthoritiesGiven
Lino.users.AuthoritiesGiven.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 3,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/users/AuthoritiesGiven",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesGiven','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesGiven','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesGiven','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesGiven','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesGiven','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Erteilte Vollmachten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "authorized" }, 'authorizedHidden', { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 3,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var authorized1126 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/AuthoritiesGiven/authorized" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      authorized1126.setContextValue('mk',bp['mk']);
      authorized1126.setContextValue('mt',bp['mt']);
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "authorized", "editable": true, "editor": authorized1126, "filter": { "type": "string" }, "header": "Benutzer", "renderer": Lino.fk_renderer('authorizedHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(users.AuthoritiesGiven.authorized) The user who gets the right to represent the author", "width": Lino.chars2width(21) } ];
    Lino.users.AuthoritiesGiven.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.users.AuthoritiesGiven.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesGiven", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesGiven", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesGiven", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesGiven", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesGiven", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesGiven", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesGiven", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesGiven", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.users.Authorities.ParamsPanel({});
  return new Lino.users.AuthoritiesGiven.GridPanel(p);
});

// js_render_GridPanel_class users.AuthoritiesTaken
Lino.users.AuthoritiesTaken.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 3,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/users/AuthoritiesTaken",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesTaken','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesTaken','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesTaken','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesTaken','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesTaken','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Erhaltene Vollmachten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 3,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var user6104 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/AuthoritiesTaken/user" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "user", "editable": true, "editor": user6104, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(users.AuthoritiesTaken.user) The user who gives the right of representation. author of this\nauthority", "width": Lino.chars2width(21) } ];
    Lino.users.AuthoritiesTaken.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.users.AuthoritiesTaken.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesTaken", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesTaken", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesTaken", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesTaken", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesTaken", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesTaken", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesTaken", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/AuthoritiesTaken", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.users.Authorities.ParamsPanel({});
  return new Lino.users.AuthoritiesTaken.GridPanel(p);
});

// js_render_GridPanel_class vat.InvoicesByJournal
Lino.vat.InvoicesByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 29,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/vat/InvoicesByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/InvoicesByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/InvoicesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/InvoicesByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/InvoicesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/InvoicesByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Rechnungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "total_incl" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "user" }, 'userHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "your_ref" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "journal" }, 'journalHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 11,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.InvoicesByJournal.detail;
    this.ls_insert_handler = Lino.vat.InvoicesByJournal.insert;
    var ww = this.containing_window;
    var number_with_year_disp4174 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var voucher_date4175 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var due_date4176 = new Lino.DateField({ "selectOnFocus": true });
    var partner4177 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/partner" }) }) });
    var total_incl4178 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_base4179 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat4180 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var user4181 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/user" }) }) });
    var workflow_buttons_disp4182 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4183 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var entry_date4184 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period4185 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/accounting_period" }) }) });
    var number4186 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var narration4187 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state4188 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var payment_term4189 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/payment_term" }) }) });
    var match4190 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/match" }) }) });
    var your_ref4191 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var vat_regime4192 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var mobile_item_disp4193 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4194 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal4195 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      match4190.setContextValue('mk',bp['mk']);
      match4190.setContextValue('mt',bp['mt']);
      match4190.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      journal4195.on('change',Lino.chooser_handler(match4190,'journal'));
      partner4177.on('change',Lino.chooser_handler(match4190,'partner'));
      Lino.vat.InvoicesByJournal.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "sortable": false, "tooltip": "(vat.InvoicesByJournal.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4175, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "sortable": true, "tooltip": "(vat.InvoicesByJournal.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "due_date", "editable": true, "editor": due_date4176, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": true, "tooltip": "(vat.InvoicesByJournal.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "partner", "editable": true, "editor": partner4177, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(vat.InvoicesByJournal.partner) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "total_incl", "editable": true, "editor": total_incl4178, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(vat.InvoicesByJournal.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "total_base", "editable": true, "editor": total_base4179, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "sortable": true, "tooltip": "(vat.InvoicesByJournal.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "total_vat", "editable": true, "editor": total_vat4180, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "sortable": true, "tooltip": "(vat.InvoicesByJournal.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user4181, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(vat.InvoicesByJournal.user) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(vat.InvoicesByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 9, "dataIndex": "id", "editable": true, "editor": id4183, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(vat.InvoicesByJournal.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 10, "dataIndex": "entry_date", "editable": true, "editor": entry_date4184, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "hidden": true, "sortable": true, "tooltip": "(vat.InvoicesByJournal.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4185, "filter": { "type": "string" }, "header": "Buchungsperiode", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 12, "dataIndex": "number", "editable": true, "editor": number4186, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(vat.InvoicesByJournal.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 13, "dataIndex": "narration", "editable": true, "editor": narration4187, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(vat.InvoicesByJournal.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "state", "editable": true, "editor": state4188, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 15, "dataIndex": "payment_term", "editable": true, "editor": payment_term4189, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(vat.InvoicesByJournal.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "match", "editable": true, "editor": match4190, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 17, "dataIndex": "your_ref", "editable": true, "editor": your_ref4191, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(vat.InvoicesByJournal.your_ref) ", "width": Lino.chars2width(22) }, { "colIndex": 18, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime4192, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 19, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "journal", "editable": true, "editor": journal4195, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(vat.InvoicesByJournal.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) } ];
    Lino.vat.InvoicesByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.InvoicesByJournal.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.vat.InvoicesByJournal.insertPanel = Ext.extend(Lino.vat.InvoicesByJournal.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/vat/InvoicesByJournal",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.InvoicesByJournal.detail;
    this.ls_insert_handler = Lino.vat.InvoicesByJournal.insert;
    Lino.vat.InvoicesByJournal.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.InvoicesByJournal.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.vat.InvoicesByJournal.insertPanel(p);
});
Lino.vat.InvoicesByJournal.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.vat.InvoicesByJournal.detailPanel = Ext.extend(Lino.vat.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/vat/InvoicesByJournal",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.InvoicesByJournal.detail;
    this.ls_insert_handler = Lino.vat.InvoicesByJournal.insert;
    Lino.vat.InvoicesByJournal.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.InvoicesByJournal.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.InvoicesByJournal.detailPanel(p);
});
Lino.vat.InvoicesByJournal.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.vat.InvoicesByJournal.ParamsPanel({});
  return new Lino.vat.InvoicesByJournal.GridPanel(p);
});
Lino.vat.InvoicesByJournal.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/InvoicesByJournal", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class vat.PrintableInvoicesByJournal
Lino.vat.PrintableInvoicesByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/vat/PrintableInvoicesByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/PrintableInvoicesByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/PrintableInvoicesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/PrintableInvoicesByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/PrintableInvoicesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/PrintableInvoicesByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Purchase journal",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "number", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "total_base" }, { "name": "total_vat" }, { "name": "total_incl" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "your_ref" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "number_with_year" }, { "name": "journal" }, 'journalHidden' ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.PrintableInvoicesByJournal.detail;
    this.ls_insert_handler = Lino.vat.Invoices.insert;
    var ww = this.containing_window;
    var number6106 = new Ext.form.NumberField({ "selectOnFocus": true });
    var entry_date6107 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var partner6108 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/PrintableInvoicesByJournal/partner" }) }) });
    var total_base6109 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat6110 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_incl6111 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var vat_regime6112 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var id6113 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user6114 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/PrintableInvoicesByJournal/user" }) }) });
    var voucher_date6115 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period6116 = new Lino.RemoteComboFieldElement({ "emptyText": "Buchungsperiode ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 10, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/PrintableInvoicesByJournal/accounting_period" }) }) });
    var narration6117 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state6118 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var payment_term6119 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/PrintableInvoicesByJournal/payment_term" }) }) });
    var match6120 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/PrintableInvoicesByJournal/match" }) }) });
    var your_ref6121 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var due_date6122 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var mobile_item_disp6123 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6124 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6125 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var number_with_year_disp6126 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal6127 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Journal ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/PrintableInvoicesByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      journal6127.on('change',Lino.chooser_handler(match6120,'journal'));
      partner6108.on('change',Lino.chooser_handler(match6120,'partner'));
      Lino.vat.PrintableInvoicesByJournal.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "number", "editable": true, "editor": number6106, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(vat.PrintableInvoicesByJournal.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "entry_date", "editable": true, "editor": entry_date6107, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": true, "tooltip": "(vat.PrintableInvoicesByJournal.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "partner", "editable": true, "editor": partner6108, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(vat.PrintableInvoicesByJournal.partner) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "total_base", "editable": true, "editor": total_base6109, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "sortable": true, "tooltip": "(vat.PrintableInvoicesByJournal.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "total_vat", "editable": true, "editor": total_vat6110, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "sortable": true, "tooltip": "(vat.PrintableInvoicesByJournal.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "total_incl", "editable": true, "editor": total_incl6111, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(vat.PrintableInvoicesByJournal.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime6112, "filter": { "type": "string" }, "header": "MwSt.-Regime", "sortable": false, "tooltip": "(vat.PrintableInvoicesByJournal.vat_regime) ", "width": Lino.chars2width(19) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id6113, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(vat.PrintableInvoicesByJournal.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user6114, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(vat.PrintableInvoicesByJournal.user) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date6115, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "hidden": true, "sortable": true, "tooltip": "(vat.PrintableInvoicesByJournal.voucher_date) The date on the voucher (i.e. when it has been issued by its\nemitter).", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period6116, "filter": { "type": "string" }, "header": "Buchungsperiode", "hidden": true, "sortable": false, "tooltip": "(vat.PrintableInvoicesByJournal.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "narration", "editable": true, "editor": narration6117, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": true, "tooltip": "(vat.PrintableInvoicesByJournal.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "state", "editable": true, "editor": state6118, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(vat.PrintableInvoicesByJournal.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(14) }, { "colIndex": 13, "dataIndex": "payment_term", "editable": true, "editor": payment_term6119, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(vat.PrintableInvoicesByJournal.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "match", "editable": true, "editor": match6120, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(vat.PrintableInvoicesByJournal.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 15, "dataIndex": "your_ref", "editable": true, "editor": your_ref6121, "filter": { "type": "string" }, "header": "Ihr Zeichen", "hidden": true, "sortable": true, "tooltip": "(vat.PrintableInvoicesByJournal.your_ref) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "due_date", "editable": true, "editor": due_date6122, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Zahlungsziel", "hidden": true, "sortable": true, "tooltip": "(vat.PrintableInvoicesByJournal.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 17, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(vat.PrintableInvoicesByJournal.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(vat.PrintableInvoicesByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(vat.PrintableInvoicesByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "number_with_year", "editable": false, "header": "Nr.", "hidden": true, "sortable": false, "tooltip": "(vat.PrintableInvoicesByJournal.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 21, "dataIndex": "journal", "editable": true, "editor": journal6127, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "renderer": Lino.fk_renderer('journalHidden','Lino.ledger.Journals.detail'), "sortable": false, "tooltip": "(vat.PrintableInvoicesByJournal.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) } ];
    Lino.vat.PrintableInvoicesByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.PrintableInvoicesByJournal.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/PrintableInvoicesByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.PrintableInvoicesByJournal.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/PrintableInvoicesByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.PrintableInvoicesByJournal.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/PrintableInvoicesByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.PrintableInvoicesByJournal.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/PrintableInvoicesByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.PrintableInvoicesByJournal.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/PrintableInvoicesByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.PrintableInvoicesByJournal.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/PrintableInvoicesByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.vat.PrintableInvoicesByJournal.detailPanel = Ext.extend(Lino.vat.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/vat/PrintableInvoicesByJournal",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.PrintableInvoicesByJournal.detail;
    this.ls_insert_handler = Lino.vat.Invoices.insert;
    Lino.vat.PrintableInvoicesByJournal.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.PrintableInvoicesByJournal.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.PrintableInvoicesByJournal.detailPanel(p);
});
Lino.vat.PrintableInvoicesByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.vat.PrintableInvoicesByJournal.ParamsPanel({});
  return new Lino.vat.PrintableInvoicesByJournal.GridPanel(p);
});
Lino.vat.PrintableInvoicesByJournal.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/PrintableInvoicesByJournal", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.PrintableInvoicesByJournal.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/PrintableInvoicesByJournal", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.PrintableInvoicesByJournal.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/PrintableInvoicesByJournal", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.PrintableInvoicesByJournal.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/PrintableInvoicesByJournal", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.PrintableInvoicesByJournal.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/PrintableInvoicesByJournal", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class vat.ItemsByInvoice
Lino.vat.ItemsByInvoice.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 9,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/vat/ItemsByInvoice",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/ItemsByInvoice','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/ItemsByInvoice','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/ItemsByInvoice','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/ItemsByInvoice','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/ItemsByInvoice','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Inhalt",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "account" }, 'accountHidden', { "name": "title" }, { "name": "vat_class" }, 'vat_classHidden', { "name": "total_base" }, { "name": "total_vat" }, { "name": "total_incl" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 43,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var account6129 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Konto ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/ItemsByInvoice/account" }) }) });
    var title6130 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var vat_class6131 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var total_base6132 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat6133 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_incl6134 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      account6129.setContextValue('mk',bp['mk']);
      account6129.setContextValue('mt',bp['mt']);
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "account", "editable": true, "editor": account6129, "filter": { "type": "string" }, "header": "Konto", "sortable": false, "tooltip": "(vat.ItemsByInvoice.account) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "title", "editable": true, "editor": title6130, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(vat.ItemsByInvoice.title) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "vat_class", "editable": true, "editor": vat_class6131, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "sortable": false, "tooltip": "(vat.ItemsByInvoice.vat_class) ", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 3, "dataIndex": "total_base", "editable": true, "editor": total_base6132, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "sortable": true, "tooltip": "(vat.ItemsByInvoice.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "total_vat", "editable": true, "editor": total_vat6133, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "sortable": true, "tooltip": "(vat.ItemsByInvoice.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "total_incl", "editable": true, "editor": total_incl6134, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": true, "tooltip": "(vat.ItemsByInvoice.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.vat.ItemsByInvoice.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.ItemsByInvoice.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/ItemsByInvoice", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/ItemsByInvoice", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/ItemsByInvoice", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/ItemsByInvoice", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/ItemsByInvoice", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/ItemsByInvoice", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/ItemsByInvoice", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/ItemsByInvoice", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/ItemsByInvoice", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.ItemsByInvoice.GridPanel(p);
});
Lino.vat.ItemsByInvoice.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/ItemsByInvoice", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/ItemsByInvoice", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.LinesByTopic
Lino.courses.LinesByTopic.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 40,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/LinesByTopic",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByTopic','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByTopic','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByTopic','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByTopic','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByTopic','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Aktivit\u00e4tenreihen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "topic" }, 'topicHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "guest_role" }, 'guest_roleHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "excerpt_title" }, { "name": "excerpt_title_de" }, { "name": "excerpt_title_fr" }, { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "fee" }, 'feeHidden', { "name": "options_cat" }, 'options_catHidden', { "name": "fees_cat" }, 'fees_catHidden', { "name": "body_template" }, { "name": "course_type" }, 'course_typeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 15,
  ls_grid_configs : [  ],
  content_type : 57,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.LinesByTopic.detail;
    this.ls_insert_handler = Lino.courses.LinesByTopic.insert;
    var ww = this.containing_window;
    var ref3832 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name3833 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de3834 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr3835 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var topic3836 = new Lino.RemoteComboFieldElement({ "emptyText": "Thema ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/topic" }) }) });
    var course_area3837 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.courses.CourseAreas });
    var event_type3838 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/event_type" }) }) });
    var guest_role3839 = new Lino.RemoteComboFieldElement({ "emptyText": "Gastrolle ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/guest_role" }) }) });
    var every_unit3840 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every3841 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var id3842 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var company3843 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/company" }) }) });
    var contact_person3844 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/contact_person" }) }) });
    var contact_role3845 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/contact_role" }) }) });
    var excerpt_title3846 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var excerpt_title_de3847 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var excerpt_title_fr3848 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var description3849 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de3850 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr3851 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var fee3852 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/fee" }) }) });
    var options_cat3853 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarifkategorie ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/options_cat" }) }) });
    var fees_cat3854 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarifkategorie ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/fees_cat" }) }) });
    var body_template3855 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/body_template" }) }) });
    var course_type3856 = new Lino.RemoteComboFieldElement({ "emptyText": "Aktivit\u00e4tsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/course_type" }) }) });
    var mobile_item_disp3857 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3858 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp3859 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      contact_person3844.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      fee3852.setContextValue('fees_cat', record ? record.data['fees_catHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company3843.on('change',Lino.chooser_handler(contact_person3844,'company'));
      fees_cat3854.on('change',Lino.chooser_handler(fee3852,'fees_cat'));
      Lino.courses.LinesByTopic.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref3832, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(courses.LinesByTopic.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name3833, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(courses.LinesByTopic.name) The designation of this activity line as seen by the user\ne.g. when selecting the line.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de3834, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(courses.LinesByTopic.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr3835, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(courses.LinesByTopic.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "topic", "editable": true, "editor": topic3836, "filter": { "type": "string" }, "header": "Thema", "renderer": Lino.fk_renderer('topicHidden','Lino.courses.Topics.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.topic) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "course_area", "editable": true, "editor": course_area3837, "filter": { "type": "string" }, "header": "Layout", "sortable": false, "tooltip": "(courses.LinesByTopic.course_area) Pointer to CourseAreas.  This is used only when an\napplication defines several variants of\nEnrolmentsByPupil.", "width": Lino.chars2width(14) }, { "colIndex": 6, "dataIndex": "event_type", "editable": true, "editor": event_type3838, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.event_type) The type of calendar entries to be generated. If this is empty, no calendar entries will be generated.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "guest_role", "editable": true, "editor": guest_role3839, "filter": { "type": "string" }, "header": "Anwesenheiten erfassen als", "renderer": Lino.fk_renderer('guest_roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.guest_role) The default guest role for particpants of calendar entries for activities in this series. Leave empty if you don't want any presences management.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "every_unit", "editable": true, "editor": every_unit3840, "filter": { "type": "string" }, "header": "Wiederholung", "sortable": false, "tooltip": "(courses.LinesByTopic.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 9, "dataIndex": "every", "editable": true, "editor": every3841, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "sortable": true, "tooltip": "(courses.LinesByTopic.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 10, "dataIndex": "id", "editable": true, "editor": id3842, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByTopic.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "company", "editable": true, "editor": company3843, "filter": { "type": "string" }, "header": "Organisation", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.company) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "contact_person", "editable": true, "editor": contact_person3844, "filter": { "type": "string" }, "header": "Vertreten durch", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "contact_role", "editable": true, "editor": contact_role3845, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "excerpt_title", "editable": true, "editor": excerpt_title3846, "filter": { "type": "string" }, "header": "Excerpt title", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByTopic.excerpt_title) The title to be used when printing an excerpt.", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "excerpt_title_de", "editable": true, "editor": excerpt_title_de3847, "filter": { "type": "string" }, "header": "Excerpt title (de)", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByTopic.excerpt_title_de) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "excerpt_title_fr", "editable": true, "editor": excerpt_title_fr3848, "filter": { "type": "string" }, "header": "Excerpt title (fr)", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByTopic.excerpt_title_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "description", "editable": true, "editor": description3849, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.description) ", "width": Lino.chars2width(61) }, { "colIndex": 18, "dataIndex": "description_de", "editable": true, "editor": description_de3850, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 19, "dataIndex": "description_fr", "editable": true, "editor": description_fr3851, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 20, "dataIndex": "fee", "editable": true, "editor": fee3852, "filter": { "type": "string" }, "header": "Teilnahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.fee) ", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "options_cat", "editable": true, "editor": options_cat3853, "filter": { "type": "string" }, "header": "Kategorie f\u00fcr Optionen", "hidden": true, "renderer": Lino.fk_renderer('options_catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.options_cat) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "fees_cat", "editable": true, "editor": fees_cat3854, "filter": { "type": "string" }, "header": "Kategorie f\u00fcr Teilnahmegeb\u00fchren", "hidden": true, "renderer": Lino.fk_renderer('fees_catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.fees_cat) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "body_template", "editable": true, "editor": body_template3855, "filter": { "type": "string" }, "header": "Textk\u00f6rper-Vorlage", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.body_template) The body template to use when printing a course of this series. Leave empty to use the site's default.", "width": Lino.chars2width(11) }, { "colIndex": 24, "dataIndex": "course_type", "editable": true, "editor": course_type3856, "filter": { "type": "string" }, "header": "Aktivit\u00e4tsart", "hidden": true, "renderer": Lino.fk_renderer('course_typeHidden','Lino.courses.CourseTypes.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.course_type) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.courses.LinesByTopic.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.LinesByTopic.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByTopic", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByTopic", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByTopic", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByTopic", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByTopic", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.LinesByTopic.insertPanel = Ext.extend(Lino.courses.Lines.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/LinesByTopic",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.LinesByTopic.detail;
    this.ls_insert_handler = Lino.courses.LinesByTopic.insert;
    Lino.courses.LinesByTopic.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.LinesByTopic.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(16), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.LinesByTopic.insertPanel(p);
});
Lino.courses.LinesByTopic.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByTopic", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByTopic", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByTopic", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByTopic", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.LinesByTopic.detailPanel = Ext.extend(Lino.courses.Lines.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/courses/LinesByTopic",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.LinesByTopic.detail;
    this.ls_insert_handler = Lino.courses.LinesByTopic.insert;
    Lino.courses.LinesByTopic.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.LinesByTopic.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.LinesByTopic.detailPanel(p);
});
Lino.courses.LinesByTopic.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByTopic", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.LinesByTopic.GridPanel(p);
});
Lino.courses.LinesByTopic.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByTopic", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EntriesByTeacher
Lino.courses.EntriesByTeacher.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 7,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EntriesByTeacher",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByTeacher','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByTeacher','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByTeacher','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByTeacher','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByTeacher','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Kalendereintr\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "when_text" }, { "name": "owner" }, { "name": "room" }, 'roomHidden', { "name": "state" }, 'stateHidden', { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EntriesByTeacher.detail;
    this.ls_insert_handler = Lino.courses.EntriesByTeacher.insert;
    var ww = this.containing_window;
    var when_text_disp2893 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var owner_disp2894 = new Ext.form.DisplayField({ "disabled": true });
    var room2895 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByTeacher/room" }) }) });
    var state2896 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(courses.EntriesByTeacher.when_text) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "sortable": false, "tooltip": "(courses.EntriesByTeacher.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "room", "editable": true, "editor": room2895, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.EntriesByTeacher.room) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "state", "editable": true, "editor": state2896, "filter": { "type": "string" }, "header": "Zustand", "sortable": false, "tooltip": "(courses.EntriesByTeacher.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) } ];
    Lino.courses.EntriesByTeacher.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EntriesByTeacher.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EntriesByTeacher.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/EntriesByTeacher",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EntriesByTeacher.detail;
    this.ls_insert_handler = Lino.courses.EntriesByTeacher.insert;
    Lino.courses.EntriesByTeacher.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EntriesByTeacher.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EntriesByTeacher.insertPanel(p);
});
Lino.courses.EntriesByTeacher.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EntriesByTeacher.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/EntriesByTeacher",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EntriesByTeacher.detail;
    this.ls_insert_handler = Lino.courses.EntriesByTeacher.insert;
    Lino.courses.EntriesByTeacher.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EntriesByTeacher.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EntriesByTeacher.detailPanel(p);
});
Lino.courses.EntriesByTeacher.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.courses.EntriesByTeacher.GridPanel(p);
});
Lino.courses.EntriesByTeacher.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByTeacher.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByTeacher", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.CoursesByTeacher
Lino.courses.CoursesByTeacher.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 58,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/CoursesByTeacher",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTeacher','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTeacher','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTeacher','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTeacher','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTeacher','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Aktivit\u00e4ten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "name": "end_time" }, { "name": "line" }, 'lineHidden', { "name": "room" }, 'roomHidden', { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "teacher" }, 'teacherHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByTeacher.detail;
    this.ls_insert_handler = Lino.courses.CoursesByTeacher.insert;
    var ww = this.containing_window;
    var start_date2899 = new Lino.DateField({ "selectOnFocus": true });
    var start_time2900 = new Lino.TimeField({ "selectOnFocus": true });
    var end_time2901 = new Lino.TimeField({ "selectOnFocus": true });
    var line2902 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/line" }) }) });
    var room2903 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/room" }) }) });
    var id2904 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref2905 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var end_date2906 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var user2907 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/user" }) }) });
    var every_unit2908 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every2909 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday2910 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday2911 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday2912 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday2913 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday2914 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday2915 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday2916 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events2917 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date2918 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var slot2919 = new Lino.RemoteComboFieldElement({ "emptyText": "Timetable Slot ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/slot" }) }) });
    var description2920 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de2921 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr2922 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark2923 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state2924 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places2925 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name2926 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until2927 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee2928 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/fee" }) }) });
    var payment_term2929 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/payment_term" }) }) });
    var paper_type2930 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/paper_type" }) }) });
    var mobile_item_disp2931 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2932 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2933 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp2934 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments2935 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp2936 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested2937 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed2938 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox2939 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Anwesenheiten", "value": "<br/>" });
    var trying2940 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places2941 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var what_text_disp2942 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp2943 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp2944 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration2945 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    var teacher2946 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/teacher" }) }) });
    this.before_row_edit = function(record) {
      fee2928.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox2939.refresh();
    };
    this.onRender = function(ct, position) {
      line2902.on('change',Lino.chooser_handler(fee2928,'line'));
      Lino.courses.CoursesByTeacher.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date2899, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.CoursesByTeacher.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "start_time", "editable": true, "editor": start_time2900, "header": "Start time", "sortable": true, "tooltip": "(courses.CoursesByTeacher.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "end_time", "editable": true, "editor": end_time2901, "header": "Endet um", "sortable": true, "tooltip": "(courses.CoursesByTeacher.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 3, "dataIndex": "line", "editable": true, "editor": line2902, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.CoursesByTeacher.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "room", "editable": true, "editor": room2903, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.CoursesByTeacher.room) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id2904, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "ref", "editable": true, "editor": ref2905, "filter": { "type": "string" }, "header": "Referenz", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "end_date", "editable": true, "editor": end_date2906, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user2907, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.CoursesByTeacher.user) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "every_unit", "editable": true, "editor": every_unit2908, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 10, "dataIndex": "every", "editable": true, "editor": every2909, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 12, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 18, "dataIndex": "max_events", "editable": true, "editor": max_events2917, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 19, "dataIndex": "max_date", "editable": true, "editor": max_date2918, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 20, "dataIndex": "slot", "editable": true, "editor": slot2919, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "renderer": Lino.fk_renderer('slotHidden','Lino.courses.Slots.detail'), "sortable": false, "tooltip": "(courses.CoursesByTeacher.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "description", "editable": true, "editor": description2920, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.description) ", "width": Lino.chars2width(61) }, { "colIndex": 22, "dataIndex": "description_de", "editable": true, "editor": description_de2921, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 23, "dataIndex": "description_fr", "editable": true, "editor": description_fr2922, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 24, "dataIndex": "remark", "editable": true, "editor": remark2923, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "state", "editable": true, "editor": state2924, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 26, "dataIndex": "max_places", "editable": true, "editor": max_places2925, "filter": { "type": "numeric" }, "format": "0", "header": "Verf\u00fcgbare Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.max_places) Maximum number of participants", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 27, "dataIndex": "name", "editable": true, "editor": name2926, "filter": { "type": "string" }, "header": "Bezeichnung", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 28, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until2927, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Einschreibung m\u00f6glich bis", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 29, "dataIndex": "fee", "editable": true, "editor": fee2928, "filter": { "type": "string" }, "header": "Standard-Teilnehmahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.CoursesByTeacher.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 30, "dataIndex": "payment_term", "editable": true, "editor": payment_term2929, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.CoursesByTeacher.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 31, "dataIndex": "paper_type", "editable": true, "editor": paper_type2930, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 34, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "events_text", "editable": false, "header": "Kalendereintr\u00e4ge", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 36, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Einschreibungen", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.enrolments) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 37, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 38, "dataIndex": "requested", "editable": false, "format": "0", "header": "Angefragt", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.requested) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 39, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Best\u00e4tigt", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.confirmed) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 40, "dataIndex": "presences_box", "editable": false, "header": "Anwesenheiten", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 41, "dataIndex": "trying", "editable": false, "format": "0", "header": "Test", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.trying) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 42, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Freie Pl\u00e4tze", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.free_places) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 43, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 44, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 46, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 47, "dataIndex": "teacher", "editable": true, "editor": teacher2946, "filter": { "type": "string" }, "header": "Kursleiter", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.CoursesByTeacher.teacher) ", "width": Lino.chars2width(21) } ];
    Lino.courses.CoursesByTeacher.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByTeacher.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesByTeacher.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/CoursesByTeacher",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByTeacher.detail;
    this.ls_insert_handler = Lino.courses.CoursesByTeacher.insert;
    Lino.courses.CoursesByTeacher.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByTeacher.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.CoursesByTeacher.insertPanel(p);
});
Lino.courses.CoursesByTeacher.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesByTeacher.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/CoursesByTeacher",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByTeacher.detail;
    this.ls_insert_handler = Lino.courses.CoursesByTeacher.insert;
    Lino.courses.CoursesByTeacher.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByTeacher.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CoursesByTeacher.detailPanel(p);
});
Lino.courses.CoursesByTeacher.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.CoursesByTeacher.GridPanel(p);
});
Lino.courses.CoursesByTeacher.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTeacher", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.CoursesBySlot
Lino.courses.CoursesBySlot.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 58,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/CoursesBySlot",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesBySlot','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesBySlot','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesBySlot','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesBySlot','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesBySlot','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": null, "menu": [ { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)", "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Aktivit\u00e4ten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "name" }, { "name": "line" }, 'lineHidden', { "name": "teacher" }, 'teacherHidden', { "name": "room" }, 'roomHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "ref" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "what_text" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "duration" }, { "name": "slot" }, 'slotHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesBySlot.detail;
    this.ls_insert_handler = Lino.courses.CoursesBySlot.insert;
    var ww = this.containing_window;
    var start_date2730 = new Lino.DateField({ "selectOnFocus": true });
    var name2731 = new Ext.form.TextField({ "maxLength": 100, "selectOnFocus": true });
    var line2732 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/line" }) }) });
    var teacher2733 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/teacher" }) }) });
    var room2734 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/room" }) }) });
    var workflow_buttons_disp2735 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id2736 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref2737 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_time2738 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date2739 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time2740 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user2741 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/user" }) }) });
    var every_unit2742 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every2743 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday2744 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday2745 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday2746 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday2747 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday2748 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday2749 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday2750 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events2751 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date2752 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var description2753 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de2754 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr2755 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark2756 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state2757 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places2758 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var enrolments_until2759 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee2760 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/fee" }) }) });
    var payment_term2761 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/payment_term" }) }) });
    var paper_type2762 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/paper_type" }) }) });
    var mobile_item_disp2763 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2764 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp2765 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments2766 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp2767 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested2768 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed2769 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox2770 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Anwesenheiten", "value": "<br/>" });
    var trying2771 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places2772 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var what_text_disp2773 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var weekdays_text_disp2774 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp2775 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration2776 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    var slot2777 = new Lino.RemoteComboFieldElement({ "emptyText": "Timetable Slot ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/slot" }) }) });
    this.before_row_edit = function(record) {
      fee2760.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox2770.refresh();
    };
    this.onRender = function(ct, position) {
      line2732.on('change',Lino.chooser_handler(fee2760,'line'));
      Lino.courses.CoursesBySlot.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date2730, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.CoursesBySlot.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name2731, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(courses.CoursesBySlot.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "line", "editable": true, "editor": line2732, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.CoursesBySlot.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "teacher", "editable": true, "editor": teacher2733, "filter": { "type": "string" }, "header": "Kursleiter", "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.CoursesBySlot.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "room", "editable": true, "editor": room2734, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.CoursesBySlot.room) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.CoursesBySlot.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id2736, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "ref", "editable": true, "editor": ref2737, "filter": { "type": "string" }, "header": "Referenz", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time2738, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date2739, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time2740, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user2741, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.CoursesBySlot.user) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "every_unit", "editable": true, "editor": every_unit2742, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 13, "dataIndex": "every", "editable": true, "editor": every2743, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 14, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 20, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 21, "dataIndex": "max_events", "editable": true, "editor": max_events2751, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date2752, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "description", "editable": true, "editor": description2753, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.description) ", "width": Lino.chars2width(61) }, { "colIndex": 24, "dataIndex": "description_de", "editable": true, "editor": description_de2754, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_fr", "editable": true, "editor": description_fr2755, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "remark", "editable": true, "editor": remark2756, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "state", "editable": true, "editor": state2757, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 28, "dataIndex": "max_places", "editable": true, "editor": max_places2758, "filter": { "type": "numeric" }, "format": "0", "header": "Verf\u00fcgbare Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.max_places) Maximum number of participants", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 29, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until2759, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Einschreibung m\u00f6glich bis", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 30, "dataIndex": "fee", "editable": true, "editor": fee2760, "filter": { "type": "string" }, "header": "Standard-Teilnehmahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.CoursesBySlot.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 31, "dataIndex": "payment_term", "editable": true, "editor": payment_term2761, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.CoursesBySlot.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "paper_type", "editable": true, "editor": paper_type2762, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 34, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "events_text", "editable": false, "header": "Kalendereintr\u00e4ge", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 36, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Einschreibungen", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.enrolments) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 37, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 38, "dataIndex": "requested", "editable": false, "format": "0", "header": "Angefragt", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.requested) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 39, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Best\u00e4tigt", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.confirmed) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 40, "dataIndex": "presences_box", "editable": false, "header": "Anwesenheiten", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 41, "dataIndex": "trying", "editable": false, "format": "0", "header": "Test", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.trying) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 42, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Freie Pl\u00e4tze", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.free_places) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 43, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.what_text) ", "width": Lino.chars2width(31) }, { "colIndex": 44, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.times_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 46, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 47, "dataIndex": "slot", "editable": true, "editor": slot2777, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "renderer": Lino.fk_renderer('slotHidden','Lino.courses.Slots.detail'), "sortable": false, "tooltip": "(courses.CoursesBySlot.slot) ", "width": Lino.chars2width(21) } ];
    Lino.courses.CoursesBySlot.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesBySlot.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesBySlot.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/CoursesBySlot",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesBySlot.detail;
    this.ls_insert_handler = Lino.courses.CoursesBySlot.insert;
    Lino.courses.CoursesBySlot.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesBySlot.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.CoursesBySlot.insertPanel(p);
});
Lino.courses.CoursesBySlot.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesBySlot.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": null, "menu": [ { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)", "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/CoursesBySlot",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesBySlot.detail;
    this.ls_insert_handler = Lino.courses.CoursesBySlot.insert;
    Lino.courses.CoursesBySlot.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesBySlot.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CoursesBySlot.detailPanel(p);
});
Lino.courses.CoursesBySlot.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.CoursesBySlot.GridPanel(p);
});
Lino.courses.CoursesBySlot.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesBySlot", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsByOption
Lino.courses.EnrolmentsByOption.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 32,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsByOption",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByOption','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByOption','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByOption','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByOption','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByOption','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Enrolments using this option",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "course" }, 'courseHidden', { "name": "pupil" }, 'pupilHidden', { "name": "remark" }, { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "user" }, 'userHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "places", "type": "int", "useNull": true }, { "name": "confirmation_details" }, { "name": "amount" }, { "name": "fee" }, 'feeHidden', { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "printed" }, { "name": "option" }, 'optionHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByOption.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByOption.insert;
    var ww = this.containing_window;
    var course2055 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Activity ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByOption/course" }) }) });
    var pupil2056 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Teilnehmer ausw\u00e4hlen...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByOption/pupil" }) }) });
    var remark2057 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var request_date2058 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var id2059 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_date2060 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date2061 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var user2062 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByOption/user" }) }) });
    var printed_by2063 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area2064 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state2065 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var places2066 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 1 });
    var confirmation_details2067 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var amount2068 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var fee2069 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByOption/fee" }) }) });
    var free_events2070 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox2071 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Teilnehmer", "value": "<br/>" });
    var payment_info_disp2072 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp2073 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp2074 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2075 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2076 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp2077 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var option2078 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByOption/option" }) }) });
    this.before_row_edit = function(record) {
      course2055.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course2055.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil2056.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee2069.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      pupil_info_htmlbox2071.refresh();
      option2078.setContextValue('course', record ? record.data['courseHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      course_area2064.on('change',Lino.chooser_handler(course2055,'course_area'));
      request_date2058.on('change',Lino.chooser_handler(course2055,'request_date'));
      course2055.on('change',Lino.chooser_handler(pupil2056,'course'));
      course2055.on('change',Lino.chooser_handler(fee2069,'course'));
      course2055.on('change',Lino.chooser_handler(option2078,'course'));
      Lino.courses.EnrolmentsByOption.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "course", "editable": true, "editor": course2055, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByOption.course) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "pupil", "editable": true, "editor": pupil2056, "filter": { "type": "string" }, "header": "Teilnehmer", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByOption.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "remark", "editable": true, "editor": remark2057, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(courses.EnrolmentsByOption.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "request_date", "editable": true, "editor": request_date2058, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum der Anfrage", "sortable": true, "tooltip": "(courses.EnrolmentsByOption.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id2059, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByOption.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "start_date", "editable": true, "editor": start_date2060, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByOption.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "end_date", "editable": true, "editor": end_date2061, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enddatum", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByOption.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user2062, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByOption.user) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByOption.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 10, "dataIndex": "state", "editable": true, "editor": state2065, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 11, "dataIndex": "places", "editable": true, "editor": places2066, "filter": { "type": "numeric" }, "format": "0", "header": "Anz. Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByOption.places) The number of participants in this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 12, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details2067, "filter": { "type": "string" }, "header": "Details Best\u00e4tigung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.confirmation_details) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 13, "dataIndex": "amount", "editable": true, "editor": amount2068, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByOption.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 14, "dataIndex": "fee", "editable": true, "editor": fee2069, "filter": { "type": "string" }, "header": "Tarif", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByOption.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 15, "dataIndex": "free_events", "editable": true, "editor": free_events2070, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByOption.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 16, "dataIndex": "pupil_info", "editable": false, "header": "Teilnehmer", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "payment_info", "editable": false, "header": "Info Buchhaltung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "invoicing_info", "editable": false, "header": "Info Fakturation", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "option", "editable": true, "editor": option2078, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByOption.option) ", "width": Lino.chars2width(21) } ];
    Lino.courses.EnrolmentsByOption.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByOption.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByOption.insertPanel = Ext.extend(Lino.courses.Enrolments.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/EnrolmentsByOption",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByOption.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByOption.insert;
    Lino.courses.EnrolmentsByOption.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByOption.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsByOption.insertPanel(p);
});
Lino.courses.EnrolmentsByOption.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByOption.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsByOption",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByOption.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByOption.insert;
    Lino.courses.EnrolmentsByOption.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByOption.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsByOption.detailPanel(p);
});
Lino.courses.EnrolmentsByOption.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.create_excerpt9 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.create_excerpt10 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsByOption.GridPanel(p);
});
Lino.courses.EnrolmentsByOption.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByOption", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsByPupil
Lino.courses.EnrolmentsByPupil.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 32,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsByPupil",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByPupil','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByPupil','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByPupil','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByPupil','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByPupil','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Einschreibungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "course" }, 'courseHidden', { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "places", "type": "int", "useNull": true }, { "name": "remark" }, { "name": "amount" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "option" }, 'optionHidden', { "name": "confirmation_details" }, { "name": "fee" }, 'feeHidden', { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "pupil" }, 'pupilHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByPupil.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByPupil.insert;
    var ww = this.containing_window;
    var request_date1840 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var course1841 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Activity ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/course" }) }) });
    var start_date1842 = new Lino.DateField({ "selectOnFocus": true });
    var end_date1843 = new Lino.DateField({ "selectOnFocus": true });
    var places1844 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var remark1845 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var amount1846 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp1847 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id1848 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user1849 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/user" }) }) });
    var printed_by1850 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area1851 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state1852 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var option1853 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/option" }) }) });
    var confirmation_details1854 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var fee1855 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/fee" }) }) });
    var free_events1856 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox1857 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Teilnehmer", "value": "<br/>" });
    var payment_info_disp1858 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp1859 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp1860 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1861 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp1862 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var pupil1863 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Teilnehmer ausw\u00e4hlen...", "forceSelection": false, "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/pupil" }) }) });
    this.before_row_edit = function(record) {
      course1841.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course1841.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      option1853.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee1855.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      pupil_info_htmlbox1857.refresh();
      pupil1863.setContextValue('course', record ? record.data['courseHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      course_area1851.on('change',Lino.chooser_handler(course1841,'course_area'));
      request_date1840.on('change',Lino.chooser_handler(course1841,'request_date'));
      course1841.on('change',Lino.chooser_handler(option1853,'course'));
      course1841.on('change',Lino.chooser_handler(fee1855,'course'));
      course1841.on('change',Lino.chooser_handler(pupil1863,'course'));
      Lino.courses.EnrolmentsByPupil.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date1840, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum der Anfrage", "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "course", "editable": true, "editor": course1841, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.course) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "start_date", "editable": true, "editor": start_date1842, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "end_date", "editable": true, "editor": end_date1843, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enddatum", "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "places", "editable": true, "editor": places1844, "filter": { "type": "numeric" }, "format": "0", "header": "Anz. Pl\u00e4tze", "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.places) The number of participants in this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark1845, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 6, "dataIndex": "amount", "editable": true, "editor": amount1846, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id1848, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 9, "dataIndex": "user", "editable": true, "editor": user1849, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.user) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 12, "dataIndex": "state", "editable": true, "editor": state1852, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "colIndex": 13, "dataIndex": "option", "editable": true, "editor": option1853, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.option) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details1854, "filter": { "type": "string" }, "header": "Details Best\u00e4tigung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.confirmation_details) ", "width": Lino.chars2width(61) }, { "colIndex": 15, "dataIndex": "fee", "editable": true, "editor": fee1855, "filter": { "type": "string" }, "header": "Tarif", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 16, "dataIndex": "free_events", "editable": true, "editor": free_events1856, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 17, "dataIndex": "pupil_info", "editable": false, "header": "Teilnehmer", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "payment_info", "editable": false, "header": "Info Buchhaltung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "invoicing_info", "editable": false, "header": "Info Fakturation", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "pupil", "editable": true, "editor": pupil1863, "filter": { "type": "string" }, "header": "Teilnehmer", "hidden": true, "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.pupil) ", "width": Lino.chars2width(21) } ];
    Lino.courses.EnrolmentsByPupil.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByPupil.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByPupil.insertPanel = Ext.extend(Lino.courses.EnrolmentsByPupil.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/EnrolmentsByPupil",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByPupil.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByPupil.insert;
    Lino.courses.EnrolmentsByPupil.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByPupil.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsByPupil.insertPanel(p);
});
Lino.courses.EnrolmentsByPupil.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByPupil.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsByPupil",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByPupil.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByPupil.insert;
    Lino.courses.EnrolmentsByPupil.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByPupil.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsByPupil.detailPanel(p);
});
Lino.courses.EnrolmentsByPupil.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.create_excerpt10 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.create_excerpt9 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsByPupil.GridPanel(p);
});
Lino.courses.EnrolmentsByPupil.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByPupil", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsByCourse
Lino.courses.EnrolmentsByCourse.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 32,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsByCourse",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByCourse','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByCourse','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByCourse','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByCourse','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByCourse','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Einschreibungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "pupil" }, 'pupilHidden', { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "places", "type": "int", "useNull": true }, { "name": "remark" }, { "name": "fee" }, 'feeHidden', { "name": "free_events", "type": "int", "useNull": true }, { "name": "amount" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "option" }, 'optionHidden', { "name": "confirmation_details" }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "course" }, 'courseHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 12,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByCourse.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByCourse.insert;
    var ww = this.containing_window;
    var request_date6136 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var pupil6137 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Teilnehmer ausw\u00e4hlen...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/pupil" }) }) });
    var start_date6138 = new Lino.DateField({ "selectOnFocus": true });
    var end_date6139 = new Lino.DateField({ "selectOnFocus": true });
    var places6140 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var remark6141 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var fee6142 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/fee" }) }) });
    var free_events6143 = new Ext.form.NumberField({ "selectOnFocus": true });
    var amount6144 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp6145 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id6146 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user6147 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/user" }) }) });
    var printed_by6148 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area6149 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state6150 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var option6151 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/option" }) }) });
    var confirmation_details6152 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox6153 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Teilnehmer", "value": "<br/>" });
    var payment_info_disp6154 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp6155 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp6156 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6157 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp6158 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var course6159 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Activity ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/course" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      pupil6137.setContextValue('mk',bp['mk']);
      pupil6137.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      fee6142.setContextValue('mk',bp['mk']);
      fee6142.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      option6151.setContextValue('mk',bp['mk']);
      option6151.setContextValue('mt',bp['mt']);
      pupil_info_htmlbox6153.refresh();
      course6159.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course6159.setContextValue('request_date', record ? record.data['request_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      course6159.on('change',Lino.chooser_handler(pupil6137,'course'));
      course6159.on('change',Lino.chooser_handler(fee6142,'course'));
      course6159.on('change',Lino.chooser_handler(option6151,'course'));
      course_area6149.on('change',Lino.chooser_handler(course6159,'course_area'));
      request_date6136.on('change',Lino.chooser_handler(course6159,'request_date'));
      Lino.courses.EnrolmentsByCourse.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date6136, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum der Anfrage", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "pupil", "editable": true, "editor": pupil6137, "filter": { "type": "string" }, "header": "Teilnehmer", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "start_date", "editable": true, "editor": start_date6138, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "end_date", "editable": true, "editor": end_date6139, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enddatum", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "places", "editable": true, "editor": places6140, "filter": { "type": "numeric" }, "format": "0", "header": "Anz. Pl\u00e4tze", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.places) The number of participants in this enrolment.", "width": Lino.chars2width(9), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark6141, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "fee", "editable": true, "editor": fee6142, "filter": { "type": "string" }, "header": "Tarif", "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 7, "dataIndex": "free_events", "editable": true, "editor": free_events6143, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(9), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "amount", "editable": true, "editor": amount6144, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 10, "dataIndex": "id", "editable": true, "editor": id6146, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user6147, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.user) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 14, "dataIndex": "state", "editable": true, "editor": state6150, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "colIndex": 15, "dataIndex": "option", "editable": true, "editor": option6151, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.option) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details6152, "filter": { "type": "string" }, "header": "Details Best\u00e4tigung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.confirmation_details) ", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "pupil_info", "editable": false, "header": "Teilnehmer", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "payment_info", "editable": false, "header": "Info Buchhaltung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "invoicing_info", "editable": false, "header": "Info Fakturation", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "course", "editable": true, "editor": course6159, "filter": { "type": "string" }, "header": "Activity", "hidden": true, "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.course) ", "width": Lino.chars2width(21) } ];
    Lino.courses.EnrolmentsByCourse.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByCourse.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByCourse.insertPanel = Ext.extend(Lino.courses.EnrolmentsByCourse.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/EnrolmentsByCourse",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByCourse.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByCourse.insert;
    Lino.courses.EnrolmentsByCourse.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByCourse.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsByCourse.insertPanel(p);
});
Lino.courses.EnrolmentsByCourse.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByCourse.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsByCourse",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByCourse.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByCourse.insert;
    Lino.courses.EnrolmentsByCourse.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByCourse.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsByCourse.detailPanel(p);
});
Lino.courses.EnrolmentsByCourse.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.create_excerpt10 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.create_excerpt9 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsByCourse.GridPanel(p);
});
Lino.courses.EnrolmentsByCourse.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByCourse", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsByFee
Lino.courses.EnrolmentsByFee.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 32,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsByFee",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByFee','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByFee','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByFee','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByFee','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByFee','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Einschreibungen mit diesem Tarif",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "course" }, 'courseHidden', { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "pupil_info" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "places", "type": "int", "useNull": true }, { "name": "remark" }, { "name": "free_events", "type": "int", "useNull": true }, { "name": "amount" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "pupil" }, 'pupilHidden', { "name": "state" }, 'stateHidden', { "name": "option" }, 'optionHidden', { "name": "confirmation_details" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "printed" }, { "name": "fee" }, 'feeHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByFee.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByFee.insert;
    var ww = this.containing_window;
    var course6161 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Activity ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByFee/course" }) }) });
    var request_date6162 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var pupil_info_htmlbox6163 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Teilnehmer", "value": "<br/>" });
    var start_date6164 = new Lino.DateField({ "selectOnFocus": true });
    var end_date6165 = new Lino.DateField({ "selectOnFocus": true });
    var places6166 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var remark6167 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var free_events6168 = new Ext.form.NumberField({ "selectOnFocus": true });
    var amount6169 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var id6170 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user6171 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByFee/user" }) }) });
    var printed_by6172 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area6173 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var pupil6174 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Teilnehmer ausw\u00e4hlen...", "forceSelection": false, "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByFee/pupil" }) }) });
    var state6175 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var option6176 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByFee/option" }) }) });
    var confirmation_details6177 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_info_disp6178 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp6179 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp6180 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6181 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6182 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp6183 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var fee6184 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByFee/fee" }) }) });
    this.before_row_edit = function(record) {
      course6161.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course6161.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil_info_htmlbox6163.refresh();
      pupil6174.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      option6176.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee6184.setContextValue('course', record ? record.data['courseHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      course_area6173.on('change',Lino.chooser_handler(course6161,'course_area'));
      request_date6162.on('change',Lino.chooser_handler(course6161,'request_date'));
      course6161.on('change',Lino.chooser_handler(pupil6174,'course'));
      course6161.on('change',Lino.chooser_handler(option6176,'course'));
      course6161.on('change',Lino.chooser_handler(fee6184,'course'));
      Lino.courses.EnrolmentsByFee.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "course", "editable": true, "editor": course6161, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByFee.course) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "request_date", "editable": true, "editor": request_date6162, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum der Anfrage", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "pupil_info", "editable": false, "header": "Teilnehmer", "sortable": false, "tooltip": "(courses.EnrolmentsByFee.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "start_date", "editable": true, "editor": start_date6164, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "end_date", "editable": true, "editor": end_date6165, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enddatum", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "places", "editable": true, "editor": places6166, "filter": { "type": "numeric" }, "format": "0", "header": "Anz. Pl\u00e4tze", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.places) The number of participants in this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "remark", "editable": true, "editor": remark6167, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 7, "dataIndex": "free_events", "editable": true, "editor": free_events6168, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "amount", "editable": true, "editor": amount6169, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 9, "dataIndex": "id", "editable": true, "editor": id6170, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByFee.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 10, "dataIndex": "user", "editable": true, "editor": user6171, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByFee.user) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByFee.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 13, "dataIndex": "pupil", "editable": true, "editor": pupil6174, "filter": { "type": "string" }, "header": "Teilnehmer", "hidden": true, "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByFee.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "state", "editable": true, "editor": state6175, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "colIndex": 15, "dataIndex": "option", "editable": true, "editor": option6176, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByFee.option) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details6177, "filter": { "type": "string" }, "header": "Details Best\u00e4tigung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.confirmation_details) ", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "payment_info", "editable": false, "header": "Info Buchhaltung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "invoicing_info", "editable": false, "header": "Info Fakturation", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "fee", "editable": true, "editor": fee6184, "filter": { "type": "string" }, "header": "Tarif", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByFee.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) } ];
    Lino.courses.EnrolmentsByFee.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByFee.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByFee.insertPanel = Ext.extend(Lino.courses.EnrolmentsByCourse.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/EnrolmentsByFee",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByFee.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByFee.insert;
    Lino.courses.EnrolmentsByFee.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByFee.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsByFee.insertPanel(p);
});
Lino.courses.EnrolmentsByFee.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByFee.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsByFee",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByFee.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByFee.insert;
    Lino.courses.EnrolmentsByFee.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByFee.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsByFee.detailPanel(p);
});
Lino.courses.EnrolmentsByFee.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.create_excerpt9 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.create_excerpt10 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsByFee.GridPanel(p);
});
Lino.courses.EnrolmentsByFee.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByFee", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.TeachersByType
Lino.courses.TeachersByType.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 65,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/TeachersByType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/TeachersByType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/TeachersByType','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/TeachersByType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/courses/TeachersByType','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/TeachersByType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/TeachersByType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Kursleiter",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name_column" }, { "name": "address_column" }, { "name": "teacher_type" }, 'teacher_typeHidden', { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "prefix" }, { "name": "name" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_id" }, { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "title" }, { "name": "first_name" }, { "name": "middle_name" }, { "name": "last_name" }, { "name": "gender" }, 'genderHidden', { "name": "birth_date" }, { "name": "national_id" }, { "name": "birth_country" }, 'birth_countryHidden', { "name": "birth_place" }, { "name": "nationality" }, 'nationalityHidden', { "name": "card_number" }, { "dateFormat": "d.m.Y", "name": "card_valid_from", "type": "date" }, { "dateFormat": "d.m.Y", "name": "card_valid_until", "type": "date" }, { "name": "card_type" }, 'card_typeHidden', { "name": "card_issuer" }, { "name": "noble_condition" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "age" }, { "name": "mti_navigator" }, { "name": "debit_balance" }, { "name": "image" }, { "name": "eid_info" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.TeachersByType.detail;
    this.ls_insert_handler = Lino.courses.TeachersByType.insert;
    var ww = this.containing_window;
    var name_column_disp3567 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var address_column_disp3568 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var teacher_type3569 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiterart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/teacher_type" }) }) });
    var id3570 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email3571 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language3572 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var url3573 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone3574 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm3575 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax3576 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country3577 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/country" }) }) });
    var city3578 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/city" }) }) });
    var zip_code3579 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region3580 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/region" }) }) });
    var addr13581 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix3582 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street3583 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no3584 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box3585 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr23586 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var prefix3587 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name3588 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks3589 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term3590 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/payment_term" }) }) });
    var vat_regime3591 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_id3592 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var invoice_recipient3593 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/invoice_recipient" }) }) });
    var paper_type3594 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/paper_type" }) }) });
    var title3595 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var first_name3596 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var middle_name3597 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_name3598 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gender3599 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var birth_date3600 = new Lino.IncompleteDateField({ "hidden": true, "selectOnFocus": true });
    var national_id3601 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var birth_country3602 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/birth_country" }) }) });
    var birth_place3603 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var nationality3604 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/nationality" }) }) });
    var card_number3605 = new Ext.form.TextField({ "hidden": true, "maxLength": 20, "selectOnFocus": true });
    var card_valid_from3606 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_valid_until3607 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_type3608 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.beid.BeIdCardTypes) });
    var card_issuer3609 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var noble_condition3610 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var mobile_item_disp3611 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3612 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp3613 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var age_disp3614 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp3615 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var debit_balance3616 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var image_htmlbox3617 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "image", "value": "<br/>" });
    var eid_info_disp3618 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      city3578.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city3578.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region3580.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      image_htmlbox3617.refresh();
    };
    this.onRender = function(ct, position) {
      country3577.on('change',Lino.chooser_handler(city3578,'country'));
      region3580.on('change',Lino.chooser_handler(city3578,'region'));
      country3577.on('change',Lino.chooser_handler(region3580,'country'));
      Lino.courses.TeachersByType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name_column", "editable": false, "header": "Name", "sortable": false, "tooltip": "(courses.TeachersByType.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "address_column", "editable": false, "header": "Adresse", "sortable": false, "tooltip": "(courses.TeachersByType.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "teacher_type", "editable": true, "editor": teacher_type3569, "filter": { "type": "string" }, "header": "Kursleiterart", "renderer": Lino.fk_renderer('teacher_typeHidden','Lino.courses.TeacherTypes.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.teacher_type) Pointer to TeacherType.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id3570, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "email", "editable": true, "editor": email3571, "filter": { "type": "string" }, "header": "E-Mail-Adresse", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "language", "editable": true, "editor": language3572, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "url", "editable": true, "editor": url3573, "filter": { "type": "string" }, "header": "Adresse (URL)", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.url) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "phone", "editable": true, "editor": phone3574, "filter": { "type": "string" }, "header": "Telefon", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "gsm", "editable": true, "editor": gsm3575, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "fax", "editable": true, "editor": fax3576, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "country", "editable": true, "editor": country3577, "filter": { "type": "string" }, "header": "Land", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.country) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "city", "editable": true, "editor": city3578, "filter": { "type": "string" }, "header": "Locality", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.city) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "zip_code", "editable": true, "editor": zip_code3579, "filter": { "type": "string" }, "header": "Postleitzahl", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 13, "dataIndex": "region", "editable": true, "editor": region3580, "filter": { "type": "string" }, "header": "Regierungsbezirk", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.region) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "addr1", "editable": true, "editor": addr13581, "filter": { "type": "string" }, "header": "Adresszeile vor Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.addr1) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix3582, "filter": { "type": "string" }, "header": "Pr\u00e4fix Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.street_prefix) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "street", "editable": true, "editor": street3583, "filter": { "type": "string" }, "header": "Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.street) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "street_no", "editable": true, "editor": street_no3584, "filter": { "type": "string" }, "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.street_no) ", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "street_box", "editable": true, "editor": street_box3585, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.street_box) ", "width": Lino.chars2width(12) }, { "colIndex": 19, "dataIndex": "addr2", "editable": true, "editor": addr23586, "filter": { "type": "string" }, "header": "Adresszeile nach Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.addr2) ", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "prefix", "editable": true, "editor": prefix3587, "filter": { "type": "string" }, "header": "Name prefix", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.prefix) An optional name prefix. For organisations this is inserted\nbefore the name, for persons this is inserted between first\nname and last name (see\nlino.mixins.human.Human.get_last_name_prefix()).", "width": Lino.chars2width(22) }, { "colIndex": 21, "dataIndex": "name", "editable": true, "editor": name3588, "filter": { "type": "string" }, "header": "Name", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 22, "dataIndex": "remarks", "editable": true, "editor": remarks3589, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 23, "dataIndex": "payment_term", "editable": true, "editor": payment_term3590, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime3591, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 25, "dataIndex": "vat_id", "editable": true, "editor": vat_id3592, "filter": { "type": "string" }, "header": "MwSt.-Nr.", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 26, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient3593, "filter": { "type": "string" }, "header": "Fakturationsadresse", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "paper_type", "editable": true, "editor": paper_type3594, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 28, "dataIndex": "title", "editable": true, "editor": title3595, "filter": { "type": "string" }, "header": "Titel", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.title) Used to specify a professional position or academic\nqualification like \"Dr.\" or \"PhD\".", "width": Lino.chars2width(22) }, { "colIndex": 29, "dataIndex": "first_name", "editable": true, "editor": first_name3596, "filter": { "type": "string" }, "header": "Vorname", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.first_name) The first name, also known as given name.", "width": Lino.chars2width(22) }, { "colIndex": 30, "dataIndex": "middle_name", "editable": true, "editor": middle_name3597, "filter": { "type": "string" }, "header": "Zwischenname", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.middle_name) A space-separated list of all middle names.", "width": Lino.chars2width(22) }, { "colIndex": 31, "dataIndex": "last_name", "editable": true, "editor": last_name3598, "filter": { "type": "string" }, "header": "Familienname", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.last_name) The last name, also known as family name.", "width": Lino.chars2width(22) }, { "colIndex": 32, "dataIndex": "gender", "editable": true, "editor": gender3599, "filter": { "type": "string" }, "header": "Geschlecht", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.gender) The sex of this person (male or female).", "width": Lino.chars2width(10) }, { "colIndex": 33, "dataIndex": "birth_date", "editable": true, "editor": birth_date3600, "filter": { "type": "string" }, "header": "Geburtsdatum", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".", "width": Lino.chars2width(13) }, { "colIndex": 34, "dataIndex": "national_id", "editable": true, "editor": national_id3601, "filter": { "type": "string" }, "header": "NR-Nummer", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.", "width": Lino.chars2width(22) }, { "colIndex": 35, "dataIndex": "birth_country", "editable": true, "editor": birth_country3602, "filter": { "type": "string" }, "header": "Geburtsland", "hidden": true, "renderer": Lino.fk_renderer('birth_countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.birth_country) ", "width": Lino.chars2width(21) }, { "colIndex": 36, "dataIndex": "birth_place", "editable": true, "editor": birth_place3603, "filter": { "type": "string" }, "header": "Geburtsort", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.birth_place) ", "width": Lino.chars2width(22) }, { "colIndex": 37, "dataIndex": "nationality", "editable": true, "editor": nationality3604, "filter": { "type": "string" }, "header": "Staatsangeh\u00f6rigkeit", "hidden": true, "renderer": Lino.fk_renderer('nationalityHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.nationality) The nationality. This is a pointer to\ncountries.Country which should\ncontain also entries for refugee statuses.", "width": Lino.chars2width(21) }, { "colIndex": 38, "dataIndex": "card_number", "editable": true, "editor": card_number3605, "filter": { "type": "string" }, "header": "eID-Kartennummer", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.card_number) ", "width": Lino.chars2width(22) }, { "colIndex": 39, "dataIndex": "card_valid_from", "editable": true, "editor": card_valid_from3606, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "ID-Karte g\u00fcltig von", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.card_valid_from) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 40, "dataIndex": "card_valid_until", "editable": true, "editor": card_valid_until3607, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "bis", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.card_valid_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 41, "dataIndex": "card_type", "editable": true, "editor": card_type3608, "filter": { "type": "string" }, "header": "eID-Kartenart", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.card_type) ", "width": Lino.chars2width(42) }, { "colIndex": 42, "dataIndex": "card_issuer", "editable": true, "editor": card_issuer3609, "filter": { "type": "string" }, "header": "eID-Karte ausgestellt durch", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.card_issuer) ", "width": Lino.chars2width(22) }, { "colIndex": 43, "dataIndex": "noble_condition", "editable": true, "editor": noble_condition3610, "filter": { "type": "string" }, "header": "Adelstitel", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.noble_condition) Eventueller Adelstitel", "width": Lino.chars2width(22) }, { "colIndex": 44, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 47, "dataIndex": "age", "editable": false, "header": "Alter", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.age) ", "width": Lino.chars2width(31) }, { "colIndex": 48, "dataIndex": "mti_navigator", "editable": false, "header": "Ansicht als ", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.mti_navigator) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 49, "dataIndex": "debit_balance", "editable": false, "format": "0.000,00/i", "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.debit_balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 50, "dataIndex": "image", "editable": false, "header": "image", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.image) ", "width": Lino.chars2width(31) }, { "colIndex": 51, "dataIndex": "eid_info", "editable": false, "header": "eID-Karte", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.eid_info) ", "width": Lino.chars2width(31) } ];
    Lino.courses.TeachersByType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.TeachersByType.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.TeachersByType.insertPanel = Ext.extend(Lino.contacts.Persons.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/TeachersByType",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.TeachersByType.detail;
    this.ls_insert_handler = Lino.courses.TeachersByType.insert;
    Lino.courses.TeachersByType.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.TeachersByType.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.TeachersByType.insertPanel(p);
});
Lino.courses.TeachersByType.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.TeachersByType.detailPanel = Ext.extend(Lino.courses.Teachers.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/courses/TeachersByType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.TeachersByType.detail;
    this.ls_insert_handler = Lino.courses.TeachersByType.insert;
    Lino.courses.TeachersByType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.TeachersByType.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.TeachersByType.detailPanel(p);
});
Lino.courses.TeachersByType.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.create_excerpt1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.show_invoice_partners = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.courses.TeachersByType.GridPanel(p);
});
Lino.courses.TeachersByType.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.ins_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.ins_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.del_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.read_beid = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "POST", pk, "read_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.ins_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.del_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.del_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.ins_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.del_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.del_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.ins_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.find_by_beid = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/TeachersByType", "POST", pk, "find_by_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.PupilsByType
Lino.courses.PupilsByType.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 73,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/PupilsByType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/PupilsByType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/PupilsByType','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/PupilsByType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Etiketten", "overflowText": "Etiketten", "panel_btn_handler": Lino.list_action_handler('/courses/PupilsByType','print_labels','GET',Lino.get_current_grid_config), "text": "Etiketten", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/PupilsByType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/PupilsByType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-arrow_join", "itemId": "merge_row", "menu_item_text": "Fusionieren", "overflowText": "Fusionieren", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Pupils.merge_row), "tooltip": "Dieses Objekt in ein anderes Objekt der gleichen Klasse fusionieren." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Teilnehmer",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "name_column" }, { "name": "address_column" }, { "name": "pupil_type" }, 'pupil_typeHidden', { "name": "section" }, 'sectionHidden', { "name": "is_lfv", "type": "boolean" }, { "name": "is_ckk", "type": "boolean" }, { "name": "is_raviva", "type": "boolean" }, { "dateFormat": "d.m.Y", "name": "member_until", "type": "date" }, { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "prefix" }, { "name": "name" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "vat_id" }, { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "title" }, { "name": "first_name" }, { "name": "middle_name" }, { "name": "last_name" }, { "name": "gender" }, 'genderHidden', { "name": "birth_date" }, { "name": "national_id" }, { "name": "birth_country" }, 'birth_countryHidden', { "name": "birth_place" }, { "name": "nationality" }, 'nationalityHidden', { "name": "card_number" }, { "dateFormat": "d.m.Y", "name": "card_valid_from", "type": "date" }, { "dateFormat": "d.m.Y", "name": "card_valid_until", "type": "date" }, { "name": "card_type" }, 'card_typeHidden', { "name": "card_issuer" }, { "name": "noble_condition" }, { "name": "legacy_id" }, { "name": "is_member", "type": "boolean" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "age" }, { "name": "mti_navigator" }, { "name": "debit_balance" }, { "name": "image" }, { "name": "eid_info" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PupilsByType.detail;
    this.ls_insert_handler = Lino.courses.PupilsByType.insert;
    var ww = this.containing_window;
    var name_column_disp1707 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var address_column_disp1708 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var pupil_type1709 = new Lino.RemoteComboFieldElement({ "emptyText": "Teilnehmerart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/pupil_type" }) }) });
    var section1710 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.Sections) });
    var is_lfv1711 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var is_ckk1712 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var is_raviva1713 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var member_until1714 = new Lino.DateField({ "selectOnFocus": true });
    var id1715 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email1716 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language1717 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var url1718 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone1719 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm1720 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax1721 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country1722 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/country" }) }) });
    var city1723 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/city" }) }) });
    var zip_code1724 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region1725 = new Lino.RemoteComboFieldElement({ "emptyText": "Ort ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/region" }) }) });
    var addr11726 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix1727 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street1728 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no1729 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box1730 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr21731 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var prefix1732 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name1733 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks1734 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term1735 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/payment_term" }) }) });
    var vat_regime1736 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var vat_id1737 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var invoice_recipient1738 = new Lino.RemoteComboFieldElement({ "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/invoice_recipient" }) }) });
    var paper_type1739 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/paper_type" }) }) });
    var title1740 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var first_name1741 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var middle_name1742 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_name1743 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gender1744 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var birth_date1745 = new Lino.IncompleteDateField({ "hidden": true, "selectOnFocus": true });
    var national_id1746 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var birth_country1747 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/birth_country" }) }) });
    var birth_place1748 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var nationality1749 = new Lino.RemoteComboFieldElement({ "emptyText": "Land ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/nationality" }) }) });
    var card_number1750 = new Ext.form.TextField({ "hidden": true, "maxLength": 20, "selectOnFocus": true });
    var card_valid_from1751 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_valid_until1752 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_type1753 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.beid.BeIdCardTypes) });
    var card_issuer1754 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var noble_condition1755 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var legacy_id1756 = new Ext.form.TextField({ "hidden": true, "maxLength": 12, "selectOnFocus": true });
    var is_member1757 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var mobile_item_disp1758 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1759 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1760 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var age_disp1761 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp1762 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var debit_balance1763 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var image_htmlbox1764 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "image", "value": "<br/>" });
    var eid_info_disp1765 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      city1723.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city1723.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region1725.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      image_htmlbox1764.refresh();
    };
    this.onRender = function(ct, position) {
      country1722.on('change',Lino.chooser_handler(city1723,'country'));
      region1725.on('change',Lino.chooser_handler(city1723,'region'));
      country1722.on('change',Lino.chooser_handler(region1725,'country'));
      Lino.courses.PupilsByType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name_column", "editable": false, "header": "Name", "sortable": false, "tooltip": "(courses.PupilsByType.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "address_column", "editable": false, "header": "Adresse", "sortable": false, "tooltip": "(courses.PupilsByType.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "pupil_type", "editable": true, "editor": pupil_type1709, "filter": { "type": "string" }, "header": "Teilnehmerart", "renderer": Lino.fk_renderer('pupil_typeHidden','Lino.courses.PupilTypes.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.pupil_type) Pointer to PupilType.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "section", "editable": true, "editor": section1710, "filter": { "type": "string" }, "header": "Sektion", "sortable": false, "tooltip": "(courses.PupilsByType.section) ", "width": Lino.chars2width(14) }, { "colIndex": 4, "dataIndex": "is_lfv", "editable": true, "filter": { "type": "boolean" }, "header": "LFV", "sortable": false, "tooltip": "(courses.PupilsByType.is_lfv) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 5, "dataIndex": "is_ckk", "editable": true, "filter": { "type": "boolean" }, "header": "CKK", "sortable": false, "tooltip": "(courses.PupilsByType.is_ckk) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 6, "dataIndex": "is_raviva", "editable": true, "filter": { "type": "boolean" }, "header": "Raviva", "sortable": false, "tooltip": "(courses.PupilsByType.is_raviva) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 7, "dataIndex": "member_until", "editable": true, "editor": member_until1714, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Mitglied bis", "sortable": true, "tooltip": "(courses.PupilsByType.member_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id1715, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 9, "dataIndex": "email", "editable": true, "editor": email1716, "filter": { "type": "string" }, "header": "E-Mail-Adresse", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "language", "editable": true, "editor": language1717, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "url", "editable": true, "editor": url1718, "filter": { "type": "string" }, "header": "Adresse (URL)", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.url) ", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "phone", "editable": true, "editor": phone1719, "filter": { "type": "string" }, "header": "Telefon", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 13, "dataIndex": "gsm", "editable": true, "editor": gsm1720, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "fax", "editable": true, "editor": fax1721, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "country", "editable": true, "editor": country1722, "filter": { "type": "string" }, "header": "Land", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.country) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "city", "editable": true, "editor": city1723, "filter": { "type": "string" }, "header": "Locality", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.city) ", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "zip_code", "editable": true, "editor": zip_code1724, "filter": { "type": "string" }, "header": "Postleitzahl", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "region", "editable": true, "editor": region1725, "filter": { "type": "string" }, "header": "Regierungsbezirk", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.region) ", "width": Lino.chars2width(21) }, { "colIndex": 19, "dataIndex": "addr1", "editable": true, "editor": addr11726, "filter": { "type": "string" }, "header": "Adresszeile vor Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.addr1) ", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix1727, "filter": { "type": "string" }, "header": "Pr\u00e4fix Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.street_prefix) ", "width": Lino.chars2width(22) }, { "colIndex": 21, "dataIndex": "street", "editable": true, "editor": street1728, "filter": { "type": "string" }, "header": "Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.street) ", "width": Lino.chars2width(22) }, { "colIndex": 22, "dataIndex": "street_no", "editable": true, "editor": street_no1729, "filter": { "type": "string" }, "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.street_no) ", "width": Lino.chars2width(12) }, { "colIndex": 23, "dataIndex": "street_box", "editable": true, "editor": street_box1730, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.street_box) ", "width": Lino.chars2width(12) }, { "colIndex": 24, "dataIndex": "addr2", "editable": true, "editor": addr21731, "filter": { "type": "string" }, "header": "Adresszeile nach Stra\u00dfe", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.addr2) ", "width": Lino.chars2width(22) }, { "colIndex": 25, "dataIndex": "prefix", "editable": true, "editor": prefix1732, "filter": { "type": "string" }, "header": "Name prefix", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.prefix) An optional name prefix. For organisations this is inserted\nbefore the name, for persons this is inserted between first\nname and last name (see\nlino.mixins.human.Human.get_last_name_prefix()).", "width": Lino.chars2width(22) }, { "colIndex": 26, "dataIndex": "name", "editable": true, "editor": name1733, "filter": { "type": "string" }, "header": "Name", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 27, "dataIndex": "remarks", "editable": true, "editor": remarks1734, "filter": { "type": "string" }, "header": "Bemerkungen", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "payment_term", "editable": true, "editor": payment_term1735, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 29, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime1736, "filter": { "type": "string" }, "header": "MwSt.-Regime", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.vat_regime) ", "width": Lino.chars2width(19) }, { "colIndex": 30, "dataIndex": "vat_id", "editable": true, "editor": vat_id1737, "filter": { "type": "string" }, "header": "MwSt.-Nr.", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 31, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient1738, "filter": { "type": "string" }, "header": "Fakturationsadresse", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "paper_type", "editable": true, "editor": paper_type1739, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "title", "editable": true, "editor": title1740, "filter": { "type": "string" }, "header": "Titel", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.title) Used to specify a professional position or academic\nqualification like \"Dr.\" or \"PhD\".", "width": Lino.chars2width(22) }, { "colIndex": 34, "dataIndex": "first_name", "editable": true, "editor": first_name1741, "filter": { "type": "string" }, "header": "Vorname", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.first_name) The first name, also known as given name.", "width": Lino.chars2width(22) }, { "colIndex": 35, "dataIndex": "middle_name", "editable": true, "editor": middle_name1742, "filter": { "type": "string" }, "header": "Zwischenname", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.middle_name) A space-separated list of all middle names.", "width": Lino.chars2width(22) }, { "colIndex": 36, "dataIndex": "last_name", "editable": true, "editor": last_name1743, "filter": { "type": "string" }, "header": "Familienname", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.last_name) The last name, also known as family name.", "width": Lino.chars2width(22) }, { "colIndex": 37, "dataIndex": "gender", "editable": true, "editor": gender1744, "filter": { "type": "string" }, "header": "Geschlecht", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.gender) The sex of this person (male or female).", "width": Lino.chars2width(10) }, { "colIndex": 38, "dataIndex": "birth_date", "editable": true, "editor": birth_date1745, "filter": { "type": "string" }, "header": "Geburtsdatum", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".", "width": Lino.chars2width(13) }, { "colIndex": 39, "dataIndex": "national_id", "editable": true, "editor": national_id1746, "filter": { "type": "string" }, "header": "NR-Nummer", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.", "width": Lino.chars2width(22) }, { "colIndex": 40, "dataIndex": "birth_country", "editable": true, "editor": birth_country1747, "filter": { "type": "string" }, "header": "Geburtsland", "hidden": true, "renderer": Lino.fk_renderer('birth_countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.birth_country) ", "width": Lino.chars2width(21) }, { "colIndex": 41, "dataIndex": "birth_place", "editable": true, "editor": birth_place1748, "filter": { "type": "string" }, "header": "Geburtsort", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.birth_place) ", "width": Lino.chars2width(22) }, { "colIndex": 42, "dataIndex": "nationality", "editable": true, "editor": nationality1749, "filter": { "type": "string" }, "header": "Staatsangeh\u00f6rigkeit", "hidden": true, "renderer": Lino.fk_renderer('nationalityHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.nationality) The nationality. This is a pointer to\ncountries.Country which should\ncontain also entries for refugee statuses.", "width": Lino.chars2width(21) }, { "colIndex": 43, "dataIndex": "card_number", "editable": true, "editor": card_number1750, "filter": { "type": "string" }, "header": "eID-Kartennummer", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.card_number) ", "width": Lino.chars2width(22) }, { "colIndex": 44, "dataIndex": "card_valid_from", "editable": true, "editor": card_valid_from1751, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "ID-Karte g\u00fcltig von", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.card_valid_from) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 45, "dataIndex": "card_valid_until", "editable": true, "editor": card_valid_until1752, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "bis", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.card_valid_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 46, "dataIndex": "card_type", "editable": true, "editor": card_type1753, "filter": { "type": "string" }, "header": "eID-Kartenart", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.card_type) ", "width": Lino.chars2width(42) }, { "colIndex": 47, "dataIndex": "card_issuer", "editable": true, "editor": card_issuer1754, "filter": { "type": "string" }, "header": "eID-Karte ausgestellt durch", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.card_issuer) ", "width": Lino.chars2width(22) }, { "colIndex": 48, "dataIndex": "noble_condition", "editable": true, "editor": noble_condition1755, "filter": { "type": "string" }, "header": "Adelstitel", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.noble_condition) Eventueller Adelstitel", "width": Lino.chars2width(22) }, { "colIndex": 49, "dataIndex": "legacy_id", "editable": true, "editor": legacy_id1756, "filter": { "type": "string" }, "header": "Alte Nr.", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.legacy_id) ", "width": Lino.chars2width(14) }, { "colIndex": 50, "dataIndex": "is_member", "editable": true, "filter": { "type": "boolean" }, "header": "Mitglied", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.is_member) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 51, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 52, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 53, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 54, "dataIndex": "age", "editable": false, "header": "Alter", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.age) ", "width": Lino.chars2width(31) }, { "colIndex": 55, "dataIndex": "mti_navigator", "editable": false, "header": "Ansicht als ", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.mti_navigator) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 56, "dataIndex": "debit_balance", "editable": false, "format": "0.000,00/i", "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.debit_balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 57, "dataIndex": "image", "editable": false, "header": "image", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.image) ", "width": Lino.chars2width(31) }, { "colIndex": 58, "dataIndex": "eid_info", "editable": false, "header": "eID-Karte", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.eid_info) ", "width": Lino.chars2width(31) } ];
    Lino.courses.PupilsByType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PupilsByType.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.print_labels = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PupilsByType.insertPanel = Ext.extend(Lino.courses.Pupils.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/PupilsByType",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PupilsByType.detail;
    this.ls_insert_handler = Lino.courses.PupilsByType.insert;
    Lino.courses.PupilsByType.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PupilsByType.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.PupilsByType.insertPanel(p);
});
Lino.courses.PupilsByType.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PupilsByType.detailPanel = Ext.extend(Lino.courses.Pupils.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-arrow_join", "itemId": "merge_row", "menu_item_text": "Fusionieren", "overflowText": "Fusionieren", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Pupils.merge_row), "tooltip": "Dieses Objekt in ein anderes Objekt der gleichen Klasse fusionieren." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Schulden", "overflowText": "Schulden", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Schulden" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Rechnungssender", "overflowText": "Rechnungssender", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Rechnungssender" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/courses/PupilsByType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PupilsByType.detail;
    this.ls_insert_handler = Lino.courses.PupilsByType.insert;
    Lino.courses.PupilsByType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PupilsByType.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.PupilsByType.detailPanel(p);
});
Lino.courses.PupilsByType.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.create_excerpt1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.due = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.show_invoice_partners = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Pupils.ParamsPanel({});
  return new Lino.courses.PupilsByType.GridPanel(p);
});
Lino.courses.PupilsByType.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.ins_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.ins_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.del_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.read_beid = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "POST", pk, "read_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.ins_company = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.del_teacher = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.del_partner = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.ins_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.del_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.del_pupil = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.ins_person = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.find_by_beid = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/PupilsByType", "POST", pk, "find_by_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.CoursesByTopic
Lino.courses.CoursesByTopic.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 60,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/CoursesByTopic",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTopic','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTopic','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTopic','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTopic','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTopic','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Aktivit\u00e4ten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "overview" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "max_places", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "requested", "type": "int", "useNull": true }, { "name": "trying", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "name": "room" }, 'roomHidden', { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "workflow_buttons" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "presences_box" }, { "name": "what_text" }, { "name": "duration" }, { "name": "line__topic" }, 'line__topicHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByTopic.detail;
    this.ls_insert_handler = Lino.courses.Activities.insert;
    var ww = this.containing_window;
    var overview_disp1007 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var weekdays_text_disp1008 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var times_text_disp1009 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var max_places1010 = new Ext.form.NumberField({ "selectOnFocus": true });
    var confirmed1011 = new Ext.form.NumberField({ "disabled": true });
    var free_places1012 = new Ext.form.NumberField({ "disabled": true });
    var requested1013 = new Ext.form.NumberField({ "disabled": true });
    var trying1014 = new Ext.form.NumberField({ "disabled": true });
    var id1015 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref1016 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date1017 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time1018 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date1019 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time1020 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user1021 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/user" }) }) });
    var every_unit1022 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every1023 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday1024 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday1025 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday1026 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday1027 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday1028 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday1029 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday1030 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events1031 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var room1032 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/room" }) }) });
    var max_date1033 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var line1034 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/line" }) }) });
    var teacher1035 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/teacher" }) }) });
    var slot1036 = new Lino.RemoteComboFieldElement({ "emptyText": "Timetable Slot ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/slot" }) }) });
    var description1037 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de1038 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr1039 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark1040 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state1041 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var name1042 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until1043 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee1044 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/fee" }) }) });
    var payment_term1045 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/payment_term" }) }) });
    var paper_type1046 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/paper_type" }) }) });
    var mobile_item_disp1047 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1048 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp1049 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments1050 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp1051 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var presences_box_htmlbox1052 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Anwesenheiten", "value": "<br/>" });
    var what_text_disp1053 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration1054 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    var line__topic1055 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Thema ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "sortable": false, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
      fee1044.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox1052.refresh();
    };
    this.onRender = function(ct, position) {
      line1034.on('change',Lino.chooser_handler(fee1044,'line'));
      Lino.courses.CoursesByTopic.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(courses.CoursesByTopic.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(courses.CoursesByTopic.weekdays_text) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "sortable": false, "tooltip": "(courses.CoursesByTopic.times_text) ", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 3, "dataIndex": "max_places", "editable": true, "editor": max_places1010, "filter": { "type": "numeric" }, "format": "0", "header": "Verf\u00fcgbare Pl\u00e4tze", "sortable": true, "tooltip": "(courses.CoursesByTopic.max_places) Maximum number of participants", "width": Lino.chars2width(9), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Best\u00e4tigt", "sortable": false, "tooltip": "(courses.CoursesByTopic.confirmed) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Freie Pl\u00e4tze", "sortable": false, "tooltip": "(courses.CoursesByTopic.free_places) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "requested", "editable": false, "format": "0", "header": "Angefragt", "sortable": false, "tooltip": "(courses.CoursesByTopic.requested) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "trying", "editable": false, "format": "0", "header": "Test", "sortable": false, "tooltip": "(courses.CoursesByTopic.trying) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id1015, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 9, "dataIndex": "ref", "editable": true, "editor": ref1016, "filter": { "type": "string" }, "header": "Referenz", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "start_date", "editable": true, "editor": start_date1017, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "start_time", "editable": true, "editor": start_time1018, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 12, "dataIndex": "end_date", "editable": true, "editor": end_date1019, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 13, "dataIndex": "end_time", "editable": true, "editor": end_time1020, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 14, "dataIndex": "user", "editable": true, "editor": user1021, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.CoursesByTopic.user) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "every_unit", "editable": true, "editor": every_unit1022, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 16, "dataIndex": "every", "editable": true, "editor": every1023, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 17, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 20, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 21, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 22, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 23, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 24, "dataIndex": "max_events", "editable": true, "editor": max_events1031, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 25, "dataIndex": "room", "editable": true, "editor": room1032, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.CoursesByTopic.room) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "max_date", "editable": true, "editor": max_date1033, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 27, "dataIndex": "line", "editable": true, "editor": line1034, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "hidden": true, "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.CoursesByTopic.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 28, "dataIndex": "teacher", "editable": true, "editor": teacher1035, "filter": { "type": "string" }, "header": "Kursleiter", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.CoursesByTopic.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 29, "dataIndex": "slot", "editable": true, "editor": slot1036, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "renderer": Lino.fk_renderer('slotHidden','Lino.courses.Slots.detail'), "sortable": false, "tooltip": "(courses.CoursesByTopic.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 30, "dataIndex": "description", "editable": true, "editor": description1037, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.description) ", "width": Lino.chars2width(61) }, { "colIndex": 31, "dataIndex": "description_de", "editable": true, "editor": description_de1038, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 32, "dataIndex": "description_fr", "editable": true, "editor": description_fr1039, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 33, "dataIndex": "remark", "editable": true, "editor": remark1040, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 34, "dataIndex": "state", "editable": true, "editor": state1041, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "colIndex": 35, "dataIndex": "name", "editable": true, "editor": name1042, "filter": { "type": "string" }, "header": "Bezeichnung", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 36, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until1043, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Einschreibung m\u00f6glich bis", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 37, "dataIndex": "fee", "editable": true, "editor": fee1044, "filter": { "type": "string" }, "header": "Standard-Teilnehmahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.CoursesByTopic.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 38, "dataIndex": "payment_term", "editable": true, "editor": payment_term1045, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.CoursesByTopic.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 39, "dataIndex": "paper_type", "editable": true, "editor": paper_type1046, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 40, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 41, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 42, "dataIndex": "events_text", "editable": false, "header": "Kalendereintr\u00e4ge", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 43, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Einschreibungen", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.enrolments) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 44, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.print_actions) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "presences_box", "editable": false, "header": "Anwesenheiten", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.presences_box) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 48, "dataIndex": "line__topic", "editable": false, "filter": { "type": "string" }, "header": "Thema", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.line__topic) ", "width": Lino.chars2width(21) } ];
    Lino.courses.CoursesByTopic.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByTopic.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesByTopic.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/CoursesByTopic",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByTopic.detail;
    this.ls_insert_handler = Lino.courses.Activities.insert;
    Lino.courses.CoursesByTopic.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByTopic.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CoursesByTopic.detailPanel(p);
});
Lino.courses.CoursesByTopic.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.CoursesByTopic.ParamsPanel({});
  return new Lino.courses.CoursesByTopic.GridPanel(p);
});
Lino.courses.CoursesByTopic.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByTopic", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.CoursesByLine
Lino.courses.CoursesByLine.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 58,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/CoursesByLine",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByLine','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByLine','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByLine','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByLine','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByLine','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Aktivit\u00e4ten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "overview" }, { "name": "weekdays_text" }, { "name": "room" }, 'roomHidden', { "name": "times_text" }, { "name": "teacher" }, 'teacherHidden', { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "mobile_item" }, { "name": "workflow_buttons" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "what_text" }, { "name": "duration" }, { "name": "line" }, 'lineHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByLine.detail;
    this.ls_insert_handler = Lino.courses.CoursesByLine.insert;
    var ww = this.containing_window;
    var overview_disp3478 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var weekdays_text_disp3479 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var room3480 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/room" }) }) });
    var times_text_disp3481 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var teacher3482 = new Lino.RemoteComboFieldElement({ "emptyText": "Kursleiter ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/teacher" }) }) });
    var id3483 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref3484 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date3485 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time3486 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date3487 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time3488 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user3489 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/user" }) }) });
    var every_unit3490 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every3491 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday3492 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday3493 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday3494 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday3495 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday3496 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday3497 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday3498 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events3499 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date3500 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var slot3501 = new Lino.RemoteComboFieldElement({ "emptyText": "Timetable Slot ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/slot" }) }) });
    var description3502 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de3503 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr3504 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark3505 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state3506 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places3507 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name3508 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until3509 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee3510 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/fee" }) }) });
    var payment_term3511 = new Lino.RemoteComboFieldElement({ "emptyText": "Zahlungsbedingung ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/payment_term" }) }) });
    var paper_type3512 = new Lino.RemoteComboFieldElement({ "emptyText": "Papierart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/paper_type" }) }) });
    var mobile_item_disp3513 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp3514 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp3515 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments3516 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp3517 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested3518 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed3519 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox3520 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Anwesenheiten", "value": "<br/>" });
    var trying3521 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places3522 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var what_text_disp3523 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration3524 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    var line3525 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Aktivit\u00e4tenreihe ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/line" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      fee3510.setContextValue('mk',bp['mk']);
      fee3510.setContextValue('mt',bp['mt']);
      presences_box_htmlbox3520.refresh();
    };
    this.onRender = function(ct, position) {
      line3525.on('change',Lino.chooser_handler(fee3510,'line'));
      Lino.courses.CoursesByLine.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(courses.CoursesByLine.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "weekdays_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(courses.CoursesByLine.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "room", "editable": true, "editor": room3480, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.CoursesByLine.room) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "times_text", "editable": false, "header": "Uhrzeiten", "sortable": false, "tooltip": "(courses.CoursesByLine.times_text) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "teacher", "editable": true, "editor": teacher3482, "filter": { "type": "string" }, "header": "Kursleiter", "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.CoursesByLine.teacher) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id3483, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "ref", "editable": true, "editor": ref3484, "filter": { "type": "string" }, "header": "Referenz", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date3485, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time3486, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date3487, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time3488, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user3489, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.CoursesByLine.user) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "every_unit", "editable": true, "editor": every_unit3490, "filter": { "type": "string" }, "header": "Wiederholung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 13, "dataIndex": "every", "editable": true, "editor": every3491, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 14, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Montag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Dienstag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Mittwoch", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Donnerstag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Freitag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Samstag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 20, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sonntag", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 21, "dataIndex": "max_events", "editable": true, "editor": max_events3499, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.max_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date3500, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Termine generieren bis", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "slot", "editable": true, "editor": slot3501, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "renderer": Lino.fk_renderer('slotHidden','Lino.courses.Slots.detail'), "sortable": false, "tooltip": "(courses.CoursesByLine.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "description", "editable": true, "editor": description3502, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.description) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_de", "editable": true, "editor": description_de3503, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_fr", "editable": true, "editor": description_fr3504, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "remark", "editable": true, "editor": remark3505, "filter": { "type": "string" }, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "state", "editable": true, "editor": state3506, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 29, "dataIndex": "max_places", "editable": true, "editor": max_places3507, "filter": { "type": "numeric" }, "format": "0", "header": "Verf\u00fcgbare Pl\u00e4tze", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.max_places) Maximum number of participants", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 30, "dataIndex": "name", "editable": true, "editor": name3508, "filter": { "type": "string" }, "header": "Bezeichnung", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 31, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until3509, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Einschreibung m\u00f6glich bis", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 32, "dataIndex": "fee", "editable": true, "editor": fee3510, "filter": { "type": "string" }, "header": "Standard-Teilnehmahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.CoursesByLine.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "payment_term", "editable": true, "editor": payment_term3511, "filter": { "type": "string" }, "header": "Zahlungsbedingung", "hidden": true, "renderer": Lino.fk_renderer('payment_termHidden','Lino.ledger.PaymentTerms.detail'), "sortable": false, "tooltip": "(courses.CoursesByLine.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner\u2019s default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "paper_type", "editable": true, "editor": paper_type3512, "filter": { "type": "string" }, "header": "Papierart", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site\u2019s default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 35, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 37, "dataIndex": "events_text", "editable": false, "header": "Kalendereintr\u00e4ge", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 38, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Einschreibungen", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.enrolments) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 39, "dataIndex": "print_actions", "editable": false, "header": "Drucken", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 40, "dataIndex": "requested", "editable": false, "format": "0", "header": "Angefragt", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.requested) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 41, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Best\u00e4tigt", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.confirmed) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 42, "dataIndex": "presences_box", "editable": false, "header": "Anwesenheiten", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 43, "dataIndex": "trying", "editable": false, "format": "0", "header": "Test", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.trying) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 44, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Freie Pl\u00e4tze", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.free_places) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 45, "dataIndex": "what_text", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 46, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 47, "dataIndex": "line", "editable": true, "editor": line3525, "filter": { "type": "string" }, "header": "Aktivit\u00e4tenreihe", "hidden": true, "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.CoursesByLine.line) Pointer to the course series.", "width": Lino.chars2width(21) } ];
    Lino.courses.CoursesByLine.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByLine.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesByLine.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/CoursesByLine",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByLine.detail;
    this.ls_insert_handler = Lino.courses.CoursesByLine.insert;
    Lino.courses.CoursesByLine.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByLine.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.CoursesByLine.insertPanel(p);
});
Lino.courses.CoursesByLine.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesByLine.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "menu_item_text": "Anwesenheitsliste (HTML)", "overflowText": "Anwesenheitsliste (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Anwesenheitsliste (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "print_presence_sheet", "menu_item_text": "Anwesenheitsliste", "overflowText": "Anwesenheitsliste", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Anwesenheitsliste" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Rechnungen erstellen", "overflowText": "Rechnungen erstellen", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/CoursesByLine",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByLine.detail;
    this.ls_insert_handler = Lino.courses.CoursesByLine.insert;
    Lino.courses.CoursesByLine.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByLine.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CoursesByLine.detailPanel(p);
});
Lino.courses.CoursesByLine.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.create_excerpt3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.create_excerpt11 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.start_invoicing = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.CoursesByLine.GridPanel(p);
});
Lino.courses.CoursesByLine.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.do_update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CoursesByLine", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.LinesByType
Lino.courses.LinesByType.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 40,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/LinesByType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByType','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Aktivit\u00e4tenreihen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "topic" }, 'topicHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "guest_role" }, 'guest_roleHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "excerpt_title" }, { "name": "excerpt_title_de" }, { "name": "excerpt_title_fr" }, { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "fee" }, 'feeHidden', { "name": "options_cat" }, 'options_catHidden', { "name": "fees_cat" }, 'fees_catHidden', { "name": "body_template" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "course_type" }, 'course_typeHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 15,
  ls_grid_configs : [  ],
  content_type : 57,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.LinesByType.detail;
    this.ls_insert_handler = Lino.courses.LinesByType.insert;
    var ww = this.containing_window;
    var ref3400 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name3401 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de3402 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr3403 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var topic3404 = new Lino.RemoteComboFieldElement({ "emptyText": "Thema ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/topic" }) }) });
    var course_area3405 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.courses.CourseAreas });
    var event_type3406 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/event_type" }) }) });
    var guest_role3407 = new Lino.RemoteComboFieldElement({ "emptyText": "Gastrolle ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/guest_role" }) }) });
    var every_unit3408 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every3409 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var id3410 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var company3411 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/company" }) }) });
    var contact_person3412 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/contact_person" }) }) });
    var contact_role3413 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/contact_role" }) }) });
    var excerpt_title3414 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var excerpt_title_de3415 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var excerpt_title_fr3416 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var description3417 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de3418 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr3419 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var fee3420 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/fee" }) }) });
    var options_cat3421 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarifkategorie ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/options_cat" }) }) });
    var fees_cat3422 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarifkategorie ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/fees_cat" }) }) });
    var body_template3423 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/body_template" }) }) });
    var mobile_item_disp3424 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3425 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp3426 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var course_type3427 = new Lino.RemoteComboFieldElement({ "emptyText": "Aktivit\u00e4tsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/course_type" }) }) });
    this.before_row_edit = function(record) {
      contact_person3412.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      fee3420.setContextValue('fees_cat', record ? record.data['fees_catHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company3411.on('change',Lino.chooser_handler(contact_person3412,'company'));
      fees_cat3422.on('change',Lino.chooser_handler(fee3420,'fees_cat'));
      Lino.courses.LinesByType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref3400, "filter": { "type": "string" }, "header": "Referenz", "sortable": true, "tooltip": "(courses.LinesByType.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name3401, "filter": { "type": "string" }, "header": "Bezeichnung", "sortable": true, "tooltip": "(courses.LinesByType.name) The designation of this activity line as seen by the user\ne.g. when selecting the line.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de3402, "filter": { "type": "string" }, "header": "Bezeichnung (de)", "sortable": true, "tooltip": "(courses.LinesByType.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr3403, "filter": { "type": "string" }, "header": "Bezeichnung (fr)", "sortable": true, "tooltip": "(courses.LinesByType.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "topic", "editable": true, "editor": topic3404, "filter": { "type": "string" }, "header": "Thema", "renderer": Lino.fk_renderer('topicHidden','Lino.courses.Topics.detail'), "sortable": false, "tooltip": "(courses.LinesByType.topic) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "course_area", "editable": true, "editor": course_area3405, "filter": { "type": "string" }, "header": "Layout", "sortable": false, "tooltip": "(courses.LinesByType.course_area) Pointer to CourseAreas.  This is used only when an\napplication defines several variants of\nEnrolmentsByPupil.", "width": Lino.chars2width(14) }, { "colIndex": 6, "dataIndex": "event_type", "editable": true, "editor": event_type3406, "filter": { "type": "string" }, "header": "Kalendereintragsart", "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(courses.LinesByType.event_type) The type of calendar entries to be generated. If this is empty, no calendar entries will be generated.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "guest_role", "editable": true, "editor": guest_role3407, "filter": { "type": "string" }, "header": "Anwesenheiten erfassen als", "renderer": Lino.fk_renderer('guest_roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(courses.LinesByType.guest_role) The default guest role for particpants of calendar entries for activities in this series. Leave empty if you don't want any presences management.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "every_unit", "editable": true, "editor": every_unit3408, "filter": { "type": "string" }, "header": "Wiederholung", "sortable": false, "tooltip": "(courses.LinesByType.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 9, "dataIndex": "every", "editable": true, "editor": every3409, "filter": { "type": "numeric" }, "format": "0", "header": "... alle", "sortable": true, "tooltip": "(courses.LinesByType.every) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 10, "dataIndex": "id", "editable": true, "editor": id3410, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByType.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "company", "editable": true, "editor": company3411, "filter": { "type": "string" }, "header": "Organisation", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(courses.LinesByType.company) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "contact_person", "editable": true, "editor": contact_person3412, "filter": { "type": "string" }, "header": "Vertreten durch", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(courses.LinesByType.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "contact_role", "editable": true, "editor": contact_role3413, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "excerpt_title", "editable": true, "editor": excerpt_title3414, "filter": { "type": "string" }, "header": "Excerpt title", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByType.excerpt_title) The title to be used when printing an excerpt.", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "excerpt_title_de", "editable": true, "editor": excerpt_title_de3415, "filter": { "type": "string" }, "header": "Excerpt title (de)", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByType.excerpt_title_de) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "excerpt_title_fr", "editable": true, "editor": excerpt_title_fr3416, "filter": { "type": "string" }, "header": "Excerpt title (fr)", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByType.excerpt_title_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "description", "editable": true, "editor": description3417, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.description) ", "width": Lino.chars2width(61) }, { "colIndex": 18, "dataIndex": "description_de", "editable": true, "editor": description_de3418, "filter": { "type": "string" }, "header": "Beschreibung (de)", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 19, "dataIndex": "description_fr", "editable": true, "editor": description_fr3419, "filter": { "type": "string" }, "header": "Beschreibung (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 20, "dataIndex": "fee", "editable": true, "editor": fee3420, "filter": { "type": "string" }, "header": "Teilnahmegeb\u00fchr", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.LinesByType.fee) ", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "options_cat", "editable": true, "editor": options_cat3421, "filter": { "type": "string" }, "header": "Kategorie f\u00fcr Optionen", "hidden": true, "renderer": Lino.fk_renderer('options_catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(courses.LinesByType.options_cat) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "fees_cat", "editable": true, "editor": fees_cat3422, "filter": { "type": "string" }, "header": "Kategorie f\u00fcr Teilnahmegeb\u00fchren", "hidden": true, "renderer": Lino.fk_renderer('fees_catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(courses.LinesByType.fees_cat) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "body_template", "editable": true, "editor": body_template3423, "filter": { "type": "string" }, "header": "Textk\u00f6rper-Vorlage", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.body_template) The body template to use when printing a course of this series. Leave empty to use the site's default.", "width": Lino.chars2width(11) }, { "colIndex": 24, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 25, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "course_type", "editable": true, "editor": course_type3427, "filter": { "type": "string" }, "header": "Aktivit\u00e4tsart", "hidden": true, "renderer": Lino.fk_renderer('course_typeHidden','Lino.courses.CourseTypes.detail'), "sortable": false, "tooltip": "(courses.LinesByType.course_type) ", "width": Lino.chars2width(21) } ];
    Lino.courses.LinesByType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.LinesByType.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.LinesByType.insertPanel = Ext.extend(Lino.courses.Lines.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/LinesByType",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.LinesByType.detail;
    this.ls_insert_handler = Lino.courses.LinesByType.insert;
    Lino.courses.LinesByType.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.LinesByType.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(16), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.LinesByType.insertPanel(p);
});
Lino.courses.LinesByType.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByType", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.LinesByType.detailPanel = Ext.extend(Lino.courses.Lines.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/courses/LinesByType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.LinesByType.detail;
    this.ls_insert_handler = Lino.courses.LinesByType.insert;
    Lino.courses.LinesByType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.LinesByType.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.LinesByType.detailPanel(p);
});
Lino.courses.LinesByType.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.LinesByType.GridPanel(p);
});
Lino.courses.LinesByType.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/LinesByType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsAndPaymentsByCourse
Lino.courses.EnrolmentsAndPaymentsByCourse.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 5,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsAndPaymentsByCourse",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsAndPaymentsByCourse','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsAndPaymentsByCourse','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsAndPaymentsByCourse','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsAndPaymentsByCourse','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsAndPaymentsByCourse','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Einschreibungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "pupil_info" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "invoicing_info" }, { "name": "payment_info" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsAndPaymentsByCourse.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsAndPaymentsByCourse.insert;
    var ww = this.containing_window;
    var pupil_info_htmlbox6186 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Teilnehmer", "value": "<br/>" });
    var start_date6187 = new Lino.DateField({ "selectOnFocus": true });
    var invoicing_info_disp6188 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payment_info_disp6189 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      pupil_info_htmlbox6186.refresh();
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "pupil_info", "editable": false, "header": "Teilnehmer", "sortable": false, "tooltip": "(courses.EnrolmentsAndPaymentsByCourse.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "start_date", "editable": true, "editor": start_date6187, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.EnrolmentsAndPaymentsByCourse.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "invoicing_info", "editable": false, "header": "Info Fakturation", "sortable": false, "tooltip": "(courses.EnrolmentsAndPaymentsByCourse.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "payment_info", "editable": false, "header": "Info Buchhaltung", "sortable": false, "tooltip": "(courses.EnrolmentsAndPaymentsByCourse.payment_info) ", "width": Lino.chars2width(31) } ];
    Lino.courses.EnrolmentsAndPaymentsByCourse.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsAndPaymentsByCourse.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsAndPaymentsByCourse.insertPanel = Ext.extend(Lino.courses.Enrolments.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/EnrolmentsAndPaymentsByCourse",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsAndPaymentsByCourse.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsAndPaymentsByCourse.insert;
    Lino.courses.EnrolmentsAndPaymentsByCourse.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsAndPaymentsByCourse.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsAndPaymentsByCourse.insertPanel(p);
});
Lino.courses.EnrolmentsAndPaymentsByCourse.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsAndPaymentsByCourse.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsAndPaymentsByCourse",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsAndPaymentsByCourse.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsAndPaymentsByCourse.insert;
    Lino.courses.EnrolmentsAndPaymentsByCourse.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsAndPaymentsByCourse.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsAndPaymentsByCourse.detailPanel(p);
});
Lino.courses.EnrolmentsAndPaymentsByCourse.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.create_excerpt9 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.create_excerpt10 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsAndPaymentsByCourse.GridPanel(p);
});
Lino.courses.EnrolmentsAndPaymentsByCourse.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsByHike
Lino.courses.EnrolmentsByHike.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 32,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsByHike",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByHike','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByHike','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByHike','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByHike','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByHike','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Einschreibungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "pupil" }, 'pupilHidden', { "name": "places", "type": "int", "useNull": true }, { "name": "remark" }, { "name": "fee" }, 'feeHidden', { "name": "option" }, 'optionHidden', { "name": "amount" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "user" }, 'userHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "confirmation_details" }, { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "course" }, 'courseHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 11,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByHike.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByHike.insert;
    var ww = this.containing_window;
    var request_date6191 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var pupil6192 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Teilnehmer ausw\u00e4hlen...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/pupil" }) }) });
    var places6193 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var remark6194 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var fee6195 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/fee" }) }) });
    var option6196 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/option" }) }) });
    var amount6197 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp6198 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id6199 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_date6200 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date6201 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var user6202 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/user" }) }) });
    var printed_by6203 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area6204 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state6205 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var confirmation_details6206 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var free_events6207 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox6208 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Teilnehmer", "value": "<br/>" });
    var payment_info_disp6209 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp6210 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp6211 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6212 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp6213 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var course6214 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Activity ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/course" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      pupil6192.setContextValue('mk',bp['mk']);
      pupil6192.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      fee6195.setContextValue('mk',bp['mk']);
      fee6195.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      option6196.setContextValue('mk',bp['mk']);
      option6196.setContextValue('mt',bp['mt']);
      pupil_info_htmlbox6208.refresh();
      course6214.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course6214.setContextValue('request_date', record ? record.data['request_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      course6214.on('change',Lino.chooser_handler(pupil6192,'course'));
      course6214.on('change',Lino.chooser_handler(fee6195,'course'));
      course6214.on('change',Lino.chooser_handler(option6196,'course'));
      course_area6204.on('change',Lino.chooser_handler(course6214,'course_area'));
      request_date6191.on('change',Lino.chooser_handler(course6214,'request_date'));
      Lino.courses.EnrolmentsByHike.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date6191, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum der Anfrage", "sortable": true, "tooltip": "(courses.EnrolmentsByHike.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "pupil", "editable": true, "editor": pupil6192, "filter": { "type": "string" }, "header": "Teilnehmer", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByHike.pupil) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "places", "editable": true, "editor": places6193, "filter": { "type": "numeric" }, "format": "0", "header": "Anz. Pl\u00e4tze", "sortable": true, "tooltip": "(courses.EnrolmentsByHike.places) The number of participants in this enrolment.", "width": Lino.chars2width(9), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark6194, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(courses.EnrolmentsByHike.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "fee", "editable": true, "editor": fee6195, "filter": { "type": "string" }, "header": "Tarif", "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByHike.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "option", "editable": true, "editor": option6196, "filter": { "type": "string" }, "header": "Option", "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByHike.option) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "amount", "editable": true, "editor": amount6197, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "sortable": true, "tooltip": "(courses.EnrolmentsByHike.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.EnrolmentsByHike.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id6199, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByHike.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 9, "dataIndex": "start_date", "editable": true, "editor": start_date6200, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByHike.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_date", "editable": true, "editor": end_date6201, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enddatum", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByHike.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user6202, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByHike.user) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByHike.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 14, "dataIndex": "state", "editable": true, "editor": state6205, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "colIndex": 15, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details6206, "filter": { "type": "string" }, "header": "Details Best\u00e4tigung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.confirmation_details) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 16, "dataIndex": "free_events", "editable": true, "editor": free_events6207, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByHike.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 17, "dataIndex": "pupil_info", "editable": false, "header": "Teilnehmer", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "payment_info", "editable": false, "header": "Info Buchhaltung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "invoicing_info", "editable": false, "header": "Info Fakturation", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "course", "editable": true, "editor": course6214, "filter": { "type": "string" }, "header": "Activity", "hidden": true, "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByHike.course) ", "width": Lino.chars2width(21) } ];
    Lino.courses.EnrolmentsByHike.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByHike.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByHike.insertPanel = Ext.extend(Lino.courses.EnrolmentsByHike.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/EnrolmentsByHike",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByHike.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByHike.insert;
    Lino.courses.EnrolmentsByHike.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByHike.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsByHike.insertPanel(p);
});
Lino.courses.EnrolmentsByHike.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByHike.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsByHike",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByHike.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByHike.insert;
    Lino.courses.EnrolmentsByHike.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByHike.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsByHike.detailPanel(p);
});
Lino.courses.EnrolmentsByHike.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.create_excerpt10 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.create_excerpt9 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsByHike.GridPanel(p);
});
Lino.courses.EnrolmentsByHike.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByHike", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsByJourney
Lino.courses.EnrolmentsByJourney.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 32,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsByJourney",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByJourney','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByJourney','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByJourney','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByJourney','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByJourney','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Einschreibungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "pupil" }, 'pupilHidden', { "name": "places", "type": "int", "useNull": true }, { "name": "remark" }, { "name": "fee" }, 'feeHidden', { "name": "option" }, 'optionHidden', { "name": "amount" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "user" }, 'userHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "confirmation_details" }, { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "printed" }, { "name": "course" }, 'courseHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 11,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByJourney.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByJourney.insert;
    var ww = this.containing_window;
    var request_date6216 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var pupil6217 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Teilnehmer ausw\u00e4hlen...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByJourney/pupil" }) }) });
    var places6218 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var remark6219 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var fee6220 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByJourney/fee" }) }) });
    var option6221 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByJourney/option" }) }) });
    var amount6222 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp6223 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id6224 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_date6225 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date6226 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var user6227 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByJourney/user" }) }) });
    var printed_by6228 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Auszug ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area6229 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state6230 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var confirmation_details6231 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var free_events6232 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox6233 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Teilnehmer", "value": "<br/>" });
    var payment_info_disp6234 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp6235 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp6236 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6237 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp6238 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var course6239 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Activity ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByJourney/course" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      pupil6217.setContextValue('mk',bp['mk']);
      pupil6217.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      fee6220.setContextValue('mk',bp['mk']);
      fee6220.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      option6221.setContextValue('mk',bp['mk']);
      option6221.setContextValue('mt',bp['mt']);
      pupil_info_htmlbox6233.refresh();
      course6239.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course6239.setContextValue('request_date', record ? record.data['request_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      course6239.on('change',Lino.chooser_handler(pupil6217,'course'));
      course6239.on('change',Lino.chooser_handler(fee6220,'course'));
      course6239.on('change',Lino.chooser_handler(option6221,'course'));
      course_area6229.on('change',Lino.chooser_handler(course6239,'course_area'));
      request_date6216.on('change',Lino.chooser_handler(course6239,'request_date'));
      Lino.courses.EnrolmentsByJourney.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date6216, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum der Anfrage", "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "pupil", "editable": true, "editor": pupil6217, "filter": { "type": "string" }, "header": "Teilnehmer", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.pupil) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "places", "editable": true, "editor": places6218, "filter": { "type": "numeric" }, "format": "0", "header": "Anz. Pl\u00e4tze", "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.places) The number of participants in this enrolment.", "width": Lino.chars2width(9), "xtype": "numbercolumn" }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark6219, "filter": { "type": "string" }, "header": "Bemerkung", "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "fee", "editable": true, "editor": fee6220, "filter": { "type": "string" }, "header": "Tarif", "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "option", "editable": true, "editor": option6221, "filter": { "type": "string" }, "header": "Option", "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.option) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "amount", "editable": true, "editor": amount6222, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Betrag", "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id6224, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 9, "dataIndex": "start_date", "editable": true, "editor": start_date6225, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_date", "editable": true, "editor": end_date6226, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enddatum", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user6227, "filter": { "type": "string" }, "header": "Autor", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.user) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Ausgedruckt", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 14, "dataIndex": "state", "editable": true, "editor": state6230, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "colIndex": 15, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details6231, "filter": { "type": "string" }, "header": "Details Best\u00e4tigung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.confirmation_details) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 16, "dataIndex": "free_events", "editable": true, "editor": free_events6232, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 17, "dataIndex": "pupil_info", "editable": false, "header": "Teilnehmer", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "payment_info", "editable": false, "header": "Info Buchhaltung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "invoicing_info", "editable": false, "header": "Info Fakturation", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "printed", "editable": false, "header": "Ausgedruckt", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "course", "editable": true, "editor": course6239, "filter": { "type": "string" }, "header": "Activity", "hidden": true, "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.course) ", "width": Lino.chars2width(21) } ];
    Lino.courses.EnrolmentsByJourney.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByJourney.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByJourney.insertPanel = Ext.extend(Lino.courses.EnrolmentsByHike.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/EnrolmentsByJourney",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByJourney.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByJourney.insert;
    Lino.courses.EnrolmentsByJourney.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByJourney.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsByJourney.insertPanel(p);
});
Lino.courses.EnrolmentsByJourney.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByJourney.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Auszug von diesem Datensatz erstellen zwecks Ausdruck." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsByJourney",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByJourney.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByJourney.insert;
    Lino.courses.EnrolmentsByJourney.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByJourney.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsByJourney.detailPanel(p);
});
Lino.courses.EnrolmentsByJourney.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.create_excerpt9 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.create_excerpt10 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.clear_printed = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsByJourney.GridPanel(p);
});
Lino.courses.EnrolmentsByJourney.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentsByJourney", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class uploads.UploadsByController
Lino.uploads.UploadsByController.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 19,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/uploads/UploadsByController",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByController','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByController','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByController','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByController','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByController','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Uploads",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "file" }, { "name": "type" }, 'typeHidden', { "name": "description" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "mimetype" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "upload_area" }, 'upload_areaHidden', { "name": "description_link" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "owner" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 71,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadsByController.detail;
    this.ls_insert_handler = Lino.uploads.UploadsByController.insert;
    var ww = this.containing_window;
    var file6241 = Lino.file_field_handler(this,{ "maxLength": 100, "selectOnFocus": true });
    var type6242 = new Lino.RemoteComboFieldElement({ "emptyText": "Upload-Art ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByController/type" }) }) });
    var description6243 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user6244 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByController/user" }) }) });
    var id6245 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mimetype6246 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": 255 });
    var owner_type6247 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByController/owner_type" }) }) });
    var owner_id6248 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByController/owner_id" }) }) });
    var upload_area6249 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var description_link_disp6250 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp6251 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6252 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6253 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var owner_disp6254 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      type6242.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
      owner_id6248.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      upload_area6249.on('change',Lino.chooser_handler(type6242,'upload_area'));
      owner_type6247.on('change',Lino.chooser_handler(owner_id6248,'owner_type'));
      Lino.uploads.UploadsByController.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "file", "editable": true, "editor": file6241, "filter": { "type": "string" }, "header": "Datei", "sortable": true, "tooltip": "(uploads.UploadsByController.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type6242, "filter": { "type": "string" }, "header": "Upload-Art", "renderer": Lino.fk_renderer('typeHidden','Lino.uploads.UploadTypes.detail'), "sortable": false, "tooltip": "(uploads.UploadsByController.type) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "description", "editable": true, "editor": description6243, "filter": { "type": "string" }, "header": "Beschreibung", "sortable": true, "tooltip": "(uploads.UploadsByController.description) A short description entered manually by the user.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user6244, "filter": { "type": "string" }, "header": "Hochgeladen durch", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(uploads.UploadsByController.user) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id6245, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(uploads.UploadsByController.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "mimetype", "editable": false, "filter": { "type": "string" }, "header": "MIME-Art", "hidden": true, "sortable": true, "tooltip": "(uploads.UploadsByController.mimetype) The Media type\nof the file.  See also this thread\nabout length of MIME type field.", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "owner_type", "editable": true, "editor": owner_type6247, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(uploads.UploadsByController.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "owner_id", "editable": true, "editor": owner_id6248, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "upload_area", "editable": true, "editor": upload_area6249, "filter": { "type": "string" }, "header": "Upload-Bereich", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.upload_area) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "description_link", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.description_link) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.owner) ", "width": Lino.chars2width(11) } ];
    Lino.uploads.UploadsByController.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadsByController.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByController", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByController", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByController", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByController", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByController", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.UploadsByController.insertPanel = Ext.extend(Lino.uploads.UploadsByController.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/uploads/UploadsByController",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadsByController.detail;
    this.ls_insert_handler = Lino.uploads.UploadsByController.insert;
    Lino.uploads.UploadsByController.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadsByController.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.uploads.UploadsByController.insertPanel(p);
});
Lino.uploads.UploadsByController.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByController", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByController", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByController", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.UploadsByController.detailPanel = Ext.extend(Lino.uploads.Uploads.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/uploads/UploadsByController",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadsByController.detail;
    this.ls_insert_handler = Lino.uploads.UploadsByController.insert;
    Lino.uploads.UploadsByController.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadsByController.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.UploadsByController.detailPanel(p);
});
Lino.uploads.UploadsByController.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByController", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.uploads.Uploads.ParamsPanel({});
  return new Lino.uploads.UploadsByController.GridPanel(p);
});
Lino.uploads.UploadsByController.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadsByController", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class changes.ChangesByObject
Lino.changes.ChangesByObject.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/changes/ChangesByObject",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByObject','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByObject','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByObject','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByObject','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByObject','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" } ],
  cell_edit : true,
  title : "\u00c4nderungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "time" }, { "name": "user" }, 'userHidden', { "name": "type" }, 'typeHidden', { "name": "changed_fields" }, { "name": "master" }, { "name": "master_type" }, 'master_typeHidden', { "name": "master_id" }, 'master_idHidden', { "name": "id", "type": "int" }, { "name": "object_type" }, 'object_typeHidden', { "name": "object_id" }, 'object_idHidden', { "name": "diff" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "object" } ],
  pk_index : 11,
  ls_grid_configs : [  ],
  content_type : 77,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.changes.ChangesByObject.detail;
    var ww = this.containing_window;
    var time11149 = new Ext.form.DisplayField({ "allowBlank": false, "selectOnFocus": true, "value": "<br>" });
    var user11150 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByObject/user" }) }) });
    var type11151 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.changes.ChangeTypes });
    var changed_fields11152 = new Ext.form.TextField({ "maxLength": 250, "selectOnFocus": true });
    var master_disp11153 = new Ext.form.DisplayField({ "disabled": true });
    var master_type11154 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByObject/master_type" }) }) });
    var master_id11155 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByObject/master_id" }) }) });
    var id11156 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var object_type11157 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByObject/object_type" }) }) });
    var object_id11158 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByObject/object_id" }) }) });
    var diff11159 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var mobile_item_disp11160 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp11161 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp11162 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var object_disp11163 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      master_type11154.on('change',Lino.chooser_handler(master_id11155,'master_type'));
      object_type11157.on('change',Lino.chooser_handler(object_id11158,'object_type'));
      Lino.changes.ChangesByObject.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "time", "editable": true, "editor": time11149, "header": "time", "sortable": true, "tooltip": "(changes.ChangesByObject.time) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user11150, "filter": { "type": "string" }, "header": "Benutzer", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(changes.ChangesByObject.user) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "type", "editable": true, "editor": type11151, "filter": { "type": "string" }, "header": "\u00c4nderungsart", "sortable": false, "tooltip": "(changes.ChangesByObject.type) ", "width": Lino.chars2width(16) }, { "colIndex": 3, "dataIndex": "changed_fields", "editable": true, "editor": changed_fields11152, "filter": { "type": "string" }, "header": "Felder", "sortable": true, "tooltip": "(changes.ChangesByObject.changed_fields) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "master", "editable": false, "header": "Stammdaten", "sortable": false, "tooltip": "(changes.ChangesByObject.master) The database object which acts as \"master\".", "width": Lino.chars2width(11) }, { "colIndex": 5, "dataIndex": "master_type", "editable": true, "editor": master_type11154, "filter": { "type": "string" }, "header": "Master type", "renderer": Lino.fk_renderer('master_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(changes.ChangesByObject.master_type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "master_id", "editable": true, "editor": master_id11155, "filter": { "type": "string" }, "header": "master id", "sortable": false, "tooltip": "(changes.ChangesByObject.master_id) ", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id11156, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(changes.ChangesByObject.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "object_type", "editable": true, "editor": object_type11157, "filter": { "type": "string" }, "header": "Object type", "hidden": true, "renderer": Lino.fk_renderer('object_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(changes.ChangesByObject.object_type) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "object_id", "editable": true, "editor": object_id11158, "filter": { "type": "string" }, "header": "object id", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByObject.object_id) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "diff", "editable": true, "editor": diff11159, "filter": { "type": "string" }, "header": "\u00c4nderungen", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByObject.diff) ", "width": Lino.chars2width(61) }, { "colIndex": 11, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByObject.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByObject.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByObject.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "object", "editable": false, "header": "Object", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByObject.object) The database object which has been modified.", "width": Lino.chars2width(11) } ];
    Lino.changes.ChangesByObject.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.ChangesByObject.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangesByObject", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByObject.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangesByObject", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByObject.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangesByObject", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByObject.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangesByObject", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByObject.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangesByObject", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByObject.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangesByObject", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.changes.ChangesByObject.detailPanel = Ext.extend(Lino.changes.Changes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/changes/ChangesByObject",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.changes.ChangesByObject.detail;
    Lino.changes.ChangesByObject.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.ChangesByObject.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.changes.ChangesByObject.detailPanel(p);
});
Lino.changes.ChangesByObject.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.changes.Changes.ParamsPanel({});
  return new Lino.changes.ChangesByObject.GridPanel(p);
});

// js_render_GridPanel_class invoicing.InvoicingsByInvoiceable
Lino.invoicing.InvoicingsByInvoiceable.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/invoicing/InvoicingsByInvoiceable",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/invoicing/InvoicingsByInvoiceable','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/InvoicingsByInvoiceable','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/InvoicingsByInvoiceable','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/invoicing/InvoicingsByInvoiceable','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/invoicing/InvoicingsByInvoiceable','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Fakturierungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "voucher" }, 'voucherHidden', { "name": "title" }, { "name": "qty" }, { "dateFormat": "d.m.Y", "name": "voucher__voucher_date", "type": "date" }, { "name": "voucher__state" }, 'voucher__stateHidden', { "name": "product__number_of_events", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "total_incl" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_class" }, 'vat_classHidden', { "name": "unit_price" }, { "name": "product" }, 'productHidden', { "name": "description" }, { "name": "discount" }, { "name": "invoiceable_type" }, 'invoiceable_typeHidden', { "name": "invoiceable_id" }, 'invoiceable_idHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "move_buttons" }, { "name": "invoiceable" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 44,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var voucher967 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Produktrechnung ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/InvoicingsByInvoiceable/voucher" }) }) });
    var title968 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var qty969 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "maxLength": 6, "selectOnFocus": true });
    var voucher__voucher_date970 = new Lino.DateField({ "disabled": true, "sortable": false });
    var voucher__state971 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "disabled": true, "maxLength": 10, "sortable": false });
    var product__number_of_events972 = new Ext.form.NumberField({ "disabled": true, "sortable": false });
    var id973 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var seqno974 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var total_incl975 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_base976 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat977 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_class978 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var unit_price979 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var product980 = new Lino.RemoteComboFieldElement({ "emptyText": "Tarif ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/InvoicingsByInvoiceable/product" }) }) });
    var description981 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var discount982 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var invoiceable_type983 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/InvoicingsByInvoiceable/invoiceable_type" }) }) });
    var invoiceable_id984 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/InvoicingsByInvoiceable/invoiceable_id" }) }) });
    var mobile_item_disp985 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp986 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp987 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp988 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoiceable_disp989 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      invoiceable_type983.on('change',Lino.chooser_handler(invoiceable_id984,'invoiceable_type'));
      Lino.invoicing.InvoicingsByInvoiceable.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "voucher", "editable": true, "editor": voucher967, "filter": { "type": "string" }, "header": "Produktrechnung", "renderer": Lino.fk_renderer('voucherHidden','Lino.sales.Invoices.detail'), "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.voucher) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "title", "editable": true, "editor": title968, "filter": { "type": "string" }, "header": "\u00dcberschrift", "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.title) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 2, "dataIndex": "qty", "editable": true, "editor": qty969, "filter": { "type": "string" }, "format": "", "header": "Menge", "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.qty) ", "width": Lino.chars2width(8) }, { "colIndex": 3, "dataIndex": "voucher__voucher_date", "editable": false, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Belegdatum", "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.voucher__voucher_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "voucher__state", "editable": false, "filter": { "type": "string" }, "header": "Zustand", "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.voucher__state) ", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 5, "dataIndex": "product__number_of_events", "editable": false, "filter": { "type": "numeric" }, "format": "0", "header": "Anzahl Termine", "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.product__number_of_events) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id973, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "seqno", "editable": true, "editor": seqno974, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "total_incl", "editable": true, "editor": total_incl975, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 9, "dataIndex": "total_base", "editable": true, "editor": total_base976, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 10, "dataIndex": "total_vat", "editable": true, "editor": total_vat977, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "MwSt.", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 11, "dataIndex": "vat_class", "editable": true, "editor": vat_class978, "filter": { "type": "string" }, "header": "MwSt.-Klasse", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.vat_class) ", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 12, "dataIndex": "unit_price", "editable": true, "editor": unit_price979, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "St\u00fcckpreis", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.unit_price) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 13, "dataIndex": "product", "editable": true, "editor": product980, "filter": { "type": "string" }, "header": "Tarif", "hidden": true, "renderer": Lino.fk_renderer('productHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.product) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "description", "editable": true, "editor": description981, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.description) A multi-line rich text to be printed in the resulting printable\ndocument.", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 15, "dataIndex": "discount", "editable": true, "editor": discount982, "filter": { "type": "numeric" }, "format": "0.000,00/i", "header": "Erm\u00e4\u00dfigung", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.discount) ", "width": Lino.chars2width(8), "xtype": "numbercolumn" }, { "colIndex": 16, "dataIndex": "invoiceable_type", "editable": true, "editor": invoiceable_type983, "filter": { "type": "string" }, "header": "Fakturiertes Objekt (Modell)", "hidden": true, "renderer": Lino.fk_renderer('invoiceable_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.invoiceable_type) ", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "invoiceable_id", "editable": true, "editor": invoiceable_id984, "filter": { "type": "string" }, "header": "Fakturiertes Objekt (Objekt)", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.invoiceable_id) ", "width": Lino.chars2width(11) }, { "colIndex": 18, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "move_buttons", "editable": false, "header": "Bearbeiten", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 22, "dataIndex": "invoiceable", "editable": false, "header": "Fakturiertes Objekt", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.invoiceable) ", "width": Lino.chars2width(11) } ];
    Lino.invoicing.InvoicingsByInvoiceable.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.InvoicingsByInvoiceable.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.invoicing.InvoicingsByInvoiceable.GridPanel(p);
});
Lino.invoicing.InvoicingsByInvoiceable.move_up = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.move_down = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.NotesByOwner
Lino.notes.NotesByOwner.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 30,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/NotesByOwner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByOwner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByOwner','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByOwner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByOwner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByOwner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Notizen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "event_type" }, 'event_typeHidden', { "name": "type" }, 'typeHidden', { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "body" }, { "name": "language" }, 'languageHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "owner" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByOwner.detail;
    var ww = this.containing_window;
    var date669 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time670 = new Lino.TimeField({ "selectOnFocus": true });
    var event_type671 = new Lino.RemoteComboFieldElement({ "emptyText": "Event Type ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/event_type" }) }) });
    var type672 = new Lino.RemoteComboFieldElement({ "emptyText": "Notizart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/type" }) }) });
    var subject673 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user674 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/user" }) }) });
    var id675 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_time676 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method677 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company678 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/company" }) }) });
    var contact_person679 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/contact_person" }) }) });
    var contact_role680 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/contact_role" }) }) });
    var owner_type681 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/owner_type" }) }) });
    var owner_id682 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/owner_id" }) }) });
    var body683 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var language684 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var mobile_item_disp685 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp686 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp687 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var owner_disp688 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      contact_person679.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id682.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company678.on('change',Lino.chooser_handler(contact_person679,'company'));
      owner_type681.on('change',Lino.chooser_handler(owner_id682,'owner_type'));
      Lino.notes.NotesByOwner.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date669, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum", "sortable": true, "tooltip": "(notes.NotesByOwner.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time670, "header": "Zeit", "sortable": true, "tooltip": "(notes.NotesByOwner.time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type671, "filter": { "type": "string" }, "header": "Ereignisart (Form)", "renderer": Lino.fk_renderer('event_typeHidden','Lino.notes.EventTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByOwner.event_type) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type672, "filter": { "type": "string" }, "header": "Notizart (Inhalt)", "renderer": Lino.fk_renderer('typeHidden','Lino.notes.NoteTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByOwner.type) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "subject", "editable": true, "editor": subject673, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(notes.NotesByOwner.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user674, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.NotesByOwner.user) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id675, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByOwner.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 7, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByOwner.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "build_method", "editable": true, "editor": build_method677, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 9, "dataIndex": "company", "editable": true, "editor": company678, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Organisation)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.NotesByOwner.company) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "contact_person", "editable": true, "editor": contact_person679, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.NotesByOwner.contact_person) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "contact_role", "editable": true, "editor": contact_role680, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_type", "editable": true, "editor": owner_type681, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByOwner.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "owner_id", "editable": true, "editor": owner_id682, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "body", "editable": true, "editor": body683, "filter": { "type": "string" }, "header": "Inhalt", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.body) ", "width": Lino.chars2width(61) }, { "colIndex": 15, "dataIndex": "language", "editable": true, "editor": language684, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.language) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.owner) ", "width": Lino.chars2width(11) } ];
    Lino.notes.NotesByOwner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByOwner.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByOwner.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/NotesByOwner",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByOwner.detail;
    Lino.notes.NotesByOwner.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByOwner.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.NotesByOwner.detailPanel(p);
});
Lino.notes.NotesByOwner.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.NotesByOwner.GridPanel(p);
});
Lino.notes.NotesByOwner.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/NotesByOwner", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.TasksByController
Lino.cal.TasksByController.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 4,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/TasksByController",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByController','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByController','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByController','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByController','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByController','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Aufgaben",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 18,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.TasksByController.detail;
    this.ls_insert_handler = Lino.cal.TasksByController.insert;
    var ww = this.containing_window;
    var start_date6256 = new Lino.DateField({ "selectOnFocus": true });
    var summary6257 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp6258 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id6259 = new Ext.form.NumberField({ "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date6256, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(cal.TasksByController.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "summary", "editable": true, "editor": summary6257, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.TasksByController.summary) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.TasksByController.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id6259, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.TasksByController.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" } ];
    Lino.cal.TasksByController.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TasksByController.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.TasksByController.insertPanel = Ext.extend(Lino.cal.Tasks.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/TasksByController",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.TasksByController.detail;
    this.ls_insert_handler = Lino.cal.TasksByController.insert;
    Lino.cal.TasksByController.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TasksByController.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.TasksByController.insertPanel(p);
});
Lino.cal.TasksByController.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.TasksByController.detailPanel = Ext.extend(Lino.cal.Tasks.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  ls_url: "/cal/TasksByController",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.TasksByController.detail;
    this.ls_insert_handler = Lino.cal.TasksByController.insert;
    Lino.cal.TasksByController.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TasksByController.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.TasksByController.detailPanel(p);
});
Lino.cal.TasksByController.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Tasks.ParamsPanel({});
  return new Lino.cal.TasksByController.GridPanel(p);
});
Lino.cal.TasksByController.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.wf1 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.wf4 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TasksByController", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class gfks.HelpTextsByModel
Lino.gfks.HelpTextsByModel.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 6,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/gfks/HelpTextsByModel",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTextsByModel','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTextsByModel','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTextsByModel','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTextsByModel','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTextsByModel','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Hilfetexte",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "field" }, { "name": "verbose_name" }, { "name": "help_text" }, { "name": "id", "type": "int" }, { "name": "content_type" }, 'content_typeHidden', { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 16,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var field3363 = new Lino.SimpleRemoteComboFieldElement({ "allowBlank": false, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/gfks/HelpTextsByModel/field" }) }) });
    var verbose_name3364 = new Ext.form.TextField({ "disabled": true, "maxLength": 200 });
    var help_text3365 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var id3366 = new Ext.form.NumberField({ "selectOnFocus": true });
    var content_type3367 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Datenbankmodell ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/gfks/HelpTextsByModel/content_type" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      field3363.setContextValue('mk',bp['mk']);
      field3363.setContextValue('mt',bp['mt']);
    };
    this.onRender = function(ct, position) {
      content_type3367.on('change',Lino.chooser_handler(field3363,'content_type'));
      Lino.gfks.HelpTextsByModel.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "field", "editable": true, "editor": field3363, "filter": { "type": "string" }, "header": "Feld", "sortable": false, "tooltip": "(gfks.HelpTextsByModel.field) ", "width": Lino.chars2width(11) }, { "colIndex": 1, "dataIndex": "verbose_name", "editable": false, "header": "Feldbezeichnung", "sortable": false, "tooltip": "(gfks.HelpTextsByModel.verbose_name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "help_text", "editable": true, "editor": help_text3365, "filter": { "type": "string" }, "header": "Hilfetext", "sortable": false, "tooltip": "(gfks.HelpTextsByModel.help_text) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id3366, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(gfks.HelpTextsByModel.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "content_type", "editable": true, "editor": content_type3367, "filter": { "type": "string" }, "header": "Modell", "renderer": Lino.fk_renderer('content_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(gfks.HelpTextsByModel.content_type) ", "width": Lino.chars2width(21) } ];
    Lino.gfks.HelpTextsByModel.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.gfks.HelpTextsByModel.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTextsByModel", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTextsByModel", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTextsByModel", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTextsByModel", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTextsByModel", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTextsByModel", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTextsByModel", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/HelpTextsByModel", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.gfks.HelpTextsByModel.GridPanel(p);
});

// js_render_GridPanel_class outbox.MailsByController
Lino.outbox.MailsByController.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 16,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/MailsByController",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByController','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByController','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByController','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByController','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByController','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "E-Mail senden", "overflowText": "E-Mail senden", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  cell_edit : true,
  title : "E-Mail-Ausg\u00e4nge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "sent" }, { "name": "recipients" }, { "name": "subject" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "body" }, { "name": "owner" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 72,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MailsByController.detail;
    this.ls_insert_handler = Lino.outbox.MailsByController.insert;
    var ww = this.containing_window;
    var sent6261 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var recipients_htmlbox6262 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "recipients", "title": "Empf\u00e4nger", "value": "<br/>" });
    var subject6263 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id6264 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user6265 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/MailsByController/user" }) }) });
    var owner_type6266 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/MailsByController/owner_type" }) }) });
    var owner_id6267 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/MailsByController/owner_id" }) }) });
    var date6268 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var mobile_item_disp6269 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6270 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6271 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var body6272 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var owner_disp6273 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      recipients_htmlbox6262.refresh();
      owner_id6267.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type6266.on('change',Lino.chooser_handler(owner_id6267,'owner_type'));
      Lino.outbox.MailsByController.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "sent", "editable": false, "header": "sent", "sortable": true, "tooltip": "(outbox.MailsByController.sent) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "recipients", "editable": false, "header": "Empf\u00e4nger", "sortable": false, "tooltip": "(outbox.MailsByController.recipients) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "subject", "editable": true, "editor": subject6263, "filter": { "type": "string" }, "header": "Betreff", "sortable": true, "tooltip": "(outbox.MailsByController.subject) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id6264, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(outbox.MailsByController.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user6265, "filter": { "type": "string" }, "header": "Absender", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(outbox.MailsByController.user) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "owner_type", "editable": true, "editor": owner_type6266, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(outbox.MailsByController.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "owner_id", "editable": true, "editor": owner_id6267, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(outbox.MailsByController.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "date", "editable": true, "editor": date6268, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Datum", "hidden": true, "sortable": true, "tooltip": "(outbox.MailsByController.date) \n        The official date to be printed on the document.\n        ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.MailsByController.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.MailsByController.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(outbox.MailsByController.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "body", "editable": true, "editor": body6272, "filter": { "type": "string" }, "header": "Inhalt", "hidden": true, "sortable": false, "tooltip": "(outbox.MailsByController.body) ", "width": Lino.chars2width(61) }, { "colIndex": 12, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(outbox.MailsByController.owner) ", "width": Lino.chars2width(11) } ];
    Lino.outbox.MailsByController.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MailsByController.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByController", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByController", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByController", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByController", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByController", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.MailsByController.insertPanel = Ext.extend(Lino.outbox.Mails.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/outbox/MailsByController",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MailsByController.detail;
    this.ls_insert_handler = Lino.outbox.MailsByController.insert;
    Lino.outbox.MailsByController.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MailsByController.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.outbox.MailsByController.insertPanel(p);
});
Lino.outbox.MailsByController.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByController", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByController", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByController", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.MailsByController.detailPanel = Ext.extend(Lino.outbox.Mails.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "E-Mail senden", "overflowText": "E-Mail senden", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  ls_url: "/outbox/MailsByController",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MailsByController.detail;
    this.ls_insert_handler = Lino.outbox.MailsByController.insert;
    Lino.outbox.MailsByController.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MailsByController.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.MailsByController.detailPanel(p);
});
Lino.outbox.MailsByController.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByController", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByController", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.outbox.Mails.ParamsPanel({});
  return new Lino.outbox.MailsByController.GridPanel(p);
});
Lino.outbox.MailsByController.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByController", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.send_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/MailsByController", "GET", pk, "send_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class plausibility.ProblemsByOwner
Lino.plausibility.ProblemsByOwner.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/plausibility/ProblemsByOwner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByOwner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByOwner','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByOwner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByOwner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByOwner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Datenkontrolle durchf\u00fchren" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Datenprobleme reparieren" } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : false,
  title : "Datenprobleme",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "message" }, { "name": "checker" }, 'checkerHidden', { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "owner" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 17,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.ProblemsByOwner.detail;
    var ww = this.containing_window;
    var message6275 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 250, "selectOnFocus": true });
    var checker6276 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.plausibility.Checkers });
    var user6277 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/ProblemsByOwner/user" }) }) });
    var id6278 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type6279 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/ProblemsByOwner/owner_type" }) }) });
    var owner_id6280 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/ProblemsByOwner/owner_id" }) }) });
    var mobile_item_disp6281 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6282 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6283 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var owner_disp6284 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      owner_type6279.on('change',Lino.chooser_handler(owner_id6280,'owner_type'));
      Lino.plausibility.ProblemsByOwner.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "message", "editable": true, "editor": message6275, "filter": { "type": "string" }, "header": "Meldung", "sortable": true, "tooltip": "(plausibility.ProblemsByOwner.message) The message text. This is a concatenation of all messages that\nwere yeld by the checker.", "width": Lino.chars2width(51) }, { "colIndex": 1, "dataIndex": "checker", "editable": true, "editor": checker6276, "filter": { "type": "string" }, "header": "Datentest", "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.checker) The Checker which reported\nthis problem.", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user6277, "filter": { "type": "string" }, "header": "Verantwortlicher", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.user) The user reponsible\nfor fixing this problem.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id6278, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(plausibility.ProblemsByOwner.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "owner_type", "editable": true, "editor": owner_type6279, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "owner_id", "editable": true, "editor": owner_id6280, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.owner) ", "width": Lino.chars2width(11) } ];
    Lino.plausibility.ProblemsByOwner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.ProblemsByOwner.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByOwner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByOwner.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByOwner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByOwner.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByOwner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByOwner.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByOwner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByOwner.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByOwner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByOwner.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByOwner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.plausibility.ProblemsByOwner.detailPanel = Ext.extend(Lino.plausibility.Problems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Datenkontrolle durchf\u00fchren" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Datenprobleme reparieren" } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/plausibility/ProblemsByOwner",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.ProblemsByOwner.detail;
    Lino.plausibility.ProblemsByOwner.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.ProblemsByOwner.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.ProblemsByOwner.detailPanel(p);
});
Lino.plausibility.ProblemsByOwner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.plausibility.Problems.ParamsPanel({});
  return new Lino.plausibility.ProblemsByOwner.GridPanel(p);
});
Lino.plausibility.ProblemsByOwner.update_problem = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByOwner", "GET", pk, "update_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByOwner.fix_problem = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/ProblemsByOwner", "GET", pk, "fix_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class changes.ChangesByMaster
Lino.changes.ChangesByMaster.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/changes/ChangesByMaster",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByMaster','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByMaster','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByMaster','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByMaster','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByMaster','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" } ],
  cell_edit : true,
  title : "\u00c4nderungen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "time" }, { "name": "user" }, 'userHidden', { "name": "type" }, 'typeHidden', { "name": "changed_fields" }, { "name": "object" }, { "name": "id", "type": "int" }, { "name": "object_type" }, 'object_typeHidden', { "name": "object_id" }, 'object_idHidden', { "name": "master_type" }, 'master_typeHidden', { "name": "master_id" }, 'master_idHidden', { "name": "diff" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "master" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 77,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.changes.ChangesByMaster.detail;
    var ww = this.containing_window;
    var time1472 = new Ext.form.DisplayField({ "allowBlank": false, "selectOnFocus": true, "value": "<br>" });
    var user1473 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByMaster/user" }) }) });
    var type1474 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.changes.ChangeTypes });
    var changed_fields1475 = new Ext.form.TextField({ "maxLength": 250, "selectOnFocus": true });
    var object_disp1476 = new Ext.form.DisplayField({ "disabled": true });
    var id1477 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var object_type1478 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByMaster/object_type" }) }) });
    var object_id1479 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByMaster/object_id" }) }) });
    var master_type1480 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByMaster/master_type" }) }) });
    var master_id1481 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByMaster/master_id" }) }) });
    var diff1482 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var mobile_item_disp1483 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1484 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1485 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var master_disp1486 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      object_type1478.on('change',Lino.chooser_handler(object_id1479,'object_type'));
      master_type1480.on('change',Lino.chooser_handler(master_id1481,'master_type'));
      Lino.changes.ChangesByMaster.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "time", "editable": true, "editor": time1472, "header": "time", "sortable": true, "tooltip": "(changes.ChangesByMaster.time) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user1473, "filter": { "type": "string" }, "header": "Benutzer", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(changes.ChangesByMaster.user) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "type", "editable": true, "editor": type1474, "filter": { "type": "string" }, "header": "\u00c4nderungsart", "sortable": false, "tooltip": "(changes.ChangesByMaster.type) ", "width": Lino.chars2width(16) }, { "colIndex": 3, "dataIndex": "changed_fields", "editable": true, "editor": changed_fields1475, "filter": { "type": "string" }, "header": "Felder", "sortable": true, "tooltip": "(changes.ChangesByMaster.changed_fields) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "object", "editable": false, "header": "Object", "sortable": false, "tooltip": "(changes.ChangesByMaster.object) The database object which has been modified.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id1477, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(changes.ChangesByMaster.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "object_type", "editable": true, "editor": object_type1478, "filter": { "type": "string" }, "header": "Object type", "hidden": true, "renderer": Lino.fk_renderer('object_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(changes.ChangesByMaster.object_type) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "object_id", "editable": true, "editor": object_id1479, "filter": { "type": "string" }, "header": "object id", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.object_id) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "master_type", "editable": true, "editor": master_type1480, "filter": { "type": "string" }, "header": "Master type", "hidden": true, "renderer": Lino.fk_renderer('master_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(changes.ChangesByMaster.master_type) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "master_id", "editable": true, "editor": master_id1481, "filter": { "type": "string" }, "header": "master id", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.master_id) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "diff", "editable": true, "editor": diff1482, "filter": { "type": "string" }, "header": "\u00c4nderungen", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.diff) ", "width": Lino.chars2width(61) }, { "colIndex": 11, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "master", "editable": false, "header": "Stammdaten", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.master) The database object which acts as \"master\".", "width": Lino.chars2width(11) } ];
    Lino.changes.ChangesByMaster.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.ChangesByMaster.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangesByMaster", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByMaster.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangesByMaster", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByMaster.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangesByMaster", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByMaster.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangesByMaster", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByMaster.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangesByMaster", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByMaster.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangesByMaster", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.changes.ChangesByMaster.detailPanel = Ext.extend(Lino.changes.Changes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/changes/ChangesByMaster",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.changes.ChangesByMaster.detail;
    Lino.changes.ChangesByMaster.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.ChangesByMaster.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.changes.ChangesByMaster.detailPanel(p);
});
Lino.changes.ChangesByMaster.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.changes.Changes.ParamsPanel({});
  return new Lino.changes.ChangesByMaster.GridPanel(p);
});

// js_render_GridPanel_class cal.EntriesByController
Lino.cal.EntriesByController.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/EntriesByController",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByController','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByController','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByController','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByController','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByController','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Kalendereintr\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "when_text" }, { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "event_type" }, 'event_typeHidden', { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "owner" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByController.detail;
    this.ls_insert_handler = Lino.cal.EntriesByController.insert;
    var ww = this.containing_window;
    var when_text_disp6286 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var summary6287 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp6288 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id6289 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified6290 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created6291 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date6292 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time6293 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date6294 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time6295 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time6296 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method6297 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user6298 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/user" }) }) });
    var assigned_to6299 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/assigned_to" }) }) });
    var owner_type6300 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/owner_type" }) }) });
    var owner_id6301 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/owner_id" }) }) });
    var description6302 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class6303 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence6304 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type6305 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var event_type6306 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/event_type" }) }) });
    var transparent6307 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room6308 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/room" }) }) });
    var priority6309 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/priority" }) }) });
    var state6310 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var calendar6311 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp6312 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp6313 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day6314 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp6315 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp6316 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6317 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp6318 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration6319 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    var owner_disp6320 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      owner_id6301.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type6300.on('change',Lino.chooser_handler(owner_id6301,'owner_type'));
      Lino.cal.EntriesByController.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_text", "editable": false, "header": "Wann", "sortable": false, "tooltip": "(cal.EntriesByController.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "summary", "editable": true, "editor": summary6287, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(cal.EntriesByController.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(cal.EntriesByController.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id6289, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 5, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "start_date", "editable": true, "editor": start_date6292, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "start_time", "editable": true, "editor": start_time6293, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 8, "dataIndex": "end_date", "editable": true, "editor": end_date6294, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "end_time", "editable": true, "editor": end_time6295, "header": "Endet um", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "build_method", "editable": true, "editor": build_method6297, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 12, "dataIndex": "user", "editable": true, "editor": user6298, "filter": { "type": "string" }, "header": "Verantwortlicher", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.EntriesByController.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to6299, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.EntriesByController.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_type", "editable": true, "editor": owner_type6300, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.EntriesByController.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_id", "editable": true, "editor": owner_id6301, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description6302, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class6303, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence6304, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type6305, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "event_type", "editable": true, "editor": event_type6306, "filter": { "type": "string" }, "header": "Kalendereintragsart", "hidden": true, "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(cal.EntriesByController.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 22, "dataIndex": "room", "editable": true, "editor": room6308, "filter": { "type": "string" }, "header": "Raum", "hidden": true, "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(cal.EntriesByController.room) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "priority", "editable": true, "editor": priority6309, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "state", "editable": true, "editor": state6310, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 25, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(cal.EntriesByController.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 29, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.url) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 33, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 34, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.owner) ", "width": Lino.chars2width(11) } ];
    Lino.cal.EntriesByController.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByController.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EntriesByController.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/cal/EntriesByController",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByController.detail;
    this.ls_insert_handler = Lino.cal.EntriesByController.insert;
    Lino.cal.EntriesByController.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByController.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.EntriesByController.insertPanel(p);
});
Lino.cal.EntriesByController.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EntriesByController.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/EntriesByController",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByController.detail;
    this.ls_insert_handler = Lino.cal.EntriesByController.insert;
    Lino.cal.EntriesByController.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByController.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.EntriesByController.detailPanel(p);
});
Lino.cal.EntriesByController.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.EntriesByController.GridPanel(p);
});
Lino.cal.EntriesByController.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntriesByController", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class outbox.AttachmentsByController
Lino.outbox.AttachmentsByController.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 11,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/AttachmentsByController",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByController','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByController','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByController','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByController','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByController','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" } ],
  cell_edit : true,
  title : "Anh\u00e4nge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "mail" }, 'mailHidden', { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "owner" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 74,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id11165 = new Ext.form.NumberField({ "selectOnFocus": true });
    var owner_type11166 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/AttachmentsByController/owner_type" }) }) });
    var owner_id11167 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/AttachmentsByController/owner_id" }) }) });
    var mail11168 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "E-Mail-Ausgang ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/AttachmentsByController/mail" }) }) });
    var mobile_item_disp11169 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp11170 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp11171 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var owner_disp11172 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      owner_id11167.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type11166.on('change',Lino.chooser_handler(owner_id11167,'owner_type'));
      Lino.outbox.AttachmentsByController.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id11165, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(outbox.AttachmentsByController.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "owner_type", "editable": true, "editor": owner_type11166, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(outbox.AttachmentsByController.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "owner_id", "editable": true, "editor": owner_id11167, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "sortable": false, "tooltip": "(outbox.AttachmentsByController.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 3, "dataIndex": "mail", "editable": true, "editor": mail11168, "filter": { "type": "string" }, "header": "E-Mail-Ausgang", "renderer": Lino.fk_renderer('mailHidden','Lino.outbox.Mails.detail'), "sortable": false, "tooltip": "(outbox.AttachmentsByController.mail) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.AttachmentsByController.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(outbox.AttachmentsByController.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(outbox.AttachmentsByController.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(outbox.AttachmentsByController.owner) ", "width": Lino.chars2width(11) } ];
    Lino.outbox.AttachmentsByController.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.AttachmentsByController.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByController", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByController.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByController", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByController.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByController", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByController.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByController", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByController.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByController", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByController.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByController", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByController.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByController", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByController.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/AttachmentsByController", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByController.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.AttachmentsByController.GridPanel(p);
});

// js_render_GridPanel_class courses.EntriesByCourse
Lino.courses.EntriesByCourse.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 46,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EntriesByCourse",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByCourse','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByCourse','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByCourse','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByCourse','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByCourse','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Kalendereintr\u00e4ge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "workflow_buttons" }, { "name": "start_time" }, { "name": "end_time" }, { "name": "room" }, 'roomHidden', { "name": "summary" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "event_type" }, 'event_typeHidden', { "name": "transparent", "type": "boolean" }, { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "when_text" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "owner" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EntriesByCourse.detail;
    this.ls_insert_handler = Lino.courses.EntriesByCourse.insert;
    var ww = this.containing_window;
    var start_date6322 = new Lino.DateField({ "selectOnFocus": true });
    var auto_type6323 = new Ext.form.NumberField({ "selectOnFocus": true });
    var workflow_buttons_disp6324 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var start_time6325 = new Lino.TimeField({ "selectOnFocus": true });
    var end_time6326 = new Lino.TimeField({ "selectOnFocus": true });
    var room6327 = new Lino.RemoteComboFieldElement({ "emptyText": "Raum ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/room" }) }) });
    var summary6328 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id6329 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified6330 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created6331 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var end_date6332 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var build_time6333 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method6334 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user6335 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/user" }) }) });
    var assigned_to6336 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/assigned_to" }) }) });
    var owner_type6337 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/owner_type" }) }) });
    var owner_id6338 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/owner_id" }) }) });
    var description6339 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class6340 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence6341 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var event_type6342 = new Lino.RemoteComboFieldElement({ "emptyText": "Kalendereintragsart ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/event_type" }) }) });
    var transparent6343 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var priority6344 = new Lino.RemoteComboFieldElement({ "emptyText": "Priorit\u00e4t ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/priority" }) }) });
    var state6345 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var calendar6346 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Kalender ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp6347 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp6348 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var when_text_disp6349 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day6350 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp6351 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mobile_item_disp6352 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6353 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp6354 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration6355 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    var owner_disp6356 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      owner_id6338.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type6337.on('change',Lino.chooser_handler(owner_id6338,'owner_type'));
      Lino.courses.EntriesByCourse.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date6322, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Beginnt am", "sortable": true, "tooltip": "(courses.EntriesByCourse.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "auto_type", "editable": true, "editor": auto_type6323, "filter": { "type": "numeric" }, "format": "0", "header": "Nr.", "sortable": true, "tooltip": "(courses.EntriesByCourse.auto_type) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "sortable": false, "tooltip": "(courses.EntriesByCourse.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "start_time", "editable": true, "editor": start_time6325, "header": "Start time", "sortable": true, "tooltip": "(courses.EntriesByCourse.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 4, "dataIndex": "end_time", "editable": true, "editor": end_time6326, "header": "Endet um", "sortable": true, "tooltip": "(courses.EntriesByCourse.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 5, "dataIndex": "room", "editable": true, "editor": room6327, "filter": { "type": "string" }, "header": "Raum", "renderer": Lino.fk_renderer('roomHidden','Lino.cal.AllRooms.detail'), "sortable": false, "tooltip": "(courses.EntriesByCourse.room) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "summary", "editable": true, "editor": summary6328, "filter": { "type": "string" }, "header": "Kurzbeschreibung", "sortable": true, "tooltip": "(courses.EntriesByCourse.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id6329, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EntriesByCourse.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 8, "dataIndex": "modified", "editable": false, "header": "Bearbeitet", "hidden": true, "sortable": true, "tooltip": "(courses.EntriesByCourse.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 9, "dataIndex": "created", "editable": false, "header": "Erstellt", "hidden": true, "sortable": true, "tooltip": "(courses.EntriesByCourse.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 10, "dataIndex": "end_date", "editable": true, "editor": end_date6332, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.EntriesByCourse.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "hidden": true, "sortable": true, "tooltip": "(courses.EntriesByCourse.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 12, "dataIndex": "build_method", "editable": true, "editor": build_method6334, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 13, "dataIndex": "user", "editable": true, "editor": user6335, "filter": { "type": "string" }, "header": "Verantwortlicher", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EntriesByCourse.user) Der verantwortliche Benutzer.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to6336, "filter": { "type": "string" }, "header": "Zugewiesen zu", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EntriesByCourse.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_type", "editable": true, "editor": owner_type6337, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(courses.EntriesByCourse.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "owner_id", "editable": true, "editor": owner_id6338, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 17, "dataIndex": "description", "editable": true, "editor": description6339, "filter": { "type": "string" }, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 18, "dataIndex": "access_class", "editable": true, "editor": access_class6340, "filter": { "type": "string" }, "header": "Zugriffsklasse", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.access_class) Ob dieser Termin  privat, \u00f6ffentlich oder halb \u00f6ffentlich ist", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 19, "dataIndex": "sequence", "editable": true, "editor": sequence6341, "filter": { "type": "numeric" }, "format": "0", "header": "Revisionsnummer", "hidden": true, "sortable": true, "tooltip": "(courses.EntriesByCourse.sequence) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 20, "dataIndex": "event_type", "editable": true, "editor": event_type6342, "filter": { "type": "string" }, "header": "Kalendereintragsart", "hidden": true, "renderer": Lino.fk_renderer('event_typeHidden','Lino.cal.EventTypes.detail'), "sortable": false, "tooltip": "(courses.EntriesByCourse.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "nicht blockierend", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 22, "dataIndex": "priority", "editable": true, "editor": priority6344, "filter": { "type": "string" }, "header": "Priorit\u00e4t", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "state", "editable": true, "editor": state6345, "filter": { "type": "string" }, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 24, "dataIndex": "calendar", "editable": false, "header": "Kalender", "hidden": true, "renderer": Lino.fk_renderer('calendarHidden','Lino.cal.Calendars.detail'), "sortable": false, "tooltip": "(courses.EntriesByCourse.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "when_html", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "reminder", "editable": false, "header": "Erinnerung", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "when_text", "editable": false, "header": "Wann", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "all_day", "editable": true, "header": "ganztags", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 29, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.url) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "created_natural", "editable": false, "header": "Erstellt", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 33, "dataIndex": "duration", "editable": false, "format": "", "header": "Dauer", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 34, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.owner) ", "width": Lino.chars2width(11) } ];
    Lino.courses.EntriesByCourse.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EntriesByCourse.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EntriesByCourse.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "Neu",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Datensatz erstellen und dann im Detail-Fenster \u00f6ffnen") }, "menu_item_text": "Erstellen", "overflowText": "Erstellen", "panel_btn_handler": function(panel){panel.save()}, "text": "Erstellen" } ],
  ls_url: "/courses/EntriesByCourse",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EntriesByCourse.detail;
    this.ls_insert_handler = Lino.courses.EntriesByCourse.insert;
    Lino.courses.EntriesByCourse.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EntriesByCourse.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EntriesByCourse.insertPanel(p);
});
Lino.courses.EntriesByCourse.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EntriesByCourse.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "Neu", "overflowText": "Neu", "panel_btn_handler": Lino.show_insert, "tooltip": "Neuen Datensatz erstellen" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "auto_save": true, "itemId": "show_conflicting", "listeners": { "render": Lino.quicktip_renderer('a2btn',"\u00dcberschneidende Termine anzeigen") }, "menu_item_text": "\u00a0\u2694\u00a0", "overflowText": "\u00a0\u2694\u00a0", "panel_btn_handler": Lino.row_action_handler('show_conflicting','GET',null), "text": "\u00a0\u2694\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Heute", "overflowText": "Heute", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Alle meine Termine" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Teilnehmer aktualisieren", "overflowText": "Teilnehmer aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Automatische Termine erstellen oder aktualisieren.") }, "menu_item_text": "Termine aktualisieren", "overflowText": "Termine aktualisieren", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/EntriesByCourse",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EntriesByCourse.detail;
    this.ls_insert_handler = Lino.courses.EntriesByCourse.insert;
    Lino.courses.EntriesByCourse.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EntriesByCourse.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EntriesByCourse.detailPanel(p);
});
Lino.courses.EntriesByCourse.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.show_conflicting = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.show_today = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.courses.EntriesByCourse.GridPanel(p);
});
Lino.courses.EntriesByCourse.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.update_guests = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.move_next = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.assign_to_me = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.take = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.update_events = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.reset_event = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.wf2 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.wf3 = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EntriesByCourse", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class excerpts.ExcerptsByOwner
Lino.excerpts.ExcerptsByOwner.GridPanel = Ext.extend(Lino.GridPanel,{
  disabled_fields_index : 26,
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/excerpts/ExcerptsByOwner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByOwner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByOwner','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByOwner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByOwner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByOwner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Bestehende Ausz\u00fcge",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  ls_store_fields : [ { "name": "build_time" }, { "name": "excerpt_type" }, 'excerpt_typeHidden', { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "language" }, 'languageHidden', { "name": "body_template_content" }, { "name": "preview" }, { "name": "mobile_item" }, { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "owner" }, { "name": "disabled_fields" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 76,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.ExcerptsByOwner.detail;
    var ww = this.containing_window;
    var build_time6358 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var excerpt_type6359 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Auszugsart ausw\u00e4hlen...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/excerpt_type" }) }) });
    var user6360 = new Lino.RemoteComboFieldElement({ "emptyText": "Benutzer ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/user" }) }) });
    var id6361 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_method6362 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company6363 = new Lino.RemoteComboFieldElement({ "emptyText": "Organisation ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/company" }) }) });
    var contact_person6364 = new Lino.RemoteComboFieldElement({ "emptyText": "Person ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/contact_person" }) }) });
    var contact_role6365 = new Lino.RemoteComboFieldElement({ "emptyText": "Funktion ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/contact_role" }) }) });
    var owner_type6366 = new Lino.RemoteComboFieldElement({ "emptyText": "Datenbankmodell ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/owner_type" }) }) });
    var owner_id6367 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/owner_id" }) }) });
    var language6368 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "Englisch" ], [ "de", "Deutsch" ], [ "fr", "Franz\u00f6sisch" ] ] });
    var body_template_content6369 = new Ext.form.TextArea({ "disabled": true, "growMax": 2000, "hidden": true });
    var preview_htmlbox6370 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "preview", "title": "Vorschau", "value": "<br/>" });
    var mobile_item_disp6371 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6372 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6373 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var owner_disp6374 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      excerpt_type6359.setContextValue('mk',bp['mk']);
      excerpt_type6359.setContextValue('mt',bp['mt']);
      contact_person6364.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id6367.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      preview_htmlbox6370.refresh();
    };
    this.onRender = function(ct, position) {
      owner_disp6374.on('change',Lino.chooser_handler(excerpt_type6359,'owner'));
      company6363.on('change',Lino.chooser_handler(contact_person6364,'company'));
      owner_type6366.on('change',Lino.chooser_handler(owner_id6367,'owner_type'));
      Lino.excerpts.ExcerptsByOwner.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "build_time", "editable": false, "header": "Druckdatum", "sortable": true, "tooltip": "(excerpts.ExcerptsByOwner.build_time) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "excerpt_type", "editable": true, "editor": excerpt_type6359, "filter": { "type": "string" }, "header": "Auszugsart", "renderer": Lino.fk_renderer('excerpt_typeHidden','Lino.excerpts.ExcerptTypes.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.excerpt_type) The type of this excerpt (ForeignKey to ExcerptType).", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user6360, "filter": { "type": "string" }, "header": "Autor", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.user) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id6361, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(excerpts.ExcerptsByOwner.id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 4, "dataIndex": "build_method", "editable": true, "editor": build_method6362, "filter": { "type": "string" }, "header": "Konstruktionsmethode", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 5, "dataIndex": "company", "editable": true, "editor": company6363, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Organisation)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.company) The optional company of the recipient of this\nexcerpt.  See ContactRelated.company.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "contact_person", "editable": true, "editor": contact_person6364, "filter": { "type": "string" }, "header": "Empf\u00e4nger (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.contact_person) The optional contact person of the recipient of this\nexcerpt.  See ContactRelated.contact_person.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "contact_role", "editable": true, "editor": contact_role6365, "filter": { "type": "string" }, "header": "in seiner Eigenschaft als", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.contact_role) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_type", "editable": true, "editor": owner_type6366, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Modell)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "owner_id", "editable": true, "editor": owner_id6367, "filter": { "type": "string" }, "header": "Verkn\u00fcpft mit (Objekt)", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "language", "editable": true, "editor": language6368, "filter": { "type": "string" }, "header": "Sprache", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.language) The language used for printing this excerpt.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "body_template_content", "editable": false, "header": "Textk\u00f6rper-Vorlage", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.body_template_content) ", "width": Lino.chars2width(61) }, { "colIndex": 12, "dataIndex": "preview", "editable": false, "header": "Vorschau", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.preview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "mobile_item", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.mobile_item) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "overview", "editable": false, "header": "Beschreibung", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "workflow_buttons", "editable": false, "header": "Workflow", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "owner", "editable": false, "header": "Verkn\u00fcpft mit", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.owner) The object being printed by this excerpt.\nSee Controllable.owner.", "width": Lino.chars2width(11) } ];
    Lino.excerpts.ExcerptsByOwner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.ExcerptsByOwner.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.submit_detail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.grid_put = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.grid_post = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.submit_insert = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.duplicate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.excerpts.ExcerptsByOwner.detailPanel = Ext.extend(Lino.excerpts.Excerpts.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Speichern", "overflowText": "Speichern", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "\u00c4nderungen in diesem Formular speichern" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate the selected row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "L\u00f6schen", "overflowText": "L\u00f6schen", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Diesen Datensatz l\u00f6schen" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "Drucken" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Cache l\u00f6schen", "overflowText": "Cache l\u00f6schen", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Cache l\u00f6schen" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Datenkontrolle durchf\u00fchren", "overflowText": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Datenkontrolle durchf\u00fchren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Datenprobleme reparieren", "overflowText": "Datenprobleme reparieren", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Datenprobleme reparieren", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Datenkontrolle durchf\u00fchren", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "per Post", "overflowText": "per Post", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "per E-Mail", "overflowText": "per E-Mail", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/excerpts/ExcerptsByOwner",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.ExcerptsByOwner.detail;
    Lino.excerpts.ExcerptsByOwner.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.ExcerptsByOwner.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.excerpts.ExcerptsByOwner.detailPanel(p);
});
Lino.excerpts.ExcerptsByOwner.delete_selected = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.do_clear_cache = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.excerpts.Excerpts.ParamsPanel({});
  return new Lino.excerpts.ExcerptsByOwner.GridPanel(p);
});
Lino.excerpts.ExcerptsByOwner.validate = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.check_plausibility = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.fix_problems = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.create_postings = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.create_mail = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/ExcerptsByOwner", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class about.Models
Lino.about.Models.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/about/Models",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/about/Models','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/about/Models','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/about/Models','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/about/Models','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/about/Models','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" } ],
  cell_edit : true,
  title : "Models",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  ls_store_fields : [ { "name": "app" }, { "name": "name" }, { "name": "fields" }, { "name": "tables" }, { "name": "rows" }, { "name": "detail_action_column" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  initComponent : function() {
    this.ls_detail_handler = Lino.about.Models.detail;
    var ww = this.containing_window;
    var app_disp6376 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var name_disp6377 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var fields_disp6378 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var tables_disp6379 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var rows6380 = new Ext.form.NumberField({ "disabled": true });
    var detail_action_column_disp6381 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "app", "editable": false, "header": "app_label", "sortable": false, "tooltip": "(about.Models.app) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(about.Models.name) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "fields", "editable": false, "header": "Felder", "sortable": false, "tooltip": "(about.Models.fields) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "tables", "editable": false, "header": "Tables", "sortable": false, "tooltip": "(about.Models.tables) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 4, "dataIndex": "rows", "editable": false, "format": "0", "header": "Zeilen", "sortable": false, "tooltip": "(about.Models.rows) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "detail_action_column", "editable": false, "header": "Detail Action", "sortable": false, "tooltip": "(about.Models.detail_action_column) ", "width": Lino.chars2width(31) } ];
    Lino.about.Models.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.about.Models.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/Models", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Models.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/Models", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Models.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/Models", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Models.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/Models", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.about.Models.detailPanel = Ext.extend(Lino.about.Models.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/about/Models",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.about.Models.detail;
    Lino.about.Models.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.about.Models.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.about.Models.detailPanel(p);
});
Lino.about.Models.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.about.Models.GridPanel(p);
});

// js_render_GridPanel_class about.FieldsByModel
Lino.about.FieldsByModel.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/about/FieldsByModel",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/about/FieldsByModel','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/about/FieldsByModel','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/about/FieldsByModel','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/about/FieldsByModel','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/about/FieldsByModel','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Felder",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  ls_store_fields : [ { "name": "name" }, { "name": "verbose_name" }, { "name": "help_text_column" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var name_disp2808 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var verbose_name_disp2809 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var help_text_column_disp2810 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(about.FieldsByModel.name) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "verbose_name", "editable": false, "header": "verbose name", "sortable": false, "tooltip": "(about.FieldsByModel.verbose_name) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "help_text_column", "editable": false, "header": "help text", "sortable": false, "tooltip": "(about.FieldsByModel.help_text_column) ", "width": Lino.chars2width(31) } ];
    Lino.about.FieldsByModel.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.about.FieldsByModel.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/FieldsByModel", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.FieldsByModel.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/FieldsByModel", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.FieldsByModel.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/FieldsByModel", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.FieldsByModel.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/FieldsByModel", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.FieldsByModel.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.about.FieldsByModel.GridPanel(p);
});

// js_render_GridPanel_class about.Inspector
Lino.about.Inspector.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/about/Inspector",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/about/Inspector','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/about/Inspector','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/about/Inspector','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/about/Inspector','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/about/Inspector','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Inspector",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  ls_store_fields : [ { "name": "i_name" }, { "name": "i_type" }, { "name": "i_value" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var i_name_disp11174 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var i_type_disp11175 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var i_value_disp11176 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "i_name", "editable": false, "header": "Name", "sortable": false, "tooltip": "(about.Inspector.i_name) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "i_type", "editable": false, "header": "Art", "sortable": false, "tooltip": "(about.Inspector.i_type) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "i_value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(about.Inspector.i_value) ", "width": Lino.chars2width(31) } ];
    Lino.about.Inspector.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.about.Inspector.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/Inspector", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Inspector.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/Inspector", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Inspector.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/Inspector", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Inspector.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/Inspector", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Inspector.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.about.Inspector.ParamsPanel({});
  return new Lino.about.Inspector.GridPanel(p);
});

// js_render_GridPanel_class about.SourceFiles
Lino.about.SourceFiles.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/about/SourceFiles",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/about/SourceFiles','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/about/SourceFiles','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/about/SourceFiles','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/about/SourceFiles','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/about/SourceFiles','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Source files",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  ls_store_fields : [ { "name": "module_name" }, { "name": "code_lines", "type": "int", "useNull": true }, { "name": "doc_lines", "type": "int", "useNull": true } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var module_name6383 = new Ext.form.TextField({ "disabled": true, "maxLength": null });
    var code_lines6384 = new Ext.form.NumberField({ "disabled": true });
    var doc_lines6385 = new Ext.form.NumberField({ "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "module_name", "editable": false, "header": "module name", "sortable": false, "tooltip": "(about.SourceFiles.module_name) ", "width": Lino.chars2width(5) }, { "align": "right", "colIndex": 1, "dataIndex": "code_lines", "editable": false, "format": "0", "header": "Code", "sortable": false, "tooltip": "(about.SourceFiles.code_lines) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "doc_lines", "editable": false, "format": "0", "header": "doc", "sortable": false, "tooltip": "(about.SourceFiles.doc_lines) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" } ];
    Lino.about.SourceFiles.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.about.SourceFiles.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/SourceFiles", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.SourceFiles.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/SourceFiles", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.SourceFiles.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/SourceFiles", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.SourceFiles.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/about/SourceFiles", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.SourceFiles.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.about.SourceFiles.GridPanel(p);
});

// js_render_GridPanel_class ipdict.Connections
Lino.ipdict.Connections.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/ipdict/Connections",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ipdict/Connections','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ipdict/Connections','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ipdict/Connections','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ipdict/Connections','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ipdict/Connections','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Connections",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  ls_store_fields : [ { "name": "last_request" }, { "name": "ip_address" }, { "name": "login_failures" }, { "name": "blacklisted_since" }, { "name": "username" }, { "name": "last_login" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var last_request_disp525 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var ip_address_disp526 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var login_failures_disp527 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var blacklisted_since_disp528 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var username_disp529 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var last_login_disp530 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "last_request", "editable": false, "header": "Last request", "sortable": false, "tooltip": "(ipdict.Connections.last_request) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "ip_address", "editable": false, "header": "IP-Adresse", "sortable": false, "tooltip": "(ipdict.Connections.ip_address) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "login_failures", "editable": false, "header": "Login failures", "sortable": false, "tooltip": "(ipdict.Connections.login_failures) ", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "blacklisted_since", "editable": false, "header": "Blacklisted since", "sortable": false, "tooltip": "(ipdict.Connections.blacklisted_since) ", "width": Lino.chars2width(13) }, { "colIndex": 4, "dataIndex": "username", "editable": false, "header": "Benutzername", "sortable": false, "tooltip": "(ipdict.Connections.username) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "last_login", "editable": false, "header": "Last login", "sortable": false, "tooltip": "(ipdict.Connections.last_login) ", "width": Lino.chars2width(31) } ];
    Lino.ipdict.Connections.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ipdict.Connections.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ipdict/Connections", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ipdict.Connections.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ipdict/Connections", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ipdict.Connections.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ipdict/Connections", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ipdict.Connections.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ipdict/Connections", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ipdict.Connections.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(12), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(90) }, function(){
  var p = { "is_main_window": true };
  return new Lino.ipdict.Connections.GridPanel(p);
});

// js_render_GridPanel_class ledger.VouchersByPartnerBase
Lino.ledger.VouchersByPartnerBase.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/ledger/VouchersByPartnerBase",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/VouchersByPartnerBase','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/VouchersByPartnerBase','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/VouchersByPartnerBase','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/VouchersByPartnerBase','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/VouchersByPartnerBase','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Partnerbelege",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  ls_store_fields : [ { "name": "voucher" }, { "name": "partner" }, 'partnerHidden', { "name": "state" }, 'stateHidden', { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "detail_pointer" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var voucher_disp6387 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner6388 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var state6389 = new Lino.ChoicesFieldElement({ "disabled": true, "hidden": true, "store": [ [ "10", "Entwurf" ], [ "20", "Registriert" ], [ "30", "Unterschrieben" ], [ "40", "Storniert" ] ] });
    var entry_date6390 = new Lino.DateField({ "disabled": true, "hidden": true });
    var detail_pointer_disp6391 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "voucher", "editable": false, "header": "Beleg", "hidden": true, "sortable": false, "tooltip": "(ledger.VouchersByPartnerBase.voucher) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.VouchersByPartnerBase.partner) Pointer to the partner involved in this movement. This may be\nblank.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "state", "editable": false, "header": "Zustand", "hidden": true, "sortable": false, "tooltip": "(ledger.VouchersByPartnerBase.state) The workflow state of this voucher. Choices are defined in\nVoucherStates", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "entry_date", "editable": false, "format": "d.m.Y", "header": "Buchungsdatum", "hidden": true, "sortable": false, "tooltip": "(ledger.VouchersByPartnerBase.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(ledger.VouchersByPartnerBase.detail_pointer) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.VouchersByPartnerBase.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.VouchersByPartnerBase.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/VouchersByPartnerBase", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VouchersByPartnerBase.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/VouchersByPartnerBase", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VouchersByPartnerBase.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/VouchersByPartnerBase", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VouchersByPartnerBase.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/VouchersByPartnerBase", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VouchersByPartnerBase.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.VouchersByPartnerBase.GridPanel(p);
});

// js_render_GridPanel_class ledger.ExpectedMovements
Lino.ledger.ExpectedMovements.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/ExpectedMovements",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/ExpectedMovements','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/ExpectedMovements','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/ExpectedMovements','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/ExpectedMovements','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/ExpectedMovements','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  page_length : 20,
  cell_edit : true,
  title : "Schulden",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "balance" }, { "name": "debts" }, { "name": "payments" }, { "name": "id", "type": "int" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var due_date6393 = new Lino.DateField({ "disabled": true });
    var balance6394 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var debts_disp6395 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp6396 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": false, "tooltip": "(ledger.ExpectedMovements.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(16), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "balance", "editable": false, "format": "0.000,00/i", "header": "Saldo", "sortable": false, "tooltip": "(ledger.ExpectedMovements.balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "debts", "editable": false, "header": "Schulden", "sortable": false, "tooltip": "(ledger.ExpectedMovements.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "payments", "editable": false, "header": "Zahlungen", "sortable": false, "tooltip": "(ledger.ExpectedMovements.payments) List of payments in this match group", "width": Lino.chars2width(31) } ];
    Lino.ledger.ExpectedMovements.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.ExpectedMovements.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/ExpectedMovements", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.ExpectedMovements.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/ExpectedMovements", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.ExpectedMovements.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/ExpectedMovements", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.ExpectedMovements.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/ExpectedMovements", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.ExpectedMovements.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.ledger.ExpectedMovements.GridPanel(p);
});

// js_render_GridPanel_class ledger.DebtsByAccount
Lino.ledger.DebtsByAccount.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/DebtsByAccount",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByAccount','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByAccount','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByAccount','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByAccount','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByAccount','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  page_length : 20,
  cell_edit : true,
  title : "Schulden",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "balance" }, { "name": "debts" }, { "name": "payments" }, { "name": "id", "type": "int" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var due_date6398 = new Lino.DateField({ "disabled": true });
    var balance6399 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var debts_disp6400 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp6401 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": false, "tooltip": "(ledger.DebtsByAccount.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(16), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "balance", "editable": false, "format": "0.000,00/i", "header": "Saldo", "sortable": false, "tooltip": "(ledger.DebtsByAccount.balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "debts", "editable": false, "header": "Schulden", "sortable": false, "tooltip": "(ledger.DebtsByAccount.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "payments", "editable": false, "header": "Zahlungen", "sortable": false, "tooltip": "(ledger.DebtsByAccount.payments) List of payments in this match group", "width": Lino.chars2width(31) } ];
    Lino.ledger.DebtsByAccount.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.DebtsByAccount.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/DebtsByAccount", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByAccount.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/DebtsByAccount", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByAccount.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/DebtsByAccount", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByAccount.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/DebtsByAccount", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByAccount.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.ledger.DebtsByAccount.GridPanel(p);
});

// js_render_GridPanel_class ledger.DebtsByPartner
Lino.ledger.DebtsByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/DebtsByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  page_length : 20,
  cell_edit : true,
  title : "Schulden",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "balance" }, { "name": "debts" }, { "name": "payments" }, { "name": "id", "type": "int" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var due_date6403 = new Lino.DateField({ "disabled": true });
    var balance6404 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var debts_disp6405 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp6406 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": false, "tooltip": "(ledger.DebtsByPartner.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(16), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "balance", "editable": false, "format": "0.000,00/i", "header": "Saldo", "sortable": false, "tooltip": "(ledger.DebtsByPartner.balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 2, "dataIndex": "debts", "editable": false, "header": "Schulden", "sortable": false, "tooltip": "(ledger.DebtsByPartner.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "payments", "editable": false, "header": "Zahlungen", "sortable": false, "tooltip": "(ledger.DebtsByPartner.payments) List of payments in this match group", "width": Lino.chars2width(31) } ];
    Lino.ledger.DebtsByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.DebtsByPartner.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/DebtsByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByPartner.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/DebtsByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByPartner.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/DebtsByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByPartner.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/DebtsByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.ledger.DebtsByPartner.GridPanel(p);
});

// js_render_GridPanel_class ledger.Debtors
Lino.ledger.Debtors.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/ledger/Debtors",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/Debtors','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Debtors','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Debtors','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Debtors','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/Debtors','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Schuldner",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  ls_store_fields : [ { "name": "age", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "partner_id", "type": "int", "useNull": true }, { "name": "balance" }, { "name": "vouchers" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var age6408 = new Ext.form.NumberField({ "disabled": true });
    var due_date6409 = new Lino.DateField({ "disabled": true });
    var partner6410 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var partner_id6411 = new Ext.form.NumberField({ "disabled": true });
    var balance6412 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var vouchers_disp6413 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "age", "editable": false, "format": "0", "header": "Alter", "sortable": false, "tooltip": "(ledger.Debtors.age) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": false, "tooltip": "(ledger.Debtors.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "partner", "editable": false, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.Debtors.partner) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "partner_id", "editable": false, "format": "0", "header": "ID", "sortable": false, "tooltip": "(ledger.Debtors.partner_id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "balance", "editable": false, "format": "0.000,00/i", "header": "Saldo", "sortable": false, "tooltip": "(ledger.Debtors.balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "vouchers", "editable": false, "header": "Belege", "sortable": false, "tooltip": "(ledger.Debtors.vouchers) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.Debtors.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Debtors.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Debtors", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Debtors.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Debtors", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Debtors.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Debtors", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Debtors.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Debtors", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Debtors.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Debtors.ParamsPanel({});
  return new Lino.ledger.Debtors.GridPanel(p);
});

// js_render_GridPanel_class ledger.Creditors
Lino.ledger.Creditors.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/ledger/Creditors",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/Creditors','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Creditors','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Creditors','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/Creditors','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/Creditors','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Gl\u00e4ubiger",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  ls_store_fields : [ { "name": "age", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "partner_id", "type": "int", "useNull": true }, { "name": "balance" }, { "name": "vouchers" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var age6415 = new Ext.form.NumberField({ "disabled": true });
    var due_date6416 = new Lino.DateField({ "disabled": true });
    var partner6417 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Partner ausw\u00e4hlen...", "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var partner_id6418 = new Ext.form.NumberField({ "disabled": true });
    var balance6419 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var vouchers_disp6420 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "age", "editable": false, "format": "0", "header": "Alter", "sortable": false, "tooltip": "(ledger.Creditors.age) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "colIndex": 1, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": false, "tooltip": "(ledger.Creditors.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "partner", "editable": false, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.Creditors.partner) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "partner_id", "editable": false, "format": "0", "header": "ID", "sortable": false, "tooltip": "(ledger.Creditors.partner_id) ", "width": Lino.chars2width(6), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "balance", "editable": false, "format": "0.000,00/i", "header": "Saldo", "sortable": false, "tooltip": "(ledger.Creditors.balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 5, "dataIndex": "vouchers", "editable": false, "header": "Belege", "sortable": false, "tooltip": "(ledger.Creditors.vouchers) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.Creditors.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Creditors.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Creditors", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Creditors.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Creditors", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Creditors.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Creditors", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Creditors.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Creditors", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Creditors.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Creditors.ParamsPanel({});
  return new Lino.ledger.Creditors.GridPanel(p);
});

// js_render_GridPanel_class gfks.BrokenGFKs
Lino.gfks.BrokenGFKs.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/gfks/BrokenGFKs",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKs','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKs','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKs','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKs','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKs','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Broken GFKs",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  ls_store_fields : [ { "name": "database_model" }, { "name": "database_object" }, { "name": "message" }, { "name": "todo" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var database_model_disp11178 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var database_object_disp11179 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var message_disp11180 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var todo_disp11181 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "database_model", "editable": false, "header": "Database model", "sortable": false, "tooltip": "(gfks.BrokenGFKs.database_model) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "database_object", "editable": false, "header": "Datenobjekt", "sortable": false, "tooltip": "(gfks.BrokenGFKs.database_object) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "message", "editable": false, "header": "Meldung", "sortable": false, "tooltip": "(gfks.BrokenGFKs.message) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "todo", "editable": false, "header": "Action", "sortable": false, "tooltip": "(gfks.BrokenGFKs.todo) ", "width": Lino.chars2width(31) } ];
    Lino.gfks.BrokenGFKs.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.gfks.BrokenGFKs.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/BrokenGFKs", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKs.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/BrokenGFKs", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKs.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/BrokenGFKs", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKs.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/BrokenGFKs", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKs.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.gfks.BrokenGFKs.GridPanel(p);
});

// js_render_GridPanel_class gfks.BrokenGFKsByModel
Lino.gfks.BrokenGFKsByModel.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/gfks/BrokenGFKsByModel",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKsByModel','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKsByModel','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKsByModel','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKsByModel','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKsByModel','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Broken GFKs",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "database_object" }, { "name": "message" }, { "name": "todo" }, { "name": "id", "type": "int" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 1,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var database_object_disp3370 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var message_disp3371 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var todo_disp3372 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "database_object", "editable": false, "header": "Datenobjekt", "sortable": false, "tooltip": "(gfks.BrokenGFKsByModel.database_object) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "message", "editable": false, "header": "Meldung", "sortable": false, "tooltip": "(gfks.BrokenGFKsByModel.message) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "todo", "editable": false, "header": "Action", "sortable": false, "tooltip": "(gfks.BrokenGFKsByModel.todo) ", "width": Lino.chars2width(31) } ];
    Lino.gfks.BrokenGFKsByModel.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.gfks.BrokenGFKsByModel.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/BrokenGFKsByModel", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKsByModel.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/BrokenGFKsByModel", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKsByModel.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/BrokenGFKsByModel", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKsByModel.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/gfks/BrokenGFKsByModel", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKsByModel.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.gfks.BrokenGFKsByModel.GridPanel(p);
});

// js_render_GridPanel_class finan.SuggestionsByVoucher
Lino.finan.SuggestionsByVoucher.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/finan/SuggestionsByVoucher",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucher','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucher','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucher','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucher','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucher','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "F\u00fcllen", "overflowText": "F\u00fcllen", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucher','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Vorschl\u00e4ge",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "detail_pointer" }, { "name": "partner" }, 'partnerHidden', { "name": "id", "type": "int" } ],
  pk_index : 13,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp6422 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp6423 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date6424 = new Lino.DateField({ "disabled": true });
    var debts_disp6425 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp6426 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance6427 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account6428 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account6429 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Bankkonto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var detail_pointer_disp6430 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner6431 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Schulden", "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Zahlungen", "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "format": "0.000,00/i", "header": "Saldo", "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "bank_account", "editable": false, "header": "Bankkonto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.bank_account) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.partner) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByVoucher.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByVoucher.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByVoucher", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucher.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByVoucher", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucher.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByVoucher", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucher.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByVoucher", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucher.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByVoucher.GridPanel(p);
});
Lino.finan.SuggestionsByVoucher.do_fill = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByVoucher", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.SuggestionsByJournalEntry
Lino.finan.SuggestionsByJournalEntry.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/finan/SuggestionsByJournalEntry",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByJournalEntry','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByJournalEntry','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByJournalEntry','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByJournalEntry','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByJournalEntry','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "F\u00fcllen", "overflowText": "F\u00fcllen", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByJournalEntry','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Vorschl\u00e4ge",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "detail_pointer" }, { "name": "partner" }, 'partnerHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "id", "type": "int" } ],
  pk_index : 13,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp6433 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp6434 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date6435 = new Lino.DateField({ "disabled": true });
    var debts_disp6436 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp6437 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance6438 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account6439 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var detail_pointer_disp6440 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner6441 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account6442 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Bankkonto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Schulden", "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Zahlungen", "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "format": "0.000,00/i", "header": "Saldo", "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "bank_account", "editable": false, "header": "Bankkonto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.bank_account) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByJournalEntry.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByJournalEntry.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByJournalEntry", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByJournalEntry.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByJournalEntry", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByJournalEntry.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByJournalEntry", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByJournalEntry.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByJournalEntry", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByJournalEntry.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByJournalEntry.GridPanel(p);
});
Lino.finan.SuggestionsByJournalEntry.do_fill = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByJournalEntry", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.SuggestionsByPaymentOrder
Lino.finan.SuggestionsByPaymentOrder.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/finan/SuggestionsByPaymentOrder",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrder','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrder','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrder','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrder','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrder','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "F\u00fcllen", "overflowText": "F\u00fcllen", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrder','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Vorschl\u00e4ge",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "detail_pointer" }, { "name": "partner" }, 'partnerHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "id", "type": "int" } ],
  pk_index : 13,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp6444 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp6445 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date6446 = new Lino.DateField({ "disabled": true });
    var debts_disp6447 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp6448 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance6449 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account6450 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var detail_pointer_disp6451 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner6452 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account6453 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Bankkonto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Schulden", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Zahlungen", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "format": "0.000,00/i", "header": "Saldo", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "bank_account", "editable": false, "header": "Bankkonto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.bank_account) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByPaymentOrder.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByPaymentOrder.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByPaymentOrder", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrder.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByPaymentOrder", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrder.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByPaymentOrder", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrder.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByPaymentOrder", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrder.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByPaymentOrder.GridPanel(p);
});
Lino.finan.SuggestionsByPaymentOrder.do_fill = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByPaymentOrder", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.SuggestionsByBankStatement
Lino.finan.SuggestionsByBankStatement.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/finan/SuggestionsByBankStatement",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatement','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatement','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatement','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatement','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatement','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "F\u00fcllen", "overflowText": "F\u00fcllen", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatement','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Vorschl\u00e4ge",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "detail_pointer" }, { "name": "partner" }, 'partnerHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "id", "type": "int" } ],
  pk_index : 13,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp6455 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp6456 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date6457 = new Lino.DateField({ "disabled": true });
    var debts_disp6458 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp6459 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance6460 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account6461 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var detail_pointer_disp6462 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner6463 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account6464 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Bankkonto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Schulden", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Zahlungen", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "format": "0.000,00/i", "header": "Saldo", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "bank_account", "editable": false, "header": "Bankkonto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.bank_account) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByBankStatement.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByBankStatement.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByBankStatement", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatement.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByBankStatement", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatement.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByBankStatement", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatement.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByBankStatement", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatement.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByBankStatement.GridPanel(p);
});
Lino.finan.SuggestionsByBankStatement.do_fill = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByBankStatement", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.SuggestionsByVoucherItem
Lino.finan.SuggestionsByVoucherItem.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/finan/SuggestionsByVoucherItem",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucherItem','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucherItem','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucherItem','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucherItem','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucherItem','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "F\u00fcllen", "overflowText": "F\u00fcllen", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucherItem','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Vorschl\u00e4ge",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "detail_pointer" }, { "name": "partner" }, 'partnerHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "id", "type": "int" } ],
  pk_index : 13,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp6466 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp6467 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date6468 = new Lino.DateField({ "disabled": true });
    var debts_disp6469 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp6470 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance6471 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account6472 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var detail_pointer_disp6473 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner6474 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account6475 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Bankkonto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Schulden", "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Zahlungen", "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "format": "0.000,00/i", "header": "Saldo", "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "bank_account", "editable": false, "header": "Bankkonto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.bank_account) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByVoucherItem.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByVoucherItem.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByVoucherItem", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucherItem.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByVoucherItem", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucherItem.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByVoucherItem", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucherItem.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByVoucherItem", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucherItem.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByVoucherItem.GridPanel(p);
});
Lino.finan.SuggestionsByVoucherItem.do_fill = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByVoucherItem", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.SuggestionsByBankStatementItem
Lino.finan.SuggestionsByBankStatementItem.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/finan/SuggestionsByBankStatementItem",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatementItem','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatementItem','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatementItem','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatementItem','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatementItem','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "F\u00fcllen", "overflowText": "F\u00fcllen", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatementItem','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Vorschl\u00e4ge",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "detail_pointer" }, { "name": "partner" }, 'partnerHidden', { "name": "id", "type": "int" } ],
  pk_index : 13,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp6477 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp6478 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date6479 = new Lino.DateField({ "disabled": true });
    var debts_disp6480 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp6481 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance6482 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account6483 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account6484 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Bankkonto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var detail_pointer_disp6485 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner6486 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Schulden", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Zahlungen", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "format": "0.000,00/i", "header": "Saldo", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "bank_account", "editable": false, "header": "Bankkonto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.bank_account) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.partner) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByBankStatementItem.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByBankStatementItem.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByBankStatementItem", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatementItem.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByBankStatementItem", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatementItem.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByBankStatementItem", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatementItem.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByBankStatementItem", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatementItem.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByBankStatementItem.GridPanel(p);
});
Lino.finan.SuggestionsByBankStatementItem.do_fill = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByBankStatementItem", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.SuggestionsByPaymentOrderItem
Lino.finan.SuggestionsByPaymentOrderItem.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/finan/SuggestionsByPaymentOrderItem",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrderItem','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrderItem','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrderItem','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrderItem','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrderItem','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "F\u00fcllen", "overflowText": "F\u00fcllen", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrderItem','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Vorschl\u00e4ge",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "detail_pointer" }, { "name": "partner" }, 'partnerHidden', { "name": "id", "type": "int" } ],
  pk_index : 13,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp6488 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp6489 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date6490 = new Lino.DateField({ "disabled": true });
    var debts_disp6491 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp6492 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance6493 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account6494 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Konto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account6495 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Bankkonto ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var detail_pointer_disp6496 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner6497 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Partner ausw\u00e4hlen...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Zahlungsziel", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Schulden", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Zahlungen", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "format": "0.000,00/i", "header": "Saldo", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.balance) ", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Konto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "bank_account", "editable": false, "header": "Bankkonto", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.bank_account) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.partner) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByPaymentOrderItem.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByPaymentOrderItem.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByPaymentOrderItem", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrderItem.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByPaymentOrderItem", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrderItem.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByPaymentOrderItem", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrderItem.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByPaymentOrderItem", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrderItem.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByPaymentOrderItem.GridPanel(p);
});
Lino.finan.SuggestionsByPaymentOrderItem.do_fill = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/finan/SuggestionsByPaymentOrderItem", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class vat.VouchersByPartner
Lino.vat.VouchersByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/vat/VouchersByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/VouchersByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VouchersByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VouchersByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VouchersByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/VouchersByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "MwSt.-Belege",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "voucher" }, { "name": "total_incl" }, { "name": "total_base" }, { "name": "total_vat" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var entry_date6499 = new Lino.DateField({ "disabled": true });
    var voucher_disp6500 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var total_incl6501 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var total_base6502 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var total_vat6503 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "entry_date", "editable": false, "format": "d.m.Y", "header": "Buchungsdatum", "sortable": false, "tooltip": "(vat.VouchersByPartner.entry_date) The date of the journal entry, i.e. when this voucher is to\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "voucher", "editable": false, "header": "Beleg", "sortable": false, "tooltip": "(vat.VouchersByPartner.voucher) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 2, "dataIndex": "total_incl", "editable": false, "format": "0.000,00/i", "header": "Total inkl. MwSt.", "sortable": false, "tooltip": "(vat.VouchersByPartner.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 3, "dataIndex": "total_base", "editable": false, "format": "0.000,00/i", "header": "Total zzgl. MwSt.", "sortable": false, "tooltip": "(vat.VouchersByPartner.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13), "xtype": "numbercolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "total_vat", "editable": false, "format": "0.000,00/i", "header": "MwSt.", "sortable": false, "tooltip": "(vat.VouchersByPartner.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13), "xtype": "numbercolumn" } ];
    Lino.vat.VouchersByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.VouchersByPartner.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VouchersByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VouchersByPartner.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VouchersByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VouchersByPartner.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VouchersByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VouchersByPartner.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VouchersByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VouchersByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.VouchersByPartner.GridPanel(p);
});

Lino.about.About.showPanel = Ext.extend(Lino.about.About.DetailFormPanel,{
  empty_title: "Info",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/about/About",
  initComponent : function() {
    this.ls_detail_handler = Lino.about.About.show;
    Lino.about.About.showPanel.superclass.initComponent.call(this);
  }
});

Lino.about.About.show = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.about.About.showPanel(p);
});

Lino.about.About.showPanel = Ext.extend(Lino.about.About.DetailFormPanel,{
  empty_title: "Info",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/about/About",
  initComponent : function() {
    this.ls_detail_handler = Lino.about.About.show;
    Lino.about.About.showPanel.superclass.initComponent.call(this);
  }
});

Lino.about.About.show = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.about.About.showPanel(p);
});

Lino.ledger.Situation.showPanel = Ext.extend(Lino.ledger.Situation.DetailFormPanel,{
  empty_title: "Situation",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  ls_url: "/ledger/Situation",
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.Situation.show;
    Lino.ledger.Situation.showPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Situation.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Situation.ParamsPanel({});
  return new Lino.ledger.Situation.showPanel(p);
});

Lino.ledger.Situation.showPanel = Ext.extend(Lino.ledger.Situation.DetailFormPanel,{
  empty_title: "Situation",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  ls_url: "/ledger/Situation",
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.Situation.show;
    Lino.ledger.Situation.showPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Situation.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Situation.ParamsPanel({});
  return new Lino.ledger.Situation.showPanel(p);
});
Lino.ledger.Situation.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/Situation", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.ledger.ActivityReport.showPanel = Ext.extend(Lino.ledger.ActivityReport.DetailFormPanel,{
  empty_title: "T\u00e4tigkeitsbericht",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  ls_url: "/ledger/ActivityReport",
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.ActivityReport.show;
    Lino.ledger.ActivityReport.showPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.ActivityReport.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ActivityReport.ParamsPanel({});
  return new Lino.ledger.ActivityReport.showPanel(p);
});

Lino.ledger.ActivityReport.showPanel = Ext.extend(Lino.ledger.ActivityReport.DetailFormPanel,{
  empty_title: "T\u00e4tigkeitsbericht",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  ls_url: "/ledger/ActivityReport",
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.ActivityReport.show;
    Lino.ledger.ActivityReport.showPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.ActivityReport.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ActivityReport.ParamsPanel({});
  return new Lino.ledger.ActivityReport.showPanel(p);
});
Lino.ledger.ActivityReport.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/ActivityReport", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.ledger.AccountingReport.showPanel = Ext.extend(Lino.ledger.AccountingReport.DetailFormPanel,{
  empty_title: "Accounting Report",
  hide_navigator: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  ls_url: "/ledger/AccountingReport",
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.AccountingReport.show;
    Lino.ledger.AccountingReport.showPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.AccountingReport.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.AccountingReport.ParamsPanel({});
  return new Lino.ledger.AccountingReport.showPanel(p);
});

Lino.ledger.AccountingReport.showPanel = Ext.extend(Lino.ledger.AccountingReport.DetailFormPanel,{
  empty_title: "Accounting Report",
  hide_navigator: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  ls_url: "/ledger/AccountingReport",
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.AccountingReport.show;
    Lino.ledger.AccountingReport.showPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.AccountingReport.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.AccountingReport.ParamsPanel({});
  return new Lino.ledger.AccountingReport.showPanel(p);
});
Lino.ledger.AccountingReport.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/AccountingReport", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.CalendarPanel.grid = new Lino.WindowAction({  }, function(){
  return Lino.CalendarApp().get_main_panel();
});

Lino.courses.StatusReport.showPanel = Ext.extend(Lino.courses.StatusReport.DetailFormPanel,{
  empty_title: "Statusbericht",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  ls_url: "/courses/StatusReport",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.StatusReport.show;
    Lino.courses.StatusReport.showPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.StatusReport.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.StatusReport.showPanel(p);
});

Lino.courses.StatusReport.showPanel = Ext.extend(Lino.courses.StatusReport.DetailFormPanel,{
  empty_title: "Statusbericht",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Drucken", "overflowText": "Drucken", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Drucken" } ],
  ls_url: "/courses/StatusReport",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.StatusReport.show;
    Lino.courses.StatusReport.showPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.StatusReport.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.StatusReport.showPanel(p);
});
Lino.courses.StatusReport.do_print = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/StatusReport", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class plausibility.Checkers
Lino.plausibility.Checkers.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/plausibility/Checkers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/plausibility/Checkers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/Checkers','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/Checkers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/plausibility/Checkers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/plausibility/Checkers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Detail" } ],
  cell_edit : true,
  title : "Datentests",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "text" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.Checkers.detail;
    var ww = this.containing_window;
    var value11183 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11184 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(plausibility.Checkers.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(plausibility.Checkers.text) ", "width": Lino.chars2width(22) } ];
    Lino.plausibility.Checkers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.Checkers.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/Checkers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Checkers.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/Checkers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Checkers.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/Checkers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Checkers.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/plausibility/Checkers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.plausibility.Checkers.detailPanel = Ext.extend(Lino.plausibility.Checkers.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/plausibility/Checkers",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.Checkers.detail;
    Lino.plausibility.Checkers.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.Checkers.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.Checkers.detailPanel(p);
});
Lino.plausibility.Checkers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.Checkers.GridPanel(p);
});

// js_render_GridPanel_class notes.SpecialTypes
Lino.notes.SpecialTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/notes/SpecialTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/SpecialTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/SpecialTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notes/SpecialTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notes/SpecialTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/SpecialTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Sondernotizarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6505 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6506 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6507 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6508 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6509 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6510 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(notes.SpecialTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(notes.SpecialTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(notes.SpecialTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(notes.SpecialTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(notes.SpecialTypes.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(notes.SpecialTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.notes.SpecialTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.SpecialTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/SpecialTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.SpecialTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/SpecialTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.SpecialTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/SpecialTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.SpecialTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notes/SpecialTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.SpecialTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.SpecialTypes.GridPanel(p);
});

// js_render_GridPanel_class notify.MailModes
Lino.notify.MailModes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/notify/MailModes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notify/MailModes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notify/MailModes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notify/MailModes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notify/MailModes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notify/MailModes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "E-Mail-Benachrichtigungsmodi",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6512 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6513 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6514 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6515 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6516 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6517 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(notify.MailModes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(notify.MailModes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(notify.MailModes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(notify.MailModes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(notify.MailModes.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(notify.MailModes.type) ", "width": Lino.chars2width(31) } ];
    Lino.notify.MailModes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notify.MailModes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MailModes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MailModes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MailModes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MailModes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MailModes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MailModes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MailModes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MailModes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notify.MailModes.GridPanel(p);
});

// js_render_GridPanel_class vat.VatClasses
Lino.vat.VatClasses.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/vat/VatClasses",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/VatClasses','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VatClasses','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VatClasses','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VatClasses','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/VatClasses','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "MwSt.-Klassen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11186 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11187 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11188 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11189 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11190 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp11191 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(vat.VatClasses.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(vat.VatClasses.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(vat.VatClasses.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(vat.VatClasses.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(vat.VatClasses.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(vat.VatClasses.type) ", "width": Lino.chars2width(31) } ];
    Lino.vat.VatClasses.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.VatClasses.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatClasses", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatClasses.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatClasses", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatClasses.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatClasses", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatClasses.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatClasses", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatClasses.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.VatClasses.GridPanel(p);
});

// js_render_GridPanel_class beid.CivilStates
Lino.beid.CivilStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/beid/CivilStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/beid/CivilStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/beid/CivilStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/beid/CivilStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/beid/CivilStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/beid/CivilStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Zivilst\u00e4nde",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11193 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11194 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11195 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11196 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11197 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp11198 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(beid.CivilStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(beid.CivilStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(beid.CivilStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(beid.CivilStates.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(beid.CivilStates.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(beid.CivilStates.type) ", "width": Lino.chars2width(31) } ];
    Lino.beid.CivilStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.beid.CivilStates.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/beid/CivilStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.CivilStates.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/beid/CivilStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.CivilStates.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/beid/CivilStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.CivilStates.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/beid/CivilStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.CivilStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.beid.CivilStates.GridPanel(p);
});

// js_render_GridPanel_class ledger.TradeTypes
Lino.ledger.TradeTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/TradeTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/TradeTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/TradeTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/TradeTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/TradeTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/TradeTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Handelsarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11200 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11201 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11202 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11203 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11204 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp11205 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(ledger.TradeTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(ledger.TradeTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(ledger.TradeTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(ledger.TradeTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(ledger.TradeTypes.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(ledger.TradeTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.TradeTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.TradeTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/TradeTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.TradeTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/TradeTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.TradeTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/TradeTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.TradeTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/TradeTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.TradeTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.TradeTypes.GridPanel(p);
});

// js_render_GridPanel_class changes.ChangeTypes
Lino.changes.ChangeTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/changes/ChangeTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/changes/ChangeTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangeTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangeTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangeTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/changes/ChangeTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "\u00c4nderungsarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6519 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6520 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6521 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6522 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6523 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6524 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(changes.ChangeTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(changes.ChangeTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(changes.ChangeTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(changes.ChangeTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(changes.ChangeTypes.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(changes.ChangeTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.changes.ChangeTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.ChangeTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangeTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangeTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangeTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangeTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangeTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangeTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/changes/ChangeTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangeTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.changes.ChangeTypes.GridPanel(p);
});

// js_render_GridPanel_class cal.DurationUnits
Lino.cal.DurationUnits.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/cal/DurationUnits",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/DurationUnits','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/DurationUnits','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/DurationUnits','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/DurationUnits','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/DurationUnits','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "DurationUnits",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6526 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6527 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6528 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6529 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6530 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6531 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(cal.DurationUnits.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.DurationUnits.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(cal.DurationUnits.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(cal.DurationUnits.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(cal.DurationUnits.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(cal.DurationUnits.type) ", "width": Lino.chars2width(31) } ];
    Lino.cal.DurationUnits.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.DurationUnits.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/DurationUnits", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.DurationUnits.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/DurationUnits", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.DurationUnits.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/DurationUnits", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.DurationUnits.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/DurationUnits", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.DurationUnits.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.DurationUnits.GridPanel(p);
});

// js_render_GridPanel_class courses.Sections
Lino.courses.Sections.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/courses/Sections",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Sections','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Sections','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Sections','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/Sections','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Sections','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Sektionen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6533 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6534 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6535 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6536 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6537 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6538 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(courses.Sections.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(courses.Sections.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(courses.Sections.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.Sections.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(courses.Sections.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(courses.Sections.type) ", "width": Lino.chars2width(31) } ];
    Lino.courses.Sections.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Sections.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Sections", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Sections.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Sections", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Sections.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Sections", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Sections.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/Sections", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Sections.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Sections.GridPanel(p);
});

// js_render_GridPanel_class system.YesNo
Lino.system.YesNo.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/system/YesNo",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/system/YesNo','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/system/YesNo','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/system/YesNo','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/system/YesNo','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/system/YesNo','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Ja oder Nein",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6540 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6541 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6542 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6543 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6544 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6545 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(system.YesNo.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(system.YesNo.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(system.YesNo.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(system.YesNo.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(system.YesNo.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(system.YesNo.type) ", "width": Lino.chars2width(31) } ];
    Lino.system.YesNo.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.system.YesNo.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/YesNo", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.YesNo.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/YesNo", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.YesNo.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/YesNo", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.YesNo.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/YesNo", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.YesNo.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.system.YesNo.GridPanel(p);
});

// js_render_GridPanel_class cal.Weekdays
Lino.cal.Weekdays.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/cal/Weekdays",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/Weekdays','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Weekdays','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Weekdays','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Weekdays','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/Weekdays','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Weekdays",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6547 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6548 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6549 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6550 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6551 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6552 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(cal.Weekdays.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.Weekdays.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(cal.Weekdays.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(cal.Weekdays.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(cal.Weekdays.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(cal.Weekdays.type) ", "width": Lino.chars2width(31) } ];
    Lino.cal.Weekdays.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Weekdays.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Weekdays", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Weekdays.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Weekdays", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Weekdays.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Weekdays", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Weekdays.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Weekdays", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Weekdays.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.Weekdays.GridPanel(p);
});

// js_render_GridPanel_class rooms.BookingStates
Lino.rooms.BookingStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/rooms/BookingStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/rooms/BookingStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/rooms/BookingStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/rooms/BookingStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/rooms/BookingStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/rooms/BookingStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Zust\u00e4nde",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "button_text" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11207 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11208 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11209 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11210 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11211 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp11212 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var button_text11213 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": null });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(rooms.BookingStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(rooms.BookingStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(rooms.BookingStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingStates.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingStates.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingStates.type) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "button_text", "editable": false, "header": "Symbol", "hidden": true, "sortable": false, "tooltip": "(rooms.BookingStates.button_text) ", "width": Lino.chars2width(5) } ];
    Lino.rooms.BookingStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.rooms.BookingStates.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingStates.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingStates.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingStates.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/rooms/BookingStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.rooms.BookingStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.rooms.BookingStates.GridPanel(p);
});

// js_render_GridPanel_class accounts.AccountTypes
Lino.accounts.AccountTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/accounts/AccountTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "AccountTypes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "dc", "type": "boolean" }, { "name": "sheet" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6554 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6555 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6556 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var dc_disp6557 = new Ext.form.DisplayField({ "disabled": true });
    var sheet6558 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(accounts.AccountTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(accounts.AccountTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(accounts.AccountTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "dc", "editable": false, "header": "D/C", "sortable": false, "tooltip": "(accounts.AccountTypes.dc) Debit (\u2611) oder Kredit (\u2610)", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "sheet", "editable": false, "header": "Sheet", "sortable": false, "tooltip": "(accounts.AccountTypes.sheet) ", "width": Lino.chars2width(22) } ];
    Lino.accounts.AccountTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.AccountTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/accounts/AccountTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.accounts.AccountTypes.GridPanel(p);
});

// js_render_GridPanel_class beid.BeIdCardTypes
Lino.beid.BeIdCardTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/beid/BeIdCardTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/beid/BeIdCardTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/beid/BeIdCardTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/beid/BeIdCardTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/beid/BeIdCardTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/beid/BeIdCardTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "eID-Kartenarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11215 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11216 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11217 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11218 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11219 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp11220 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(beid.BeIdCardTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(beid.BeIdCardTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(beid.BeIdCardTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(beid.BeIdCardTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(beid.BeIdCardTypes.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(beid.BeIdCardTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.beid.BeIdCardTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.beid.BeIdCardTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/beid/BeIdCardTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.BeIdCardTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/beid/BeIdCardTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.BeIdCardTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/beid/BeIdCardTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.BeIdCardTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/beid/BeIdCardTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.BeIdCardTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.beid.BeIdCardTypes.GridPanel(p);
});

// js_render_GridPanel_class excerpts.Shortcuts
Lino.excerpts.Shortcuts.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/excerpts/Shortcuts",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/excerpts/Shortcuts','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/Shortcuts','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/Shortcuts','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/excerpts/Shortcuts','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/excerpts/Shortcuts','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Excerpt shortcuts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6560 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6561 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6562 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6563 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6564 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6565 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(excerpts.Shortcuts.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(excerpts.Shortcuts.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(excerpts.Shortcuts.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(excerpts.Shortcuts.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(excerpts.Shortcuts.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(excerpts.Shortcuts.type) ", "width": Lino.chars2width(31) } ];
    Lino.excerpts.Shortcuts.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.Shortcuts.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Shortcuts", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Shortcuts.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Shortcuts", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Shortcuts.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Shortcuts", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Shortcuts.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/excerpts/Shortcuts", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Shortcuts.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.excerpts.Shortcuts.GridPanel(p);
});

// js_render_GridPanel_class system.PeriodEvents
Lino.system.PeriodEvents.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/system/PeriodEvents",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/system/PeriodEvents','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/system/PeriodEvents','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/system/PeriodEvents','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/system/PeriodEvents','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/system/PeriodEvents','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Beobachtungskriterien",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6567 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6568 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6569 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6570 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6571 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6572 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(system.PeriodEvents.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(system.PeriodEvents.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(system.PeriodEvents.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(system.PeriodEvents.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(system.PeriodEvents.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(system.PeriodEvents.type) ", "width": Lino.chars2width(31) } ];
    Lino.system.PeriodEvents.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.system.PeriodEvents.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/PeriodEvents", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.PeriodEvents.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/PeriodEvents", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.PeriodEvents.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/PeriodEvents", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.PeriodEvents.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/PeriodEvents", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.PeriodEvents.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.system.PeriodEvents.GridPanel(p);
});

// js_render_GridPanel_class notify.MessageTypes
Lino.notify.MessageTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/notify/MessageTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notify/MessageTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notify/MessageTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/notify/MessageTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/notify/MessageTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notify/MessageTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Message Types",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6574 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6575 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6576 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6577 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6578 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6579 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(notify.MessageTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(notify.MessageTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(notify.MessageTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(notify.MessageTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(notify.MessageTypes.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(notify.MessageTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.notify.MessageTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notify.MessageTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MessageTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MessageTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MessageTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MessageTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MessageTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MessageTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/notify/MessageTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MessageTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notify.MessageTypes.GridPanel(p);
});

// js_render_GridPanel_class beid.ResidenceTypes
Lino.beid.ResidenceTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/beid/ResidenceTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/beid/ResidenceTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/beid/ResidenceTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/beid/ResidenceTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/beid/ResidenceTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/beid/ResidenceTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Einwohnerregister",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6581 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6582 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6583 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6584 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6585 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6586 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(beid.ResidenceTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(beid.ResidenceTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(beid.ResidenceTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(beid.ResidenceTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(beid.ResidenceTypes.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(beid.ResidenceTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.beid.ResidenceTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.beid.ResidenceTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/beid/ResidenceTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.ResidenceTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/beid/ResidenceTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.ResidenceTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/beid/ResidenceTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.ResidenceTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/beid/ResidenceTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.ResidenceTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.beid.ResidenceTypes.GridPanel(p);
});

// js_render_GridPanel_class ledger.FiscalYears
Lino.ledger.FiscalYears.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/FiscalYears",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/FiscalYears','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/FiscalYears','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/FiscalYears','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/FiscalYears','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/FiscalYears','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Gesch\u00e4ftsjahre",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11222 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11223 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11224 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11225 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11226 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp11227 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(ledger.FiscalYears.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(ledger.FiscalYears.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(ledger.FiscalYears.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(ledger.FiscalYears.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(ledger.FiscalYears.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(ledger.FiscalYears.type) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.FiscalYears.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.FiscalYears.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/FiscalYears", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.FiscalYears.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/FiscalYears", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.FiscalYears.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/FiscalYears", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.FiscalYears.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/FiscalYears", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.FiscalYears.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.FiscalYears.GridPanel(p);
});

// js_render_GridPanel_class vat.DeclarationFieldsBase
Lino.vat.DeclarationFieldsBase.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/vat/DeclarationFieldsBase",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/DeclarationFieldsBase','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/DeclarationFieldsBase','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/DeclarationFieldsBase','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/DeclarationFieldsBase','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/DeclarationFieldsBase','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Declaration fields",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "description" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6588 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6589 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6590 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var description_disp6591 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark_disp6592 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6593 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6594 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(vat.DeclarationFieldsBase.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(vat.DeclarationFieldsBase.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(vat.DeclarationFieldsBase.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "description", "editable": false, "header": "Beschreibung", "sortable": false, "tooltip": "(vat.DeclarationFieldsBase.description) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(vat.DeclarationFieldsBase.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(vat.DeclarationFieldsBase.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(vat.DeclarationFieldsBase.type) ", "width": Lino.chars2width(31) } ];
    Lino.vat.DeclarationFieldsBase.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.DeclarationFieldsBase.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/DeclarationFieldsBase", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.DeclarationFieldsBase.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/DeclarationFieldsBase", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.DeclarationFieldsBase.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/DeclarationFieldsBase", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.DeclarationFieldsBase.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/DeclarationFieldsBase", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.DeclarationFieldsBase.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.DeclarationFieldsBase.GridPanel(p);
});

// js_render_GridPanel_class ledger.JournalGroups
Lino.ledger.JournalGroups.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/JournalGroups",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/JournalGroups','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/JournalGroups','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/JournalGroups','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/JournalGroups','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/JournalGroups','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Journalgruppen",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11229 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11230 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11231 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11232 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11233 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp11234 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(ledger.JournalGroups.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(ledger.JournalGroups.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(ledger.JournalGroups.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(ledger.JournalGroups.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(ledger.JournalGroups.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(ledger.JournalGroups.type) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.JournalGroups.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.JournalGroups.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/JournalGroups", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.JournalGroups.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/JournalGroups", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.JournalGroups.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/JournalGroups", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.JournalGroups.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/JournalGroups", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.JournalGroups.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.JournalGroups.GridPanel(p);
});

// js_render_GridPanel_class system.Genders
Lino.system.Genders.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/system/Genders",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/system/Genders','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/system/Genders','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/system/Genders','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/system/Genders','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/system/Genders','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Genders",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6596 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6597 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6598 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6599 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6600 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6601 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(system.Genders.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(system.Genders.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(system.Genders.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(system.Genders.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(system.Genders.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(system.Genders.type) ", "width": Lino.chars2width(31) } ];
    Lino.system.Genders.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.system.Genders.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/Genders", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.Genders.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/Genders", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.Genders.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/Genders", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.Genders.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/system/Genders", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.Genders.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.system.Genders.GridPanel(p);
});

// js_render_GridPanel_class uploads.Shortcuts
Lino.uploads.Shortcuts.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/uploads/Shortcuts",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/Shortcuts','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/Shortcuts','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/Shortcuts','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/Shortcuts','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/Shortcuts','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Upload shortcuts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6603 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6604 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6605 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6606 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6607 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6608 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(uploads.Shortcuts.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(uploads.Shortcuts.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(uploads.Shortcuts.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(uploads.Shortcuts.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(uploads.Shortcuts.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(uploads.Shortcuts.type) ", "width": Lino.chars2width(31) } ];
    Lino.uploads.Shortcuts.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.Shortcuts.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Shortcuts", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Shortcuts.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Shortcuts", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Shortcuts.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Shortcuts", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Shortcuts.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/Shortcuts", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Shortcuts.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.Shortcuts.GridPanel(p);
});

// js_render_GridPanel_class cal.Recurrencies
Lino.cal.Recurrencies.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/cal/Recurrencies",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/Recurrencies','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Recurrencies','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Recurrencies','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/Recurrencies','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/Recurrencies','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Recurrencies",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6610 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6611 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6612 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6613 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6614 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6615 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(cal.Recurrencies.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.Recurrencies.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(cal.Recurrencies.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(cal.Recurrencies.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(cal.Recurrencies.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(cal.Recurrencies.type) ", "width": Lino.chars2width(31) } ];
    Lino.cal.Recurrencies.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Recurrencies.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Recurrencies", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Recurrencies.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Recurrencies", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Recurrencies.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Recurrencies", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Recurrencies.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/Recurrencies", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Recurrencies.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.Recurrencies.GridPanel(p);
});

// js_render_GridPanel_class cal.EntryStates
Lino.cal.EntryStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/cal/EntryStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/EntryStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntryStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntryStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EntryStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/EntryStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Termin-Zust\u00e4nde",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "button_text" }, { "name": "edit_guests", "type": "boolean" }, { "name": "fixed", "type": "boolean" }, { "name": "transparent", "type": "boolean" }, { "name": "noauto", "type": "boolean" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11236 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11237 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11238 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var button_text11239 = new Ext.form.TextField({ "disabled": true, "maxLength": null });
    var edit_guests_disp11240 = new Ext.form.DisplayField({ "disabled": true });
    var fixed_disp11241 = new Ext.form.DisplayField({ "disabled": true });
    var transparent_disp11242 = new Ext.form.DisplayField({ "disabled": true });
    var noauto_disp11243 = new Ext.form.DisplayField({ "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(cal.EntryStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.EntryStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(cal.EntryStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "button_text", "editable": false, "header": "Symbol", "sortable": false, "tooltip": "(cal.EntryStates.button_text) ", "width": Lino.chars2width(5) }, { "colIndex": 4, "dataIndex": "edit_guests", "editable": false, "header": "Teilnehmer bearbeiten", "sortable": false, "tooltip": "(cal.EntryStates.edit_guests) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "fixed", "editable": false, "header": "Stabil", "sortable": false, "tooltip": "(cal.EntryStates.fixed) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "transparent", "editable": false, "header": "nicht blockierend", "sortable": false, "tooltip": "(cal.EntryStates.transparent) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "noauto", "editable": false, "header": "No auto", "sortable": false, "tooltip": "(cal.EntryStates.noauto) ", "width": Lino.chars2width(21) } ];
    Lino.cal.EntryStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntryStates.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntryStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntryStates.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntryStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntryStates.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntryStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntryStates.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EntryStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntryStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.EntryStates.GridPanel(p);
});

// js_render_GridPanel_class ledger.PeriodStates
Lino.ledger.PeriodStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/PeriodStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/PeriodStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/PeriodStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/PeriodStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/PeriodStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/PeriodStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Zust\u00e4nde",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "button_text" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6617 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6618 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6619 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6620 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6621 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6622 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var button_text6623 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": null });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(ledger.PeriodStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(ledger.PeriodStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(ledger.PeriodStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(ledger.PeriodStates.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(ledger.PeriodStates.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(ledger.PeriodStates.type) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "button_text", "editable": false, "header": "Symbol", "hidden": true, "sortable": false, "tooltip": "(ledger.PeriodStates.button_text) ", "width": Lino.chars2width(5) } ];
    Lino.ledger.PeriodStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.PeriodStates.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PeriodStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PeriodStates.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PeriodStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PeriodStates.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PeriodStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PeriodStates.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/PeriodStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PeriodStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.PeriodStates.GridPanel(p);
});

// js_render_GridPanel_class cal.EventEvents
Lino.cal.EventEvents.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/cal/EventEvents",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/EventEvents','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EventEvents','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EventEvents','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/EventEvents','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/EventEvents','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Beobachtungskriterien",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6625 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6626 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6627 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6628 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6629 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6630 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(cal.EventEvents.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.EventEvents.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(cal.EventEvents.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(cal.EventEvents.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(cal.EventEvents.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(cal.EventEvents.type) ", "width": Lino.chars2width(31) } ];
    Lino.cal.EventEvents.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EventEvents.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventEvents", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventEvents.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventEvents", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventEvents.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventEvents", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventEvents.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/EventEvents", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventEvents.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.EventEvents.GridPanel(p);
});

// js_render_GridPanel_class cal.GuestStates
Lino.cal.GuestStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/cal/GuestStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/GuestStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/GuestStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Gast-Zust\u00e4nde",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "afterwards", "type": "boolean" }, { "name": "text" }, { "name": "button_text" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11245 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11246 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var afterwards_disp11247 = new Ext.form.DisplayField({ "disabled": true });
    var text11248 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var button_text11249 = new Ext.form.TextField({ "disabled": true, "maxLength": null });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(cal.GuestStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.GuestStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "afterwards", "editable": false, "header": "Nachtr\u00e4glich", "sortable": false, "tooltip": "(cal.GuestStates.afterwards) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(cal.GuestStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "button_text", "editable": false, "header": "Symbol", "sortable": false, "tooltip": "(cal.GuestStates.button_text) ", "width": Lino.chars2width(5) } ];
    Lino.cal.GuestStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestStates.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestStates.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestStates.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestStates.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/GuestStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.GuestStates.GridPanel(p);
});

// js_render_GridPanel_class products.DeliveryUnit
Lino.products.DeliveryUnit.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/products/DeliveryUnit",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/products/DeliveryUnit','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/products/DeliveryUnit','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/products/DeliveryUnit','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/products/DeliveryUnit','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/products/DeliveryUnit','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Delivery units",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "button_text" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6632 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6633 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6634 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6635 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6636 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6637 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var button_text6638 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": null });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(products.DeliveryUnit.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(products.DeliveryUnit.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(products.DeliveryUnit.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(products.DeliveryUnit.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(products.DeliveryUnit.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(products.DeliveryUnit.type) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "button_text", "editable": false, "header": "Symbol", "hidden": true, "sortable": false, "tooltip": "(products.DeliveryUnit.button_text) ", "width": Lino.chars2width(5) } ];
    Lino.products.DeliveryUnit.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.products.DeliveryUnit.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/DeliveryUnit", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.DeliveryUnit.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/DeliveryUnit", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.DeliveryUnit.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/DeliveryUnit", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.DeliveryUnit.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/products/DeliveryUnit", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.DeliveryUnit.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.DeliveryUnit.GridPanel(p);
});

// js_render_GridPanel_class vat.VatRegimes
Lino.vat.VatRegimes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/vat/VatRegimes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/VatRegimes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VatRegimes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VatRegimes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VatRegimes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/VatRegimes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "MwSt.-Regimes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11251 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11252 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11253 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11254 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11255 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp11256 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(vat.VatRegimes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(vat.VatRegimes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(vat.VatRegimes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(vat.VatRegimes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(vat.VatRegimes.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(vat.VatRegimes.type) ", "width": Lino.chars2width(31) } ];
    Lino.vat.VatRegimes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.VatRegimes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRegimes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRegimes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRegimes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRegimes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRegimes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRegimes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatRegimes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatRegimes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.VatRegimes.GridPanel(p);
});

// js_render_GridPanel_class courses.EnrolmentStates
Lino.courses.EnrolmentStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/courses/EnrolmentStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Einschreibungs-Zust\u00e4nde",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "invoiceable", "type": "boolean" }, { "name": "type" }, { "name": "button_text" }, { "name": "uses_a_place", "type": "boolean" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11258 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11259 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11260 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11261 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11262 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoiceable_disp11263 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var type_disp11264 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var button_text11265 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": null });
    var uses_a_place_disp11266 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(courses.EnrolmentStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(courses.EnrolmentStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(courses.EnrolmentStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentStates.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentStates.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "invoiceable", "editable": false, "header": "Fakturierbar", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentStates.invoiceable) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentStates.type) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "button_text", "editable": false, "header": "Symbol", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentStates.button_text) ", "width": Lino.chars2width(5) }, { "colIndex": 8, "dataIndex": "uses_a_place", "editable": false, "header": "Besetzt einen Platz", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentStates.uses_a_place) ", "width": Lino.chars2width(21) } ];
    Lino.courses.EnrolmentStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentStates.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentStates.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentStates.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentStates.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/EnrolmentStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentStates.GridPanel(p);
});

// js_render_GridPanel_class ledger.VoucherTypes
Lino.ledger.VoucherTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/VoucherTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Belegarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11268 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11269 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11270 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11271 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11272 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp11273 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(ledger.VoucherTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(ledger.VoucherTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(ledger.VoucherTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(ledger.VoucherTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(ledger.VoucherTypes.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(ledger.VoucherTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.VoucherTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.VoucherTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/VoucherTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VoucherTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/VoucherTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VoucherTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/VoucherTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VoucherTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/VoucherTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VoucherTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.VoucherTypes.GridPanel(p);
});

// js_render_GridPanel_class printing.BuildMethods
Lino.printing.BuildMethods.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/printing/BuildMethods",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/printing/BuildMethods','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/printing/BuildMethods','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/printing/BuildMethods','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/printing/BuildMethods','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/printing/BuildMethods','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "BuildMethods",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6640 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6641 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6642 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6643 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6644 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6645 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(printing.BuildMethods.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(printing.BuildMethods.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(printing.BuildMethods.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(printing.BuildMethods.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(printing.BuildMethods.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(printing.BuildMethods.type) ", "width": Lino.chars2width(31) } ];
    Lino.printing.BuildMethods.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.printing.BuildMethods.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/printing/BuildMethods", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.printing.BuildMethods.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/printing/BuildMethods", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.printing.BuildMethods.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/printing/BuildMethods", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.printing.BuildMethods.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/printing/BuildMethods", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.printing.BuildMethods.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.printing.BuildMethods.GridPanel(p);
});

// js_render_GridPanel_class cal.AccessClasses
Lino.cal.AccessClasses.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/cal/AccessClasses",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/AccessClasses','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/AccessClasses','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/AccessClasses','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/AccessClasses','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/AccessClasses','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "AccessClasses",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6647 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6648 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6649 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6650 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6651 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6652 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(cal.AccessClasses.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.AccessClasses.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(cal.AccessClasses.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(cal.AccessClasses.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(cal.AccessClasses.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(cal.AccessClasses.type) ", "width": Lino.chars2width(31) } ];
    Lino.cal.AccessClasses.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AccessClasses.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AccessClasses", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AccessClasses.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AccessClasses", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AccessClasses.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AccessClasses", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AccessClasses.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/AccessClasses", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AccessClasses.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.AccessClasses.GridPanel(p);
});

// js_render_GridPanel_class uploads.UploadAreas
Lino.uploads.UploadAreas.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/uploads/UploadAreas",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadAreas','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadAreas','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadAreas','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadAreas','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadAreas','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Upload-Bereiche",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11275 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11276 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11277 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11278 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11279 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp11280 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(uploads.UploadAreas.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(uploads.UploadAreas.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(uploads.UploadAreas.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadAreas.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadAreas.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadAreas.type) ", "width": Lino.chars2width(31) } ];
    Lino.uploads.UploadAreas.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadAreas.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadAreas", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadAreas.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadAreas", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadAreas.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadAreas", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadAreas.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/uploads/UploadAreas", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadAreas.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.UploadAreas.GridPanel(p);
});

// js_render_GridPanel_class outbox.RecipientTypes
Lino.outbox.RecipientTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/outbox/RecipientTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "RecipientTypes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6654 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6655 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6656 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6657 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6658 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6659 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(outbox.RecipientTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(outbox.RecipientTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(outbox.RecipientTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(outbox.RecipientTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(outbox.RecipientTypes.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(outbox.RecipientTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.outbox.RecipientTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.RecipientTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/RecipientTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/RecipientTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/RecipientTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/outbox/RecipientTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.RecipientTypes.GridPanel(p);
});

// js_render_GridPanel_class ledger.VoucherStates
Lino.ledger.VoucherStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/ledger/VoucherStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Zust\u00e4nde",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "button_text" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6661 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6662 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6663 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6664 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6665 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6666 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var button_text6667 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": null });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(ledger.VoucherStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(ledger.VoucherStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(ledger.VoucherStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(ledger.VoucherStates.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(ledger.VoucherStates.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(ledger.VoucherStates.type) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "button_text", "editable": false, "header": "Symbol", "hidden": true, "sortable": false, "tooltip": "(ledger.VoucherStates.button_text) ", "width": Lino.chars2width(5) } ];
    Lino.ledger.VoucherStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.VoucherStates.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/VoucherStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VoucherStates.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/VoucherStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VoucherStates.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/VoucherStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VoucherStates.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/ledger/VoucherStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VoucherStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.VoucherStates.GridPanel(p);
});

// js_render_GridPanel_class cal.TaskStates
Lino.cal.TaskStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/cal/TaskStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/TaskStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/TaskStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/cal/TaskStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/cal/TaskStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/TaskStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Aufgaben-Zust\u00e4nde",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "button_text" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11282 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11283 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11284 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11285 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11286 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp11287 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var button_text11288 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": null });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(cal.TaskStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.TaskStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(cal.TaskStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(cal.TaskStates.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(cal.TaskStates.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(cal.TaskStates.type) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "button_text", "editable": false, "header": "Symbol", "hidden": true, "sortable": false, "tooltip": "(cal.TaskStates.button_text) ", "width": Lino.chars2width(5) } ];
    Lino.cal.TaskStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TaskStates.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TaskStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TaskStates.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TaskStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TaskStates.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TaskStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TaskStates.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/cal/TaskStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TaskStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.TaskStates.GridPanel(p);
});

// js_render_GridPanel_class courses.CourseAreas
Lino.courses.CourseAreas.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/courses/CourseAreas",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/CourseAreas','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseAreas','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseAreas','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseAreas','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/CourseAreas','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Aktivit\u00e4tenlayouts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6669 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6670 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6671 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6672 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6673 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6674 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(courses.CourseAreas.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(courses.CourseAreas.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(courses.CourseAreas.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.CourseAreas.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(courses.CourseAreas.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(courses.CourseAreas.type) ", "width": Lino.chars2width(31) } ];
    Lino.courses.CourseAreas.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CourseAreas.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseAreas", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseAreas.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseAreas", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseAreas.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseAreas", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseAreas.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseAreas", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseAreas.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CourseAreas.GridPanel(p);
});

// js_render_GridPanel_class users.UserTypes
Lino.users.UserTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/users/UserTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/users/UserTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/UserTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/users/UserTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/users/UserTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/users/UserTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Benutzerarten",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "user_role" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11290 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11291 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11292 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var user_role_disp11293 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(users.UserTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(users.UserTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(users.UserTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "user_role", "editable": false, "header": "User role", "sortable": false, "tooltip": "(users.UserTypes.user_role) ", "width": Lino.chars2width(31) } ];
    Lino.users.UserTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.users.UserTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UserTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UserTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UserTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UserTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UserTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UserTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/users/UserTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UserTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.users.UserTypes.GridPanel(p);
});

// js_render_GridPanel_class vat.VatColumns
Lino.vat.VatColumns.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/vat/VatColumns",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/VatColumns','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VatColumns','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VatColumns','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/vat/VatColumns','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/VatColumns','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "VAT columns",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11295 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11296 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11297 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11298 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11299 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp11300 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(vat.VatColumns.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(vat.VatColumns.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(vat.VatColumns.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(vat.VatColumns.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(vat.VatColumns.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(vat.VatColumns.type) ", "width": Lino.chars2width(31) } ];
    Lino.vat.VatColumns.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.VatColumns.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatColumns", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatColumns.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatColumns", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatColumns.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatColumns", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatColumns.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/vat/VatColumns", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VatColumns.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.VatColumns.GridPanel(p);
});

// js_render_GridPanel_class contacts.PartnerEvents
Lino.contacts.PartnerEvents.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/contacts/PartnerEvents",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnerEvents','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnerEvents','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnerEvents','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnerEvents','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnerEvents','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Beobachtungskriterien",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6676 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6677 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6678 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6679 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6680 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6681 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(contacts.PartnerEvents.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(contacts.PartnerEvents.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(contacts.PartnerEvents.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnerEvents.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnerEvents.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnerEvents.type) ", "width": Lino.chars2width(31) } ];
    Lino.contacts.PartnerEvents.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnerEvents.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnerEvents", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnerEvents.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnerEvents", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnerEvents.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnerEvents", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnerEvents.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/contacts/PartnerEvents", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnerEvents.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.PartnerEvents.GridPanel(p);
});

// js_render_GridPanel_class courses.CourseStates
Lino.courses.CourseStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/courses/CourseStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/CourseStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/CourseStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Zust\u00e4nde",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "invoiceable", "type": "boolean" }, { "name": "type" }, { "name": "button_text" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value11302 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name11303 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text11304 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp11305 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp11306 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoiceable_disp11307 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var type_disp11308 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var button_text11309 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": null });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(courses.CourseStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(courses.CourseStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(courses.CourseStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(courses.CourseStates.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(courses.CourseStates.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "invoiceable", "editable": false, "header": "Fakturierbar", "hidden": true, "sortable": false, "tooltip": "(courses.CourseStates.invoiceable) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(courses.CourseStates.type) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "button_text", "editable": false, "header": "Symbol", "hidden": true, "sortable": false, "tooltip": "(courses.CourseStates.button_text) ", "width": Lino.chars2width(5) } ];
    Lino.courses.CourseStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CourseStates.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseStates.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseStates.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseStates.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/courses/CourseStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CourseStates.GridPanel(p);
});

// js_render_GridPanel_class countries.PlaceTypes
Lino.countries.PlaceTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "Keine Daten anzuzeigen.", "forceFit": true },
  ls_url : "/countries/PlaceTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/countries/PlaceTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Tabelle (Querformat)", "overflowText": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/countries/PlaceTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Tabelle (Querformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Tabelle (Hochformat)", "overflowText": "Tabelle (Hochformat)", "panel_btn_handler": Lino.list_action_handler('/countries/PlaceTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Tabelle (Hochformat)", "tooltip": "Diese Tabelle in eine .pdf-Datei exportieren" } ], "menu_item_text": "Tabelle (Querformat)", "panel_btn_handler": Lino.list_action_handler('/countries/PlaceTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/countries/PlaceTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "PlaceTypes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "detail_pointer" }, { "name": "type" }, { "name": "None" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value6683 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name6684 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text6685 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp6686 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var detail_pointer_disp6687 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp6688 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "Wert", "sortable": false, "tooltip": "(countries.PlaceTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(countries.PlaceTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "Text", "sortable": false, "tooltip": "(countries.PlaceTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Bemerkung", "hidden": true, "sortable": false, "tooltip": "(countries.PlaceTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "detail_pointer", "editable": false, "header": "Rechnung", "hidden": true, "sortable": false, "tooltip": "(countries.PlaceTypes.detail_pointer) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "type", "editable": false, "header": "Art", "hidden": true, "sortable": false, "tooltip": "(countries.PlaceTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.countries.PlaceTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.PlaceTypes.show_as_html = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlaceTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlaceTypes.as_pdf = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlaceTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlaceTypes.as_pdf_p = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlaceTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlaceTypes.export_excel = function(rp, is_main, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, is_main, "/countries/PlaceTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlaceTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.PlaceTypes.GridPanel(p);
});
